<?php

class BlogsPrototype extends Module {

	var $main_title;
	var $table_prefix;
	var $addition_to_path;
	var $require_authorization		= 1;
	var $is_authorized				= FALSE;
	var $module_name				= 'blogs';
	var $block_module_actions		= array();
	var $block_main_module_actions	= array();
	var $default_action				= 'showlist';
	var $admin_default_action		= 'showlist';
	var $tpl_path					= 'mod/blogs/tpl/';
	var $blog_allowable_tags		= '<p>,<a>,<img>,<strong>,<b>,<em>,<i>,<u>,<strike>,<ul>,<ol>,<li>,<blockquote>';
	var $blog_date_mask				= '%d %m %Y | %H:%i';
	var $allow_img_typs				= array('image/gif', 'image/jpeg', 'image/png', 'image/pjpeg', 'image/x-png');
	var $img_expansions				= array('image/gif' => 'gif', 'image/jpeg' => 'jpeg', 'image/png' => 'png', 'image/pjpeg' => 'jpg', 'image/x-png' => 'png');
	var $transurl					= '';
	var $months						= array();
	var $action_tpl = array(
	    'showlist' => 'blogs_list.html',
	    'showblogs' => 'blogs_blogs.html',
	    'showsearchform' => 'blogs_searchform.html',
	    'blogsannounce' => 'blogs_announce.html',
	    'curuserinfo' => 'blogs_curuser_info.html',
	    'lastuserblog' => 'blogs_lastuserblog.html',
	    'friends' => 'blogs_friends.html',
	);

	function BlogsPrototype($action = '', $transurl = '', $properties = array(), $prefix = NULL, $rewrite_mod_params = NULL, $adminurl = NULL, $noadmin = false) {
		GLOBAL $main, $tpl, $tpl_path, $baseurl, $cash, $lc, $CONFIG, $PAGE, $core, $server, $lang, $request_type, $_RESULT;
		
		/* Get $action, $tpl_name, $permissions */
		extract( $this->init(array(
		        'server' => $server, 'lang' => $lang, 'prefix' => $prefix,
		        'action' => $action, 'tpl_name' => $properties['tpl']
		)), EXTR_OVERWRITE);
		
		$this->block_module_actions		= array(
		        'showlist' => $this->_msg['Show_last_blogs'],
		        'showblogs' => $this->_msg['Show_user_blogs'],
		        'showsearchform' => $this->_msg['Show_blogs_search_form'],
		        'blogsannounce' => $this->_msg['Show_blogs_announces'],
		        'curuserinfo' => $this->_msg['Show_current_user_info'],
		        'lastuserblog' => $this->_msg['Show_user_last_blogs'],
		        'friends' => $this->_msg['Show_user_friends']
		);
		$this->block_main_module_actions	= array(
		        'showlist' => $this->_msg['Show_last_blogs'],
		        'showblogs' => $this->_msg['Show_user_blogs'],
		        'lastuserblog' => $this->_msg['Show_user_last_blogs'],
		        'friends' => $this->_msg['Show_user_friends']
		);
		
		// проверить авторизован ли пользователь
		$this->is_authorized = $_SESSION['siteuser']['is_authorized'] ? true : false;
		$CONFIG['blogs_img_path'] = $CONFIG['files_upload_path'].'blogs/'.$this->table_prefix.'/';

  		$this->months = $this->_msg['months'];
  		
  		if ('only_create_object' == $action) {
  		    return;
  		}
  		
  		if ($this->actionExists($action)) {
  		    $this->doAction($action);
  		    return;
  		}
  		
		if (! self::is_admin()) {

		    $params = explode('/', $rewrite_mod_params);
    		if (!empty($params[0])) {
    		    $PAGE['current_user_id'] = $this->test_siteuser($params[0]);
    		    if ($PAGE['current_user_id']) {
    		    	$GLOBALS['request_siteuser'] = $params[0];
        			$action = empty($action) || $action == 'showlist' ? 'showblogs' : $action;
        			if ($CONFIG["rewrite_mod"]) {
        				$url = parse_url($transurl);
        				$this->transurl = $url['path'].$params[0]."/";
        			} else {
        			    $this->transurl .= "&siteuser=".$params[0];
        			}
        			if (0 == $PAGE['field']) {
            		    $PAGE['process_params'] = true;
            		}
            		$tpl_name = $this->checkTplName($tpl_name, $action);
    		    }
    		}    		
		    if (0 == $PAGE['field'] && $GLOBALS['request_siteuser']
		        && in_array($action, array('showblogs', 'lastuserblog', 'friends', 'list'))
		    ) {
		    	$PAGE['current_user_id'] = $this->test_siteuser($GLOBALS['request_siteuser']);
		    } elseif (0 == $PAGE['field'] && in_array($action, array('addblog')) && $this->is_authorized) {
		        $PAGE['current_user_id'] = $_SESSION['siteuser']['id'];
		    }
		    if ($PAGE['current_user_id']) {
		    	if (!class_exists('SiteusersPrototype')) {
					require(RP."mod/siteusers/lib/class.SiteusersPrototype.php");
				}
				$this->addition_to_path = array(SiteusersPrototype::getUserName($PAGE['current_user_id']) => '');
		    }
		    
		    if ($this->actionExists($action)) {
		        $this->doAction($action);
		        return;
		    }
//---------------------------------- обработка действий с сайта --------------------------------//
			switch ($action) {
// Показать список последних блогов
			case "showlist":
                global $request_start;
				$main->include_main_blocks($tpl_name, "main");
				$tpl->prepare();
				$this->show_last_blogs($properties[1], $transurl, $request_start);
				break;

// Показать форму поиска блогов
			case "showsearchform":
				global $request_sdata;
				$main->include_main_blocks($tpl_name, "main");
				$tpl->prepare();
				$tpl->assign(array(
								"transurl"		=> $transurl,
								"siteusername"	=> str_replace(array("<", ">", "\"", "'", ".", "@", "\\"), "", $request_sdata["siteusername"]),
								"surname"		=> str_replace(array("<", ">", "\"", "'", ".", "@", "\\"), "", $request_sdata["surname"]),
								"firstname"		=> str_replace(array("<", ">", "\"", "'", ".", "@", "\\"), "", $request_sdata["firstname"]),
							));
				break;

// Показать форму поиска блогов
			case "showsearchresult":
				global $request_sdata;
				$main->include_main_blocks($this->module_name."_searchresult.html", "main");
				$tpl->prepare();
				$this->show_search_result($request_sdata, $transurl);
				break;
/*
// Добавить отзыв
			case "addcomment":
				global $request_blog, $request_comment, $request_ref;
                if ($request_blog = (int)$request_blog) {
					$this->add_comment($request_blog, $request_comment);
					Module::go_back($request_ref);
                    header('Location: '.$transurl.'&action=showblog&blog='.$request_blog);
				} else {
					header('Location: '.$transurl.'&action=showlist');
				}
				break;
*/
// Добавить пользователя в друзья
			case "addfriend":
				if (!$this->is_authorized) {
					$main->show_result_message($this->_msg["Only_for_auth_user"]);
					break;
				}
				global $request_siteuser;
				$siteuser_id = $this->test_siteuser($request_siteuser);
				if (!$siteuser_id) {
					header('Location: '.$transurl.'&action=showlist');
					break;
				}
				$this->add_friend($siteuser_id);
				Module::go_back();
				header('Location: '.$transurl.'&action=showprofile&siteuser='.$request_siteuser);
				exit;
				break;

// Удалить пользователя из друзей
			case "delfriend":
				if (!$this->is_authorized) {
					$main->show_result_message($this->_msg["Only_for_auth_user"]);
					break;
				}
				global $request_siteuser, $request_id;
				$request_id = $request_id ? $request_id : $this->test_siteuser($request_siteuser);
				if (!$request_id) {
					header('Location: '.$transurl.'&action=showlist');
					break;
				}
				$this->delete_friend($request_id);
				Module::go_back();
				header('Location: '.$transurl.'&action=showlist');
				exit;

// Показать профиль пользователя
			case "showprofile":
				global $request_siteuser;
				$request_siteuser = ($properties[1]) ? $properties[1] : $request_siteuser;
				if (!$siteuser_id = $this->test_siteuser($request_siteuser)) {
					header('Location: '.$transurl.'&action=showlist');
					exit();
				}
				$main->include_main_blocks($this->module_name."_profile.html", "main");
				$tpl->prepare();
				$this->show_profile($siteuser_id, 1, $transurl);
				break;

// Показать блоги пользователя
			case "showblogs":
				global $request_siteuser, $request_start;
				$request_siteuser = $request_siteuser ? $request_siteuser : $_SESSION["siteuser"]["siteusername"];
				$siteuser_id = $this->test_siteuser($request_siteuser);
				if (!$siteuser_id) {
					header('Location: '.$transurl.'&action=showlist');
					exit();
				}
				$start = (int)$request_start;

				$main->include_main_blocks($tpl_name, "main");
				$tpl->prepare();
				if ($siteuser_id == $_SESSION["siteuser"]["id"]) {
					$tpl->newBlock('block_add_blog');
					$tpl->assign(
						array(
							"add_blog_link"	=> $transurl.(($CONFIG["rewrite_mod"]) ? "" : '&siteuser='.$request_siteuser."&")
														."action=addblog",
						));
				}
				$this->show_profile($siteuser_id, 0, $transurl);
				$this->show_blogs($siteuser_id, $start, $CONFIG['blogs_max_rows'], $transurl, $action);
				/*
				$main->_show_nav_string($this->table_prefix."_blogs",
										" AND author_id=".$siteuser_id,
										"",
										"&siteuser=".$request_siteuser."&action=".$action,
										$start,
										$CONFIG['blogs_max_rows'],
										"date DESC",
										"",
										0);
				*/
				break;

			case "lastuserblog":
				if ($PAGE['current_user_id']) {
					$main->include_main_blocks($tpl_name, "main");
					$tpl->prepare();
					if ($PAGE['current_user_id'] == $_SESSION["siteuser"]["id"]) {
					    $tpl->newBlock('block_add_blog');
					    $tpl->assign(array(
							"add_blog_link"	=> $transurl.(($CONFIG["rewrite_mod"]) ? "" : '&user_id='.$PAGE['current_user_id']."&")."action=addblog",
						));
					}
					$this->show_profile($PAGE['current_user_id'], 0, $transurl);
					$this->show_blogs($PAGE['current_user_id'], 0, 1, $transurl, $action);
				}
				break;

			case "friends":
				if ($PAGE['current_user_id']) {
					$main->include_main_blocks($tpl_name, "main");
					$tpl->prepare();
					$this->show_friends($PAGE['current_user_id'], $transurl);
				}
				break;

// Показать блог пользователя
			case "showblog":
				global $request_blog, $request_answer;
				$request_blog = (int)$request_blog;
				$main->include_main_blocks($this->module_name."_blog.html", "main");
				$tpl->prepare();				
				
				if (file_exists(RP."mod/comments")) {
				    require_once(RP."mod/comments/lib/class.CommentsPrototype.php");
				    $comm = new CommentsPrototype('only_create_object');
				    $comm->showBlogComments($request_blog, $CONFIG['blogs_comment_cnt']);
				}
				
				$this->show_blog($request_blog, $request_answer, $transurl);
				break;

// Добавить блог пользователя
			case 'addblog':
				// если пользователь неавторизован
				if (!$this->is_authorized) {
					$main->show_result_message($this->_msg["Only_for_auth_user"]);
					break;
				}
				$main->include_main_blocks($this->module_name."_blog_edit.html", "main");
				$tpl->prepare();
				$tpl->assign(array(
				    'form_action'	=> $transurl."&action=saveblog",
					"image_max_width" => $CONFIG['blogs_img_max_width'],
					"image_max_height" => $CONFIG['blogs_img_max_height'],
					"image_max_size" => $CONFIG['blogs_img_max_size'],
				));
				$tpl->newBlock('block_blog_add_title');
			break;

// Сохранить блог пользователя
			case "saveblog":
				// если пользователь неавторизован
				if (!$this->is_authorized) {
					$main->show_result_message($this->_msg["Only_for_auth_user"]);
					break;
				}
				global $request_data;
				
				$request_data['active'] = 1;
				if ($this->update_blog($request_data)) {
				    if ($this->upload_file($request_data)) {
				    	header('Location: '.$transurl.'&action=showblogs');
				    } else {
				    	header('Location: '.$transurl.'&action=editblog&blog='.$request_data['id'].'&upload_err');
				    }
					break;
				}

// Изменить блог пользователя
			case "editblog":
				// если пользователь неавторизован
				if (!$this->is_authorized) {
					$main->show_result_message($this->_msg["Only_for_auth_user"]);
					break;
				}
				global $request_blog, $request_upload_err;
				if ($request_data) {
					$data = $request_data;
				} else {
					$data = $this->get_blog_data($request_blog, $_SESSION["siteuser"]["id"]);
					$data["content"] = ($data["content"])
										? $data["announce"].'<p class="SPLITER">&nbsp;</p>'.$data["content"]
										: $data["announce"];
					unset($data["announce"]);
				}
				$main->include_main_blocks($this->module_name."_blog_edit.html", "main");
				$tpl->prepare();
				$tpl->assign(array(
					"form_action"	=> $transurl."&action=saveblog",
				    'active_checked' => $data["active"] ? '' : '', 
					"blog_id"		=> $data["id"],
					"blog_title"	=> $data["title"],
					"blog_content"	=> $data["content"],
					"selected_".$data["comments_type"]	=> " selected",
					"blog_image"	=> $data["image"],
					"blog_preview"	=> $data["preview"],
					"image_max_width" => $CONFIG['blogs_img_max_width'],
                    "image_max_height" => $CONFIG['blogs_img_max_height'],
                    "image_max_size" => $CONFIG['blogs_img_max_size'],
				));

				$tpl->newBlock('block_blog_edit_title');
				if ($data["image"]) {
					$tpl->newBlock('block_image');
					$tpl->assign(
                        array(
                            "image_path" => "/".$CONFIG['blogs_img_path'].$data["image"],
                            "preview_path" => "/".$CONFIG['blogs_img_path'].$data["preview"],
                            "image_max_width" => $CONFIG['blogs_img_max_width'],
                            "image_max_height" => $CONFIG['blogs_img_max_height'],
                            "image_max_size" => $CONFIG['blogs_img_max_size'],
                        )
					);
				}
				if (isset($request_upload_err)) {
					$tpl->newBlock('block_upload_err');
					$tpl->assign(
                        array(
                            'image_max_size' => $CONFIG['blogs_img_max_size']
                        )
					);
				}
				$this->show_profile($_SESSION["siteuser"]["id"], 0, $transurl);
				break;

// Удалить блог пользователя
			case "delblog":
				// если пользователь неавторизован
				if (!$this->is_authorized) {
					$main->show_result_message($this->_msg["Only_for_auth_user"]);
					break;
				}
				global $request_blog;
				$this->delete_blog($request_blog, $_SESSION["siteuser"]["id"]);
				header('Location: '.$_SERVER["HTTP_REFERER"]);
				exit();
				break;
/*
// Удалить коментарий блога
			case "delcomment":
				// если пользователь неавторизован
				if (!$this->is_authorized) {
					$main->show_result_message($this->_msg["Only_for_auth_user"]);
					break;
				}
				global $request_comment;
				$this->delete_comment($request_comment);
				Module::go_back();
				header('Location: '.$baseurl."&action=showlist");
				exit();
				break;
*/
// Информация о текущем пользователе
			case "curuserinfo":
				global $BLOG_CUR_USER;
				$main->include_main_blocks($tpl_name, "main");
				$tpl->prepare();
                #var_dump($BLOG_CUR_USER);
				if (is_array($BLOG_CUR_USER)) {
					$tpl->newBlock('block_cur_user_info');
					$tpl->assign(
						array(
              "siteusername" => $BLOG_CUR_USER["name"],
							"about_url"	=> $BLOG_CUR_USER["about"],
							"home_url"	=> $BLOG_CUR_USER["home"],
						));
					if ($BLOG_CUR_USER["avatar_img"]) {
						$tpl->newBlock('block_cur_user_img');
						$tpl->assign(
							array(
								"blog_avatar_img"	=> $BLOG_CUR_USER["avatar_img"],
								"img_alt"			=> $BLOG_CUR_USER["name"],
							));
					} else {
						$tpl->newBlock('block_no_img');
					}
					if ($BLOG_CUR_USER["site"]) {
						if (substr($BLOG_CUR_USER["site"], 0,7) !== "http://") {
							$BLOG_CUR_USER["site"] = "http://".$BLOG_CUR_USER["site"];
						}
						$tpl->newBlock('block_cur_user_site');
						$tpl->assign("cur_user_site",	$BLOG_CUR_USER["site"]);
					}
				} else {
					$tpl->newBlock('block_no_cur_user');
				}
				break;

// Анонсы блогов
			case "blogsannounce":
				$main->include_main_blocks($tpl_name, "main");
				$tpl->prepare();
				$this->show_discuss_blogs(intval($properties[1]), $transurl);
				$this->show_new_blogs(intval($properties[2]), $transurl);
				$this->show_random_blogs(intval($properties[2]), $transurl);
				$this->show_best_blogers(intval($properties[3]), $transurl);
				break;
// Default...
			default:
//				$main->show_result_message("Этот раздел доступен только для авторизованного пользователя. Пожалуйста, введите свой логин и пароль в формочку слева, либо <a href=\"{$transurl}&action=registration\">зарегистрируйтесь</a> на сайте.");
				if (is_object($tpl)) $tpl->prepare();
				return;
			}
//------------------------------- конец обработки действий с сайта -----------------------------//
		} else {
//------------------------------ обработка действий из админ части -----------------------------//

		  if ($this->actionExists($action)) {
		      $this->doAction($action);
		      return;
		  }

			if (!isset($tpl)) $main->message_die('Не подключен класс для работы с шаблонами');
			if (empty($action)) $action = $this->admin_default_action;
			switch ($action) {
			case 'block_prp':
				global $request_sub_action, $request_block_id;
		    	$arr  = $this->getEditLink($request_sub_action, $request_block_id);
				$cont = 'var container = document.getElementById(\'target_span\');
		    		  	 container.innerHTML = "'.$this->getPropertyFields().'";
		    		  	 material_id		  = "'.$arr['material_id'].'";
		    		  	 material_url		  = "'.$arr['material_url'].'";
		    		  	 changeAction();';
		    	header('Content-Length: '.strlen($cont));
		    	echo $cont;
		    	exit;
		    	break;

// Редактирование свойств блока
			case 'properties':
				if (!$permissions['e']) $main->message_access_denied($blogs->module_name, $action);
				global $module_id, $request_field, $request_block_id, $title;

				$main->include_main_blocks('_block_properties.html', 'main');
				$tpl->prepare();

				if ($main->show_actions($request_field, '', $this->block_main_module_actions, $this->block_module_actions)) {
					$main->show_linked_pages($module_id, $request_field);
				}

				$tpl->assign(array(	'_ROOT.title'		=> $title,
									'_ROOT.username'	=> $_SESSION['session_login'],
									'_ROOT.password'	=> $_SESSION['session_password'],
									'_ROOT.name'		=> $this->module_name,
									'_ROOT.lang'		=> $lang,
									'_ROOT.block_id'	=> $request_block_id,
									));

				$this->main_title	= $this->_msg["Block_properties"];
				break;

// Показать список блогов
// prayer_q  14.07.08

// надо сделать постраничный вывод!

			case 'showlist':
				if (!$permissions['r']) $main->message_access_denied($this->module_name, $action);
				$main->include_main_blocks_2($this->module_name.'_list.html', $this->tpl_path);
				$tpl->prepare();
				$tpl->assign(array(
					'MSG_Activ' => $this->_msg['Activ'],
					'MSG_Edit' => $main->_msg['Ed'],
					'MSG_Rights' => $this->_msg['Rights'],
                    'MSG_Author' => $this->_msg['Author'],
					'MSG_Title' => $this->_msg['Title'],
					'MSG_Comments_count' =>  $this->_msg['Comments_count'],
					'MSG_Date' => $this->_msg['Date'],
					'MSG_Del' => $this->_msg['Del'],
					'MSG_New_blog' => $this->_msg['New_blog'],
					'MSG_Create'=> $this->_msg['Create'],

					//'_ROOT.form_action'	=>	$baseurl.'&action=addblog', // +addblog!

					'MSG_Select_action' => $this->_msg['Select_action'],
					'MSG_Activate' => $this->_msg['Activate'],
					'MSG_Suspend' => $this->_msg['Suspend'],
					'MSG_Delete' => $this->_msg['Delete'],
					'MSG_Execute' => $this->_msg['Execute']
				));
				$this->show_list();
				$this->main_title = $this->_msg['Blog_list'];
				break;

// показать список комментариев блога
			case 'showcomments':
				global $request_blog;
				if (!$permissions['r']) $main->message_access_denied($this->module_name, $action);
				$main->include_main_blocks_2($this->module_name.'_comment_list.html', $this->tpl_path);
				$tpl->prepare();
				$tpl->assign(array(
				//	'MSG_Add_value' => 'Трям',
					'MSG_Activ' => $this->_msg['Activ'],
					'MSG_Edit' => $main->_msg['Ed'],
					'MSG_Rights' => $this->_msg['Rights'],
					'MSG_Author' => $this->_msg['Author'],
					'MSG_Contetnt' => $this->_msg['Contetnt'],
					'MSG_Date' => $this->_msg['Date'],
					'MSG_Del' => $this->_msg['Del'],
					'MSG_New_blog' => $this->_msg['New_blog'],
					'MSG_Create'=> $this->_msg['Create'],
					'MSG_Add_comment' =>  $this->_msg['Add_comment'],
					'action' => $baseurl.'&action=addcomm&blog='.$request_blog,

					//'_ROOT.form_action'	=>	$baseurl.'&action=addblog', // +addblog!
					'MSG_Select_action' => $this->_msg['Select_action'],
					'MSG_Activate' => $this->_msg['Activate'],
					'MSG_Suspend' => $this->_msg['Suspend'],
					'MSG_Delete' => $this->_msg['Delete'],
					'MSG_Execute' => $this->_msg['Execute']
				));
				$this->main_title = $this->show_comments_list($request_blog);
				break;

// редактирование свойств модуля
			case 'prp':
		    if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $request_step; //blogs_block_properties
				$main->include_main_blocks('_properties.html', $this->tpl_path);
				$tpl->prepare();
				$tpl->assign(Array(
					"MSG_Information"	=> $main->_msg["Information"],
					"MSG_Value"			=> $main->_msg["Value"],
					"MSG_Save"			=> $main->_msg["Save"],
					"MSG_Cancel"		=> $main->_msg["Cancel"],
				));

		        if (!$request_step || $request_step == 1) {
					$tpl->assign(array('form_action'	=> $baseurl,
									   'step'			=> 2,
									   'lang'			=> $lang,
									   'name'			=> $this->module_name,
									   'action'			=> 'prp'));

					$prp_html = $main->getModuleProperties($this->module_name);
		            $this->main_title = $this->_msg["Controls"];
				} elseif (2 == $request_step) {
		        	$t = $main->setModuleProperties($this->module_name, $_POST);
							header('Location: '.$baseurl.'&action=prp&step=1');
				}
		    break;


// Удаление записи
			case 'delblog':
				if (!$permissions["d"]) $main->message_access_denied($this->module_name, $action);
				global $request_id, $request_category, $request_start;
				if (!$this->test_item_rights("d", "id", $this->table_prefix."_blogs", $request_id, false, $ctg_owner_id))
					$main->message_access_denied($this->module_name, $action);

				if ($this->delete_blog($request_category,'')) {
					//@$cache->delete_cache_files();
//					$lc->delete_internal_links($this->module_name, $lang.'_vacancies', $request_id);
				}
				header ('Location: '.$baseurl.'&action=showlist');
			break;

			case 'addblog':
				if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
				global $request_step, $request_data;
				if (!$request_step || $request_step == 1) {
					$main->include_main_blocks_2($this->module_name.'_edit.html', $this->tpl_path);
					$tpl->prepare();
					$tpl->assign(array(
						'form_action'	=> $baseurl.'&action=addblog&step=2',
						'image_max_width' => $CONFIG['blogs_img_max_width'],
					    'image_max_height' => $CONFIG['blogs_img_max_height'],
					    'image_max_size' => $CONFIG['blogs_img_max_size'],

						'MSG_Enter_title' => $this->_msg['Enter_title'],

/*
						'blog_image'	=> $data['image'],
						'blog_preview'	=> $data['preview'],
*/

						'MSG_Picture' => $this->_msg['Image'],
						'MSG_blog_content' => $this->_msg['Contetnt'],
						'MSG_Title' => $this->_msg['Title'],
						"MSG_Save"			=> $main->_msg["Save"],
						"MSG_Cancel"		=> $main->_msg["Cancel"]
					));
 			  } elseif ($request_step == 2){
/*					list($allow, $ctg_rights) = $this->test_item_rights("e", "id", $this->table_prefix."_siteusers",
																		$request_category, false, 0, true);
																		*/
					if (!$this->test_item_rights("e", "id", $this->table_prefix."_blogs", $request_id, false, $ctg_owner_id))
						$main->message_access_denied($this->module_name, $action);
					
					if ($this->update_blog($request_data)) {
							if ($this->upload_file($request_data)) {
								header('Location: '.$baseurl.'&action=showlist');
							} else {
								header('Location: '.$baseurl.'&action=editblog&blog='.$request_data['id'].'&upload_err');
							}
						break;
					}
				}
				$this->main_title	= $this->_msg['Add_blog'];
			break;

			case 'editblog':
				if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
				global $request_step, $request_data, $request_category;
				if ($request_data) {
					$data = $request_data;
				} else {
					$data = $this->get_blog_data($request_category,'');
					$data["content"] = ($data["content"])
										? $data["announce"].'<p class="SPLITER">&nbsp;</p>'.$data["content"]
										: $data["announce"];
					unset($data["announce"]);
				}

				if (!$request_step || $request_step == 1) {
					$main->include_main_blocks_2($this->module_name.'_edit.html', $this->tpl_path);
					$tpl->prepare();
					$tpl->assign(array(
						'blog_id'		=> $data['id'],
						'blog_title'	=> $data['title'],
						'blog_content'	=> $data['content'],
					    'active_checked' => $data["active"] ? 'checked' : '',
						'selected_'.$data['comments_type']	=> ' selected',
						'blog_image'	=> $data['image'],
						'blog_preview'	=> $data['preview'],

						'form_action'	=> $baseurl."&action=addblog&step=2",
						"image_max_width" => $CONFIG['blogs_img_max_width'],
            "image_max_height" => $CONFIG['blogs_img_max_height'],
            "image_max_size" => $CONFIG['blogs_img_max_size'],

						'MSG_Picture' => $this->_msg['Image'],
						'MSG_blog_content' => $this->_msg['Contetnt'],
						'MSG_Title' => $this->_msg['Title'],
						"MSG_Save"			=> $main->_msg["Save"],
						"MSG_Cancel"		=> $main->_msg["Cancel"]
					));
					$tpl->newBlock('block_blog_edit_title');
					if ($data["image"]) {
						$tpl->newBlock('block_image');
						$tpl->assign(
													array(
															"image_path" => "/".$CONFIG['blogs_img_path'].$data["image"],
															"preview_path" => "/".$CONFIG['blogs_img_path'].$data["preview"],
															"image_max_width" => $CONFIG['blogs_img_max_width'],
															"image_max_height" => $CONFIG['blogs_img_max_height'],
															"image_max_size" => $CONFIG['blogs_img_max_size'],
													)
						);
					}
 			  }
				elseif ($request_step == 2){
/*					list($allow, $ctg_rights) = $this->test_item_rights("e", "id", $this->table_prefix."_siteusers",
																		$request_category, false, 0, true);
																		*/
					if (!$this->test_item_rights("e", "id", $this->table_prefix."_blogs", $request_id, false, $ctg_owner_id))
						$main->message_access_denied($this->module_name, $action);
// print_r( $request_data);
					if ($this->update_blog($request_data)) {
							if ($this->upload_file($request_data)) {
								header('Location: '.$baseurl.'&action=showlist');
							} else {
								header('Location: '.$baseurl.'&action=editblog&blog='.$request_data['id'].'&upload_err');
							}
						break;
					}
				}
				$this->main_title	= $this->_msg['Edit_blog'];

			break;

  		case 'editblogrights':
				if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $request_id, $request_category, $request_start;
				//list($category_title, $ctg_owner_id) = $this->show_category($request_category, false);
				if (!$this->test_item_rights("e", "id", $this->table_prefix."_blogs", $request_category, true, ''/*$ctg_owner_id*/))
					$main->message_access_denied($this->module_name, $action);
				if (!$this->show_rights_form($this->table_prefix."_blogs", "title", $request_category,
											"&category=".$request_category."&start=".$request_start, $this->_msg["Image"])) {
					header('Location: '.$baseurl.'&action=showlist');
				}
			break;

			case 'saverights':
				if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $request_category, $request_rights;
				//list($category_title, $ctg_owner_id) = $this->show_category($request_category, false);
				if (!$this->test_item_rights("e", "id", $this->table_prefix."_blogs", $request_category, true, ''))
					$main->message_access_denied($this->module_name, $action);

				$this->save_rights_form($this->table_prefix."_blogs", $request_category, $request_rights);
				if ($request_type == "JsHttpRequest") {
					$_RESULT = array(
					    "res" => 1,
					    "id"	=> $request_id
					);
				} else {
					  header('Location: '.$baseurl.'&action=showlist');
					}
				exit;
				break;

			case 'pactivate':
				if (!$permissions["p"]) $main->message_access_denied($this->module_name, $action);
				global $request_category, $request_start;
				if ($this->test_item_rights("p", "id", $this->table_prefix."_blogs", $request_category, false, '')) {
					if ($main->activate($this->table_prefix."_blogs", $request_category)) {
					    Cache::delete_cache_files();
					}
				}
				Module::go_back();
				header('Location: '.$baseurl.'&action=showlist');
				exit;
			break;

			case 'psuspend':
				if (!$permissions["p"]) $main->message_access_denied($this->module_name, $action);
				global $request_category, $request_start;
				if ($this->test_item_rights("p", "id", $this->table_prefix."_blogs", $request_category, false, '')) {
					if ($main->suspend($this->table_prefix."_blogs", $request_category)) {
					    Cache::delete_cache_files();
					}
				}
				Module::go_back();
				header('Location: '.$baseurl.'&action=showlist');
				exit;
			break;

			case 'suspendb_checked':
				if (!$permissions['p']) $main->message_access_denied($this->module_name, $action);
				global $request_check;
				if (is_array($request_check)) {
					foreach($request_check as $k => $v) {
						if ($this->test_item_rights("p", "id", $this->table_prefix."_blogs",  $v, false, '')) {
							if ($main->suspend($this->table_prefix."_blogs",  $v));//@$cache->delete_cache_files();
						}
					}
				}
				header('Location: '.$baseurl.'&action=showlist');
				exit;
		break;

			case 'activateb_checked':
				if (!$permissions['p']) $main->message_access_denied($this->module_name, $action);
				global $request_check;
				if (is_array($request_check)) {
					foreach($request_check as $k => $v) {
						if ($this->test_item_rights("p", "id", $this->table_prefix."_blogs",  $v, false, '')) {
							if ($main->activate($this->table_prefix."_blogs",  $v)) ;//@$cache->delete_cache_files();
						}
					}
				}
				header('Location: '.$baseurl.'&action=showlist');
				exit;
			break;

			case 'deleteb_checked':
				if (!$permissions['d']) $main->message_access_denied($this->module_name, $action);
				global $request_check;
				if (is_array($request_check)) {
					foreach($request_check as $k => $v) {
						if ($this->test_item_rights("d", "id", $this->table_prefix."_blogs", $v)) {
							if ($this->delete_blog($v,'')) {
								//@$cache->delete_cache_files();
								//$lc->delete_internal_links($this->module_name, $this->table_prefix.'_articles', $v);
							}
						}
					}
				}
				header('Location: '.$baseurl.'&action=showlist');
				exit;
			break;
/*
			case 'suspendc_checked':
				if (!$permissions['p']) $main->message_access_denied($this->module_name, $action);
				global $request_check, $request_blog;
				if (is_array($request_check)) {
					foreach($request_check as $k => $v) {
						if ($this->test_item_rights("p", "id", $this->table_prefix."_blogs",  $v, false, '')) {
							if ($main->suspend($this->table_prefix."_blogs_comments",  $v));// @$cache->delete_cache_files();
						}
					}
				}
			  header('Location: '.$baseurl.'&action=showcomments&blog='.$request_blog);
			  exit;
		break;

			case 'activatec_checked':
				if (!$permissions['p']) $main->message_access_denied($this->module_name, $action);
				global $request_check, $request_blog;
				if (is_array($request_check)) {
					foreach($request_check as $k => $v) {
						if ($this->test_item_rights("p", "id", $this->table_prefix."_blogs",  $v, false, '')) {
							if ($main->activate($this->table_prefix."_blogs_comments",  $v));// @$cache->delete_cache_files();
						}
					}
				}
			  header('Location: '.$baseurl.'&action=showcomments&blog='.$request_blog);
			  exit;
			break;
*/
			case 'deletec_checked':
				if (!$permissions['d']) $main->message_access_denied($this->module_name, $action);
				global $request_check, $request_blog;
				if (is_array($request_check)) {
					foreach($request_check as $k => $v) {
						if ($this->test_item_rights("d", "id", $this->table_prefix."_blogs", $v)) {
							if ($this->delete_comment($v)) {
								//@$cache->delete_cache_files();
								//$lc->delete_internal_links($this->module_name, $this->table_prefix.'_articles', $v);
							}
						}
					}
				}
			  header('Location: '.$baseurl.'&action=showcomments&blog='.$request_blog);
				exit;
			break;

// Default...
			default:
				$main->include_main_blocks();
				$tpl->prepare();
			}
//--------------------------- конец обработки действий из админ части --------------------------//
		}
	}

	/**
	 * Проверка имени пользователя сайта
	 *
	 * @param int $rows
	 * @return int 0 - ошибка, id - OK
	 */
	function test_siteuser($siteusername) {
		global $db;
		static $ret = array();
		if (! isset($ret[$siteusername])) {
    		$db->query("SELECT id FROM core_users WHERE username='".$db->escape(trim($siteusername))."'");
    		if ($db->next_record()) {
    		    $ret[$siteusername] = $db->f('id');
    		}
		}
		return isset($ret[$siteusername]) ? $ret[$siteusername] : 0;
	}

	/**
	 * Отображение информации о последних блогах
	 *
	 * @param int $rows
	 * @return boolean FALSE - ошибка, TRUE - OK
	 */
	function show_last_blogs($rows, $transurl, $page)	{
		global $db, $tpl, $CONFIG;
		$rows = ((int)$rows) ? (int)$rows : 5;
		$page = $page > 1 ? (int) $page : 1;
	$commentable = defined('COMMENTS_BLOG_TYPE');
    $query = "SELECT ".
		 " b.id,b.date AS _date, ".
		 " DATE_FORMAT(b.date,'%d %m %Y | %H:%i') as date, ".
		 " b.title, ".
		 " b.announce, ".
		 " LENGTH(b.content) as content_length, ".
		 " b.comments_type, ".
		 " b.author_id, ".
		 " b.image,  ".
		 " b.preview, ".
		 " u.username, ".
		 " u.email".
		 (defined('COMMENTS_BLOG_TYPE') ? ", count(c.id) as cnt_comments " : "").
		 " FROM {$this->table_prefix}_blogs b  ".
		 " JOIN core_users u  ".
		 (defined('COMMENTS_BLOG_TYPE') 
		     ? " LEFT JOIN {$this->table_prefix}_comments_resource r ON (r.item_id=b.id AND r.type="
		     .COMMENTS_BLOG_TYPE.") LEFT JOIN {$this->table_prefix}_comments c ON c.resrc_id=r.id" : "").
		 " WHERE b.author_id=u.id AND b.active=1  ".
		 " GROUP BY b.id  ".
		 " ORDER BY _date DESC  ".
             " LIMIT ". ($page-1)*$rows . ",".$rows;
 		if ($db->query($query)) {
 		    /*$patt = array(
                "/\n/",
                "/<br[^>]*>/i",
                "/<p[^>]*>/i",
                //"/<\/p>/i",
                "/<a[^>]+href\s?=\s?['\"](.*?)['\"][^>]*>(.*?)<\/a>/i",
                "/<img[^>]+src\s?=\s?['\"](.*?)['\"][^>]*>/i",
 		    );
 		    $repl = array(
                "",
                "_-##BR##-_ ",
                "_-##P##-_ ",
                //"_-##/P##-_ ",
                "_-##A-=|=-\\1-=|=-\\2##-_ ",
                "_-##IMG-=|=-\\1##-_ "
 		    );
 		    $_patt = array(
                "/_-##BR##-_/",
                "/_-##P##-_/",
                //"/_-##\/P##-_/",
                "/_-##A-=\|=-(.*)-=\|=-(.*)##-_/U",
                "/_-##IMG-=\|=-(.*)##-_/U"
 		    );
 		    $_repl = array(
                "<br>",
                "<p>",
                //"</p>",
                "<a href=\"\\1\">\\2</a>",
                "<a href=\"\\1\" target=\"_blank\">".$this->_msg["Image"]."</a>",
 		    );*/
 		    if (!class_exists('SiteusersPrototype')) {
			    require(RP."mod/siteusers/lib/class.SiteusersPrototype.php");
			}
			while ($db->next_record()) {
				$user_link = SiteusersPrototype::getUserLink($db->Record["username"]);
				$url = $this->get_transurl($transurl, $db->Record['username']);
                //$anns = Main::tokenize(preg_replace($patt, $repl, $db->f("announce")));
                //$anns = preg_replace($_patt, $_repl, $anns);
				$tpl->newBlock('block_blog_row');
				$tpl->assign(array(
						"blog_id"			  => $db->f("id"),
						"blog_date"           => $this->format_date($db->f("date")),
						"blog_title"          => $db->f("title"),
						"blog_announce"       => $db->f("announce"),
//						"blog_short_announce"  => $anns,
						"blog_edit_link"      => $url."action=editblog&blog=".$db->f("id"),
						"blog_delete_link"    => $url."action=delblog&blog=".$db->f("id"),
						"author_link"         => $user_link,
						"siteusername"        => $db->f("username"),
						"email"             => $db->f("email"),
						"blog_details_link"   => $url."action=showblog&blog=".$db->f("id"),
					));
				if ($db->f("author_id") == $_SESSION["siteuser"]["id"]) {
					$tpl->newBlock('block_edit_link');
					$tpl->assign(array(
							"blog_edit_link"	=> $url."action=editblog&blog=".$db->f("id"),
							"blog_delete_link"	=> $url."&ction=delblog&blog=".$db->f("id"),
						));
				}
				if ($db->f("content_length")) {
					$tpl->newBlock('block_more_link');
					$tpl->assign(array(
							"blog_more_url"	=> $url."action=showblog&blog=".$db->f("id"),
						));
				}
				$tpl->newBlock('block_comments');
				if ($db->f("cnt_comments")) {
					$tpl->newBlock('block_comments_show');
					$tpl->assign(array(
							"comments_link"	=> $url."action=showblog&blog=".$db->f("id"),
							"cnt_comments"	=> $db->f("cnt_comments"),
						));
				} else {
					$tpl->newBlock('block_no_comments');
				}
				$blog_id = $db->f("id");
				$comments_type = $db->f("comments_type");
				if ($db->f("author_id") == $_SESSION["siteuser"]["id"]	// комментирует автор
					|| $comments_type == 0								// комментируют все
					|| ($comments_type == 1 && $this->is_authorized)	// комментируют зарегистрированные
					|| ($comments_type == 2 && $this->is_authorized && $this->is_I_friend($db->f("author_id")))) {// комментируют друзья
					$tpl->newBlock('block_write_message');
					$tpl->assign(array(
							"write_msg_url"	=> $url."action=showblog&blog=".$blog_id."&answer=yes",
						));
				}

				$preview_name = $db->f('preview');
				$preview_path = $CONFIG['blogs_img_path'].$preview_name;
				if ($preview_name && file_exists(RP.$preview_path)) {
				    $preview_inf = getimagesize(RP.$preview_path);
				    $tpl->newBlock('block_preview');
					$tpl->assign(
                        array(
                            "preview_path"	=> "/".$preview_path,
                            "preview_attr"	=> $preview_inf[3],
                            "blog_details_link"	=> $url."action=showblog&blog=".$db->f("id"),
						)
					);
				}
			}

			$query = "SELECT COUNT(*) AS cnt FROM ".$this->table_prefix."_blogs WHERE active=1";
			$db->query($query);
			$db->next_record();

			$url = $this->get_transurl($transurl);
			//Main::_show_nav_block(ceil($db->f('cnt')/$rows), 'block_nav', "action=showlist", $page, $separator);
			Pager::Build(
			    $db->f('cnt'),
			    $rows,
			    $page,
			    $url ."action=showlist"
			);

			return TRUE;
		}
		return FALSE;
	}

	/**
	 * Добавление комментария
	 *
	 * @param int $id
	 * @param string $comment
	 * @return boolean FALSE - ошибка, TRUE - OK
	 */
	/*
	function add_comment($id, $comment)
	{
		global $db;
		$blog = $this->get_blog_data($id);
		if ($blog["author_id"] == $_SESSION["siteuser"]["id"]	// комментирует автор
			|| $comments_type == 0								// комментируют все
			|| ($comments_type == 1 && $this->is_authorized)	// комментируют зарегистрированные
			|| ($comments_type == 2 && $this->is_authorized && $this->is_I_friend($blog["author_id"]))) {// комментируют друзья
			$comment = $db->escape(trim(strip_tags($comment)));
			if ($comment) {
				$query = 'INSERT INTO '.$this->table_prefix.'_blogs_comments
							SET blog_id = '.$id.',
								comment = "'.$comment.'",
								author_id = '.(($_SESSION["siteuser"]["id"]) ? $_SESSION["siteuser"]["id"] : 0).',
								date = NOW()';
				$db->query($query);
			}
		}
		return TRUE;
	}
	*/
	/*
	function add_comment_adm($id, $comment)
	{
		global $db;
//		$comment = preg_replace('/<[^>]*>/', '', $comment);
		$comment = $db->escape(trim(strip_tags($comment)));
  	if ($comment) {
				$query = 'INSERT INTO '.$this->table_prefix.'_blogs_comments
							SET blog_id = '.$id.',
								comment = "'.$comment.'",
								author_id = '.(($_SESSION["siteuser"]["id"]) ? $_SESSION["siteuser"]["id"] : 0).',
								date = NOW()';
				$db->query($query);
		}
		return TRUE;
	}
	*/
	/**
	 * получить форматтированную строку для baseurl
	 *
	 * @return string
	 */
	function get_baseurl_format($transurl)
	{
		global $CONFIG;
		if ($CONFIG["rewrite_mod"]) {
			$baseurltmp = explode('/', $transurl);
			$baseurltmp[sizeof($baseurltmp)-2] = "%s";
			$baseurltmp = implode('/', $baseurltmp);
		} else {
			$baseurltmp = $transurl."&siteuser=%s";
		}
		return $baseurltmp;
	}

	/**
	 * Отображение друзей
	 *
	 * @return boolean FALSE - ошибка, TRUE - OK
	 */
	function show_friends($id, $transurl)
	{
		global $tpl, $db, $CONFIG;
		$query = "SELECT u.id,u.username
					FROM ".$this->table_prefix."_blogs_friends f, core_users u
					WHERE f.siteuser_id=".$id." AND f.friend_id=u.id AND u.active
					ORDER BY u.username";
		if ($db->query($query)) {
		    if ($db->nf()) {
		        $blog_url = Core::formPageLink($CONFIG["blogs_page_link"], $CONFIG["blogs_page_address"], $lang, 1);
		    	$tpl->newBlock('block_my_friends');
		    	if ($_SESSION["siteuser"]["id"] == $id) {
					$tpl->newBlock('block_my_friends_edit');
					$tpl->newBlock('block_my_friends_edit_start');
					$tpl->assign(array(
					   'baseurl' => $blog_url,
					   'action' => $blog_url."&action=delfriend",
					));
				}
				if (!class_exists('SiteusersPrototype')) {
					require(RP."mod/siteusers/lib/class.SiteusersPrototype.php");
				}
				while ($db->next_record()) {
    				$tpl->newBlock('block_my_friend');
    				$user_link = SiteusersPrototype::getUserLink($db->f("username"));
    				$assign = array(
    				    "user_id"   	=> $db->f("id"),
    				    "siteusername"	=> $db->f("username"),
    					"email"		=> $db->f("email"),
    					"user_link"	=> $user_link,
    					"profile_link"	=> $user_link
    				);
    				$tpl->assign($assign);
    				if ($db->Record['img'] && file_exists(RP.$CONFIG['siteusers_img_path'].$db->Record['img'])) {
    					$tpl->newBlock('block_my_friend_img');
    					$tpl->assign($assign + array('path' => '/'.$CONFIG['siteusers_img_path'].$db->Record['img']));
    				} else {
    				    $tpl->newBlock('block_my_friend_no_img');
    					$tpl->assign($assign);
    				}
    				if ($_SESSION["siteuser"]["id"] == $id) {
    					$tpl->newBlock('block_my_friend_edit');
    					$tpl->assign($assign);
    				}
    			}
    			return TRUE;
		    } else {
		        $tpl->newBlock('block_no_friends');
		    }
		}
		return FALSE;
	}

 	/**
	 * Отображение кто друдит с пользователем id
	 *
	 * @return boolean FALSE - ошибка, TRUE - OK
	 */
	function show_I_friend($id)
	{
		global $tpl, $db;
		if (!class_exists('SiteusersPrototype')) {
		    require(RP."mod/siteusers/lib/class.SiteusersPrototype.php");
		}
		$tpl->newBlock('block_i_friends');
		$query = "SELECT u.id,u.email,u.username
					FROM ".$this->table_prefix."_blogs_friends f, core_users u
					WHERE f.friend_id=".$id." AND f.siteuser_id=u.id
					ORDER BY u.username";
		if ($db->query($query)) {
			while ($db->next_record()) {
				$tpl->newBlock('block_i_friend');
				$tpl->assign(array(
						"siteusername"	=> $db->f("username"),
						"email"		=> $db->f("email"),
						"profile_link"	=> SiteusersPrototype::getUserLink($db->f("username"))
					));
			}
			return TRUE;
		}
		return FALSE;
	}

	/**
	 * Имеет ли пользователь друзей
	 *
	 * @param int $id
	 * @return boolean
	 */
	function has_friends($id)
	{
		global $db;
		$db->query("SELECT siteuser_id FROM ".$this->table_prefix."_blogs_friends WHERE siteuser_id="
		    .intval($id)." LIMIT 1");
		return $db->nf() ? true : false;
	}

	/**
	 * Проверка на друга
	 *
	 * @param int $id
	 * @return boolean FALSE - ошибка, TRUE - OK
	 */
	function is_friend($id)
	{
		global $db;
		$ret = false;
		if ($_SESSION["siteuser"]["id"]) {
			$db->query("SELECT count(*) as cnt FROM ".$this->table_prefix."_blogs_friends
					WHERE siteuser_id=".$_SESSION["siteuser"]["id"]."
						AND friend_id=".intval($id));
			$db->next_record();
			$ret = $db->f('cnt') ? TRUE : FALSE;
		}

		return $ret;
	}

	/**
	 * Проверка: Я друг?
	 *
	 * @param int $id
	 * @return boolean FALSE - ошибка, TRUE - OK
	 */
	function is_I_friend($id)
	{
		global $db;
		$query = "SELECT count(*) as cnt FROM ".$this->table_prefix."_blogs_friends
					WHERE siteuser_id=".intval($id)."
						AND friend_id=".$_SESSION["siteuser"]["id"];
		$db->query($query);
		$db->next_record();
		return ($db->f('cnt')) ? TRUE : FALSE;
	}

	/**
	 * Добавление друга
	 *
	 * @param int $id
	 * @return boolean FALSE - ошибка, TRUE - OK
	 */
	function add_friend($id)
	{
		global $db;
		$query = "REPLACE INTO ".$this->table_prefix."_blogs_friends
					SET siteuser_id=".$_SESSION["siteuser"]["id"].",
						friend_id=".intval($id);
		return ($db->query($query)) ? TRUE : FALSE;
	}

	/**
	 * Удаление друга
	 *
	 * @param int $id
	 * @return boolean FALSE - ошибка, TRUE - OK
	 */
	function delete_friend($id)
	{
		global $db;
		if (is_array($id) && !empty($id)) {
			$id = "(".implode(",", array_map("intval", $id)).")";
		} else {
		    $id = "(".intval($id).")";
		}
		$query = "DELETE FROM ".$this->table_prefix."_blogs_friends
					WHERE siteuser_id=".$_SESSION["siteuser"]["id"]."
						AND friend_id IN ".$id;
		return ($db->query($query)) ? TRUE : FALSE;
	}

	/**
	 * Отображение информации о пользователе
	 *
	 * @param int $id
	 * @param int $full_mode
	 * @return boolean FALSE - ошибка, TRUE - OK
	 */
	function show_profile($id, $full_mode = 1, $transurl)
	{
		global $CONFIG, $db, $tpl, $BLOG_CUR_USER;
		$rows = ((int)$rows) ? (int)$rows : 5;
		$query = "SELECT * FROM core_users u WHERE u.id=".$id;
		if ($db->query($query)) {
			if ($db->next_record()) {
			    if (!class_exists('SiteusersPrototype')) {
    			    require(RP."mod/siteusers/lib/class.SiteusersPrototype.php");
    			}
			    $user_link = SiteusersPrototype::getUserLink($db->f("username"));
				$tpl->assign(array(
						"_ROOT.siteusername"	=> $db->f("username"),
						"_ROOT.email"			=> $db->f("email"),
						"_ROOT.profile_link"	=> $this->transurl."&action=showprofile", //&siteuser=".$db->f("username"),
						"_ROOT.user_link"	=> $user_link,
					));
				$tpl->newBlock($db->f("gender") == 'm' ? 'block_male' : 'block_female');

				$BLOG_CUR_USER["name"]	= $db->f("username");
				$BLOG_CUR_USER["site"]	= $db->f("url");
				$BLOG_CUR_USER["about"]	= $this->transurl."&action=showprofile";
				$BLOG_CUR_USER["home"]	= $this->transurl;
				$siteusername = $db->f("siteusername");
				if ($full_mode && $this->is_authorized && $_SESSION["siteuser"]["id"] !== $db->f("id")) {
					if ($this->is_friend($db->f("id"))) {
						$tpl->newBlock('block_it_is_friend');
						$tpl->assign(array(
								"delete_friend_link" => $this->transurl.(($CONFIG["rewrite_mod"]) ? ""
								    : '&siteuser='.$siteusername."&")."action=delfriend",
							));
					} else {
						$tpl->newBlock('block_add_to_friends');
						$tpl->assign(array(
								"add_friends_link" => $this->transurl.(($CONFIG["rewrite_mod"]) ? ""
								    : '&siteuser='.$siteusername."&")."action=addfriend",
							));
					}
				}
			}
			if ($full_mode) {
				$this->show_friends($id, $transurl);
				$this->show_I_friend($id);
			}
			return TRUE;
		}
		return FALSE;
	}

	/**
	 * Получение постраничной информации о блогах
	 *
	 * @param int $siteuser_id,
	 * @param int $start,
	 * @param int $rows
	 * @return boolean FALSE - ошибка, array - массив данных
	 */
	function get_blogs($siteuser_id, $start, $rows)
	{
        global $db;
		$siteuser_id	= (int)$siteuser_id;
		if (!$siteuser_id) {
			return FALSE;
		}
		$start			= (int)$start;
		$start = ($start) ? $start : 1;
		$rows			= (int)$rows;

		$query = "SELECT b.id,b.date AS _date,DATE_FORMAT(b.date,'".$this->blog_date_mask."') as date,b.title,
						b.announce,LENGTH(b.content) as content_length,b.author_id,
						b.comments_type, b.preview,
						u.email,u.username"
						.(defined('COMMENTS_BLOG_TYPE') ? ", count(c.id) as cnt_comments " : "").
					" FROM ".$this->table_prefix."_blogs b					
					INNER JOIN core_users u ON b.author_id=u.id".
					(defined('COMMENTS_BLOG_TYPE') 
					? " LEFT JOIN {$this->table_prefix}_comments_resource r ON (r.item_id=b.id AND r.type="
					.COMMENTS_BLOG_TYPE.") LEFT JOIN {$this->table_prefix}_comments c ON c.resrc_id=r.id" : "").
					" WHERE b.author_id=".$siteuser_id." AND b.active=1 GROUP BY b.id
					ORDER BY _date DESC LIMIT ".(($start-1)*$rows).",".$rows;
		return $db->getArrayOfResult($query);
	}
	function get_blogs_count($siteuser_id)
	{
        global $db;
		$siteuser_id	= (int)$siteuser_id;
		if (!$siteuser_id) {
			return FALSE;
		}
		$db->query("SELECT COUNT(*) FROM ".$this->table_prefix."_blogs WHERE author_id=".$siteuser_id." AND active");
		$db->next_record();
		return $db->Record[0];
	}

	function has_user_blog($user_id)
	{
        global $db;
		$db->query("SELECT id FROM  ".$this->table_prefix."_blogs WHERE author_id=".intval($user_id)." AND active LIMIT 1");
		return $db->nf() ? true : false;
	}

	/**
	 * Отображение постраничной информации о блогах
	 *
	 * @param int $siteuser_id,
	 * @param int $start,
	 * @param int $rows
	 * @return boolean FALSE - ошибка, TRUE - OK
	 */
	function show_blogs($siteuser_id, $start, $rows, $transurl, $action = 'showblogs')
	{
		global $tpl, $CONFIG;
		if ($arr = $this->get_blogs($siteuser_id, $start, $rows)) {
			for($i=0; $i < sizeof($arr); $i++) {
				$tpl->newBlock('block_blog_row');
				$url = $this->get_transurl($transurl, $arr[$i]["username"]);
				$tpl->assign(array(
						"blog_id"			=> $arr[$i]["id"],
						"blog_date"			=> $this->format_date($arr[$i]["date"]),
						"blog_announce"		=> $arr[$i]["announce"],
						"blog_title"		=> $arr[$i]["title"],
						"email"     		=> $arr[$i]["email"],
						"username"    		=> $arr[$i]["username"],
						"blog_details_link"	=> $url."action=showblog&blog=".$arr[$i]["id"],
					));
				if ($siteuser_id == $_SESSION["siteuser"]["id"]) {
					$tpl->newBlock('block_edit_link');
					$tpl->assign(array(
						"blog_edit_link"	=> $url."action=editblog&blog=".$arr[$i]["id"],
						"blog_delete_link"	=> $url."action=delblog&blog=".$arr[$i]["id"],
						));
				}
				if ($arr[$i]["content_length"]) {
					$tpl->newBlock('block_more_link');
					$tpl->assign(array(
							"blog_more_url"	=> $url."action=showblog&blog=".$arr[$i]["id"],
						));
				}
				$tpl->newBlock('block_comments');
				if ($arr[$i]["cnt_comments"]) {
					$tpl->newBlock('block_comments_show');
					$tpl->assign(array(
							"comments_link"	=> $url."action=showblog&blog=".$arr[$i]["id"],
							"cnt_comments"	=> $arr[$i]["cnt_comments"],
						));
				} else {
					$tpl->newBlock('block_no_comments');
				}
				if ($arr[$i]["author_id"] == $_SESSION["siteuser"]["id"]		// комментирует автор
					|| $arr[$i]["comments_type"] == 0							// комментируют все
					|| ($arr[$i]["comments_type"] == 1 && $this->is_authorized)	// комментируют зарегистрированные
					|| ($arr[$i]["comments_type"] == 2 && $this->is_authorized && $this->is_I_friend($arr[$i]["author_id"]))) {// комментируют друзья
					$tpl->newBlock('block_write_message');
					$tpl->assign(array(
							"write_msg_url"	=> $url."action=showblog&blog=".$arr[$i]["id"]."&answer=yes",
						));
				}
				$preview_path = $CONFIG['blogs_img_path'].$arr[$i]["preview"];
				if ($arr[$i]["preview"] && file_exists(RP.$preview_path)) {
				    $preview_inf = getimagesize(RP.$preview_path);
				    $tpl->newBlock('block_preview');
					$tpl->assign(
                        array(
                            "preview_path"	=> "/".$preview_path,
                            "preview_attr"	=> $preview_inf[3],
                            "blog_details_link"	=> $url."action=showblog&blog=".$arr[$i]["id"],
						)
					);
				}
			}
			Pager::Build(
			    $this->get_blogs_count($siteuser_id),
			    $rows,
			    $start,
			    $url."action=".$action
			);
			return TRUE;
		}
		return FALSE;
	}

	/**
	 * Отображение информации о блоге
	 *
	 * @param int $id,
	 * @param string $write_answer,
	 * @return boolean FALSE - ошибка, array - массив данных
	 */
	function show_blog($id, $write_answer, $transurl)
	{
        global $CONFIG, $db, $tpl, $BLOG_CUR_USER;
		$id				= (int)$id;
		if (!$id) {
			return FALSE;
		}
		$query = "SELECT b.id,DATE_FORMAT(b.date,'".$this->blog_date_mask."') as date,b.title,CONCAT(b.announce,b.content) as content,
						b.comments_type,b.author_id,b.image,u.username,u.email
					FROM ".$this->table_prefix."_blogs b, core_users u
					WHERE b.id=".$id." AND b.author_id=u.id AND b.active=1";
		$db->query($query);
		if ($db->next_record()) {
		    $tpl->newBlock('block_blog');
			if ($db->f("img")) {
				$BLOG_CUR_USER["avatar_img"] = "/".$CONFIG['img_path'].$db->f("img");
			}
			if (!class_exists('SiteusersPrototype')) {
			    require(RP."mod/siteusers/lib/class.SiteusersPrototype.php");
			}
			$user_link = SiteusersPrototype::getUserLink($db->f("username"));
			$url = $this->get_transurl($transurl, $db->f("username"));
			$BLOG_CUR_USER["name"]	= $db->f("username");
			$BLOG_CUR_USER["site"]	= $db->f("url");
			$BLOG_CUR_USER["about"]	= $user_link;
			$BLOG_CUR_USER["home"]	= $this->transurl;
			$tpl->assign(array(
				"blog_id"			=> $db->f("id"),
				"blog_date"		=> $this->format_date($db->f("date")),
				"blog_content"	=> $db->f("content"),
				"blog_title"		=> $db->f("title"),
			));
			if ($BLOG_CUR_USER["avatar_img"]) {
				$tpl->newBlock('block_user_img');
				$tpl->assign(array(
					"siteuserimg"	=> $BLOG_CUR_USER["avatar_img"],
				));
			}

			$image_name = $db->f('image');
			$image_path = $CONFIG['blogs_img_path'].$image_name;
			if ($image_name && file_exists(RP.$image_path)) {
			    $image_inf = getimagesize(RP.$image_path);
			    $tpl->newBlock('block_image');
			    $tpl->assign(
                    array(
                        "image_path"	=> "/".$image_path,
                        "image_attr"	=> $image_inf[3],
                    )
				);
			}
			$tpl->newBlock('block_author');
			$tpl->assign(array(
			    "author_link"	=> $user_link,
			    "siteusername"	=> $db->f("username"),
			    "email"		=> $db->f("email")
			));
			if ($db->f("author_id") == $_SESSION["siteuser"]["id"]) {
				$tpl->newBlock('block_edit_link');
				$tpl->assign(array(
				    "blog_edit_link"	=> $url."action=editblog&blog=".$db->f("id"),
					"blog_delete_link"	=> $url."action=delblog&blog=".$db->f("id"),
				));
			}
			/*
			if ($write_answer === "yes") {
					$tpl->newBlock('block_message_form');
					$tpl->assign(array(
							"form_action"	=> $url."action=addcomment",
							"blog_id"		=> $id,
							"referer"		=> $_SERVER['HTTP_REFERER'],
						));
			} else {
				if ($db->f("author_id") == $_SESSION["siteuser"]["id"]	// комментирует автор
					|| $comments_type == 0								// комментируют все
					|| ($comments_type == 1 && $this->is_authorized)	// комментируют зарегистрированные
					|| ($comments_type == 2 && $this->is_authorized && $this->is_I_friend($db->f("author_id")))) {// комментируют друзья
					$tpl->newBlock('block_write_message');
					$tpl->assign(array(
							"write_msg_url"	=> $url."action=showblog&blog=".$id."&answer=yes",
						));
				}
				$tpl->newBlock('block_comments');
				$this->show_blog_comments($id);
			}
			*/
		} else {
		     $tpl->newBlock('block_not_exists');
		}
		return FALSE;
	}

	/**
	 * Получение информации о блоге для редактирования
	 *
	 * @param int $id,
	 * @param int $siteuser_id,
	 * @return boolean FALSE - ошибка, array - массив данных
	 */
	function get_blog_data($id, $siteuser_id = 0)
	{
        global $db;
		$id				= (int)$id;
		$siteuser_id	= (int)$siteuser_id;
		if (!$id) {
			return FALSE;
		}

		$query = "SELECT * FROM ".$this->table_prefix."_blogs
					WHERE id=".$id.(($siteuser_id) ? " AND author_id=".$siteuser_id : "");
		$res_arr = $db->getArrayOfResult($query);
		return $res_arr[0];
	}

	/**
	 * Сохранение информации о блоге
	 *
	 * @param array $data
	 * @return boolean FALSE - ошибка сохранения, TRUE - сохранено
	 */
	function update_blog(&$data)
	{
		global $db;

		$data["id"]				= (int)$data["id"];
		$blog_title				= $db->escape(htmlspecialchars(trim($data["title"])));

		$data["content"]		= strip_tags(trim($data["content"]), $this->blog_allowable_tags);
		$data["comments_type"]	= (int)$data["comments_type"];
		$content = preg_split("/<p class=\"SPLITER\">.*<\/p>/U", $data["content"]);
		$announce = $db->escape(trim(array_shift($content))); //
		$content = $db->escape(trim(implode('', $content)));  //

		$query = $this->table_prefix."_blogs SET title='".$blog_title."', announce='".$announce."', content='"
		    .$content."', comments_type=".$data["comments_type"].', active='.($data['active'] ? 1 : 0);

		if ($data["id"]) {
			$query = "UPDATE ".$query." WHERE id=".$data["id"];//." AND author_id=".$_SESSION["siteuser"]["id"];
			return $db->query($query);
		} else {
			$query = "INSERT INTO ".$query.", author_id=".$_SESSION["siteuser"]["id"].", date=NOW()";
			if ($db->query($query)) {
			    $data["id"] = $db->lid();
			    return TRUE;
			}
		}

		return FALSE;
	}

	function upload_file(&$data)
	{
		global $CONFIG, $main, $db;

		if (! $data['id']) return FALSE;

		$update = FALSE;
		$err = TRUE;
		if ($data['del_img']) {
		    if ($data['image']) {
		    	unlink(RP.$CONFIG['blogs_img_path'].$data['image']);
		    }
		    if ($data['preview']) {
		    	unlink(RP.$CONFIG['blogs_img_path'].$data['preview']);
		    }
		    $data['image'] = $data['preview'] = '';
		    $update = TRUE;
		}

		if (@$_FILES['image']['name']) {
			$up_img = $_FILES['image'];
			if ( is_uploaded_file($up_img['tmp_name']) ) {
			    // Проверка типа файла
				if (in_array($up_img['type'], $this->allow_img_typs)) {
				    $image_name = $data["id"].".".$this->img_expansions[$up_img['type']];
				    $preview_name = $data["id"]."s".".".$this->img_expansions[$up_img['type']];
				    $image_path = RP.$CONFIG['blogs_img_path'].$image_name;
				    $preview_path = RP.$CONFIG['blogs_img_path'].$preview_name;
					// Проверка ограничений на макс. размер файла
					if (filesize($up_img['tmp_name']) <= $CONFIG['blogs_img_max_size']*1024) {
						move_uploaded_file($up_img['tmp_name'], $image_path);
						list($width, $height) = getimagesize($image_path);
						if ($width > $CONFIG['blogs_img_max_width']
                            || $height > $CONFIG['blogs_img_max_height']) {
							/* Сжимаем до макс. размеров */
    						$main->generate_image(
                                $image_path,
                                $image_path,
                                $CONFIG['blogs_img_max_width'],
                                $CONFIG['blogs_img_max_height'],
                                "resize",
                                "",
                                "",
                                100);
						}

                        /* Создаём превьюшку */
                        $main->generate_image(
                            $image_path,
                            $preview_path,
                            $CONFIG['blogs_preview_max_width'],
                            $CONFIG['blogs_preview_max_height'],
                            "resize",
                            "",
                            "",
                            100);
						@chmod($image_path, 0666);
						@chmod($preview_path, 0666);
						$data['image'] = $image_name;
						$data['preview'] = $preview_name;
						$update = TRUE;
						$err = FALSE;
					}
				}
			}
		} else {
		    $err = FALSE;
		}

		if ($update) {
		    $query = "UPDATE ".$this->table_prefix."_blogs SET";
    		$query .= " image='".$data["image"]."', preview='".$data["preview"]."'";
    		$query .= " WHERE id = ".$data['id']." AND author_id=".$_SESSION["siteuser"]["id"];
    		return $db->query($query);
		}

		return !$err;
	}

	/**
	 * Удаление информации о блоге
	 *
	 * @param int $blog_id
	 * @param int $siteuser_id
	 * @return boolean FALSE - ошибка, TRUE - ОК
	 */
	function delete_blog($blog_id, $siteuser_id)
	{
        global $db, $CONFIG;
		$blog_id				= (int)$blog_id;
		$siteuser_id			= (int)$siteuser_id;
		$blog_data = $this->get_blog_data($blog_id, $siteuser_id);
		if (! $blog_data) return FALSE;
		$query	=  'DELETE FROM '.$this->table_prefix.'_blogs WHERE id='.$blog_id.(($siteuser_id)?' AND author_id='.$siteuser_id:'');
		$db->query($query);
		if ($db->affected_rows()) {
		    /*
			$query	=  'DELETE FROM '.$this->table_prefix.'_blogs_comments WHERE blog_id='.$blog_id;
			$db->query($query);
			*/
			if ($blog_data['image']) {
				@unlink(RP.$CONFIG['blogs_img_path'].$blog_data["image"]);
			}
			if ($blog_data['preview']) {
				@unlink(RP.$CONFIG['blogs_img_path'].$blog_data["preview"]);
			}
			if (file_exists(RP."mod/comments")) {
				require_once(RP."mod/comments/lib/class.CommentsPrototype.php");
				$comm = new CommentsPrototype('only_create_object');
				$comm->delResource($blog_id, COMMENTS_BLOG_TYPE);
			}
			return TRUE;
		}

		return FALSE;
	}

	/**
	 * Удаление коментария блога
	 *
	 * @param int $comment_id
	 * @return boolean FALSE - ошибка, TRUE - ОК
	 */
	/*
	function delete_comment($comment_id)
	{
        global $db;
		$comment_id   = (int)$comment_id;

		$query	=  'DELETE FROM '.$this->table_prefix.'_blogs_comments WHERE id='.$comment_id;
		$db->query($query);

		return $db->affected_rows() ? TRUE : FALSE;
	}
	*/

	/**
	 * Вывод поисковой информации о пользователях
	 *
	 * @param array $sdata
	 * @return boolean FALSE - ошибка, TRUE - ОК
	 */
	function show_search_result($sdata, $transurl) {
    global $CONFIG, $db, $tpl;
    $sdata["surname"] = str_replace(array("<", ">", "\"", "'", ".", "@"), "", $sdata["surname"]);
    $sdata["surname"] = str_replace('\\', '', $sdata["surname"]);
    $sdata["siteusername"] = str_replace(array("<", ">", "\"", "'", ".", "@"), "", $sdata["siteusername"]);
    $sdata["siteusername"] = str_replace('\\', '', $sdata["siteusername"]);
    if($sdata["siteusername"]){$sdata["username"]=&$sdata["siteusername"];unset($sdata["siteusername"]);};
		$sdata["username"]	= addslashes($db->escape(trim($sdata["username"])));
		$sdata["surname"]		= addslashes($db->escape(trim($sdata["surname"])));
		$sdata["firstname"]		= addslashes($db->escape(trim($sdata["firstname"])));

		$search_filter = array();
		foreach($sdata as $name => $value){
			if ($value)
				$search_filter[] = $name." LIKE '%".$value."%'";
		}
		if (sizeof($search_filter) == 0) return FALSE;

		$db->query("SELECT u.*, DATE_FORMAT(max(b.date),'".$this->blog_date_mask."') as date
					FROM core_users u
					INNER JOIN ".$this->table_prefix."_blogs b ON u.id = b.author_id
					WHERE ".implode(' AND ', $search_filter)."
					GROUP BY u.id");
		if ($db->nf()) {
			if (!class_exists('SiteusersPrototype')) {
    			require(RP."mod/siteusers/lib/class.SiteusersPrototype.php");
    		}
			while ($db->next_record()) {
				$tpl->newBlock('block_siteuser');
			    $user_link = SiteusersPrototype::getUserLink($db->f("username"));
			    $baseurltmp = $this->get_transurl($transurl, $db->Record['username']);
				$tpl->assign(array(
								"siteusername"	=> $db->f('username'),
								"email"		=> $db->f('email'),
								"last_date"		=> $this->format_date($db->f('date')),
								"blog_link"		=> $baseurltmp,
							));
			}
		} else {
			$tpl->newBlock('block_not_found');
		}
	}

	/**
	 * Вывод информации о самых обсуждаемых блогах
	 *
	 * @param int $cnt
	 * @return boolean FALSE - ошибка, TRUE - ОК
	 */
	function show_discuss_blogs($cnt, $transurl)
	{
		if ($cnt < 1) return TRUE;
        global $CONFIG, $db, $tpl;

		$tpl->newBlock('block_discuss_blogs');
//							u.username, su.group_id, count( c.date ) AS cnt_comments
		$db->query(
            " SELECT b.id, b.title, DATE_FORMAT(b.date,'%d %m %Y | %H:%i') as date, u.username"
			.(defined('COMMENTS_BLOG_TYPE') ? ", count(c.id)" : ", 0")." as cnt_comments".
            " FROM {$this->table_prefix}_blogs b ".
            " INNER JOIN core_users u on (b.author_id=u.id) ".
            (defined('COMMENTS_BLOG_TYPE') 
				? " LEFT JOIN {$this->table_prefix}_comments_resource r ON (r.item_id=b.id AND r.type="
				.COMMENTS_BLOG_TYPE.") LEFT JOIN {$this->table_prefix}_comments c ON c.resrc_id=r.id" : "").
            " WHERE b.active = 1 ".
            " GROUP BY b.id ".
            " ORDER BY cnt_comments DESC ".
            " LIMIT 0, ".intval($cnt)
        );

		if ($db->nf()) {
		    if (!class_exists('SiteusersPrototype')) {
			    require(RP."mod/siteusers/lib/class.SiteusersPrototype.php");
			}
			while ($db->next_record()) {
			    $user_link = SiteusersPrototype::getUserLink($db->f("username"));
			    $baseurltmp = $this->get_transurl($transurl, $db->Record['username']);
				$tpl->newBlock('block_blog_info');
				$tpl->assign(array(
				    "blog_link"			=> $baseurltmp."action=showblog&blog=".$db->f('id'),
					"blog_title"		=> $db->f('title'),
					"cnt_comments"		=> $db->f('cnt_comments'),
					"blog_date"			=> $this->format_date($db->f('date')),
					"siteusername"		=> $db->f('username'),
					"user_blog_link"	=> $user_link,
				));
			}
		}
	}

	/**
	 * Вывод информации о новых блогах
	 *
	 * @param int $cnt
	 * @return boolean FALSE - ошибка, TRUE - ОК
	 */
	function show_new_blogs($cnt, $transurl)
	{
		if ($cnt < 1) return TRUE;
        global $CONFIG, $db, $tpl;

		$tpl->newBlock('block_new_blogs');
		$db->query("SELECT b.id, b.title, DATE_FORMAT(b.date,'".$this->blog_date_mask
		    ."') as date_txt, u.username FROM ".$this->table_prefix."_blogs b "
		    ." INNER JOIN core_users u ON b.author_id = u.id WHERE  b.active = 1"
		    ." ORDER BY b.date DESC LIMIT 0, ".intval($cnt));
		if ($db->nf()) {
			if (!class_exists('SiteusersPrototype')) {
			    require(RP."mod/siteusers/lib/class.SiteusersPrototype.php");
			}
			while ($db->next_record()) {
			    $user_link = SiteusersPrototype::getUserLink($db->f("username"));
				$tpl->newBlock('block_new_blog_info');
				$baseurltmp = $this->get_transurl($transurl, $db->Record['username']);
				$tpl->assign(array(
								"blog_link"			=> $baseurltmp."action=showblog&blog=".$db->f('id'),
								"blog_title"		=> $db->f('title'),
								"blog_date"			=> $this->format_date($db->f('date_txt')),
								"siteusername"		=> $db->f('username'),
								"user_blog_link"	=> $user_link,
							));
			}
		}
	}

	/**
	 * Вывод информации о случайных блогах
	 *
	 * @param int $cnt
	 * @return boolean FALSE - ошибка, TRUE - ОК
	 */
	function show_random_blogs($cnt, $transurl)
	{
		if ($cnt<1) return TRUE;
        global $CONFIG, $db, $tpl;

		$tpl->newBlock('block_random_blogs');
		$ids = array();
		$query = 'SELECT id FROM '.$this->table_prefix.'_blogs WHERE active=1';
		$db->query($query);
		if ($db->nf()) {
			while ($db->next_record()) {
			    $ids[] = $db->f('id');
			}
		}
		if ($cnt > count($ids)) {
		    $rand_keys = array_keys($ids);
		} else {
		    $rand_keys = array_rand($ids, $cnt);
		}
		if (is_array($rand_keys)) {
			foreach($rand_keys as $key) {
				$needed_ids[] = $ids[$key];
			}
		} else {
			$needed_ids = array($ids[$rand_keys]);
		}
		if (! empty($needed_ids)){
			$db->query( "SELECT b.id, b.title, DATE_FORMAT(b.date,'".$this->blog_date_mask."') as date_txt, u.username"
			    .(defined('COMMENTS_BLOG_TYPE') ? ", count(c.id)" : ", 0")." as cnt_comments".
				" FROM ".$this->table_prefix."_blogs b
				INNER JOIN core_users u ON b.author_id = u.id".
                (defined('COMMENTS_BLOG_TYPE')
				? " LEFT JOIN {$this->table_prefix}_comments_resource r ON (r.item_id=b.id AND r.type="
				    .COMMENTS_BLOG_TYPE.") LEFT JOIN {$this->table_prefix}_comments c ON c.resrc_id=r.id"
				: "").
				" WHERE b.id IN (".implode(',', $needed_ids).") GROUP BY b.id"
			);
			if ($db->nf()) {
				if (!class_exists('SiteusersPrototype')) {
    			    require(RP."mod/siteusers/lib/class.SiteusersPrototype.php");
    			}
    			while ($db->next_record()) {
    			    $user_link = SiteusersPrototype::getUserLink($db->f("username"));
					$tpl->newBlock('block_rnd_blog_info');
					$baseurltmp = $this->get_transurl($transurl, $db->Record['username']);
					$tpl->assign(array(
									"blog_link"			=> $baseurltmp."action=showblog&blog=".$db->f('id'),
									"blog_title"		=> $db->f('title'),
									"blog_date"			=> $this->format_date($db->f('date_txt')),
									"siteusername"		=> $db->f('username'),
									"user_blog_link"	=> $user_link,
									"cnt_comments"		=> $db->f('cnt_comments'),
								));
				}
			}
		}
	}

	/**
	 * Вывод информации об активных блогерах
	 *
	 * @param int $cnt
	 * @return boolean FALSE - ошибка, TRUE - ОК
	 */
	function show_best_blogers($cnt)
	{
		if ($cnt<1) return TRUE;
        global $CONFIG, $db, $tpl;

		$tpl->newBlock('block_best_blogers');
		$db->query("SELECT count(*) as cnt, u.username
					FROM ".$this->table_prefix."_blogs b INNER JOIN core_users u ON b.author_id = u.id
					WHERE b.active = 1
					GROUP BY u.id DESC
					ORDER BY cnt DESC
					LIMIT 0, ".intval($cnt));
		if ($db->nf()) {
			if (!class_exists('SiteusersPrototype')) {
			    require(RP."mod/siteusers/lib/class.SiteusersPrototype.php");
			}
			while ($db->next_record()) {
			    $user_link = SiteusersPrototype::getUserLink($db->f("username"));
				$tpl->newBlock('block_best_bloger_info');
				$tpl->assign(array(
								"siteusername"		=> $db->f('username'),
								"user_blog_link"	=> $user_link,
							));
			}
		}
	}


	function format_date($date) {
		$date = explode(" ", $date);
		$date[1] = $this->months[$date[1]];
		return implode(" ", $date);
	}


	function getPropertyFields() {
		GLOBAL $request_sub_action;
		if ('' != $request_sub_action) {

			$tpl = $this->getTmpProperties();

			switch ($request_sub_action) {
				case 'showlist':
					$tpl->newBlock('block_properties');
					$tpl->assign(array(
						"MSG_Blogs_quantity"	=> $this->_msg["Blogs_quantity"],
					));
					break;

				case 'showblogs':
					$tpl->newBlock('block_users');
					$tpl->assign(array(
						"MSG_User_login"	=> $this->_msg["User_login"],
					));
					break;

				case 'blogsannounce':
					$tpl->newBlock('block_announce');
					$tpl->assign(array(
						"MSG_Quantity_more_discussed"	=> $this->_msg["Quantity_more_discussed"],
						"MSG_Quantity_random"			=> $this->_msg["Quantity_random"],
						"MSG_Quantity_active_authors"	=> $this->_msg["Quantity_active_authors"],
					));
					break;

				default:
					$tpl->newBlock('block_properties_none');
					$tpl->assign(array(
						"MSG_No"	=> $this->_msg["No"],
					));
					break;
			}
			return $this->getOutputContent($tpl->getOutputContent());
		}
		return FALSE;
	}

	function getEditLink($sub_action = NULL, $block_id = NULL) {
		GLOBAL $request_name, $db, $lang, $server;
		$block_id	= (int)$block_id;
		if ($sub_action && $block_id) {
			$db->query('SELECT	property1,
								property2,
								property3,
								property4,
								property5
							FROM '.$this->table_prefix.'_pages_blocks
							WHERE id = '.$block_id);
			if ($db->nf() > 0) {
				$db->next_record();
				$arr[]	= $db->f('property1');
				$arr[]	= $db->f('property2');
				$arr[]	= $db->f('property3');
				$arr[]	= $db->f('property4');
				$arr[]	= $db->f('property5');

				switch ($sub_action) {
					default:
						$link['material_url']	= '';
						$link['material_id']	= '';
						break;
				}
				return $link;
			}

			switch ($sub_action) {
				default:
					$link['material_url']	= '';
					$link['material_id']	= '';
					break;
			}
			return $link;
		}
		return FALSE;
	}
/*********************************
 *
 *		Вывод списка блогов
 *
 *
 ********************************/
	function show_list(){
		global $CONFIG, $db, $tpl, $baseurl;
		if (strstr($_SERVER['PHP_SELF'], 'admin.php')) $admin = 1;

		$this->get_list_with_rights(
				'C.*, `core_users`.username as username'.(defined('COMMENTS_BLOG_TYPE') ? ", count(cm.id)" : ", 0")." as cnt_comments",  			//список возвращаемых полей
				$this->table_prefix.'_blogs AS C LEFT JOIN `core_users` ON `core_users`.id=C.author_id'.
                (defined('COMMENTS_BLOG_TYPE') 
				? " LEFT JOIN {$this->table_prefix}_comments_resource r ON (r.item_id=C.id AND r.type="
				.COMMENTS_BLOG_TYPE.") LEFT JOIN {$this->table_prefix}_comments cm ON cm.resrc_id=r.id" : ""), 	//список таблиц, учавствующих в запросе
				'C',  												//алиас основной таблицы, из которой берутся права
				'', 'C.id');  		//условие-фильтр, группировка записей, порядок вывода записей


		$cnt = $db->nf();
		if ($cnt) {
			$actions = array(	'edit'		=> 'editblog',
								'activate'	=>	array('pactivate', 'psuspend'),
								'editrights'=> 'editblogrights',
								'delete'	=> 'delblog',
								'confirm_delete'	=> $this->_msg['Del_action'],);

			while ($db->next_record()) {
				if ($only_editable && !($db->f('user_rights') & 2)) continue;

				$id	= intval($db->f('id'));

				$adm_actions	= $this->get_actions_by_rights($baseurl."&category=".$id, $db->f("active"), $db->f("is_owner"), $db->f("user_rights"), $actions);
		/*
		SELECT C.*, `core_users`.username as username, 1 as is_owner, 15 AS user_rights FROM new_rus_blogs AS C, `core_users`
				WHERE `core_users`.id=C.author_id AND 1 ORDER BY C.id
		*/
				$title = htmlspecialchars($db->f('title'));
				$author = htmlspecialchars($db->f('username'));
				// Обрезаем все таги и заменяем таги <img /> на [img]
				$T = preg_replace(
						 array('(\<img(/?[^\>]+)\>)',
									'(\<(/?[^(img)|^\>]+)\>)'),
						 array('<img src=\'/i/admin/ico_img.gif\'/> ',
									' '),
						$db->f('announce')
				);

        		//$mail = htmlspecialchars(stripslashes($db->f("mail")));
				$selected = ($id == $selected_category) ? " selected" : "";
			//!----
				$trim_len = 250;
				$tpl->newBlock('blog');
				$tpl->assign(array(
				  'change_status_action'	=>	$adm_actions['change_status_action'],
					'blog_edit_action' =>	$adm_actions['edit_action'],
					'blog_edit_rights_action'	=>	$adm_actions['edit_rights_action'],
					'blog_del_action'	=>	$adm_actions['delete_action'],
					'blog_title'	=>	$title,
					'blog_author' => $author,
					'blog_content' => (strlen($T)>$trim_len)? substr($T,0,$trim_len).'...':$T,
					'blog_link' => str_replace('name=blogs', 'name=comments', $baseurl).'&action=comments&type='.COMMENTS_BLOG_TYPE.'&item_id='.$id,
					'blog_id' => $id,
					'date' => $this->format_date($db->f('date')),
					'comments_count' => $db->f('cnt_comments'),
					'MSG_is' => $this->_msg['is'],
 				    'MSG_blog_ID' => $this->_msg['blog_id']

				));
				//	if ($adm_actions["rights"]["d"] || $adm_actions["rights"]["p"]) {  //проверка права редактирования блогов
					$tpl->newBlock('block_check');
					$tpl->assign("blog_id", $id);
					//}
			} // end while
			return $cnt;
		} //end if
		return FALSE;
	} // show_list()

/*********************************
 *
 *		Вывод списка комментариев
 *		$blog_id - ID блога
 *
 ********************************/
	function show_comments_list($blog_id){
		global $CONFIG, $db, $tpl, $baseurl;
	  $admin = Module::is_admin();
	  $blog_id = (int) $blog_id;
//* Вывод комментариев оставленных зарегестрированными пользователями
		$trim_len = 250;
		$this->get_list_with_rights(
				'C.*, `core_users`.username as username', //список возвращаемых полей
				$this->table_prefix.'_blogs_comments AS C LEFT JOIN `core_users` ON `core_users`.id=C.author_id ', //список таблиц, учавствующих в запросе
				'C', //алиас основной таблицы, из которой берутся права
				' C.blog_id ='.$blog_id, 'C.date'); //условие-фильтр, группировка записей, порядок вывода записей

		$cnt = $db->nf();
		if ($cnt) {
			$actions = array(	'edit'		=> 'editcomm',
								'activate'	=>	array('activcomm', 'suspcomm'),
								'editrights'=> 'editcommrights',
								'delete'	=> 'delcomm',
								'confirm_delete'	=> $this->_msg['Del_comm_action']);

			while ($db->next_record()) {
				if ($only_editable && !($db->f('user_rights') & 2)) continue;

				$id	= intval($db->f('id'));
				// косяк....
				$adm_actions	= $this->get_actions_by_rights($baseurl.'&id='.$id.'&blog='.$blog_id, $db->f('active'), $db->f('is_owner'), $db->f('user_rights'), $actions);
//				$adm_actions	= $this->get_actions_by_rights($baseurl."&category=".$id, $id, $db->f("is_owner"), $db->f("user_rights"), $actions);
		/*
		SELECT C.*, `core_users`.username as username, 1 as is_owner, 15 AS user_rights FROM new_rus_blogs AS C, `core_users`
				WHERE `core_users`.id=C.author_id AND 1 ORDER BY C.id
		*/
				$title = htmlspecialchars($db->f('title'));
				$author = htmlspecialchars($db->f('username'));
				$T = preg_replace(
						 array('(\<img(/?[^\>]+)\>)',
									'(\<(/?[^(img)|^\>]+)\>)'),
						 array('<img src=\'/i/admin/ico_img.gif\'/> ',
									' '),
						$db->f('comment')
				);
        		//$mail = htmlspecialchars(stripslashes($db->f("mail")));
				$selected = ($id == $selected_category) ? " selected" : "";
			//!----
				$tpl->newBlock('comments');
				$tpl->assign(array(
				    'change_status_action'	=>	$adm_actions['change_status_action'],
					'blog_edit_action' =>	$adm_actions['edit_action'],
					'blog_edit_rights_action'	=>	$adm_actions['edit_rights_action'],
					'comment_del_action'	=>	$adm_actions['delete_action'],
					'comment_author' => $author,
					'comment_content' => (strlen($T)>$trim_len)? substr($T,0,$trim_len).'...':$T, //
					'blog_link' => $baseurl.'&action=showcomments&blog='.$id,
					'blog_id' => $id,
					'date' => $this->format_date($db->f('date')),
					'MSG_is' => $this->_msg['is'],
 				    'MSG_blog_ID' => $this->_msg['blog_id']

				));
				//	if ($adm_actions["rights"]["d"] || $adm_actions["rights"]["p"]) {  //проверка права редактирования блогов
					$tpl->newBlock('block_check');
					$tpl->assign("blog_id", $id);
			//}
			} // end while
		} //end if

// Вывод комментариев оставленных гостями (
//+! За гостей считаем всех с user_id = 0
// $this->_msg['Guest']
		$this->get_list_with_rights(
				'C.*, \''.$this->_msg['Guest'].'\' as username', //список возвращаемых полей
				$this->table_prefix.'_blogs_comments AS C', //список таблиц, учавствующих в запросе
				'C', //алиас основной таблицы, из которой берутся права
				'(C.`author_id`=0) AND (C.blog_id ='.$blog_id.')', 'C.date'); //условие-фильтр, группировка записей, порядок вывода записей

		$cnt = $db->nf();
		if ($cnt) {
			$actions = array(	'edit'		=> 'editcomm',
								'activate'	=>	array('activcomm', 'suspcomm'),
								'editrights'=> 'editcommrights',
								'delete'	=> 'delcomm',
								'confirm_delete'	=> $this->_msg['Del_action']);

			while ($db->next_record()) {
				if ($only_editable && !($db->f('user_rights') & 2)) continue;

				$id	= intval($db->f('id'));

//				$adm_actions	= $this->get_actions_by_rights($baseurl."&category=".$id, $id, $db->f("is_owner"), $db->f("user_rights"), $actions);
				$adm_actions	= $this->get_actions_by_rights($baseurl."&id=".$id.'&blog='.$blog_id, $db->f("active"), $db->f("is_owner"), $db->f("user_rights"), $actions);		/*
		SELECT C.*, `core_users`.username as username, 1 as is_owner, 15 AS user_rights FROM new_rus_blogs AS C, `core_users`
				WHERE `core_users`.id=C.author_id AND 1 ORDER BY C.id
		*/
				$title = htmlspecialchars($db->f('title'));
				$author = htmlspecialchars($db->f('username'));
        		//$mail = htmlspecialchars(stripslashes($db->f("mail")));
				$selected = ($id == $selected_category) ? " selected" : "";
				$T = preg_replace(
						 array('(\<img(/?[^\>]+)\>)',
									'(\<(/?[^(img)|^\>]+)\>)'),
						 array('<img src=\'/i/admin/ico_img.gif\'/> ',
									' '),
						$db->f('comment')
				);

			//!----
				$tpl->newBlock('comments');
				$tpl->assign(array(

				  'change_status_action'	=>	$adm_actions['change_status_action'],
					'blog_edit_action' =>	$adm_actions['edit_action'],
					'blog_edit_rights_action'	=>	$adm_actions['edit_rights_action'],
					'blog_del_action'	=>	$adm_actions['delete_action'],
					'comment_author' => $author,
					'comment_content' => (strlen($T)>$trim_len)? substr($T,0,$trim_len).'...':$T,
					'blog_link' => $baseurl.'&action=showcomments&blog='.$id,
					'blog_id' => $id,
					'date' => $this->format_date($db->f('date')),
					'MSG_is' => $this->_msg['is'],
 				    'MSG_blog_ID' => $this->_msg['blog_id']

				));
				//	if ($adm_actions["rights"]["d"] || $adm_actions["rights"]["p"]) {  //проверка права редактирования блогов
					$tpl->newBlock('block_check');
					$tpl->assign("blog_id", $id);
			//}
			} // end while
		} //end if

		$db->query('SELECT * FROM '.$this->table_prefix.'_blogs WHERE id='.$blog_id.';');
		if ($db->nf()>0) {
			$db->next_record();
			return $db->f('title');
		}
		return FALSE;
	} //show_comments_list
/*
		function get_comment_data($id)
		{   global $db;
		
			$id = (int)$id;
			$siteuser_id = (int)$siteuser_id;
			if (!$id) {
				return FALSE;
			}
			$query = "SELECT * FROM ".$this->table_prefix."_blogs_comments
						WHERE id=".$id.(($siteuser_id) ? " AND author_id=".$siteuser_id : "");
			$res_arr = $db->getArrayOfResult($query);
			return $res_arr[0];
		}


		function update_comm($data)
		{   global $db;
		
		$data["id"] = (int)$data["id"];
		$comment = $db->escape(trim(strip_tags($data["announce"])));
		$query = 'UPDATE '.$this->table_prefix.'_blogs_comments SET
					`comment`=\''.$comment.
					'\' WHERE id='.$data['id'];//." AND author_id=".$_SESSION["siteuser"]["id"];
			return $db->query($query);
		}

		function getCountComment($id)
		{   global $db1;
    	    $query = 'SELECT  count(*) as count_comm FROM '.$this->table_prefix.'_blogs_comments WHERE blog_id='.$id;
          	$db1->query($query);
    		if ($db1->nf() > 0) {
    			$db1->next_record();
    			return $db1->f('count_comm');
    		}
        	return 0;
    	} // getCountComment
*/
    	function get_transurl($transurl, $username = '')
    	{
    	    global $CONFIG;
    		if ($CONFIG["rewrite_mod"]) {
    		    $url = parse_url($transurl);
    		    return $url['path'].("/" == substr($url['path'], -1) ? "" : "/")
    		        .($username ? $username."/" : "")."?";
    		} else {
    		    return $transurl.("&" == substr($transurl, -1) ? "" : "&")
    		        .($username ? "siteuser=".$username."&" : "");
    		}
    	}
    	
	function getCommentableItem($id)
	{   global $db;

	    $ret = false;
		$db->query("SELECT id, title, comments_type, author_id FROM ".$this->table_prefix."_blogs WHERE id=".intval($id));
		if ($db->next_record()) {
		    if (//$db->Record["author_id"] == $_SESSION["siteuser"]["id"] || 	// комментирует автор
				$db->Record["comments_type"] == 0							// комментируют все
				|| ($db->Record["comments_type"] == 1 && $this->is_authorized)	// комментируют зарегистрированные
				|| ($db->Record["comments_type"] == 2 && $this->is_authorized &&
				    ($db->Record["author_id"] == $_SESSION["siteuser"]["id"] || $this->is_I_friend($db->Record["author_id"]))
				)
			) {
		        $ret = array('id' => $id, 'title' => $db->Record['title']);
		    }
		}
		
		return $ret;

	}
}


?>