<?php // Vers 5.9.3 16.05.2016
/**
* индекс type задёт тип значения, возможные значения:
*	integer  - целое число
*	double   - вещественное число
*	string   - строка
*	checkbox - элемент допускающий установку/снятие галочки (тег <input type="checkbox">)
*	select   - выпадающий список
* индекс defval задаёт значение по умоляанию,
* индекс descr задаёт текстовое описание данного элемента, для вывода в качестве справки
* индекс access устанавливает уровень доступа, возможные значения
* 	public	- элемент доступен для чтения/изменения
*	final	- элемент доступен только для чтения
*	private - элемент не доступен
*/

define('COMMENTS_PRODUCT_TYPE', 1);
define('COMMENTS_NEWS_TYPE', 2);
define('COMMENTS_BLOG_TYPE', 3);
define('COMMENTS_ARTICLE_TYPE', 4);
define('COMMENTS_PHOTO_TYPE', 5);

$TYPES_NEW = array(
    'comments_max_rows' => array(
        'type' => 'integer',
        'defval' => '10',
        'descr' => array(
            'rus' => 'Количество записей на страницу',
            'eng' => 'Quantity of records on page'),
        'access' => 'editable'
    ),
    'comments_adm_order' => array(
        'type' => 'select',
        'defval' => array(
            'crt_date' => array(
                'rus' => 'в порядке добавления',
                'eng' => 'As it should be to addition'),
            'crt_date DESC' => array(
                'rus' => 'в порядке обратном добавлению',
                'eng' => 'As it should be the return to addition'),
        ),
        'descr' => array(
            'rus' => 'Порядок выводимых комментариев в адм. интерфейсе',
            'eng' => 'Order of deduced comments in administrative the interface'),
        'access' => 'editable'
    ),   
    'comments_crop_symbols' => array(
        'type' => 'integer',
        'defval' => '0',
        'descr' => array(
            'rus' => 'Количество символов выводимых в комментарии адм. интерфейса(0 - выводить весь комментарий)',
            'eng' => 'Number of symbols in comment'),
        'access' => 'editable'
    ),
    'comments_guest_name' => array(
        'type' => 'string',
        'defval' => 'Гость',
        'descr' => array(
            'rus' => 'Имя автора по умолчанию (если при комментировании пользователь был не авторизован, то это значение выводится в поле автора)',
            'eng' => 'Default guest name'),
        'access' => 'editable'
    ),
    'comments_capcha' => array(
        'type' => 'checkbox',
        'defval' => '',
        'descr' => array(
            'rus' => 'Включенить капчу для всех комментариев, если пользователь не авторизован',
            'eng' => 'Set capcha for unauthorithed users'),
        'access' => 'editable'
    ),
    'comments_repl_link' => array(
        'type' => 'checkbox',
        'defval' => '',
        'descr' => array(
            'rus' => 'Заменять ссылки на текст в комментариях',
            'eng' => 'To replace references to the text in comments'),
        'access' => 'editable'
    ),
    /*    
    'comments_resrc_max_rows' => array(
        'type' => 'integer',
        'defval' => '10',
        'descr' => array(
            'rus' => 'Количество ресурсов(товаров, статей, новостейй и пр.) на страницу',
            'eng' => 'Quantity of resource on page'),
        'access' => 'editable'
    ), 
    'comments_auth' => array(
        'type' => 'checkbox',
        'defval' => '',
        'descr' => array(
            'rus' => 'Комментируют только авторизованные пользователи',
            'eng' => 'The authorised users make comments only'),
        'access' => 'editable'
    ),
    */
    'comments_date_format' => array(
        'type' => 'select',
        'defval' => array(
            '%d.%m.%Y' => array(
                'rus' => 'дд.мм.гггг',
                'eng' => 'dd.mm.yyyy'),
            '%Y.%m.%d' => array(
                'rus' => 'гггг.мм.дд',
                'eng' => 'yyyy.mm.dd'),
            '%d.%m.%Y %H:%i' => array(
                'rus' => 'дд.мм.гггг чч:мм',
                'eng' => 'dd.mm.yyyy hour:min'),
            '%Y.%m.%d %H:%i' => array(
                'rus' => 'гггг.мм.дд чч:мм',
                'eng' => 'yyyy.mm.dd hour:min'),
        ),
        'descr'	=> array(
            'rus' => 'Формат вывода даты',
            'eng' => 'Date output format'),
        'access'	=> 'editable'
    ),
);


$OPEN_NEW = array (
    'comments_resrc_type' => array(
        COMMENTS_PRODUCT_TYPE => array(
            'name' => 'product',
            'module' => 'catalog',
        ),
        COMMENTS_NEWS_TYPE => array(
            'name' => 'news',
            'module' => 'news',
        ),
        COMMENTS_BLOG_TYPE => array(
            'name' => 'blog',
            'module' => 'blogs',
        ),
        COMMENTS_ARTICLE_TYPE => array(
            'name' => 'article',
            'module' => 'article',
        ),
        COMMENTS_PHOTO_TYPE => array(
            'name' => 'photo',
            'module' => 'gallery',
        )
    ),
    'comments_access' => array(
        0 => array(
            'rus' => 'без комментариев ',
            'eng' => 'without comments'),
        1 => array(
            'rus' => 'комментируют все',
            'eng' => 'comment all',
        ),
        2 => array(
            'rus' => 'комментируют авторизованные пользователи',
            'eng' => 'comment only authorithed users',
        )
    ),
    'comments_resrc_max_rows' => 10,
    'comments_captcha_width' => 110,
    'comments_captcha_height' => 32,
    'comments_captcha_fontsize' => 16,
    'comments_captcha_fontdepth' => 2,
    'comments_captcha_symbols' => "0123456789",
    'comments_captcha_wordlength' => 5,
    'comments_captcha_fonts' => array(
    	RP."inc/captcha/arialbd.ttf",
    	RP."inc/captcha/comicbd.ttf",
    	RP."inc/captcha/courbd.ttf",
    	RP."inc/captcha/timesbd.ttf",
    ),
    'comments_captcha_bgcolor' => array(98, 118, 144),
    'comments_captcha_color' => array(rand(190, 210), rand(200, 220), rand(30, 50)),
    'comments_captcha_color2' => array(rand(150, 170), rand(50, 70), rand(140, 160))
);

/*------------- Ниже следующий массив задаётся из административного раздела модуля -------*/
$NEW = array(
/* ABOCMS:START */
'comments_max_rows' => '10',
'comments_adm_order' => 'crt_date DESC',
'comments_crop_symbols' => '80',
'comments_guest_name' => 'Гость',
'comments_capcha' => 'on',
'comments_repl_link' => 'on',
'comments_date_format' => '%d.%m.%Y %H:%i',
/* ABOCMS:END */
);
?>