<?php
include_once RP.'inc/class.BbCode.php';
class CommentsPrototype extends Module {

	var $main_title;
	var $table_prefix;
	var $addition_to_path;
	var $module_name = 'comments';
	var $default_action = 'addcomment';
	var $admin_default_action = 'allcomments';
	var $tpl_path = 'mod/comments/tpl/';
	var $block_module_actions = array();
	var $block_main_module_actions = array();
	var $is_admin = false;
	var $_msg = array();

	function CommentsPrototype($action = '', $transurl = '', $properties = array(), $prefix = NULL, $rewrite_mod_params = NULL, $adminurl = NULL, $noadmin = false)
	{   global $main, $tpl, $tpl_path, $baseurl, $cache, $lc, $CONFIG, $PAGE, $server, $lang,	$permissions, $request_type, $_RESULT;
	    static $_s_msg = array();

		/* Get $action, $tpl_name, $permissions */
		extract( $this->init(array(
		    'server' => $server, 'lang' => $lang, 'prefix' => $prefix,
		    'action' => $action, 'tpl_name' => $properties['tpl']
		)), EXTR_OVERWRITE);

		$this->block_main_module_actions = array(
		    'addcomment' => $this->_msg['Add_comment']
		);
		
		$this->is_admin = $is_admin = $noadmin ? 0 : preg_match('/admin\.php/', $_SERVER["SCRIPT_NAME"]);
		
		if ('only_create_object' == $action) {
		    return;
		}
		
		if ($this->actionExists($action)) {
		    $this->doAction($action);
		    return;
		}
		
		if (empty($is_admin)) {
//---------------------------------- обработка действий с сайта --------------------------------//
			switch ($action) {
			/**
			 * Добавить комментарий
			 */
			case "addcomment":
				if ($_REQUEST['id'] && $_REQUEST['type'] && $_REQUEST['text']) {
				    $referer = preg_replace("/&?reply=\d{1,9}/", "", $_SERVER['HTTP_REFERER']);
				    if ( ($comm_id = $this->addComment($_REQUEST['id'], $_REQUEST['type'], $_REQUEST['text'], $_REQUEST['reply'])) ) {
				        if ($GLOBALS['JsHttpRequest']) {
                	        $GLOBALS['_RESULT'] = $this->getComment($comm_id);
                	        exit;
                	    }
				        Module::go_back($referer);
				    } else {
				        if ($GLOBALS['JsHttpRequest']) {
                	        $GLOBALS['_RESULT'] = false;
                	        exit;
                	    }
				        $main->include_main_blocks($this->module_name.'_err.html', 'main');
				        $tpl->prepare();
				        $tpl->newBlock('block_err');
				        $tpl->assign('back_link', $referer);
				    }
				}
				if ($GLOBALS['JsHttpRequest']) {
                	$GLOBALS['_RESULT'] = false;
                	exit;
                }				
				break;
			/**
			 * Добавить комментарий
			 */
			case "setcomment":
				$comm = $this->getComment($_REQUEST['id']);
				$referer = preg_replace("/&?edit=\d{1,9}/", "", $_SERVER['HTTP_REFERER']);
				if ($comm && $comm['author_id'] == $_SESSION['siteuser']['id']) {
				    if ( $this->setComment($_REQUEST['id'], $_REQUEST['text']) ) {
				        if ($GLOBALS['JsHttpRequest']) {
                	        $GLOBALS['_RESULT'] = $this->getComment($_REQUEST['id']);
                	        exit;
                	    }
				        Module::go_back($referer);
				    } else {
				        if ($GLOBALS['JsHttpRequest']) {
                	        $GLOBALS['_RESULT'] = false;
                	        exit;
                	    }
				        $main->include_main_blocks($this->module_name.'_err.html', 'main');
				        $tpl->prepare();
				        $tpl->newBlock('block_err');
				        $tpl->assign('back_link', $referer);
				    }
				}
				if ($GLOBALS['JsHttpRequest']) {
                	$GLOBALS['_RESULT'] = false;
                	exit;
                }
				Module::go_back($referer);
				break;
			/**
			 * Удалить комментарий
			 */
			case "delcomment":
			    $res = false;
				if ($_REQUEST['id'] && ($comm = $this->getComment($_REQUEST['id'])) ) {
        	        if ($_SESSION['siteuser']['id'] && $_SESSION['siteuser']['id'] == $comm['author_id']) {
        	           $res = $this->delAllComments($_REQUEST['id']);
        	        }
        	    }
        	    if ($GLOBALS['JsHttpRequest']) {
        	        $GLOBALS['_RESULT'] = $res;
        	        exit;
        	    }
				Module::go_back($referer);
				break;

			/**
			 * Проверить каптчу
			 */
			case "check_captcha":
			case "checkcaptcha":
			    $res = Core::getCaptcha()->isValidCode($_REQUEST['captcha'], array('key' => $this->module_name));
        	    if ($GLOBALS['JsHttpRequest']) {
        	        $GLOBALS['_RESULT'] = $res;
        	    } else if (abo_is_ajax()) {
        	        echo (int)$res;
        	    }
				exit;
// Default...
			default:
				if (is_object($tpl)) $tpl->prepare();
				break;
			}
//------------------------------- конец обработки действий с сайта -----------------------------//
		} else {
//------------------------------ обработка действий из админ части -----------------------------//						
			if (!isset($tpl)) {
			    $main->message_die('Не подключен класс для работы с шаблонами');
			}
			switch ($action) {
		    case 'prp':
		    	if (!$permissions['e']) {
		    	    $main->message_access_denied($this->module_name, $action);
		    	}
				global $request_step;
				$main->include_main_blocks('_properties.html', $this->tpl_path);
				$tpl->prepare();
				$tpl->assign(Array(
					"MSG_Information"	=> $main->_msg["Information"],
					"MSG_Value"			=> $main->_msg["Value"],
					"MSG_Save"			=> $main->_msg["Save"],
					"MSG_Cancel"		=> $main->_msg["Cancel"],
				));
		        if (!$request_step || $request_step == 1) {
					$tpl->assign(array('form_action'	=> $baseurl,
									   'step'			=> 2,
									   'lang'			=> $lang,
									   'name'			=> $this->module_name,
									   'action'			=> 'prp'));
					$prp_html = $main->getModuleProperties($this->module_name);
		            $this->main_title = $this->_msg["Controls"];
				} elseif (2 == $request_step) {
		        	$main->setModuleProperties($this->module_name, $_POST);
					header('Location: '.$baseurl.'&action=prp&step=1');
				}
		    	break;

			case 'block_prp':
				global $request_sub_action, $request_block_id;
		        $arr  = $this->getEditLink($request_sub_action, $request_block_id);
				$cont = 'var container = document.getElementById(\'target_span\');
		    		  	 container.innerHTML	= "'.$this->getPropertyFields($arr).'";
		    		  	 material_id			= "'.$arr['material_id'].'";
		    		  	 material_url			= "'.$arr['material_url'].'";
		    		  	 changeAction();
		    	      	 setURL("property1")';
				header('Content-Length: '.strlen($cont));
		    	echo $cont;
		    	exit;
		    	break;

            case 'properties':
                if (!$permissions['e']) $main->message_access_denied($siteusres->module_name, $action);
                global $module_id, $request_field, $title;

                $main->include_main_blocks('_block_properties.html', 'main');
                $tpl->prepare();

                if ($main->show_actions($request_field, '', $this->block_main_module_actions, $this->block_module_actions)) {
                    $main->show_linked_pages($module_id, $request_field);
                }

                $tpl->assign(array(
                    '_ROOT.title'		=> $title,
                    '_ROOT.username'	=> $_SESSION['session_login'],
                    '_ROOT.password'	=> $_SESSION['session_password'],
                    '_ROOT.name'		=> $this->module_name,
                    '_ROOT.lang'		=> $lang,
                ));
                $this->main_title	= $this->_msg["Block_properties"];
                break;

		    /**
		     *
		     */
			case 'types':
		        if (!$permissions["e"]) {
		            $main->message_access_denied($this->module_name, $action);
		        }
		        
		        global $request_type, $request_start;
		        
				$main->include_main_blocks_2($this->module_name."_".$action.".html", $this->tpl_path);
				$tpl->prepare();
				
				$request_type = $request_type > 0 ? (int) $request_type : 1;
				$request_start = $request_start > 0 ? (int) $request_start : 1;
				
				$tpl->assign(Array(					
					"baseurl" => $baseurl
				));
				$this->showTypes($action, $request_type);
				$filtr = array('start' => $request_start, 'cnt' => $CONFIG['comments_resrc_max_rows']);
				$cnt = $this->getResrcCount($request_type);
				$pages_cnt = ceil($cnt/$filtr['cnt']);
				$list = $this->getResrcList($request_type, $filtr);
				$assign = array(
				    "MSG_Title" => $this->_msg["Title"],
					"MSG_Last_comment_time" => $this->_msg["Last_comment_time"],
					"MSG_Comments_count" => $this->_msg["Comments_count"],
					"MSG_Pages" => $this->_msg["Pages"],
					"MSG_Del" => $this->_msg["Del"],
					"MSG_Delete" => $this->_msg["Delete"],
				    'baseurl' => $baseurl,
				    'action' => 'comments',
				);
				$this->showList('resrc', $list, $assign);
				Main::_show_nav_block($pages_cnt, null, "action=".$action."&type=".$request_type, $request_start);
				
				$this->main_title = $this->_msg["Comments"];
		    	break;

		    /**
		     *
		     */
			case 'comments':
		        if (!$permissions["r"]) {
		            $main->message_access_denied($this->module_name, $action);
		        }
		        
		        global $request_type, $request_item_id, $request_start;
		        
				$main->include_main_blocks_2($this->module_name."_".$action.".html", $this->tpl_path);
				$tpl->prepare();
				
				$request_type = $request_type > 0 ? (int) $request_type : 1;
				$request_item_id = $request_item_id > 0 ? (int) $request_item_id : 1;
				$request_start = $request_start > 0 ? (int) $request_start : 1;
				
				$tpl->assign(Array(
					"MSG_"            => $this->_msg[""],
					"baseurl"  => $baseurl
				));
				
				$this->showTypes('types', $request_type);
				$this->showComments($request_item_id, $request_type, false);
				
				$this->main_title = $this->_msg["Comments"];
		    	break;

		    /**
		     *
		     */
		    case 'newscomments':
		    case 'articlecomments':
		    case 'blogcomments':
		    case 'photocomments':
		    case 'productcomments':        
			case 'allcomments':
		        if (!$permissions["r"]) {
		            $main->message_access_denied($this->module_name, $action);
		        }
		        
		        global $request_start, $request_q;
		        
				$main->include_main_blocks_2($this->module_name."_allcomments.html", $this->tpl_path);
				$tpl->prepare();
				
				$request_start = $request_start > 0 ? (int) $request_start : 1;
				$filter = array();
				if ($request_q) {
				    $filter['q'] = $request_q;
				}
				switch ($action) {
					case 'newscomments':
						$filter['type'] = COMMENTS_NEWS_TYPE;
						$this->main_title = $this->_msg["Newses"];
						break;					
					case 'articlecomments':
						$filter['type'] = COMMENTS_ARTICLE_TYPE;
						$this->main_title = $this->_msg["Articles"];
						break;
					case 'blogcomments':
						$filter['type'] = COMMENTS_BLOG_TYPE;
						$this->main_title = $this->_msg["Blogs"];
						break;
					case 'photocomments':
						$filter['type'] = COMMENTS_PHOTO_TYPE;
						$this->main_title = $this->_msg["Photos"];
						break;
					case 'productcomments':
						$filter['type'] = COMMENTS_PRODUCT_TYPE;
						$this->main_title = $this->_msg["Catalog"];
						break;
					default:
					    $type = false;
					    $this->main_title = $this->_msg["All_comments"];
				}				
				$tpl->assign(Array(
					"MSG_Find" => $this->_msg["Find"],
					"baseurl"  => $baseurl,
					"action" => $action,
					"lang" => $lang,
					"q" => htmlspecialchars($request_q),
				));
				
				$this->showAllComments($request_start, $action, $filter);
								
		    	break;

		    /**
		     *
		     */
			case 'delcomment':
		        if (!$permissions["d"]) {
		            $main->message_access_denied($this->module_name, $action);
		        }
		        $comm = $this->getComment($_REQUEST['id']);
		        if ($comm) {
		            $this->delComment($comm['id']);
		        }
		        Module::go_back();
		        if ($comm) {
		            header("Location: {$baseurl}&action=comments&type={$comm['type']}&item_id={$comm['item_id']}");
		        } else {
		            header("Location: {$baseurl}&action=types");
		        }
		        exit;

		    /**
		     *
		     */
		    case 'delete':
			case 'delallcomment':			    
		        if (!$permissions["d"]) {
		            $main->message_access_denied($this->module_name, $action);
		        }
		        $comm = $this->getComment($_REQUEST['id']);
		        if ($comm) {
		            $this->delAllComments($comm['id']);
		        }
		        Module::go_back();
		        if ($comm) {
		            header("Location: {$baseurl}&action=comments&type={$comm['type']}&item_id={$comm['item_id']}");
		        } else {
		            header("Location: {$baseurl}&action=types");
		        }
		        exit;
		        
		    case 'delete_checked':			    
		        if (!$permissions["d"]) {
		            $main->message_access_denied($this->module_name, $action);
		        }
		        if (isset($_REQUEST['check'])) {
    		        foreach ($_REQUEST['check'] as $id) {
    		        	$comm = $this->getComment($id);
        		        if ($comm) {
        		            $this->delAllComments($comm['id']);
        		        }
    		        }
		        }
		        
		        Module::go_back();
		        header("Location: {$baseurl}&action=allcomments");
		        exit;

		    /**
		     *
		     */
			case 'editcomment':
		        if (!$permissions["e"]) {
		            $main->message_access_denied($this->module_name, $action);
		        }
		        $comm = $this->getComment($_REQUEST['id']);
		        if ($comm) {
		            $this->setComment($comm['id'], $_REQUEST['text']);
		        }
		        Module::go_back($_REQUEST['back'], "#comment-{$comm['id']}");
		        if ($comm) {
		            header("Location: {$baseurl}&action=comments&type={$comm['type']}&item_id={$comm['item_id']}");
		        } else {
		            header("Location: {$baseurl}&action=types");
		        }
		        exit;

		    /**
		     *
		     */
			case 'comment':
		        if (!$permissions["r"]) {
		            $main->message_access_denied($this->module_name, $action);
		        }
		        $comm = $this->getComment($_REQUEST['id']);
		        if ($comm) {
		            $main->include_main_blocks_2($this->module_name."_".$action.".html", $this->tpl_path);
		            $tpl->prepare();
		            $tpl->assign($comm + array(
		                'baseurl' => $baseurl,
		                'back_uri' => $_SERVER['HTTP_REFERER'],
		                'MSG_Save' => $this->_msg['Save'],
		                'MSG_Comment' => $this->_msg['Comment']));
		            $this->main_title = $this->_msg["Edit_comment"];
		            break;
		        }
		        Module::go_back('', "#comment-{$comm['id']}");
		        if ($comm) {
		            header("Location: {$baseurl}&action=comments&type={$comm['type']}&item_id={$comm['item_id']}");
		        } else {
		            header("Location: {$baseurl}&action=types");
		        }
		        exit;

		    /**
		     *
		     */
			case 'delresrc':
		        if (!$permissions["d"]) {
		            $main->message_access_denied($this->module_name, $action);
		        }
		        $res = $this->delResource($_REQUEST['item_id'], $_REQUEST['type']);		        
		        Module::go_back('');
		        header("Location: {$baseurl}&action=types&type={$_REQUEST['type']}&start={$_REQUEST['start']}");
		        exit;

// Default...
			default:
				$main->include_main_blocks();
				$tpl->prepare();
			}
//--------------------------- конец обработки действий из админ части --------------------------//
		}
	}

	function getPropertyFields()
	{   GLOBAL $request_site_target, $request_sub_action;

		return FALSE;
	}

	function getEditLink($sub_action = NULL, $block_id = NULL)
	{   GLOBAL $request_name, $db, $lang, $server;

		return FALSE;
	}

	function initDbTree()
	{   static $_db_obj = false;
		if (!$_db_obj) {
		    include_once(RP."inc/class.NsDbTree.php");
		    $_db_obj = new NsDbTree($this->table_prefix."_comments", 'id');
		}
		return $_db_obj;
	}
	/**
	 * Показать комментарии.
	 * !!! Вызывать до обработки каких-либо блоков и переменных в шаблоне, если $include_tpl = true !!!
	 *
	 * @param int $id id комментируемого ресурса(статьи, новости ...)
	 * @param int $type тип комментируемого ресурса. См. $CONFIG['comments_resrc_type']
	 */
	function showComments($id, $type, $include_tpl = true, $comm_on_page = 0)
	{   global $CONFIG, $tpl, $baseurl;

		$_baseurl = $_SERVER['REQUEST_URI'];
		$_baseurl .= strpos($_baseurl, "?") ? '&' : '?';
		$_baseurl = preg_replace("/&?(reply|edit)=\d{1,9}/", "", $_baseurl);
		$start = $_REQUEST['start'] > 1 ? (int) $_REQUEST['start'] : 1;
	    $ret = false;
	    $id = (int) $id;
	    $type = (int) $type;	    
	    $item = $this->getCommentableItem($id, $type);
	    $comm_cnt = $this->getCommentsCnt($id, $type);
	    $filter = array('start' => $start, 'limit' => $comm_on_page);
	    $comm_list = $this->getComments($id, $type, $filter);
	    if (!empty($comm_list) || $item) {
            if ($include_tpl) {
                $tpl->assignInclude('comments', $CONFIG['tpl_path'].$this->table_prefix."/".$this->module_name.'.html');
                $tpl->prepare();
            }
            $comments_link = Core::formPageLink($CONFIG['comments_page_link'],$CONFIG['comments_page_address'], $lang, 1);
            
            $tpl->newBlock('block_comments');
            $msg_arr = array(
                'baseurl' => $baseurl,
                'requesr_uri' => $_baseurl,
                'comment_uri' => $comments_link,
                'MSG_Delete' => $this->_msg['Delete'],
                'MSG_Edit' => $this->_msg['Edit'],
                'MSG_Delete_all' => $this->_msg['Delete_all'],
                'MSG_Comments' => $this->_msg['Comments'],
                'MSG_Updated' => $this->_msg['Updated'],
                'MSG_Guest' => $CONFIG['comments_guest_name'],
                'resource_type' => $this->_msg[ $CONFIG['comments_resrc_type'][$type]['name'] ],
                'resource_title' => $item['title'],
            );
            $tpl->assign($msg_arr);
            $mod_user = Module::load_mod('siteusers', 'only_create_object');           
            $show_form = true;
            $indents = array();
            $j = 0;
            if (!empty($comm_list)) {                
                $tpl->newBlock('block_comments_list');
                $tpl->assign($msg_arr + array('cnt' => count($comm_list)));
                foreach ($comm_list as $key => $val) {
                	$tpl->newBlock('block_comment');
                	$val['author_link'] = $mod_user->getUserLink($val['author_username']);
                	if (!isset($indents[$val['clevel']])) {
                		for ($i = 1; $i <= 50; $i++) {
	                		$indents[$val['clevel']]["indent_x{$i}"] = ($val['clevel']-1)*$i;
	                	}
                	}
                	$val = array_merge($val, $indents[$val['clevel']], $msg_arr);
                	$val['css_class_odd'] = ++$j % 2 ? 'odd' : '';
                	$val['css_class_even'] = $val['css_class_odd'] ? '' : 'even';
                	$tpl->assign($val);
                	if ($_REQUEST['edit'] && $_REQUEST['edit'] == $val['id']) {
                	    $tpl->newBlock('block_comment_edit');
                	} else {
                	    $tpl->newBlock('block_comment_text');
                	}
                	$tpl->assign($val);
                	if ($val['author_id']) {
                	    $tpl->newBlock('block_comment_author');
                	} else {
                	    $tpl->newBlock('block_comment_no_author');
                	    $tpl->assign($val);
                	    $tpl->newBlock('block_comment_guest_img');
                	}
                	$tpl->assign($val);
                	if ($val['author_img'] && file_exists(RP.$CONFIG['siteusers_img_path'].$val['author_img'])) {
                	    $tpl->newBlock('block_comment_author_img');
                	    $val['path'] = "/".$CONFIG['siteusers_img_path'].$val['author_img'];
                	} else if($val['author_id']) {
                	    $tpl->newBlock('block_comment_author_no_img');
                	}
                	$tpl->assign($val);
                	if (isset($_SESSION['siteuser']['id']) && $_SESSION['siteuser']['id'] == $val['author_id']) {
                	    $tpl->newBlock('block_comment_del_edit');
                	    $tpl->assign(array(
                	       'requesr_uri' => $_baseurl,
                	       'baseurl' => $comments_link,
                	       'id' => $val['id'],
                	    ));
                	}
                	if ($item) {
                	    if (isset($_REQUEST['reply']) && $_REQUEST['reply'] == $val['id']) {
   	                	    $tpl->newBlock('block_comment_reply_form');
   	                	    $tpl->assign(array(
   	                	        'action' => "{$comments_link}&action=addcomment&type={$type}&id={$id}&reply={$val['id']}",
   	                	        'id' => $val['id']
   	                	    ));
   	                	    if (!$_SESSION['siteuser']['id'] && $CONFIG['comments_capcha']) {
   	                	        $tpl->newBlock('block_comment_reply_captcha');
   	                	        $tpl->assign(array(
       	                	        'img_path' => '/'.$CONFIG['captcha_img_path'].'?key='.$this->module_name
       	                	    ));
   	                	    }
   	                	    $show_form = false;
   	                	} else {
   	                	    $tpl->newBlock('block_reply_link');
   	                	    $tpl->assign(array(
   	                	    	'reply_link' => "{$_baseurl}reply={$val['id']}",
   	                	    	'id' => $val['id']
   	                	    ));
   	                	}
                	}
                	if ($val['upd_date']) {
                	    $tpl->newBlock('block_comment_update');
                	    $tpl->assign($val);
                	}
                }
                if ($comm_on_page && $comm_cnt > $comm_on_page) {
                    Pager::Build($comm_cnt, $comm_on_page, $start, $_baseurl);
                }
            }
            if ($item && $show_form) {
                $tpl->newBlock('block_reply_form');
                $tpl->assign(array(
                    'action' => "{$comments_link}&action=addcomment&type={$type}&id={$id}",
                ));
                if (!$_SESSION['siteuser']['id'] && $CONFIG['comments_capcha']) {
   	                $tpl->newBlock('block_reply_captcha');
   	                $tpl->assign(array(
       	                'img_path' => '/'.$CONFIG['captcha_img_path'].'?key='.$this->module_name//$comments_link."action=captcha#".rand(1111, 111111111)
       	            ));
   	            }
	        }
	    }
	}
	
	function showAllComments($start, $action, $filter)
	{   global $CONFIG, $tpl, $baseurl, $main;

		$_baseurl = $_SERVER['REQUEST_URI'];
		$_baseurl .= strpos($_baseurl, "?") ? '&' : '?';
		
	    $ret = false;
	    $comm_list = $this->getAllComments($start, $CONFIG['comments_max_rows'], $filter);
	    $comm_cnt = $this->getAllCommentsCnt($filter);
	    if (!empty($comm_list)) {
            $user_baseurl = str_replace('name=comments', 'name=siteusers', $baseurl);
            $tpl->newBlock('block_comments');
            $msg_arr = array(
                'baseurl' => $baseurl,
                'requesr_uri' => $_baseurl,
                'user_baseurl' => $user_baseurl,
                'MSG_Guest' => $CONFIG['comments_guest_name'],
                'MSG_Delete' => $this->_msg['Delete'],
                'MSG_Edit' => $this->_msg['Edit'],
                'MSG_Ed' => $this->_msg['Ed'],
                'MSG_Del' => $this->_msg['Del'],
                'MSG_Comment' => $this->_msg['Comment'],
                'MSG_Module' => $this->_msg['Module'],
                'MSG_Title' => $this->_msg['Title'],
                'MSG_Author' => $this->_msg['Author'],
                'MSG_Date' => $this->_msg['Date'],
                'MSG_Delete_all' => $this->_msg['Delete_all'],
                'MSG_Comments' => $this->_msg['Comments'],
                'MSG_Updated' => $this->_msg['Updated'],
                'MSG_Select_action' => $this->_msg['Select_action'],
                'MSG_Execute' => $this->_msg['Execute'],
                'MSG_Post' => $this->_msg['Post'],
                'css_class_hide' => 'allcomments' == $action ? '' : 'hide'
            );
            $tpl->assign($msg_arr);
            if (!empty($comm_list)) {                
                $tpl->newBlock('block_comments_list');
                $tpl->assign($msg_arr + array('cnt' => $comm_cnt));
                $j = 0;
                foreach ($comm_list as $key => $val) {
                	$tpl->newBlock('block_comment');
                	$val['author_link'] = $user_baseurl."&action=editsiteuser&id=".$val['author_id'];
                	$val['resource_type_title'] = $this->_msg[ $CONFIG['comments_resrc_type'][$val['resource_type']]['name'] ];
                	$val = array_merge($val, $msg_arr);
                	$val['css_class_odd'] = ++$j % 2 ? 'odd' : '';                	
                	$val['css_class_even'] = $val['css_class_odd'] ? '' : 'even';
                	$val['MSG_Go'] = $this->_msg['Go'];
                	$tpl->assign($val);
                	if ($val['author_id']) {
                	    $tpl->newBlock('block_author');
                	} else {
                	    $tpl->newBlock('block_no_author');
                	}
                	$tpl->assign($val);
                	if ($val['upd_date']) {
                	    $tpl->newBlock('block_comment_update');
                	    $tpl->assign($val);
                	}
                	if ($val['url']) {
                	    $tpl->newBlock('block_comment_referer');
                	    $tpl->assign($val);
                	} else {
                	    $tpl->newBlock('block_comment_no_referer');
                	}
                }
                $link = "action=".$action.($filter['q'] ? "&q=".htmlspecialchars($filter['q']) : "");
                Main::_show_nav_block(ceil($comm_cnt/$CONFIG['comments_max_rows']), null, $link, $start);
            }
	    } else {
	        $tpl->newBlock('block_no_comments');
            $tpl->assign("MSG_Not_found", $this->_msg['Not_found']);
	    }
	}

	function getCommentableItem($id, $type)
	{   global $CONFIG;

	    $ret = false;
		$resrc_mod = Module::load_mod($CONFIG['comments_resrc_type'][$type]['module'], 'only_create_object');
	    if ( $resrc_mod && method_exists($resrc_mod, 'getCommentableItem')) {
	        $ret = $resrc_mod->getCommentableItem($id);
	    }

	    return $ret;
	}

	function showProductComments($id, $comm_on_page = 0)
	{
		$this->showComments($id, COMMENTS_PRODUCT_TYPE, true, $comm_on_page);
	}

	function showNewsComments($id, $comm_on_page = 0)
	{
		$this->showComments($id, COMMENTS_NEWS_TYPE, true, $comm_on_page);
	}

	function showBlogComments($id, $comm_on_page = 0)
	{
		$this->showComments($id, COMMENTS_BLOG_TYPE, true, $comm_on_page);
	}

	function showArticleComments($id, $comm_on_page = 0)
	{
		$this->showComments($id, COMMENTS_ARTICLE_TYPE, true, $comm_on_page);
	}

	function showPhotoComments($id, $comm_on_page = 0)
	{
		$this->showComments($id, COMMENTS_PHOTO_TYPE,true,  $comm_on_page);
	}

	function getComments($item_id, $type, $filter)
	{   global $db, $CONFIG;

		$ret = false;
		$resrc = $this->getResource($item_id, $type);
		if ($resrc) {
		    $limit = '';
		    if (isset($filter['limit']) && $filter['limit'] > 0) {
		        $filter['start'] = isset($filter['start']) && $filter['start'] > 1 ? (int)$filter['start'] : 1;
		        $filter['limit'] = (int) $filter['limit'];		        
		        $limit = " LIMIT ".($filter['start'] - 1)*$filter['limit'].",{$filter['limit']}";
		    }
		    $db->query("SELECT C.*, DATE_FORMAT(crt_date, '{$CONFIG['comments_date_format']}') AS crt_date, "
    		    ."DATE_FORMAT(upd_date, '{$CONFIG['comments_date_format']}') AS upd_date, "
    		    ." U.username AS author_username, U.img AS author_img"
    		    ." FROM {$this->table_prefix}_comments AS C LEFT JOIN core_users AS U ON author_id=U.id "
    		    ."WHERE resrc_id={$resrc['id']} ORDER BY cleft{$limit}");
		    while ($db->next_record()) {
		    	$ret[$db->Record['id']] = array(
		    	    'id' => $db->Record['id'],
		    	    'clevel' => $db->Record['clevel'],
		    	    'crt_date' => $db->Record['crt_date'],
		    	    'upd_date' => $db->Record['upd_date'],
		    	    'author_id' => $db->Record['author_id'],
		    	    'author_username' => $db->Record['author_username'],
		    	    'author_img' => $db->Record['author_img'],
		    	    'author_firstname' => $db->Record['author_firstname'],
		    	    'author_surname' => $db->Record['author_surname'],
		    	    'text' => $db->Record['text'],
		    		'text_parse' => BbCode::parse($db->Record['text']),
		    	);
		    }
		}

		return $ret;
	}
	
	function getCommentsCnt($item_id, $type)
	{   global $db;

	    $ret = false;
		$resrc = $this->getResource($item_id, $type);
		if ($resrc) {
		    $db->query("SELECT COUNT(*) FROM {$this->table_prefix}_comments WHERE resrc_id={$resrc['id']}");
		    $ret = $db->next_record()? $db->Record[0] : 0;
		}

		return $ret;
	}

	function getAllComments($start, $limit, $filter)
	{   global $db, $CONFIG;

		$ret = false;
		$start = $start > 1 ? (int) $start : 1;
		$limit = (int) $limit;
		$clause = $this->getAllCommentsClause($filter);
		$db->query("SELECT C.*, DATE_FORMAT(crt_date, '{$CONFIG['comments_date_format']}') AS crt_date, "
    		."DATE_FORMAT(upd_date, '{$CONFIG['comments_date_format']}') AS upd_date, "
    		."U.username AS author_username, R.title AS resource_title, R.type AS resource_type,"
    		." R.item_id AS resource_item_id  FROM {$this->table_prefix}_comments AS C INNER JOIN "
    		."{$this->table_prefix}_comments_resource R ON R.id=C.resrc_id LEFT JOIN core_users AS U ON C.author_id=U.id "
    		.($clause ? " WHERE {$clause} " : "")
    		."ORDER BY C.{$CONFIG['comments_adm_order']}"
    		.($limit > 0 ? " LIMIT ".($start-1)*$limit.",{$limit}" : ""));
		while ($db->next_record()) {
		    $cut_text = $CONFIG['comments_crop_symbols'] > 0
		        ? abo_substr($db->Record['text'], 0, $CONFIG['comments_crop_symbols']) 
		        : $db->Record['text'];
		    if ($cut_text != $db->Record['text']) {
		        $cut_text .= "...";
		    }
		   $ret[$db->Record['id']] = array(
		    	'id' => $db->Record['id'],
		    	'clevel' => $db->Record['clevel'],
		    	'crt_date' => $db->Record['crt_date'],
		    	'upd_date' => $db->Record['upd_date'],
		    	'author_id' => $db->Record['author_id'],
		    	'author_username' => $db->Record['author_username'],
		    	'resource_title' => $db->Record['resource_title'],
		    	'resource_type' => $db->Record['resource_type'],
		    	'resource_item_id' => $db->Record['resource_item_id'],
		    	'text' => $db->Record['text'],
		    	'cut_text' => $cut_text,
		    	'url' => $db->Record['url']
		   );
		}

		return $ret;
	}
	
	function getAllCommentsCnt($filter)
	{   global $db;

	    $clause = $this->getAllCommentsClause($filter);
		$db->query("SELECT COUNT(C.id) FROM {$this->table_prefix}_comments AS C INNER JOIN "
    		."{$this->table_prefix}_comments_resource R ON R.id=C.resrc_id"
		    .($clause ? " WHERE {$clause}" : ""));

		return $db->next_record()? $db->Record[0] : 0;
	}
	
	function getAllCommentsClause($filter)
	{   global $CONFIG;
	
		$ret = false;
		if (is_array($filter)) {
		    if (isset($filter['type']) && array_key_exists($filter['type'], $CONFIG['comments_resrc_type'])) {
		        $ret[] = 'R.type='.$filter['type'];
		    }
		    if (isset($filter['q'])) {
		        $ret[] = "C.text LIKE '%".addcslashes(My_Sql::escape($filter['q']), "%_")."%'";
		    }
		}
		
		return empty($ret) ? false : implode(" AND ", $ret);
	}

	function getResource($item_id, $type)
	{   global $db;
        
        $ret = false;
    	$db->query("SELECT * FROM {$this->table_prefix}_comments_resource WHERE type="
    		.intval($type)." AND item_id=".intval($item_id));
    	if ($db->nf() && $db->next_record()) {
    		$ret = array(
    		    'id' => $db->Record['id'],
    		    'type' => $db->Record['type'],
    		    'item_id' => $db->Record['item_id'],
    		    'title' => $db->Record['title'],
    		);
        }		

		return $ret;
	}

	function addResource($id, $type, $title)
	{   global $db, $CONFIG;

		$id = (int) $id;
		$type = (int) $type;
		$title = $db->escape($title);
		$db->query("INSERT INTO {$this->table_prefix}_comments_resource (type, item_id, title) VALUES ({$type}, {$id}, '{$title}')");

		return $db->lid();
	}
	
	function delResource($item_id, $type)
	{   global $db;

		$ret = false;
		$id = (int) $id;
		$type = (int) $type;
		$db_tree = $this->initDbTree();
		$db->query("SELECT C.id FROM {$this->table_prefix}_comments C INNER JOIN "
		    .$this->table_prefix."_comments_resource R ON R.id=C.resrc_id WHERE R.type={$type} AND R.item_id={$item_id}"
		    ." ORDER BY cleft LIMIT 1");
		if ($db->next_record()) {
		    $this->delAllComments($db->Record['id']);
		}
		$db->query("DELETE FROM {$this->table_prefix}_comments_resource WHERE type={$type} AND item_id={$item_id}");
		
		return $db->affected_rows();
	}

	function addComment($id, $type, $text, $reply = 0)
	{   global $db, $CONFIG, $PAGE;

		$ret = false;
		$item = $this->getCommentableItem($id, $type);
	    if ($item && 0 == $PAGE['field']) {
    		$resrc = $this->getResource($id, $type);
    		/* Если ещё не создан ресурс для комментирования, создаем его */
    		if (!$resrc) {
    		    $this->addResource($id, $type, $item['title']);
    		    $resrc = $this->getResource($id, $type);
    		}
    		if ($resrc && $text && ( $_SESSION['siteuser']['id']  
    		    || (!$_SESSION['siteuser']['id'] && $CONFIG['comments_capcha'] && Core::getCaptcha()->isValidCode($_REQUEST['captcha'], array('key' => $this->module_name)))
    		    || (!$_SESSION['siteuser']['id'] && !$CONFIG['comments_capcha'])
    		) ) {
    		    Core::getCaptcha()->clean(array('key' => $this->module_name));
    		    $text = $this->cutTags($text);
    		    $reply = $this->commentExists($reply) ? (int) $reply : 1;
    		    $db_tree = $this->initDbTree();
    		    $d = date("Y-m-d H:i:s");
    		    $ret = $db_tree->insert($reply, array(
    		        'resrc_id' => $resrc['id'],
    		        'crt_date' => $d,
    		        'author_id' => $_SESSION['siteuser']['id'],
    		        'text' => $text
    		    ));
    		    if ($ret) {
    		        $url = preg_replace("/\#comment-\d+/", '', $_SERVER['HTTP_REFERER']).'#comment-'.$ret;
    		        $db->query("UPDATE {$this->table_prefix}_comments SET url='".
    		            preg_replace("/\#comment-\d+/", '', $_SERVER['HTTP_REFERER']).'#comment-'.$ret
    		            ."' WHERE id={$ret}");
    		    }
    		}
	    }

		return $ret;
	}
	
	function cutTags($text)
	{   global $CONFIG;

		/*
	    $text = preg_replace ("/<\s*br[^>]*>\r?\n/i", "\n", $text );
		$text = repl_entities(nl2br($text));
		$allowed = "br|b|i|u|code|strong|em|p";
		$text = preg_replace ( "/(<\s*(?!(\/|{$allowed}|a)\b)[^>]*>)/i", "", $text );
		$text = preg_replace ( "/(<\/\s*(?!({$allowed}|a)\b)[^>]*>)/i", "", $text );
		$text = preg_replace ( "/<(\/?\s*({$allowed})\b)[^>]*>/i", "<\\1>", $text );
		$text = preg_replace ( "/<\/[^>]*a[^>]*>/i", "</a>", $text );
		$text = preg_replace ( "/<a[^>]*(href\s*=s*(\"|')(.*?)\2)[^>]*>/i", "<a href=\"\\3\">", $text );
		$text = preg_replace ( "/<a (href=\"\s*javascript:.*?\")>/i", "<a>", $text );		
		if ($CONFIG['comments_repl_link']) {
		    if (preg_match_all("/<a href=\"(.*)\">(.*)<\/a>/i", $text, $match)) {
		        foreach ($match[1] as $key => $val) {
		            $url = parse_url($val);
		            if ($url['host']) {
		            	$url['host'] = preg_replace("/^www\./", '', strtolower($url['host']));
		            	if ($url['host'] != $CONFIG['domen']) {
    		                $text = str_replace($match[0][$key], "{$match[2][$key]} ({$val})", $text);
    		            }
		            }		            
		        }
		    }
		}
		*/
		return My_Sql::escape(htmlspecialchars(strip_tags($text)));
	}
	
	function showTypes($action, $type = 0)
	{   global $CONFIG, $baseurl, $tpl;
	
		foreach ($CONFIG['comments_resrc_type'] as $key => $val) {
			$tpl->newBlock('block_type_list');
			$tpl->assign(array(
			    'id' => $key,
			    'title' => $this->_msg[$val['name']],
			    'name' => $val['name'],
			    'baseurl' => $baseurl,
			    'action' => $action,
			    'css_class_curr' => $type == $key ? 'curr' : ''
			));
		}
	}

	function getResrcList($type, $filter = false)
	{   global $db, $CONFIG;

		$ret = false;
		$filt = $this->getResrcListFilter($filter);
		$db->query("SELECT R.*, COUNT(C.id) AS comments_count, DATE_FORMAT(MAX(C.crt_date), '{$CONFIG['comments_date_format']}') AS last_comment_time"
		    ." FROM {$this->table_prefix}_comments_resource R LEFT JOIN {$this->table_prefix}_comments C ON R.id=C.resrc_id WHERE type="
		    .intval($type).($filt['where'] ? " AND {$filt['where']}" : '')." GROUP BY R.id"
		    .($filt['order'] ? " ORDER BY {$filt['order']}" : '')
		    .($filt['limit'] ? " LIMIT {$filt['limit']}" : ''));
		while ($db->next_record()) {
		    $ret[] = array(
		        'id' => $db->Record['id'],
		        'type' => $db->Record['type'],
		        'item_id' => $db->Record['item_id'],
		        'title' => $db->Record['title'],
		        'comments_count' => $db->Record['comments_count'],
		        'last_comment_time' => $db->Record['last_comment_time'],
		    );
		}

		return $ret;
	}

	function getResrcCount($type, $filter = false)
	{   global $db;

		$ret = false;
		$filt = $this->getResrcListFilter($filter);
		$db->query("SELECT COUNT(*) FROM {$this->table_prefix}_comments_resource WHERE type="
		    .intval($type).($filt['where'] ? " AND {$filt['where']}" : ''));
		if ($db->next_record()) {
		    $ret = $db->Record[0];
		}

		return $ret;
	}

	function getResrcListFilter($filter)
	{   global $CONFIG;

		$ret = array('limit' => false, 'order' => 'last_comment_time DESC', 'where' => false);
		if (isset($filter['cnt']) && 0 != $filter['cnt']) {
		    $c = $filter['cnt'] >= 1 ? (int) $filter['cnt'] : $CONFIG['comments_resrc_max_rows'];
		    $ret['limit'] = ($filter['start'] >= 1 ? intval($filter['start'])-1 : 1) * $c.", ".$c;
		}		
		return $ret;
	}
	
	function showList($block_name, $list, $assign = flase)
	{   global $tpl;
	
		$ret = false;
		if (is_array($list) && !empty($list)) {
		    $tpl->newBlock("block_{$block_name}_list");
		    if (is_array($assign)) {
		        $tpl->assign($assign);
		    }
		    foreach ($list as $val) {
		    	if (is_array($assign)) {
		    	    $val = array_merge($val, $assign);
		    	}
		    	$tpl->newBlock("block_{$block_name}_item");
		    	$tpl->assign($val);
		    }
		}
	}
	
	function commentExists($id)
	{   global $db;

		$db->query("SELECT id FROM {$this->table_prefix}_comments WHERE id=".intval($id));
		
		return $db->nf() ? true : false;
	}
	
	function getComment($id)
	{   global $db;

		$ret = false;
		if ($id) {
		    $db->query("SELECT C.*, DATE_FORMAT(crt_date, '{$CONFIG['comments_date_format']}') AS crt_date, "
    		    ."DATE_FORMAT(upd_date, '{$CONFIG['comments_date_format']}') AS upd_date, "
    		    ."U.username AS author_username, U.img AS author_img, R.type, R.item_id FROM "
    		    ."{$this->table_prefix}_comments AS C INNER JOIN "
    		    ."{$this->table_prefix}_comments_resource AS R ON resrc_id=R.id LEFT JOIN "
    		    ."core_users AS U ON author_id=U.id "
    		    ."WHERE C.id=".intval($id));
		    while ($db->next_record()) {
		    	$ret = array(
		    	    'id' => $db->Record['id'],
		    	    'clevel' => $db->Record['clevel'],
		    	    'crt_date' => $db->Record['crt_date'],
		    	    'upd_date' => $db->Record['upd_date'],
		    	    'author_id' => $db->Record['author_id'],
		    	    'author_username' => $db->Record['author_username'],
		    	    'author_img' => $db->Record['author_img'],
		    	    'text' => $db->Record['text'],
		    	    'resrc_id' => $db->Record['resrc_id'],
		    	    'type' => $db->Record['type'],
		    	    'item_id' => $db->Record['item_id'],
		    	);
		    }
		}

		return $ret;
	}
	
	function delComment($id)
	{   global $db;

		$ret = false;
		$db_tree = $this->initDbTree();
		if ($this->commentExists($id)) {
		    $ret = $db_tree->delete($id);
		}

		return $ret;
	}
	
	function delAllComments($id)
	{   global $db;

		$ret = false;
		$db_tree = $this->initDbTree();
		if ($this->commentExists($id)) {
		    $ret = $db_tree->deleteAll($id);
		}

		return $ret;
	}
	
	function setComment($id, $text)
	{   global $db;
	
		$ret = false;
		if ($this->commentExists($id) && $text) {
		    $db->query("UPDATE {$this->table_prefix}_comments SET text='".$this->cutTags($text)."', upd_date='".date("Y-m-d H:i:s")."' WHERE id=".intval($id));
		    $ret = true;
		}

		return $ret;
	}
	
	function showCommentableForm($curr_access_type = 0)
	{   global $CONFIG, $tpl;

		$tpl->newBlock('block_commentable');
		$tpl->assign(array(
		    'MSG_Comments' => $this->_msg['Comments']));
		foreach ($CONFIG['comments_access'] as $key => $val) {
			$tpl->newBlock('block_comment_access');
			$tpl->assign(array(
			    'id' => $key,
			    'title' => $val[$CONFIG['admin_lang']],
			    'checked' => $curr_access_type == $key ? 'checked' : '',
			    'selected' => $curr_access_type == $key ? 'selected' : ''
			));
		}
		
	}
}
?>