<?php // Vers 5.9.3 16.05.2016
/**
* индекс type задёт тип значения, возможные значения:
*	integer  - целое число
*	double   - вещественное число
*	string   - строка
*	checkbox - элемент допускающий установку/снятие галочки (тег <input type="checkbox">)
*	select   - выпадающий список
* индекс defval задаёт значение по умоляанию,
* индекс descr задаёт текстовое описание данного элемента, для вывода в качестве справки
* индекс access устанавливает уровень доступа, возможные значения
* 	public	- элемент доступен для чтения/изменения
*	final	- элемент доступен только для чтения
*	private - элемент не доступен
*/
$TYPES_NEW = array(
			   'documents_max_rows'		=> array('type'		=> 'integer',
			   									 'defval'	=> '10',
			   									 'descr'	=> array(	'rus' => 'Максимальное количество записей на страницу',
												 						'eng' => 'Maximum quantity of records on page'),
			   									 'access'	=> 'editable'
			   									 ),

			   'documents_dll_order_by' => array('type'		=> 'select',
			   									 'defval'	=> array('rank'			=> array(	'rus' => 'В порядке заданном пользователем',
																		 						'eng' => 'In order of a user-defined'),
			   									 					 'name DESC'	=> array(	'rus' => 'По названию Я-А',
													 											'eng' => 'By name Z-A'),
			   									 					 'name'		=> array(	'rus' => 'По названию А-Я',
													 											'eng' => 'By name A-Z'),
			   									 					 ),
			   									 'descr'	=> array(	'rus' => 'Порядок вывода категорий',
																		'eng' => 'Order of categories displaying'),
			   									 'access'	=> 'editable',
			   									 ),

			   'documents_prod_order_by' => array('type'	=> 'select',
			   									 'defval'	=> array('added DESC'	=> array(	'rus' => 'В порядке обратном дате доумента',
													 											'eng' => 'In order to reverse the date doumenta'),
			   									 					 'added'		=> array(	'rus' => 'По дате доумента',
													 											'eng' => 'By date doumenta'),
			   									 					 'rank'	=> array(	'rus' => 'В порядке заданном пользователем',
													 											'eng' => 'In order of a user-defined'),
			   									 					 'name DESC'	=> array(	'rus' => 'По названию Я-А',
													 											'eng' => 'By name Z-A'),
			   									 					 'name'		=> array(	'rus' => 'По названию А-Я',
													 											'eng' => 'By name A-Z'),
			   									 					 ),
			   									 'descr'	=> array(	'rus' => 'Порядок вывода документов',
							 											'eng' => 'Order of document displaying'),
			   									 'access'	=> 'editable',
			   									 ),

			  'documents_date_format'	=> array('type'		=> 'select',
			   									 'defval'	=> array('%d.%m.%Y %H:%i'	=> array(	'rus' => 'День.Месяц.Год Часы:Минуты',
												 										  			'eng' => 'Day.Month.Year Hours:Minutes'),
			   									 					 '%d.%m.%Y'			=> array(	'rus' => 'День.Месяц.Год',
												 													'eng' => 'Day.Month.Year'),
			   									 					 '%Y.%m.%d'			=> array(	'rus' => 'Год.Месяц.День',
												 													'eng' => 'Year.Month.Day'),
			   									 					 '%Y.%m.%d %H:%i'	=> array(	'rus' => 'Год.Месяц.День Часы:Минуты',
												 													'eng' => 'Year.Month.Day Hours:Minutes'),
			   									 					 ),
												 'descr'	=> array(	'rus' => 'Формат выводимой даты',
												 						'eng' => 'Format of deduced date'),
												 'access'	=> 'editable',
												 ),

			   'documents_default_rights'	=> array('type'		=> 'string',
			   									 'defval'	=> '111111110001',
			   									 'descr'	=> array(	'rus' => 'Права для документа по-умолчанию (формат <img src="/i/admin/rights_format.gif" width=72 height=18 alt="формат прав">, где x - 0 или 1, каждая группа представляет набор прав: удаление, публикация, редактирование, чтение)',
 												 						'eng' => 'Document default rights (format <img src="/i/admin/rights_format.gif" width=72 height=18 alt="rights format">, where x - 0 or 1, every group is rights set: delete, publication, edit, read)'),
			   									 'access'	=> 'editable'
			   									 ),
			   );

$OPEN_NEW = array (
	"documents_img_path" 		=> "files/documents/{SITE_PREFIX}/images/", 			// куда ложить закачанные на сервер картинки для документа
	"documents_file_path" 		=> "files/documents/{SITE_PREFIX}/files/",			// куда ложить закачанные на сервер файлы для документа
	"documents_dll_img_path" 	=> "files/documents/{SITE_PREFIX}/categories/",	 	// куда ложить закачанные на сервер картинки для категорий
	"documents_ico_path"    	=> "files/documents/{SITE_PREFIX}/ico/",    	 	// директория с иконками для файлов
   	"documents_max_level" 		=> 10, 												// максимальная допустимая вложенность в каталоге (начиная с нуля): на первый уровень нельзя добавлять документы, на последний - подкатегории
   	"document_file_formats" => array(
		"application/octet-stream"			=> "cdp",
		"application/msword"				=> "doc",
		"application/vnd.openxmlformats-officedocument.wordprocessingml.document" => "docx",
		"application/x-unknown" => "docx",
		"application/pdf"					=> "pdf",
		"application/x-pdf"					=> "pdf",
		"application/vnd.pdf"				=> "pdf",
		"text/pdf"        					=> "pdf",
		'application/x-download'			=> "pdf",
		'application/force-download'		=> "pdf",
		"application/vnd.ms-powerpoint"		=> "ppt",
		"application/octet-stream"			=> "rar",
		"text/plain"						=> "txt",
		"application/vnd.ms-excel"			=> "xls",
		"application/vnd.openxmlformats-officedocument.spreadsheetml.sheet"			=> "xlsx",
		"application/x-zip-compressed"		=> "zip",
		"application/gzip"		=> "gzip",
		"application/x-rar-compressed"		=> "rar",
		"application/xml" => "xml",
		"image/gif" => "gif",
		"image/jpeg" => "jpeg",
		"image/pjpeg" => "jpeg",
		"image/png" => "png",
		"image/bmp" => "bmp",
		"image/svg+xml" => "svg",
		"image/tiff" => "tiff",
		"text/csv" => "csv",
	)
);

/*------------- Ниже следующий массив задаётся из административного раздела модуля -------*/
$NEW = array(
/* ABOCMS:START */
'documents_max_rows' => '5',
'documents_dll_order_by' => 'rank',
'documents_prod_order_by' => 'rank',
'documents_date_format' => '%d.%m.%Y',
'documents_default_rights' => '111111110001',
/* ABOCMS:END */
);
?>