<?php

require_once (RP.'mod/documents/lib/class.documentsDB.php');

class DocumentsPrototype extends Module {

	var $main_title; 						// переопределяет title страницы, если модуль главный
	var $table_prefix;
	var $module_name 		= 'documents';
	var $_msg				= array();
	var $addition_to_path 	= array(); 		// добавляет к пути страницы строку, если модуль главный
	// действия, которые пользователь имеет возможность задать для блока с данным модулем
	// если поле блока НЕ ЯВЛЯЕТСЯ полем главного модуля:
	var $block_module_actions = array();
	// если поле блока ЯВЛЯЕТСЯ полем главного модуля:
	var $block_main_module_actions	= array();
	var $default_action 			= 'assortment';
	var $admin_default_action		= 'assortment';
	var $tpl_path					= 'mod/documents/tpl/';
	var $product_images 	= array(array('title' 		=> 'Image',
										  'field_name'	=> 'image',
										  'resize'		=> 150,
									));

	var $category_images	= array(array(	'title'			=> 'Logo',
											'field_name'	=> 'image',
											'resize'		=> 150,
										));

	var $document_image_formats = array('image/jpeg' => 'jpg',
										'image/jpg' => 'jpg',
										'image/pjpeg' => 'jpg',
										'image/gif' => 'gif',
										'image/x-png' => 'png',
										'image/png' => 'png'
										);

	var $product_files		= array(array(
		"title"				=> 'File',
		"field_name"	=> "file_name",
		"field_path"	=> "file_path",
	));
	var $cache = array();
	
	var $action_tpl = array(
	   'searchform' => 'documents_searchform.html',
	   'tree' => 'documents_tree.html',
	   'notfound' => 'documents_notfound.html',
	   'assortment' => 'documents_assortment.html',
	   'accessdeny' => 'documents_accessdeny.html'
	);
	
	function DocumentsPrototype($action = '', $transurl = '?', $properties = array(), $prefix = NULL, $rewrite_mod_params = NULL, $adminurl = NULL, $noadmin = false)
	{   global $main, $tpl, $tpl_path, $baseurl, $cache, $lc, $CONFIG, $PAGE,
	    $core, $server, $lang, $permissions, $request_type, $_RESULT;
		
		/* Get $action, $tpl_name, $permissions */
		extract( $this->init(array(
		    'server' => $server, 'lang' => $lang, 'prefix' => $prefix,
		    'action' => $action, 'tpl_name' => $properties['tpl']
		)), EXTR_OVERWRITE);

		$this->block_module_actions = array(
		        'stats_last'		=> $this->_msg["Show_last_added_files"],
		        'stats_documents'	=> $this->_msg["Show_popular_files"],
		        'assortment'		=> $this->_msg["Show_documents_library"],
		        'searchform'		=> $this->_msg["Search_form"],
		        'tree'              => $this->_msg['Show_doc_tree'],
		);
		// если поле блока ЯВЛЯЕТСЯ полем главного модуля:
		$this->block_main_module_actions = array(
		        'stats_last'		=> $this->_msg["Show_last_added_files"],
		        'stats_documents'	=> $this->_msg["Show_popular_files"],
		        'assortment'		=> $this->_msg["Show_documents_library"],
		        'searchform'		=> $this->_msg["Search_form"],
		        'tree'              => $this->_msg['Show_doc_tree'],
		);
		
		// выставим свойства, которые пользователь имеет возможность задать для блока с данным модулем
		// индекс свойства в массиве $properties соответствует номеру поля в БД
		// например, первый элемент соотв. полю property1 в БД
		$max_rows = intval($properties[1]); // показывать документов на странице

		$CONFIG["documents_img_path"] = str_replace("{SITE_PREFIX}", $this->table_prefix, $CONFIG['documents_img_path']);
		$CONFIG["documents_file_path"] = str_replace("{SITE_PREFIX}", $this->table_prefix, $CONFIG['documents_file_path']);
		$CONFIG["documents_dll_img_path"] = str_replace("{SITE_PREFIX}", $this->table_prefix, $CONFIG['documents_dll_img_path']);
		$CONFIG["documents_ico_path"] = str_replace("{SITE_PREFIX}", $this->table_prefix, $CONFIG['documents_ico_path']);

		if ('only_create_object' == $action) {
		    return;
		}	
		
		if (! self::is_admin()) {
		    
		    $actions = array('assortment', 'showatree', 'showcategories', 'showselectmenu',
		        'showproduct', 'stats_last', 'stats_documents', 'count_file', 'download');
//---------------------------------- обработка действий с сайта --------------------------------//        
            if($PAGE['dop_params'] && $PAGE['field']==0) {
                $PAGE['process_params'] = true;
                $raw = explode('/',str_replace(strtok($baseurl, '?'), '', $_SERVER['REQUEST_URI']));
                $action = $raw[0];
                $GLOBALS['request_parent'] = $raw[1];
                $GLOBALS['request_id'] = $raw[2];
                if (!in_array($action, $actions)) {
                    $PAGE['process_params'] = false;
                }
                if ($GLOBALS['request_parent']) {
                    $v = $this->test_ctgr($GLOBALS['request_parent']);
                    if (-1 == $v) {
                        $action = 'accessdeny';
                    } else if (!$v || 0 == $v['active']) {
                        $PAGE['process_params'] = false;
                    }
                }
                if ($GLOBALS['request_id']) {
                    $v = $this->get_prod($GLOBALS['request_id']);
                    if (-1 == $v) {
                        $action = 'accessdeny';
                    } else if (!$v || 0 == $v['active']) {
                        $PAGE['process_params'] = false;
                    }
                }
            }
            
            if ($this->actionExists($action)) {
                $this->doAction($action);
                return;
            }
            
			switch ($action) {
			// Форма поиска 
			case "accessdeny":
			    global $request_parent;
				$tpl_name = $tpl_name ? $tpl_name : $this->action_tpl[$action];
                $main->include_main_blocks($tpl_name, 'main', $adm_tpl);
				$tpl->prepare();
				$tpl->assign(array(
				    'baseurl' => $baseurl
				));
				break;
				
			// Форма поиска 
			case "searchform":
			    global $request_parent;
				$tpl_name = $tpl_name ? $tpl_name : $this->action_tpl[$action];
                $main->include_main_blocks($tpl_name, 'main', $adm_tpl);
				$tpl->prepare();
				$tpl->assign(array(
				    'transurl' => $transurl,
				    'parent' => $request_parent ? (int)$request_parent : '',
				    'c' => $_GET['c'] ? htmlentities($_GET['c'], ENT_QUOTES, 'UTF-8') : '',
				    'd' => $_GET['d'] ? htmlentities($_GET['d'], ENT_QUOTES, 'UTF-8') : '',
				));
				break;
				
			// Вывод списка категорий и документов
			case "assortment":
				global $lang, $request_start, $request_parent;
				$start = $request_start>1 ? intval($request_start) : 1;
				$parent = intval($request_parent ? intval($request_parent) : $properties[2]);
				$rows = intval($max_rows);
				if (!$rows) $rows = $CONFIG["documents_max_rows"];
				if ($parent || $_GET['c'] || $_GET['d']) {
					$tpl_name = $tpl_name ? $tpl_name : $this->action_tpl[$action];
					$main->include_main_blocks($tpl_name, 'main');
					$tpl->prepare();
					$this->get_nav_path($parent, $transurl);
					$this->show_cat($parent, $transurl);
					$this->show_cats($parent, $transurl);
					$filter = $_GET;
					$page_cnt = $this->show_prods("pages", $transurl, $parent, $start, $rows, $filter);

					if ($page_cnt) {
    				    $link = '';
    				    if ($filter['c']) {
    				        $link .= "&c=".htmlspecialchars($filter['c'], ENT_QUOTES, 'UTF-8');
    				    }
    				    if ($filter['d']) {
    				        $link .= "&d=".htmlspecialchars($filter['d'], ENT_QUOTES, 'UTF-8');
    				    }
    					// вывод навигации по документам
    					$main->_show_nav_block($page_cnt, null, "action=".$action."&parent=".$parent.$link, $start);
    				}
					//$main->_show_nav_string($this->table_prefix."_documents_products", " AND category_id = $parent", "nav", "action=$action&parent=$parent", $start, $rows, $CONFIG["documents_prod_order_by"], "", 0, 0);
				} else {
					$main->include_main_blocks($this->module_name . "_index.html", "main");
					$tpl->prepare();
					$this->show_cats($parent, $transurl);
				}
				$this->create_tree($request_parent, 'tree', '', $baseurl);
				break;


// Вывод списка категорий и документов
			case "showatree":
				global $lang, $request_start;
				$main->include_main_blocks($this->module_name . "_dll_tree.html", "main");
				$tpl->prepare();
				$this->create_tree($request_parent, 'tree', '', $baseurl);

				break;


			// Вывод списка категорий как подменю сайта
//------------------------------------------------
			case "showcategories":
				$main->include_main_blocks($this->module_name . "_categories.html", "main");
				$tpl->prepare();
				$this->show_categories(0, $transurl);
				break;


			// Вывод списка категорий как выпадающего меню
//---------------------------------------------------
			case "showselectmenu":
				global $lang, $request_parent;
				$main->include_main_blocks($this->module_name . "_select_menu.html", "main");
				$tpl->prepare();
				$this->show_categories(0, $transurl, $request_parent);
				break;


			// Показать описание конкретного документа
//--------------------------------------------
			case "showproduct":
				global $lang, $request_start, $request_id;
				$id = intval($request_id);
				$request_start = intval($request_start);
				$main->include_main_blocks($this->module_name . "_product.html", "main");
				$tpl->prepare();
				list(,$parent) = $this->show_prod($id, $request_start, $transurl);
				$this->get_nav_path($parent, $transurl, $id);
				break;


			// Вывод последних добавленных
//----------------------------
			case "stats_last":
				global $lang, $request_start;
				$start = $start>1 ? intval($request_start) : 1;
				$parent = intval($request_parent ? intval($request_parent) : $properties[2]);
				$rows = intval($max_rows);
				if (!$rows) $rows = $CONFIG["documents_max_rows"];
				$main->include_main_blocks($this->module_name . "_last.html", "main");
				$tpl->prepare();
				$this->show_products("stats_last", $transurl, 0, 0, $max_rows);
				$this->create_tree($request_parent, 'tree', '', $baseurl);
				break;


			// Вывод самых популярных
//----------------------------
			case "stats_documents":
				global $lang, $request_start;
				$start = $start>1 ? intval($request_start) : 1;
				$parent = intval($request_parent ? intval($request_parent) : $properties[2]);
				$rows = intval($max_rows);
				if (!$rows) $rows = $CONFIG["documents_max_rows"];
				$main->include_main_blocks($this->module_name . "_pop.html", "main");
				$tpl->prepare();
				$this->show_products("stats_documents", $transurl, 0, 0, $max_rows);
				$this->create_tree($request_parent, 'tree', '', $baseurl);
				break;


			// Забор файла
//----------------------------
			case "count_file":
			    global $request_id;
				if (!$this->test_item_rights("r", "id", $this->table_prefix."_documents_products", $request_id))
				$main->message_access_denied($this->module_name, $action);
				$main->include_main_blocks($this->module_name . "_count_file.html", "main");
				$tpl->prepare();
				$this->count_file($request_id);
				break;
			// Выгрузка файла
//----------------------------
			case "download":
			    global $request_id;
				if (!$this->test_item_rights("r", "id", $this->table_prefix."_documents_products", $request_id))
					$main->message_access_denied($this->module_name, $action);

				$DD = new CDocumentsData_DB($this->table_prefix."_documents_products", "id");				
				$DD->show_product($request_id);
				if ($DD > 0) {				    
				    $DD->countup_document($request_id);
					$file_path = RP.$CONFIG["documents_file_path"].$DD->path.$DD->file_path;
					$file_name = str_replace('+', ' ', urlencode($DD->file_name));					
					if(!$DD->file_path  || ($DD->file_path && !file_exists($file_path)) ) {
					    Module::go_back($baseurl."&action=notfound");
					}

					$file_size = filesize($file_path);
					if($f = fopen($file_path, "rb")) {
						header("Pragma: public");
						header("Expires: 0");
						header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
						header("Cache-Control: private", false);
						header("Content-Type: application/force-download");
						$CONFIG['user_agent_opera'] || $CONFIG['user_agent_ie']
						    ? header("Content-Disposition: attachment; filename=\"" . $file_name . "\"")
						    : header("Content-Disposition: attachment; filename=\"" . $file_name . "\"; filename*=\"UTF-8'ru-ru'" . $file_name . "\"");
						header("Content-Transfer-Encoding: binary");
						header("Content-Length: " . $file_size);
						while (!feof($f)) {
                          echo fread($f, 2048);
                        }
                        fclose($f);

						//$contents = fread($f, $file_size);
						//echo $contents;
					}
				}
				exit;

// Вывод дерева категорий
			case "tree":
				$tpl_name = $tpl_name ? $tpl_name : $this->action_tpl[$action];
                $main->include_main_blocks($tpl_name, 'main');
				$tpl->prepare();
				$tree_list = $this->getSubTree($properties[2], array('active' => 1));
				$this->showTree($tree_list, $transurl);
				/*
				$html	= $this->get_tree_2($transurl, $properties[3]);
				$tpl->assign(array("sub_menu_two" => $html));
				*/
				break;

			case "notfound":
				$tpl_name = $tpl_name ? $tpl_name : $this->action_tpl[$action];
                $main->include_main_blocks($tpl_name, 'main');
				$tpl->prepare();
				break;
				
			// Default...
//-----------------------------------------------------------------------------
			default:
				if (is_object($tpl)) $tpl->prepare();
				return;
			}
//------------------------------- конец обработки действий с сайта -----------------------------//
		} else {
//------------------------------ обработка действий из админ части -----------------------------//
            
      		if ($this->actionExists($action)) {
      		    $this->doAction($action);
      		    return;
      		}
      		
			if (!isset($tpl)) {
			    $main->message_die(iconv("WINDOWS-1251", "UTF-8", 'Не подключен класс для работы с шаблонами'));
			}
			switch ($action) {
		    case 'prp':
		    	if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $request_step;
				$main->include_main_blocks('_properties.html', $this->tpl_path);
				$tpl->prepare();
				$tpl->assign(Array(
					"MSG_Information"	=> $main->_msg["Information"],
					"MSG_Value"			=> $main->_msg["Value"],
					"MSG_Save"			=> $main->_msg["Save"],
					"MSG_Cancel"		=> $main->_msg["Cancel"],
				));
		        if (!$request_step || $request_step == 1) {
					$tpl->assign(array('form_action'	=> $baseurl,
									   'step'			=> 2,
									   'lang'			=> $lang,
									   'name'			=> $this->module_name,
									   'action'			=> 'prp'));
					$prp_html = $main->getModuleProperties($this->module_name);
		            $this->main_title = $this->_msg["Controls"];
				} elseif (2 == $request_step) {
		        	$main->setModuleProperties($this->module_name, $_POST);
					header('Location: '.$baseurl.'&action=prp&step=1');
				}
		    	break;

			case 'block_prp':
				global $request_sub_action, $request_block_id;
		    	$arr  = $this->getEditLink($request_sub_action, $request_block_id);
		    	$cont = 'var container = document.getElementById(\'target_span\');
		    		  	 container.innerHTML = "'.$this->getPropertyFields().'";
		    		  	 material_id		  = "'.$arr['material_id'].'";
		    		  	 material_url		  = "'.$arr['material_url'].'";
		    		  	 changeAction();
		    	      	 //setURL("property1");';
				header('Content-Length: '.strlen($cont));
		    	echo $cont;
		    	exit;
		    	break;

			case "showtree":
				if (!$permissions["r"]) $main->message_access_denied($this->module_name, $action);
				global $request_parent;
				$main->include_main_blocks_2($this->module_name."_dll_tree.html", $this->tpl_path);
				$tpl->prepare();
				$this->create_tree($request_parent, 'tree', '', $baseurl);
				$this->main_title = $this->_msg["Catalogue_tree"];
				break;

// Вывод списка категорий и документов
			case "assortment":
				if (!$permissions["r"]) $main->message_access_denied($this->module_name, $action);
				global $request_start, $request_parent;
				$ctg_owners = $this->get_category_owners($request_parent);
				$start	= (int)$request_start;
				$parent	= (int)$request_parent;
				if (!$start) $start = 1;
				$main->include_main_blocks_2($this->module_name."_assortment.html", $this->tpl_path);
				$tpl->prepare();
				$filter = $_GET;
				$tpl->assign(array(
				    'baseurl' => $baseurl,
				    'action' => $action,
				    'parent' => $parent,
				    'c' => $filter['c']
				));
				// навигационная строчка
				$level = $this->show_nav_path($parent, $baseurl);
				// показывать иконку добавления документа или подкатегории в текущую категорию
				$this->show_add_to_current($level, $parent);
				// список категорий
				$this->show_categories($parent, null, null, $ctg_owners);				
				$pages_cnt = $this->show_products("pages", $baseurl, $parent, $start, $CONFIG["documents_max_rows"], $ctg_owners, $filter);
				if ($pages_cnt) {
				    $link = '';
				    if ($filter['c']) {
				        $link .= "&c=".htmlspecialchars($filter['c']);
				    }
				    if ($filter['d']) {
				        $link .= "&d=".htmlspecialchars($filter['d']);
				    }
					// вывод навигации по документам
					$main->_show_nav_block($pages_cnt, null, "action=".$action."&parent=".$parent.$link, $start);
				}
				$tpl->assign(Array(
					"nav.Pages" => $this->_msg["Pages"],
				));
				
				if ($filter['c']) {
				    $tpl->newBlock('block_search');
				    $tpl->assign('c', htmlspecialchars($filter['c']));
				}
				$this->main_title = $this->_msg["Sections_documents"];
				break;

// Добавить категорию
			case "adddll":
				if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
				global $request_step, $request_parent, $request_start, $request_cname,
						$request_url, $request_description, $request_active, $request_block_id;
				$ctg_owners = $this->get_category_owners($request_parent);
				if ($request_parent) {
					list($allow, $ctg_rights) = $this->test_item_rights("e", "id", $this->table_prefix."_documents_categories",
																		$request_parent, false, $ctg_owners, true);
					if (!$allow) $main->message_access_denied($this->module_name, $action);
				} else {
					$ctg_rights = $CONFIG["documents_default_rights"];
				}


				$main->include_main_blocks_2($this->module_name."_edit_category.html", $this->tpl_path);
				$tpl->prepare();
				$tpl->assign(Array(
					"MSG_Enter_name" => $this->_msg["Enter_name"],
					"MSG_Name" => $this->_msg["Name"],
					"MSG_Description" => $this->_msg["Description"],
					"MSG_required_fields" => $this->_msg["required_fields"],
					"MSG_Save" => $this->_msg["Save"],
					"MSG_Cancel" => $this->_msg["Cancel"],
				));
				if (!$request_step || $request_step == 1) {
					$level = $this->show_nav_path($request_parent, $baseurl);
					if ($level > $CONFIG["documents_max_level"]) {
						header("Location: $baseurl&action=assortment&parent=$request_parent");
						exit;
					}
					$tpl->assign(array(
						"_ROOT.form_action"	=>	"$baseurl&action=adddll&start=$request_start",
						"_ROOT.parent"		=>	$request_parent,
						"_ROOT.cancel_link"	=>	"javascript:history.back();",
						"_ROOT.str_path"	=>	"/admin/?name=documents&action=str"
					));
					$this->show_document_images($this->category_images, $CONFIG["documents_dll_img_path"], "block_dll_image");
					$this->main_title = $this->_msg["Create_new_category"];
					break;
				} else if ($request_step == 2) {
					$block_id = intval(substr($request_block_id, 10));
					$lid = $this->add_category($request_active, $request_cname, $request_parent, $request_url, $request_description, $ctg_rights, $block_id);
					if ($lid) @$cache->delete_cache_files();
					header("Location: $baseurl&action=assortment&parent=$request_parent");
					exit;
					break;
				}

// Редактировать категорию
			case "editdll":
				if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
				global $request_id, $request_start, $request_parent;
				$ctg_owners = $this->get_category_owners($request_parent);
				if (!$this->test_item_rights("e", "id", $this->table_prefix."_documents_categories", $request_id, false, $ctg_owners))
					$main->message_access_denied($this->module_name, $action);

				$main->include_main_blocks_2($this->module_name."_edit_category.html", $this->tpl_path);
				$tpl->prepare();
				$tpl->assign(Array(
					"MSG_Enter_name" => $this->_msg["Enter_name"],
					"MSG_Name" => $this->_msg["Name"],
					"MSG_Description" => $this->_msg["Description"],
					"MSG_required_fields" => $this->_msg["required_fields"],
					"MSG_Save" => $this->_msg["Save"],
					"MSG_Cancel" => $this->_msg["Cancel"],
				));
				$level = $this->show_nav_path($request_id, $baseurl);
				$tpl->assign(array(
					"_ROOT.form_action"	=>	"$baseurl&action=updatedll&start=$request_start",
					"_ROOT.parent"		=>	$request_parent,
					"_ROOT.referer"		=>	$_SERVER['HTTP_REFERER'],
					"_ROOT.cancel_link"	=>	"javascript:history.back();",
					"_ROOT.str_path"	=>	"$baseurl&action=str",
				));
				if (!$this->show_category($request_id, $baseurl)) { // если нет такой записи то редирект
					header("Location: $baseurl&action=assortment");
					exit;
				}
				$this->main_title = $this->_msg["Edit_category"];
				break;

// Обновить категорию
			case "updatedll":
				if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
				global $request_id, $request_cname, $request_url, $request_description,
						$request_referer, $request_parent, $request_active, $request_start;
				$ctg_owners = $this->get_category_owners($request_parent);
				if (!$this->test_item_rights("e", "id", $this->table_prefix."_documents_categories", $request_id, false, $ctg_owners))
					$main->message_access_denied($this->module_name, $action);

				if ($this->update_category($request_id, $request_active, $request_cname, $request_url, $request_description, $imagename)) @$cache->delete_cache_files();
				$location = ($request_referer) ? $request_referer : "$baseurl&action=assortment&parent=$request_parent&start=$request_start";
				header("Location: $location");
				break;

// Поднять категорию на shift позиций вверх
			case "updll":
				if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
				global $request_parent, $request_rank, $request_shift, $request_start;
				$request_parent = intval($request_parent);
				$request_shift = (int)$request_shift;
				$ctg_owners = $this->get_category_owners($request_parent);
				if (!$this->test_item_rights("p", "id", $this->table_prefix."_documents_categories", $request_id, false, $ctg_owners))
					$main->message_access_denied($this->module_name, $action);

				if ($main->change_order('up', $this->table_prefix.'_documents_categories', 'rank', $request_rank, $request_shift, "parent_id=".$request_parent." AND "))
					@$cache->delete_cache_files();
				header("Location: $baseurl&action=assortment&parent=$request_parent&start=$request_start");
				exit;
				break;

// Опустить категорию на shift позиций вниз
			case "downdll":
				if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
				global $request_parent, $request_rank, $request_shift, $request_start;
				$request_parent = intval($request_parent);
				$request_shift = (int)$request_shift;
				$ctg_owners = $this->get_category_owners($request_parent);
				if (!$this->test_item_rights("p", "id", $this->table_prefix."_documents_categories", $request_id, false, $ctg_owners))
					$main->message_access_denied($this->module_name, $action);

				// поправка для Одиссея
				if ($main->change_order('down', $this->table_prefix.'_documents_categories', 'rank', $request_rank, $request_shift, "parent_id=".$request_parent." AND "))
					@$cache->delete_cache_files();
				header("Location: $baseurl&action=assortment&parent=$request_parent&start=$request_start");
				exit;
				break;

// Удалить категорию и все связанные с нею записи
//------------------------------------------------------
			case "deldll":
				if (!$permissions["d"]) $main->message_access_denied($this->module_name, $action);
				global $request_step, $request_id, $request_start, $request_category, $request_parent;
				if ($request_id) $request_category = $request_id;
				$ctg_owners = $this->get_category_owners($request_parent);
				if (!$this->test_item_rights("d", "id", $this->table_prefix."_documents_categories", $request_category, false, $ctg_owners))
					$main->message_access_denied($this->module_name, $action);

				// Удаление категории, первый шаг
				if (!$request_step || $request_step == 1) {
					$main->include_main_blocks_2($this->module_name."_del_category.html", $this->tpl_path);
					$tpl->prepare();
					$tpl->assign(array(
						"MSG_Deleting_category" => $this->_msg["Deleting_category"],
						"MSG_deletes_all_subcategories" => $this->_msg["deletes_all_subcategories"],
						"MSG_Confirm_delete_category" => $this->_msg["Confirm_delete_category"],
						"MSG_Delete" => $this->_msg["Delete"],
						"MSG_Cancel" => $this->_msg["Cancel"],
						"_ROOT.form_action"	=>	"$baseurl&action=deldll&start=$request_start",
						"_ROOT.category"	=>	$request_category,
						"_ROOT.parent"		=>	$request_parent,
						"_ROOT.cancel_link"	=>	"javascript:history.back();",
					));
					$this->show_category($request_category, $baseurl);
					$this->main_title = $this->_msg["Category_deleting"];
					break;
				// Удаление категории, шаг второй
				} else if ($request_step == 2) {
					if ($this->delete_category($request_category)) @$cache->delete_cache_files();
					header("Location: $baseurl&action=assortment&parent=$request_parent&start=$request_start");
					exit;
				}
				$this->main_title = $this->_msg["Document_sections"];
				break;

// Выключение публикации
			case "suspend":
				if (!$permissions["p"]) $main->message_access_denied($this->module_name, $action);
				global $request_id, $request_parent, $request_start;
				$ctg_owners = $this->get_category_owners($request_parent);
				if (!$this->test_item_rights("p", "id", $this->table_prefix."_documents_categories", $request_id, false, $ctg_owners))
					$main->message_access_denied($this->module_name, $action);

				if ($main->suspend($this->table_prefix.'_documents_categories', $request_id)) @$cache->delete_cache_files();
				header("Location: $baseurl&action=assortment&parent=$request_parent&start=$request_start");
				exit;
				break;

// Включение публикации
			case "activate":
				if (!$permissions["p"]) $main->message_access_denied($this->module_name, $action);
				global $request_id, $request_parent, $request_start;
				$ctg_owners = $this->get_category_owners($request_parent);
				if (!$this->test_item_rights("p", "id", $this->table_prefix."_documents_categories", $request_id, false, $ctg_owners))
					$main->message_access_denied($this->module_name, $action);

				if ($main->activate($this->table_prefix.'_documents_categories', $request_id)) @$cache->delete_cache_files();
				header("Location: $baseurl&action=assortment&parent=$request_parent&start=$request_start");
				exit;
				break;


// Отключить публикацию выбранных разделов документов
			case "suspendcategory_checked":
				if (!$permissions["p"]) $main->message_access_denied($this->module_name, $action);
				global $request_check, $request_parent, $request_start;
				if(is_array($request_check)) {
					$ctg_owners = $this->get_category_owners($request_parent);
					foreach($request_check as $k => $v) {
						if ($this->test_item_rights("p", "id", $this->table_prefix."_documents_categories", $v, false, $ctg_owners)) {
							if ($main->suspend($this->table_prefix.'_documents_categories', $v)) @$cache->delete_cache_files();
						}
					}
				}
				header("Location: $baseurl&action=assortment&parent=$request_parent&start=$request_start");
				exit;
				break;

// Включить публикацию выбранных разделов документов
			case "activatecategory_checked":
				if (!$permissions["p"]) $main->message_access_denied($this->module_name, $action);
				global $request_check, $request_parent, $request_start;
				if(is_array($request_check)) {
					$ctg_owners = $this->get_category_owners($request_parent);
					foreach($request_check as $k => $v) {
						if ($this->test_item_rights("p", "id", $this->table_prefix."_documents_categories", $v, false, $ctg_owners)) {
							if ($main->activate($this->table_prefix.'_documents_categories', $v)) @$cache->delete_cache_files();
						}
					}
				}
				header("Location: $baseurl&action=assortment&parent=$request_parent&start=$request_start");
				exit;
				break;

// Удалить выбранные разделы документов
			case "deletecategory_checked":
				if (!$permissions["d"]) $main->message_access_denied($this->module_name, $action);
				global $request_check, $request_parent, $request_start;
				if(is_array($request_check)) {
					$ctg_owners = $this->get_category_owners($request_parent);
					foreach($request_check as $k => $v) {
						if ($this->test_item_rights("p", "id", $this->table_prefix."_documents_categories", $v, false, $ctg_owners)) {
							if ($this->delete_category($v)) @$cache->delete_cache_files();
						}
					}
				}
				header("Location: $baseurl&action=assortment&parent=$request_parent&start=$request_start");
				exit;
				break;

// Редактирование прав категории
			case 'editctgrights':
				if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $request_id, $request_parent, $request_start;
				$ctg_owners = $this->get_category_owners($request_parent);
				if (!$this->test_item_rights("e", "id", $this->table_prefix."_documents_categories", $request_id, true, $ctg_owners, false, true))
					$main->message_access_denied($this->module_name, $action);

				if (!$this->show_rights_form($this->table_prefix."_documents_categories", "name", $request_id,
											"&id=".$request_id."&parent=".$request_parent, $this->_msg["Category"], "savectgrights")) {
					header('Location: '.$baseurl.'&parent='.$request_parent.'&start='.$request_start);
				}
				break;

// Сохранение прав категории
			case 'savectgrights':
				if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $request_id, $request_parent, $request_start, $request_rights;
				$ctg_owners = $this->get_category_owners($request_parent);
				if (!$this->test_item_rights("e", "id", $this->table_prefix."_documents_categories", $request_id, true, $ctg_owners, false, true))
					$main->message_access_denied($this->module_name, $action);

				$this->save_rights_form($this->table_prefix."_documents_categories", $request_id, $request_rights);
				if ($request_type == "JsHttpRequest") {
					$_RESULT = array(
									"res"	=> 1,
									"category"	=> $request_parent,
								);
				} else {
					header('Location: '.$baseurl.'&parent='.$request_parent.'&start='.$request_start);
				}
				exit;
				break;


// Добавить документ
			case "addproduct":
				if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
				global $request_parent, $request_start, $request_step, $request_pname,
						$request_short_description, $request_txt_content, $request_full_description,
						$request_code, $request_date, $request_active, $request_block_id;
				$ctg_owners = $this->get_category_owners($request_parent);
				list($allow, $ctg_rights) = $this->test_item_rights("e", "id", $this->table_prefix."_documents_categories",
																	$request_parent, false, $ctg_owners, true);
				if (!$allow) $main->message_access_denied($this->module_name, $action);

				$main->include_main_blocks_2($this->module_name."_edit_product.html", $this->tpl_path);
				$tpl->prepare();
				$tpl->assign(Array(
					"MSG_Enter_document_name" => $this->_msg["Enter_document_name"],
					"MSG_Name" => $this->_msg["Name"],
					"MSG_Short_description" => $this->_msg["Short_description"],
					"MSG_Full_description" => $this->_msg["Full_description"],
					"MSG_required_fields" => $this->_msg["required_fields"],
					"MSG_Save" => $this->_msg["Save"],
					"MSG_Cancel" => $this->_msg["Cancel"],
					"MSG_Date" => $this->_msg["Date"],
					"MSG_Code" => $this->_msg["Code"],
					"MSG_Select" => $this->_msg["Select"],
				));

				$level = $this->show_nav_path($request_parent, $baseurl);
				if ($level > $CONFIG["documents_max_level"]) {
					header("Location: $baseurl&action=assortment&parent=$request_parent&start=$request_start");
					exit;
				}

				$this->show_document_images($this->product_images, $CONFIG["documents_img_path"], "block_product_image");
				$this->show_document_files($this->product_files, $CONFIG["documents_file_path"].$lang.'/', "block_product_file");

				if (!$request_step || $request_step == 1) {
					$tpl->assign(array(
						'_ROOT.form_action'		=> $baseurl.'&action=addproduct',
						'_ROOT.parent'			=> $request_parent,
						'_ROOT.cancel_link'		=> 'javascript:history.back();',
						'_ROOT.date'		=> date('d.m.Y'),
					));
					$this->main_title = $this->_msg["Add_document"];
					break;
				} else if ($request_step == 2) {
                    $block_id = intval(substr($request_block_id, 10));
					$lid = $this->add_product($request_active, $request_pname, $request_code, $request_date,
					    $request_short_description, $request_txt_content,
					    $request_parent, $ctg_rights, $block_id);
					if ($lid) {
						$lc->add_internal_links($this->module_name, $this->table_prefix.'_documents_products', 'full_description', $lid, $this->_msg["link_in_catalogue"], $request_full_description);
						@$cache->delete_cache_files();
					}
					header('Location: '.$baseurl.'&action=assortment&parent='.$request_parent.'&start='.$request_start);
					exit;
					break;
				}

// Редактировать документ
			case "editproduct":
				if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
				global $request_parent, $request_start, $request_id;
				$ctg_owners = $this->get_category_owners($request_parent);
				if (!$this->test_item_rights("e", "id", $this->table_prefix."_documents_products", $request_id, false, $ctg_owners))
					$main->message_access_denied($this->module_name, $action);

				$main->include_main_blocks_2($this->module_name."_edit_product.html", $this->tpl_path);
				$tpl->prepare();
				$tpl->assign(Array(
					"MSG_Enter_document_name" => $this->_msg["Enter_document_name"],
					"MSG_Name" => $this->_msg["Name"],
					"MSG_Short_description" => $this->_msg["Short_description"],
					"MSG_Full_description" => $this->_msg["Full_description"],
					"MSG_required_fields" => $this->_msg["required_fields"],
					"MSG_Save" => $this->_msg["Save"],
					"MSG_Cancel" => $this->_msg["Cancel"],
					"MSG_Date" => $this->_msg["Date"],
					"MSG_Code" => $this->_msg["Code"],
					"MSG_Select" => $this->_msg["Select"],
				));
				$level = $this->show_nav_path($request_parent, $baseurl);
				$tpl->assign(array(
					"_ROOT.form_action"		=>	"$baseurl&action=updateproduct&start=$request_start",
					"_ROOT.parent"			=>	$request_parent,
					"_ROOT.referer"			=>	$_SERVER['HTTP_REFERER'],
					"_ROOT.cancel_link"		=>	"$baseurl&action=assortment&parent=$request_parent",
				));
				list($success) = $this->show_product($request_id, $request_start);
				// если нет такой записи то редирект
				if (!$success) {header("Location: $baseurl&action=addproduct"); exit;}
				$this->main_title = $this->_msg["Edit_document"];
				break;

// Обновить документ
			case "updateproduct":
				if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
				global $request_id, $request_pname, $request_short_description, $request_txt_content,
				    $request_parent, $request_full_description, $request_referer, $request_start,
				    $request_code, $request_date, $request_active;
				$ctg_owners = $this->get_category_owners($request_parent);
				if (!$this->test_item_rights("e", "id", $this->table_prefix."_documents_products", $request_id, false, $ctg_owners))
					$main->message_access_denied($this->module_name, $action);

				if ($this->update_product($request_id, $request_active, $request_pname, $request_code, $request_date, $request_short_description, $request_txt_content, $request_parent)) {
					$lc->add_internal_links($this->module_name, $this->table_prefix.'_documents_products', 'full_description', $request_id, $this->_msg["link_in_catalogue"], $request_full_description);
					@$cache->delete_cache_files();
				}
				$location = ($request_referer) ? $request_referer : "$baseurl&action=assortment&parent=$request_parent&start=$request_start";
				header("Location: $location");
				exit;
				break;

// Поднять документ на shift позиций вверх
			case "upproduct":
				if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
				global $request_parent, $request_rank, $request_shift, $request_start;
				$request_parent = intval($request_parent);
				$request_shift = intval($request_shift);
				$ctg_owners = $this->get_category_owners($request_parent);
				if (!$this->test_item_rights("p", "id", $this->table_prefix."_documents_products", $request_id, false, $ctg_owners))
					$main->message_access_denied($this->module_name, $action);

				if ($main->change_order('up', $this->table_prefix.'_documents_products', 'rank', $request_rank, $request_shift, 'category_id = '.$request_parent.' AND ')) @$cache->delete_cache_files();
				header("Location: $baseurl&action=assortment&parent=$request_parent&start=$request_start");
				exit;
				break;


// Опустить документ на shift позиций вниз
			case "downproduct":
				if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
				global $request_parent, $request_rank, $request_shift, $request_start;
				$request_parent = intval($request_parent);
				$request_shift = intval($request_shift);
				$ctg_owners = $this->get_category_owners($request_parent);
				if (!$this->test_item_rights("p", "id", $this->table_prefix."_documents_products", $request_id, false, $ctg_owners))
					$main->message_access_denied($this->module_name, $action);

				if ($main->change_order('down', $this->table_prefix.'_documents_products', "rank", $request_rank, $request_shift, "category_id = $request_parent AND ")) @$cache->delete_cache_files();
				header("Location: $baseurl&action=assortment&parent=$request_parent&start=$request_start");
				exit;
				break;

// Удалить документ
			case "delproduct":
				if (!$permissions["d"]) $main->message_access_denied($this->module_name, $action);
				global $request_id, $request_parent, $request_start;
				$ctg_owners = $this->get_category_owners($request_parent);
				if (!$this->test_item_rights("d", "id", $this->table_prefix."_documents_products", $request_id, false, $ctg_owners))
					$main->message_access_denied($this->module_name, $action);

				if ($this->delete_product($this->table_prefix.'_documents_products', $request_id)) {
					$lc->delete_internal_links($this->module_name, $this->table_prefix.'_documents_products', $request_id);
					@$cache->delete_cache_files();
				}
				header("Location: $baseurl&action=assortment&parent=$request_parent&start=$request_start");
				exit;
				break;

// Выключение публикации документа
			case "suspendproduct":
				if (!$permissions["p"]) $main->message_access_denied($this->module_name, $action);
				global $request_id, $request_parent, $request_start;
				$ctg_owners = $this->get_category_owners($request_parent);
				if (!$this->test_item_rights("p", "id", $this->table_prefix."_documents_products", $request_id, false, $ctg_owners))
					$main->message_access_denied($this->module_name, $action);

				if ($main->suspend($this->table_prefix.'_documents_products', $request_id)) @$cache->delete_cache_files();
				header("Location: $baseurl&action=assortment&parent=$request_parent&start=$request_start");
				exit;
				break;

// Включение публикации документа
			case "activateproduct":
				if (!$permissions["p"]) $main->message_access_denied($this->module_name, $action);
				global $request_id, $request_parent, $request_start;
				$ctg_owners = $this->get_category_owners($request_parent);
				if (!$this->test_item_rights("p", "id", $this->table_prefix."_documents_products", $request_id, false, $ctg_owners))
					$main->message_access_denied($this->module_name, $action);

				if ($main->activate($this->table_prefix.'_documents_products', $request_id)) @$cache->delete_cache_files();
				header("Location: $baseurl&action=assortment&parent=$request_parent&start=$request_start");
				exit;
				break;


// Удалить выбранные документы
			case "deleteproduct_checked":
				if (!$permissions["d"]) $main->message_access_denied($this->module_name, $action);
				global $request_check, $request_parent, $request_start;
				if(is_array($request_check)) {
					$ctg_owners = $this->get_category_owners($request_parent);
					foreach($request_check as $k => $v) {
						if ($this->test_item_rights("d", "id", $this->table_prefix."_documents_products", $v, false, $ctg_owners)) {
							if ($this->delete_product($this->table_prefix.'_documents_products', $v)) {
								$lc->delete_internal_links($this->module_name, $this->table_prefix.'_documents_products', $v);
								@$cache->delete_cache_files();
							}
						}
					}
				}
				header("Location: $baseurl&action=assortment&parent=$request_parent&start=$request_start");
				exit;
				break;

// Отключить публикацию выбранных документов
			case "suspendproduct_checked":
				if (!$permissions["p"]) $main->message_access_denied($this->module_name, $action);
				global $request_check, $request_parent, $request_start;
				if(is_array($request_check)) {
					$ctg_owners = $this->get_category_owners($request_parent);
					foreach($request_check as $k => $v) {
						if ($this->test_item_rights("p", "id", $this->table_prefix."_documents_products", $v, false, $ctg_owners)) {
							if ($main->suspend($this->table_prefix.'_documents_products', $v)) @$cache->delete_cache_files();
						}
					}
				}
				header("Location: $baseurl&action=assortment&parent=$request_parent&start=$request_start");
				exit;
				break;

// Включить публикацию выбранных документов
			case "activateproduct_checked":
				if (!$permissions["p"]) $main->message_access_denied($this->module_name, $action);
				global $request_check, $request_parent, $request_start;
				if(is_array($request_check)) {
					$ctg_owners = $this->get_category_owners($request_parent);
					foreach($request_check as $k => $v) {
						if ($this->test_item_rights("p", "id", $this->table_prefix."_documents_products", $v, false, $ctg_owners)) {
							if ($main->activate($this->table_prefix.'_documents_products', $v)) @$cache->delete_cache_files();
						}
					}
				}
				header("Location: $baseurl&action=assortment&parent=$request_parent&start=$request_start");
				exit;
				break;


// Вывести из лидеров продаж
			case "noleader":
				if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
				global $request_id, $request_parent, $request_start;
				if ($this->no_leader($request_id)) @$cache->delete_cache_files();
				header("Location: $baseurl&action=assortment&parent=$request_parent&start=$request_start");
				exit;
				break;

// Сделать лидером продаж
			case "makeleader":
				if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
				global $request_id, $request_parent, $request_start;
				if ($this->make_leader($request_id)) @$cache->delete_cache_files();
				header("Location: $baseurl&action=assortment&parent=$request_parent&start=$request_start");
				exit;
				break;

// Редактирование прав документа
			case 'editrights':
				if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $request_id, $request_parent, $request_start;
				if (!$this->test_item_rights("e", "id", $this->table_prefix."_documents_products", $request_id, true))
					$main->message_access_denied($this->module_name, $action);

				if (!$this->show_rights_form($this->table_prefix."_documents_products", "name", $request_id,
											"&id=".$request_id."&parent=".$request_parent."&start=".$request_start, $this->_msg["Document"])) {
					header('Location: '.$baseurl.'&action=assortment&parent='.$request_parent.'&start='.$request_start);
				}
				break;

// Сохранение прав документа
			case 'saverights':
				if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $request_id, $request_parent, $request_start, $request_rights;
				if (!$this->test_item_rights("e", "id", $this->table_prefix."_documents_products", $request_id, true))
					$main->message_access_denied($this->module_name, $action);

				$this->save_rights_form($this->table_prefix."_documents_products", $request_id, $request_rights);
				if ($request_type == "JsHttpRequest") {
					$_RESULT = array(
						"res" => 1,
						"id" => $request_id,
					);
				} else {
					header('Location: '.$baseurl.'&action=assortment&parent='.$request_parent.'&start='.$request_start);
				}
				exit;
				break;

// Обнуления счетчика
			case 'tonull':
				if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $request_id, $db;
				if (!$this->test_item_rights("e", "id", $this->table_prefix."_documents_products", $request_id, true)) {
				    $main->message_access_denied($this->module_name, $action);
				}
				$db->query('UPDATE '.$this->table_prefix.'_documents_products SET downloads=0 WHERE id='.$request_id);
				header('Location: '.$_SERVER['HTTP_REFERER']);
				exit;
				break;

// Иконки для файлов
			case 'ico':
				if (!$permissions['r']) {
				    $main->message_access_denied($this->module_name, $action);
				}
				$main->include_main_blocks_2("{$this->module_name}_{$action}.html", $this->tpl_path);
				$tpl->prepare();
				$tpl->assign(array(
				    'MSG_Add' => $this->_msg['Add'],
				    'MSG_Extention' => $this->_msg['Extention'],
				    'MSG_Ico' => $this->_msg['Ico'],
				    'MSG_Save' => $this->_msg['Save'],
				    'MSG_Cancel' => $this->_msg['Cancel'],
				    'MSG_Add_file_ico' => $this->_msg['Add_file_ico'],
				    'MSG_Allowed_extensions' => $this->_msg['Allowed_extensions'],
				    'baseurl' => $baseurl,
				    'allowed_extensions' => implode(", ", array_unique($this->document_image_formats))
				));
				$this->showIcoList();
				$this->main_title = $this->_msg["Files_ico"];
				break;

// Добавить иконку
			case 'addico':
				if (!$permissions['e']) {
				    $main->message_access_denied($this->module_name, $action);
				}
				$this->addIco($_POST['ext']);
				Module::go_back();
				exit;
				break;

// Удалить иконку
			case 'delico':
				if (!$permissions['d']) {
				    $main->message_access_denied($this->module_name, $action);
				}
				$this->delIco($_REQUEST['id']);
				Module::go_back();
				exit;
				break;

// Редактирование свойств блока
			case 'properties':
				if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $module_id, $request_field, $request_field, $title;
				$main->include_main_blocks('_block_properties.html', 'main');
				$tpl->prepare();

				if ($main->show_actions($request_field, '', $this->block_main_module_actions, $this->block_module_actions)) {
					//$this->create_tree(0, 'list');
					$main->show_linked_pages($module_id, $request_field);
				}

				$tpl->assign(array( '_ROOT.title'		=> $title,
									'_ROOT.username'	=> $_SESSION['session_login'],
									'_ROOT.password'	=> $_SESSION['session_password'],
									'_ROOT.name'		=> $this->module_name,
									'_ROOT.lang'		=> $lang,
									));
				$this->main_title	= $this->_msg["Block_properties"];
				break;

// Создание объекта для дальнейшего использования
			case 'only_create_object':
				break;

// Default...
			default:
				$main->include_main_blocks();
				$tpl->prepare();
			}
//--------------------------- конец обработки действий из админ части --------------------------//
		}
	}


	// функция для вывода категорий каталога в навигационном
	// подменю наравне со ссылками на страницы сайта
	// вызывается в модуле pages в функции
	// show_sub_nav_menu при формировании подменю
	// ------------------------------------------------------
	function get_submenu_items_from_module() {
		global $DC, $CONFIG, $baseurl, $request_parent, $server, $lang;
		$parent = intval($request_parent);
		$mod_titles_array = array();
		$mod_links_array = array();
		$DC = new CDocumentsCategories_DB($this->table_prefix."_documents_categories", "id");
		$DC->get_submenu_items($CONFIG["documents_dll_order_by"]);
		if (count($DC) > 0) {
			foreach ($DC as $k=>$v) {
				$mod_titles_array[$v["id"]] = $v["name"];
				$mod_links_array[$v["id"]] = "${baseurl}&action=assortment&parent=".$v["id"];
			}
		}
		return array($mod_titles_array, $mod_links_array, $parent);
	}


	function show_cats($parent = 0, $transurl = null, $selected_category = null) {
		global $CONFIG, $tpl, $baseurl, $server, $lang;
		if (!isset($transurl)) $transurl = $baseurl;
		$parent = intval($parent);
		$DC = new CDocumentsCategories_DB($this->table_prefix."_documents_categories", "id");
		$temp = $DC->show_cats($parent, (strstr($_SERVER['PHP_SELF'], "admin.php") ? false : true), $CONFIG['documents_dll_order_by']);
		if (count($temp) > 0) {
			$tpl->newBlock("block_categories");
			foreach($temp as $k => $v) {
				$id = $v["id"];
				#$cat_link = $transurl.'&action=assortment&parent='.$id;
				$cat_link = ($CONFIG['rewrite_mod']) ? $this->cats_link('assortment', $id)
				                                     : $transurl.'&action=assortment&parent='.$id;
				$tpl->newBlock("block_categories_row");
				$tpl->assign(array(
					id						=>	$id,
					category_id				=>	$id,
					category_name			=>	$v["name"],
					category_descr			=>	nl2br($v["description"]),
					category_link			=>	$cat_link,
				));
			}
		}
	}

	function cats_link($action, $parent, $id=false, $transurl = false) {
	  global $baseurl;
	  
	  $url = $transurl ? $transurl : $baseurl;
	  if ($id)
	    return strtok($url, '?').$action.'/'.$parent.'/'.$id.'/';
	  else
	    return strtok($url, '?').$action.'/'.$parent.'/';
	}

	function show_cat($id, $transurl) {
		global $server, $lang, $CONFIG, $main, $tpl, $baseurl;
		$admin = Module::is_admin();
		$cat = $this->get_cat($id);
		if (!$cat || (!$admin && 0 == $cat['active'])) {
		    return 0;
		}
		$tpl->newBlock("block_category");
		$tpl->assign(array(
			category_id					=>	$cat['id'],
			category_name				=>	$cat['name'],
			category_descr				=>	$cat['description'],
			category_link				=>	"{$transurl}&action=assortment&parent=".$cat['id'],
		));
		$this->main_title = $cat['name'];
		return $cat['name'];
	}
	
	function get_cat($id)
	{   global $db;
		$ret = false;
		$id = (int) $id;
		if ($id > 0) {
		    if (isset($this->cache["cat{$id}"])) {
		        $ret = $this->cache["cat{$id}"];
		    } else {
		        $this->get_list_with_rights("d.*", $this->table_prefix."_documents_categories d", "d", "id = ".$id);
		        if ($db->next_record()) {
		            $ret = array(
		                'id' => $db->Record['id'],
		                'parent_id' => $db->Record['parent_id'],
		                'name' => $db->Record['name'],
		                'description' => $db->Record['description'],
		                'level' => $db->Record['level'],
		                'active' => $db->Record['active'],
		                'rank' => $db->Record['rank'],
		                'owner_id' => $db->Record['owner_id'],
		                'usr_group_id' => $db->Record['usr_group_id'],
		                'rights' => $db->Record['rights'],
		                'fs_name' => $db->Record['fs_name']		                
		            );
		            $this->cache["cat{$id}"] = $ret;
		        }
		    }
		}
		
		return $ret;
	}
	
	/**
	 * Поверить права на чтение категории и получить ее
	 * @param ште $id
	 * @return mixed -1 - нет прав, false - не найдена, array - найдена и есть права
	 */
	function test_ctgr($id)
	{   global $db;
	    $ret = $db->fetchOne($this->table_prefix."_documents_categories", array('clause' => array('id' => $id)));
	    if ($ret) {
	        if (!$this->test_item_rights('r', 'id', $this->table_prefix."_documents_categories", $ret['id'])) {
	            $ret = -1;
	        }
	    }
	    return $ret;
	}
	
	/**
	 * Поверить права на чтение документа и получить его
	 * @param ште $id
	 * @return mixed -1 - нет прав, false - не найден, array - найден и есть права
	 */
	function test_doc($id)
	{   global $db;
	    $ret = $db->fetchOne($this->table_prefix."_documents_products", array('clause' => array('id' => $id)));
	    if ($ret) {
	        if (!$this->test_item_rights('r', 'id', $this->table_prefix."_documents_products", $ret['id'])) {
	            $ret = -1;
	        }
	    }
	    return $ret;
	}
	
	function get_prod($id)
	{   global $db, $CONFIG;
		$ret = false;
		$id = (int) $id;
		if ($id > 0) {
		    if (isset($this->cache["prod{$id}"])) {
		        $ret = $this->cache["prod{$id}"];
		    } else {
		        $this->get_list_with_rights(
		            "d.*, DATE_FORMAT(d.added,'".$CONFIG["documents_date_format"]."') as added",
		            $this->table_prefix."_documents_products d", "d", "id = ".$id);
		        if ($db->next_record()) {
		            $ret = array(
		                'id' => $db->Record['id'],
		                'category_id' => $db->Record['category_id'],
		                'name' => $db->Record['name'],
		                'code' => $db->Record['code'],
		                'short_description' => $db->Record['short_description'],
		                'full_description' => $db->Record['full_description'],
		                'downloads' => $db->Record['downloads'],
		                'file_name' => $db->Record['file_name'],
		                'file_path' => $db->Record['file_path'],
		                'updated' => $db->Record['updated'],
		                'added' => $db->Record['added'],
		                'active' => $db->Record['active'],
		                'rank' => $db->Record['rank'],
		                'owner_id' => $db->Record['owner_id'],
		                'usr_group_id' => $db->Record['usr_group_id'],
		                'rights' => $db->Record['rights']		                
		            );
		            $this->cache["prod{$id}"] = $ret;
		        }
		    }
		}
		
		return $ret;
	}

	function show_prods( $type, $transurl, $category_id = null, $start = null, $rows = null, $filter = false) {
		global $server, $lang, $CONFIG, $main, $tpl, $core, $request_total, $db;
		$admin = Module::is_admin();
		$order_by = $CONFIG["documents_prod_order_by"];
		if (!$rows) $rows = $CONFIG["documents_max_rows"];
		$clause = (!$admin ? "d.active=1 AND c.active=1 AND " : "");
		$ret = false;
		if ($type == "pages") {
		    $category_str = '';
			$category_id = intval($category_id);
			if ($filter['c']) {
			    $c = My_Sql::escape(str_replace(
			        array('%', '_'),
			        array('\%', '\_'),
			        $filter['c']
			    ));
			    $category_str .= " AND (d.name LIKE '%{$c}%' OR d.code LIKE '%{$c}%')";
			}
			if ($filter['d']) {
			    $category_str .= " AND d.added='".Main::transform_date($filter['d'])."'";
			}
			if ($category_id) {
			    $category_str .= " AND category_id = $category_id";
			}
			if (! $category_str) {
			    return 0;
			}
			
			$start = $start > 1 ? (int) $start : 1;
			$total = $this->get_list_with_rights(
									"d.*, DATE_FORMAT(d.added,'".$CONFIG["documents_date_format"]."') as added",
									$this->table_prefix."_documents_products d INNER JOIN {$this->table_prefix}_documents_categories c ON d.category_id=c.id",
									"d", $clause."!ISNULL(category_id) ".$category_str,
									"", $order_by, $start, $rows, true);			
		// ---------------------------------------------------------------------------------------------------
		} else if ($type == "leaders") {
			$total = $this->get_list_with_rights(
							"d.*, DATE_FORMAT(d.added,'".$CONFIG["documents_date_format"]."') as added",
							$this->table_prefix."_documents_products d INNER JOIN {$this->table_prefix}_documents_categories c ON d.category_id=c.id",
							"d", $clause."is_leader = 1", "", "RAND()",
							0, $rows);
		// ---------------------------------------------------------------------------------------------------
		} else if ($type == "stats_last") {
			$total = $this->get_list_with_rights(
							"d.*, DATE_FORMAT(d.added,'".$CONFIG["documents_date_format"]."') as added",
							$this->table_prefix."_documents_products d INNER JOIN {$this->table_prefix}_documents_categories c ON d.category_id=c.id",
							"d", $clause."1=1", "", "added DESC",
							0, $rows);
		// ---------------------------------------------------------------------------------------------------
		} else if ($type == "stats_documents") {
			$total = $this->get_list_with_rights(
							"d.*, DATE_FORMAT(d.added,'".$CONFIG["documents_date_format"]."') as added",
							$this->table_prefix."_documents_products d INNER JOIN {$this->table_prefix}_documents_categories c ON d.category_id=c.id",
							"d", $clause."1=1", "", "downloads DESC",
							0, $rows);
		} else {
			return 0;
		}

		$ret = ceil($total/$rows);

		if ($db->nf()) {
			$i = 0;
			$n = 0;
			$tpl->newBlock("block_documents");
			while($db->next_record()) {
				$v = $db->Record;
				$vtmp = new stdClass();
				foreach($v as $key => $val)
				{
					$vtmp->$key = $val;
				}
				$v = $vtmp;
				$i++;
				$n++;
				$id = $v->id;
				$tpl->newBlock("block_documents_row");
				$_f = realpath(RP . $CONFIG["documents_file_path"] . $v->file_path);

				$cat_link = ($CONFIG['rewrite_mod']) ? $this->cats_link('showproduct', $category_id, $id, $transurl)
				                                     : $transurl."&action=showproduct&id=$id&parent=$category_id&start=$start";
				$file_link = ($CONFIG['rewrite_mod']) ? $this->cats_link('download', $category_id, $id, $transurl)
				                                      : "$transurl&action=download&id=$id";
				$tpl->assign(array(
					'id'							=>	$v->id,
					'document_id'					=>	$v->id,
					'document_name'					=>	$v->name,
					'document_code'					=>	$v->code,
					'added'							=>	$v->added,
					'document_short_description'	=>	$v->short_description,
					'document_full_description'		=>	$v->full_description,
					'document_link'					=>	$cat_link,
					'category_id'					=>	$v->category_id,
					'rank'							=>	$v->rank,
					'count_downloads'				=>	$v->downloads,
					'file_size'						=>	($_f) ? round(filesize($_f) / 1024, 1) : NULL,
					'file_link'						=>	$file_link,
					'n'								=>	$n,
				));
				if ($v->code) {
				    $tpl->newBlock("block_code");
					$tpl->assign(array(
					    "code" => $v->code
					));
				}
				if($v->file_path && $_f) {
					$tpl->newBlock("block_download");
					$tpl->assign(array(
					    "file_link" => $file_link,
					    "document_link" => "$transurl&action=showproduct&id=$id&parent=$category_id&start=$start"
					));
					$ext = $this->getIcoByExt($this->getFileExt($v->file_name));
					if ($ext && $ext['path']) {
					    $tpl->newBlock('block_documents_ico');
					    $tpl->assign('path', $ext['path']);
					} else {
					    $tpl->newBlock('block_documents_no_ico');
					}
				}
				$this->show_document_files($this->product_files, $CONFIG["documents_file_path"], "block_documents_row", $v);
			}
			return $ret;
		}
		return 0;
	}

	function show_prod($id, $start, $transurl) {
		global $server, $lang, $CONFIG, $main, $tpl, $baseurl, $core, $db;
		$admin = Module::is_admin();
		$id = (int) $id;
		$prod = $this->get_prod($id);
		
		if (!$prod || (!$admin && 0 == $prod['active'])) {
		    return false;
		}
		$this->addition_to_path[$name] = "";
		$this->main_title	= $prod['name'];
		$tpl->newBlock("block_product");
		$_f = realpath(RP . $CONFIG["documents_file_path"] . $prod['file_path']);
		$tpl->assign(array(
			'product_id'					=>	$id,
			'product_name'				=>	$prod['name'],
			'product_code'				=>	$prod['code'],
			'added'						=>	$prod['added'],
			'product_short_description'	=>	nl2br($prod['short_description']),
			'product_full_description'	=>	$prod['full_description'],
			'rank'						=>	$prod['rank'],
			'count_downloads'			=>	$prod['downloads'],
			'start'						=>	$start,
			'file_size'					=>	($_f) ? round(filesize($_f) / 1024, 1) : NULL,
			'product_link'				=>	"$transurl&action=count_file&id=$id",
		));
		if ($prod['code']) {
		    $tpl->newBlock("block_code");
			$tpl->assign(array(
			    "code" => $prod['code']
			));
		}
		$file_link = ($CONFIG['rewrite_mod']) ? $this->cats_link('download', 1, $id)
			: "$transurl&action=download&id=$id";
		if($prod['file_path'] && $_f) {
			$tpl->newBlock("block_download");
			$tpl->assign("product_link", $file_link);
			$ext = $this->getIcoByExt($this->getFileExt($prod['file_path']));
			if ($ext && $ext['path']) {
				$tpl->newBlock('block_documents_ico');
				$tpl->assign('path', $ext['path']);
			} else {
				$tpl->newBlock('block_documents_no_ico');
			}
		}
		$this->show_document_files($this->product_files, $CONFIG["documents_file_path"], "block_product_file", $db->Record);
		return array(1, $prod['category_id']);
	}


	// функция для вывода таблицы категорий/разделов
	function show_categories($parent = 0, $transurl = null, $selected_category = null, $ctg_owners = 0) {
		global $main, $CONFIG, $tpl, $baseurl, $db;
		if (!isset($transurl)) $transurl = $baseurl;
		$admin = Module::is_admin();
		if (!isset($admin)) $active_str = "AND active = 1";
		$parent = intval($parent);
		$this->get_list_with_rights(
						"c.*", $this->table_prefix."_documents_categories c", "c",
						"parent_id = ".$parent." ".$active_str, "", $CONFIG['documents_dll_order_by'],
						1, 0, false, $ctg_owners, true);
		$cnt = $db->nf();
		if ($cnt) {
			$tpl->newBlock("block_categories");
			$tpl->assign(Array(
				"MSG_Activ" => $this->_msg["Activ"],
				"MSG_Ed" => $this->_msg["Ed"],
				"MSG_Rights" => $main->_msg["Rights"],
				"MSG_Section" => $this->_msg["Section"],
				"MSG_Add" => $this->_msg["Add"],
				"MSG_Del" => $this->_msg["Del"],
				"MSG_Choose_action" => $this->_msg["Choose_action"],
				"MSG_Activate" => $this->_msg["Activate"],
				"MSG_Suspend" => $this->_msg["Suspend"],
				"MSG_Delete" => $this->_msg["Delete"],
				"MSG_Execute" => $this->_msg["Execute"],
			));
			$i = 1;
			$h = ceil($cnt/2);
			$ctg_actions = array(   "addctg"	=> "adddll",
                                	"ctg_max_lvl"	=> $CONFIG["documents_max_level"],
                                	"addprd"	=> "addproduct",
									"addprdmsg"	=> $this->_msg["Add_document"],
							);
			$actions = array(   "edit"		=> "editdll",
								"editrights"=> "editctgrights",
								"activate"	=>	array("activate","suspend"),
								"delete"	=> "deldll",
								"confirm_delete"	=> $this->_msg["Confirm_delete_record"]
							);
			while($db->next_record()) {
				$id					= $db->f("id");
				if ('' != $db->f('image')) {
			    	$category_image = '<img align="center" src="'.$CONFIG['documents_dll_img_path'].$db->f('image').'">';
				} else {
					$category_image = '&nbsp;';
				}

				$actions["ctg_cur_lvl"]	= $db->f("level");
				$adm_actions = $this->get_actions_by_rights($transurl."&id=".$id."&parent=".$parent, $db->f("active"), $db->f("is_owner"), $db->f("user_rights"), $actions);
				$adm_ctg_actions = $this->get_actions_by_rights($transurl."&parent=".$id, $db->f("active"), $db->f("is_owner"), $db->f("user_rights"), $ctg_actions);
				$dll_link			= $transurl.'&action=assortment&parent='.$id;
				// вывод на экран списка
				$is_first = 0;
				$is_last = 0;
				if ($i == 1) {$img_up = "ico_ligrup.gif"; $is_first = "1";}
				else {$img_up = "ico_listup.gif";}
				if ($i == count($DC)) {$img_down = "ico_ligrdw.gif"; $is_last = "1";}
				else {$img_down = "ico_listdw.gif";}
				$selected = ($db->f("id") == $selected_category) ? " selected" : "";
				$tpl->newBlock("block_category");
				$tpl->assign(Array(
					"MSG_Edit" => $this->_msg["Edit"],
					"MSG_Add_document" => $this->_msg["Add_document"],
					"MSG_Confirm_delete_record" => $this->_msg["Confirm_delete_record"],
					"MSG_Delete" => $this->_msg["Delete"],
				));
				if (!isset($admin)) {
					$td = ($i == $h) ? "</ul></td><td width=\"5%\"><br></td><td width=\"55%\"><ul class=\"document\">" : "";
				}
				$tpl->assign(array(
					id						=>	$id,
					category_id				=>	$id,
					category_image			=>	$category_image,
					category_name			=>	$db->f("name"),
					url						=>	$db->f("url"),
					category_description	=>	nl2br($db->f("description")),
					dll_link				=>	$dll_link,
					dll_edit_action			=>	$adm_actions["edit_action"],
					dll_edit_rights_action	=>	$adm_actions["edit_rights_action"],
					dll_del_action			=>	$adm_actions["delete_action"],
					dll_add_action			=>	$adm_ctg_actions["addctg_action"],
					product_add_action		=>	$adm_ctg_actions["addprd_action"],
					change_status_action	=>	$adm_actions["change_status_action"],
					dll_up_link				=>	"$transurl&action=updll&parent=$parent&id=$id&rank=".$db->f("rank"),
					dll_down_link			=>	"$transurl&action=downdll&parent=$parent&id=$id&rank=".$db->f("rank"),
					img_down				=>	$img_down,
					img_up					=>	$img_up,
					is_first				=>	$is_first,
					is_last					=>	$is_last,
					selected				=>	$selected,
					td	=>	$td
				));
				if ($adm_actions["rights"]["d"] || $adm_actions["rights"]["p"]) {
					$tpl->newBlock('block_ctg_check');
					$tpl->assign("category_id", $id);
				}
				$i++;
				$this->show_document_images($this->category_images, $CONFIG["documents_dll_img_path"], "block_dll_image", $v);
			}
			return 1;
		}
		return 0;
	}

	// функция для вывода информации о категории по id
	function show_category($id, $transurl, $blockname = "") {
		global $server, $lang, $CONFIG, $main, $tpl, $baseurl;
		$admin = Module::is_admin();
		$id = intval($id);
		if (!$id) return 0;
		$DC = new CDocumentsCategories_DB($this->table_prefix."_documents_categories", "id");
		$DC->show_cat($id);
		if (count($DC) > 0) {
			if ($admin) {
				$cname					= htmlspecialchars($DC->name);
				$url					= htmlspecialchars($DC->url);
				$description			= htmlspecialchars($DC->description);
			} else {
				$cname					= $DC->name;
				$url						= $DC->url;
				$description			= $DC->description;
				$this->main_title	= $cname;
			}
			if ($blockname) $tpl->newBlock($blockname);
			$tpl->assign(array(
			    'active_checked' => $DC->active ? 'checked' : '',
				'category' =>	$DC->id,
				'cname' =>	$cname,
				'url' =>	$url,
				'category_description' =>	$description,
				'category_link' =>	"$transurl&action=assortment&parent=".$DC->id,
				'rank' =>	$DC->rank,
			));
			$this->show_document_images($this->category_images, $CONFIG["documents_dll_img_path"], "block_dll_image", $DC);
			$this->main_title = $cname;
			return $cname;
		}
		return 0;
	}


	// функция для получения информации о владельцах категории по id
	function get_category_owners($id) {
		global $db;
		if ($id == 0) return 0;
		$ret = 0;
		$db->query("SELECT id, parent_id, owner_id FROM ".$this->table_prefix."_documents_categories");
		if ($db->nf()) {
			while ($db->next_record()) {
				$parents[$db->f("id")] = array("parent_id" => $db->f("parent_id"), "owner_id" => $db->f("owner_id"));
			}
			$ret = array();
			while ($id) {
				if (!in_array($parents[$id]["owner_id"], $ret)) $ret[] = $parents[$id]["owner_id"];
				$id = $parents[$id]["parent_id"];
			}
		}
		return $ret;
	}


	// функция для вывода списка документов для данной категории
	function show_products( $type, $transurl, $category_id = null, $start = null, $rows = null, $ctg_owners = 0, $filter = false) {
		global $CONFIG, $main, $tpl, $request_total, $db, $lang;
		$admin = Module::is_admin();
		$order_by = $CONFIG["documents_prod_order_by"];
		if (!$rows) $rows = $CONFIG["documents_max_rows"];
		$DD2 = new CDocumentsData_DB($this->table_prefix."_documents_products", "id");
		$pages_cnt = 1;
		$link = '';
		if ($type == "pages") {
			$category_id = intval($category_id);
			if (!$category_id && !$filter['c']) return 0;
			if ($category_id) $category_str = " AND category_id = $category_id";
			$start = (intval($start)) ? $start : 1;
			if ($filter['c']) {
			    $c = My_Sql::escape(str_replace(
			        array('%', '_'),
			        array('\%', '\_'),
			        $filter['c']
			    ));
			    $category_str .= " AND (name LIKE '%{$c}%' OR code LIKE '%{$c}%')";
			    $link .= '&c='.htmlspecialchars($filter['c']);
			}
			if ($filter['d']) {
			    $category_str .= " AND added='".Main::transform_date($filter['d'])."'";
			    $link .= '&d='.htmlspecialchars($filter['d']);
			}
			$total = $this->get_list_with_rights(
									"d.*, DATE_FORMAT(d.added,'".$CONFIG["documents_date_format"]."') as added",
									$this->table_prefix."_documents_products d", "d",
									"!ISNULL(category_id) ".$category_str, "", $order_by,
									$start, $rows,
									$admin ? true : false, $ctg_owners);
			$pages_cnt = ceil($total/$rows);
		// ---------------------------------------------------------------------------------------------------
		} else if ($type == "leaders") {
			$this->get_list_with_rights(
							"d.*, DATE_FORMAT(d.added,'".$CONFIG["documents_date_format"]."') as added",
							$this->table_prefix."_documents_products d", "d",
							"is_leader = 1", "", "RAND()",
							0, $rows, false, $ctg_owners);
		// ---------------------------------------------------------------------------------------------------
		} else if ($type == "stats_last") {
			$this->get_list_with_rights(
							"d.*, d.added AS _added, DATE_FORMAT(d.added,'".$CONFIG["documents_date_format"]."') as added",
							$this->table_prefix."_documents_products d", "d",
							"", "", "_added DESC",
							0, $rows, false, $ctg_owners);
		// ---------------------------------------------------------------------------------------------------
		} else if ($type == "stats_documents") {
			$this->get_list_with_rights(
							"d.*, DATE_FORMAT(d.added,'".$CONFIG["documents_date_format"]."') as added",
							$this->table_prefix."_documents_products d", "d",
							"", "", "downloads DESC",
							0, $rows, false, $ctg_owners);
		// ---------------------------------------------------------------------------------------------------
		} else {
			return 0;
		}
		if ($db->nf() || $filter['d'] || $filter['c']) {
			$i = 0;
			$n = 0;
			$tpl->newBlock("block_product_table");
			$tpl->assign(Array(
				"MSG_Documents_list" => $this->_msg["Documents_list"],
				"MSG_Activ" => $this->_msg["Activ"],
				"MSG_Ed" => $this->_msg["Ed"],
				"MSG_Rights" => $main->_msg["Rights"],
				"MSG_Downloads" => $this->_msg["Downloads"],
				"MSG_Null" => $this->_msg["Null"],
				"MSG_Name" => $this->_msg["Name"],
				"MSG_Del" => $this->_msg["Del"],
				"MSG_Choose_action" => $this->_msg["Choose_action"],
				"MSG_Activate" => $this->_msg["Activate"],
				"MSG_Suspend" => $this->_msg["Suspend"],
				"MSG_Delete" => $this->_msg["Delete"],
				"MSG_Execute" => $this->_msg["Execute"],
				"MSG_Date_short" => $this->_msg["Date_short"],
				"MSG_Code_short" => $this->_msg["Code_short"],
				"baseurl" => $transurl,
				"lang" => $lang,
				"parent" => $category_id,
				"c" => $filter['c'] ? htmlspecialchars($filter['c']) : '',
				"d" => $filter['d'] ? htmlspecialchars($filter['d']) : '',
			));
			$tpl->assign(array(
				'cnt'	=> $db->nf()
			));
			$actions = array(	"edit"		=> "editproduct",
								"editrights"=> "editrights",
								"activate"	=>	array("activateproduct","suspendproduct"),
								"delete"	=> "delproduct",
								"confirm_delete"	=> $this->_msg["Confirm_delete_record"]
							);
			while($db->next_record()) {
				$i++;
				$n++;
				$id = $db->f("id");
				$category_id = $db->f("category_id");
				if ($admin == 1 && $type == "pages") {
					$is_first = 0;
					$is_last = 0;
					if ($start == 1 && $i == 1) {
						$img_up = "ico_ligrup.gif"; $is_first = "1";
						$img_down = "ico_listdw.gif";
					} else if ($start == ceil($total/$rows) && $i == count($temp)) {
						$img_up = "ico_listup.gif";
						$img_down = "ico_ligrdw.gif"; $is_last = "1";
					} else {
						$img_up = "ico_listup.gif";
						$img_down = "ico_listdw.gif";
					}
				}
				if ($type == "leaders") {
					if ($n == 1) {
						$tr_begin = "<tr>";
						$tr_end = "";
					} else if ($n == 2) {
						$tr_begin = "";
						$tr_end = "</tr>";
						$n = 0;
					} else {
						$tr_begin = "";
						$tr_end = "";
					}
				}
				// вывод на экран списка
				$img_null	=	$db->f("downloads") ? "b_select.gif" : "b_select_off.gif";
				$link_null = $db->f("downloads") ? $transurl . '&action=tonull&id='.$id : '#';
				$adm_actions	= $this->get_actions_by_rights($transurl."&id=".$id."&parent=".$category_id."&start=".$start, $db->f("active"), $db->f("is_owner"), $db->f("user_rights"), $actions);
				$prod_link = ($CONFIG['rewrite_mod'] && !$admin) ? $this->cats_link('showproduct', $category_id, $id, $transurl)
				                                     : $transurl."&action=showproduct&id=$id&parent=$category_id&start=$start";
				$tpl->newBlock("block_product_row");
				$tpl->assign(array(
					id								=>	$id,
					product_id						=>	$id,
					product_name					=>	$db->f("name"),
					product_downloads					=>	$db->f("downloads"),
					img_null					=>	$img_null,
					link_null					=>	$link_null,
					product_full_description		=>	$db->f("full_description"),
					dated							=>	$db->f("date"),
					bg_color						=>	"#F6F6F6",
					product_short_description		=>	nl2br($db->f("short_description")),
					product_link					=>	$prod_link,
					product_edit_action				=>	$adm_actions["edit_action"],
					product_edit_rights_action		=>	$adm_actions["edit_rights_action"],
					product_del_action				=>	$adm_actions["delete_action"],
					change_status_action			=>	$adm_actions["change_status_action"],
					img_down						=>	$img_down,
					img_up							=>	$img_up,
					is_first						=>	$is_first,
					is_last							=>	$is_last,
					category_id						=>	$db->f("category_id"),
					rank							=>	$db->f("rank"),
					tr_begin						=>	$tr_begin,
					tr_end							=>	$tr_end,
					n								=>	$n,
					counter_dlls					=>	$db->f("downloads"),
					product_code					=>	$db->f("code"),
					product_date					=>	$db->f("added"),
					prod_up_link				=>	"$transurl&action=upproduct&parent=$category_id&id=$id&rank=".$db->f("rank"),
					prod_down_link			=>	"$transurl&action=downproduct&parent=$category_id&id=$id&rank=".$db->f("rank"),
				));
				if ($adm_actions["rights"]["d"] || $adm_actions["rights"]["p"]) {
					$tpl->newBlock('block_check');
					$tpl->assign("product_id", $id);
				}
				$ext = $this->getIcoByExt($this->getFileExt($db->f('file_name')));
				if ($ext && $ext['path']) {
					$tpl->newBlock('block_documents_ico');
					$tpl->assign('path', $ext['path']);
				} else {
					$tpl->newBlock('block_documents_no_ico');
				}

				$DD2->load($id);
				$this->show_document_images($this->product_images, $CONFIG["documents_img_path"], "block_dll_image", $DD2);
			}
			return $pages_cnt;
		}
		return 0;
	}

	// увеличивание счётчика скачиваний файла
	function count_file($id) {
		global $request_id, $server, $lang, $CONFIG, $main, $tpl, $baseurl, $transurl, $core;
		if (!isset($id)) return 0;
		$id = intval($id);
		$admin = Module::is_admin();
		$DD = new CDocumentsData_DB($this->table_prefix."_documents_products", "id");
		$DD->show_product($id);
		$DD->countup_document($id);
		if ($DD > 0) {
			$this->show_document_files($this->product_files, $CONFIG["documents_file_path"], "block_product_file", $DD);
		}
	}

	// вывести информацию о документе по его id
	function show_product($id, $start) {
		global $server, $lang, $CONFIG, $main, $tpl, $baseurl, $transurl, $core;
		$admin = Module::is_admin();
		$id = intval($id); if (!$id) return 0;
		$DD = new CDocumentsData_DB($this->table_prefix."_documents_products", "id");
		$DD->show_product($id);
		if ($DD > 0) {
			if ($admin) {
				$name				=	htmlspecialchars($DD->name);
				$short_description	=	htmlspecialchars($DD->short_description);
				$full_description	=	htmlspecialchars($DD->full_description);
				$code				=	htmlspecialchars($DD->code);
			} else {
				$name				=	$DD->name;
				$short_description	=	nl2br($DD->short_description);
				$full_description	=	nl2br($DD->full_description);
				$code				=	$DD->code;
				// добавить в хлебные крошки
				$this->addition_to_path[$DD->name] = "";
			}
			// наличие
			if ($DD->availability) {
				$av_checked		= "checked";
				$availability	= $this->_msg["Presence"];
			} else {
				$av_checked		= "";
				$availability	= $this->_msg["Only_order"];
			}
			if (!$admin) {
				$this->main_title	= $name;
				$tpl->newBlock("block_product");
			}
			//вывод на экран
			$tpl->assign(array(
			    'active_checked' => $DD->active ? 'checked' : '',
				product_id					=>	$DD->id,
				product_name				=>	$name,
				product_short_description	=>	$short_description,
				product_full_description	=>	$full_description,
				text						=>	$full_description,
				product_code				=>	$code,
				product_availability		=>	$availability,
				av_checked 					=>	$av_checked,
				rank						=>	$DD->rank,
				start						=>	$start,
				downloads					=>	$DD->downloads,
				counter_dlls				=>	$DD->downloads,
				date        				=>	$DD->added,
				product_link				=>	"$transurl&action=count_file&id=$id",
			));
			$this->show_document_images($this->product_images, $CONFIG["documents_img_path"], "block_product_image", $DD);
			$this->show_document_files($this->product_files, $CONFIG["documents_file_path"], "block_product_file", $DD);
			$category_id = $DD->category_id;
			return array(1, $category_id);
		}
		return array();
	}


	// функция для вывода картинок каталога
	// -------------------------------------
	function show_document_files($files_array, $path, $blockname, $temp = null) {
		global $lang, $CONFIG, $tpl, $baseurl;
		$admin = Module::is_admin();
		foreach ($files_array as $arr) {
			$field_name = $arr["field_name"];
			$field_path = $arr["field_path"];
			$file_name = "";
			$file_path = "";
			$file_exists = "";
			$file = "";
			if ($temp) {
				if ($temp->$field_path) {
					$file_exists = "&nbsp;<a href=\"".$path.$temp->$field_path."\" target=_blank>" . $temp->$field_name . "</a>";
				}
				$file = $this->get_file($temp->$field_path, $path);
				$file_name = $temp->$field_name;
				$file_path = $temp->$field_path;
				$file_id = $temp->id;
			}
			if (!file_exists($path.$file_path)) {
			    $file_size = "<span style=\"font-size: 8pt; font-weight: bold; color: red\">&mdash;&mdash;</span>";
			} else {
			    $file_size = @sprintf("%0.2f", filesize($path.$file_path)/1000000);
			}
			if ($admin) $tpl->newBlock($blockname);
			$tpl->assign(Array(
				"MSG_Allowed_extensions" => $this->_msg["Allowed_extensions"],
				"MSG_Delete" => $this->_msg["Delete"],
			));
			$crypted_file_name = ($CONFIG['rewrite_mod']) ? $this->cats_link('download', 1, $file_id)
				                                      : $baseurl."&action=download&id=".$file_id;
			$tpl->assign(array(
				field_name			=>	$arr["field_name"],
				field_path			=>	$arr["field_path"],
				file_title			=>	$arr["title"],
				file_name			=>	$file_name,
				file_path			=>	$file_path,
				crypted_file_name	=>	$crypted_file_name,
				#crypted_file_name	=>	"/mod/documents/lib/download.php?path=".$path.$file_name,
				file_exists			=>	$file_exists,
				file_size			=>	$file_size,
				$arr["field_name"]	=>	$file,
			));
			asort($CONFIG["document_file_formats"]);
			$tpl->assign("file_types", implode(", ", array_unique($CONFIG["document_file_formats"])));
		}
		return;
	}


	// -------------------------------------
	function get_file($file = null, $path = null, $no_file = null) {
		if ($file && file_exists($path . $file)) {
			$file = $path . $file;
		} else if ($no_file && file_exists($no_file)) {
			$file = $no_file;
		} else {
			$file = "";
		}
		return $file;
	}


	// -------------------------------------
	function get_image($image = null, $alt = null, $path = null, $no_image = null) {
		if ($image && file_exists($path . $image)) {
			$img_path = $path . $image;
			$image = "<img src=\"/" . $img_path . "\" alt=\"" . $alt . "\">";
		} else if ($no_image && file_exists($no_image)) {
			$img_path = $no_image;
			$image = "<img src=\"/" . $img_path . "\" alt=\"" . $alt . "\">";
		} else {
			$image = "";
		}
		return $image;
	}


	// функция для вывода картинок каталога
	function show_document_images($images_array, $path, $blockname, $arry = null) {
		global $tpl;
		$admin = Module::is_admin();
		$field_name = $images_array["0"]["field_name"];
		$title = $images_array["0"]["title"];
		if (isset($arry)) {
			if (isset($arry->$field_name)) {
				$image_exists = "&nbsp;<a href=\"".$path.$arry->$field_name."\" target=_blank>" . $this->_msg["already_uploaded"] . "</a>";
			}
			$image			= $this->get_image($arry->$field_name, $arry->name, $path);
			$image_name 	= $arry->$field_name;
		}
		if ($admin) $tpl->newBlock($blockname);
		$tpl->assign(array(
			field_name			=>	$field_name,
			image_title			=>	$title,
			image_name			=>	$image_name,
			image_exists		=>	$image_exists,
			$field_name			=>	$image,
		));
		return;
	}

	// функция для вывода дерева каталога
	// или его отдельных ветвей
	function create_tree($parent = 0, $type = "tree", $blockname = "", $transurl = "?") {
		global $lang, $CONFIG, $tpl;
		$html_output = $this->get_tree($type, $parent, $transurl);
		if ($blockname) {
			$tpl->newBlock($blockname);
		}
		$tpl->assign(array(
			"documents"		=>	$html_output,
			"documents_url"		=>	"$transurl&parent=",
		));
		return 1;
	}


	// функция для получения дерева каталога
	// или его отдельных ветвей, $parent - родительская для данной ветки категория
	// ------------------------------------------------
	function get_tree($type, $parent, $transurl = "?") {
		global $server, $lang, $CONFIG, $tpl, $baseurl;
		$admin = Module::is_admin();
		$DD = new CDocumentsData_DB($this->table_prefix."_documents_products", "id");
		$DC = new CDocumentsCategories_DB($this->table_prefix."_documents_categories", "id");
		$tempc = $DC->get_tree($CONFIG["documents_dll_order_by"]);
		if (count($tempc) > 0) {
			require_once($CONFIG["inc_path"] . "class.TreeMenu.php");
			$icon = 'folder.gif';
			$open_icon = 'folderopen.gif';
	    	$menu  = new TreeMenu();
			$first = 1; // указатель на первой позиции в выборке из БД
			foreach ($tempc as $vc) {
				$id	= $vc["id"];
				$pid	= $vc["parent_id"];
				$cname	= addslashes($vc["name"]);
				$level	= $vc["level"];
				if ($type != 'tree') {
					$text = $cname;
					$link = $id;
				} else {
					$a 		= "assortment";
					$dll_link 	= "$transurl&action=$a&parent=$id";
					$temp 		= $DD->count_by_cat($id);
					if ($temp > 0) $count_dlls = "[".$temp."]";
					else $count_dlls = "";
					if (!$admin && $pid == 0) {
						$text = "<a href=\"$dll_link\">$cname $count_dlls</a>";
					} else if ($id == $parent) {
						$text = "<a href=\"$dll_link\"><b>$cname $count_dlls</b></a>";
					} else {
						$text = "<a href=\"$dll_link\">$cname $count_dlls</a>";
					}
					$link = "";
				}
				$array = array('text' => $text, 'link' => $link, 'icon' => $icon, 'expandedIcon' => $open_icon);
				if ($pid == 1 && $parent == $CONFIG["documents_default_category"]) $array['ensureVisible'] = true;
				if ($pid == 0) {
				    $node[$id] = new TreeNode($array);
					$menu->addItem($node[$id]);
				} else  if (is_object($node[$pid])) {
				    $node[$id] = &$node[$pid]->addItem(new TreeNode($array));
				}
				$first = 0;
			}
			$treeMenu = new TreeMenu_DHTML($menu);
			return $treeMenu->toHTML();
		}
		return;
	}


	// вывести навигационную строчку, отображающую путь к текущей категории
	function show_nav_path($id, $transurl = "?", $product_id = 0, $wh=null) {
		global $tpl;
		list($level, $path) = $this->get_nav_path($id, $transurl, $product_id, $wh);
		$tpl->assign(array(
			'_ROOT.path'	=>	$path,
		));
		return $level;
	}


	// получить навигационную строчку, отображающую путь к текущей категории
	// строчка вида Каталог >> Бытовая техника >> Пылесосы... и т.д.
	// функция также возвращает уровень вложенности $level для данного элемента
	function get_nav_path($id, $transurl = "?", $product_id = 0, $wh = "") {
		global $server, $lang, $CONFIG;
		$id				= intval($id);
		$product_id	= intval($product_id);
		$arr				= array();
		$separator		= $CONFIG["nav_separator"];
		$path			= "";
		$level			= 0;
		$i					= 0;
		$root				= ($id) ? "$separator<a href=\"$transurl&action=assortment&parent=0\" class=\"header1\">" . $this->_msg["documents"] . "</a>" : "$separator<span class=\"modul\">" . $this->_msg["documents"] . "</span>";
		$DD = new CDocumentsData_DB($this->table_prefix."_documents_products", "id");
		$DC = new CDocumentsCategories_DB($this->table_prefix."_documents_categories", "id");
		if ($product_id) {
			$DD->load($product_id);
			$path = "$separator<span class=\"modul\">$DD->name</span>";
		}
		while ($id) {
			$level++;
			$DC->load($id);
			if (count($DC) > 0) {
				$name = $DC->name;
				$this->addition_to_path[$name] = ($CONFIG['rewrite_mod'])
				    ? $this->cats_link('assortment', $DC->id)
				    : $transurl.'&action=assortment&parent='.$DC->id;
				if ($i == 0 && !$product_id) {
					$h = "$separator<span class=\"modul\">".$name."</span>";
				} else {
					$h = "$separator<a href=\"$transurl&action=assortment&parent=$id\">".$name."</a>";
				}
				$path = $h.$path;
				$id = $DC->parent_id;
				$i++;
			}
		}
		$path = $root.$path;
		$this->addition_to_path = array_reverse($this->addition_to_path);
		return array($level, $path);
	}

	function getPropertyFields() {
		GLOBAL $request_sub_action;

		if ('' != $request_sub_action) {

			$tpl = $this->getTmpProperties();
			switch ($request_sub_action) {
				case 'stats_last':
				case 'stats_documents':
				case 'assortment':
					$tpl->newBlock('block_properties');
					$tpl->newBlock('block_properties_per_page');
                    $tpl->assign(array(
                        'MSG_Documents_per_page' => $this->_msg['Documents_per_page']
                    ));
                    $tpl->newBlock('block_properties_ctg_list');
					$tpl->assign(Array(
						"MSG_Show_category" => $this->_msg["Show_category"],
						"MSG_All_categories" => $this->_msg["All_categories"],
					));
					$list = $this->getAllRootCategs();
					abo_str_array_crop($list);
					$tpl->assign_array('block_properties_ctg', $list);
					break;
				case 'tree':
					$tpl->newBlock('block_properties');
                    $tpl->newBlock('block_properties_ctg_list');
					$tpl->assign(Array(
						"MSG_Show_category" => $this->_msg["Show_category"],
						"MSG_All_categories" => $this->_msg["All_categories"],
					));
					$list = $this->getAllRootCategs();
					abo_str_array_crop($list);
					$tpl->assign_array('block_properties_ctg', $list);
					break;

				case 'showatree':
					$tpl->newBlock('block_properties_none');
                    $tpl->assign(array(
                      'MSG_Documents_per_page' => $this->_msg['Documents_per_page']
                    ));
					break;
			}
			return $this->getOutputContent($tpl->getOutputContent());
		}
		return FALSE;
	}

	function getEditLink($sub_action = NULL, $block_id = NULL) {
		GLOBAL $request_name, $db, $lang, $server;
		$block_id	= (int)$block_id;
		if ($sub_action && $block_id) {
			$db->query('SELECT	property1,
								property2,
								property3,
								property4,
								property5
							FROM '.$this->table_prefix.'_pages_blocks
							WHERE id = '.$block_id);
			if ($db->nf() > 0) {
				$db->next_record();
				$arr[]	= $db->f('property1');
				$arr[]	= $db->f('property2');
				$arr[]	= $db->f('property3');
				$arr[]	= $db->f('property4');
				$arr[]	= $db->f('property5');

				switch ($sub_action) {
					default:
						$link['material_url']	= '';
						$link['material_id']	= '';
						break;
				}
				return $link;
			}

			switch ($sub_action) {
				default:
					$link['material_url']	= '';
					$link['material_id']	= '';
					break;
			}
			return $link;
		}
		return FALSE;
	}

	function add_category($active, $name, $parent_id, $url = "", $description = "", $item_rights, $block_id = 0) {
		global $server, $lang, $CONFIG, $main, $db;
		if (!$name) return FALSE;

		$owner_id = $_SESSION["siteuser"]["id"];
		if ($parent_id) {
			$db->query("SELECT usr_group_id FROM ".$this->table_prefix."_documents_categories WHERE id=".$parent_id);
			if (!$db->next_record()) return false;
			list($group_id, $rights) = $this->get_group_and_rights('documents_default_rights', $block_id, $db->f("usr_group_id"));
			$rights = $item_rights ? $item_rights : $rights;
		} else {
			list($group_id, $rights) = $this->get_group_and_rights('documents_default_rights', $block_id);
		}

		// Получить значение rank (порядок следования в каталоге)
		list($max_rank, $min_rank)	= $main->get_max_min_rank($this->table_prefix.'_documents_categories');
		list($level, $path)			= $this->get_nav_path($parent_id);
		if ($level > $CONFIG["documents_max_level"]) return 0;
		$DC					= new CDocumentsCategories_DB($this->table_prefix.'_documents_categories', 'id');
		$DC->id				= 0;
		$DC->active = $active ? 1 : 0; 
		$DC->parent_id		= (int)$parent_id;
		$DC->name			= $db->escape(trim($name));
		$DC->description	= $db->escape(trim($description));
		$DC->rank			= $max_rank + 1;
		$DC->level			= $level;
    	$DC->owner_id		= $owner_id;
    	$DC->usr_group_id	= $group_id;
    	$DC->rights			= $rights;
    	
		if (!$DC->store()) {
			return 0;
		} else {
			$lid = db_insert_id();
			// закачаем картинки
			$update_img_str = $this->upload_document_images($this->category_images, $CONFIG["documents_dll_img_path"], $lid);
			$query = "UPDATE ".$DC->_tbl." SET name = '$name' $update_img_str WHERE id = $lid";
			db_exec($query);
			return $lid;
		}
	}


	// функция для обновления категории по id
	function update_category($id, $active, $name, $url = "", $description = "") {
		global $server, $lang, $CONFIG, $db;
		$name			= $db->escape(trim($name));
		if (!$name) return FALSE;
		$description	= $db->escape(trim($description));
		$url			= $db->escape(trim($url));
		$id				= (int)$id;
		$update_img_str = $this->upload_document_images($this->category_images, $CONFIG["documents_dll_img_path"], $id);
		$query = "UPDATE ".$this->table_prefix."_documents_categories SET active=".($active ? 1 : 0)
		    .", name = '$name', description = '$description' $update_img_str WHERE id = $id";
		if (db_exec($query)) {
			return TRUE;
		} else {
			return FALSE;
		}
	}


	// функция для удаления категории по id
	function delete_category($id = null) {
		$id = intval($id);
		if (!$id) return 0;
		global $lang, $CONFIG, $tpl, $name;
		$arr = array($id);

		return $this->delete_elements($arr);
	}


	// функция для удаления
	// из каталога категории и всех её подкатегорий
	function delete_elements($arr) {
		global $CONFIG, $db;
		
		$ctgr_ids = $db->fetchColumn($this->table_prefix."_documents_categories", 'id', array('clause' => array(
		    new DbExp('id IN ('.implode(',', $arr).')')
		)));
		$ret = false;
		if (! empty($ctgr_ids)) {
		    $ids = $ctgr_ids;
		    while ( $ids = $db->fetchColumn($this->table_prefix."_documents_categories", 'id', array('clause' => array(
    		    new DbExp('parent_id IN ('.implode(',', $ids).')')
    		))) ) {
    			$ctgr_ids = array_merge($ctgr_ids, $ids);
    		}
    		$ctgr_ids = implode(',', $ctgr_ids);
    		$db->del($this->table_prefix."_documents_categories",  array(new DbExp("id IN ({$ctgr_ids})")));
    		$a = $db->fetchColumn($this->table_prefix."_documents_products", 'file_path', array('clause' => array(
		        new DbExp("id IN ({$ctgr_ids})"),  new DbExp("file_path<>''")
		    )));
		    if (! empty($a)) {
		        foreach ($a as $f) {
		        	if (file_exists(RP.$CONFIG['documents_file_path'].$f)) {
		        	    unlink(RP.$CONFIG['documents_file_path'].$f);
		        	}
		        }
		    }
		    $db->del($this->table_prefix."_documents_products",  array(new DbExp("category_id IN ({$ctgr_ids})")));
		    $ret = true;
		}
		
		return $ret;
	}


	// функция для показа строки с функциональностью добавления
	// документа или подкатегории в данную категорию
	function show_add_to_current($level, $parent) {
		global $lang, $CONFIG, $tpl, $name, $baseurl;
		if ($level != 0) {
			$product_add_link = "$baseurl&action=addproduct&parent=$parent";
			$product_add_img = '<img src="/' . $CONFIG["admin_img_path"] . 'ico_addprod.gif" alt="' . $this->_msg["Add_document"] . '" title="' . $this->_msg["Add_document"] . '" width=17 height=18 border=0 valign="absmiddle">&nbsp;' . $this->_msg["Add_document"];
			$product_add = "<a class=\"add_btn\" href=\"$product_add_link\"><span>$product_add_img</span></a>";
		}
		if ($level < $CONFIG["documents_max_level"]) {
			$dll_add_link = "$baseurl&action=adddll&parent=$parent";
			$dll_add_img = '<img src="/' . $CONFIG["admin_img_path"] . 'ico_addcat.gif" alt="' . $this->_msg["Add_category"] . '" title="' . $this->_msg["Add_category"] . '" width=17 height=18 border=0>&nbsp;' . $this->_msg["Add_category"];
			$dll_add = "<a class=\"add_btn\" href=\"$dll_add_link\"><span>$dll_add_img</span></a>";
		}
		$tpl->assign(array(
			add_to_current	=>	$dll_add . "" . $product_add,
		));
		return 1;
	}

	// функция для удаления документа из базы данных
	function delete_product($table = null, $id = null) {
		global $CONFIG, $main, $server, $lang;
		$id = (int)$id;
		if (!isset($id)) return FALSE;
		// получим имена всех картинок
		$DD = new CDocumentsData_DB($this->table_prefix."_documents_products", "id");
		$DD->load($id);
		if (!$DD->delete($id)) {
			$main->message_die($this->_msg["Cannot_delete_object"]);
			return FALSE;
		} else {
			if (is_array($this->product_images) && count($this->product_images) > 0) {
				foreach($this->product_images as $arr) {
					$field_name = $arr["field_name"];
					@unlink($CONFIG["documents_img_path"].$DD->$field_name);
				}
			}
			if (is_array($this->product_files) && count($this->product_files) > 0) {
				foreach($this->product_files as $arr) {
				    $field_path = $arr["field_path"];
					if ($arr["field_path"] && $DD->$arr["field_path"]) {
					    @unlink(RP.$CONFIG["documents_file_path"].$DD->$arr["field_path"]);
					}					
				}
			}
			return TRUE;
		}
		return FALSE;
	}


	// функция для удаления записи из базы данных
	function delete_entry($table = null, $id = 0) {
		global $lang, $CONFIG;
		$id = intval($id);
		if (!isset($id)) return 0;
		if (!isset($table)) return 0;
		$query = "DELETE FROM $table WHERE id = $id";
		db_exec($query);
		return (db_affected_rows() > 0) ? 1 : 0;
	}

	// Сделать лидером продаж
	function make_leader($id = "") {
		$id = intval($id); if (!$id) return 0;
		global $server, $lang, $CONFIG;
		$DD = new CDocumentsData_DB($this->table_prefix."_documents_products", "id");
		$DD->make_leader($id);
		return (db_affected_rows() > 0) ? 1 : 0;
	}


	// Удалить документ из лидеров продаж
	function no_leader($id = "") {
		$id = intval($id); if (!$id) return 0;
		global $server, $lang, $CONFIG;
		$query = "UPDATE ".$this->table_prefix."_documents_products SET is_leader = 0 WHERE id = $id";
		db_exec($query);
		return (db_affected_rows() > 0) ? 1 : 0;
	}

	// функция для загрузки картинок для документа
	function upload_document_images($images_array, $path, $id) {
		global $lang, $CONFIG, $main;
		if (!$id) return "";
		$id = str_pad($id, 5, "0", STR_PAD_LEFT);
		$imagenames_array = array();
		$update_img_str = "";
		if (is_array($images_array) && count($images_array) > 0) {
			foreach ($images_array as $arr) {
				// удалить картинку
				if ($_REQUEST["del_{$arr["field_name"]}"]) {
					$update_img_str .= ", {$arr["field_name"]} = NULL";
					if ($_REQUEST["{$arr["field_name"]}_name"]) @unlink($path . $_REQUEST["{$arr["field_name"]}_name"]);
				} else {
					// загрузить картинку
					if ($_FILES[$arr["field_name"]]['name']) {
						$type = $this->document_image_formats[$_FILES[$arr["field_name"]]['type']];
						$set_file_name = ($type) ? "{$id}_{$arr["field_name"]}.{$type}" : "";
						$imagename = $main->upload_file($arr["field_name"], $CONFIG["files_img_max_size"], $path, "", $this->document_image_formats, $set_file_name);
						if ($imagename) {
							// подогнать по ширине
							if ($arr["resize"]) $main->resize_by_width($imagename, $path, $arr["resize"], null, $CONFIG["sitename_rus"], 65);
							$imagenames_array[] = $imagename;
							$update_img_str .= ", {$arr["field_name"]} = '$imagename'";
						}
					}
				}
			}
		}
		return $update_img_str;
	}

	// функция для добавления документа в базу данных
	function add_product($active, $pname, $code, $date, $short_description, $full_description, $parent, $item_rights, $block_id = 0 ) {
		global $server, $lang, $CONFIG, $main, $db;
		if (!$pname) return FALSE;

		$owner_id = $_SESSION["siteuser"]["id"];
		$db->query("SELECT usr_group_id FROM ".$this->table_prefix."_documents_categories WHERE id=".$parent);
		if (!$db->next_record()) return false;
		list($group_id, $rights) = $this->get_group_and_rights('documents_default_rights', $block_id, $db->f("usr_group_id"));
		$rights = $item_rights ? $item_rights : $rights;

		list($max_rank, $min_rank) 	= $main->get_max_min_rank($this->table_prefix."_documents_products");
		$DD 						= new CDocumentsData_DB($this->table_prefix."_documents_products", "id");
		$DD->id						= 0;
		$DD->active = $active ? 1 : 0;
		$DD->category_id			= (int)$parent;
		$DD->name					= $db->escape(trim($pname));;
		$DD->code					= $db->escape(trim($code));;
		$DD->rank					= $max_rank + 1;
		$DD->short_description		= $db->escape($short_description);
		$DD->full_description		= $db->escape($full_description);
		$DD->added					= $date ? Main::transform_date($date) : date("Y-m-d");
    	$DD->owner_id				= $owner_id;
    	$DD->usr_group_id			= $group_id;
    	$DD->rights					= $rights;

		if ($DD->store()) {
			$lid = db_insert_id();
			// закачаем файл
			$update_file_str = $this->upload_document_files($this->product_files, $CONFIG["documents_file_path"], $lid);
			$db->query("UPDATE ".$DD->_tbl." SET name = '$pname' $update_file_str WHERE id = $lid");
			return $lid;
		} else {
			return 0;
		}
		return 0;
	}


	// функция для загрузки файлов для документа
	function upload_document_files($files_array, $path, $id) {
		global $lang, $CONFIG, $main;
		if (!$id) return "";
		$id = str_pad($id, 5, "0", STR_PAD_LEFT);
		$update_file_str = "";
		if (is_array($files_array) && count($files_array) > 0) {
			foreach ($files_array as $arr) {
				// удалить file
				if ($_REQUEST["del_{$arr["field_name"]}"]) {
					$update_file_str .= ", {$arr["field_name"]} = NULL";
					if ($_REQUEST["{$arr["field_name"]}_name"]) {
					    @unlink($path . $_REQUEST["{$arr["field_name"]}_name"]);
					}
				} else {
					// загрузить file
					if ($_FILES[$arr["field_name"]]['name'] && UPLOAD_ERR_OK == $_FILES[$arr["field_name"]]['error']) {
						$type = Main::getFileExt($_FILES[$arr["field_name"]]['name']);
						if (! $type) {
						    $main->message_die("<span class=\"title\">Недопустимый формат файла " . $_FILES[$arr["field_name"]]['type'] . "!</span>");
						}
						$set_file_name = md5($id.$_FILES[$arr["field_name"]]['tmp_name'].time()).'.'.$type;
						$filename = $main->upload_file(
							$arr["field_name"],
							$CONFIG["files_file_max_size"],
							$path,
							"",
							$CONFIG["document_file_formats"],
							$set_file_name
						);
						if ($filename) {
							$update_file_str .= ", {$arr["field_path"]} = '{$filename}'";
							$update_file_str .= ", {$arr["field_name"]} = '".My_Sql::escape($_FILES[$arr["field_name"]]['name'])."'";
						}
					}
				}
			}
		}
		return $update_file_str;
	}


	// функция для обновления документа в базе данных
	function update_product($id, $active, $pname, $code, $date, $short_description, $full_description, $parent ) {
		global $server, $lang, $CONFIG, $db;
		$id 				= ($id) ? (int)$id : 0;
		$pname 				= $db->escape(trim($pname));
		$code 				= $db->escape(trim($code));
		$date 				= Main::transform_date($date);
		if (!$pname) return FALSE;
		$short_description 	= $db->escape($short_description);
		$full_description 	= $db->escape($full_description);
		$category 			= (int)$parent;
		$updated = date("Y-m-d H:i:s");
		$update_file_str	= $this->upload_document_files($this->product_files, $CONFIG["documents_file_path"], $id);
		$query = "UPDATE ".$this->table_prefix."_documents_products SET name = '{$pname}', active= ".($active ? 1 : 0).","
		    ." code = '{$code}', added = '{$date}', short_description = '{$short_description}',"
		    ." full_description = '{$full_description}', updated = '{$updated}'"
		    ." {$update_file_str} WHERE id = {$id}";
		if (!db_exec($query)) {
			return FALSE;
		} else {
			return TRUE;
		}
	}	
	
	function addIco($ext)
	{   global $CONFIG, $db;
	
		$ret = false;
		$ext = preg_replace("/\W/", '', strtolower($ext));
		if ($ext && !$this->getIcoByExt($ext) && $_FILES['ico']['tmp_name'] 
		    && array_key_exists($_FILES['ico']['type'], $this->document_image_formats)
		) {
		    $ico_ext = $this->getFileExt($_FILES['ico']['name']);
		    if ($ico_ext && move_uploaded_file($_FILES['ico']['tmp_name'], RP.$CONFIG['documents_ico_path']."{$ext}.{$ico_ext}")) {
		        $db->query("INSERT INTO {$this->table_prefix}_documents_file_ico (ext, file) VALUES "
		            ."('{$ext}', '{$ext}.{$ico_ext}')");
		        $ret = $db->lid();
		    }
		}
		
		return $ret;
	}
	
	function getIco($id)
	{   global $CONFIG, $db;
		$ret = false;
		$db->query("SELECT * FROM {$this->table_prefix}_documents_file_ico WHERE id=".intval($id));
		if ($db->next_record()) {
		    $ret = array(
		        'id' => $db->Record['id'],
		        'file' => $db->Record['file'],
		        'ext' => $db->Record['ext'],
		        'path' => $db->Record['file'] && file_exists(RP.$CONFIG['documents_ico_path'].$db->Record['file'])
		            ? "/".$CONFIG['documents_ico_path'].$db->Record['file'] : ""
		    );
		}
		
		return $ret;
	}
	
	function getIcoByExt($ext)
	{   global $CONFIG, $db1;
		$ret = false;
		$db1->query("SELECT * FROM {$this->table_prefix}_documents_file_ico WHERE ext='".My_Sql::escape($ext)."'");
		if ($db1->next_record()) {
		    $ret = array(
		        'id' => $db1->Record['id'],
		        'file' => $db1->Record['file'],
		        'ext' => $db1->Record['ext'],
		        'path' => $db1->Record['file'] && file_exists(RP.$CONFIG['documents_ico_path'].$db1->Record['file'])
		            ? "/".$CONFIG['documents_ico_path'].$db1->Record['file'] : ""
		    );
		}
		
		return $ret;
	}
	
	function delIco($id)
	{   global $CONFIG, $db;
		$ret = false;
		$ico = $this->getIco($id);
		if ($ico) {
		    if ($ico['file'] && file_exists(RP.$CONFIG['documents_ico_path'].$ico['file'])) {
		        unlink(RP.$CONFIG['documents_ico_path'].$ico['file']);
		    }
		    $db->query("DELETE FROM {$this->table_prefix}_documents_file_ico WHERE id=".intval($id));
		    $ret = true;
		}
		return $ret;
	}
	
	function getIcoList()
	{   global $CONFIG, $db;
		$ret = false;
		$db->query("SELECT * FROM {$this->table_prefix}_documents_file_ico");
		while($db->next_record()) {
		    $ret[] = array(
		        'id' => $db->Record['id'],
		        'file' => $db->Record['file'],
		        'ext' => $db->Record['ext'],
		        'path' => $db->Record['file'] && file_exists(RP.$CONFIG['documents_ico_path'].$db->Record['file'])
		            ? "/".$CONFIG['documents_ico_path'].$db->Record['file'] : ""
		    );
		}
		
		return $ret;
	}
	
	function showIcoList()
	{   global $tpl, $baseurl;
		$list = $this->getIcoList();
		if (! empty($list)) {
		    $tpl->newBlock('block_ico_list');
		    $tpl->assign(array(
		        'MSG_Ico' => $this->_msg['Ico'],
		        'MSG_Extention' => $this->_msg['Extention'],
		        'MSG_Del' => $this->_msg['Del'],
		    ));
		    foreach ($list as $val) {
		    	$tpl->newBlock('block_ico');
		    	$val['MSG_Confirm_delete_record'] = $this->_msg['Confirm_delete_record'];
		    	$val['MSG_Delete'] = $this->_msg['Delete'];
		    	$val['baseurl'] = $baseurl;
    		    $tpl->assign($val);
		    }
		}
	}
	
	function getFileExt($file_name)
	{
		$ret = false;
		if ($file_name) {
		    $inf = pathinfo($file_name);
		    $ret = $inf['extension'];
		}
		
		return $ret;
	}

    /**
     * Получение корневых категорий
     */
    function getAllRootCategs()
    {   GLOBAL $db;

        $ret = FALSE;
        $db->query('SELECT id, name FROM '.$this->table_prefix.'_documents_categories WHERE active = 1');
        if ($db->nf() > 0) {
            while ($db->next_record()) {
                $ret[] = array(
                    'categ_id' => $db->f('id'),
                    'categ_name' => $db->f('name')
                );
            }
        }
        return $ret;
    }
    
    function getSubTree($root_id, $filter = array())
	{   global $db, $CONFIG;
	    $root_id = (int) $root_id;
	    $ctgr = $root_id ? $this->get_cat($root_id) : array('id' => 0);
	    $list = array();
	    $ret = false;
	    if ($ctgr) {
	        $parents = $ctgr['id'];
	        $level = $ctgr['level'];
	        $ids = array($ctgr['id']);
	        $list[$ctgr['id']] = array(
	           'id' => $ctgr['id'],
	           'parent_id' => $ctgr['parent_id'],
	           'title' => $ctgr['name'],
	           'level' => $ctgr['level'],
	           'childs' => array()
	        );
	        if (!$root_id) {
	            $level = 0;
	            $list = array();
	        }
	        while ( ($child_list = $this->getChilds($parents, $filter)) ) {
	            $level++;
	            $parents = array();
	            foreach ($child_list as $id=>$child) {
	                $parents[] = $id;
	                $ids[] = $id;
	            	if ( ($ctgr['id'] == $child['parent_id'])
	            	    || isset($list[$child['parent_id']])
        			) {
    		            $list[$id] = array(
            			    'id' => $id,
            			    'parent_id' => $child['parent_id'],
            			    'title' => $child['name'],
            			    'level' => $level,
            			    'childs' => array()
            			);
            			if (isset($list[$child['parent_id']])) {
            			    $list[$child['parent_id']]['childs'][] = $id;
            			}
    		        }
	            }
	        }
	        if (!empty($ids)) {
	            $db->query("SELECT id, category_id, name, short_description, file_name, file_path, DATE_FORMAT(added,'".$CONFIG["documents_date_format"]."') as added"
					." FROM {$this->table_prefix}_documents_products"
	               ." WHERE category_id IN (".implode(", ", $ids).") AND 1=active"
	                ." ORDER BY ".$CONFIG['documents_prod_order_by']);
	            while ($db->next_record()) {
	                $file_path = $db->Record['file_path'] && file_exists(RP.$CONFIG['documents_file_path'].$db->Record['file_path'])
	                   ? "/".$CONFIG['documents_file_path'].$db->Record['file_path'] : '';
        			$list[$db->Record['category_id']]['docs'][$db->Record['type']][] = array(
        			    'id' => $db->Record['id'],
        			    'name' => $db->Record['name'],
						'added' => $db->Record['added'],
        			    'short_description' => $db->Record['short_description'],
        			    'file_name' => $db->Record['file_name'],
        			    'file_path' => $file_path,
        			    'file_size' => $file_path ? round(filesize(RP.$CONFIG['documents_file_path'].$db->Record['file_path']) / 1024, 2) : 0
        			);
        		}
    	        $curr = reset($list);
        		unset($list[$curr['id']]);
        		if ($curr && empty($list)) {    		    
        		    $ret[$curr['id']] = $curr;
        		}
        		while (! empty($list)) {
        		    $ret[$curr['id']] = $curr;
        		    if (! empty($curr['childs'])) {
        		        /* Добавить в результат потомка текущего елемента и сделать его текущим */
        		        $id = array_shift($ret[$curr['id']]['childs']);
        		        $curr = $list[$id];
        		        unset($list[$id]);
        		    } else {
        		        /* найти ближайшего предка имеющего брата, брата добавить в результат и сделать его текущим элементом */
        		        $prnt_id = $curr['parent_id'];
            		    while ($ret[$prnt_id] && empty($ret[$prnt_id]['childs'])) {
            		    	$prnt_id = $ret[$prnt_id]['parent_id'];
            		    }
            		    if (empty($ret[$prnt_id]['childs'])) {
            		        $curr = reset($list);
            		        unset($list[$curr['id']]);
            		    } else {
            		        $id = array_shift($ret[$prnt_id]['childs']);
            		        $curr = $list[$id];
            		        unset($list[$id]);
            		    }
        		    }
        		    if (empty($list)) {
        		        $ret[$curr['id']] = $curr;
        		    }    		   
        		}
	        }	        
	    }
		return $ret;
	}
	
	function getChilds($parenr_id, $filter = false)
	{   global $db, $CONFIG;
	
		if (is_array($parenr_id)) {
		    $parenr_id = array_map('intval', $parenr_id);
		} else {
		    $parenr_id = array(intval($parenr_id));
		}
		$ret = false;
		$db->query("SELECT id, name, parent_id FROM {$this->table_prefix}_documents_categories WHERE parent_id IN ("
		    .implode(', ', $parenr_id).")".($filter['active'] ? 'AND 1=active' : '')
		    ." ORDER BY parent_id, ".$CONFIG['documents_dll_order_by']);
		while ($db->next_record()) {
			$ret[$db->Record['id']] = array(
			    'id' => $db->Record['id'],
			    'name' => $db->Record['name'],
			    'parent_id' => $db->Record['parent_id']
			);
		}
		
		return $ret;
	}
	
	
	function showTree($tree_list, $transurl)
	{   global $tpl, $CONFIG;
	    if (! empty($tree_list)) {
	        $node = reset($tree_list);
    	    $lvl = $start_level = $node['level'];
	        $tpl->newBlock('block_tree');	        
	        foreach ($tree_list as $id => $node) {
    			$tpl->newBlock('block_node');
    			$assign = array(
    			    'transurl' => $transurl,
    			    'title' => $node['title'],
    			    'id' => $node['id'],
    			    'level' => $node['level'],
    			    'parent_id' => $node['parent_id'],
    			    'link' => $transurl."/".$node['id'],
    			);
    			$tpl->newBlock('block_node_item');
    			$tpl->assign($assign);
    			if ($node['docs']) {
    			    $tpl->newBlock('block_docs_list');
    			    foreach ($node['docs'] as $type => $docs) {
    			    	$tpl->newBlock('block_docs_type');
    			    	$tpl->assign('type_title', $CONFIG['documents_type'][$type]);
    			    	foreach ($docs as $doc) {
    			    	    $doc['link'] = ($CONFIG['rewrite_mod']) 
    			    	        ? $this->cats_link('download', $node['id'], $doc['id'], $transurl)
				                : "{$transurl}&action=download&id=".$doc['id'];
    			    		$tpl->newBlock('block_doc');
    			    		$tpl->assign($doc);
    			    		$ext = $this->getIcoByExt($this->getFileExt($doc['file_name']));
                			if ($ext && $ext['path']) {
                				$tpl->newBlock('block_documents_ico');
                				$tpl->assign('path', $ext['path']);
                			} else {
                				$tpl->newBlock('block_documents_no_ico');
                			}
    			    	}
    			    }
    			}
    			if ($node['level'] > $lvl) {
    			    $tpl->newBlock('block_start_level');
    			}
    			while ($node['level'] < $lvl--) {
    			    $tpl->newBlock('block_end_level');
    			}
    			$lvl = $node['level'];
    		}    		
    		while ($start_level < $lvl--) {
    		    $tpl->newBlock('block_node');
    			$tpl->newBlock('block_end_level');
    		}
	    }		
	}
	
	function showTypes($id = 0)
	{   global $CONFIG, $tpl;
		foreach ($CONFIG['documents_type'] as $key => $val) {
			$tpl->newBlock('block_types');
			$tpl->assign(array(
			    'id' => $key,
			    'title' => $val,
			    'checked' => $key == $id ? 'checked' : '',
			));
		}
	}
}

?>