<?php

class CDocumentsData_DB extends TObject {
	var $id					= NULL;
	var $active            = NULL;
	var $category_id		= NULL;
	var $name				= NULL;
	var $code				= NULL;
	var $short_description	= NULL;
	var $full_description	= NULL;
	var $image				= NULL;
	var $file_name			= NULL;
	var $file_path			= NULL;
	var $updated			= NULL;
	var $added				= NULL;
	var $downloads			= NULL;
	var $rank				= NULL;
    var	$owner_id			= NULL;
    var	$usr_group_id		= NULL;
    var	$rights				= NULL;

	function CDocumentsData_DB ($table, $PK) {
		$this->TObject($table, $PK);
	}

	function ListAll () {
		$sql = "SELECT *, DATE_FORMAT(added,'".$CONFIG["documents_date_format"]."') as added FROM $this->_tbl ORDER BY added DESC";
		return db_loadList($sql);
	}

	function show_product ($id) {
		global $CONFIG;
		$sql = "SELECT *, DATE_FORMAT(added,'".$CONFIG["documents_date_format"]."') as added FROM $this->_tbl WHERE id = ".intval($id);
		return db_loadObject ($sql, $this);
	}

	function count_products_admin ($category_id, $order_by) {
		$sql = "SELECT COUNT(*) as count FROM $this->_tbl WHERE !ISNULL(category_id) AND category_id =".intval($category_id)." ORDER BY ".My_Sql::escape($order_by);
		//arr($sql);
		return db_loadObject ($sql, $this);
	}

	function get_products ($category_id, $order_by, $start_rows, $rows, $category_str) {
		global $CONFIG;
		$sql = "SELECT *, DATE_FORMAT(added,'".$CONFIG["documents_date_format"]."') as added FROM $this->_tbl WHERE !ISNULL(category_id) "
		    .My_Sql::escape($category_str)." ORDER BY ".My_Sql::escape($order_by)
		    ." LIMIT ".intval($start_rows).",".intval($rows);
		//arr($sql);
		return db_loadList($sql);
	}

	function get_products_leaders($rows) {
		global $CONFIG;
		$sql = "SELECT *, DATE_FORMAT(added,'".$CONFIG["documents_date_format"]."') as added FROM $this->_tbl WHERE is_leader = 1 ORDER BY RAND() LIMIT 0,".intval($rows);
		return db_loadList($sql);
	}

	function load ($id = NULL, $strip = true, $fl = false) {
		global $CONFIG;
		$sql = "SELECT *, DATE_FORMAT(added,'".$CONFIG["documents_date_format"]."') as added FROM $this->_tbl WHERE $this->_tbl_key = '".My_Sql::escape($id)."'";
		return db_loadObject($sql, $this);
	}

	function countup_document ($id) {
		$sql = "UPDATE $this->_tbl SET downloads=downloads+1 WHERE $this->_tbl_key = '".My_Sql::escape($id)."'";
		if (!db_exec($sql)) {
			return 0;
		} else {
			return 1;
		}
	}

	function get_products_stats($mode = null, $rows = 10) {
		global $CONFIG;
		if (!isset($mode)) return false;

		if ($mode == "downloads") {
			$sql = "SELECT *, DATE_FORMAT(added,'".$CONFIG["documents_date_format"]."') as added FROM $this->_tbl ORDER BY downloads DESC LIMIT 0, ".intval($rows);
		} else if ($mode == "last") {
			$sql = "SELECT *, DATE_FORMAT(added,'".$CONFIG["documents_date_format"]."') as added FROM $this->_tbl ORDER BY added DESC LIMIT 0, ".intval($rows);
		}
		return db_loadList($sql);
	}

	function count_by_cat ($parent) {
		$sql = "SELECT count(1) as count FROM $this->_tbl WHERE category_id = ".intval($parent);
		return db_loadResult($sql);
	}

	function make_leader($id) {
		$sql = "UPDATE $this->_tbl SET is_leader = 1 WHERE id = ".intval($id);
		if (!db_exec($sql)) {
			return 0;
		} else {
			return 1;
		}
	}

	function DeleteByCategory($IN) {
		$sql = "DELETE FROM $this->_tbl WHERE category_id IN (".My_Sql::escape($IN).")";
		db_exec($sql);
		if (db_affected_rows() > 0) {
			return 1;
		} else {
			return 0;
		}
	}
}


##############################################################################


class CDocumentsCategories_DB extends TObject {
	var $id				= NULL;
	var $parent_id		= NULL;
	var $name			= NULL;
	var $url			= NULL;
	var $description	= NULL;
	var $image			= NULL;
	var $level			= NULL;
	var $active			= NULL;
	var $rank			= NULL;
	var $title			= NULL;
    var	$owner_id		= NULL;
    var	$usr_group_id	= NULL;
    var	$rights			= NULL;

	function CDocumentsCategories_DB ($table, $PK) {
		$this->TObject($table, $PK);
	}

	function ListAll () {
		$sql = "SELECT * FROM $this->_tbl ORDER BY id";
		//arr($sql);
		return db_loadList($sql);
	}

	function get_submenu_items ($order_by) {
		$sql = "SELECT * FROM $this->_tbl WHERE parent_id = 0 AND active = 1 ORDER BY ".$order_by;
		//arr($sql);
		return db_loadList($sql);
	}

	function show_cats($parent, $only_active = false, $order = false) {
		return db_loadList("SELECT * FROM $this->_tbl WHERE parent_id=".intval($parent)
		  .($only_active ? " AND active = 1" : '') ." ORDER BY ".($order ? $order: "rank ASC"));
	}

	function show_cat($id) {
		$sql = "SELECT * FROM $this->_tbl WHERE id = $id";
		//arr($sql);
		return db_loadObject($sql, $this);
	}

	function get_tree ($order_by) {
		$sql = "SELECT * FROM $this->_tbl WHERE !ISNULL(parent_id) ORDER BY $order_by";
		//arr($sql);
		return db_loadList($sql);
	}

	function get_elements($str) {
		$sql = "SELECT id FROM $this->_tbl WHERE parent_id IN ($str) OR id IN ($str)";
		return db_loadList($sql);
	}

	function load($id = NULL, $strip = true, $fl = false) {
		$sql = "SELECT * FROM $this->_tbl WHERE id = '$id'";
		return db_loadObject($sql, $this);
	}

	function locate($IN) {
		$sql = "SELECT * FROM $this->_tbl WHERE id IN ($IN)";
		return db_loadList($sql, $this);
	}

	function DeleteByID($IN) {
		$sql = "DELETE FROM $this->_tbl WHERE id IN ($IN)";
		db_exec($sql);
		if (db_affected_rows() > 0) {
			return 1;
		} else {
			return 0;
		}
	}
}

?>