<?php // Vers 5.9.3 16.05.2016
/**
* индекс type задёт тип значения, возможные значения:
*	integer  - целое число
*	double   - вещественное число
*	string   - строка
*	checkbox - элемент допускающий установку/снятие галочки (тег <input type="checkbox">)
*	select   - выпадающий список
* индекс defval задаёт значение по умоляанию,
* индекс descr задаёт текстовое описание данного элемента, для вывода в качестве справки
* индекс access устанавливает уровень доступа, возможные значения
* 	public	- элемент доступен для чтения/изменения
*	final	- элемент доступен только для чтения
*	private - элемент не доступен
*/
$TYPES_NEW = array(
	'forum_default_username'		=> array('type'		=> 'string',
			   								 'defval'	=> 'Гость',
			   								 'descr'	=> array(	'rus' => 'Имя пользователя по умолчанию',
											 						'eng' => 'Default user name'),
			   								 'access'	=> 'editable'
			   								 ),

    'forum_topics_order_by'			=> array('type'		=> 'select',
			   								 'defval'	=> array('updated DESC'	=> array(	'rus' => 'По убыванию дат ответов',
											 												'eng' => 'On answers date decrease'),
			   								 					 'updated'		=> array(	'rus' => 'По возрастанию дат ответов',
																 							'eng' => 'On answers date increase'),
			   								 					),
			   								 'descr'	=> array(	'rus' => 'Сортировать темы',
											 						'eng' => 'Sort themes'),
			   								 'access'	=> 'editable'
			   								 ),

   'forum_replies_order_by'			=> array('type'		=> 'select',
											 'defval'	=> array('id'		=> array(	'rus' => 'В порядке добавления',
											 											'eng' => 'Adding order'),
                                                                 'id DESC'	=> array(	'rus' => 'В порядке обратном добавлению',
											 											'eng' => 'Reverce adding order'),
																 ),
			   								 'descr'	=> array(	'rus' => 'Сортировать ответы',
											 						'eng' => 'Sort answers'),
			   								 'access'	=> 'editable'
			   								 ),

     'forum_topics_max_rows'		=> array('type'		=> 'integer',
			   								 'defval'	=> '10',
			   								 'descr'	=> array(	'rus' => 'Максимальное количество тем на странице',
											 						'eng' => 'Maximal count themes on page'),
			   								 'access'	=> 'editable'
			   								 ),

     'forum_last_topics_max_rows'	=> array('type'		=> 'integer',
			   								 'defval'	=> '5',
			   								 'descr'	=> array(	'rus' => 'Максимальное количество последних обновлённых тем в блоке "последние"',
											 						'eng' => 'Maximal count last refreshed themes in block "last"'),
			   								 'access'	=> 'editable'
			   								 ),

     'forum_replies_max_rows'		=> array('type'		=> 'integer',
			   								 'defval'	=> '10',
			   								 'descr'	=> array(	'rus' => 'Максимальное количество ответов в теме на одной странице',
											 						'eng' => 'Maximal count answers in theme on one page'),
			   								 'access'	=> 'editable'
			   								 ),

     'forum_banip_max_rows'			=> array('type'		=> 'integer',
			   								 'defval'	=> '20',
			   								 'descr'	=> array(	'rus' => 'Максимальное количество забаненых IP на странице',
											 						'eng' => 'Maximal count banned IP on page'),
			   								 'access'	=> 'editable'
			   								 ),

     'forum_username_max_length'	=> array('type'		=> 'integer',
			   								 'defval'	=> '100',
			   								 'descr'	=> array(	'rus' => 'Максимальное длина имени автора сообщения',
											 						'eng' => 'Maximal message author name length'),
			   								 'access'	=> 'editable'
			   								 ),

     'forum_email_max_length'		=> array('type'		=> 'integer',
			   								 'defval'	=> '100',
			   								 'descr'	=> array(	'rus' => 'Максимальное длина e-mail автора сообщения',
											 						'eng' => 'Maximal message author e-mail length'),
			   								 'access'	=> 'editable'
			   								 ),

     'forum_subject_max_length'		=> array('type'		=> 'integer',
			   								 'defval'	=> '150',
			   								 'descr'	=> array(	'rus' => 'Максимальное длина заголовка сообщения',
											 						'eng' => 'Maximal message title length'),
			   								 'access'	=> 'editable'
			   								 ),

	 'forum_text_max_length'		=> array('type'		=> 'integer',
			   								 'defval'	=> '10000',
			   								 'descr'	=> array(	'rus' => 'Максимальное длина сообщения',
											 						'eng' => 'Message maximal length'),
			   								 'access'	=> 'editable'
			   								 ),
     'forum_date_format'				=> array('type'		=> 'select',
		   									 'defval'	=> array('%d.%m.%Y | %H:%i'	=> array(	'rus' => 'День.Месяц.Год | Часы:Минуты',
											 										  			'eng' => 'Day.Month.Year | Hours:Minutes'),
		   									 					 '%d.%m.%Y'			=> array(	'rus' => 'День.Месяц.Год',
											 													'eng' => 'Day.Month.Year'),
		   									 					 '%Y.%m.%d'			=> array(	'rus' => 'Год.Месяц.День',
											 													'eng' => 'Year.Month.Day'),
		   									 					 '%Y.%m.%d | %H:%i'	=> array(	'rus' => 'Год.Месяц.День | Часы:Минуты',
											 													'eng' => 'Year.Month.Day | Hours:Minutes'),
		   									 					 ),
											 'descr'	=> array(	'rus' => 'Формат выводимой даты',
											 						'eng' => 'Format of deduced date'),
			   								 'access'	=> 'editable'
			   								 ),

	'forum_requires_authorization'	=> array('type'		=> 'select',
			   								 'defval'	=> array('1' => array(	'rus' => 'Да',
											 									'eng' => 'Yes'),
			   								 					 '0' => array(	'rus' => 'Нет',
											 									'eng' => 'No'),
			   								 					),
											 'descr'	=> array(	'rus' => 'Добавление тем и сообщений только для авторизованных пользователей',
											 						'eng' => 'Only authorized user may add themes and answers'),
											 'access'	=> 'editable',
											 ),

	 'forum_img_max_width'		=> array('type'		=> 'integer',
			   								 'defval'	=> '100',
			   								 'descr'	=> array(	'rus' => 'Максимальная ширина изображения пользователя',
											 						'eng' => 'Maximum width of user picture'),
			   								 'access'	=> 'editable'
			   								 ),

	 'forum_img_max_height'		=> array('type'		=> 'integer',
			   								 'defval'	=> '100',
			   								 'descr'	=> array(	'rus' => 'Максимальная высота изображения пользователя',
											 						'eng' => 'Maximum height of user picture'),
			   								 'access'	=> 'editable'
			   								 ),

	 'forum_img_max_size'		=> array('type'		=> 'integer',
			   								 'defval'	=> '10',
			   								 'descr'	=> array(	'rus' => 'Максимальный размер изображения пользователя(Кб)',
											 						'eng' => 'Maximum size of user picture(Kb)'),
			   								 'access'	=> 'editable'
			   								 ),

	 'forum_default_rights'		=> array('type'		=> 'string',
		   									 'defval'	=> '111111110011000100010001',
		   									 'descr'	=> array(	'rus' => 'Права для форума по-умолчанию (формат <img src="/i/admin/rights_format.gif" width=143 height=18 alt="формат прав">, где x - 0 или 1, каждая группа представляет набор прав: удаление, публикация, редактирование, чтение)',
																	'eng' => 'Forum default rights (format <img src="/i/admin/rights_format.gif" width=143 height=18 alt="rights format">, where x - 0 or 1, every group is rights set: delete, publication, edit, read)'),
		   									 'access'	=> 'editable'
		   									 ),

	 'forum_active_time'			=> array('type'		=> 'integer',
		   									 'defval'	=> '15',
		   									 'descr'	=> array(	'rus' => 'Кол-во минут в течении которых пользователь считается активным на форуме',
																	'eng' => 'User`s active time (min.)'),
		   									 'access'	=> 'editable'
		   									 ),

	 'forum_hot_count'			=> array('type'		=> 'integer',
		   									 'defval'	=> '2',
		   									 'descr'	=> array(	'rus' => 'Минимальное кол-во сообщений в горячей теме',
																	'eng' => 'Min. count of messages in hot topic'),
		   									 'access'	=> 'editable'
		   									 ),

	 'forum_united_time'			=> array('type'		=> 'integer',
		   									 'defval'	=> '30',
		   									 'descr'	=> array(	'rus' => 'Время, в секундах, в течении которого объеденяются сообщения пользователя',
																	'eng' => 'Time, in seconds in which current messages of the user are united'),
		   									 'access'	=> 'editable'
		   									 ),

	 'forum_is_new_time'			=> array('type'		=> 'integer',
		   									 'defval'	=> '5',
		   									 'descr'	=> array(	'rus' => 'Время, в минутах, в течении которого сообщение считается новым после прочнетия',
																	'eng' => 'Time, in minutes in which current the message is considered new after reading'),
		   									 'access'	=> 'editable'
		   									 ),
);

$OPEN_NEW = array(
	'forum_users_max_rows' => '10'
);

/*------------- Ниже следующий массив задаётся из административного раздела модуля -------*/
$NEW = array(
/* ABOCMS:START */
'forum_default_username' => 'Гость',
'forum_topics_order_by' => 'updated DESC',
'forum_replies_order_by' => 'id',
'forum_topics_max_rows' => '6',
'forum_last_topics_max_rows' => '5',
'forum_replies_max_rows' => '5',
'forum_banip_max_rows' => '20',
'forum_username_max_length' => '100',
'forum_email_max_length' => '100',
'forum_subject_max_length' => '150',
'forum_text_max_length' => '10000',
'forum_date_format' => '%d.%m.%Y | %H:%i',
'forum_requires_authorization' => '1',
'forum_img_max_width' => '100',
'forum_img_max_height' => '100',
'forum_img_max_size' => '10',
'forum_default_rights' => '111111110011',
'forum_active_time' => '10',
'forum_hot_count' => '5',
'forum_united_time' => '30',
'forum_is_new_time' => '5',
/* ABOCMS:END */
);
?>