<?php
define('FORUM_SMILES_IMG_PATH', '/mod/forum/img/smiles/');
define('FORUM_SMILES_COLUMNS', '4');
define('FORUM_SMILES_LEFT_DELIMITER', '');
define('FORUM_SMILES_RIGHT_DELIMITER', '');


class Smiles {

	var $img_path;
	var $columns;
	var $right_delimiter;
	var $left_delimiter;
	
	function Smiles() {
		global $CONFIG, $lang, $db1;
		$this->img_path = ($CONFIG['forum_smiles_img_path'] ? $CONFIG['forum_smiles_img_path'] : FORUM_SMILES_IMG_PATH).$lang.'/';
		$this->columns  = $CONFIG['forum_smiles_columns'] ? $CONFIG['forum_smiles_columns'] : FORUM_SMILES_COLUMNS;
		$this->right_delimiter = $CONFIG['forum_smiles_right_delimiter'] ? $CONFIG['forum_smiles_right_delimiter'] : FORUM_SMILES_RIGHT_DELIMITER;
		$this->left_delimiter = $CONFIG['forum_smiles_left_delimiter'] ? $CONFIG['forum_smiles_left_delimiter'] : FORUM_SMILES_LEFT_DELIMITER;		
		$this->db = $db1;
	}
	
	function get_smiles(){
		global $server, $lang;
		$smiles = array();
		$query = 'SELECT * FROM '.$server.$lang.'_forum_smiles WHERE active ORDER BY rank';
		$this->db->query($query);
		if ($this->db->nf()) {
			while ($this->db->next_record()) {
				$smile = array();
				$smile['id'] 	  	  = $this->db->f('id');
				$smile['emotion'] 	  = $this->db->f('emotion');
				$smile['img']		  = $this->db->f('img');
				$smile['virtual_tag'] = $this->db->f('virtual_tag');
				array_push($smiles, $smile);
			}
		}
		return $smiles;
	}
	
	function wrap_tag($tag){
		$search  = array("'");
		$replace = array("\'");
		$tag = trim(str_replace($search, $replace, $tag));
		return $tag ? $this->left_delimiter.$tag.$this->right_delimiter : '';
	}
	
	function parse($text){		
		$smiles  = $this->get_smiles();
		$search  = array();
		$replace = array();
		for ($i=0; $i<count($smiles); $i++){
			$tag = $this->wrap_tag($smiles[$i]['virtual_tag']);
				array_push($search, $tag);
			$img_tag = '<img src="'.$this->img_path.$smiles[$i]['img'].'" alt="'.$smiles[$i]['emotion'].'">';
				array_push($replace, $img_tag);
		}
		$text = str_replace($search, $replace, $text);
		return $text;
	}
}
?>