<?php
$MOD_TABLES[] = "CREATE TABLE `".$prefix."_forum_category` (
					`id` smallint(5) unsigned NOT NULL auto_increment,
          `name` varchar(255) NOT NULL default '',
          `description` varchar(255) NOT NULL default '',
          `order` smallint(5) NOT NULL default '0',
          `owner_id` int(10) unsigned NOT NULL default '0',
          `usr_group_id` int(10) unsigned NOT NULL default '0',
          `rights` int(10) unsigned NOT NULL default '0',
          PRIMARY KEY  (`id`)
					) ENGINE=MyISAM";

$MOD_TABLES[] = "CREATE TABLE `".$prefix."_forum_censor` (
					`censor_id` int(11) NOT NULL auto_increment,
          `censor_word` varchar(50) NOT NULL default '',
          `censor_replace` varchar(50) default NULL,
          `censor_type` varchar(10) default 'word',
          PRIMARY KEY  (`censor_id`),
          KEY `censor_type` (`censor_type`)
				) ENGINE=MyISAM";

$MOD_TABLES[] = "CREATE TABLE `".$prefix."_forum_complaint` (
					`post_id` int(10) unsigned NOT NULL default '0',
          `user_id` smallint(6) unsigned NOT NULL default '0',
          `cdate` datetime default NULL,
          `username` varchar(100) default NULL,
          UNIQUE KEY `post_id` (`post_id`,`user_id`)
				) ENGINE=MyISAM";

$MOD_TABLES[] = "CREATE TABLE `".$prefix."_forum_ip_ban` (
					`ip` varchar(20) NOT NULL default '',
          UNIQUE KEY `unique_ip` (`ip`)
				) ENGINE=MyISAM";

$MOD_TABLES[] = "CREATE TABLE `".$prefix."_forum_last_reply` (
					`topic_id` int(10) unsigned NOT NULL default '0',
          `forum_id` smallint(5) unsigned default NULL,
          `reply_id` int(10) unsigned NOT NULL default '0',
          `post_date` datetime default NULL,
          `user_id` smallint(6) unsigned NOT NULL default '0',
          `username` varchar(100) default NULL,
          PRIMARY KEY  (`topic_id`)
					) ENGINE=MyISAM";

$MOD_TABLES[] = "CREATE TABLE `".$prefix."_forum_moderator` (
  				  `forum_id` smallint(5) unsigned NOT NULL default '0',
            `user_id` smallint(6) unsigned NOT NULL default '1',
            UNIQUE KEY `forum_id` (`forum_id`,`user_id`)
				) ENGINE=MyISAM";

$MOD_TABLES[] = "CREATE TABLE `".$prefix."_forum_online_user` (
					`sid` varchar(32) NOT NULL default '',
          `vtime` datetime default NULL,
          `forum_id` smallint(5) unsigned default NULL,
          `topic_id` int(10) unsigned NOT NULL default '0',
          `user_id` smallint(6) unsigned NOT NULL default '0',
          `username` varchar(31) NOT NULL default '',
          UNIQUE KEY `sid` (`sid`)
					) ENGINE=MyISAM";

$MOD_TABLES[] = "CREATE TABLE `".$prefix."_forum_post_state` (
					`topic_id` int(10) unsigned NOT NULL default '0',
          `type` tinyint(3) unsigned default '0',
          `status` tinyint(3) unsigned default '0',
          PRIMARY KEY  (`topic_id`)
					) ENGINE=MyISAM";

$MOD_TABLES[] = "CREATE TABLE `".$prefix."_forum_posts` (
					`id` int(10) unsigned NOT NULL auto_increment,
          `forum_id` smallint(5) unsigned default NULL,
          `topic_id` int(11) unsigned default NULL,
          `parent_id` int(5) unsigned NOT NULL default '0',
          `user_id` smallint(6) unsigned NOT NULL default '0',
          `subject` varchar(255) NOT NULL default '',
          `text` text,
          `signature` varchar(255) default NULL,
          `username` varchar(100) default NULL,
          `email` varchar(100) default NULL,
          `views` smallint(6) NOT NULL default '0',
          `replies` smallint(5) unsigned default NULL,
          `ip` varchar(20) default NULL,
          `host` varchar(100) default NULL,
          `post_date` datetime default NULL,
          `updated` datetime default NULL,
          `edit_user_id` smallint(6) unsigned NOT NULL default '0',
          `edit_username` varchar(100) default NULL,
          `active` tinyint(4) NOT NULL default '1',
          `replies_to_email` tinyint(4) NOT NULL default '0',
          `author_module` varchar(255) NOT NULL default '',
          `author_module_link` varchar(255) NOT NULL default '',
          `owner_id` int(10) unsigned NOT NULL default '0',
          `usr_group_id` int(10) unsigned NOT NULL default '0',
          `rights` int(10) unsigned NOT NULL default '0',
          PRIMARY KEY  (`id`),
          KEY `views` (`views`)
					) ENGINE=MyISAM";

$MOD_TABLES[] = "CREATE TABLE `".$prefix."_forum_smiles` (
				  `id` int(11) NOT NULL auto_increment,
          `emotion` varchar(128) default NULL,
          `img` varchar(128) default NULL,
          `virtual_tag` varchar(64) default NULL,
          `active` tinyint(1) default '1',
          `rank` int(11) default NULL,
          PRIMARY KEY  (`id`)
				) ENGINE=MyISAM";

$MOD_TABLES[] = "CREATE TABLE `".$prefix."_forum_topic_visit` (
					`forum_id` smallint(5) unsigned default NULL,
          `topic_id` int(10) unsigned NOT NULL default '0',
          `user_id` smallint(6) unsigned NOT NULL default '0',
          `username` varchar(31) NOT NULL default '',
          `last_visit` datetime default NULL,
          UNIQUE KEY `forum_id` (`forum_id`,`topic_id`,`user_id`)
				) ENGINE=MyISAM";

$MOD_TABLES[] = "CREATE TABLE `".$prefix."_forums` (
					`id` smallint(5) unsigned NOT NULL auto_increment,
          `category_id` smallint(5) unsigned NOT NULL default '0',
          `name` varchar(255) NOT NULL default '',
          `description` text,
          `rules` text,
          `state` tinyint(3) unsigned NOT NULL default '0',
          `last_post_date` datetime default NULL,
          `last_user_id` smallint(6) unsigned NOT NULL default '0',
          `last_username` varchar(100) default NULL,
          `topics` smallint(6) unsigned NOT NULL default '0',
          `replies` smallint(6) unsigned NOT NULL default '0',
          `weight` int(11) NOT NULL default '0',
          `active` tinyint(4) NOT NULL default '0',
          `f_order` smallint(6) NOT NULL default '0',
          `edit_personal_msg` tinyint(1) NOT NULL default '1',
          `owner_id` int(10) unsigned NOT NULL default '0',
          `usr_group_id` int(10) unsigned NOT NULL default '0',
          `rights` int(10) unsigned NOT NULL default '0',
          `last_post_id` int(10) unsigned default '0',
          PRIMARY KEY  (`id`)
					) ENGINE=MyISAM";

?>