<?php

class FriendsPrototype extends Module {

	var $main_title;
	var $table_prefix;
	var $addition_to_path;
	var $module_name				= 'friends';
	var $default_action				= 'search';
	var $admin_default_action		= 'forms';
	var $tpl_path					= 'mod/friends/tpl/';
	var $block_module_actions		= array();
	var $block_main_module_actions	= array();
	var $is_admin					= false;
	var $start_year					= 1975;
	var $end_year					= 2000;
	var $sex_man                    = 'm';
	var $sex_wom                    = 'w';

	function FriendsPrototype($action = '', $transurl = '', $properties = array(), $prefix = NULL, $rewrite_mod_params = NULL, $adminurl = NULL, $noadmin = false) {
		global $main, $tpl, $tpl_path, $baseurl, $cache, $lc, $CONFIG, $PAGE, $server, $lang, $permissions, $request_type, $_RESULT;

		/* Get $action, $tpl_name, $permissions */
		extract( $this->init(array(
		    'server' => $server, 'lang' => $lang, 'prefix' => $prefix,
		    'action' => $action, 'tpl_name' => $properties['tpl']
		)), EXTR_OVERWRITE);
		
		$this->block_module_actions = array(
		        'search'   => $this->_msg["Search"],
		);
		$this->block_main_module_actions  = array(
		        'search'   => $this->_msg["Search"],
		        'list'   => $this->_msg["Forms"],
		);

		$category = $field = (int)$properties[1];
		$rows		= (int)$properties[2];

		if (!$rows) $rows = $CONFIG['friends_max_rows'];
		
		if ('only_create_object' == $action) {
		    return;
		}
		
		if ($this->actionExists($action)) {
		    $this->doAction($action);
		    return;
		}

		if (! self::is_admin()) {
		    if ($_SESSION['siteuser']['id'] && in_array($action, array('userform', 'usrvcncsshw', 'uservacancy')) ) {
            	$PAGE['current_user_id'] = $_SESSION['siteuser']['id'];
            }
		    if (0 == $PAGE['field'] && $_REQUEST['user_id']
		        && in_array($action, array('form'))
		    ) {
		    	$PAGE['current_user_id'] = $_REQUEST['user_id'];
		    }
		    if ($PAGE['current_user_id']) {
		    	if (!class_exists('SiteusersPrototype')) {
					require(RP."mod/siteusers/lib/class.SiteusersPrototype.php");
				}
				$this->addition_to_path = array(SiteusersPrototype::getUserName($PAGE['current_user_id']) => '');
		    }
//---------------------------------- обработка действий с сайта --------------------------------//
			switch ($action) {
			/**
			 * Показать анкету
			 */
			case "form":
				$main->include_main_blocks($this->module_name . "_".$action.".html", "main");
				$tpl->prepare();
				$form = $_REQUEST['user_id']
				    ? $this->GetUserForm($_REQUEST['user_id'])
				    : $this->GetForm($_REQUEST['id']);
				$this->ShowForm($form);

				break;
			/**
			 * Показать форму поиска
			 */
			case "search":
				$main->include_main_blocks($this->module_name . "_".$action.".html", "main");
				$tpl->prepare();
				$this->ShowSearchForm($transurl, false);

				break;
			/**
			 * Показать форму добавления/редактирования анкеты
			 */
			case "userform":
				$main->include_main_blocks($this->module_name . "_".$action.".html", "main");
				$tpl->prepare();
				$this->ShowUserForm();

				break;
			/**
			 * Показать резултат поиска
			 */
			case "list":
			case "searchres":
				$main->include_main_blocks($this->module_name . "_formlist.html", "main");
				$tpl->prepare();
				if ($_REQUEST['data'] ) {
				    $this->ShowSearchRes($_REQUEST['start'], 0, $_REQUEST['data']);
				}
				$tpl->gotoBlock('_ROOT');
				$this->ShowSearchForm($baseurl, true);

				break;
			/**
			 * Добавить/редактировать анкету
			 */
			case "setform":
			    if ($this->CheckUserForm($_REQUEST['data']['id'])) {
    			    $form_id = $this->SetForm($_REQUEST['data']);
    			    if ($GLOBALS['JsHttpRequest']) {
    		        	if (! $form_id) {
    		        		$GLOBALS['_RESULT']['err'] = true;
    		        	} else {
    		        	    $GLOBALS['_RESULT'] = $this->GetForm($form_id);
    		        	}
    		        	exit;
    		        }
			    }
		        header("Location: ".$baseurl."&action=userform");
		        exit;
		    /**
			 * Удалить анкету
			 */
			case "delform":
			    if ($this->CheckUserForm($_REQUEST['id'])) {
    			    $res = $this->DelForm($_REQUEST['id']);
    			    if ($GLOBALS['JsHttpRequest']) {
    		        	if (! $res) {
    		        		$GLOBALS['_RESULT']['err'] = true;
    		        	} else {
    		        	    $GLOBALS['_RESULT'] = true;
    		        	}
    		        	exit;
    		        }
			    }
		        header("Location: ".$baseurl."&action=userform");
		        exit;
// Default...
			default:
				if (is_object($tpl)) $tpl->prepare();
				break;
			}
//------------------------------- конец обработки действий с сайта -----------------------------//
		} else {
//------------------------------ обработка действий из админ части -----------------------------//      		
			if (!isset($tpl)) {
			    $main->message_die('Не подключен класс для работы с шаблонами');
			}

			switch ($action) {
		    case 'prp':
		    	if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $request_step;
				$main->include_main_blocks('_properties.html', $this->tpl_path);
				$tpl->prepare();
				$tpl->assign(Array(
					"MSG_Information"	=> $main->_msg["Information"],
					"MSG_Value"			=> $main->_msg["Value"],
					"MSG_Save"			=> $main->_msg["Save"],
					"MSG_Cancel"		=> $main->_msg["Cancel"],
				));
		        if (!$request_step || $request_step == 1) {
					$tpl->assign(array('form_action'	=> $baseurl,
									   'step'			=> 2,
									   'lang'			=> $lang,
									   'name'			=> $this->module_name,
									   'action'			=> 'prp'));
					$prp_html = $main->getModuleProperties($this->module_name);
		            $this->main_title = $this->_msg["Controls"];
				} elseif (2 == $request_step) {
		        	$main->setModuleProperties($this->module_name, $_POST);
					header('Location: '.$baseurl.'&action=prp&step=1');
				}
		    	break;

			case 'block_prp':
				global $request_sub_action, $request_block_id;
		        $arr  = $this->getEditLink($request_sub_action, $request_block_id);
				$cont = 'var container = document.getElementById(\'target_span\');
		    		  	 container.innerHTML	= "'.$this->getPropertyFields($arr).'";
		    		  	 material_id			= "'.$arr['material_id'].'";
		    		  	 material_url			= "'.$arr['material_url'].'";
		    		  	 changeAction();
		    	      	 setURL("property1")';
				header('Content-Length: '.strlen($cont));
		    	echo $cont;
		    	exit;
		    	break;

      case 'properties':
          if (!$permissions['e']) $main->message_access_denied($siteusres->module_name, $action);
          global $module_id, $request_field, $title;

          $main->include_main_blocks('_block_properties.html', 'main');
          $tpl->prepare();

          if ($main->show_actions($request_field, '', $this->block_main_module_actions, $this->block_module_actions)) {
              $main->show_linked_pages($module_id, $request_field);
          }

          $tpl->assign(array(
              '_ROOT.title'		=> $title,
              '_ROOT.username'	=> $_SESSION['session_login'],
              '_ROOT.password'	=> $_SESSION['session_password'],
              '_ROOT.name'		=> $this->module_name,
              '_ROOT.lang'		=> $lang,
          ));
          $this->main_title	= $this->_msg["Block_properties"];
          break;

		    /**
		     * Справочники
		     */
			case 'ref':
		        if (!$permissions["e"]) {
		            $main->message_access_denied($this->module_name, $action);
		        }
				$main->include_main_blocks_2($this->module_name."_ref.html", $this->tpl_path);
				$tpl->prepare();
				$tpl->assign(Array(
					"MSG_Add_reference"            => $this->_msg["Add_reference"],
					"MSG_Edit_reference"           => $this->_msg["Edit_reference"],
					"MSG_Del_reference"            => $this->_msg["Del_reference"],
					"MSG_Reference"                => $this->_msg["Reference"],
					"MSG_Name"                     => $this->_msg["Name"],
					"MSG_Delete"                   => $this->_msg["Delete"],
					"MSG_Edit"                     => $this->_msg["Edit"],
					"MSG_Confirm_delete_record"    => $this->_msg["Confirm_delete_record"],
					"MSG_Value"                    => $this->_msg["Value"],
					"MSG_Values"                   => $this->_msg["Values"],
					"MSG_Add_value"                => $this->_msg["Add_value"],
					"MSG_Edit_value"               => $this->_msg["Edit_value"],
					"MSG_Del_value"                => $this->_msg["Del_value"],
					"MSG_Num"                      => $this->_msg["Num"],
					"MSG_Activate"                 => $this->_msg["Activate"],
					"MSG_Suspend"                  => $this->_msg["Suspend"],
					"MSG_Value"			=> $main->_msg["Value"],
					"MSG_Save"			=> $main->_msg["Save"],
					"MSG_Cancel"		=> $main->_msg["Cancel"],
					"MSG_Del"      		=> $main->_msg["Del"],
					"MSG_Ed"       		=> $main->_msg["Ed"],

					"baseurl"  => $baseurl
				));

				$this->ShowRefList();

				$this->main_title = $this->_msg["References"];
		    	break;

		    /**
		     * Добавить/редактировать справочник
		     */
			case 'setref':
		        if (!$permissions["e"]) {
		            $main->message_access_denied($this->module_name, $action);
		        }

		        $err = false;
		        if ($_REQUEST['id']) {
		            if (! $this->SetReference($_REQUEST['id'], $_REQUEST['title'])) {
		                $err = true;
		            } else {
		                $ref_id = $request_id;
		            }
		        } else {
		            $ref_id =  $this->AddReference($_REQUEST['title']);
		            if (! $ref_id) {
		                $err = true;
		            }
		        }
		        if ($GLOBALS['JsHttpRequest']) {
		        	if ($err) {
		        		$GLOBALS['_RESULT']['err'] = true;
		        	} else {
		        	    $GLOBALS['_RESULT'] = $this->GetReference($ref_id);
		        	}
		        	exit;
		        }

		        header("Location: ".$baseurl."&action=ref");

		    	break;

		    /**
		     * Удалить справочник
		     */
			case 'delref':
		        if (!$permissions["d"]) {
		            $main->message_access_denied($this->module_name, $action);
		        }

		        $err = $this->DelReference($_REQUEST['id']) ? false : true;
		        if ($GLOBALS['JsHttpRequest']) {
		        	if ($err) {
		        		$GLOBALS['_RESULT']['err'] = true;
		        	} else {
		        	    $GLOBALS['_RESULT']['id'] = $_REQUEST['id'];
		        	}
		        	exit;
		        }

		        header("Location: ".$baseurl."&action=ref");

		    	break;

		    /**
		     * Получить данный по справочнику
		     */
			case 'getref':
		        if (!$permissions["r"]) {
		            $main->message_access_denied($this->module_name, $action);
		        }

		        $ref = $this->GetReference($_REQUEST['id']);
		        $err = $ref ? false : true;
		        if (! $err) {
		        	$ref['vals'] = $this->GetReferenceValList($_REQUEST['id']);
		        }
		        if ($GLOBALS['JsHttpRequest']) {
		        	if ($err) {
		        		$GLOBALS['_RESULT']['err'] = true;
		        	} else {
		        	    $GLOBALS['_RESULT'] = $ref;
		        	}
		        	exit;
		        }

		        header("Location: ".$baseurl."&action=ref");

		    	break;

		    /**
		     * Добавить/редактировать значение справочника
		     */
			case 'setrefval':
		        if (!$permissions["e"]) {
		            $main->message_access_denied($this->module_name, $action);
		        }

		        $err = false;
		        if ($_REQUEST['id']) {
		            if (! $this->SetReferenceVal($_REQUEST['id'], $_REQUEST['title'], $_REQUEST['num'])) {
		                $err = true;
		            } else {
		                $val_id = $_REQUEST['id'];
		            }
		        } else {
		            $val_id =  $this->AddReferenceVal($_REQUEST['ref_id'], $_REQUEST['title'], $_REQUEST['num']);
		            if (! $val_id) {
		                $err = true;
		            }
		        }
		        if ($GLOBALS['JsHttpRequest']) {
		        	if ($err) {
		        		$GLOBALS['_RESULT']['err'] = true;
		        	} else {
		        	    $GLOBALS['_RESULT'] = $this->GetReferenceVal($val_id);
		        	}
		        	exit;
		        }

		        header("Location: ".$baseurl."&action=ref");

		    	break;

		    /**
		     * Удалить значение справочника
		     */
			case 'delrefval':
		        if (!$permissions["d"]) {
		            $main->message_access_denied($this->module_name, $action);
		        }

		        $err = $this->DelReferenceVal($_REQUEST['id']) ? false : true;
		        if ($GLOBALS['JsHttpRequest']) {
		        	if ($err) {
		        		$GLOBALS['_RESULT']['err'] = true;
		        	} else {
		        	    $GLOBALS['_RESULT']['id'] = $_REQUEST['id'];
		        	}
		        	exit;
		        }

		        header("Location: ".$baseurl."&action=ref");

		    	break;

		    /**
		     * анкета
		     */
			case 'forms':
		        if (!$permissions["r"]) {
		            $main->message_access_denied($this->module_name, $action);
		        }
				$main->include_main_blocks_2($this->module_name."_".$action.".html", $this->tpl_path);
				$tpl->prepare();
				$tpl->assign(Array(
					"MSG_Add_form"               => $this->_msg["Add_form"],
					"MSG_Edit_form"              => $this->_msg["Edit_form"],
					"MSG_Del_form"               => $this->_msg["Del_form"],
					"MSG_City"                     => $this->_msg["City"],
					"MSG_Education"                => $this->_msg["Education"],
					"MSG_Select"                   => $this->_msg["Select"],
					"MSG_Unimportant"              => $this->_msg["Unimportant"],
					"MSG_Sex"                      => $this->_msg["Sex"],
					"MSG_Man"                      => $this->_msg["Man"],
					"MSG_Wom"                      => $this->_msg["Wom"],
					"MSG_Partner"                  => $this->_msg["Partner"],
					"MSG_Birthday"                 => $this->_msg["Birthday"],
					"MSG_Height"                   => $this->_msg["Height"],
					"MSG_Weight"                   => $this->_msg["Weight"],
					"MSG_About"                    => $this->_msg["About"],
   					"MSG_Find"                     => $this->_msg["Find"],
					"MSG_Hair"                     => $this->_msg["Hair"],
					"MSG_Figure"                   => $this->_msg["Figure"],
					"MSG_Family"                   => $this->_msg["Family"],
					"MSG_Aim"                      => $this->_msg["Aim"],
					"MSG_Langs"                    => $this->_msg["Langs"],
					"MSG_Fotos"                    => $this->_msg["Fotos"],
					"MSG_Activate"                 => $this->_msg["Activate"],
					"MSG_Suspend"                  => $this->_msg["Suspend"],
					"MSG_Main_foto"                => $this->_msg["Main_foto"],
					"MSG_Add_foto"                => $this->_msg["Add_foto"],

					"MSG_Delete"                   => $this->_msg["Delete"],
					"MSG_Edit"                     => $this->_msg["Edit"],
					"MSG_Confirm_delete_record"    => $this->_msg["Confirm_delete_record"],
					"MSG_Save"			=> $main->_msg["Save"],
					"MSG_Cancel"		=> $main->_msg["Cancel"],
					"MSG_Del"      		=> $main->_msg["Del"],
					"MSG_Ed"       		=> $main->_msg["Ed"],

					"max_img_cnt" => $CONFIG['friends_img_cnt'],
					"baseurl"  => $baseurl
				));
				$this->ShowUserForm();
				$this->ShowFormList($_REQUEST['start'], $CONFIG['friends_max_rows'], array(), $action);

				$this->main_title = $this->_msg["Forms"];
		    	break;

		    /**
		     * Добавить/редактировать анкета
		     */
			case 'setform':
		        if (!$permissions["e"]) {
		            $main->message_access_denied($this->module_name, $action);
		        }
		        $form_id = $this->SetForm($_REQUEST['data']);
		        if ($GLOBALS['JsHttpRequest']) {
		        	if (! $form_id) {
		        		$GLOBALS['_RESULT']['err'] = true;
		        	} else {
		        	    $GLOBALS['_RESULT'] = $this->GetForm($form_id);
		        	}
		        	exit;
		        }
		        header("Location: ".$baseurl."&action=forms".(! $form_id ? "&err" : ""));
		        exit;
		    	break;

		    /**
		     * Получить данный анкета
		     */
			case 'getform':
		        if (!$permissions["r"]) {
		            $main->message_access_denied($this->module_name, $action);
		        }

		        $form = $this->GetForm($_REQUEST['id']);
		        if ($GLOBALS['JsHttpRequest']) {
		        	if ($form) {
		        		$GLOBALS['_RESULT'] = $form;
		        	} else {
		        	    $GLOBALS['_RESULT']['err'] = true;
		        	    $GLOBALS['_RESULT']['form'] = $form;
		        	}
		        	exit;
		        }

		        header("Location: ".$baseurl."&action=forms");

		    	break;

		    /**
		     * Удалить анкета
		     */
			case 'delform':
		        if (!$permissions["d"]) {
		            $main->message_access_denied($this->module_name, $action);
		        }

		        $err = $this->DelForm($_REQUEST['id']) ? false : true;
		        if ($GLOBALS['JsHttpRequest']) {
		        	if ($err) {
		        		$GLOBALS['_RESULT']['err'] = true;
		        	} else {
		        	    $GLOBALS['_RESULT']['id'] = $_REQUEST['id'];
		        	}
		        	exit;
		        }

		        header("Location: ".$baseurl."&action=forms");

		    	break;
		    /**
		     * Редактирование прав анкета
		     */
		    /*
			case 'formrights':
				if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $request_id, $request_start;
				if (!$this->test_item_rights("e", "id", 'user_friends_form', $request_id, true))
					$main->message_access_denied($this->module_name, $action);

				if (! $this->show_rights_form(
				    'user_friends_form', "post", $request_id,
				    "&id=".$request_id, $this->_msg["Form"], "saveformrights")
				) {
					header('Location: '.$baseurl."&action=form".($request_start ? "&start=".$request_start : ""));
				}
				break;
			*/
			/**
			 * Сохранить права доступа к анкета
			 */
			/*
			case 'saveformrights':
				if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $request_id, $request_rights, $request_start;
				if (!$this->test_item_rights("e", "id", 'user_friends_form', $request_id, true))
					$main->message_access_denied($this->module_name, $action);

				$this->save_rights_form('user_friends_form', $request_id, $request_rights);
				if ($GLOBALS['JsHttpRequest']) {
					$GLOBALS['_RESULT'] = array(
					   "res"	=> 1,
					   "id"	=> $request_id,
				    );
				} else {
					header('Location: '.$baseurl."&action=form".($request_start ? "&start=".$request_start : ""));
				}
				exit;
				break;
			*/

			/**
			 * Отключить публикацию анкета
			 */
			case "formsuspend":
				if (!$permissions["p"]) $main->message_access_denied($this->module_name, $action);
				global $request_id, $request_start;
				if (!$this->test_item_rights("p", "id", 'user_friends_form', $request_id, true))
					$main->message_access_denied($this->module_name, $action);

				if ($main->suspend('user_friends_form', $request_id)) {
				    @$cache->delete_cache_files();
				    if ($GLOBALS['JsHttpRequest']) {
    					$GLOBALS['_RESULT'] = array(
    					   "active"	=> 0,
    					   "id"	=> $request_id,
    				    );
    				    exit;
    				}
				} else if ($GLOBALS['JsHttpRequest']) {
					$GLOBALS['_RESULT']['err'] = true;
					exit;
				}
				header('Location: '.$baseurl."&action=form".($request_start ? "&start=".$request_start : ""));
				exit;
				break;
			/**
			 * Включение публикации анкета
			 */
			case "formactivate":
				if (!$permissions["p"]) {
				    $main->message_access_denied($this->module_name, $action);
				}
				global $request_id, $request_start;
				if (!$this->test_item_rights("p", "id", 'user_friends_form', $request_id, true))
					$main->message_access_denied($this->module_name, $action);

				if ($main->activate('user_friends_form', $request_id)) {
				    @$cache->delete_cache_files();
				    if ($GLOBALS['JsHttpRequest']) {
    					$GLOBALS['_RESULT'] = array(
    					   "active"	=> 1,
    					   "id"	=> $request_id,
    				    );
    				    exit;
    				}
				} else if ($GLOBALS['JsHttpRequest']) {
					$GLOBALS['_RESULT']['err'] = true;
					exit;
				}
				header('Location: '.$baseurl."&action=forms".($request_start ? "&start=".$request_start : ""));
				exit;
				break;

// Default...
			default:
				$main->include_main_blocks();
				$tpl->prepare();
			}
//--------------------------- конец обработки действий из админ части --------------------------//
		}
	}

	function getPropertyFields() {
		GLOBAL $request_site_target, $request_sub_action;
		if ('' != $request_sub_action) {

			$tpl = $this->getTmpProperties();

			switch ($request_sub_action) {
				default:
					$tpl->newBlock('block_properties_none');
					$tpl->assign(Array(
						"MSG_No" => $this->_msg["No"],
					));
					break;
			}
			return $this->getOutputContent($tpl->getOutputContent());
		}
		return FALSE;
	}

	function getEditLink($sub_action = NULL, $block_id = NULL) {
		GLOBAL $request_name, $db, $lang, $server;
		$block_id	= (int)$block_id;
		if ($sub_action && $block_id) {
			$db->query('SELECT	property1,
								property2,
								property3,
								property4,
								property5
							FROM '.$this->table_prefix.'_pages_blocks
							WHERE id = '.$block_id);
			if ($db->nf() > 0) {
				$db->next_record();
				$arr[]	= $db->f('property1');
				$arr[]	= $db->f('property2');
				$arr[]	= $db->f('property3');
				$arr[]	= $db->f('property4');
				$arr[]	= $db->f('property5');

				switch ($sub_action) {
					case 'list':
						$link['material_url']	= '/admin.php?lang='.$lang.'&name='.$request_name.'&action=list&menu=false&category=';
						$link['material_id']	= $arr[0];
						break;

					case 'vacancies_field_list':
						$link['material_url']	= '/admin.php?lang='.$lang.'&name='.$request_name.'&action=editfield&menu=false&field=';
						$link['material_id']	= $arr[0];
						break;
				}
				return $link;
			}

			switch ($sub_action) {
				case 'list':
					$link['material_url']	= '/admin.php?lang='.$lang.'&name='.$request_name.'&action=list&menu=false&category=';
					$link['material_id']	= '';
					break;

				case 'categorys_list':
					$link['material_url']	= '/admin.php?lang='.$lang.'&name='.$request_name.'&action=editfield&menu=false&field=';
					$link['material_id']	= '';
					break;
			}
			return $link;
		}
		return FALSE;
	}

	/**
	 * Получить массив сфер деятельности
	 * @param int $selected_field Текущая сфера деятельности
	 * @return mixed
	 */
	function getFields($selected_field = '')
	{   global $CONFIG, $db, $baseurl;

		$selected_field	= (int)$selected_field;
		$db->query('SELECT * FROM '.$this->table_prefix.'_vacancies_fields ORDER BY id');
		if ($db->nf() > 0) {
			while($db->next_record()) {
				if ($db->f('id') == $selected_field) {
					$selected = ' selected';
					$this->main_title		= $db->f('name');
				} else {
					$selected = '';
				}
				$arr[]	= array('field_name'		=> $db->f('name'),
								'field_link'		=> $baseurl.'&action=field_list&field='.$db->f('id'),
								'field_edit_link'	=> $baseurl.'&action=editfield&field='.$db->f('id'),
								'cfield_del_link'	=> $baseurl.'&action=delfield&field='.$db->f('id'),
								'field'				=> $db->f('id'),
								'selected'				=> $selected,
								);
			}
			return $arr;
		}
		return FALSE;
	}

	/**
	 * Существует ли справочник
	 *
	 * @param int $id
	 * @return boolean
	 */
	function ReferenceExist($id)
	{
		global $db;
		$id = (int) $id;
		$db->query("SELECT id FROM `user_friends_reference` WHERE id=".$id);

		return $db->nf() ? true : false;
	}

	/**
	 * Добавить справочник
	 *
	 * @param name $name
	 * @return mixed false or id добавленного справочника
	 */
	function AddReference($name)
	{
		global $db;

		$name = $db->escape($name);
		if (! $name) {
			return false;
		}
		$db->query("INSERT INTO `user_friends_reference` SET name='".$name."'");

		return $db->lid();
	}

	/**
	 * Изменить название справочника
	 *
	 * @param int $id
	 * @param name $name
	 * @return boolean
	 */
	function SetReference($id, $name)
	{
		global $db;
		$id = (int) $id;
		$name = $db->escape($name);
		if (! $name) {
			return false;
		}
		$db->query("UPDATE `user_friends_reference` SET name='".$name."' WHERE id=".$id);

		return $db->$this->Errno ? false : true;
	}

	/**
	 * Удалить справочник
	 *
	 * @param int $id
	 * @return boolean
	 */
	function DelReference($id)
	{
		global $db;
		$id = (int) $id;
		$db->query("DELETE FROM `user_friends_reference` WHERE id=".$id);
		if ($db->affected_rows()) {
		    $db->query("DELETE FROM `user_friends_reference_val` WHERE ref_id=".$id);
		    return true;
		}
		return false;
	}

	/**
	 * Удалить значение из справочника
	 *
	 * @param int $id
	 * @return boolean
	 */
	function DelReferenceVal($id)
	{
		global $db;
		$id = (int) $id;
		$db->query("DELETE FROM `user_friends_reference_val` WHERE id=".$id);
		return $db->affected_rows() ? true : false;
	}

	/**
	 * Добавить значение в справочник
	 *
	 * @param int $ref_id
	 * @param string $val_name
	 * @param int $val_num
	 * @return mixed false или id добавленного справочника
	 */
	function AddReferenceVal($ref_id, $val_name, $val_num)
	{
		global $db;
		$ref_id = (int) $ref_id;
		$val_name = $db->escape($val_name);
		$val_num = (int) $val_num;
		if ($this->ReferenceExist($ref_id) || ! $val_name) {
			$db->query("INSERT INTO user_friends_reference_val SET ref_id=".$ref_id
			    .", name='".$val_name."', num=".$val_num);
			return $db->affected_rows() ? $db->lid() : false;
		}
		return false;
	}

	/**
	 * Изменить значение в справочнике
	 *
	 * @param int $id
	 * @param string $val_name
	 * @param int $val_num
	 * @return boolean
	 */
	function SetReferenceVal($id, $val_name, $val_num)
	{
		global $db;
		$id = (int) $id;
		$val_name = $db->escape($val_name);
		$val_num = (int) $val_num;
		if (! $val_name) {
			return false;
		}
		$db->query("UPDATE user_friends_reference_val SET name='".$val_name."', num=".$val_num
		    ." WHERE id=".$id);
		return $db->$this->Errno ? false : true;
	}

	/**
	 * Получить справочник
	 *
	 * @param int $id
	 * @return mixed false или массив ['id', 'name']
	 */
	function GetReference($id)
	{
	    global $db;
	    $id = (int) $id;
	    $db->query("SELECT * FROM `user_friends_reference` WHERE id=".$id);
	    if ($db->nf()) {
	        $db->next_record();
	        return array('id' => $db->f('id'), 'name' => $db->f('name'));
	    }
	    return false;
	}

	/**
	 * Получить список значений справочника
	 *
	 * @param int $id
	 * @return array
	 */
	function GetReferenceValList($id)
	{
	    global $db;
	    $id = (int) $id;
	    $ret = array();
	    $db->query("SELECT * FROM user_friends_reference_val WHERE ref_id=".$id." ORDER BY num, name");
	    while ($db->next_record()) {
	        $id = $db->f('id');
	        $ret[$id] = array('id' => $id, 'name' => $db->f('name'), 'num' => $db->f('num'));
	    }
	    return $ret;
	}

	/**
	 * Получить список справочников
	 *
	 * @return mixed Массив справочников или false
	 */
	function GetReferenceList()
	{
	    global $db;
	    return $db->getArrayOfResult("SELECT * FROM `user_friends_reference` ORDER BY name");
	}

	/**
	 * Показать сисок справочников
	 *
	 */
	function ShowRefList()
	{
		global $tpl;
		$l = $this->GetReferenceList();
		if ($l) {
		    $tpl->newBlock('block_ref_list');
		    $tpl->assign(array(
    		    "MSG_Reference"   => $this->_msg["Reference"],
    			"MSG_Del"        => $this->_msg["Del"],
    			"MSG_Ed"         => $this->_msg["Ed"],
    		));
		    foreach ($l as $key => $val) {
		        $tpl->newBlock('block_ref');
		    	$tpl->assign(array(
		    	    'id' => $val['id'],
		    	    'name' => $val['name'],
		    	    'MSG_Confirm_delete_record' => $this->_msg['Confirm_delete_record'],
		    	    'MSG_Delete' => $this->_msg['Delete'],
		    	    'MSG_Edit' => $this->_msg['Edit'],
		    	));
		    }
		}
	}

	/**
	 * Получить значение справочника
	 *
	 * @param int $id
	 * @return mixed false или массив ['id', 'name', 'num']
	 */
	function GetReferenceVal($id)
	{
	    global $db;
	    $id = (int) $id;
	    $db->query("SELECT * FROM `user_friends_reference_val` WHERE id=".$id);
	    if ($db->nf()) {
	        $db->next_record();
	        return array('id' => $db->f('id'), 'name' => $db->f('name'), 'num' => $db->f('num'));
	    }
	    return false;
	}

	/**
	 * Получить список значений справочника
	 *
	 * @param array $id_list Список id значений справочника
	 * @return mixed false OR [val_id => [id, name, num]]
	 */
	function GetReferenceVals($id_list)
	{
		global $db1;

		static $val_list = array();

		if (empty($val_list)) {
			$db1->query("SELECT * FROM `user_friends_reference_val`");
    	    while ($db1->next_record()) {
    	        $id = $db1->f('id');
    	        $val_list[$id] = array('id' => $id, 'name' => $db1->f('name'), 'num' => $db1->f('num'));
    	    }
		}

		if (!is_array($id_list) || empty($id_list)) {
	    	return false;
	    }

	    $ret = array();
	    foreach ($id_list as $key => $val) {
	        if (array_key_exists($val, $val_list)) {
	        	$ret[$val] = $val_list[$val];
	        }
	    }
	    return $ret;
	}

	/**
	 * Существует ли анкета
	 *
	 * @param int $id
	 * @return boolean
	 */
	function FormExist($id)
	{
		global $db;

		$db->query("SELECT id FROM `user_friends_form` WHERE id=".intval($id));

		return $db->nf() ? true : false;
	}

	/**
	 * Добавить/изменить анкету
	 *
	 * @param array $data
	 * @return mixed false OR id анкету
	 */
	function SetForm($data, $block_id = 0)
	{
		global $db;

		$insert = array();
		/* анкета пользователя */
		if ($data['id']) {
			$insert['id'] = (int) $data['id'];
			$form = $this->is_admin ? $this->GetForm($insert['id']) : $this->GetUserForm();
			/* редактируется только личная анкета */
			if (!$form || $form['id'] != $data['id']) {
				return false;
			}
		} else {
		    /* Не больше одной анкеты на пользователя */
		    $form = $this->is_admin ? false : $this->GetUserForm();
		    if ($form) {
		    	return false;
		    }
		}
		$insert['year'] = (int) $data['year'];
		if ($insert['year'] < $this->start_year || $insert['year'] > $this->end_year) {
			return false;
		}
		$insert['month'] = (int) $data['month'];
		if ($insert['month'] < 1 || $insert['month'] > 12) {
			return false;
		}
		$insert['day'] = (int) $data['day'];
		if ($insert['day'] < 1 || $insert['day'] > 31) {
			$insert['day'] = 0;
		}
		$insert['height'] = (int) $data['height'];
		$insert['weight'] = (int) $data['weight'];
		$insert['sex'] = My_Sql::escape($data['sex']);
		if ($insert['sex'] != $this->sex_man && $insert['sex'] != $this->sex_wom) {
			return false;
		}
		$partner = (array) $data['partner'];
		$insert['partner'] = in_array($this->sex_man, $partner) ? $this->sex_man  : '';
		$insert['partner'] .= in_array($this->sex_wom, $partner) ? ",".$this->sex_wom  : '';
		if (! $insert['partner']) {
			return false;
		}
		$insert['about'] = My_Sql::escape($data['about']);
		$insert['find'] = My_Sql::escape($data['find']);
		$insert['ref_city'] = intval($data['ref_city']);
		if (!$insert['ref_city']) {
			return false;
		}
		$insert['ref_hair'] = intval($data['ref_hair']);
		$insert['ref_figure'] = intval($data['ref_figure']);
		$insert['ref_family'] = intval($data['ref_family']);
		$insert['ref_education'] = intval($data['ref_education']);
		$insert['ref_aim'] = intval($data['ref_aim']);
		if (! $insert['id']) {
		    $insert['owner_id'] = $_SESSION["siteuser"]["id"];
		    list($insert['usr_group_id'], $insert['rights']) = $this->get_group_and_rights('friends_default_rights', $block_id);
		}

		$query = "";
		foreach ($insert as $key => $val) {
			$query .= "`".$key."`='".$val."', ";
		}

		if ($insert['id']) {
		    $db->query("UPDATE `user_friends_form` SET ".substr($query, 0, -2)." WHERE id=".$insert['id']);
		    $id = $insert['id'];
		} else {
		    $db->query("INSERT INTO `user_friends_form` SET ".substr($query, 0, -2));
		    $id = $db->lid();
		}
		$this->SetFormLangs($id, $data['langs']);
		$this->SetFormImgs($id, $data['delfoto'], $data['mainfoto']);

		return $id;
	}

	/**
	 * Получить анкету
	 *
	 * @param int $id
	 * @return mixed false или массив полей анкеты
	 */
	function GetForm($id)
	{
	    global $db;

	    $res = $db->getArrayOfResult("SELECT F.*, U.username, U.email, U.client_type"
	        ." FROM `user_friends_form` AS F, core_users AS U WHERE U.id=F.owner_id AND F.id=".intval($id)
	       .(! $this->is_admin ? " AND F.active=1" : ""));
	    if (is_array($res)) {
	        $res[0]['imgs'] = $this->GetFormImgs($res[0]['id']);
	        $res[0]['langs'] = $this->GetFormLangs($res[0]['id']);

	        return $res[0];
	    }
	    return false;
	}

	/**
	 * Удалить анкета
	 *
	 * @param int $id
	 * @return boolean
	 */
	function DelForm($id)
	{
	    global $db, $main;

	    if (!$this->test_item_rights("d", "id", "user_friends_form", $id, false)) {
	        $main->message_access_denied($this->module_name, $action);
	    }

	    $db->query("DELETE FROM `user_friends_form` WHERE id=".intval($id));
	    if ($db->affected_rows()) {
    	    $this->DelFormLangs($id);
    	    $this->DelFormImgs($id);
    	    return  true;
	    }
	    return  false;
	}

	/**
	 * Получить список анкет
	 *
	 * @param mixed $start
	 * @param mixed $rows
	 * @param array $filter
	 * @return mixed
	 */
	function GetFormList($start, $rows, $filter = array())
	{
	    global $db, $baseurl, $CONFIG;
		$fltr = array();
		$limit = '';
		if (false !== $start && false !== $rows) {
			$start = $start >= 1 ? (int) $start : 1;
			$rows = $rows > 1 ? (int) $rows : $CONFIG['friends_max_rows'];
		}
		if (isset($filter['ref_city']) && (int)$filter['ref_city']) {
			$fltr[] = "r.ref_city=".intval($filter['ref_city']);
		}
		if (! $this->is_admin) {
			$fltr[] = "r.active=1";
		}
		$total_cnt = $this->get_list_with_rights(
		    "r.*, u.username, u.email", "user_friends_form r LEFT JOIN core_users u ON u.id=owner_id", "r",
		    implode(" AND ", $fltr), "r.last_upd DESC", "",
		    $start, $rows, true
		);
		$pages_cnt = ceil($total_cnt/$rows);
		$year = date("Y");
		if ($db->nf() > 0) {
			while($db->next_record()) {
				$id		= $db->f('id');
				$is_owner = $db->f("is_owner");
				$rights = $db->f("user_rights");
				$ref_val_list = $this->GetReferenceVals(array(
				    $db->Record['ref_city'],
				    $db->Record['ref_hair'],
				    $db->Record['ref_figure'],
				    $db->Record['ref_family'],
				    $db->Record['ref_education'],
				    $db->Record['ref_aim']
				));

				$arr[] = $db->Record
				    + array(
				        'age' => $year - $db->Record['year'],
				        'ref_city_val' => $ref_val_list[$db->Record['ref_city']]['name'],
				        'ref_hair_val' => $ref_val_list[$db->Record['ref_hair']]['name'],
				        'ref_figure_val' => $ref_val_list[$db->Record['ref_figure']]['name'],
				        'ref_family_val' => $ref_val_list[$db->Record['ref_family']]['name'],
				        'ref_aim_val' => $ref_val_list[$db->Record['ref_aim']]['name'],
				        'link' => $baseurl."&action=form&id=".$db->Record['id']
				    );
			}
			return array($arr, $pages_cnt);
		}

		return false;
	}

	/**
	 * Получить общее число анкет
	 *
	 * @param boolean $only_acrive
	 * @return int
	 */
	function GetFormCount($only_acrive)
	{
		global $db;
		$db->query("SELECT COUNT(*) FROM user_friends_form".($only_acrive ? " WHERE active" : ""));
		$db->next_record();

		return $db->Record[0];
	}
	/**
	 * Показать список анкет
	 *
	 * @param mixed $start
	 * @param mixed $rows
	 * @param array $filter
	 * @param string $action
	 */
	function ShowFormList($start, $rows, $filter = array(), $action = '')
	{
		global $tpl, $main;
		$l = $this->GetFormList($start, $rows, $filter);
		if ($l) {
		    $tpl->newBlock('block_form_list');
		    $tpl->assign(array(
		        "MSG_Rights"      => $main->_msg["Rights"],
    		    "MSG_Reference"   => $this->_msg["Reference"],
    		    "MSG_Del"         => $this->_msg["Del"],
    		    "MSG_Ed"          => $this->_msg["Ed"],
    		    "MSG_Activ"       => $this->_msg["Activ"],
    		    "MSG_User"        => $this->_msg["User"],
    		    "MSG_City"        => $this->_msg["City"],
    		    "MSG_Updated"     => $this->_msg["Updated"],
    		    "MSG_Age"         => $this->_msg["Age"],
    		    "MSG_Sex"         => $this->_msg["Sex"],
    		    "MSG_Partner"     => $this->_msg["Partner"],
    		));
		    foreach ($l[0] as $key => $val) {
		        $tpl->newBlock('block_form_item');
		    	$tpl->assign($val);
		    	if ($this->is_admin) {
    		    	$this->show_block_by_rights(
    		    	    $val['id'],
    		    	    $val['active'],
    		    	    $val['is_owner'],
    		    	    $val['user_rights'],
    		    	    $baseurl,
    		    	    '_form',
    		    	    array()
    		    	);
		    	}
		    }

		    $action = $action ? $action : 'ressume';
		    foreach ($filter as $key => $val) {
		    	$action .= "&data[".$key."]=".$val;
		    }
		    if ($l[1]) {
		        $main->_show_nav_block($l[1], null, 'action='.$action, $start >= 1 ? (int) $start : 1);
		        $tpl->gotoBlock('nav');
		        $tpl->assign('MSG_Pages', $this->_msg['Pages']);
		    }
		}

	}

	/**
	 * Получить анкету пользователя.
	 * Если $user_id не указан, пользователь авторизован, возращается его анкета.
	 * Иначе false/
	 *
	 * @param int $user_id
	 * @return mixed
	 */
	function GetUserForm($user_id = 0)
	{
		global $db;
		$user_id = $user_id
		  ? (int) $user_id
		  : (isset($_SESSION["siteuser"]["id"]) ? $_SESSION["siteuser"]["id"] : 0);
	    $res = $db->getArrayOfResult("SELECT F.*, U.username, U.email"
	       ." FROM `user_friends_form` AS F LEFT JOIN `core_users` AS U ON F.owner_id=U.id"
	       ." WHERE F.owner_id=".intval($user_id));
	    if (is_array($res)) {
	        $res[0]['imgs'] = $this->GetFormImgs($res[0]['id']);
	        $res[0]['langs'] = $this->GetFormLangs($res[0]['id']);
	        return $res[0];
	    }
	    return false;
	}

	/**
	 * имеет ли пользователь анкету
	 *
	 * @param int $user_id
	 * @return boolean
	 */
	function hasUserForm($user_id)
	{
	    global $db;
		$user_id = $user_id
		  ? (int) $user_id
		  : (isset($_SESSION["siteuser"]["id"]) ? $_SESSION["siteuser"]["id"] : 0);
	    $db->query("SELECT id FROM `user_friends_form` WHERE owner_id=".intval($user_id));
	    return $db->nf() ? true : false;
	}

	/**
	 * Получить список картинок анкеты.
	 * Если пользователем не установлена "главная" фотограия,
	 * то главной становится первая фотография(по возрастанию id).
	 *
	 * @param int $form_id
	 * @return array
	 */
	function GetFormImgs($form_id)
	{
		global $db, $CONFIG;

		$db->query("SELECT * FROM `user_friends_form_img` WHERE form_id=".intval($form_id)
		    ." ORDER BY is_main DESC, id");
		$ret = array();
		$first_id = 0;
		$set_main = false;
		while ($db->next_record()) {
		    $s = $db->f('small');
		    $b = $db->f('big');
		    $id = $db->f('id');
		    if (! $first_id) {
		    	$first_id = $id;
		    }
			$ret[$id] = array(
			    'id' => $id,
			    'small' => $s,
			    'small_path' => file_exists(RP.$CONFIG['friends_img_path'].$s) ? $CONFIG['friends_img_path'].$s : '',
			    'big' => $b,
			    'big_path' => file_exists(RP.$CONFIG['friends_img_path'].$b) ? $CONFIG['friends_img_path'].$b : '',
			    'is_main' => $db->f('is_main'),
			);
			if ($ret[$id]['is_main']) {
				$set_main = true;
			}
		}
		if ($first_id && ! $set_main) {
			$ret[$first_id]['is_main'] = 1;
		}

		return $ret;
	}

	/**
	 * Получить языки анкеты
	 *
	 * @param int $form_id
	 * @return array
	 */
	function GetFormLangs($form_id)
	{
		global $db, $CONFIG;

		$db->query("SELECT V.id, V.name FROM `user_friends_form_lang` AS L"
		    ." LEFT JOIN `user_friends_reference_val` AS V ON lang_id=V.id"
		    ." WHERE form_id=".intval($form_id)
		    ." ORDER BY V.num");
		$ret = array();
		while ($db->next_record()) {
			$ret[$db->f('id')] = $db->f('name');
		}

		return $ret;
	}

	/**
	 * Удалить языки анкеты
	 *
	 * @param int $form_id
	 * @return boolean
	 */
	function DelFormLangs($form_id)
	{
		global $db, $CONFIG;

		$db->query("DELETE FROM `user_friends_form_lang` WHERE form_id=".intval($form_id));

		return $db->affected_rows() ? true : false;
	}

	/**
	 * Удалить все фото анкеты
	 *
	 * @param int $form_id
	 * @return boolean
	 */
	function DelFormImgs($form_id)
	{
		global $db, $CONFIG;

		$imgs = $this->GetFormImgs($form_id);
		if (! empty($imgs)) {
		    foreach ($imgs as $img) {
		        $this->_DelFormImg($img);
		    }
			$db->query("DELETE FROM `user_friends_form_img` WHERE form_id=".intval($form_id));
			return true;
		}

		return false;
	}

	/**
	 * Удалить фото анкеты
	 *
	 * @param array $foto ['id', 'small', 'small_path', 'big', 'big_path' ...]
	 * @return boolean
	 */
	function _DelFormImg($img)
	{
		global $db;

		if (! empty($img)/* && $img['id']*/) {
		    if ($img['small_path'] && file_exists(RP.$img['small_path'])) {
		        @unlink(RP.$img['small_path']);
		    }
		    if ($img['big_path'] && file_exists(RP.$img['big_path'])) {
		        @unlink(RP.$img['big_path']);
		    }
			/*
			$db->query("DELETE FROM `user_friends_form_img` WHERE form_id=".intval($img['id']));
			*/
			return true;
		}

		return false;
	}
	/**
	 * Установить языки анкеты
	 *
	 * @param int $form_id
	 * @return array
	 */
	function SetFormLangs($form_id, $langs)
	{
		global $db, $CONFIG;

		$this->DelFormLangs($form_id);
		if (! empty($langs)) {
			$db->query("INSERT INTO `user_friends_form_lang` SELECT ".intval($form_id).", id"
    		    ." FROM `user_friends_reference_val` WHERE ref_id=".intval($CONFIG['friends_ref_lang_id'])
    		    ." AND id IN (".implode(",", array_map('intval', $langs)).")");
    		return $db->affected_rows();
		}

		return 0;
	}

	/**
	 * Показать форму добавления/редактирования анкета пользователя
	 *
	 */
	function ShowUserForm()
	{
		global $tpl, $CONFIG, $baseurl;

		if (! $_SESSION["siteuser"]["is_authorized"]) {
			$tpl->newBlock('block_access_deny');
			return;
		}
		$tpl->newBlock('block_form');
		$tpl->assign('baseurl', $baseurl);
		$user_form = $this->GetUserForm();
		if (! $user_form) {
			$tpl->newBlock('block_add');
		} else {
		    if (!class_exists('SiteusersPrototype')) {
				require(RP."mod/siteusers/lib/class.SiteusersPrototype.php");
			}
		    $tpl->assign($user_form + array(
		        'baseurl' => $baseurl,
		        'sex_man_checked' => $this->sex_man == $user_form['sex'] ? 'checked' : '',
		        'sex_wom_checked' => $this->sex_wom == $user_form['sex'] ? 'checked' : '',
		        'partner_man_checked' => FALSE !== strpos($user_form['partner'], $this->sex_man) ? 'checked' : '',
		        'partner_wom_checked' => FALSE !== strpos($user_form['partner'], $this->sex_wom) ? 'checked' : '',
		        'user_link' => SiteusersPrototype::getUserLink($user_form['username'])
			));
			$tpl->newBlock('block_edit');
			$tpl->assign(array(
			    'baseurl' => $baseurl,
			    'last_upd' => $user_form['last_upd'],
			    'id' => $user_form['id']
			));
		}

		Module::show_select('block_ref_city', $user_form['ref_city'], 'name', $this->GetReferenceValList($CONFIG['friends_ref_city_id']));
		Module::show_select('block_ref_hair', $user_form['ref_hair'], 'name', $this->GetReferenceValList($CONFIG['friends_ref_hair_id']));
		Module::show_select('block_ref_figure', $user_form['ref_figure'], 'name', $this->GetReferenceValList($CONFIG['friends_ref_figure_id']));
		Module::show_select(
		    'block_langs',
		    !empty($user_form['langs']) ? array_keys($user_form['langs']) : '',
		    'name',
		    $this->GetReferenceValList($CONFIG['friends_ref_lang_id'])
		);
		Module::show_select('block_ref_family', $user_form['ref_family'], 'name', $this->GetReferenceValList($CONFIG['friends_ref_family_id']));
		Module::show_select('block_ref_aim', $user_form['ref_aim'], 'name', $this->GetReferenceValList($CONFIG['friends_ref_aim_id']));
		Module::show_select('block_ref_education', $user_form['ref_education'], 'name', $this->GetReferenceValList($CONFIG['friends_ref_education_id']));
		Module::show_select('block_yaer_list', $user_form['year'], 'name',$this->GetRange($CONFIG['friends_start_year'], $CONFIG['friends_end_year']));
		Module::show_select('block_month_list', $user_form['month'], 'name', $this->GetRange(1, 12));
		Module::show_select('block_day_list', $user_form['day'], 'name', $this->GetRange(1, 31));

		if ($CONFIG['friends_img_cnt'] > 0) {
			$tpl->newBlock('block_fotos');
			$this->ShowFotoList($user_form['imgs']);
			$img_cnt = $CONFIG['friends_img_cnt'] - count($user_form['imgs']);
			if ($img_cnt > 0) {
				$tpl->newBlock('block_foto_add');
				for ($i = 0; $i < $img_cnt; $i++) {
				    $tpl->newBlock('block_foto_add_item');
				}
			}
		}
	}

	/**
	 * Показать список фотографий
	 *
	 * @param array $foto_list
	 */
	function ShowFotoList($foto_list)
	{
		global $tpl;

		if (! is_array($foto_list) || empty($foto_list) ) {
			return;
		}
		$tpl->newBlock('block_foto_list');
		foreach ($foto_list as $img) {
			$tpl->newBlock('block_foto');
			$tpl->assign($img + array('is_main_checked' => $img['is_main'] ? 'checked' : ''));
		}
	}

	/**
	 * Может ли текущий пользователь добавлять/редактировать анкету
	 *
	 * @param int $form_id
	 * @return boolean
	 */
	function CheckUserForm($form_id = 0)
	{
		global $db;

		if (! $_SESSION["siteuser"]["is_authorized"]) {
			return false;
		}
		$user_form = $this->GetUserForm();
		/* Может ли пользователь редактировать анкету */
		if ($form_id && !$user_form) {
		    /* У пользоватиеля нет анкеты */
			return false;
		}
		if ($form_id && $user_form && $user_form['id'] != $form_id) {
		    /* Чужое анкета */
			return false;
		}

		/* Может ли пользователь добавлять анкета */
		if (!$form_id && $user_form) {
			/* У пользователя уже есть анкета */
			return false;
		}

		return true;
	}

	/**
	 * Показать анкету
	 */
	function ShowForm($form, $request = '', $start = 0)
	{
		global $tpl, $CONFIG, $baseurl;

		if (!$form) {
			$tpl->newBlock('block_not_exist');
			return;
		}
		if (!class_exists('SiteusersPrototype')) {
		    require(RP."mod/siteusers/lib/class.SiteusersPrototype.php");
		}
		$url_query = $start > 1 ? "&satrt=".$start : "";
		if (is_array($request)) {
			foreach ($request as $key => $val) {
			    if (is_array($val)) {
			    	foreach ($val as $v) {
			    		$url_query .= "&data[".htmlentities($key)."][]=".htmlentities($v);
			    	}
			    } else {
			        $url_query .= "&data[".htmlentities($key)."]=".htmlentities($val);
			    }
			}
		}
		$tpl->newBlock('block_form');
		$ref_val_list = $this->GetReferenceVals(array(
		    $form['ref_city'],
		    $form['ref_hair'],
		    $form['ref_figure'],
		    $form['ref_lang'],
		    $form['ref_family'],
		    $form['ref_education'],
		    $form['ref_aim']
		));
		$tpl->assign($form + array(
		    'ref_city_val' => $ref_val_list[$form['ref_city']]['name'],
		    'ref_hair_val' => $ref_val_list[$form['ref_hair']]['name'],
		    'ref_figure_val' => $ref_val_list[$form['ref_figure']]['name'],
		    'ref_lang_val' => $ref_val_list[$form['ref_lang']]['name'],
		    'ref_family_val' => $ref_val_list[$form['ref_family']]['name'],
		    'ref_aim_val' => $ref_val_list[$form['ref_aim']]['name'],
		    'month_val' => $CONFIG['friends_months'][$form['month']],
		    'sex_val' => $this->sex_man == $form['sex'] ? $this->_msg['Man']
		        : ($this->sex_wom == $form['sex'] ? $this->_msg['Wom'] : ''),
		    'age' => date("Y")-$form['year'],
		    'list_link' => $baseurl.$url_query,
		    'user_link' => SiteusersPrototype::getUserLink($form['username']),
		));

		$this->ShowPartner($form['partner']);

		foreach ($form['langs'] as $key => $val) {
			$tpl->newBlock('block_langs');
			$tpl->assign('name', $val);
		}
		$this->ShowFotoList($form['imgs']);

		if ($form['owner_id'] == $_SESSION["siteuser"]["id"]) {
			$tpl->newBlock('block_form_edit');
			$tpl->assign(array(
			    'edit_link' => $baseurl."&action=userform",
			    'del_link' => $baseurl."&action=delform&id=".$form['id']
			));
		}
	}

	function GetRange($min, $max)
	{
	    $ret = array();
		for ($i = $min; $i <= $max; $i++) {
		    $ret[$i] = array('name' => $i);
		}
		return $ret;
	}
	/**
	 * Установить фото анкеты
	 *
	 * @param int $form_id
	 * @param array $del_list Список id фотографий которые надо удалить
	 * @param int $main Id фотографии которая будет главной
	 * @return $main
	 */
	function SetFormImgs($form_id, $del_list, $mainfoto)
	{
		global $db, $CONFIG, $main;

		$imgs = $this->GetFormImgs($form_id);
		if (! empty($imgs)) {
		    /* Удаление фотографий */
		    if (is_array($del_list) && ! empty($del_list)) {
		    	$del_list = array_intersect($del_list, array_keys($imgs));
		    	foreach ($del_list as $img_id) {
		    		$this->_DelFormImg($imgs[$img_id]);
		    		unset($imgs[$img_id]);
		    		$db->query('DELETE FROM `user_friends_form_img` WHERE id='.$img_id);
		    	}
		    }
		}
		if (isset($_FILES['userimg']) && count($imgs) < $CONFIG['friends_img_cnt']) {
		    foreach ($_FILES['userimg']['tmp_name'] as $key => $tmp_name) {
    		    if (array_key_exists($_FILES['userimg']['type'][$key], $CONFIG['friends_allow_img_type'])
    		      && count($imgs) < $CONFIG['friends_img_cnt']
    		    ) {
    		        $db->query('INSERT INTO `user_friends_form_img` SET form_id='.intval($form_id).', is_main=0');
    		        $img_id = $db->lid();
    		        $big_name = $form_id."_".$img_id.".".$CONFIG['friends_allow_img_type'][$_FILES['userimg']['type'][$key]];
    		        $small_name = $form_id."_".$img_id."_s.".$CONFIG['friends_allow_img_type'][$_FILES['userimg']['type'][$key]];
    		        if (! $main->generate_image(
    		            $tmp_name,
    		            RP.$CONFIG['friends_img_path'].$big_name,
    		            $CONFIG['friends_img_width'],
    		            $CONFIG['friends_img_height'],
    		            "resize",
    		            "",
    		            "",
    		            100
    		        )) {
    		            $big_name = '';
    				}

    				if (! $main->generate_image(
    				    $tmp_name,
    				    RP.$CONFIG['friends_img_path'].$small_name,
    				    $CONFIG['friends_prvw_width'],
    				    $CONFIG['friends_prvw_height'],
    				    "resize",
    				    "",
    				    "",
    				    100
    				)) {
    				    $small_name = '';
    				}

    				if ($big_name && $small_name) {
    				    $db->query("UPDATE `user_friends_form_img` SET small='".$small_name."',"
    				        ." big='".$big_name."' WHERE id=".$img_id);
    				    $imgs[$img_id] = true;
    				} else {
    				    $db->query("DELETE FROM `user_friends_form_img` WHERE id=".$img_id);
    				    if ($big_name && file_exists(RP.$CONFIG['friends_img_path'].$big_name)) {
    				        @unlink(RP.$CONFIG['friends_img_path'].$big_name);
    				    }
    				    if ($small_name && file_exists(RP.$CONFIG['friends_img_path'].$small_name)) {
    				        @unlink(RP.$CONFIG['friends_img_path'].$small_name);
    				    }
    				}
    		    }
		    }
		}

		/**
		 * Устанавливается "главная" фотография.
		 * Если параметр $mainfoto не передан главной становится 'первая' фотография
		 */
		if (count($imgs)) {
		    if (($mainfoto && !array_key_exists($mainfoto, $imgs)) || !$mainfoto) {
    		    list($mainfoto) = each($imgs);
    		}
    		$db->query('UPDATE `user_friends_form_img` SET is_main=0 WHERE form_id='.$form_id);
    		$db->query('UPDATE `user_friends_form_img` SET is_main=1 WHERE id='.$mainfoto);
		}

		return ;
	}

	/**
	 * Показать форму поиска анкет
	 *
	 */
	function ShowSearchForm($transurl, $show_search)
	{
		global $tpl, $CONFIG;

		$tpl->newBlock('block_searchform');
		$user_form = $this->GetUserForm();
		$partner_man = $partner_wom = false;
		if ($_SESSION['friends_partner']) {
			$partner_man = FALSE !== strpos($_SESSION['friends_partner'], $this->sex_man) ? true : false;
			$partner_wom = FALSE !== strpos($_SESSION['friends_partner'], $this->sex_wom) ? true : false;
		} else if (!$show_search && $user_form) {
			$partner_man = FALSE !== strpos($user_form['partner'], $this->sex_man) ? true : false;
			$partner_wom = FALSE !== strpos($user_form['partner'], $this->sex_wom) ? true : false;
		}
		$sex_man = $sex_wom = false;
		if ($_SESSION['friends_sex']) {
			$this->sex_man == $_SESSION['friends_sex'] ? $sex_man = true : $sex_wom = false;
			$this->sex_wom == $_SESSION['friends_sex'] ? $sex_wom = true : $sex_man = false;
		} else if (!$show_search && $user_form) {
		    $this->sex_man == $user_form['sex'] ? $sex_man = true : $sex_wom = false;
			$this->sex_wom == $user_form['sex'] ? $sex_wom = true : $sex_man = false;
		}
		$tpl->assign(array(
		    'baseurl' => $transurl,
		    'form_count' => $this->GetFormCount(true),
		    'sex_man_checked' => $sex_man ? 'checked' : '',
		    'sex_wom_checked' => $sex_wom ? 'checked' : '',
		    'sex_man_selected' => $sex_man ? 'selected' : '',
		    'sex_wom_selected' => $sex_wom ? 'selected' : '',
		    'partner_man_checked' => $partner_man ? 'checked' : '',
		    'partner_wom_checked' => $partner_wom ? 'checked' : '',
		    'partner_man_selected' => $partner_man ? 'selected' : '',
		    'partner_wom_selected' => $partner_wom ? 'selected' : '',
		    'foto_checked' => $_SESSION['friends_foto'] ? 'checked' : '',
		    'onsite_checked' => $_SESSION['friends_onsite'] ? 'checked' : '',
		));
		$city = !$show_search && $user_form  ? $user_form['ref_city'] : (int) $_SESSION['friends_city'];
		Module::show_select('block_ref_city', $city, 'name', $this->GetReferenceValList($CONFIG['friends_ref_city_id']));
		Module::show_select('block_age_list', intval($_SESSION['friends_age']), 'name', $CONFIG['friends_ages']);
		if ($_SESSION["siteuser"]["is_authorized"] && $this->GetUserForm()) {
			$tpl->newBlock('block_edit_link');
		} else {
			$tpl->newBlock('block_add_link');
		}
		$tpl->assign('link', $transurl."&action=userform");
	}

	/**
	 * Вывод результата поиска
	 *
	 * @param int $start
	 * @param int $rows
	 * @param array $filter
	 */
	function ShowSearchRes($start, $rows, $filter = array())
	{
		global $tpl, $db, $CONFIG, $baseurl, $main;

		$where_form = $where = ""; /* $where_form - условия для таблицы анкет*/
		$year = date("Y");
		$start = $start >= 1 ? (int) $start : 1;
		$rows = $rows > 1 ? (int) $rows : $CONFIG['friends_max_rows'];

		if (isset($filter['sex']) && ($this->sex_man == $filter['sex'] || $this->sex_wom == $filter['sex'])) {
		    $where_form .= " AND FIND_IN_SET('".$filter['sex']."', F.partner)";
		    $_SESSION['friends_sex'] = $filter['sex'];
		} else {
		    unset($_SESSION['friends_sex']);
		}
		if (isset($filter['partner']) &&
		    (in_array($this->sex_man, $filter['partner']) || in_array($this->sex_wom, $filter['partner']))
		) {
		    $s = array();
		    if (in_array($this->sex_man, $filter['partner']) ) {
		    	$s[] = "F.sex='".$this->sex_man."'";
		    	$_SESSION['friends_partner'] = $this->sex_man;
		    }
		    if (in_array($this->sex_wom, $filter['partner']) ) {
		    	$s[] = "F.sex='".$this->sex_wom."'";
		    	$_SESSION['friends_partner'] = $this->sex_wom;
		    }
		    if (1 == count($s)) {
		        $where_form .= " AND ".$s[0]."";
		    } else {
		        $where_form .= " AND (".implode(" OR ", $s).")";
		        $_SESSION['friends_partner'] = 0;
		    }
		} else {
		    unset($_SESSION['friends_partner']);
		}
		if (isset($filter['age']) && $filter['age']) {
		    $_SESSION['friends_age'] = $filter['age'];
		    $s = explode("-", $filter['age']);
		    $min_age = (int)$s[0];
		    $max_age = (int)$s[1];
		    if ($nim_age > $max_age) {
		    	$s = $nim_age;
		    	$min_age = $max_age;
		    	$max_age = $s;
		    }
		    if ($min_age > 10 && $max_age >= $min_age) {
		    	$where_form .= " AND F.year BETWEEN ".($year-$max_age)." AND ".($year-$min_age);
		    }
		} else {
		    unset($_SESSION['friends_age']);
		}
		if (isset($filter['ref_city']) && $filter['ref_city']) {
		    $_SESSION['friends_city'] = (int)$filter['ref_city'];
		    $where_form .= " AND F.ref_city=".intval($filter['ref_city']);
		} else {
		    unset($_SESSION['friends_city']);
		}
		if (isset($filter['foto']) && $filter['foto']) {
		    $_SESSION['friends_foto'] = (int)$filter['foto'];
		    $where .= " AND I.id";
		} else {
		    unset($_SESSION['friends_foto']);
		}
		if (isset($filter['onsite']) && $filter['onsite']) {
		    $_SESSION['friends_onsite'] = (int)$filter['onsite'];
		    $where .= " AND U.onsite";
		} else {
		    unset($_SESSION['friends_onsite']);
		}
		$query = "SELECT COUNT(*) FROM `user_friends_form` AS F WHERE active".$where_form;
		$db->query($query);

		$db->next_record();
		$form_cnt = $db->Record[0];
		if (0 == $form_cnt) {
			$tpl->newBlock('block_not_found');
			return;
		}
		$pages = ceil($form_cnt/$rows);

		$query = "SELECT F.*, I.id AS img_id, I.big AS big_img, I.small AS small_img, "
		    ." U.username, U.email, U.client_type"
		    ." FROM `core_users` AS U, `user_friends_form` AS F"
		    ." LEFT JOIN `user_friends_form_img` AS I ON F.id=I.form_id AND I.is_main"
		    ." WHERE F.active AND F.owner_id=U.id".$where_form.$where." LIMIT ".($start-1)*$rows.",".$rows;
		$db->query($query);

		$tpl->newBlock('block_form_list');
		$tpl->assign(array(
		    'form_cnt' => $form_cnt,
		    'pages' => $pages,
		));
		$url_query = "";
		foreach ($filter as $key => $val) {
			if (is_array($val)) {
			    foreach ($val as $v) {
			        $url_query .= "&data[".$key."][]=".$v;
			    }
			} else {
			    $url_query .= "&data[".$key."]=".$val;
			}
		}
		while($db->next_record()) {
		    $tpl->newBlock('block_form');
		    $ref_val_list = $this->GetReferenceVals(array($db->Record['ref_city']));
		    $assign = array(
		        'link' => $baseurl."&action=form&id=".$db->Record['id'].($start > 1 ? "&start=".$start : "").$url_query,
		        'id' => $db->Record['id'],
		        'username' => $db->Record['username'],
		        'year' => $db->Record['year'],
		        'month' => $db->Record['month'],
		        'day' => $db->Record['day'],
		        'height' => $db->Record['height'],
		        'weight' => $db->Record['weight'],
		        'sex' => $db->Record['sex'],
		        'partner' => $db->Record['partner'],
		        'last_upd' => $db->Record['last_upd'],
		        'age' => $year - $db->Record['year'],
		        'ref_city_val' => $ref_val_list[$db->Record['ref_city']]['name'],
		        'sex_val' => $this->sex_man == $db->Record['sex'] ? $this->_msg['Man']
		            : ($this->sex_wom == $db->Record['sex'] ? $this->_msg['Wom'] : ''),
		    );
		    $tpl->assign($assign);
		    $this->ShowPartner($db->Record['partner']);
		    if ($db->Record['small_img'] && file_exists(RP.$CONFIG['friends_img_path'].$db->Record['small_img'])) {
		    	$tpl->newBlock('block_foto');
		    	$tpl->assign($assign + array(
		    	    'small_path' => $CONFIG['friends_img_path'].$db->Record['small_img'],
		    	    'big_path' => $CONFIG['friends_img_path'].$db->Record['big_img']));
		    } else {
		        $tpl->newBlock('block_no_foto');
		    }
		}

		if ($pages > 1) {
		    $action = 'searchres';
    		foreach ($filter as $key => $val) {
    		    $action .= "&data[".$key."]=".$val;
    		}
    		$main->_show_nav_block($pages, null, 'action='.$action, $start);
		    $tpl->gotoBlock('nav');
		}
	}

	function ShowPartner($partner)
	{
	    global $tpl;

		if (false !== strpos($partner, $this->sex_wom)
		    && false !== strpos($partner, $this->sex_man)) {
		    $tpl->newBlock('block_partner_bee');
		} else if (false !== strpos($partner, $this->sex_man)) {
		    $tpl->newBlock('block_partner_man');
		} else if (false !== strpos($partner, $this->sex_wom)) {
		    $tpl->newBlock('block_partner_wom');
		}
	}
}
?>