<?php

class GalleryPrototype extends Module {

	var $main_title;
	var $table_prefix;
	var $addition_to_path;
	var $module_name				= 'gallery';
	var $default_action				= 'list';
	var $admin_default_action		= 'list';
	var $tpl_path					= 'mod/gallery/tpl/';
	var $block_module_actions		= array();
	var $block_main_module_actions	= array();
	var $image_formats		= array('image/jpeg'	=> 'jpg',
									'image/jpg'		=> 'jpg',
									'image/pjpeg'	=> 'jpg',
									'image/gif'		=> 'gif',
									'image/x-png'	=> 'png',
									'image/png'	=> 'png',
									);
	var $action_tpl = array(
	    'clouds' => 'gallery_clouds.html',
	    'list' => 'gallery_categories.html',
	    'showctg' => 'gallery_images.html',
	    'theme' => 'gallery_theme.html',
	    'themes' => 'gallery_themes.html',
	    'tag' => 'gallery_tag.html',
	);

	function GalleryPrototype($action = '', $transurl = '', $properties = array(), $prefix = NULL, $rewrite_mod_params = NULL, $adminurl = NULL, $noadmin = false) {
		global $main, $tpl, $tpl_path, $baseurl, $cache, $lc, $CONFIG, $PAGE, $server, $lang, $permissions, $request_type, $_RESULT;

		/* Get $action, $tpl_name, $permissions */
		extract( $this->init(array(
		    'server' => $server, 'lang' => $lang, 'prefix' => $prefix,
		    'action' => $action, 'tpl_name' => $properties['tpl']
		)), EXTR_OVERWRITE);
		
		$this->block_module_actions = array(
		        'list'		=> $this->_msg["Show_photo_categories"],
		        'showctg'	=> $this->_msg["Show_photo_category"],
		        'annonce'	=> $this->_msg["Photo_annonce"],
		        'themes'	=> $this->_msg["Themes"],
		        'clouds'	=> $this->_msg["clouds"],
		        'searchform'	=> 'Форма поиска фотографий',
		);
		$this->block_main_module_actions = array(
		        'list'		=> $this->_msg["Show_photo_categories"],
		        'showctg'	=> $this->_msg["Show_photo_category"],
		        'annonce'	=> $this->_msg["Photo_annonce"],
		        'themes'	=> $this->_msg["Themes"],
		        'clouds'	=> $this->_msg["clouds"],
		);
		
		$CONFIG['gallery_img_path'] = str_replace('{SITE_PREFIX}', $this->table_prefix, $CONFIG['gallery_img_path']);

		$show_preliminary = $properties[1] > 0 ? (int) $properties[1] : (int) $CONFIG["gallery_preliminary_showing"];
		$rows = $properties[2] > 0 ? (int) $properties[2] : (int) $CONFIG["gallery_max_rows"];

        if (! class_exists('Siteusers')) {
			include(RP."mod/siteusers/lib/class.Siteusers.php");
		}
		
		if ('only_create_object' == $action) {
		    return;
		}
		
		if ($this->actionExists($action)) {
		    $this->doAction($action);
		    return;
		}
		if (! self::is_admin()) {
		    if ($_SESSION['siteuser']['id'] && in_array($action, array('editctg', 'userctgr', 'addimg', 'editimg', 'delimg', 'userctgrlist')) ) {
            	$PAGE['current_user_id'] = $_SESSION['siteuser']['id'];
            }
		    if (0 == $PAGE['field'] && $_REQUEST['user_id']
		        && in_array($action, array('list', 'userlist', 'show'))
		    ) {
		    	$PAGE['current_user_id'] = $_REQUEST['user_id'];
		    }
		    if ($PAGE['current_user_id']) {
		    	if (!class_exists('SiteusersPrototype')) {
					require(RP."mod/siteusers/lib/class.SiteusersPrototype.php");
				}
				$this->addition_to_path = array(SiteusersPrototype::getUserName($PAGE['current_user_id']) => '');
		    }
//---------------------------------- обработка действий с сайта --------------------------------//
			switch ($action) {
			  /**
			 * Форма поиска фотографий
			 */
			case "searchform":
			    global $request_q;
				$main->include_main_blocks($this->module_name.'_'.$action.'.html', 'main');
				$tpl->prepare();

				$tpl->assign(array(
				    'transurl' => $transurl,
				    'q' => htmlspecialchars($request_q)
				));
				break;
				/**
			 * Результат поиска фотографий
			 */
			case "search":
			    global $request_q, $request_start;
			    $request_start = $request_start > 1 ? (int) $request_start : 1;
				$main->include_main_blocks($this->module_name.'_'.$action.'.html', 'main');
				$tpl->prepare();
				$cnt = $this->cntFindImgs($request_q);
				if (!$cnt) {
					$tpl->newBlock('block_search_no');
					$tpl->assign(array(
    				    'q' => htmlspecialchars($request_q)
    				));
				} else {
					$tpl->newBlock('block_search');
					$tpl->assign(array(
    				    'q' => htmlspecialchars($request_q),
    				    'cnt' => $cnt
    				));
    				$img_on_page  = $CONFIG['gallery_max_rows'];
    				$this->ShowImgList($this->findImgs($request_q, $request_start, $img_on_page));
    				$main->_show_nav_block(ceil($cnt/$img_on_page), null, "action=".$action."&q=".$request_q, $request_start);
				}
				break;
			/**
			 * Нет доступа
			 */
			case "accessdeny":
				$main->include_main_blocks($this->module_name.'_'.$action.'.html', 'main');
				$tpl->prepare();
				break;
			/**
			 * Список категорий пользователя
			 */
			case "userctgrlist":
			    if (! $_SESSION["siteuser"]["id"]) {
			        header("Location: ".$baseurl."&action=accessdeny");
			    	exit;
			    }
				$main->include_main_blocks($this->module_name.'_'.$action.'.html', 'main');
				$tpl->assignInclude( "edit_form", RP.$tpl_path . $this->module_name . "_editctg.html" );
				$tpl->prepare();

				$this->show_categories($transurl, array('show_preliminary' => $show_preliminary, 'owner' => $_SESSION['siteuser']['id']));
				$tpl->newBlock('block_category');
				$tpl->assign(array(
				    'baseurl' => $baseurl
				));
				break;
			/**
			 * Удаление комментария
			 */
			case "del_comm":
			  global $request_id, $request_user_id, $db;
			    if ($_SESSION["siteuser"]["id"] == $request_user_id || $_SESSION['session_is_admin'] == 1) {
			      $db->query('DELETE FROM '.$this->table_prefix.'_gallery_comment WHERE id='.$request_id);
			      header("Location: ".$_SERVER['HTTP_REFERER']);
			    }
				break;
			/**
			 * Список категорий пользователя
			 */
			case "setuserctgr":
				global $request_data;
				if (! $_SESSION["siteuser"]["id"]) {
			        header("Location: ".$baseurl."&action=accessdeny");
			    	exit;
			    }
			    $request_data['commentable'] = isset($request_data['comment']) ? intval($request_data['comment']) : 0;
				if ($request_data['id']) {
				    $request_data['poll'] = isset($request_data['poll']) ? intval($request_data['poll']) : 0;		    
				    $request_data['del_img'] = isset($request_data['del_img']) ? 1 : 0;		    
					$this->update_category($request_data['id'], $request_data['title'], $request_data['dscr'], $request_data);
				} else {
				    $request_data['user_ctgr'] = 1;
				    $this->add_category($request_data['title'], 0, $request_data);
				}
				header("Location: ".$baseurl."&action=userctgrlist");
				break;
			/**
			 * Форма редактирования категории
			 */
			case "editctg":
			    if (! $_SESSION["siteuser"]["id"]) {
			        header("Location: ".$baseurl."&action=accessdeny");
			    	exit;
			    }
			    global $request_category;
				$main->include_main_blocks($this->module_name.'_'.$action.'.html', 'main');
				$tpl->prepare();

				$this->show_category($transurl, $request_category, '', true);
				break;
			/**
			 * Категория пользователя
			 */
			case 'userctgr':
			    $main->include_main_blocks($this->module_name.'_'.$action.'.html', 'main');
			    $tpl->assignInclude( "edit_form", $tpl_path . $this->module_name . "_editctg.html" );
				$tpl->prepare();
				global $request_start, $request_category;
				$start		= (int)$request_start; if (!$start) $start = 1;					// показывать начиная со страницы
				$category	= (int)$request_category;
				$order_by	= $CONFIG['gallery_order_by'];

				if (! $this->show_category($transurl, $category, '', true) || ! $_SESSION["siteuser"]["id"]) {
			        header("Location: ".$baseurl."&action=accessdeny");
			    	exit;
			    }
			    $filter = array(
				    'active' => 1,
				    'category' => $category,
				    'start' => $start,
				    'limit' => $rows,
				);
				$param = array(
				    'baseurl' => $baseurl,
				    'transurl' => $transurl,
				);
				$this->ShowImgList($this->getImgList($filter), $param);
				$img_cnt = $this->GetImgCnt($filter);
				$pages_cnt = ceil($img_cnt/$rows);
				if ($pages_cnt > 1) {
				    $main->_show_nav_block($pages_cnt, null, 'action='.$action.'&category='.$category, $start);
				}

				break;
			/**
			 * Форма редактирования изображения
			 */
			case "addimg":
			case "editimg":
			    global $request_category, $request_id;;
			    $main->include_main_blocks($this->module_name.'_editimg.html', 'main');
				$tpl->prepare();
			    $ctgr = $this->GetCategory($request_category);
			    if (!$ctgr || ! $ctgr['is_owner']) {
			    	header("Location: ".$baseurl."&action=accessdeny");
			    	exit;
			    }
			    $tpl->assign(array(
			        'baseurl' => $transurl,
			        'category_id' => $ctgr['id'],
			        'category_title' => $ctgr['title']
			    ));
			    $img = false;
			    if ($request_id) {
			        $img = $this->GetImage($request_id);
			    	$tpl->assign($img);
			    	$tpl->newBlock('block_img');
			    	$tpl->assign(array(
			    	    'small_image_path' => "/".$CONFIG['gallery_img_path'].$img['small_image'],
			    	    'big_image_path' =>  "/".$CONFIG['gallery_img_path'].$img['big_image'],
			    	));
			    }
			    if (isset($_GET['err'])) {
					$tpl->newBlock('err');
					$tpl->assign(array(
					    'baseurl' => $baseurl,
					    'small_image_width' => $CONFIG['gallery_small_image_width'],
					    'small_image_height' => $CONFIG['gallery_small_image_height'],
					));
				}
				$this->show_select('block_theme', $img ? $img['theme_id'] : 0, 'title', $this->GetThemeList());
				break;

			/**
			 * Добавить/редактировать изображение
			 */
			case "setimg":
			    global $request_data, $request_generate_small;

			    $ctgr = $this->GetCategory($request_data['category']);
			    if (!$ctgr || ! $ctgr['is_owner']) {
			    	header("Location: ".$baseurl."&action=accessdeny");
			    	exit;
			    }
			    $request_generate_small = 1;
			    $id = (int)$request_data['id'];
			    if ($id) {
			    	$res = $this->update_gallery_image(
			    	    1,
			            $request_data['category'],
			            $request_data['theme'],
			            $request_data['signature'],
			            $request_data['tags'],
			            $request_data['description'],
			            $request_data['set_cover'],
			            $id
			        );
			    } else {
			        $res = $this->add_gallery_image(
			            1,
			            $request_data['category'],
			            $request_data['theme'],
			            $request_data['signature'],
			            $request_data['tags'],
			            $request_data['description'],
			            $request_data['set_cover'],
			            ''
			        );
			    }
			    if ($res) {
			        header("Location: ".$baseurl."&action=userctgr&category=".$request_data['category']);
			    } else {
			        if ($id) {
			            header("Location: {$baseurl}&action=editimg&id={$id}&category={$ctgr['id']}&err");
			        } else {
			            header("Location: {$baseurl}&action=addimg&category={$ctgr['id']}&err");
			        }
			    }
				break;

			/**
			 * Удалить изображение
			 */
			case "delimg":
			    global $request_id;

			    $img = $this->GetImage($request_id);
			    if (!$img || ! $img['is_owner']) {
			    	header("Location: ".$baseurl."&action=accessdeny");
			    	exit;
			    }
			    $this->delete_gallery_image($request_id);
			    Module::go_back();
			    header("Location: ".$baseurl."&action=userctgr&category=".$img['category_id']);
			    break;

			/**
			 * Удалить категорию
			 */
			case "delctg":
			    global $request_category;

			    $ctgr = $this->GetCategory($request_category);
			    if (!$ctgr || ! $ctgr['is_owner']) {
			    	header("Location: ".$baseurl."&action=accessdeny");
			    	exit;
			    }
			    if ($this->delete_category($request_category)) @$cache->delete_cache_files();
			    Module::go_back();
			    header("Location: ".$baseurl."&action=userctgrlist");
			    break;

			case 'list':
				global $request_start, $request_category, $request_user_id;
				$start		= $request_start > 1 ? (int)$request_start : 1;					// показывать начиная со страницы
				$category	= !$PAGE['field'] && $request_category ? (int)$request_category : 0;
				
				if ($category) {
				    $where = "AND category_id = $category";
				}
				$order_by	= $CONFIG['gallery_order_by'];

				if (!$category) {
					$tpl_name = $tpl_name ? $tpl_name : $this->action_tpl[$action];
                    $main->include_main_blocks($tpl_name, 'main');
				} else {
					$main->include_main_blocks($this->module_name.'_images.html', 'main');
				}
				$tpl->prepare();

				$request_user_id = $PAGE['current_user_id'] ? $PAGE['current_user_id'] : $request_user_id;
				if (!$category) {
				    $filter =  array('show_preliminary' => $show_preliminary);
				    if ($request_user_id) {
				    	$filter['owner'] = $request_user_id;
				    }
				    $filter['active'] = 'C.active = 1';
					$this->show_categories($transurl, $filter);
				} else {
//					$this->show_categories($transurl, $category);
					$this->show_category($transurl, $category);
					$filter = array(
    				    'active' => 1,
    				    'category' => $category,
    				    'start' => $start,
    				    'limit' => $rows,
    				);
    				$param = array(
    				    'baseurl' => $baseurl,
    				    'transurl' => $transurl,
    				    'owner_id' => $request_user_id
    				);
    				$this->ShowImgList($this->getImgList($filter), $param);
    				$img_cnt = $this->GetImgCnt($filter);
    				$pages_cnt = ceil($img_cnt/$rows);
    				if ($pages_cnt > 1) {
    				    $main->_show_nav_block($pages_cnt, null, 'action='.$action.'&category='.$category, $start);
    				}
				}
				break;

			case 'userlist':
				global $request_start, $request_category, $request_user_id;
				$start		= $request_start > 1 ? (int)$request_start : 1;					// показывать начиная со страницы
				$category	= (int)$request_category;
				if ($category) $where = "AND category_id = $category";
				$order_by	= $CONFIG['gallery_order_by'];

				if (!$category) {
					$main->include_main_blocks($this->module_name.'_usercategories.html', 'main');
					$tpl->assignInclude( "edit_form", RP.$tpl_path . $this->module_name . "_editctg.html" );
				} else {
					$main->include_main_blocks($this->module_name.'_images.html', 'main');
				}
				$tpl->prepare();

				$request_user_id = $PAGE['current_user_id'] ? $PAGE['current_user_id'] : $request_user_id;
				if ($request_user_id) {
				    $filter =  array(
    				    'show_preliminary' => $show_preliminary,
    				    'owner' => $request_user_id,
    				    'active' => 'C.active = 1',
    				    'img_count' => $properties[1],
    				);
    				$this->show_categories($transurl, $filter);
    				$tpl->newBlock('block_category');
				$tpl->assign(array(
				    'baseurl' => $baseurl
				));
				}
				break;

			case "showctg":
				global $request_start, $request_category;
				$start = (int)$request_start; if (!$start) $start = 1;					// показывать начиная со страницы
				$category = $request_category > 0 ? (int)$request_category : (int)$properties[3];
				$where = $category ? "AND category_id = ".$category : "";
				$order_by = $CONFIG["gallery_order_by"];

				if (!$category) {
					$main->include_main_blocks($this->module_name."_categories.html", "main");
				} else {
					$main->include_main_blocks($this->module_name."_images.html", "main");
				}
				$tpl->prepare();
				$this->show_category($transurl, $category);
				$filter = array(
    				'active' => 1,
    				'category' => $category,
    				'start' => $start,
    				'limit' => $rows,
    			);
    			$param = array(
    				'baseurl' => $baseurl,
    				'transurl' => $transurl,
    				//'owner_id' => $request_user_id
    			);
    			$this->ShowImgList($this->getImgList($filter), $param);
    			$img_cnt = $this->GetImgCnt($filter);
    			$pages_cnt = ceil($img_cnt/$rows);
    			if ($pages_cnt > 1) {
    				$main->_show_nav_block($pages_cnt, null, 'action='.$action.'&category='.$category, $start);
    			}
				$filter =  array(
    				'active' => 'C.active = 1',
    				'excule_category' => $category,
    				'pref' => 'other_'
    			);
    			$this->show_categories($transurl, $filter);
				break;

            // Вывод записи по id
			case "show":
			  global $request_id, $request_text, $request_addcomment, $request_start, $request_user_id;
				$id = intval($request_id);
				$main->include_main_blocks($this->module_name . "_image.html", "main");
				$tpl->prepare();
				
				$img = $this->GetImage($request_id);				
				if ($img) {
				    $tpl->assign(array(
        				'baseurl' => $baseurl,
        				'transurl' => $transurl,
        				'config_small_height' => $CONFIG["gallery_small_image_height"],
        				'config_small_width' => $CONFIG["gallery_small_image_width"],
        			));
    				$filter = array(
        				'active' => 1,
        				'category' => $img['category_id'],
        			);
        			$param = array(
        				'baseurl' => $baseurl,
        				'transurl' => $transurl,
        				'selected' => $request_id,
        			);
        			$this->ShowImgList($this->getImgList($filter), $param);
				    $ctgr = $this->GetCategory($img['category_id']);
				    if ($request_user_id) {
				    	$transurl .= "&user_id=".$request_user_id;
				    }
					$this->show_gallery_image($id, $transurl, 0, 0, $request_start);
    				if ($CONFIG['gallery_count_hits']) {
    					Main::addHits($this->table_prefix."_gallery", $id);
    				}
    				if (file_exists(RP."mod/comments")) {
    				    require_once(RP."mod/comments/lib/class.CommentsPrototype.php");
    				    $comm = new CommentsPrototype('only_create_object');
    				    $comm->showPhotoComments($request_id, $CONFIG['gallery_comment_cnt']);
    				}
				}
				break;

			/**
			 * Проголосовать
			 */
			case "image_poll":
				global $request_mark, $request_gallery_image_id, $request_gallery_category_id, $request_lang, $tpl;
				$mark = intval($_REQUEST['mark']);
				$gallery_image_id = intval($_REQUEST['gallery_image_id']);
				$category_id = intval($_REQUEST['gallery_category_id']);
								
                $res = $this->poll_image($gallery_image_id, $mark);
                echo "{$mark}, {$gallery_image_id}, {$category_id}";
                if ($GLOBALS['JsHttpRequest']) {
		        	if (!$res) {
		        		$GLOBALS['_RESULT']['err'] = true;
		        	} else {
		        	    $GLOBALS['_RESULT'] = $res;
		        	}
		        	exit;
		        }

				Header("Location: ".$transurl."&action=show&category=".$category_id."&id=".$gallery_image_id."&voted=1");
				break;
			/**
			 * Вывод лидеров голосования
			 */
			case 'best_images':
				global $request_start, $request_category;
				$start		= (int)$request_start > 0 ? (int)$request_start : 1;
				$category	= (int)$request_category;
				if ($category) {
					$where = "AND category_id = $category";
				}
				$order_by	= $CONFIG['gallery_order_by'];

				if (!$category) {
					$main->include_main_blocks($this->module_name.'_categories.html', 'main');
				} else {
					$main->include_main_blocks($this->module_name.'_images.html', 'main');
				}
				$tpl->prepare();

				if (!$category) {
					$this->show_categories($transurl, array('show_preliminary' => $show_preliminary, 'is_best' => 1));
				} else {
//					$this->show_categories($transurl, $category);
					$this->show_category($transurl, $category, 1);
					$this->show_best_images($transurl, $category, $rows);
				}
				break;
			/**
			 * Обзор галлерей
			 */
			case 'annonce':
				global $request_start, $request_category;
				$main->include_main_blocks($this->module_name.'_'.$action.'.html', 'main');
				$tpl->prepare();

				$tpl->assign(array(
				    'full_cnt' => $this->GetImgCnt()
				));
				$cnt = $properties[1] ? (int) $properties[1] : 0;
				$this->ShowImgList($this->GetBestPollImgs($cnt), array(
				    'transurl' => $transurl,
				    'pref' => 'pop_'
				));
				$this->ShowImgList($this->GetBestCommentImgs($cnt), array(
				    'transurl' => $transurl,
				    'pref' => 'discus_'
				));
				$this->ShowImgList($this->GetNewImgs($cnt), array(
				    'transurl' => $transurl,
				    'pref' => 'new_'
				));

				break;
			/**
			 * Показать темы
			 */
			case 'themes':
				global $request_start, $request_category;
				$main->include_main_blocks($this->module_name.'_'.$action.'.html', 'main');
				$tpl->prepare();

				$this->ShowThemeList($transurl, true);

				break;

			case 'theme':
			    $tpl_name = $tpl_name ? $tpl_name : $this->action_tpl[$action];
                $main->include_main_blocks($tpl_name, 'main');
				$tpl->prepare();				
				global $request_id;
				$id = intval($request_id ? $request_id : $properties[3]);
				if ($id && ($theme = $this->GetTheme($id)) ) {
				    $tpl->assign(array(
				        'theme_id' => $theme['id'],
				        'theme_title' => $theme['title'],
				        'baseurl' => $baseurl,
				        'transurl' => $transurl
				    ));
				    $filter = array(
				        'active' => 1,
				        'theme' => $id
				    );
				    $param = array(
				        'baseurl' => $baseurl,
				        'transurl' => $transurl,
				    );
				    $this->ShowImgList($this->getImgList($filter), $param);
				}
				break;

			case 'tag':
			    $tpl_name = $tpl_name ? $tpl_name : $this->action_tpl[$action];
                $main->include_main_blocks($tpl_name, 'main');
				$tpl->prepare();
				
				global $request_tag;
				if ($request_tag && ($tag = $this->getTagsByNames(array($request_tag))) ) {
				    $tag = array_shift($tag);
				    $tpl->assign(array(
				        'tag_id' => $tag['id'],
				        'tag' => $tag['name'],
				        'baseurl' => $baseurl,
				        'transurl' => $transurl
				    ));
				    $filter = array(
				        'active' => 1,
				        'tag' => $request_tag
				    );
				    $param = array(
				        'baseurl' => $baseurl,
				        'transurl' => $transurl,
				    );
				    $this->ShowImgList($this->getImgList($filter), $param);
				}
				break;
				
			case 'clouds':
				$tpl_name = $tpl_name ? $tpl_name : $this->action_tpl[$action];
                $main->include_main_blocks($tpl_name, 'main');
                $tpl->prepare();
                
                $tpl->assignList('tag_', $this->getTagCloud(), array('transurl' => $transurl, 'divider' => ','));
                $tpl->assignList('theme_', $this->getThemeCloud(), array('transurl' => $transurl, 'divider' => ','));
				break;

// Default...
			default:
				if (is_object($tpl)) $tpl->prepare();
				return;
			}
//------------------------------- конец обработки действий с сайта -----------------------------//
		} else {
//------------------------------ обработка действий из админ части -----------------------------//            
			if (!isset($tpl)) $main->message_die('Не подключен класс для работы с шаблонами');

			switch ($action) {
		    case 'prp':
		    if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $request_step, $request_del_img;
				$main->include_main_blocks('_properties.html', $this->tpl_path);
				$tpl->prepare();
				$tpl->assign(Array(
					"MSG_Information"	=> $main->_msg["Information"],
					"MSG_Value"			=> $main->_msg["Value"],
					"MSG_Save"			=> $main->_msg["Save"],
					"MSG_Cancel"		=> $main->_msg["Cancel"],
				));
		        if (!$request_step || $request_step == 1) {
					$tpl->assign(array('form_action'	=> $baseurl,
									   'step'			=> 2,
									   'lang'			=> $lang,
									   'name'			=> $this->module_name,
									   'action'			=> 'prp'));
					$prp_html = $main->getModuleProperties($this->module_name);
		            $this->main_title = $this->_msg["Controls"];
				} elseif (2 == $request_step) {
				  $_POST['gallery_photo_imposition'] = $_FILES['gallery_photo_imposition']['name'] ? $_FILES['gallery_photo_imposition']['name'] : $_POST['gallery_photo_imposition_ex'];
				  if ($_FILES['gallery_photo_imposition']['name']) {
				    @unlink(RP.$CONFIG['gallery_img_path'].$_POST['gallery_photo_imposition_ex']);
				  }
				  if($request_del_img) {
				    @unlink(RP.$CONFIG['gallery_img_path'].$_POST['gallery_photo_imposition_ex']);
				    $_POST['gallery_photo_imposition'] = '';
				    $_POST['gallery_photo_imposition_ex'] = '';
				  }
				  $main->setModuleProperties($this->module_name, $_POST);
		      if ($_FILES['gallery_photo_imposition']['name']) {
		          /*
		        $size = getimagesize($_FILES['gallery_photo_imposition']['tmp_name']);
		        if($size[0] > $CONFIG['gallery_photo_imp_w'] || $size[1] > $CONFIG['gallery_photo_imp_h']) {		          
		            $ftype			= $_FILES['gallery_photo_imposition']['type'];
		          $main->generate_image(
    						$_FILES['gallery_photo_imposition']['tmp_name'],
    						RP.$CONFIG['gallery_img_path'].$_FILES['gallery_photo_imposition']['name'],
    						$CONFIG['gallery_photo_imp_w'],
    						$CONFIG['gallery_photo_imp_h'],
    						'resize',
    						$ftype
    					);
		        }	else {
		        */
		          $main->upload_file('gallery_photo_imposition', $CONFIG['files_img_max_size'], RP.$CONFIG['gallery_img_path'], '', $this->image_formats);
    				//}
		      }
					header('Location: '.$baseurl.'&action=prp&step=1');
				}
		    	break;

		    case 'block_prp':
				global $request_sub_action, $request_block_id;
		    	$arr  = $this->getEditLink($request_sub_action, $request_block_id);
		    	$cont = 'var container = document.getElementById(\'target_span\');
		    		  	 container.innerHTML = "'.$this->getPropertyFields().'";
		    		  	 material_id		  = "'.$arr['material_id'].'";
		    		  	 material_url		  = "'.$arr['material_url'].'";
		    		  	 changeAction();
		    	      	 setURL("property3");';
				header('Content-Length: '.strlen($cont));
		    	echo $cont;
		    	exit;
		    	break;

		    /**
		     * Тамы
		     */
			case 'themes':
		        if (!$permissions["e"]) {
		            $main->message_access_denied($this->module_name, $action);
		        }
				$main->include_main_blocks_2($this->module_name."_".$action.".html", $this->tpl_path);
				$tpl->prepare();
				$tpl->assign(Array(
					"MSG_Add_theme"            => $this->_msg["Add_theme"],
					"MSG_Edit_theme"           => $this->_msg["Edit_theme"],
					"MSG_Del_theme"            => $this->_msg["Del_theme"],
					"MSG_Theme"                => $this->_msg["Theme"],
					"MSG_Themes"               => $this->_msg["Themes"],
					"MSG_Name"                     => $this->_msg["Name"],
					"MSG_Delete"                   => $this->_msg["Delete"],
					"MSG_Edit"                     => $this->_msg["Edit"],
					"MSG_Confirm_delete_record"    => $this->_msg["Confirm_delete_record"],
					"MSG_Num"                      => $this->_msg["Num"],
					"MSG_Save"			=> $main->_msg["Save"],
					"MSG_Cancel"		=> $main->_msg["Cancel"],
					"MSG_Del"      		=> $main->_msg["Del"],
					"MSG_Ed"       		=> $main->_msg["Ed"],

					"baseurl"  => $baseurl
				));

				$this->ShowThemeList($baseurl);

				$this->main_title = $this->_msg["Themes"];
		    	break;

		    /**
		     * Добавить/редактировать тему
		     */
			case 'settheme':
		        if (!$permissions["e"]) {
		            $main->message_access_denied($this->module_name, $action);
		        }

		        $err = false;
		        if ($_REQUEST['id']) {
		            if (! $this->SetTheme($_REQUEST['id'], $_REQUEST['title'])) {
		                $err = true;
		            } else {
		                $ref_id = $request_id;
		            }
		        } else {
		            $ref_id =  $this->AddTheme($_REQUEST['title']);
		            if (! $ref_id) {
		                $err = true;
		            }
		        }
		        if ($GLOBALS['JsHttpRequest']) {
		        	if ($err) {
		        		$GLOBALS['_RESULT']['err'] = true;
		        	} else {
		        	    $GLOBALS['_RESULT'] = $this->GetTheme($ref_id);
		        	}
		        	exit;
		        }

		        header("Location: ".$baseurl."&action=themes");

		    	break;

		    /**
		     * Удалить тему
		     */
			case 'deltheme':
		        if (!$permissions["d"]) {
		            $main->message_access_denied($this->module_name, $action);
		        }

		        $err = $this->DelTheme($_REQUEST['id']) ? false : true;
		        if ($GLOBALS['JsHttpRequest']) {
		        	if ($err) {
		        		$GLOBALS['_RESULT']['err'] = true;
		        	} else {
		        	    $GLOBALS['_RESULT']['id'] = $_REQUEST['id'];
		        	}
		        	exit;
		        }

		        header("Location: ".$baseurl."&action=themes");

		    	break;

		    /**
		     * Получить данные по теме
		     */
			case 'gettheme':
		        if (!$permissions["r"]) {
		            $main->message_access_denied($this->module_name, $action);
		        }

		        $ref = $this->GetTheme($_REQUEST['id']);
		        $err = $ref ? false : true;
		        if ($GLOBALS['JsHttpRequest']) {
		        	if ($err) {
		        		$GLOBALS['_RESULT']['err'] = true;
		        	} else {
		        	    $GLOBALS['_RESULT'] = $ref;
		        	}
		        	exit;
		        }

		        header("Location: ".$baseurl."&action=themes");

		    	break;

			case "list":
				if (!$permissions["r"]) $main->message_access_denied($this->module_name, $action);
				$main->include_main_blocks_2($this->module_name.'_categories.html', $this->tpl_path);
    			$tpl->assignInclude('search_form', $tpl_path.'_search_form.html');
    			$tpl->prepare();
    			$tpl->assign(array(
    				"MSG_Empty_field" => $this->_msg["Empty_field"],
    				"MSG_Ed" => $this->_msg["Ed"],
    				"MSG_Activ" => $main->_msg["Activ"],
    				"MSG_Rights" => $main->_msg["Rights"],
    				"MSG_Category" => $this->_msg["Category"],
    				"MSG_Order" => $this->_msg["Order"],
    				"MSG_Del" => $this->_msg["Del"],
    				"MSG_Create_new_category" => $this->_msg["Create_new_category"],
    				"MSG_Create" => $this->_msg["Create"],
    				'_ROOT.form_search_action'	=> $baseurl.'&action=search',
    				'_ROOT.lang'				=> $lang,
    				'_ROOT.name'				=> $this->module_name,
    				'_ROOT.action'				=> 'search',
    				'_ROOT.form_action'			=> $baseurl.'&action=addctg',
    			));

    			$this->show_categories($baseurl);
    			$this->main_title	= $this->_msg["Gallery_categories"];				
				break;

// Вывод результата поиска
			case "search":
				if (!$permissions["r"]) $main->message_access_denied($this->module_name, $action);
				global $request_search, $request_category, $request_start;
				$search = strip_tags(trim($request_search));
				$main->include_main_blocks_2($this->module_name."_list.html", $this->tpl_path);
                $tpl->assignInclude('search_form', $tpl_path.'_search_form.html');
				$tpl->prepare();

				$tpl->assign(array(
					"MSG_Activ" => $this->_msg["Activ"],
					"MSG_Ed" => $this->_msg["Ed"],
					"MSG_Rights" => $main->_msg["Rights"],
					"MSG_Picture" => $this->_msg["Picture"],
					"MSG_Sign" => $this->_msg["Sign"],
					"MSG_Shows" => $this->_msg["Shows"],
					"MSG_Order" => $this->_msg["Order"],
					"MSG_Del" => $this->_msg["Del"],
					"MSG_Select_action" => $this->_msg["Select_action"],
					"MSG_Activate" => $this->_msg["Activate"],
					"MSG_Suspend" => $this->_msg["Suspend"],
					"MSG_Delete" => $this->_msg["Delete"],
					"MSG_Execute" => $this->_msg["Execute"],
					"_ROOT.form_search_action"	=> $baseurl."&action=search",
					"_ROOT.lang"				=> $lang,
					"_ROOT.name"				=> $this->module_name,
					"_ROOT.action"				=> "search",
				));


				list($category_title, $ctg_owner_id) = $this->show_category_adm($request_category, false);
				$result = $this->show_gallery_adm($request_category, $request_start, $search, $ctg_owner_id);
				if (!$result) $no_res = $this->_msg["Didnt_match_anything"];

				$tpl->assign(
					array(
						"_ROOT.form_search_action"	=> $baseurl.'&action=search',
						"_ROOT.lang"				=> $lang,
						"_ROOT.name"				=> $this->module_name,
						"_ROOT.action"				=> "search",
						"_ROOT.search"				=> $search,
						"_ROOT.search_result"		=> $this->_msg["Search_results"] . ' "'.$search.'": '.$no_res,
					)
				);

				$this->main_title = $this->_msg["Gallery_search_results"];
				break;

// Добавление записи в базу данных
			case 'add':
				if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $request_step, $request_category, $request_theme, $request_signature, $request_tags,
					$request_txt_content, $request_description, $request_set_cover,
				    $request_block_id, $request_active;

				if (!$request_step || $request_step == 1) {
					$main->include_main_blocks_2($this->module_name.'_edit.html', $this->tpl_path);
					$tpl->prepare();
					$tpl->assign(Array(
						"MSG_Enter_sign" => $this->_msg["Enter_sign"],
						"MSG_Choose_category" => $this->_msg["Choose_category"],
						"MSG_Category" => $this->_msg["Category"],
						"MSG_Select_category" => $this->_msg["Select_category"],
						"MSG_Theme" => $this->_msg["Theme"],
						"MSG_Select_theme" => $this->_msg["Select_theme"],
						"MSG_Name" => $this->_msg["Name"],
						"MSG_Description" => $this->_msg["Description"],
						"MSG_Big_picture_info" => $this->_msg["Big_picture_info"],
						"MSG_Big_picture" => $this->_msg["Big_picture"],
						"MSG_Delete" => $this->_msg["Delete"],
						"MSG_Small_picture" => $this->_msg["Small_picture"],
						"MSG_Make_from_big" => $this->_msg["Make_from_big"],
						"MSG_Video_file" => $this->_msg["Video_file"],
						"MSG_required_fields" => $this->_msg["required_fields"],
						"MSG_Save" => $this->_msg["Save"],
						"MSG_Cancel" => $this->_msg["Cancel"],
						'_ROOT.form_action'	=> $baseurl.'&action=add&step=2',
						'_ROOT.cancel_link'	=> $baseurl.'&action=showctg',
						'_ROOT.max_tags'	=> $CONFIG['gallery_max_tags_cnt'],
					));
					$nf = $this->show_categories($baseurl, array('only_editable' => 1));
					$this->show_select('block_theme', 0, 'title', $this->GetThemeList());
					if ($nf == 0) {
						header('Location: '.$baseurl.'&action=showctg');
						exit;
					}
					if (isset($_GET['err'])) {
					    $tpl->newBlock('err');
					    $tpl->assign(array(
					        'baseurl' => $baseurl,
					        'small_image_width' => $CONFIG['gallery_small_image_width'],
					        'small_image_height' => $CONFIG['gallery_small_image_height'],
					    ));
					}
					$this->main_title	= $this->_msg["Add_photo_to_gallery"];
				} else if ($request_step == 2) {
					list($allow, $ctg_rights) = $this->test_item_rights("e", "id", $this->table_prefix."_gallery_categories",
																		$request_category, false, 0, true);
					if (!$allow) $main->message_access_denied($this->module_name, $action);

					$block_id = intval(substr($request_block_id, 10));
					$lid = $this->add_gallery_image($request_active, $request_category, $request_theme, $request_signature, $request_tags, $request_txt_content, $request_set_cover, $ctg_rights, $block_id);
					if ($lid) {
						@$cache->delete_cache_files();
						$lc->add_internal_links($this->module_name, $CONFIG['gallery_table'], 'description', $lid, 'ссылка в галерее', $request_description);
						header('Location: '.$baseurl.'&action=showctg&category='.$request_category);
					} else {
						header('Location: '.$baseurl.'&action=add&category='.$request_category.'&err');
					}
					exit;
				}
				break;



// Редактирование записи
			case 'edit':
				if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $request_id, $request_category, $request_start;
				list($category_title, $ctg_owner_id) = $this->show_category_adm($request_category, false);
				if (!$this->test_item_rights("e", "id", $this->table_prefix."_gallery", $request_id, false, $ctg_owner_id))
					$main->message_access_denied($this->module_name, $action);

				$main->include_main_blocks_2($this->module_name.'_edit.html', $this->tpl_path);
				$tpl->prepare();
				$tpl->assign(Array(
					"MSG_Enter_sign" => $this->_msg["Enter_sign"],
					"MSG_Choose_category" => $this->_msg["Choose_category"],
					"MSG_Category" => $this->_msg["Category"],
					"MSG_Select_category" => $this->_msg["Select_category"],
					"MSG_Theme" => $this->_msg["Theme"],
					"MSG_Select_theme" => $this->_msg["Select_theme"],
					"MSG_Name" => $this->_msg["Name"],
					"MSG_Description" => $this->_msg["Description"],
					"MSG_Big_picture_info" => $this->_msg["Big_picture_info"],
					"MSG_Big_picture" => $this->_msg["Big_picture"],
					"MSG_Delete" => $this->_msg["Delete"],
					"MSG_Small_picture" => $this->_msg["Small_picture"],
					"MSG_Make_from_big" => $this->_msg["Make_from_big"],
					"MSG_Video_file" => $this->_msg["Video_file"],
					"MSG_required_fields" => $this->_msg["required_fields"],
					"MSG_Save" => $this->_msg["Save"],
					"MSG_Cancel" => $this->_msg["Cancel"],
					'_ROOT.form_action'	=> $baseurl.'&action=update&id='.$request_id.'&start='.$request_start,
					'_ROOT.cancel_link'	=> $baseurl.'&action=list&category='.$request_category.'&start='.$request_start,
				    'max_tags' => $CONFIG['gallery_max_tags_cnt']
				));
				if (!$this->show_gallery_image($request_id, $transurl, $request_start, 1)) {
					header('Location: '.$baseurl.'&action=list');
					exit;
				}
				$img = $this->GetImage($request_id);
				$this->show_categories($baseurl, array('selected_category' => $img['category_id'], 'only_editable' => 1));
				$this->show_select('block_theme', $img['theme_id'], 'title', $this->GetThemeList());
				if (isset($_GET['err'])) {
					$tpl->newBlock('err');
					$tpl->assign(array(
					    'baseurl' => $baseurl,
					    'small_image_width' => $CONFIG['gallery_small_image_width'],
					    'small_image_height' => $CONFIG['gallery_small_image_height'],
					));
				}
				$this->main_title	= $this->_msg["Edit_record"];
				break;

// Обновление записи
			case 'update':
				if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);

				list($category_title, $ctg_owner_id) = $this->show_category_adm($_REQUEST['category'], false);
				if (!$this->test_item_rights("e", "id", $this->table_prefix."_gallery", $_REQUEST['id'], false, $ctg_owner_id))
					$main->message_access_denied($this->module_name, $action);
					
				$res = $this->update_gallery_image($_REQUEST['active'], $_REQUEST['category'], $_REQUEST['theme'], $_REQUEST['signature'], $_REQUEST['tags'], $_REQUEST['txt_content'], $_REQUEST['set_cover'], $_REQUEST['id'], $_REQUEST['del_img']);
				if ($res) {
					@$cache->delete_cache_files();
					$lc->add_internal_links($this->module_name, $CONFIG['gallery_table'], 'description', $_REQUEST['id'], $this->_msg["Link_in_gallery"], $_REQUEST['description']);
				}
				if ($GLOBALS['JsHttpRequest']) {
		        	if (! $res) {
		        		$GLOBALS['_RESULT']['err'] = true;
		        	} else {
		        	    $GLOBALS['_RESULT'] = $this->GetImage($_REQUEST['id']);
		        	}
		        	exit;
				}
				if ($res) {
				    header('Location: '.$baseurl.'&action=showctg&category='.$_REQUEST['category'].'&start='.$_REQUEST['start']);
				} else {
				    header('Location: '.$baseurl.'&action=edit&id='.$_REQUEST['id'].'&category='.$_REQUEST['category'].'&start='.$_REQUEST['start'].'&err');
				}
				exit;
				break;

// Удаление записи
			case "del":
				if (!$permissions["d"]) $main->message_access_denied($this->module_name, $action);
				global $request_id, $request_category, $request_start;
				list($category_title, $ctg_owner_id) = $this->show_category_adm($request_category, false);
				if (!$this->test_item_rights("d", "id", $this->table_prefix."_gallery", $request_id, false, $ctg_owner_id))
					$main->message_access_denied($this->module_name, $action);

				if ($this->delete_gallery_image($request_id)) {
					@$cache->delete_cache_files();
					$lc->delete_internal_links($this->module_name, $CONFIG["gallery_table"], $request_id);
				}
				header("Location: $baseurl&action=showctg&category=$request_category&start=$request_start");
				exit;
				break;

// Отключение публикации
			case "suspend":
				if (!$permissions["p"]) $main->message_access_denied($this->module_name, $action);
				global $request_id, $request_category, $request_start;
				list($category_title, $ctg_owner_id) = $this->show_category_adm($request_category, false);
				if (!$this->test_item_rights("p", "id", $this->table_prefix."_gallery", $request_id, false, $ctg_owner_id))
					$main->message_access_denied($this->module_name, $action);

				if ($main->suspend($this->table_prefix.'_gallery', $request_id)) @$cache->delete_cache_files();
				header("Location: $baseurl&action=showctg&category=$request_category&start=$request_start");
				exit;
				break;

// Включение публикации
			case "activate":
				if (!$permissions["p"]) $main->message_access_denied($this->module_name, $action);
				global $request_id, $request_category, $request_start;
				list($category_title, $ctg_owner_id) = $this->show_category_adm($request_category, false);
				if (!$this->test_item_rights("p", "id", $this->table_prefix."_gallery", $request_id, false, $ctg_owner_id))
					$main->message_access_denied($this->module_name, $action);

				if ($main->activate($this->table_prefix.'_gallery', $request_id)) @$cache->delete_cache_files();
				header("Location: $baseurl&action=showctg&category=$request_category&start=$request_start");
				exit;
				break;


// Удалить выбранные фотографии
			case "delete_checked":
				if (!$permissions["d"]) $main->message_access_denied($this->module_name, $action);
				global $request_check, $request_category, $request_start;
				if(is_array($request_check)) {
					list($category_title, $ctg_owner_id) = $this->show_category_adm($request_category, false);
					foreach($request_check as $k => $v) {
						if ($this->test_item_rights("d", "id", $this->table_prefix."_gallery", $v, false, $ctg_owner_id)) {
							if ($this->delete_gallery_image($v)) {
								@$cache->delete_cache_files();
								$lc->delete_internal_links($this->module_name, $CONFIG["gallery_table"], $v);
							}
						}
					}
				}
				header("Location: $baseurl&action=showctg&category=$request_category&start=$request_start");
				exit;
				break;

// Отключить публикацию выбранных фотографий
			case "suspend_checked":
				if (!$permissions["p"]) $main->message_access_denied($this->module_name, $action);
				global $request_check, $request_category, $request_start;
				if(is_array($request_check)) {
					list($category_title, $ctg_owner_id) = $this->show_category_adm($request_category, false);
					foreach($request_check as $k => $v) {
						if ($this->test_item_rights("p", "id", $this->table_prefix."_gallery", $v, false, $ctg_owner_id)) {
							if ($main->suspend($this->table_prefix.'_gallery', $v)) @$cache->delete_cache_files();
						}
					}
				}
				header("Location: $baseurl&action=showctg&category=$request_category&start=$request_start");
				exit;
				break;

// Включить публикацию выбранных фотографий
			case "activate_checked":
				if (!$permissions["p"]) $main->message_access_denied($this->module_name, $action);
				global $request_check, $request_category, $request_start;
				if(is_array($request_check)) {
					list($category_title, $ctg_owner_id) = $this->show_category_adm($request_category, false);
					foreach($request_check as $k => $v) {
						if ($this->test_item_rights("p", "id", $this->table_prefix."_gallery", $v, false, $ctg_owner_id)) {
							if ($main->activate($this->table_prefix.'_gallery', $v)) @$cache->delete_cache_files();
						}
					}
				}
				header("Location: $baseurl&action=showctg&category=$request_category&start=$request_start");
				exit;
				break;


// Редактирование прав элемента галереи
			case 'editrights':
				if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $request_id, $request_category, $request_start;
				list($category_title, $ctg_owner_id) = $this->show_category_adm($request_category, false);
				if (!$this->test_item_rights("e", "id", $this->table_prefix."_gallery", $request_id, true, $ctg_owner_id))
					$main->message_access_denied($this->module_name, $action);

				if (!$this->show_rights_form($this->table_prefix."_gallery", "signature", $request_id,
											"&id=".$request_id."&category=".$request_category."&start=".$request_start, $this->_msg["Image"])) {
					header('Location: '.$baseurl.'&action=showctg&category='.$request_category.'&start='.$request_start);
				}
				if ($request_type == "JsHttpRequest") {
					require_once RP."inc/class.JsHttpRequest.php";
					$JsHttpRequest = new JsHttpRequest("utf-8");
				}
				break;

// Сохранение прав элемента галереи
			case 'saverights':
				if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $request_id, $request_category, $request_start, $request_rights;
				list($category_title, $ctg_owner_id) = $this->show_category_adm($request_category, false);
				if (!$this->test_item_rights("e", "id", $this->table_prefix."_gallery", $request_id, true, $ctg_owner_id))
					$main->message_access_denied($this->module_name, $action);

				$this->save_rights_form($this->table_prefix."_gallery", $request_id, $request_rights);
				if ($request_type == "JsHttpRequest") {
					require_once RP."inc/class.JsHttpRequest.php";
					$JsHttpRequest = new JsHttpRequest("utf-8");
					$_RESULT = array(
									"res"	=> 1,
									"id"	=> $request_id,
								);
				} else {
					header('Location: '.$baseurl.'&action=showctg&category='.$request_category.'&start='.$request_start);
				}
				exit;
				break;


// Вывод категорий
			case 'showctg':
				if (!$permissions['r']) $main->message_access_denied($this->module_name, $action);
				global $request_start, $request_category;
				$start = ($request_start) ? $request_start : 1;
				$category = ($request_category) ? $request_category : 1;
				$main->include_main_blocks_2($this->module_name.'_list.html', $this->tpl_path);
				$tpl->assignInclude('search_form', $tpl_path.'_search_form.html');
				$tpl->prepare();
				$tpl->assign(array(
					"MSG_Activ" => $this->_msg["Activ"],
					"MSG_Ed" => $this->_msg["Ed"],
					"MSG_Rights" => $main->_msg["Rights"],
					"MSG_Picture" => $this->_msg["Picture"],
					"MSG_Sign" => $this->_msg["Sign"],
					"MSG_Shows" => $this->_msg["Shows"],
					"MSG_Order" => $this->_msg["Order"],
					"MSG_Del" => $this->_msg["Del"],
					"MSG_Select_action" => $this->_msg["Select_action"],
					"MSG_Activate" => $this->_msg["Activate"],
					"MSG_Suspend" => $this->_msg["Suspend"],
					"MSG_Delete" => $this->_msg["Delete"],
					"MSG_Execute" => $this->_msg["Execute"],
					"MSG_To_comment" => $this->_msg["To_comment"],
					"_ROOT.form_search_action"	=> $baseurl."&action=search",
					"_ROOT.lang"				=> $lang,
					"_ROOT.name"				=> $this->module_name,
					"_ROOT.action"				=> "search",
				));
				list($category_title, $ctg_owner_id) = $this->show_category_adm($request_category, false);
				$pages_cnt = $this->show_gallery_adm($request_category, $request_start, "", $ctg_owner_id);
				$main->_show_nav_block($pages_cnt, null, "action=".$action."&category=".$category, $start);
				$tpl->assign(Array(
					"MSG_Pages" => $this->_msg["Pages"],
				));
				$this->main_title = ($category_title) ? $category_title : "";
    			
				break;
// Включение публикации категории
			case "cactivate":
				if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
				global $request_category;
				$this->changeLeader($request_category);

				//header("Location: $baseurl&action=assortment&id=".$request_category_id);
				header("Location: ". $_SERVER['HTTP_REFERER']);
				exit;
				break;

// Выключение публикации категории
			case "csuspend":
				if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
				global $request_category;
				$this->changeLeader($request_category);

				//header("Location: $baseurl&action=assortment&id=".$request_category_id);
				header("Location: ". $_SERVER['HTTP_REFERER']);
				exit;
				break;

// Добавить категорию
			case "addctg":
				if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
				global $request_title, $request_block_id;
				if ($this->add_category($request_title, intval(substr($request_block_id, 10)))) @$cache->delete_cache_files();
				header("Location: $baseurl&action=list");
				exit;
				break;

// Вывод категории для редактирования
			case "editctg":
				if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
				global $request_category;
				if (!$this->test_item_rights("e", "id", $this->table_prefix."_gallery_categories", $request_category))
					$main->message_access_denied($this->module_name, $action);

				$main->include_main_blocks_2($this->module_name.'_edit_category.html', $this->tpl_path);
				$tpl->prepare();
				$tpl->assign(Array(
					"MSG_Empty_field" => $this->_msg["Empty_field"],
					"MSG_Save" => $this->_msg["Save"],
					"MSG_Cancel" => $this->_msg["Cancel"],
					"_ROOT.form_action"	=>	"$baseurl&action=updatectg",
					"_ROOT.cancel_link"	=>	"$baseurl&action=showctg",
				));
				$ctgr = $this->show_category_adm($request_category);
				if (file_exists(RP."mod/comments")) {
    				require_once(RP."mod/comments/lib/class.CommentsPrototype.php");
    				$comm = new CommentsPrototype('only_create_object');
    				$comm->showCommentableForm($ctgr[2]);
    			}
				$this->main_title = $this->_msg["Edit_category"];
				break;

// Обновить категорию
			case "updatectg":
				if (!$permissions["e"]) {
				    $main->message_access_denied($this->module_name, $action);
				}
				global $request_category, $request_title, $request_dscr, $request_is_poll, $request_is_comm,
				    $request_commentable, $request_del_img, $request_active;
				
				if (!$this->test_item_rights("e", "id", $this->table_prefix."_gallery_categories", $request_category))
					$main->message_access_denied($this->module_name, $action);

                $request_is_poll = $request_is_poll ? 1 : 0;
                $data['del_img'] = $request_del_img ? 1 : 0;
                $data['poll'] = $request_is_poll;
                $data['commentable'] = $request_commentable;
                $data['active'] = (int)$request_active;
				$this->update_category($request_category, $request_title, $request_dscr, $data);
				header('Location: '.$baseurl.'&action=list');
				exit;
				break;

// Изменить проядок 
			case "ctgup":
				if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
				global $request_shift, $request_rank;
				if ($main->change_order('up', $this->table_prefix.'_gallery_categories', 'idx', $request_rank, $request_shift)) {
					@$cache->delete_cache_files();
				}
				Module::go_back();
				exit;
				break;
				
			case "ctgdown":
				if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
				global $request_shift, $request_rank;
				if ($main->change_order('down', $this->table_prefix.'_gallery_categories', 'idx', $request_rank, $request_shift)) {
					@$cache->delete_cache_files();
				}
				Module::go_back();
				exit;
				break;
				
			case "up":
				if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
				global $request_shift, $request_rank, $request_category;
				if ($main->change_order('up', $this->table_prefix.'_gallery', 'idx', $request_rank, $request_shift, "category_id=".intval($request_category)." AND ")) {
					@$cache->delete_cache_files();
				}
				Module::go_back();
				exit;
				break;
				
			case "down":
				if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
				global $request_shift, $request_rank, $request_category;
				if ($main->change_order('down', $this->table_prefix.'_gallery', 'idx', $request_rank, $request_shift, "category_id=".intval($request_category)." AND ")) {
					@$cache->delete_cache_files();
				}
				Module::go_back();
				exit;
				break;
/*
			case "ctgtop":
			case "ctgup":
			case "ctgdown":
			case "ctgbottom":
				if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
				global $request_category;
				if (!$this->test_item_rights("p", "id", $this->table_prefix."_gallery_categories", $request_category))
					$main->message_access_denied($this->module_name, $action);

				$this->move_category( $request_category, substr($action,3) ); @$cache->delete_cache_files();
				header("Location: $baseurl&action=showctg");
				exit;
				break;
*/
// Удалить категорию
			case "delctg":
				if (!$permissions["d"]) $main->message_access_denied($this->module_name, $action);
				global $request_step, $request_category;
				if (!$this->test_item_rights("d", "id", $this->table_prefix."_gallery_categories", $request_category))
					$main->message_access_denied($this->module_name, $action);

				// Удаление категории, первый шаг
				if (!$request_step || $request_step == 1) {
					$main->include_main_blocks_2($this->module_name.'_del_category.html', $this->tpl_path);
					$tpl->prepare();
					$tpl->assign(Array(
						"MSG_Category_deleting" => $this->_msg["Category_deleting"],
						"MSG_deletes_all_its_photos" => $this->_msg["deletes_all_its_photos"],
						"MSG_Confirm_delete_this_category" => $this->_msg["Confirm_delete_this_category"],
						"MSG_Delete" => $this->_msg["Delete"],
						"MSG_Cancel" => $this->_msg["Cancel"],
					));
					$tpl->assign(
						array(
							"_ROOT.form_action"	=>	"$baseurl&action=delctg&step=2&category=$request_category",
							"_ROOT.cancel_link"	=>	"$baseurl&action=showctg",
						)
					);
					$this->show_category_adm($request_category);
					$this->main_title = $this->_msg["Deleting_category"];
				// Удаление категории, шаг второй
				} else if ($request_step == 2) {
					if ($this->delete_category($request_category)) @$cache->delete_cache_files();
					header("Location: $baseurl&action=list");
					exit;
				}
				break;

// Редактирование прав категории
			case 'editctgrights':
				if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $request_category, $request_start;
				if (!$this->test_item_rights("e", "id", $this->table_prefix."_gallery_categories", $request_category, true))
					$main->message_access_denied($this->module_name, $action);

				if (!$this->show_rights_form($this->table_prefix."_gallery_categories", "title", $request_category,
											"&category=".$request_category, $this->_msg["Category"], "savectgrights")) {
					header('Location: '.$baseurl);
				}
				if ($request_type == "JsHttpRequest") {
					require_once RP."inc/class.JsHttpRequest.php";
					$JsHttpRequest = new JsHttpRequest("utf-8");
				}
				break;

// Сохранение прав категории
			case 'savectgrights':
				if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $request_category, $request_start, $request_rights, $baseurl;
				if (!$this->test_item_rights("e", "id", $this->table_prefix."_gallery_categories", $request_category, true))
					$main->message_access_denied($this->module_name, $action);

				$this->save_rights_form($this->table_prefix."_gallery_categories", $request_category, $request_rights);
				if ($request_type == "JsHttpRequest") {
					require_once RP."inc/class.JsHttpRequest.php";
					$JsHttpRequest = new JsHttpRequest("utf-8");
					$_RESULT = array(
									"res"	=> 1,
									"category"	=> $request_category,
								);
				} else {
					header('Location: '.$baseurl);
				}
				exit;
				break;
				
			case 'multiupload':
				if (!$permissions['e']) {
				    $main->message_access_denied($this->module_name, $action);
				}
				if (!$this->test_item_rights("e", "id", $this->table_prefix."_gallery_categories", $request_category, true))
					$main->message_access_denied($this->module_name, $action);

				if ($_FILES['image']['tmp_name']) {
				    $res = $this->add_gallery_image(1, $_REQUEST['category']);
				    if ($res) {
				        $ret = array(
				            'id' => $res['id'],
				            'small_img_path' => "/{$CONFIG['gallery_img_path']}{$res['small_image']}",
				            'error' => false
				        );
				    } else {
				        $ret = array('error' => "Минимальные размеры загружаемого изображения (ширина/высота): {$CONFIG['gallery_small_image_width']}х{$CONFIG['gallery_small_image_height']} пикселей.");
				    }
				    echo json_encode($ret);
				    exit;
				}
				$main->include_main_blocks_2("{$this->module_name}_{$action}.html", $this->tpl_path);
				$tpl->prepare();
				
				$tpl->assign(array(
				    'baseurl' => $baseurl,
				    'action' => $action,
				    'category' => (int)$_REQUEST['category'],
				    'sid_name' => session_name(),
				    'sid' => session_id(),
				    'max_tags' => $CONFIG['gallery_max_tags_cnt']
				));
				$this->show_select('block_theme', $img['theme_id'], 'title', $this->GetThemeList());
				
				$ctgr = $this->GetCategory($_REQUEST['category']);
				if (! $ctgr) {
				    $this->main_title = $this->_msg['multiupload'];
				    $this->show_categories($baseurl, array('only_editable' => 1));
				} else {
				    $this->main_title = "Добавить изображения в альбом - ".$ctgr['title'];
				}				
				
				break;

			case 'tag_list':
			    // Права доступа.
			    if (!$permissions["r"])
			    {
			        $main->message_access_denied($this->module_name, $action);
			    }
				$category = intval($request_category);
				$main->include_main_blocks_2($this->module_name.'_'.$action.'.html', $this->tpl_path);
				$tpl->prepare();
				$tpl->assign(array(
				    'baseurl' => $baseurl,
				    'action' => $action
				));
				$filter = array('limit' => $CONFIG['gallery_max_rows'], 'start' => $_REQUEST['start']);
				$tpl->assignList('tag_', $this->getTagList($filter), array('transurl' => $transurl, 'baseurl' => $baseurl, 'divider' => ','));
				Pager::Build($this->getTagListCnt($filter), $filter['limit'], $filter['start'], $baseurl.'&action='.$action);
				
				$this->main_title = $this->_msg['tags'];

				break;

			case 'del-tag':
				// Права доступа.
				if (!$permissions["d"]){
					$main->message_access_denied($this->module_name, $action);
				}
				global $db;
				$id = (int)$_REQUEST['id'];
				$db->del($this->table_prefix.'_tag_item', array('tag_id' => $id));
				$db->del($this->table_prefix.'_tag', array('id' => $id));
				
				Module::go_back();
				exit;

			case 'set-tag':
				// Права доступа.
				if (!$permissions["e"]){
					$main->message_access_denied($this->module_name, $action);
				}
				global $db;
				$id = (int)$_REQUEST['id'];
				if ($id && $_REQUEST['title']) {
				    $db->set($this->table_prefix.'_tag', array('name' => $_REQUEST['title']), array('id' => $id));
				}								
				
				Module::go_back();
				exit;


// Редактирование свойств блока
			case 'properties':
				if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $module_id, $request_field, $request_block_id, $title;
				$main->include_main_blocks('_block_properties.html', 'main');
				$tpl->prepare();

				if ($main->show_actions($request_field, '', $this->block_main_module_actions, $this->block_module_actions)) {
					$main->show_linked_pages($module_id, $request_field);
				}
				$tpl->assign(array(	'_ROOT.title'		=> $title,
									'_ROOT.username'	=> $_SESSION['session_login'],
									'_ROOT.password'	=> $_SESSION['session_password'],
									'_ROOT.name'		=> $this->module_name,
									'_ROOT.lang'		=> $lang,
									'_ROOT.block_id'	=> $request_block_id,
								));
				$this->main_title	= $this->_msg["Block_properties"];
				// Load JsHttpRequest backend.
				require_once RP."inc/class.JsHttpRequest.php";
				// Create main library object. You MUST specify page encoding!
				$JsHttpRequest = new JsHttpRequest("utf-8");
				break;

// Default...
			default:
				$main->include_main_blocks();
				$tpl->prepare();
			}
//--------------------------- конец обработки действий из админ части --------------------------//
		}
	}


	// функция для вывода категорий галереи в навигационном
	// подменю наравне со ссылками на страницы сайта
	// вызывается в модуле pages в функции
	// show_sub_nav_menu при формировании подменю
	function get_submenu_items_from_module() {
		global $CONFIG, $db, $baseurl, $request_category, $server, $lang;
		$category = intval($request_category); //if (!$category) return 0;
		$mod_titles_array = array(); // массив пунктов меню
		$mod_links_array = array(); // массив ссылок меню

		$query = "SELECT * FROM ".$this->table_prefix."_gallery_categories ORDER BY idx";
		$db->query($query);

		if ($db->nf() > 0) {
			while($db->next_record()) {
				$mod_titles_array[$db->f("id")] = $db->f("title");
				$mod_links_array[$db->f("id")] = "${baseurl}&action=list&category=" . $db->f("id");
			}
		}

		// mod_titles_array - массив пунктов меню,
		// mod_links_array - массив ссылок меню,
		// parent - выделенный элемент меню
		return array($mod_titles_array, $mod_links_array, $category);
	}


	// функция для вывода списка записей
	function show_gallery($transurl, $category = '', $start = 1, $rows = '', $order_by = '', $owner_id = '')
	{   GLOBAL $CONFIG, $db, $tpl, $baseurl;
	
		if ('' == $order_by) {
		    $order_by = $CONFIG["gallery_order_by"];
		}
		$rows = $rows >= 1 ? intval($rows) : $CONFIG['gallery_max_rows'];
		$category = intval($category);
		$ctg_str = ($category) ? "category_id = $category AND" : "";

		$total_cnt = $this->get_list_with_rights(
						"g.*",
						$this->table_prefix."_gallery AS g", "g",
						$ctg_str.' active = 1', "", $order_by,
						$start, $rows,
						true);
		$pages_cnt = ceil($total_cnt/$rows);
		if ($db->nf() > 0) {
			$i = 0;
			while($db->next_record()) {
				$i++;
				$small_image = $this->get_image($db->f("small_image"),
												$db->f("signature"),
												$CONFIG['gallery_img_path']);
//				$big_image = $this->get_image($db->f("big_image"), $db->f("signature"), $CONFIG["gallery_img_path"]);
                $url_suff = $owner_id ? "&user_id=".$owner_id : "";
				$tpl->newBlock("block_gallery_image");
				$img_link = $transurl."&action=show&category=".$db->f("category_id")."&id=".$db->f("id").$url_suff;
				$tpl->assign(
					array(
						'gallery_image_signature'		=>	$db->f("signature"),
						'gallery_image_description'	=>	$db->f("description"),
						'gallery_image_link'			=>	$img_link,
						'gallery_image_id'			=>	$db->f('id'),
						'gallery_idf'					=>	sprintf("%03d", $i + $start_row),
						'small_image'					=> $small_image,
						'category_id'					=> $db->f("category_id"),
						'id'          					=> $db->f("id"),
						'baseurl'          				=> $transurl.$url_suff,
//						'big_image'	=> $big_image,
						'small_image_path'	=> $db->f("small_image") && file_exists(RP.$CONFIG['gallery_img_path'].$db->Record['small_image'])
						    ? '/'.$CONFIG['gallery_img_path'].$db->Record['small_image'] : $CONFIG['gallery_no_photo'],
						'big_image_path'	=> $db->f("big_image") && file_exists(RP.$CONFIG['gallery_img_path'].$db->Record['big_image'])
						    ? '/'.$CONFIG['gallery_img_path'].$db->Record['big_image'] : $CONFIG['gallery_no_photo'],
						'big_image_watermark_path'	=>  '/img.php?img='.$db->Record['big_image'].(SITE_PREFIX != $this->table_prefix ? '&p='.$this->table_prefix : ''),
					)
				);

				if ($db->f("is_owner")) {
					$tpl->newBlock("block_gallery_image_edit");
					$tpl->assign(array(
					    'edit_link' => $transurl."&action=editimg&category=".$db->f("category_id")."&id=".$db->f("id"),
					    'del_link' => $transurl."&action=delimg&category=".$db->f("category_id")."&id=".$db->f("id"),
					));
				}

				if ($db->f("signature")) {
					$tpl->newBlock("title");
				} else {
				    $tpl->newBlock("no_title");
				}
				$tpl->assign(array(
					'gallery_image_signature' => $db->f("signature"),
					'gallery_image_link' => $img_link,
				));
					
				$tags = trim($db->f("tags"), ',');
				$tags = preg_split("/,|\s/", $tags, -1, PREG_SPLIT_NO_EMPTY);
				foreach ($tags as $key => $val) {
					$tags[$key] = array('name' => $val);
				}
				$tpl->assignList('tag_', $tags, array(
				    'baseurl' => $baseurl,
				    'transurl' => $baseurl,
					'divider' => ','
				));
				
				$poll_rate = $db->f('poll_rate');
				$voices = $db->f('voices');
				$average_rate = number_format($voices > 0 ? $poll_rate/$voices : 0, 2, ".", "");
				if ($average_rate > 0) {
				    $tpl->newBlock('rating');
				    $tpl->assign('rating', $average_rate);
				} else {
				    $tpl->newBlock('no_rating');
				    $tpl->assign('rating', 0);
				}
			}
			return $pages_cnt;
		}
		return FALSE;
	}


	// функция для вывода записи по id
	function show_gallery_image($id = "", $transurl, $start = "", $admin = 0, $start_comment = 0)
	{   global $CONFIG, $main, $db, $tpl, $server, $lang, $request_voted, $baseurl, $request_category;

	    $id = intval($id);
	    if (!$id) return 0;
		$this->get_list_with_rights(
						"g.*, GROUP_CONCAT(DISTINCT T.name ORDER BY T.name SEPARATOR ',') AS tags, c.title AS ctgr_title, c.poll as ctgr_poll, t.title AS theme_title, u.username",
						$this->table_prefix."_gallery AS g INNER JOIN {$this->table_prefix}_gallery_categories c ON g.category_id=c.id"
						." LEFT JOIN {$this->table_prefix}_gallery_themes t ON g.theme_id=t.id"
						." LEFT JOIN core_users u ON g.owner_id=u.id"
						." LEFT JOIN {$this->table_prefix}_tag_item TI ON g.id=TI.item_id"
						." LEFT JOIN {$this->table_prefix}_tag T ON TI.tag_id=T.id",
						"g",
						'g.id = '.$id.((!$admin)?' AND g.active=1':''), 'g.id'
		);
		if ($db->nf() > 0) {
			$db->next_record();

			$category_id = $db->f('category_id');
			if ($admin) {
				$signature		= htmlspecialchars($db->f('signature'));
				$description	= $db->f('description');
			} else {
				$signature		= $db->f('signature');		
				$description	= $db->f('description');
			}
			$tags = trim($db->f('tags'), ',');

			$small_image	= $this->get_image($db->f("small_image"), $signature, $CONFIG["gallery_img_path"]);
			$big_image		= $this->get_image($db->f("big_image"), $signature, $CONFIG["gallery_img_path"], '', $CONFIG['gallery_photo_imposition'] ? true : false);

			if (!$admin) {
				$tpl->newBlock("block_image");
//				$this->main_title = $db->f("ctitle");
			}

			$tpl->assign(array(
				'baseurl'					=> $baseurl,
				'text'						=> $description,
				'gallery_image_signature'	=> $signature,
				'gallery_image_tags'		=> $tags,
				'gallery_image_id'			=> $id,
				'gallery_idf'				=> sprintf("%03d", $db->f('id')),
				'small_image_exists'		=> $small_image_exists,
				'big_image_exists'			=> $big_image_exists,
				'small_image'				=> $small_image,
				'root_link' 				=> $transurl.'&action=list&category='.$category_id,
				'big_image'					=> $big_image,
				'big_image_link'			=> $link_next,
				'description'				=> $db->f('description'),
				'category_title'			=> $db->f('ctgr_title'),
				'gallery_category_id'		=> $category_id,
				'theme_title'				=> $db->f('theme_title'),
				'tags'      				=> $tags,
				'simagename'				=> $db->f('small_image'),
				'bimagename'				=> $db->f('big_image'),
				'small_image_path' => $db->Record["small_image"] && file_exists(RP.$CONFIG['gallery_img_path'].$db->Record['small_image'])
					? '/'.$CONFIG['gallery_img_path'].$db->Record['small_image'] : $CONFIG['gallery_no_photo'],
				'big_image_path'	=> $db->Record["big_image"] && file_exists(RP.$CONFIG['gallery_img_path'].$db->Record['big_image'])
					? '/'.$CONFIG['gallery_img_path'].$db->Record['big_image'] : $CONFIG['gallery_no_photo'],
				'big_image_watermark_path'	=>  $db->Record["big_image"] && file_exists(RP.$CONFIG['gallery_img_path'].$db->Record['big_image'])
					? '/img.php?img='.$db->Record['big_image'].(SITE_PREFIX != $this->table_prefix ? '&p='.$this->table_prefix : '') : $CONFIG['gallery_no_photo'],
				'original_image_path'	=> $db->Record["original_image"] && file_exists(RP.$CONFIG['gallery_img_path'].$db->Record['original_image'])
					? '/'.$CONFIG['gallery_img_path'].$db->Record['original_image'] : $CONFIG['gallery_no_photo'],
				'original_image_watermark_path'	=>  $db->Record["original_image"] && file_exists(RP.$CONFIG['gallery_img_path'].$db->Record['original_image'])
				    ? '/img.php?img='.$db->Record['original_image'].(SITE_PREFIX != $this->table_prefix ? '&p='.$this->table_prefix : '') : $CONFIG['gallery_no_photo'],
			    'active_checked' => $db->Record['active'] ? 'checked' : ''
			));
			
			if ($db->Record['original_image']) {
			    $tpl->newBlock('image');
			    $tpl->assign(array(
			        'big_image_path' => '/'.$CONFIG['gallery_img_path'].$db->Record['big_image'],
			        'small_image_path' => '/'.$CONFIG['gallery_img_path'].$db->Record['small_image'],
			        'original_image_path' => '/'.$CONFIG['gallery_img_path'].$db->Record['original_image'],
			    ));
			}
			if ($db->Record['theme_title']) {
			    $tpl->newBlock('block_theme');
			    $tpl->assign(array(
			        'baseurl' => $baseurl,
			        'theme_title' => $db->Record['theme_title'],
			        'theme_link' => $baseurl."&action=theme&id=".$db->Record['theme_id'],
			    ));
			}
			if ($description) {
			    $tpl->newBlock('block_dscr');
			    $tpl->assign(array(
			        'baseurl' => $baseurl,
			        'description' => $description,
			    ));
			}
			if ($db->Record['owner_id']) {
			    $tpl->newBlock('block_author');
			    $tpl->assign(array(
			        'baseurl' => $baseurl,
			        'login' => $db->Record['username'],
			        'link' => SiteusersPrototype::getUserLink($db->Record['username'])
			    ));
			}
			$tags = preg_split("/,|\s/", $tags, -1, PREG_SPLIT_NO_EMPTY);
			foreach ($tags as $key => $val) {
				$tags[$key] = array('name' => $val);
			}
			$tpl->assignList($pref.'img_tag_', $tags, array(
			    'baseurl' => $baseurl,
			    'transurl' => $baseurl,
				'divider' => ','
			));

			$poll_rate = $db->f('poll_rate');
			$voices = $db->f('voices');
			$average_rate = number_format($voices > 0 ? $poll_rate/$voices : 0, 2, ".", "");
			/**
			 * Голосование
			 */
			if ($db->Record['ctgr_poll']) {
				$tpl->newBlock("poll_block");
    			$tpl->assign(array(
    				'average_rate' => $average_rate,
    				'voices' => $voices
    			));

    			if (!$this->is_user_poll($id)) {
    			/*
    				if ($request_voted) {
    				    $tpl->newBlock("negative_message");
    				}
    			} else {
    			*/
        			$tpl->newBlock("poll_form");
        			$tpl->assign(array(
        			    'gallery_category_id' => $category_id,
        				'gallery_image_id' => $id,
        				'lang' => $lang,
        				'form_url' => $transurl
        			));
    			}

    			if ($request_voted) {
    				$tpl->newBlock("affirmative_message");
    			}
			}
			// Вывод ссылки на предыдущую страницу (если она существует)
			$this->get_list_with_rights(
							"g.id",
							$this->table_prefix."_gallery AS g", "g",
							'category_id = '.$category_id.' AND id < '.$id.' AND active=1',
							"", "id DESC", "0", "1");
			if($db->nf() > 0) {
				$db->next_record();
				$tpl->newBlock("previous_page");
				$tpl->assign(array(
					'page_link' => "$transurl&action=show&category=".$category_id."&id=".$db->f("id"),
				));
			}

			// Вывод ссылки на следующую страницу (если она существует)
  		    $this->get_list_with_rights(
  						"g.*",
  						$this->table_prefix."_gallery AS g", "g",
  						'category_id = '.$category_id.' AND id > '.$id.' AND active=1',
  						"", "id", "0", "1");
      		if($db->nf() > 0) {
      			$db->next_record();
      			$tpl->newBlock("next_page");
      			$tpl->assign(array(
      			   'page_link' => "$transurl&action=show&category=".$category_id."&id=".$db->f("id"),
      			));
      			$link_next = "$transurl&action=show&category=".$category_id."&id=".$db->f("id");
      		} else {
      		  $link_next = '';
      		}
      		// Вывод ссылки на следующую картинку
      		if ($link_next) {
                $tpl->newBlock("block_next_page_link");      		
      		} else {
      		    $tpl->newBlock("block_no_next_page_link");
      		}
      		$tpl->assign(array(
          		'next_image_link' => $link_next,
          		'big_image' => $big_image,
          	));
          	
          	return 1;
		}
		return 0;
	}


	// функция для вывода информации о категории по id
	function show_category($transurl, $id = '', $is_best = '', $owner = false) {
		global $CONFIG, $db, $tpl, $baseurl, $server, $lang;
		$id = (int)$id;
		if (!$id) {
			$tpl->assign(array(
				'category_link'		=> '#',
				'category_title'	=> $this->_msg["photo_list"],
			));
			return FALSE;
		}

		$this->get_list_with_rights(
				"C.*",
				$this->table_prefix."_gallery_categories AS C", "C",
				"C.id = ".$id);
		$db->next_record();
		if ($db->nf() > 0 && (!$owner || ($owner && $db->f("is_owner")))) {
			$this->main_title = htmlspecialchars($db->f("title"));
			//вывод на экран
			$tpl->newBlock('block_category');
			$tpl->assign(array(
			    'baseurl' =>	$transurl,
				'category'		=> $id,
				'id'		=> $id,
//				'category_link'	=> str_replace('?', '', $transurl),
				'category_title'	=> $this->main_title,
				'comment_checked'   => $db->f("comment") ? 'checked' : '',
				'poll_checked'   => $db->f("poll") ? 'checked' : '',
				'dscr'   => $db->f('dscr'),
				'best_images_link'    =>  $transurl.'&action=best_images&category='.$db->f('id'),
			    'active_checked' => $db->Record['active'] ? 'checked' : ''
			));
			if (!$is_best) {
				$tpl->newBlock('block_best_images');
			    $tpl->assign(array(
			        'best_images_link'    =>  $transurl.'&action=best_images&category='.$db->f('id')
			    ));
			}
			if ($db->Record['image'] && file_exists(RP.$CONFIG['gallery_img_path'].$_db['image'])) {
				$tpl->newBlock('block_ctgr_img');
				$tpl->assign(array(
				    'img_path' => '/'.$CONFIG['gallery_img_path'].$db->Record['image'],
				    'title' => $db->Record['title'],
				));
			} else {
				$tpl->newBlock('block_no_ctgr_img');
				$tpl->assign(array(
				    'title' => $db->Record['title'],
				));
			}
			return $db->f('title');
		}
		return FALSE;
	}

	// вывод списка категорий
	/**
	 * Показать список категорий
	 *
	 * @param string $transurl
	 * @param array $filter array('selected_category' => int, 'show_preliminary' => 1|0, 'is_best' => 1|0,
	 *                            'only_editable' => 1|0, 'owner' => int)
	 * @return mixed false  OR Categories count
	 */
	function show_categories($transurl, $filter = array())
	{
		global $CONFIG, $db, $tpl;

		$admin = FALSE !== strpos($_SERVER['PHP_SELF'], 'admin.php') ? 1 : 0;
		$selected_category = isset($filter['selected_category']) ? (int)$filter['selected_category'] : 0;
		$order = $admin ?'idx' : $CONFIG['gallery_order_by'];
		$clause = array();
		if ($filter['excule_category']) {
		    $clause[] = 'category_id<>'.intval($filter['excule_category']);
		}
		if ($filter['active']) {
		    $clause[] = $filter['active'];
		}
		$clause = empty($clause) ? '' : implode(' AND ', $clause);
		$this->get_list_with_rights(
		    "C.*, U.username, SUM(G.active) AS cnt",
		    $this->table_prefix."_gallery_categories AS C LEFT JOIN ".$this->table_prefix."_gallery AS G ON category_id=C.id"
		    ." LEFT JOIN core_users AS U ON C.owner_id=U.id",
		    "C", $clause, "C.id", $order
		);
		$pref = $filter['pref'] ? $filter['pref'] : '';
		if ($nf = $db->nf()) {
			$actions = array(
			    "edit"		=> "editctg",
			    "activate"	=>	array("cactivate","csuspend"),
			    "editrights"=> "editctgrights",
			    "top"		=> "ctgtop",
			    "up"		=> "ctgup",
			    "down"		=> "ctgdown",
			    "bottom"	=> "ctgbottom",
			    "delete"	=> "delctg",
			    "confirm_delete" => $this->_msg['Delete'].' ?',
			);
            while($db->next_record()){
                $_dump[] = $db->Record;
            }
            $show = false;
            $i = 0;
			foreach($_dump as $_db) {
				if ((!$admin && !$filter['owner'] && $_db['cnt'] < 1)
					|| ($filter['only_editable'] && !($_db["user_rights"] & 2))
					|| ($filter['owner'] && $filter['owner'] != $_db['owner_id'])
				) {
					continue;
				}				
				$id = $_db['id'];
				$title = $_db['title'];
				$url_suff = $filter['owner'] ? "&user_id=".$filter['owner'] : "";
				$adm_actions = $this->get_actions_by_rights($transurl."&category=".$id, $_db["active"], $_db["is_owner"], $_db["user_rights"], $actions);
				$category_link	= $transurl.'&action=showctg&category='.$id.$url_suff;
				if ($id == $selected_category) {
					$selected				= ' selected';
					$category_full_link		= $title;
					$this->addition_to_path	= $title;
					$this->main_title		= $title;
				} else {
					$selected			= '';
					$category_full_link	= '<a href="'.$category_link.'">'.$title.'</a>';
				}

				($id == $selected_category) ? $_db["question"] : "<a href=\"$poll_link\">" . $_db["question"] . "</a>";
				if (!$show) {
					$tpl->newBlock($pref.'block_categories_show');
					$show = true;
					$tpl->assign(array(
					"MSG_Activ" => $this->_msg["Activ"],
					"MSG_Ed" => $this->_msg["Ed"],
					"MSG_Rights" => $GLOBALS['main']->_msg["Rights"],
					"MSG_Order" => $this->_msg["Order"],
					"MSG_Del" => $this->_msg["Del"],
					"MSG_Category" => $this->_msg["Category"]));

					if ($filter['owner'] && $filter['owner']==$_SESSION['siteuser']['id']) {
    					$tpl->newBlock($pref."block_edit");
    					$tpl->assign(array(
    			    	    'add_link'    =>  $transurl.'&action=setuserctgr',
    			    	    'baseurl'    =>  $transurl,
    					));
    				}
				}
				$tpl->newBlock($pref."block_categories");
				$tpl->assign(array(
					"MSG_Category_ID" => $this->_msg["Category_ID"],
					"MSG_Begin" => $this->_msg["Begin"],
					"MSG_Up" => $this->_msg["Up"],
					"MSG_Down" => $this->_msg["Down"],
					"MSG_End" => $this->_msg["End"],
					"is_first" => 1 == ++$i ? 1 : 0,
					"is_last" => $nf == $i ? 1 : 0,
					"img_up" => 1 == $i ? 'ico_ligrup.gif' : 'ico_listup.gif',
					"img_down" => $nf == $i ? 'ico_ligrdw.gif' : 'ico_listdw.gif',
					"up_link" => "{$transurl}&action=ctgup&category={$id}&rank={$_db['idx']}",
					"down_link" => "{$transurl}&action=ctgdown&category={$id}&rank={$_db['idx']}",
					'id' =>	$id,
					'idx' =>	$_db['idx'],
					'category_title'		=>	$title,
					//'category_link'		=>	($admin ? $category_link : '<a href="'.$category_link.'" class="more"><em>" . $this->_msg["All_photos"] . "</em>&nbsp;&nbsp;<img src="/i/arr01.gif" alt="Все фото" title=""></a>'),
					'category_link'		=>	$category_link,
					'userctgr_link'		=>	$transurl.'&action=userctgr&category='.$id,
					'category_full_link'	=>	$category_full_link,
					'category_edit_action'=>	$adm_actions["edit_action"],
					'change_status_action'	=>	$adm_actions["change_status_action"],
					'category_edit_rights_action'	=>	$adm_actions["edit_rights_action"],
					'category_top_action'	=>	$adm_actions["top_action"],
					'category_up_action'	=>	$adm_actions["up_action"],
					'category_down_action'=>	$adm_actions["down_action"],
					'category_bottom_action'=>	$adm_actions["bottom_action"],
					'category_del_action'	=>	$adm_actions["delete_action"],
					'category'			=>	$id,
					'selected'			=>	$selected,
					'img_count'			=>	intval($_db['cnt']),
					'baseurl'			=>	$transurl,
					'siteusername'		=>  $_db['username'],
					'dscr'		=>  $_db['dscr'],
					'category_description'		=>  $_db['dscr'],
				));
				if ($_db['is_owner']) {
					$tpl->newBlock($pref."block_categories_edit");
					$tpl->assign(array(
			    	    'edit_link'    =>  $transurl.'&action=editctg&category='.$_db['id'],
			    	    'del_link'    =>  $transurl.'&action=delctg&category='.$_db['id'],
			    	    'add_img_link'    =>  $transurl.'&action=addimg&category='.$_db['id'],
					));
				}
				if (!$filter['is_best']) {
					$tpl->newBlock($pref.'block_best_images');
			    	$tpl->assign(array(
			    	    'best_images_link'    =>  $transurl.'&action=best_images&category='.$_db['id'].$url_suff
					));
				}
				if ($_db['image'] && file_exists(RP.$CONFIG['gallery_img_path'].$_db['image'])) {
				    $tpl->newBlock($pref.'block_img');
				    $tpl->assign(array(
				        'img_path' => '/'.$CONFIG['gallery_img_path'].$_db['image'],
				        'title' => $_db['title'],
				        'category_link' => $category_link,
				        'userctgr_link'		=>	$transurl.'&action=userctgr&category='.$id,
				    ));
				} else {
				    $tpl->newBlock($pref.'block_no_img');
				    $tpl->assign(array(
				        'title' => $_db['title'],
				        'category_link' => $category_link,
				        'userctgr_link'		=>	$transurl.'&action=userctgr&category='.$id,
				    ));
				}
				if (!$admin && $filter['show_preliminary']) {
				    $_filter = array(
        				'active' => 1,
        				'category' =>  $_db["id"],
        				'start' => 1,
        				'limit' => $filter['show_preliminary'],
        			);
        			$param = array(
        				'baseurl' => $baseurl,
        				'transurl' => $transurl,
        				'owner_id' => $filter['owner']
        			);
        			$this->ShowImgList($this->getImgList($_filter), $param);
				}
				$tpl->gotoBlock("_ROOT");
			}
			return sizeof($_db);
		}
		return FALSE;
	}

	// получение списка категорий
	function getCategories($filter = false) {
		global $CONFIG, $db, $tpl, $server, $lang;

		$where = "";
		if (isset($filter['owner']) && $filter['owner']) {
			$where = " C.owner_id=".intval($filter['owner']);
		}
		$this->get_list_with_rights(
				"C.*",
				$this->table_prefix."_gallery_categories AS C", "C",
				$where, "", "idx");
		if ($db->nf() > 0) {
			for ($i = 0; $i < $db->nf(); $i++) {
				$db->next_record();
				$array[$i]['ctg_id']	= $db->f('id');
				$array[$i]['ctg_title']	= $db->f('title');
				$array[$i]['selected']	= (isset($filter['selected_category']) && $db->f('id') == $filter['selected_category'] ? ' selected' : '');
			}
			return $array;
		}
		return FALSE;
	}


	function get_image($image = '', $alt = '', $path = '', $no_image = '', $type_img = false) {
		$alt	= strip_tags($alt);
		if ($image && file_exists($path.$image)) {
			#$img_path	= $path.$image;
			$img_path	= $type_img
			    ? 'img.php?img='.$image.(SITE_PREFIX != $this->table_prefix ? '&p='.$this->table_prefix : '')
			    : $path.$image;
			$image		= '<img src="/'.$img_path.'" alt="'.$alt.'">';
		} else if ($no_image && file_exists($no_image)) {
			$image		= '<img src="/'.$no_image.'" alt="'.$alt.'">';
		} else {
			$image		= '';
		}
		return $image;
	}

	/**
	* Проголосовать за изображение
	* @param int	$gallery_image_id	Id изображения
	* @param int	$mark	Оценка
	* @return int	1 - голос засчитан, 0 - уже голосовал
	*/
	function poll_image($gallery_image_id, $mark)
	{
		global $CONFIG, $db, $tpl, $server, $lang;

		if (!$this->is_user_poll($gallery_image_id)){
			setcookie("image_id[".$gallery_image_id."]", 1, time()+60*60*24);
			$db->query("UPDATE ".$this->table_prefix."_gallery SET"
			    ." poll_rate = poll_rate + ".$mark
			    .", voices = voices + 1, last_poll_date=NOW() WHERE id = '".$gallery_image_id."'");
			$db->query("SELECT poll_rate, voices FROM ".$this->table_prefix."_gallery WHERE id = '".$gallery_image_id."'");
			$db->next();
			$db->Record['rating'] = number_format($db->Record['voices'] > 0 ? $db->Record['poll_rate']/$db->Record['voices'] : 0, 2, ".", "");
			return $db->Record;
		} else{
			return 0;
		}
	}

	/**
	* Проверяет, голосовал ли пользователь
	* @param int	$gallery_image_id	Id изображения
	* @return boolean
	*/
	function is_user_poll($gallery_image_id)
	{
		return isset($_COOKIE['image_id'][$gallery_image_id]) ? TRUE : FALSE;
	}

	/**
	* Вывод лидеров рейтинга
	* @param string	$transurl
	* @param int	$category	Id категории
	* @param int	$cnt	Кол-во изображений
	* @return boolean
	*/
	function show_best_images($transurl, $category = '', $cnt)
	{
		GLOBAL $CONFIG, $db, $db2, $tpl, $baseurl, $server, $lang;
		$order_by = $CONFIG["gallery_order_by"];
		$cnt = intval($cnt);
		$category = intval($category);
		$ctg_str = ($category) ? "category_id = $category AND" : "";

		$this->get_list_with_rights(
				"g.*, IF(voices, poll_rate/voices, 0) AS rate",
				$this->table_prefix."_gallery AS g", "g",
				$ctg_str." active = 1", "", "rate DESC", 0, $cnt);
		if ($db->nf() > 0) {
			$i = 0;
			while($db->next_record()) {
				$i++;
				$small_image = $this->get_image($db->f("small_image"),
												$db->f("signature"),
												$CONFIG['gallery_img_path']);
//				$big_image = $this->get_image($db->f("big_image"), $db->f("signature"), $CONFIG["gallery_img_path"]);

				$tpl->newBlock("block_gallery_image");
				$tpl->assign(
					array(
						'gallery_image_signature'		=>	$db->f("signature"),
						'gallery_image_description'   	=>	$db->f("description"),
						'gallery_image_link'			=>	"$transurl&action=show&category=".$db->f("category_id")."&id=".$db->f("id"),
						'gallery_image_id'    			=>	$db->f('id'),
						'gallery_idf'					=>	sprintf("%03d", $i + $start_row),
						'small_image'					=> $small_image,
//						'big_image'	=> $big_image,
					)
				);
			}
			return TRUE;
		}
		return FALSE;
	}

	/**
	* Function try to move item in list
	* $id - id to be moved
	* $act - type of moving
	* $table - table name
	* $parentName - name of parent field (if exist)
	* $parentId - parent id (if exist)
	* $idxName - name of index field
	* $desc - DESC flag
	*/
	function MoveIdxTUDB( $id, $act, $table, $parentName = '', $parentId = 0, $idxName = 'idx', $desc = '' ) {
		GLOBAL $db;
		if ( $parentName && $parentId ) {
			$parentCond = $parentName."=".$parentId;
			if ( ( $act != 'bottom' && $desc != 'DESC' )
			  || ( $act != 'top' && $desc == 'DESC' ) )
				$parentCond .= " and ";
		} else
			$parentCond = '';
		if ( $desc == 'DESC' ) {
			switch ( $act ) {
			case 'bottom':
				$act = 'top';
				break;
			case 'top':
				$act = 'bottom';
				break;
			case 'down':
				$act = 'up';
				break;
			case 'up':
				$act = 'down';
				break;
			}
		}
		switch ( $act ) {
		case 'bottom': // move on bottom
			$query = "select max(".$idxName.") as max_idx from ".$table;
			if ( $parentCond )
				$query .= " where ".$parentCond;
			$db->query($query);
			$db->next_record();
			$idx = $db->f('max_idx') + 1;
			$query = "update ".$table." set ".$idxName."=".$idx." where id=".$id;
			$db->query($query);
			break;
		case 'top': // move on top
			$query = "update ".$table." set ".$idxName."=1 where id=".$id;
			$db->query($query);
			$query = "update ".$table." set ".$idxName."=".$idxName."+1 where ".$parentCond." id!=".$id;
			$db->query($query);
			break;
		case 'down': // move down
		case 'up': // move down
			$query = "select ".$idxName." from ".$table." where id=".$id;
			$db->query($query);
			$db->next_record();
			$idx = $db->f($idxName);
			$query = "select id,".$idxName." from ".$table
				." where ".$parentCond
				.$idxName.(($act=='up')?"<":">").$idx
				." order by ".$idxName.(($act=='up')?" DESC":"")
				." limit 1";
			$db->query($query);
			if ($db->next_record()) {
				$id1 = $db->f('id');  $idx1 = $db->f($idxName);
				$query = "update ".$table." set ".$idxName."=".$idx1." where id=".$id;
				$db->query($query);
				$query = "update ".$table." set ".$idxName."=".$idx." where id=".$id1;
				$db->query($query);
			}
			break;
		}
	} // function MoveIdxTUDB()

	/**
	* Function try to move category item in list
	* $id - id to be moved
	* $act - type of moving
	*/
	function move_category( $id, $act ) {
		GLOBAL $CONFIG;
		$desc = ( $CONFIG['gallery_admin_order_by'] == 'idx DESC' ) ? 'DESC' : '';
		$this->MoveIdxTUDB( $id, $act, $this->table_prefix."_gallery_categories", '', 0, "idx", $desc);
	} // function move_category()

	/**
	* Function try to move gallery image in list
	* $id - id to be moved
	* $act - type of moving
	* $parentId - item parent id to be moved
	*/
	function move_gallery_image( $id, $act, $parentId ) {
		GLOBAL $CONFIG;
		$desc = ( $CONFIG['gallery_admin_order_by'] == 'idx DESC' ) ? 'DESC' : '';
		$this->MoveIdxTUDB( $id, $act, $this->table_prefix."_gallery", "category_id", $parentId, "idx", $desc);
	} // function move_gallery_image()

	function getPropertyFields() {
		GLOBAL $request_site_target, $request_sub_action;
		if ('' != $request_sub_action) {
			$tpl = $this->getTmpProperties();

			switch ($request_sub_action) {
				case 'showctg':
					$tpl->newBlock('block_properties');
					$tpl->newBlock('block_properties_showctg');
					$tpl->assign(Array(
						"MSG_Category" => $this->_msg["Category"],
						"MSG_Select" => $this->_msg["Select"],
						"MSG_Images_per_page" => $this->_msg["Images_per_page"],
					));
					$list = $this->getCategories();
					abo_str_array_crop($list);
					$tpl->assign_array('block_select_categories', $list);
					$tpl->newBlock('block_page_edit');
					$tpl->assign(Array(
						"MSG_Goto_edit" => $this->_msg["Goto_edit"],
						"site_target" => $request_site_target,
					));
					break;

				case 'userlist':
				case 'list':
					$tpl->newBlock('block_properties');
					$tpl->newBlock('block_properties_list');
					$tpl->assign(Array(
						"MSG_Images_per_list" => $this->_msg["Images_per_list"],
						"MSG_Images_per_page" => $this->_msg["Images_per_page"],
					));
					$tpl->newBlock('block_page_edit');
					$tpl->assign(Array(
						"MSG_Goto_edit" => $this->_msg["Goto_edit"],
						"site_target" => $request_site_target,
					));
					break;

				case 'annonce':
					$tpl->newBlock('block_properties');
					$tpl->newBlock('block_properties_list');
					$tpl->assign(Array(
						"MSG_Images_per_list" => $this->_msg["Images_per_list"],
						"MSG_Images_per_page" => $this->_msg["Images_per_page"],
					));
					break;

				case 'theme':
					$tpl->newBlock('block_properties');
					$tpl->newBlock('block_theme_list');
					foreach ($this->GetThemes() as $key=>$val) {
      					$tpl->newBlock('block_select_theme');
    					  $tpl->assign(Array(
      					  'thm_id' => $key,
      					  'thm_title' => abo_str_crop($val),
      					));
					}
					break;

				case 'clouds':
					$tpl->newBlock('block_properties');
					$tpl->newBlock('block_clouds');
					break;

				default:
					$tpl->newBlock('block_properties_none');
					$tpl->assign(Array(
						"MSG_No" => $this->_msg["No"],
					));
					break;
			}
			return $this->getOutputContent($tpl->getOutputContent());
		}
		return FALSE;
	}

	function getEditLink($sub_action = NULL, $block_id = NULL) {
		GLOBAL $request_name, $db, $lang, $server;
		$block_id	= (int)$block_id;
		if ($sub_action && $block_id) {
			$db->query('SELECT	property1,
								property2,
								property3,
								property4,
								property5
							FROM '.$this->table_prefix.'_pages_blocks
							WHERE id = '.$block_id);
			if ($db->nf() > 0) {
				$db->next_record();
				$arr[]	= $db->f('property1');
				$arr[]	= $db->f('property2');
				$arr[]	= $db->f('property3');
				$arr[]	= $db->f('property4');
				$arr[]	= $db->f('property5');

				switch ($sub_action) {
					case 'showctg':
						$link['material_url']	= '/admin.php?lang='.$lang.'&name='.$request_name.'&action=list&menu=false&category=';
						$link['material_id']	= $arr[0];
						break;
				}
				return $link;
			}

			switch ($sub_action) {
					case 'showctg':
						$link['material_url']	= '/admin.php?lang='.$lang.'&name='.$request_name.'&action=list&menu=false&category=';
						$link['material_id']	= '';
						break;
			}
			return $link;
		}
		return FALSE;
	}

	function add_gallery_image($active, $category, $theme = 0, $signature = '', $tags = '', $description = '', $set_cover = 0, $item_rights = 0, $block_id = 0)
	{   GLOBAL $CONFIG, $db;
		    
	    $ret = false;
    	$category	= (int)$category;
		if ($category) {
		    $upload_res = $this->upload_gallery_images();
		    if ($upload_res) {
    		    $big_imagename = $upload_res['big_image'];
    		    $small_imagename = $upload_res['small_image'];
    		    $original_imagename = $upload_res['original_image'];
    			$db->query("SELECT usr_group_id FROM ".$this->table_prefix."_gallery_categories WHERE id=".$category);
    			if (!$db->next_record()) return false;
    			$owner_id = $_SESSION["siteuser"]["id"];
    			list($group_id, $rights) = $this->get_group_and_rights('gallery_default_rights', $block_id, $db->f("usr_group_id"));
    			$rights = $item_rights ? $item_rights : $rights;
    
    			$description	= $db->escape(trim($description));
    			$theme = $this->ThemeExist($theme) ? intval($theme) : 0;
    
    			$query = 'SELECT max(idx) as max_idx FROM '.$this->table_prefix.'_gallery WHERE category_id = '.$category;
    			$db->query($query);
    			$db->next_record();
    			$idx = $db->f('max_idx')+1;
    			
    			$base_tags = $this->getTagsBaseForm($tags);    			
    			$ret = array(
    			    'signature' => $signature,
    			    'description' => $description,
    			    'category_id' => $category,
    			    'theme_id' => $theme,
    			    'small_image' => $small_imagename,
    			    'big_image' => $big_imagename,
    			    'original_image' => $original_imagename,
    			    'active' => $active ? 1 : 0,
    			    'idx' => $idx,
    			    'owner_id' => $owner_id,
    			    'usr_group_id' => $group_id,
    			    'rights' => $rights,
    			);
    			$db->set("{$this->table_prefix}_gallery", $ret);
    
    			$ret['id'] = $db->lid();
    			$this->addImgTags($ret['id'], $base_tags);
    			if ($set_cover) {
    			    $this->setCtgrCover($ret['id']);
    			}
		    }
		}

		return $ret;
	}

	// обновление записи в базе данных
	function update_gallery_image($active, $category, $theme, $signature, $tags = '', $description = '', $set_cover = 0, $id = '', $del_img = 0)
	{   GLOBAL $CONFIG, $db;

		$ret = false;
		$id = (int)$id;
		$img = $this->GetImage($id);
      	$category = (int)$category;
      	$theme = $this->ThemeExist($theme) ? intval($theme) : 0;
        if ($id && $img) {
            $base_tags = $this->getTagsBaseForm($tags);			
			$set = array(
			    'signature' => $signature,
			    'description' => $description,
			    'theme_id' => $theme,
			    'active' => $active ? 1 : 0
			);
			if ($category > 0) {
			    $set['category_id'] = $category;
			}
			$ret = true;
			if ($_FILES['image']['tmp_name']) {
			    $upload_res = $this->upload_gallery_images();
    			if ($upload_res) {
    			    if ($img['original_image'] && file_exists(RP.$CONFIG['gallery_img_path'].$img['original_image'])) {
    			        @unlink((RP.$CONFIG['gallery_img_path'].$img['original_image']));
    			    }
    			    if ($img['big_image'] && file_exists(RP.$CONFIG['gallery_img_path'].$img['big_image'])) {
    			        @unlink((RP.$CONFIG['gallery_img_path'].$img['big_image']));
    			    }
    			    if ($img['small_image'] && file_exists(RP.$CONFIG['gallery_img_path'].$img['small_image'])) {
    			        @unlink((RP.$CONFIG['gallery_img_path'].$img['small_image']));
    			    }
    			    $set['big_image'] = $upload_res['big_image'];
    			    $set['small_image'] = $upload_res['small_image'];
    			    $set['original_image'] = $upload_res['original_image'];
    			} else {
    			    $ret = false;
    			}
			}			
			
			if ($ret) {
    			if ($ret = $db->set("{$this->table_prefix}_gallery", $set, array('id' => $id))) {
    			    $del_tags_ids = array();
        			$add_tags = $base_tags;
        			$img_tags = $this->getImageTags($id);
        			if (! empty($img_tags)) {
        			    foreach ($img_tags as $tag) {
        			        $k = array_search($tag['name'], $add_tags);
            				if (false === $k) {
            				    $del_tags_ids[] = $tag['id'];
            				} else {
            				    unset($add_tags[$k]);
            				}
            			}
        			}
        			if (!empty($del_tags_ids)) {
        			    $db->del("{$this->table_prefix}_tag_item",
        			        array('item_id' => $id, new DbExp('tag_id IN ('.implode(',', $del_tags_ids).')'))
        			    );
        			}
        			if (! empty($add_tags)) {
        			    $this->addImgTags($id, $add_tags);			    
        			}
        			if ($set_cover) {
        			    $this->setCtgrCover($id);
        			}
    			}
			}
		}
		
		return $ret;
	}

	// функция для загрузки картинок
	function upload_gallery_images() {
		GLOBAL $CONFIG;
		
		$ret = false;
		$orig_img = $this->uploadPostImg('image', '_original');
		if ($orig_img) {
		    $small_img = str_replace('_original', '_small', $orig_img);
		    $big_img = str_replace('_original', '_big', $orig_img);
		    if (! Main::generateImage(
	            RP.$CONFIG['gallery_img_path'].$orig_img,
	            RP.$CONFIG['gallery_img_path'].$small_img,
	            array(
	                'width' => $CONFIG['gallery_small_image_width'],
	                'height' => $CONFIG['gallery_small_image_height'],
	                'method' => 'crop'
	            )
	        )) {
	            $small_img = '';
	        }
		    if (! Main::generateImage(
	            RP.$CONFIG['gallery_img_path'].$orig_img,
	            RP.$CONFIG['gallery_img_path'].$big_img,
	            array(
	                'width' => $CONFIG['gallery_big_image_max_width'],
	                'height' => $CONFIG['gallery_big_image_max_height']
	            )
	        )) {
	            $big_img = '';
	        }
	        $ret = array(
	            'big_image' => $big_img,
	            'small_image' => $small_img,
	            'original_image' => $orig_img
	        );
		}

		return $ret;
	}

	// удаление записи из базы данных
	function delete_gallery_image($id)
	{   global $CONFIG, $db;
	
		$ret = false;
		$img = $this->GetImage($id);
		if ($img) {
		    if ($img['original_image'] && file_exists(RP.$CONFIG['gallery_img_path'].$img['original_image'])) {
			    @unlink((RP.$CONFIG['gallery_img_path'].$img['original_image']));
			}
			if ($img['big_image'] && file_exists(RP.$CONFIG['gallery_img_path'].$imgd['big_image'])) {
			    @unlink((RP.$CONFIG['gallery_img_path'].$img['big_image']));
			}
			if ($img['small_image'] && file_exists(RP.$CONFIG['gallery_img_path'].$img['small_image'])) {
			    @unlink((RP.$CONFIG['gallery_img_path'].$img['small_image']));
			}
			if (! empty($img['tag_list'])) {
			    $db->del("{$this->table_prefix}_tag_item", array('item_id' => $id));
			}
			$ret = $db->del("{$this->table_prefix}_gallery", array('id'=>$id));
		}
		
		return $ret;
	}


	// функция для вывода списка записей
	function show_gallery_adm($category = "", $start = "", $search = "", $owner_id = 0) {
		global $CONFIG, $main, $db, $tpl, $baseurl, $server, $lang;
    	$category	= (int)$category;
    	if (!$category && !$search) return FALSE;
		$start		= (int)$start;
		$start		= ($start) ? $start : 1;
		$rows		= $CONFIG["gallery_max_rows"];
		$order_by	= 'idx';

		if ($search) {
			$search = $db->escape($search);
			$this->get_list_with_rights(
							"g.*", $this->table_prefix."_gallery g", "g",
							"signature LIKE '%$search%' OR description LIKE '%$search%' OR id = '$search'", "id", $order_by,
							1, 0,
							false, $owner_id);
			$pages_cnt = 1;
		} else {
			$total_cnt = $this->get_list_with_rights(
									"g.*", $this->table_prefix."_gallery g", "g",
									"category_id = ".$category, "", $order_by,
									$start, $rows,
									true, $owner_id);
			$pages_cnt = ceil($total_cnt/$rows);
		}

		$i = 0;
		if ($nf = $db->nf()) {
			$actions = array(	"edit"		=> "edit",
								"editrights"=> "editrights",
								"activate"	=>	array("activate","suspend"),
								"top"		=> "top",
								"up"		=> "up",
								"down"		=> "down",
								"bottom"	=> "bottom",
								"delete"	=> "del",
								"confirm_delete"	=> $this->_msg["Confirm_delete_record"]
							);
			while($db->next()) {
				// вывод на экран списка
				$id = $db->f('id');
				$category_id = $db->f('category_id');
				$adm_actions = $this->get_actions_by_rights($baseurl."&id=".$id."&category=".$category_id."&start=".$start, $db->f("active"), $db->f("is_owner"), $db->f("user_rights"), $actions);
				$small_image	= $this->get_image($db->f("small_image"), $db->f("signature"), $CONFIG["gallery_img_path"]);
//				$big_image		= $this->get_image($db->f("big_image"), $db->f("signature"), $CONFIG["gallery_img_path"]);

				$tpl->newBlock("block_gallery_image");
				$tpl->assign(array(
					"MSG_Begin"					=> $this->_msg["Begin"],
					"MSG_Up"					=> $this->_msg["Up"],
					"MSG_Down"					=> $this->_msg["Down"],
					"MSG_End"					=> $this->_msg["End"],
					"is_first" => 1 == ++$i ? 1 : 0,
					"is_last" => $nf == $i ? 1 : 0,
					"img_up" => 1 == $i ? 'ico_ligrup.gif' : 'ico_listup.gif',
					"img_down" => $nf == $i ? 'ico_ligrdw.gif' : 'ico_listdw.gif',
					"up_link" => "{$baseurl}&action=up&category={$db->Record['category_id']}&rank={$db->Record['idx']}",
					"down_link" => "{$baseurl}&action=down&category={$db->Record['category_id']}&rank={$db->Record['idx']}",
					'id' =>	$id,
					'idx' =>	$_db['idx'],
					'gallery_image_signature'	=>	$db->f("signature"),
					'gallery_image_description'	=>	$db->f("description"),
					'gallery_hits'              =>	$db->f("hits"),
					'gallery_edit_action'		=>	$adm_actions["edit_action"],
					'gallery_edit_rights_action'=>	$adm_actions["edit_rights_action"],
					'gallery_del_action'		=>	$adm_actions["delete_action"],
					'change_status_action'		=>	$adm_actions["change_status_action"],
					'gallery_image_top_action'	=>	$adm_actions["top_action"],
					'gallery_image_up_action'	=>	$adm_actions["up_action"],
					'gallery_image_down_action'	=>	$adm_actions["down_action"],
					'gallery_image_bottom_action'	=>	$adm_actions["bottom_action"],
					'gallery_image_id'			=>	$id,
					'start'						=>	$start,
					'small_image'				=> $small_image,
//					big_image	=> $big_image,
				));
				if ($adm_actions["rights"]["d"] || $adm_actions["rights"]["p"]) {
					$tpl->newBlock('block_check');
					$tpl->assign("gallery_image_id", $id);
				}
			}
			return $pages_cnt;
		}
		return FALSE;
	}


	// функция для вывода категории по id
	function show_category_adm($id = "", $need_output = true) {
		global $CONFIG, $db, $tpl, $baseurl, $server, $lang;
		$id = (int)$id;
		if (!$id) return FALSE;

		$query = "SELECT * FROM ".$this->table_prefix."_gallery_categories WHERE id=".$id;
		$db->query($query);

		if ($db->nf() > 0) {
			$db->next_record();
            $is_poll = $db->f("poll") ? 'checked' : '';
            $is_comm = $db->f("comment") ? 'checked' : '';
			if ($need_output) {
				//вывод на экран
				$tpl->assign(
					array(
						'category' =>	$db->f("id"),
						'is_poll' =>	$is_poll,
						'is_comm' =>	$is_comm,
						'category' =>	$db->f("id"),
						'category_title' => htmlspecialchars($db->f("title")),
						'category_dscr' => $db->f("dscr"),
						'category_link' => "$baseurl&action=list&category=" . $db->f("id"),
					    'active_checked' => $db->Record['active'] ? 'checked' : '',
					)
				);
				if ($db->Record['image']) {
				    $tpl->newBlock('image');
				    $tpl->assign(array(
				        'image_name' => $db->Record['image'],
				        'image_path' => "/".$CONFIG['gallery_img_path'].$db->Record['image'],
				    ));
				}
			}
			return array($db->f("title"), $db->f("owner_id"), $db->f("comment"));
		}
		return FALSE;
	}


	// функция для добавления категории
	function add_category($title, $block_id = 0, $data = false)
	{   global $db, $CONFIG;

		$title = $db->escape(trim($title));
		$owner_id = $_SESSION["siteuser"]["id"];
		if (!$title || !$owner_id) return FALSE;
		list($group_id, $rights) = $this->get_group_and_rights('gallery_default_rights', $block_id);

		$query = 'SELECT max(idx) as max_idx FROM '.$this->table_prefix.'_gallery_categories';
		$db->query($query);
		$db->next_record();
		$idx = $db->f('max_idx')+1;
		
		$set = array(
		    'title' => $title,
		    'comment' =>  isset($data['commentable']) ? intval($data['commentable']) : 0,
		    'poll' => isset($data['poll']) && $data['poll'] ? 1 : 0,
		    'user_ctgr' => isset($data['user_ctgr']) && $data['user_ctgr'] ? 1 : 0,
		    'idx' => $idx,
		    'dscr' => $data['dscr'],
		    'active' => 1,
		    'owner_id' => $owner_id,
		    'usr_group_id' => $group_id,
		    'rights' => $rights,
		);
		
		$img = $this->uploadPostImg('image', '_album', $CONFIG['gallery_small_image_width'], $CONFIG['gallery_small_image_height']);
    	if ($img) {
    		$set['image'] = $img;
    	}	
		
		return $ret = $db->set($this->table_prefix."_gallery_categories", $set );
	}


	// функция для обновления категории по id
	function update_category($id, $title, $dscr = '', $data = false)
	{   global $CONFIG, $db, $server, $lang;
	
		$id = (int)$id;
		$ctgr = $this->GetCategory($id);
		$title	= $db->escape($title);
		if (!$ctgr || !$title || !$_SESSION["siteuser"]["id"]) return FALSE;
		$set = array(
		    'title' => $title,
		    'dscr' => $dscr,
		);
		if (isset($data['commentable'])) {
		    $set['comment'] = intval($data['commentable']);
		}
		if (isset($data['active'])) {
		    $set['active'] = $data['active'] ? 1 : 0;
		}
		if (isset($data['poll'])) {
		    $set['poll'] = $data['poll'] ? 1 : 0;
		}
		if ($data['del_img'] && $ctgr['image'] && file_exists(RP.$CONFIG['gallery_img_path'].$ctgr['image'])) {
		    $set['image'] = '';
		    unlink(RP.$CONFIG['gallery_img_path'].$ctgr['image']);
		}
		
		$img = $this->uploadPostImg('image', '_album', $CONFIG['gallery_small_image_width'], $CONFIG['gallery_small_image_height']);
		if ($img) {
		    $set['image'] = $img;
		    if ($ctgr['image'] && file_exists(RP.$CONFIG['gallery_img_path'].$ctgr['image'])) {
    		    unlink(RP.$CONFIG['gallery_img_path'].$ctgr['image']);
    		}
		}
		
		$ret = $db->set($this->table_prefix."_gallery_categories", $set, array('id' => $id) );
		
		return $ret;
	}


	// функция для удаления категории по id
	function delete_category($id = "") {
		global $CONFIG, $db, $tpl, $server, $lang;
		$id = (int)$id;
		if (!$id) return FALSE;
		$query = "DELETE FROM ".$this->table_prefix."_gallery_categories WHERE id = $id";
		$db->query($query);
		if ($db->affected_rows() > 0) {

			/* Удаление картинок */
			$query = "SELECT id, small_image, big_image, original_image FROM ".$this->table_prefix."_gallery WHERE category_id = ".$id;
			$db->query($query);
			$ids = array();
			while($db->next_record()) {
			    $ids[] = $db->Record['id'];
			    if ($db->Record['small_image']) {
			    	@unlink(RP.$CONFIG["gallery_img_path"].$db->Record['small_image']);
			    	@unlink(RP.$CONFIG["gallery_img_path"].$db->Record['big_image']);
			    	@unlink(RP.$CONFIG["gallery_img_path"].$db->Record['original_image']);
			    }
			}
			if (! empty($ids)) {
			    $ids = implode(",", $ids);
				$db->query("DELETE FROM ".$this->table_prefix."_tag_item WHERE item_id IN ({$ids})");
			}
			$query = "DELETE FROM ".$this->table_prefix."_gallery WHERE category_id = ".$id;
			$db->query($query);
			return TRUE;
		}
		return FALSE;
	}


	/**
	 * Существует ли тема
	 *
	 * @param int $id
	 * @return boolean
	 */
	function ThemeExist($id)
	{
		global $db;
		$id = (int) $id;
		$db->query("SELECT id FROM `".$this->table_prefix."_gallery_themes` WHERE id=".$id);

		return $db->nf() ? true : false;
	}

	/**
	 * Получить тему
	 *
	 * @param int $id
	 * @return mixed false или массив ['id', 'name']
	 */
	function GetTheme($id)
	{
	    global $db;
	    $id = (int) $id;
	    $db->query("SELECT * FROM `".$this->table_prefix."_gallery_themes` WHERE id=".$id);
	    if ($db->nf()) {
	        $db->next_record();
	        return array('id' => $db->f('id'), 'title' => $db->f('title'));
	    }
	    return false;
	}

	/**
	 * Добавить тему
	 *
	 * @param name $name
	 * @return mixed false or id добавленного темаа
	 */
	function AddTheme($title)
	{
		global $db;

		$title = $db->escape($title);
		if (! $title) {
			return false;
		}
		$db->query("INSERT INTO `".$this->table_prefix."_gallery_themes` SET title='".$title."'");

		return $db->lid();
	}

	/**
	 * Изменить название темы
	 *
	 * @param int $id
	 * @param string $title
	 * @return boolean
	 */
	function SetTheme($id, $title)
	{
		global $db;
		$id = (int) $id;
		$title = $db->escape($title);
		if (! $title) {
			return false;
		}
		$db->query("UPDATE `".$this->table_prefix."_gallery_themes` SET title='".$title."' WHERE id=".$id);

		return $db->Errno ? false : true;
	}

	/**
	 * Удалить тему
	 *
	 * @param int $id
	 * @return boolean
	 */
	function DelTheme($id)
	{
		global $db;
		$id = (int) $id;
		$db->query("DELETE FROM `".$this->table_prefix."_gallery_themes` WHERE id=".$id);
		return $db->affected_rows() ? true : false;
	}


	/**
	 * Получить список тем
	 *
	 * @return mixed Массив тем или false
	 */
	function GetThemeList($img_cnt = false)
	{
	    global $db;
	    $query = $img_cnt
	        ? "SELECT T.*, COUNT(I.id) AS cnt FROM `".$this->table_prefix."_gallery_themes` AS T"
	            ." LEFT JOIN ".$this->table_prefix."_gallery AS I ON I.theme_id=T.id"
	            ." GROUP BY T.id ORDER BY title"
	        : "SELECT *, 0 AS cnt FROM `".$this->table_prefix."_gallery_themes` ORDER BY title";
	    $db->query($query);
	    if ($db->nf()) {
	        $ret = array();
	        while ($db->next_record()) {
	        	$ret[$db->Record['id']] = array(
	        	    'id' => $db->Record['id'],
	        	    'title' => $db->Record['title'],
	        	    'cnt' => $db->Record['cnt']
	        	);
	        }
	        return $ret;
	    }
	    return false;
	}

	function GetThemes()
	{
	    global $db;
	    $query = "SELECT * FROM `".$this->table_prefix."_gallery_themes`";
	    $db->query($query);
	    if ($db->nf()) {
	        $ret = array();
	        while ($db->next_record()) {
	        	$ret[$db->Record['id']] = $db->Record['title'];
	        }
	        return $ret;
	    }
	    return false;
	}

	function ThemeList() {
    global $db;
    $query = "SELECT * FROM `".$this->table_prefix."_gallery_themes`";
    $db->query($query);
    if ($db->nf()) {
      $ret = array();
      while ($db->next_record()) {
      	$ret[$db->Record['id']] = $db->Record['title'];
      }
      return $ret;
    }
    return false;
	}

	/**
	 * Показать сисок тем
	 *
	 */
	function ShowThemeList($transurl, $show_img_count = false)
	{
		global $tpl;
		$l = $this->GetThemeList($show_img_count);
		if ($l) {
		    $tpl->newBlock('block_theme_list');
		    $tpl->assign(array(
    		    "MSG_Theme"   => $this->_msg["Theme"],
    			"MSG_Del"        => $this->_msg["Del"],
    			"MSG_Ed"         => $this->_msg["Ed"],
    		));
    		$transurl .= (false === strpos($transurl, "?") ? "?" : "&");
		    foreach ($l as $key => $val) {
		      $tpl->newBlock('block_theme');
		    	$tpl->assign(array(
		    	    'id' => $val['id'],
		    	    'title' => $val['title'],
		    	    'cnt' => $val['cnt'],
		    	    'link' => $transurl."action=theme&id=".$val['id'],
		    	    'MSG_Confirm_delete_record' => $this->_msg['Confirm_delete_record'],
		    	    'MSG_Delete' => $this->_msg['Delete'],
		    	    'MSG_Edit' => $this->_msg['Edit'],
		    	));
		    }
		}
	}

	function ShowThemeListById($transurl, $id) {
		global $db, $CONFIG, $tpl;

		$themes = $this->GetTheme($id);
		if($id) $filter = 'g.theme_id="'.$themes['id'].'"';
		else $filter = 'g.theme_id>0';
		$tpl->assign(Array(
		  'thm_title' => $themes['title'],
		));
		$query = 'SELECT
		            g.id,
		            g.signature,
		            g.description,
		            g.small_image,
		            g.category_id,
		            gc.title
		          FROM '.$this->table_prefix.'_gallery AS g
		          LEFT JOIN '.$this->table_prefix.'_gallery_categories AS gc ON gc.id=g.category_id
		          WHERE g.active="1" AND '.$filter;
		$db->query($query);
		if($db->nf()>0) $tpl->newBlock('block_theme_list');
		for($i=0;$i<$db->nf();$i++) {
		  $db->next_record();
          $tpl->newBlock('block_theme');
         	$tpl->assign(array(
       	    'id' => $db->f('id'),
       	    'signature' => $db->f('signature'),
      	    'description' => $db->f('description'),
      	    'small_image' => '/'.$CONFIG['gallery_img_path'].$db->f('small_image'),
      	    'category_id' => $db->f('category_id'),
      	    'title' => $db->f('title'),
      	    'img_link' => $transurl.'action=show&category='.$db->f('category_id').'&id='.$db->f('id'),
      	    'ctg_link' => $transurl.'action=list&category='.$db->f('category_id'),
     	  ));
 		}
	}

	function GetImage($id)
	{   global $db;
	    
	    $ret = false;
		$this->get_list_with_rights("g.*", $this->table_prefix."_gallery AS g", "g", 'id = '.intval($id));
		if ($db->next()) {		    
		    $ret = $db->Record;
		    $ret['tags'] = trim($ret['tags'], ',');
		    $ret['tag_list'] = $this->getImageTags($id);
		}
		return $ret;
	}

	function GetCategory($id)
	{
		global $db;
		$this->get_list_with_rights("C.*", $this->table_prefix."_gallery_categories AS C", "C", "C.id = ".intval($id));
		if ($db->nf() > 0) {
			$db->next();
			return $db->Record;
		}
		return false;
	}

	function AddComment($img_id, $text)
	{
	    global $db;

	    $text = $db->escape($text);
		if (! $this->GetImage($img_id) || !$text || !$_SESSION['siteuser']['id']) {
		  return false;
		}
		$db->query("INSERT INTO ".$this->table_prefix."_gallery_comment (img_id, user_id, `text`, `date`)"
		    ." VALUES (".intval($img_id).", ".$_SESSION['siteuser']['id'].","
		    ." '".$text."', NOW())");

		return ($db->affected_rows() > 0) ? $db->lid() : FALSE;
	}

	function GetBestPollImgs($cnt)
	{   global $db, $CONFIG;

	    $cnt = $cnt ? $cnt : $CONFIG['gallery_max_annonce'];
	    $db->query("SELECT g.*, IF(voices, poll_rate/voices, 0) AS rate, GROUP_CONCAT(DISTINCT T.name ORDER BY T.name SEPARATOR ',') AS tags FROM "
	        .$this->table_prefix."_gallery AS g"
	        ." INNER JOIN ".$this->table_prefix."_gallery_categories AS c ON g.category_id=c.id"
	        ." LEFT JOIN {$this->table_prefix}_tag_item TI ON g.id=TI.item_id"
		    ." LEFT JOIN {$this->table_prefix}_tag T ON TI.tag_id=T.id"
	        ." WHERE g.active AND c.poll GROUP BY g.id ORDER BY rate DESC, `last_poll_date` DESC LIMIT ".$cnt);
		$ret = array();
		while ($db->next()) {
			$ret[] = $db->Record;
		}

		return $ret;
	}

	function GetNewImgs($cnt)
	{   global $db, $CONFIG;

	    $cnt = $cnt ? $cnt : $CONFIG['gallery_max_annonce'];
	    $db->query("SELECT g.*, IF(voices, poll_rate/voices, 0) AS rate, GROUP_CONCAT(DISTINCT T.name ORDER BY T.name SEPARATOR ',') AS tags"
	        ." FROM ".$this->table_prefix."_gallery AS g"
	        ." INNER JOIN ".$this->table_prefix."_gallery_categories AS c ON g.category_id=c.id"
	        ." LEFT JOIN {$this->table_prefix}_tag_item TI ON g.id=TI.item_id"
		    ." LEFT JOIN {$this->table_prefix}_tag T ON TI.tag_id=T.id"
		    ." WHERE g.active GROUP BY g.id ORDER BY id DESC LIMIT ".$cnt);
		$ret = array();
		while ($db->next()) {
			$ret[] = $db->Record;
		}

		return $ret;
	}

	function GetBestCommentImgs($cnt)
	{
	    global $CONFIG, $db, $core;
	    
	    $ret = false;
	    if (defined('COMMENTS_PHOTO_TYPE')) {
	        $cnt = $cnt ? $cnt : $CONFIG['gallery_max_annonce'];
    	    $db->query("SELECT g.*, GROUP_CONCAT(DISTINCT T.name ORDER BY T.name SEPARATOR ',') AS tags, COUNT(cm.id) AS comment_cnt FROM "
    	        .$this->table_prefix."_gallery AS g INNER JOIN "
    	        .$this->table_prefix."_gallery_categories AS c ON g.category_id=c.id"
    	        ." INNER JOIN {$this->table_prefix}_comments_resource r ON (r.item_id=g.id AND r.type=".COMMENTS_PHOTO_TYPE
    	        .") INNER JOIN {$this->table_prefix}_comments cm ON cm.resrc_id=r.id"
    	        ." LEFT JOIN {$this->table_prefix}_tag_item TI ON g.id=TI.item_id"
    	        ." LEFT JOIN {$this->table_prefix}_tag T ON TI.tag_id=T.id"
    	        ." WHERE g.active"
    	        ." GROUP BY g.id ORDER BY comment_cnt DESC LIMIT ".$cnt);
    	    $ret = array();
    		$gallery_base = $core->formPageLink($CONFIG["gallery_page_link"], $CONFIG["gallery_page_address"], $lang, 1);
    		while ($db->next_record()) {
    			$ret[] = $db->Record
    			    + array(
    			        'small_image_path' => "/".$CONFIG['gallery_img_path'].$db->Record['small_image'],
    			        'big_image_path' => "/".$CONFIG['gallery_img_path'].$db->Record['big_image'],
    			        'image_link' => $gallery_base."&action=show&category=".$db->Record['category_id']."&id=".$db->Record['id']
    			    );
    		}
	    }

		return $ret;
	}

	function ShowImgList($img_list, $param)
	{   global $tpl, $CONFIG;

	    $transurl = $param['transurl'];
	    $pref = $param['pref'] ? $param['pref'] : '';
	    if (! empty($img_list)) {
    		foreach ($img_list as $key => $item) {
    			//$tpl->newBlock($block_name);
    			//$tpl->assign($item);
    			$i++;
    			$small_image = $this->get_image($item["small_image"], $item["signature"], $CONFIG['gallery_img_path']);
                $url_suff = $param['owner_id'] ? "&user_id=".$owner_id : "";
    			$tpl->newBlock($pref."block_gallery_image");
    			$img_link = $transurl."&action=show&category=".$item["category_id"]."&id=".$item["id"].$url_suff;
    			$tpl->assign(array(
    			    'config_small_height' => $CONFIG["gallery_small_image_height"],
    			    'config_small_width' => $CONFIG["gallery_small_image_width"],
    			    'gallery_image_signature' => $item["signature"],
    			    'gallery_image_description'	=>	$item["description"],
    			    'gallery_image_link' =>	$img_link,
    			    'gallery_image_id' => $item['id'],
    			    'small_image' => $small_image,
    			    'category_id' => $item["category_id"],
    			    'id' => $item["id"],
    			    'baseurl' => $transurl.$url_suff,
    			    'selected' => $param['selected'] && $param['selected'] == $item['id'] ? 'selected' : '',
    				'small_image_path' => $item["small_image"] && file_exists(RP.$CONFIG['gallery_img_path'].$item['small_image'])
    					? '/'.$CONFIG['gallery_img_path'].$item['small_image'] : $CONFIG['gallery_no_photo'],
    				'big_image_path'	=> $item["big_image"] && file_exists(RP.$CONFIG['gallery_img_path'].$item['big_image'])
    					? '/'.$CONFIG['gallery_img_path'].$item['big_image'] : $CONFIG['gallery_no_photo'],
    				'big_image_watermark_path'	=>  $item["big_image"] && file_exists(RP.$CONFIG['gallery_img_path'].$item['big_image'])
    					? '/img.php?img='.$item['big_image'].(SITE_PREFIX != $this->table_prefix ? '&p='.$this->table_prefix : '') : $CONFIG['gallery_no_photo'],
    				'original_image_path'	=> $item["original_image"] && file_exists(RP.$CONFIG['gallery_img_path'].$item['original_image'])
    					? '/'.$CONFIG['gallery_img_path'].$item['original_image'] : $CONFIG['gallery_no_photo'],
    				'original_image_watermark_path'	=>  $item["original_image"] && file_exists(RP.$CONFIG['gallery_img_path'].$item['original_image'])
    				    ? '/img.php?img='.$item['original_image'].(SITE_PREFIX != $this->table_prefix ? '&p='.$this->table_prefix : '') : $CONFIG['gallery_no_photo'],
    				''
    			));
    			if ($item["is_owner"]) {
    				$tpl->newBlock($pref."block_gallery_image_edit");
    				$tpl->assign(array(
    					'edit_link' => $transurl."&action=editimg&category=".$item["category_id"]."&id=".$item["id"],
    					'del_link' => $transurl."&action=delimg&category=".$item["category_id"]."&id=".$item["id"],
    				));
    			}
    			
    			if (! $CONFIG['gallery_dont_show_info']) {
    			    $tpl->newBlock($pref."album");
        			$tpl->assign(array(
        				'category_id' => $item["category_id"],
        				'category_title' => $item["category_title"],
        				'transurl' => $transurl,
        			));
        			if ($item["signature"]) {
        				$tpl->newBlock($pref."title");
        			} else {
        				$tpl->newBlock($pref."no_title");
        			}
        			$tpl->assign(array(
        				'gallery_image_signature' => $item["signature"],
        				'gallery_image_link' => $img_link,
        			));
        					
        			$tags = trim($item["tags"], ',');
        			$tags = preg_split("/,|\s/", $tags, -1, PREG_SPLIT_NO_EMPTY);
        			foreach ($tags as $key => $val) {
        				$tags[$key] = array('name' => $val);
        			}
        			$tpl->assignList($pref.'tag_', $tags, array(
    				    'baseurl' => $baseurl,
    				    'transurl' => $baseurl,
    					'divider' => ','
    				));
        				
        			$poll_rate = $item['poll_rate'];
        			$voices = $item['voices'];
        			$average_rate = number_format($voices > 0 ? $poll_rate/$voices : 0, 2, ".", "");
        			if ($average_rate > 0) {
        				$tpl->newBlock($pref.'rating');
        				$tpl->assign('rating', $average_rate);
        			} else {
        				$tpl->newBlock($pref.'no_rating');
        				$tpl->assign('rating', 0);
        			}
    			}
    		}
	    }
	}

	function CutWords($text)
	{
		setlocale(LC_ALL, 'ru_RU');
		$ret = preg_split("/\s/", $text, -1, PREG_SPLIT_NO_EMPTY);
		foreach ($ret as $key => $val) {
			//$ret[$key] = preg_replace("/\W/", "", $val);
			//$ret[$key] = str_replace(array('-', '.', ',', '!', '?', ':', ';', ')', '(', '"', '\''), '', $val);
			$l = mb_strlen($ret[$key], 'UTF-8');
			if (count($ret) > 6 || $l < 2) {
				unset($ret[$key]);
			} elseif ($l >= 5) {
				$ret[$key] = mb_substr($ret[$key], 0, -2, 'UTF-8');
			} elseif ($l == 3 || $l == 4) {
				$ret[$key] = mb_substr($ret[$key], 0, -1, 'UTF-8');
			}
		}
		return $ret;
	}

	function findImgs($text, $start, $cnt)
	{
	    global $CONFIG, $db, $core;

	    $cnt = $cnt > 1 ? (int) $cnt : $CONFIG['gallery_max_rows'];
	    $start = $start > 1 ? (int) $start : 1;
	    $words = $this->CutWords($text);
	    if (empty($words)) {
	    	return false;
	    }
	    $db->query("SELECT G.*, GROUP_CONCAT(DISTINCT T.name ORDER BY T.name SEPARATOR ',') AS tags"
	        ." FROM ".$this->table_prefix."_gallery AS G"
	        ." LEFT JOIN {$this->table_prefix}_tag_item TI ON G.id=TI.item_id"
		    ." LEFT JOIN {$this->table_prefix}_tag T ON TI.tag_id=T.id"
	        ." WHERE active AND (signature LIKE '%".implode("%' OR signature LIKE '%", $words)."%'"
	        ." OR description  LIKE '%".implode("%' OR description  LIKE '%", $words)."%')"
	        ." GROUP BY G.id ORDER BY last_poll_date DESC LIMIT ".($start - 1)*$cnt.",".$cnt);	    
		$ret = array();
		while ($db->next()) {
			$ret[$db->Record['id']] = $db->Record;
		}

		return $ret;
	}

	function cntFindImgs($text)
	{
	    global $db;

	    $words = $this->CutWords($text);
	    if (empty($words)) {
	    	return false;
	    }
	    $db->query("SELECT COUNT(*) AS cnt FROM "
	        .$this->table_prefix."_gallery"
	        ." WHERE active AND (signature LIKE '%".implode("%' OR signature LIKE '%", $words)."%'"
	        ." OR description  LIKE '%".implode("%' OR description  LIKE '%", $words)."%')");
	    /*
	    echo "SELECT COUNT(*) AS cnt FROM "
	        .$this->table_prefix."_gallery"
	        ." WHERE active AND (signature LIKE '%".implode("%' OR signature LIKE '%", $words)."%'"
	        ." OR description  LIKE '%".implode("%' OR description  LIKE '%", $words)."%')";
	    */
		$db->next_record();

		return $db->Record['cnt'];
	}

		/**
	 * изменить публикацию категории
	 * @param int $id	Id товара
	 * @return boolean
	 */
	function changeLeader($id)
	{   global $db;

		if (!$id = (int)$id) {
			return FALSE;
		}

		$db->query('UPDATE '.$this->table_prefix.'_gallery_categories
		        	SET active = IF (active, 0, 1) WHERE id = '.$id);

		return $db->affected_rows() ? TRUE : FALSE;

	}

	function getCommentableItem($id)
	{   global $db;

		$db->query("SELECT G.id, IF(G.signature, G.signature, G.small_image) AS title, C.comment FROM "
		    .$this->table_prefix."_gallery G INNER JOIN "
		    .$this->table_prefix."_gallery_categories AS C ON category_id=C.id WHERE G.id="
		    .intval($id)." AND C.comment>0");
		return !$db->next_record()  || (!$_SESSION['siteuser']['id'] && 2 == $db->Record['comment'])
		    ? false : array(
			'id' => $db->Record['id'],
			'title' => $db->Record['title']
		);
	}
	
	function uploadPostImg($field_name, $suff = '', $width = 0, $height = 0)
	{   global $CONFIG;
	
	    $ret = false;
	    $ext = Main::getFileExt($_FILES[$field_name]['name']);
	    if ($_FILES[$field_name]['tmp_name'] && UPLOAD_ERR_OK == $_FILES[$field_name]['tmp_name'] && $ext) {
	        $file_name = md5($_FILES[$field_name]['tmp_name'].rand())."{$suff}.{$ext}";
	        if (Main::generateImage(
	            $_FILES[$field_name]['tmp_name'],
	            RP.$CONFIG['gallery_img_path'].$file_name,
	            array(
	                'width' => $width,
	                'height' => $height,
	                'source_min_width' => $CONFIG['gallery_small_image_width'],
	                'source_min_height' => $CONFIG['gallery_small_image_height'],
	            )
	        )) {
	            $ret = $file_name;
	        }
	    }
	    
	    return $ret;
	}
	
	function getTagsBaseForm($str)
	{   global $CONFIG;
	
	    require_once(RP."inc/rumor/class.RuMor.php");
	    $ret = array();
	    $tags = preg_split("/,|\s/", $str, -1, PREG_SPLIT_NO_EMPTY);
	    
	    $rumor = new RuMor(RP."inc/rumor");
		$rumor->prep_dict();
		while ( count($ret) <= $CONFIG['gallery_max_tags_cnt'] && (list(,$v) = each($tags)) ) {
			$base = $rumor->get_base_form(iconv("UTF-8", "WINDOWS-1251", $v));			
			$val = empty($base) ? $v : iconv("WINDOWS-1251", "UTF-8", $base[0]);
			if (! in_array($val, $ret)) {
			    $ret[] = $val;
			}
		}
		
		return $ret;
	}
	
	function getTagsByNames($names)
	{   global $db;
	
	    $ret = false;	    
		
	    if (is_array($names) && !empty($names)) {
	        $names = array_map('abo_strtolower', $names);
    		$names = array_map(array('My_Sql', 'escape'), $names);
    		$ret = $db->fetchAll("{$this->table_prefix}_tag",
    		    array('clause' => array(new DbExp("name IN ('".implode("','", $names)."')"))),
    		    'name'
    		);
	    }
	    
	    return $ret;
	}
	
	function getImageTags($img_id)
	{   global $db;
	
		$db->query("SELECT T.* FROM {$this->table_prefix}_tag_item TI INNER JOIN {$this->table_prefix}_tag T"
		   ." ON TI.tag_id=T.id WHERE TI.item_id=".intval($img_id)
		);
		$ret = false;
		while ($db->next()) {
			$ret[$db->Record['id']] = $db->Record;
		}
		
		return $ret;
	}
	
	function addImgTags($img_id, $base_tags)
	{   global $db;

		if (! empty($base_tags)) {
			$tags = $this->getTagsByNames($base_tags);
			foreach ($base_tags as $val) {
			    if (isset($tags[$val])) {
			    	$tag_id = $tags[$val]['id'];
			    } else {
			    	$db->set("{$this->table_prefix}_tag", array('name' => $val));
			    	$tag_id = $db->lid();
			    }
			    $db->set("{$this->table_prefix}_tag_item", array('tag_id' => $tag_id, 'item_id' => $img_id));
			}
		}
	}
	
	function getTagCloud($param = array())
	{   global $db, $CONFIG;
	
		$limit = '';
		if ($param['limit'] > 0) {
		    $limit = " LIMIT ".intval($param['limit']);
		}
		$db->query("SELECT T.*, count(I.item_id) AS item_cnt FROM {$this->table_prefix}_tag T"
		    ." INNER JOIN {$this->table_prefix}_tag_item I ON T.id=I.tag_id"
		    ." INNER JOIN {$this->table_prefix}_gallery G ON G.id=I.item_id GROUP BY T.id ORDER BY item_cnt DESC".$limit);

		$ret = $max = $min = false;
		while ($db->next()) {
			$ret[$db->Record['id']] = $db->Record;
			$ret[$db->Record['id']]['title'] = $db->Record['name'];
			if (false === $max || $db->Record['item_cnt'] > $max) {
			    $max = $db->Record['item_cnt'];
			}
			if (false === $min || $db->Record['item_cnt'] < $min) {
			    $min = $db->Record['item_cnt'];
			}
		}
		$step = ($max - $min)/$CONFIG['gallery_font_cnt'];
		foreach ($ret as $key => $val ) {
		    $ret[$key]['font_size'] = 1;
			for($a = $min, $i = 1; $a < $val['item_cnt']; $a += $step, $i++) {
			    $ret[$key]['font_size'] = $i;

			}
		}
		if ($ret) {
		    usort($ret, create_function('$a, $b', 'return strcasecmp($a["name"], $b["name"]);'));
		}
		
		return $ret;
	}
	
	
	function getTagList($filter = false)
	{
	    global $db;
	
	    return $db->fetchAll($this->table_prefix.'_tag', $filter);
	}
	
	function getTagListCnt($filter = false)
	{
	    global $db;
	
	    return $db->fetchCnt($this->table_prefix.'_tag', $filter);
	}
	
	
	function getThemeCloud()
	{   global $db, $CONFIG;
	
		$db->query("SELECT T.*, count(I.id) AS item_cnt FROM {$this->table_prefix}_gallery_themes T"
		    ." INNER JOIN {$this->table_prefix}_gallery I ON T.id=I.theme_id GROUP BY T.id ORDER BY title");

		$ret = $max = $min = false;
		while ($db->next()) {
			$ret[$db->Record['id']] = $db->Record;
			if (false === $max || $db->Record['item_cnt'] > $max) {
			    $max = $db->Record['item_cnt'];
			}
			if (false === $min || $db->Record['item_cnt'] < $min) {
			    $min = $db->Record['item_cnt'];
			}
		}
		$step = ($max - $min)/$CONFIG['gallery_font_cnt'];
		foreach ($ret as $key => $val ) {
		    $ret[$key]['font_size'] = 1;
			for($a = $min, $i = 1; $a < $val['item_cnt']; $a += $step, $i++) {
			    $ret[$key]['font_size'] = $i;

			}
		}
		
		return $ret;
	}
	
	function getImgList($filter = array('active' => 1))
	{   global $db, $CONFIG;
	
	    $clause = $this->getImgListClause($filter);
	    $order = $filter['order'] ? $filter['order'] : $CONFIG["gallery_order_by"];
	    $limit = '';
	    if ($filter['limit'] > 0) {
	        $limit = (int)$filter['limit'];
	        $start = $filter['start'] > 1 ? (int)$filter['start'] : 1;
	        $limit = ' LIMIT '.($start - 1)*$limit.','.$limit;
	    }
		$db->query("SELECT G.*, C.title AS category_title, GROUP_CONCAT(DISTINCT T.name ORDER BY T.name SEPARATOR ',') AS tags"
		    ." FROM {$this->table_prefix}_gallery G"
		    ." INNER JOIN {$this->table_prefix}_gallery_categories C ON G.category_id=C.id "
		    ." LEFT JOIN {$this->table_prefix}_tag_item TI ON G.id=TI.item_id"
		    ." LEFT JOIN {$this->table_prefix}_tag T ON TI.tag_id=T.id"
		    .($clause['clause'] ? ' WHERE '.$clause['clause'] : '')
		    .' GROUP BY G.id ORDER BY '.$order.$limit
		);
		$ret = false;
		while ($db->next()) {
			$ret[$db->Record['id']] = $db->Record;
		}
		
		return $ret;
	}

	function GetImgCnt($filter = array('active' => 1))
	{   global $db;
	
		$clause = $this->getImgListClause($filter);
		$db->query("SELECT COUNT(*) FROM ".$this->table_prefix."_gallery G".($clause['table'] ? $clause['table'] : '')
		    .($clause['clause'] ? ' WHERE '.$clause['clause'] : ''));
		$db->next_record();
		return $db->Record[0];
	}
	
	function getImgListClause($filter = array())
	{
		$ret = array('clause' => '', 'table' => '');
		$clause = array();
		if ($filter['active']) {
		    $clause[] = 'G.active=1';
		}
		if ($filter['theme']) {
		    $clause[] = 'G.theme_id='.intval($filter['theme']);
		}
		if ($filter['category']) {
		    $clause[] = 'G.category_id='.intval($filter['category']);
		}
		if ($filter['tag']) {		    
		    $clause[] = "T.name='".My_Sql::escape($filter['tag'])."'";
		}
		if (! empty($clause)) {
		    $ret['clause'] = implode(' AND ', $clause);
		}
		return $ret;
	}
	
	function setCtgrCover($img_id)
	{   global $db, $CONFIG;
		$db->query("SELECT G.small_image, G.category_id, C.image FROM {$this->table_prefix}_gallery G"
		    ." INNER JOIN {$this->table_prefix}_gallery_categories C ON G.category_id=C.id WHERE G.id=".intval($img_id));
		if ($db->next() && $db->Record['small_image'] && file_exists(RP.$CONFIG['gallery_img_path'].$db->Record['small_image']) ) {
		    if ($db->Record['image'] && file_exists(RP.$CONFIG['gallery_img_path'].$db->Record['image'])) {
		        unlink(RP.$CONFIG['gallery_img_path'].$db->Record['image']);
		    }
		    $cover_name = str_replace('_small', '_album', $db->Record['small_image']);
		    copy(RP.$CONFIG['gallery_img_path'].$db->Record['small_image'], RP.$CONFIG['gallery_img_path'].$cover_name);
		    $db->set("{$this->table_prefix}_gallery_categories", array('image' => $cover_name), array('id' => $db->Record['category_id']));
		}
	}
}
?>