<?php

class GlossaryPrototype extends Module {

	var $main_title;
	var $table_prefix;
	var $addition_to_path;
	var $module_name				= 'glossary';
	var $block_module_actions		= array();
	var $block_main_module_actions	= array();
	var $default_action				= 'list';
	var $admin_default_action		= 'showctg';
	var $tpl_path					= 'mod/glossary/tpl/';

	function GlossaryPrototype($action = '', $transurl = '', $properties = array(), $prefix = NULL, $rewrite_mod_params = NULL, $adminurl = NULL, $noadmin = false) {
		global $main, $tpl, $tpl_path, $baseurl, $cache, $lc, $CONFIG, $PAGE, $server, $lang, $permissions, $request_type, $_RESULT;
		
		/* Get $action, $tpl_name, $permissions */
		extract( $this->init(array(
		        'server' => $server, 'lang' => $lang, 'prefix' => $prefix,
		        'action' => $action, 'tpl_name' => $properties['tpl']
		)), EXTR_OVERWRITE);
		
		$this->block_module_actions			= array();
		$this->block_main_module_actions	= array('list'	=> $this->_msg["Glossary_with_ABC_nav"]);
		
        $category	= (int)$properties[1];
        
        if ('only_create_object' == $action) {
            return;
        }
        
        if ($this->actionExists($action)) {
            $this->doAction($action);
            return;
        }

		if (! self::is_admin()) {

//---------------------------------- обработка действий с сайта --------------------------------//
			switch ($action) {
// Вывод списка записей соотв. категории 
			case 'list':
				GLOBAL $request_start, $request_category;
				$start		= substr(trim(strip_tags($request_start)), 0, 2);
				$category	= ($request_category) ? $request_category : $category;
				
				$main->include_main_blocks($this->module_name.'_list.html', 'main');
				$tpl->prepare();
				
				$this->show_alphabetic_nav($transurl, $category, $start);
				$this->show_glossary($category, $start);
				$tpl->assign(
					array(
						'_ROOT.form_action'	=> $baseurl.'&action=add&step=2',
					)
				);
				
				$this->show_categories($category);
				break;
								
			// Default...
//-----------------------------------------------------------------------------
			default:
				if (is_object($tpl)) $tpl->prepare();
				return;
			}
//------------------------------- конец обработки действий с сайта -----------------------------//
		} else {
//------------------------------ обработка действий из админ части -----------------------------//            
			if (!isset($tpl)) {
			    $main->message_die(iconv("WINDOWS-1251", "UTF-8", 'Не подключен класс для работы с шаблонами'));
			}
			switch ($action) {
		    case 'prp':
		    	if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $request_step;
				$main->include_main_blocks('_properties.html', $this->tpl_path);
				$tpl->prepare();
				$tpl->assign(Array(
					"MSG_Information"	=> $main->_msg["Information"],
					"MSG_Value"			=> $main->_msg["Value"],
					"MSG_Save"			=> $main->_msg["Save"],
					"MSG_Cancel"		=> $main->_msg["Cancel"],
				));
		        if (!$request_step || $request_step == 1) {
					$tpl->assign(array('form_action'	=> $baseurl,
									   'step'			=> 2,
									   'lang'			=> $lang,
									   'name'			=> $this->module_name,
									   'action'			=> 'prp'));
					$prp_html = $main->getModuleProperties($this->module_name);
		            $this->main_title = $this->_msg["Controls"];
				} elseif (2 == $request_step) {
		        	$main->setModuleProperties($this->module_name, $_POST);
					header('Location: '.$baseurl.'&action=prp&step=1');
				}
		    	break;

			case 'block_prp':
				global $request_sub_action, $request_block_id;
		    	$arr  = $this->getEditLink($request_sub_action, $request_block_id);
		    	$cont = 'var container = document.getElementById(\'target_span\');
		    		  	 container.innerHTML = "'.$this->getPropertyFields().'";
		    		  	 material_id		  = "'.$arr['material_id'].'";
		    		  	 material_url		  = "'.$arr['material_url'].'";
		    		  	 changeAction();
		    	      	 setURL("property1");';
		    	header('Content-Length: '.strlen($cont));
		    	echo $cont;
		    	exit;
		    	break;

			case "list":
				if (!$permissions["r"]) $main->message_access_denied($this->module_name, $action);
				global $request_start, $request_category;
				$start = ($request_start) ? $request_start : 1;
				$category = ($request_category) ? $request_category : 1;
				$main->include_main_blocks_2($this->module_name."_list.html", $this->tpl_path);
				$tpl->assignInclude("search_form", $tpl_path . "_search_form.html");
				$tpl->prepare();
				$tpl->assign(array(
					"MSG_Activ" => $this->_msg["Activ"],
					"MSG_Ed" => $this->_msg["Ed"],
					"MSG_Rights" => $main->_msg["Rights"],
					"MSG_Term" => $this->_msg["Term"],
					"MSG_Del" => $this->_msg["Del"],
					"MSG_Description" => $this->_msg["Description"],
					"MSG_Select_action" => $this->_msg["Select_action"],
					"MSG_Activate" => $this->_msg["Activate"],
					"MSG_Suspend" => $this->_msg["Suspend"],
					"MSG_Delete" => $this->_msg["Delete"],
					"MSG_Execute" => $this->_msg["Execute"],
					"_ROOT.form_search_action"	=>	"$baseurl&action=search",
					"_ROOT.lang"				=>	$lang,
					"_ROOT.name"				=>	$this->module_name,
					"_ROOT.action"				=>	"search",
				));
				list($category_title, $ctg_owner_id) = $this->show_category($request_category);
				$pages_cnt = $this->show_glossary_adm($request_category, $request_start, "", $ctg_owner_id);
				$main->_show_nav_block($pages_cnt, null, "action=".$action."&category=".$category, $start);
				$tpl->assign(Array(
					"MSG_Pages" => $this->_msg["Pages"],
				));
				$this->main_title = ($category_title) ? $category_title : "";
				break;

// Вывод результата поиска
			case "search":
				if (!$permissions["r"]) $main->message_access_denied($this->module_name, $action);
				global $request_search, $request_category, $request_start;
				$search = strip_tags(trim($request_search));
				$main->include_main_blocks_2($this->module_name."_list.html", $this->tpl_path);
				$tpl->assignInclude( "search_form", $tpl_path . "_search_form.html" );
				$tpl->prepare();
				$tpl->assign(array(
					"MSG_Activ" => $this->_msg["Activ"],
					"MSG_Ed" => $this->_msg["Ed"],
					"MSG_Rights" => $main->_msg["Rights"],
					"MSG_Term" => $this->_msg["Term"],
					"MSG_Del" => $this->_msg["Del"],
					"MSG_Description" => $this->_msg["Description"],
					"MSG_Select_action" => $this->_msg["Select_action"],
					"MSG_Activate" => $this->_msg["Activate"],
					"MSG_Suspend" => $this->_msg["Suspend"],
					"MSG_Delete" => $this->_msg["Delete"],
					"MSG_Execute" => $this->_msg["Execute"],
					"_ROOT.form_search_action"	=>	"$baseurl&action=search",
					"_ROOT.lang"				=>	$lang,
					"_ROOT.name"				=>	$this->module_name,
					"_ROOT.action"				=>	"search",
				));
				list($category_title, $ctg_owner_id) = $this->show_category($request_category);
				$result = $this->show_glossary_adm($request_category, $request_start, $search, $ctg_owner_id);
				if (!$result) $no_res = $this->_msg["Didnt_match_anything"];
				$tpl->assign(
					array(
						"_ROOT.form_search_action"	=>	"$baseurl&action=search",
						"_ROOT.lang"				=>	$lang,
						"_ROOT.name"				=>	$this->module_name,
						"_ROOT.action"				=>	"search",
						"_ROOT.search"				=>	$search,
						"_ROOT.search_result"		=>	$this->_msg["Search_results"] . " \"$search\": $no_res",
					)
				);
				$this->main_title = $this->_msg["Glossary_search_results"];
				break;

// Добавление записи в базу данных
			case 'add':
				if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $request_step, $request_category, $request_term, $request_navletter,
						$request_txt_content, $request_description, $request_block_id;
				if (!$request_step || $request_step == 1) {
					$main->include_main_blocks_2($this->module_name.'_edit.html', $this->tpl_path);
					$tpl->prepare();
					$tpl->assign(Array(
						"MSG_Enter_term" => $this->_msg["Enter_term"],
						"MSG_Enter_description" => $this->_msg["Enter_description"],
						"MSG_Choose_category" => $this->_msg["Choose_category"],
						"MSG_Category" => $this->_msg["Category"],
						"MSG_Select_category" => $this->_msg["Select_category"],
						"MSG_Term" => $this->_msg["Term"],
						"MSG_Description" => $this->_msg["Description"],
						"MSG_required_fields" => $this->_msg["required_fields"],
						"MSG_Save" => $this->_msg["Save"],
						"MSG_Cancel" => $this->_msg["Cancel"],
						'_ROOT.form_action'	=> $baseurl.'&action=add&step=2',
						'_ROOT.cancel_link'	=> $baseurl.'&action=showctg',
					));

					$nf	= $this->show_categories('', true);
					if ($nf == 0) {
						header('Location: '.$baseurl.'&action=showctg&empty');
						exit;
					}
					$this->main_title = $this->_msg["Add_term_to_glossary"];
				} else if ($request_step == 2) {
					list($allow, $ctg_rights) = $this->test_item_rights("e", "id", $this->table_prefix."_glossary_categories",
																		$request_category, false, 0, true);
					if (!$allow) $main->message_access_denied($this->module_name, $action);

					$block_id = intval(substr($request_block_id, 10));
					$lid = $this->add_term($request_category, $request_term, $request_navletter, $request_txt_content, $ctg_rights, $block_id);
					if ($lid) {
						@$cache->delete_cache_files();
						$lc->add_internal_links($this->module_name, 'glossary', 'description', $lid, $this->_msg["Link_in_glossary"], $request_description);
						header('Location: '.$baseurl.'&action=list&category='.$request_category);
					} else {
						header('Location: '.$baseurl.'&action=showctg');
					}
					exit;
				}
				break;

// Редактирование записи
			case 'edit':
				if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $request_id, $request_category, $request_start;
				list($category_title, $ctg_owner_id) = $this->show_category($request_category, false);
				if (!$this->test_item_rights("e", "id", $this->table_prefix."_glossary", $request_id, false, $ctg_owner_id))
					$main->message_access_denied($this->module_name, $action);

				$main->include_main_blocks_2($this->module_name.'_edit.html', $this->tpl_path);
				$tpl->prepare();
				$tpl->assign(Array(
					"MSG_Enter_term" => $this->_msg["Enter_term"],
					"MSG_Enter_description" => $this->_msg["Enter_description"],
					"MSG_Choose_category" => $this->_msg["Choose_category"],
					"MSG_Category" => $this->_msg["Category"],
					"MSG_Select_category" => $this->_msg["Select_category"],
					"MSG_Term" => $this->_msg["Term"],
					"MSG_Description" => $this->_msg["Description"],
					"MSG_required_fields" => $this->_msg["required_fields"],
					"MSG_Save" => $this->_msg["Save"],
					"MSG_Cancel" => $this->_msg["Cancel"],
					'_ROOT.form_action'	=> $baseurl.'&action=update&id='.$request_id.'&start='.$request_start,
					'_ROOT.cancel_link'	=> $baseurl.'&action=list&category='.$request_category.'&start='.$request_start,
				));

				if (!$this->show_term($request_id, $request_start, 1)) {
					header('Location: '.$baseurl.'&action=showctg');
					exit;
				}
				$this->show_categories($request_category, true);
				$this->main_title	= $this->_msg["Edit_record"];
				break;

// Обновление записи
			case 'update':
				if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $request_category, $request_term, $request_txt_content,
						$request_id, $request_description, $request_start;
				list($category_title, $ctg_owner_id) = $this->show_category($request_category, false);
				if (!$this->test_item_rights("e", "id", $this->table_prefix."_glossary", $request_id, false, $ctg_owner_id))
					$main->message_access_denied($this->module_name, $action);

				if ($this->update_term($request_category, $request_term, $request_txt_content, $request_id)) {
						@$cache->delete_cache_files();
					$lc->add_internal_links($this->module_name, 'glossary', 'description', $request_id, $this->_msg["Link_in_glossary"], $request_description);
				}
				header('Location: '.$baseurl.'&action=list&category='.$request_category.'&start='.$request_start);
				exit;
				break;

// Удаление записи
			case "del":
				if (!$permissions["d"]) $main->message_access_denied($this->module_name, $action);
				global $request_category, $request_id, $request_start;
				list($category_title, $ctg_owner_id) = $this->show_category($request_category, false);
				if (!$this->test_item_rights("d", "id", $this->table_prefix."_glossary", $request_id, false, $ctg_owner_id))
					$main->message_access_denied($this->module_name, $action);

				if ($this->delete_term($request_id)) {
					@$cache->delete_cache_files();
					$lc->delete_internal_links($this->module_name, "glossary", $request_id);
				}
				header("Location: $baseurl&action=list&category=$request_category&start=$request_start");
				exit;
				break;

// Отключение публикации
			case "suspend":
				if (!$permissions["p"]) $main->message_access_denied($this->module_name, $action);
				global $request_category, $request_id, $request_start;
				list($category_title, $ctg_owner_id) = $this->show_category($request_category, false);
				if (!$this->test_item_rights("p", "id", $this->table_prefix."_glossary", $request_id, false, $ctg_owner_id))
					$main->message_access_denied($this->module_name, $action);

				if ($main->suspend($this->table_prefix.'_glossary', $request_id)) @$cache->delete_cache_files();
				header("Location: $baseurl&action=list&category=$request_category&start=$request_start");
				exit;
				break;

// Включение публикации
			case "activate":
				if (!$permissions["p"]) $main->message_access_denied($this->module_name, $action);
				global $request_category, $request_id, $request_start;
				list($category_title, $ctg_owner_id) = $this->show_category($request_category, false);
				if (!$this->test_item_rights("p", "id", $this->table_prefix."_glossary", $request_id, false, $ctg_owner_id))
					$main->message_access_denied($this->module_name, $action);

				if ($main->activate($this->table_prefix.'_glossary', $request_id)) @$cache->delete_cache_files();
				header("Location: $baseurl&action=list&category=$request_category&start=$request_start");
				exit;
				break;


// Удалить выбранные термины
			case "delete_checked":
				if (!$permissions["d"]) $main->message_access_denied($this->module_name, $action);
				global $request_category, $request_check, $request_start;
				if(is_array($request_check)) {
					list($category_title, $ctg_owner_id) = $this->show_category($request_category, false);
					foreach($request_check as $k => $v) {
						if ($this->test_item_rights("d", "id", $this->table_prefix."_glossary", $v, false, $ctg_owner_id)) {
							if ($this->delete_term($v)) {
								@$cache->delete_cache_files();
								$lc->delete_internal_links($this->module_name, "glossary", $v);
							}
						}
					}
				}
				header("Location: $baseurl&action=list&category=$request_category&start=$request_start");
				exit;
				break;

// Отключить публикацию выбранных терминов
			case "suspend_checked":
				if (!$permissions["p"]) $main->message_access_denied($this->module_name, $action);
				global $request_category, $request_check, $request_start;
				if(is_array($request_check)) {
					list($category_title, $ctg_owner_id) = $this->show_category($request_category, false);
					foreach($request_check as $k => $v) {
						if ($this->test_item_rights("p", "id", $this->table_prefix."_glossary", $v, false, $ctg_owner_id)) {
							if ($main->suspend($this->table_prefix.'_glossary', $v)) @$cache->delete_cache_files();
						}
					}
				}
				header("Location: $baseurl&action=list&category=$request_category&start=$request_start");
				exit;
				break;

// Включить публикацию выбранных терминов
			case "activate_checked":
				if (!$permissions["p"]) $main->message_access_denied($this->module_name, $action);
				global $request_category, $request_check, $request_start;
				if(is_array($request_check)) {
					list($category_title, $ctg_owner_id) = $this->show_category($request_category, false);
					foreach($request_check as $k => $v) {
						if ($this->test_item_rights("p", "id", $this->table_prefix."_glossary", $v, false, $ctg_owner_id)) {
							if ($main->activate($this->table_prefix.'_glossary', $v)) @$cache->delete_cache_files();
						}
					}
				}
				header("Location: $baseurl&action=list&category=$request_category&start=$request_start");
				exit;
				break;


// Редактирование прав элемента галереи
			case 'editrights':
				if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $request_id, $request_category, $request_start;
				list($category_title, $ctg_owner_id) = $this->show_category($request_category, false);
				if (!$this->test_item_rights("e", "id", $this->table_prefix."_glossary", $request_id, true, $ctg_owner_id))
					$main->message_access_denied($this->module_name, $action);

				if (!$this->show_rights_form($this->table_prefix."_glossary", "term", $request_id,
											"&id=".$request_id."&category=".$request_category."&start=".$request_start, $this->_msg["Term"])) {
					header('Location: '.$baseurl.'&action=list&category='.$request_category.'&start='.$request_start);
				}
				break;

// Сохранение прав элемента галереи
			case 'saverights':
				if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $request_id, $request_category, $request_start, $request_rights;
				list($category_title, $ctg_owner_id) = $this->show_category($request_category, false);
				if (!$this->test_item_rights("e", "id", $this->table_prefix."_glossary", $request_id, true, $ctg_owner_id))
					$main->message_access_denied($this->module_name, $action);

				$this->save_rights_form($this->table_prefix."_glossary", $request_id, $request_rights);
				if ($request_type == "JsHttpRequest") {
					$_RESULT = array(
						"res"	=> 1,
						"id"	=> $request_id,
					);
				} else {
					header('Location: '.$baseurl.'&action=list&category='.$request_category.'&start='.$request_start);
				}
				exit;
				break;


// Показать категории
			case "showctg":
				if (!$permissions["r"]) $main->message_access_denied($this->module_name, $action);
				$main->include_main_blocks_2($this->module_name."_categories.html", $this->tpl_path);
				$tpl->assignInclude( "search_form", $tpl_path . "_search_form.html" );
				$tpl->prepare();
				$tpl->assign(array(
					"MSG_Empty_field" => $this->_msg["Empty_field"],
					"MSG_Ed" => $this->_msg["Ed"],
					"MSG_Rights" => $main->_msg["Rights"],
					"MSG_Category" => $this->_msg["Category"],
					"MSG_Del" => $this->_msg["Del"],
					"MSG_Create_new_category" => $this->_msg["Create_new_category"],
					"MSG_Create" => $this->_msg["Create"],
					"_ROOT.form_search_action"	=>	"$baseurl&action=search",
					"_ROOT.lang"				=>	$lang,
					"_ROOT.name"				=>	$this->module_name,
					"_ROOT.action"				=>	"search",
					"_ROOT.form_action"			=>	$baseurl."&action=addctg",
				));
				$res = $this->show_categories();
				if (!$res && isset($_REQUEST['empty'])) {
				    $tpl->newBlock('warning');
				    $tpl->assign('txt', 'Список категорий пуст.');
				}
				$this->main_title = $this->_msg["Glossary_categories"];
				break;

// Добавить категорию
			case "addctg":
				if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
				global $request_title, $request_block_id;
				if ($this->add_category($request_title, intval(substr($request_block_id, 10)))) @$cache->delete_cache_files();
				header("Location: $baseurl&action=showctg");
				exit;
				break;

// Вывод категории для редактирования
			case "editctg":
				if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
				global $request_category;
				if (!$this->test_item_rights("e", "id", $this->table_prefix."_glossary_categories", $request_category))
					$main->message_access_denied($this->module_name, $action);

				$main->include_main_blocks_2($this->module_name."_edit_category.html", $this->tpl_path);
				$tpl->prepare();
				$tpl->assign(Array(
					"MSG_Empty_field" => $this->_msg["Empty_field"],
					"MSG_Save" => $this->_msg["Save"],
					"MSG_Cancel" => $this->_msg["Cancel"],
					"_ROOT.form_action"	=>	"$baseurl&action=updatectg",
					"_ROOT.cancel_link"	=>	"$baseurl&action=showctg",
				));
				$this->show_category($request_category);
				$this->main_title = $this->_msg["Edit_category"];
				break;

// Обновить категорию
			case "updatectg":
				if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
				global $request_category, $request_title;
				if (!$this->test_item_rights("e", "id", $this->table_prefix."_glossary_categories", $request_category))
					$main->message_access_denied($this->module_name, $action);

				if ($this->update_category($request_category, $request_title)) @$cache->delete_cache_files();
				header("Location: $baseurl&action=showctg");
				exit;
				break;

// Удалить категорию
			case "delctg":
				if (!$permissions["d"]) $main->message_access_denied($this->module_name, $action);
				global $request_step, $request_category;
				if (!$this->test_item_rights("d", "id", $this->table_prefix."_glossary_categories", $request_category))
					$main->message_access_denied($this->module_name, $action);

				// Удаление категории, первый шаг
				if (!$request_step || $request_step == 1) {
					$main->include_main_blocks_2($this->module_name."_del_category.html", $this->tpl_path);
					$tpl->prepare();
					$tpl->assign(Array(
						"MSG_Deleting_category" => $this->_msg["Deleting_category"],
						"MSG_deletes_all_its_terms" => $this->_msg["deletes_all_its_terms"],
						"MSG_Confirm_delete_this_category" => $this->_msg["Confirm_delete_this_category"],
						"MSG_Cancel" => $this->_msg["Cancel"],
						"MSG_Delete" => $this->_msg["Delete"],
					));
					$tpl->assign(
						array(
							"_ROOT.form_action"	=>	"$baseurl&action=delctg&step=2&category=$request_category",
							"_ROOT.cancel_link"	=>	"$baseurl&action=showctg",
						)
					);
					$this->show_category($request_category);
					$this->main_title = $this->_msg["Category_deleting"];
				// Удаление категории, шаг второй
				} else if ($request_step == 2) {
					if ($this->delete_category($request_category)) @$cache->delete_cache_files();
					header("Location: $baseurl&action=showctg");
					exit;
				}
				break;

// Редактирование прав категории
			case 'editctgrights':
				if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $request_category, $request_start;
				if (!$this->test_item_rights("e", "id", $this->table_prefix."_glossary_categories", $request_category, true))
					$main->message_access_denied($this->module_name, $action);

				if (!$this->show_rights_form($this->table_prefix."_glossary_categories", "title", $request_category,
											"&category=".$request_category, $this->_msg["Category"], "savectgrights")) {
					header('Location: '.$baseurl);
				}
				break;

// Сохранение прав категории
			case 'savectgrights':
				if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $request_category, $request_start, $request_rights;
				if (!$this->test_item_rights("e", "id", $this->table_prefix."_glossary_categories", $request_category, true))
					$main->message_access_denied($this->module_name, $action);

				$this->save_rights_form($this->table_prefix."_glossary_categories", $request_category, $request_rights);
				if ($request_type == "JsHttpRequest") {
					$_RESULT = array(
						"res"	=> 1,
						"category"	=> $request_category,
					);
				} else {
					header('Location: '.$baseurl);
				}
				exit;
				break;
				
			case "import":
			    if (!$permissions["e"]) {
			        $main->message_access_denied($this->module_name, $action);
			    }
			    
			    $main->include_main_blocks_2($this->module_name.'_'.$action.'.html', $this->tpl_path);
			    $tpl->prepare();
			    
			    $report = false;
			    if ($_FILES['csv_file']['tmp_name'] && is_uploaded_file($_FILES['csv_file']['tmp_name'])) {
			        if ('ctgr' == $_POST['type']) {
			            $report = $this->csvImportCtgrs($_FILES['csv_file']['tmp_name']);
			        } else if ('term' == $_POST['type'] && $_POST['ctgr_id']) {
			            $report = $this->csvImportTerms($ctgr['id'], $_FILES['csv_file']['tmp_name']);
			        } else if ('ctgr_term' == $_POST['type']) {
			            $report = $this->csvImportAll($_FILES['csv_file']['tmp_name']);
			        } 
			    }
			    
			    if ($report) {
			        $tpl->newBlock('report');
			        $tpl->assign($report);
			        if ($report['err']) {
			            $tpl->newBlock('err');
			            $tpl->assign($report);
			        }
			    }
			    
			    $tpl->gotoBlock('_ROOT');
			    $assign = array(
			        'baseurl' => $baseurl,
			        'action' => $action
			    );
			    $tpl->assign($assign);
			    $tpl->assignList('ctgr_', $this->getCategories());
			    
			    $this->main_title = 'Импорт';
			    break;


// Редактирование свойств блока
			case 'properties':
				if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $module_id, $request_field, $request_block_id, $title;
				$main->include_main_blocks('_block_properties.html', 'main');
				$tpl->prepare();

				if ($main->show_actions($request_field, '', $this->block_main_module_actions, $this->block_module_actions)) {
					$main->show_linked_pages($module_id, $request_field);
				}

				$tpl->assign(array(	'_ROOT.title'		=> $title,
									'_ROOT.username'	=> $_SESSION['session_login'],
									'_ROOT.password'	=> $_SESSION['session_password'],
									'_ROOT.name'		=> $this->module_name,
									'_ROOT.lang'		=> $lang,
									'_ROOT.block_id'	=> $request_block_id,
									));

				$this->main_title = $this->_msg["Block_properties"];
				break;

// Создание объекта для дальнейшего использования
			case 'only_create_object':
				break;

// Default...
			default:
				$main->include_main_blocks();
				$tpl->prepare();
			}
//--------------------------- конец обработки действий из админ части --------------------------//
		}
	}


	// функция для вывода алфавитной навигации 
	// ----------------------------------------
	function show_alphabetic_nav($transurl, $category = "", $current = "") {

		global $CONFIG, $main, $db, $tpl, $server, $lang;
		$category = intval($category); $ctg_str = ($category) ? "category_id = $category AND " : "";
		$nav_string = "";

		$this->get_list_with_rights(
							"g.navletter",
							$this->table_prefix."_glossary AS g", "g",
							$ctg_str."g.active = 1", "g.navletter", "g.navletter");

		if ($db->nf() > 0) {

			$i = 0;
			$tpl->newBlock("block_alphabetic_nav");

			while($db->next_record()) {
				$i++;
				$separator = ($i == 1) ? "" : " | ";
				if ($db->f("navletter") == $current) {
					$add_str = "$separator<span>" . $db->f("navletter") . "</span>";
				} else {
					$url = "$transurl&action=list&start=" . urlencode($db->f("navletter"));
					$add_str = "$separator<a href=\"$url\">" . $db->f("navletter") . "</a>";
				}
				$nav_string .= $add_str;
			}
			$tpl->assign("nav_string", $nav_string);
			
			return 1;
		}

		return 0;
	}

	// функция для вывода списка записей
	function show_glossary($category = "", $start = "") {
		global $CONFIG, $main, $db, $tpl, $baseurl, $server, $lang;
		$category = intval($category);
		$ctg_str = ($category) ? "category_id = $category AND" : "";
		if ($start) {
			$start = My_Sql::escape($start);
			$start_str = "navletter = UPPER('".$start."') AND";
			$cnt_rec = 0;
			$this->addition_to_path = "<span style=\"text-transform: uppercase;\">$start</span>";
		} else {
			$this->get_list_with_rights(
							"g.navletter",
							$this->table_prefix."_glossary AS g", "g",
							$ctg_str." g.active = 1", "g.navletter", "g.navletter",
							1, 1);
			$db->next_record();
			$LETER = My_Sql::escape($db->f("navletter"));
			#$start_str = "navletter = UPPER('{$LETER}') AND";
			$cnt_rec = 10;
		}
		$order_by = $CONFIG["glossary_order_by"];

		$query = "SELECT * FROM ".$this->table_prefix."_glossary WHERE $start_str $ctg_str active = 1 ORDER BY $order_by $limit_str";
		$db->query($query);

		$this->get_list_with_rights(
						"g.*",
						$this->table_prefix."_glossary AS g", "g",
						$start_str." ".$ctg_str." g.active = 1", "", $order_by,
						1, $cnt_rec);
		if ($db->nf() > 0) {
			
			while($db->next_record()) {
				// вывод на экран списка
				
				$tpl->newBlock("block_glossary_terms");
				$tpl->assign(
					array(
						glossary_term	=>	$db->f("term"),
						glossary_description	=>	$db->f("description"),
						glossary_link	=>	"$baseurl&action=show&category=" . $db->f('category_id') . "&id=" . $db->f("id"),
						glossary_id	=>	$db->f('id'),
						start	=>	$start,
					)
				);
			}

			return 1;
		}
		return 0;
	}

	// функция для вывода записи по id
	function show_term($id = "", $start = "", $admin = 0) {
		$id = intval($id); if (!$id) return 0;
		global $CONFIG, $main, $db, $tpl, $baseurl, $server, $lang;
		$query = "SELECT * FROM ".$this->table_prefix."_glossary WHERE id = $id";
		$db->query($query);

		if ($db->nf() > 0) {
			$db->next_record();
			
			if ($admin) {
				$tpl->assign(
					array(
						'glossary_term'			=> htmlspecialchars($db->f('term')),
						'text'					=> $db->f('description'),
						'glossary_navletter'	=> $db->f('navletter'),
						'glossary_id'			=> $db->f('id'),
					)
				);
			} else {
				$tpl->newBlock("block_term");
				$tpl->assign(
					array(
						glossary_term			=>	$db->f("term"),
						glossary_description	=>	$db->f("description"),
						glossary_navletter		=>	$db->f("navletter"),
						glossary_id				=>	$db->f("id"),
					)
				);
			}

			return 1;
		}
		return 0;
	}

	// функция для вывода списка категорий
	function show_categories($selected_category = "", $only_editable = false) {
		global $CONFIG, $db, $tpl, $baseurl, $server, $lang;
		$selected_category = intval($selected_category);
		$this->get_list_with_rights("C.*", $this->table_prefix."_glossary_categories AS C", "C", "", "", "C.id");
		$cnt = $db->nf();
		if ($cnt) {
			$actions = array(	"edit"		=> "editctg",
								"editrights"=> "editctgrights",
								"delete"	=> "delctg",
								"confirm_delete"	=> ""
							);
			while($db->next_record()) {
				if ($only_editable && !($db->f("user_rights") & 2)) continue;

				// вывод на экран списка
				$id = $db->f('id');
				$adm_actions = $this->get_actions_by_rights($baseurl."&category=".$id, 0, $db->f("is_owner"), $db->f("user_rights"), $actions);
				$selected = ($id == $selected_category) ? " selected" : "";
				$tpl->newBlock('block_categories');
				$tpl->assign(
					array(
						category_title		=>	$db->f("title"),
						category_link		=>	"$baseurl&action=list&category=" . $db->f("id"),
						category_edit_action=>	$adm_actions["edit_action"],
						category_edit_rights_action	=>	$adm_actions["edit_rights_action"],
						category_del_action	=>	$adm_actions["delete_action"],
						category			=>	$db->f("id"),
						selected			=>	$selected,
					)
				);
			}
			return $cnt;
		}
		return 0;
	}

	function getPropertyFields() {
		GLOBAL $request_site_target, $request_sub_action;
		if ('' != $request_sub_action) {

			$tpl = $this->getTmpProperties();

			switch ($request_sub_action) {
				case 'list':
					$tpl->newBlock('block_properties');
					$tpl->assign(Array(
						"MSG_Category" => $this->_msg["Category"],
						"MSG_All_categories" => $this->_msg["All_categories"],
					));
					$list = $this->getCategories();
					abo_str_array_crop($list);
					$tpl->assign_array('block_categories', $list);
					$tpl->newBlock('block_page_edit');
					$tpl->assign(Array(
						"MSG_Goto_edit" => $this->_msg["Goto_edit"],
						"site_target" => $request_site_target,
					));
					break;

				default:
					$tpl->newBlock('block_properties');
					$tpl->assign(Array(
						"MSG_Category" => $this->_msg["Category"],
						"MSG_All_categories" => $this->_msg["All_categories"],
					));
					break;
			}
			return $this->getOutputContent($tpl->getOutputContent());
		}
		return FALSE;
	}

	function getEditLink($sub_action = NULL, $block_id = NULL) {
		GLOBAL $request_name, $db, $lang, $server;
		$block_id	= (int)$block_id;
		if ($sub_action && $block_id) {
			$db->query('SELECT	property1,
								property2,
								property3,
								property4,
								property5
							FROM '.$this->table_prefix.'_pages_blocks
							WHERE id = '.$block_id);
			if ($db->nf() > 0) {
				$db->next_record();
				$arr[]	= $db->f('property1');
				$arr[]	= $db->f('property2');
				$arr[]	= $db->f('property3');
				$arr[]	= $db->f('property4');
				$arr[]	= $db->f('property5');

				switch ($sub_action) {
					case 'list':
						$link['material_url']	= '/admin.php?lang='.$lang.'&name='.$request_name.'&action=list&menu=false&category=';
						$link['material_id']	= $arr[0];
						break;
				}
				return $link;
			}

			switch ($sub_action) {
				case 'list':
					$link['material_url']	= '/admin.php?lang='.$lang.'&name='.$request_name.'&action=list&menu=false&category=';
					$link['material_id']	= '';
					break;
			}
			return $link;
		}
		return FALSE;
	}

	// получение массива категорий
	function getCategories($selected_category = '') {
		GLOBAL $CONFIG, $db, $baseurl, $server, $lang;
		$selected_category	= (int)$selected_category;
		$db->query('SELECT * FROM '.$this->table_prefix.'_glossary_categories ORDER BY id');
		if ($db->nf() > 0) {
			while($db->next_record()) {
				$selected = ($db->f('id') == $selected_category) ? ' selected' : '';
				$arr[]	= array('category_title'		=> $db->f('title'),
								'category_link'			=> $baseurl.'&action=list&category='.$db->f('id'),
								'category_edit_link'	=> $baseurl.'&action=editctg&category='.$db->f('id'),
								'category_del_link'		=> $baseurl.'&action=delctg&category='.$db->f('id'),
								'category'				=> $db->f('id'),
								'selected'				=> $selected,
								);
			}
			return $arr;
		}
		return FALSE;
	}
	
	function getCategory($id)
	{   GLOBAL $db;
	    
	    return $db->fetchOne($this->table_prefix.'_glossary_categories', array('clause' => array('id' => $id)));
	}

	// функция для добавления записи в базе данных
	function add_term($category, $term, $navletter, $description, $item_rights, $block_id = 0) {
		global $CONFIG, $db, $server, $lang;
    	$category = intval($category); if (!$category) return 0;
		$term = $db->escape(trim(strip_tags($term))); if (!$term) return 0;

		$db->query("SELECT usr_group_id FROM ".$this->table_prefix."_glossary_categories WHERE id=".$category);
		if (!$db->next_record()) return 0;
		$owner_id = $_SESSION["siteuser"]["id"];
		list($group_id, $rights) = $this->get_group_and_rights('glossary_default_rights', $block_id, $db->f("usr_group_id"));
		$rights = $item_rights ? $item_rights : $rights;

		$description = $db->escape($description);

		$query = "INSERT INTO ".$this->table_prefix."_glossary (term, navletter, description, category_id, owner_id, usr_group_id, rights)
					VALUES ('$term', UPPER(LEFT(term,1)), '$description', $category, $owner_id, $group_id, $rights)";
		$db->query($query);
		$ret = ($db->affected_rows() > 0) ? $db->lid() : 0;
		return $ret;
	}


	// функция для обновления записи в базе данных
	function update_term($category, $term, $description = "", $id = "") {
    	global $CONFIG, $db, $server, $lang;
		$id			= (int)$id;
	    $category	= (int)$category;
		$term		= $db->escape($term);
	    if (!$id || !$category || !$term) return FALSE;

		$description = $db->escape($description);

		$query = "UPDATE ".$this->table_prefix."_glossary SET term = '$term', navletter = UPPER(LEFT(term,1)), description = '$description', category_id = $category WHERE id = $id";
		$db->query($query);

		return $db->errno ? false : true;
	}


	// функция для удаления записи из базы данных
	function delete_term($id) {
		global $CONFIG, $db, $server, $lang;
		$id		= (int)$id;
		if (!$id) return FALSE;
		$query	= "DELETE FROM ".$this->table_prefix."_glossary WHERE id = $id";
		$db->query($query);
		return ($db->affected_rows() > 0) ? TRUE : FALSE;
	}

	// функция для вывода списка записей
	function show_glossary_adm($category = "", $start = "", $search = "", $owner_id = 0) {
		global $CONFIG, $main, $db, $tpl, $baseurl, $server, $lang;
		$category	= (int)$category;
		if (!$category && !$search) return FALSE;
		$start		= (int)$start;
		$start		= ($start) ? $start : 1;
		$rows		= $CONFIG["glossary_max_rows"];
		$order_by	= $CONFIG["glossary_admin_order_by"];
		if ($search) {
			$search	= $db->escape($search);
			$this->get_list_with_rights(
							"g.*", $this->table_prefix."_glossary g", "g",
							"term LIKE '%$search%' OR id = '$search'", "id", $order_by,
							1, 0,
							false, $owner_id);
			$pages_cnt = 1;
		} else {
			$total_cnt = $this->get_list_with_rights(
									"g.*", $this->table_prefix."_glossary g", "g",
									"category_id = ".$category, "", $order_by,
									$start, $rows,
									true, $owner_id);
			$pages_cnt = ceil($total_cnt/$rows);
		}

		if ($db->nf() > 0) {
			$actions = array(	"edit"		=> "edit",
								"editrights"=> "editrights",
								"activate"	=>	array("activate","suspend"),
								"delete"	=> "del",
								"confirm_delete"	=> $this->_msg["Confirm_delete_this_term"]
							);
			while($db->next_record()) {
				// вывод на экран списка
				$id = $db->f('id');
				$category_id = $db->f('category_id');
				$adm_actions = $this->get_actions_by_rights($baseurl."&id=".$id."&category=".$category_id."&start=".$start, $db->f("active"), $db->f("is_owner"), $db->f("user_rights"), $actions);

				$tpl->newBlock("block_glossary_terms");
				$tpl->assign(
					array(
					'glossary_term'				=>	$db->f("term"),
					'glossary_description'		=>	$db->f("description"),
					'glossary_edit_action'		=>	$adm_actions["edit_action"],
					'glossary_edit_rights_action'=>	$adm_actions["edit_rights_action"],
					'glossary_del_action'		=>	$adm_actions["delete_action"],
					'change_status_action'		=>	$adm_actions["change_status_action"],
					'action_text'				=>	$action_text,
					'action_img'				=>	$action_img,
					'glossary_id'				=>	$id,
					'start'						=>	$start,
				));
				if ($adm_actions["rights"]["d"] || $adm_actions["rights"]["p"]) {
					$tpl->newBlock('block_check');
					$tpl->assign("glossary_id", $id);
				}
			}
			return $pages_cnt;
		}
		return 0;
	}

	// функция для вывода категории по id
	function show_category($id = "", $need_output = true) {
		$id = intval($id);		if (!$id) return 0;
		global $CONFIG, $db, $tpl, $baseurl, $server, $lang;
		$query = "SELECT * FROM ".$this->table_prefix."_glossary_categories WHERE id = $id";
		$db->query($query);
		if ($db->nf() > 0) {
			$db->next_record();
			$title = htmlspecialchars($db->f("title"));
			//вывод на экран
			if ($need_output) {
				$tpl->assign(
					array(
						category	=>	$db->f("id"),
						category_title	=>	$title,
						category_link	=>	"$baseurl&action=list&category=" . $db->f("id"),
					)
				);
			}

			return array($db->f("title"), $db->f("owner_id"));
		}
		return 0;
	}


	// функция для добавления категории
	function add_category($title, $block_id = 0) {
		global $CONFIG, $db, $server, $lang;
		$title = $db->escape(trim($title));
		if (!$title) return FALSE;

		$owner_id = $_SESSION["siteuser"]["id"];
		list($group_id, $rights) = $this->get_group_and_rights('glossary_default_rights', $block_id);

		$query = "INSERT INTO ".$this->table_prefix."_glossary_categories (title,owner_id,usr_group_id,rights)
					VALUES ('$title',$owner_id,$group_id,$rights)";
		$db->query($query);
		return ($db->affected_rows() > 0) ? $db->lid() : FALSE;
	}


	// функция для обновления категории по id
	function update_category($id, $title) {
		global $CONFIG, $db, $server, $lang;
		$id		= (int)$id;
		if (!$id || !$title) return FALSE;
		$title	= $db->escape($title);
		$query	= "UPDATE ".$this->table_prefix."_glossary_categories SET title = '$title' WHERE id = $id";
		$db->query($query);
		return $db->errno ? FALSE : TRUE;
	}

	// функция для удаления категории по id
	function delete_category($id = "") {
		global $CONFIG, $db, $tpl, $server, $lang;
		$id		= (int)$id;
		if (!$id) return FALSE;
		$query	= "DELETE FROM ".$this->table_prefix."_glossary_categories WHERE id = $id";
		$db->query($query);
		if ($db->affected_rows() > 0) {
			$query = "DELETE FROM ".$this->table_prefix."_glossary WHERE category_id = $id";
			$db->query($query);
			return TRUE;
		}
		return FALSE;
	}
	
	function csvImportTerms($ctgr_id,  $file_path)
	{   global $db;
	    $ret = false;
	    $ctgr = $this->getCategory($_POST['ctgr_id']);
	    if ($ctgr && $file_path && file_exists($file_path)) {
	        setLocale(LC_ALL, 'ru_RU.CP1251');
	        $fp = fopen($file_path, 'r');
	        $report = array(
	            'line' => 0, 'err' => '',
	            'add_ctgr' => 0, 'upd_ctgr' => 0,
	            'add_term' => 0, 'upd_term' => 0
	        );
	        if ($fp) {
	            $meta = array(
	                'term_list' => array(),
	            );
	            $db->query('SELECT id, term FROM '.$this->table_prefix.'_glossary WHERE category_id='.$ctgr['id']);
	            while ($db->next()) {
	                $meta['term_list'][$db->Record['id']] = $db->Record['term'];
	            }
	            while (! feof($fp)) {
	                $report['line']++;
	                $data = fgetcsv($fp, 4096, ';');
	                if ($data[0]) {
                        $term_title = iconv('WINDOWS-1251', 'UTF-8', $data[0]);
                        $term_dscr = iconv('WINDOWS-1251', 'UTF-8', $data[1]);
                        $k = array_search($term_title, $meta['term_list']);
                        if ($k) {
                            if ($this->update_term($ctgr['id'], $term_title, $term_dscr, $k)) {
                                $report['upd_term']++;
                            } else {
                                $report['err'] .= "Строка ".$report['line'].". Ошибка обновления термина.";
                            }
                        } else {
	                        if ($id = $this->add_term($ctgr['id'], $term_title, false, $term_dscr)) {
	                            $report['add_term']++;
	                            $meta['term_list'][$id] = $term_title;
	                        } else {
	                            $report['err'] .= "Строка ".$report['line'].". Ошибка добавления термина.";
	                        }
                        }
                    }
	            }
	            fclose($fp);
	            $ret = $report;
	        }
	    }
	    
	    return $ret;
	}
	
	function csvImportCtgrs($file_path)
	{   global $db;
	    $ret = false;
	    if ($file_path && file_exists($file_path)) {
	        setLocale(LC_ALL, 'ru_RU.CP1251');
	        $fp = fopen($file_path, 'r');
	        $report = array(
	            'line' => 0, 'err' => '',
	            'add_ctgr' => 0, 'upd_ctgr' => 0,
	            'add_term' => 0, 'upd_term' => 0
	        );
	        if ($fp) {
	            $meta = array(
	                'ctgr_list' => array()
	            );
	            $db->query('SELECT id, title FROM '.$this->table_prefix.'_glossary_categories');
	            while ($db->next()) {
	                $meta['ctgr_list'][$db->Record['id']] = $db->Record['title'];
	            }
	            while (! feof($fp)) {
	                $report['line']++;
	                $data = fgetcsv($fp, 4096, ';');
	                if ($data) {
	                    if ($data[0]) {
	                        $ctgr_title = iconv('WINDOWS-1251', 'UTF-8', $data[0]);
	                        $k = array_search($ctgr_title, $meta['ctgr_list']);
	                        if (! $k) {
    	                        if ($id = $this->add_category($ctgr_title)) {
    	                            $report['add_ctgr']++;
    	                            $meta['ctgr_list'][$id] = $ctgr_title;
    	                        } else {
    	                            $report['err'] .= "Строка ".$report['line'].". Ошибка добавления категории.";
    	                        }
	                        }
	                    }
	                }
	            }
	            fclose($fp);
	            $ret = $report;
	        }
	    }
	    
	    return $ret;
	}
	
	function csvImportAll($file_path)
	{   global $db;
	    $ret = false;
	    if ($file_path && file_exists($file_path)) {
	        setLocale(LC_ALL, 'ru_RU.CP1251');
	        $fp = fopen($file_path, 'r');
	        $report = array(
	            'line' => 0, 'err' => '',
	            'add_ctgr' => 0, 'upd_ctgr' => 0,
	            'add_term' => 0, 'upd_term' => 0
	        );
	        if ($fp) {
	            $meta = array(
	                'ctgr_list' => array(),
	                'term_list' => array(),
	                'ctgr_term' => array()
	            );
	            $db->query('SELECT id, title FROM '.$this->table_prefix.'_glossary_categories');
	            while ($db->next()) {
	                $meta['ctgr_list'][$db->Record['id']] = $db->Record['title'];
	            }
	            $db->query('SELECT id, term, category_id FROM '.$this->table_prefix.'_glossary');
	            while ($db->next()) {
	                $meta['term_list'][$db->Record['category_id']][$db->Record['id']] = $db->Record['term'];
	            }
	            while (! feof($fp)) {
	                $report['line']++;
	                $data = fgetcsv($fp, 4096, ';');
	                if ($data) {
	                    if ($data[0]) {
	                        $ctgr_title = iconv('WINDOWS-1251', 'UTF-8', $data[0]);
	                        $term_title = iconv('WINDOWS-1251', 'UTF-8', $data[1]);
	                        $term_dscr = iconv('WINDOWS-1251', 'UTF-8', $data[2]);
	                        $ctgr_id = array_search($ctgr_title, $meta['ctgr_list']);
	                        if (!$ctgr_id) {
    	                        if ($ctgr_id = $this->add_category($ctgr_title)) {
    	                            $report['add_ctgr']++;
    	                            $meta['ctgr_list'][$ctgr_id] = $ctgr_title;
    	                        } else {
    	                            $report['err'] .= "Строка ".$report['line'].". Ошибка добавления категории.";
    	                        }
	                        }
	                        if ($ctgr_id) {
	                            if (! isset($meta['term_list'][$ctgr_id])) {
	                                $meta['term_list'][$ctgr_id] = array();
	                            }
	                            $k = array_search($term_title, $meta['term_list'][$ctgr_id]);
	                            if ($k) {
	                                if ($this->update_term($ctgr_id, $term_title, $term_dscr, $k)) {
	                                    $report['upd_term']++;
	                                } else {
	                                    $report['err'] .= "Строка ".$report['line'].". Ошибка обновления термина.";
	                                }
	                            } else {
	                                if ($id = $this->add_term($ctgr_id, $term_title, false, $term_dscr)) {
	                                    $report['add_term']++;
	                                    $meta['term_list'][$ctgr_id][$id] = $term_title;
	                                } else {
	                                    $report['err'] .= "Строка ".$report['line'].". Ошибка добавления термина.";
	                                }
	                            }
	                        }
	                    }
	                }
	            }
	            fclose($fp);
	            $ret = $report;
	        }
	    }
	    
	    return $ret;
	}
}

?>