<?php

class JobPrototype extends Module {

	var $main_title;
	var $table_prefix;
	var $addition_to_path;
	var $module_name				= 'job';
	var $default_action				= 'list';
	var $admin_default_action		= 'vacancy';
	var $tpl_path					= 'mod/job/tpl/';
	var $block_module_actions		= array();
	var $block_main_module_actions	= array();
	var $is_admin                  = false;

	function JobPrototype($action = '', $transurl = '', $properties = array(), $prefix = NULL, $rewrite_mod_params = NULL, $adminurl = NULL, $noadmin = false) {
		global $main, $tpl, $tpl_path, $baseurl, $cache, $lc, $CONFIG, $PAGE, $server, $lang,	$permissions, $request_type, $_RESULT;
		
		/* Get $action, $tpl_name, $permissions */
		extract( $this->init(array(
		        'server' => $server, 'lang' => $lang, 'prefix' => $prefix,
		        'action' => $action, 'tpl_name' => $properties['tpl']
		)), EXTR_OVERWRITE);
		
		$this->block_module_actions = array(
		        'vacancysearch'   => $this->_msg["Vacancy_search"],
		        'resumesearch'    => $this->_msg["Resume_search"],
		        'vacancysearchform'   => $this->_msg["Vacancy_search_form"],
		        'resumesearchform'    => $this->_msg["Resume_search_form"],
		);
		$this->block_main_module_actions  = array(
		        'vacancysearch'   => $this->_msg["Vacancy_search"],
		        'resumesearch'    => $this->_msg["Resume_search"],
		        'vacancysearchform'   => $this->_msg["Vacancy_search_form"],
		        'resumesearchform'    => $this->_msg["Resume_search_form"],
		);

		$category = $field = (int)$properties[1];
		$rows = (int)$properties[2];
		if (!$rows) $rows = $CONFIG['job_max_rows'];

		$this->is_admin = $is_admin = $noadmin ? 0 : self::is_admin();
		
		if ('only_create_object' == $action) {
		    return;
		}
		
		if ($this->actionExists($action)) {
		    $this->doAction($action);
		    return;
		}

		if (! self::is_admin()) {

		    if ($_SESSION['siteuser']['id'] && in_array($action, array('userresume', 'usrvcncsshw', 'uservacancy', 'uservacancies')) ) {
            	$PAGE['current_user_id'] = $_SESSION['siteuser']['id'];
            }

		    if (0 == $PAGE['field'] && ($_REQUEST['user_id'] || $_REQUEST['data']['owner_id'])
		        && in_array($action, array('usrvcncsshw', 'resume', 'vacancy'))
		    ) {
		    	$PAGE['current_user_id'] = $_REQUEST['user_id'] ? $_REQUEST['user_id'] : $_REQUEST['data']['owner_id'];
		    }

		    if ($PAGE['current_user_id']) {
		    	if (!class_exists('SiteusersPrototype')) {
					require(RP."mod/siteusers/lib/class.SiteusersPrototype.php");
				}
				$this->addition_to_path = array(SiteusersPrototype::getUserName($PAGE['current_user_id']) => '');
		    }
//---------------------------------- обработка действий с сайта --------------------------------//
			switch ($action) {
			/**
			 * Показать резюме
			 */
			case "resume":
				$main->include_main_blocks($this->module_name . "_".$action.".html", "main");
				$tpl->prepare();
				$resume = $_REQUEST['user_id']
				    ? $this->GetUserResume($_REQUEST['user_id'])
				    : $this->GetResume($_REQUEST['id']);
				$this->ShowResume($resume, $_REQUEST['data'], $_REQUEST['start']);

				break;
			/**
			 * Показать форму поиска резюме
			 */
			case "resumesearchform":
				$main->include_main_blocks($this->module_name . "_".$action.".html", "main");
				$tpl->prepare();
				global $request_data, $request_start;

				$this->ShowResumeSrchForm($transurl, $request_data['ref_city'], $request_data['ref_activity']);

				break;

			/**
			 * Показать форму поиска резюме и результат
			 */
			case "resumesearch":
				$main->include_main_blocks($this->module_name . "_".$action.".html", "main");
				$tpl->prepare();
				global $request_data, $request_start;

				$this->ShowResumeSrchForm($transurl, $request_data['ref_city'], $request_data['ref_activity']);
				if ($request_data['ref_city']) {
					$this->ShowResumeList($request_start, 0, $request_data, $action);
				}

				break;
			/**
			 * Показать форму поиска вакансии
			 */
			case "vacancysearchform":
				$main->include_main_blocks($this->module_name . "_".$action.".html", "main");
				$tpl->prepare();
				global $request_data, $request_start;

				$this->ShowVacancySrchForm($transurl, $request_data['ref_city'], $request_data['ref_activity']);
				break;
			/**
			 * Показать форму поиска вакансии и результат поиска
			 */
			case "vacancysearch":
				$main->include_main_blocks($this->module_name . "_".$action.".html", "main");
				$tpl->prepare();
				global $request_data, $request_start;

				$this->ShowVacancySrchForm($transurl, $request_data['ref_city'], $request_data['ref_activity']);

				if ($request_data['ref_city']) {
					$this->ShowVacancyList($request_start, 0, $request_data, $action);
				}
				break;
			/**
			 * Показать вакансию
			 */
			case "vacancy":
				$main->include_main_blocks($this->module_name . "_".$action.".html", "main");
				$tpl->prepare();

				$this->ShowVacancy($this->GetVacancy($_REQUEST['id']), $_REQUEST['data'], $_REQUEST['start']);

				break;
			/**
			 * Показать форму добавления/редактирования резюме текущего пользователя
			 */
			case "userresume":
				$main->include_main_blocks($this->module_name . "_resumeform.html", "main");
				$tpl->prepare();

				$this->ShowUserResumeForm();

				break;
			/**
		     * Добавить/редактировать резюме
		     */
			case 'setresume':
		        if (! $this->CheckUserResume($_REQUEST['data']['id'])) {
		            header("Location: ".$baseurl."&action=userresume&err");
		            exit;
		        }
		        $_REQUEST['data']['active'] = 1;
		        $resume_id = $this->SetResume($_REQUEST['data']);

		        if ($GLOBALS['JsHttpRequest']) {
		        	if (! $resume_id) {
		        		$GLOBALS['_RESULT']['err'] = true;
		        	} else {
		        	    $GLOBALS['_RESULT'] = $this->GetResume($resume_id);
		        	}
		        	exit;
		        }
		        Module::go_back($_REQUEST['ref']);
		        header("Location: ".$baseurl."&action=userresume");
		        exit;
		    	break;
			/**
		     * Удалить резюме
		     */
			case 'delresume':
                if (! $this->CheckUserResume($_REQUEST['id'])) {
                  header("Location: ".$baseurl."&action=userresume&err");
                  exit;
                }
                $del = $this->DelResume($_REQUEST['id']);
                if ($GLOBALS['JsHttpRequest']) {
                	if (! $del) {
                		$GLOBALS['_RESULT']['err'] = true;
                	} else {
                	    $GLOBALS['_RESULT'] = true;
                	}
                	exit;
                }
                Module::go_back();
                header("Location: ".$baseurl."&action=userresume");
                exit;
    	    	break;
			/**
			 * Показать список вакансий текущего пользователя
			 */
			case "uservacancies":
				$main->include_main_blocks($this->module_name . "_uservacancies.html", "main");
				$tpl->prepare();

				if (! $_SESSION["siteuser"]["is_authorized"]) {
					$tpl->newBlock('block_access_deny');
					break;
				}

				$tpl->newBlock('block_vacancies');
				$tpl->assign('baseurl', $baseurl);
				$this->ShowVacancyList(
				    $_REQUEST['start'],
				    $CONFIG['job_max_rows'],
				    array('owner_id' => $_SESSION["siteuser"]["id"]),
				    $action
				);

				break;

			/**
			 * Показать список вакансий текущего пользователя
			 */
			case "usrvcncsshw":
			  global $request_user_id;
				$main->include_main_blocks($this->module_name . "_uservacancies.html", "main");
				$tpl->prepare();
				/*
				if (! $_SESSION["siteuser"]["is_authorized"]) {
					$tpl->newBlock('block_access_deny');
					break;
				}
				*/
				$tpl->newBlock('block_vacancies');
				$tpl->assign('baseurl', $baseurl);
				$this->ShowVacancyList(
				    $_REQUEST['start'],
				    $CONFIG['job_max_rows'],
				    array('owner_id' => $request_user_id),
				    $action
				);

				break;

			/**
			 * Показать форму добавления/редактирования вакансии пользователя
			 */
			case "uservacancy":
				$main->include_main_blocks($this->module_name . "_vacancyform.html", "main");
				$tpl->prepare();

				$this->ShowUserVacancyForm($_REQUEST['id']);

				break;
			/**
		     * Добавить/редактировать вакансию
		     */
			case 'setvacancy':
		        if (! $this->CheckUserVacancy($_REQUEST['data']['id'])) {
		            header("Location: ".$baseurl."&action=uservacancy&err");
		            exit;
		        }
		        $_REQUEST['data']['active'] = 1;
		        $vacancy_id = $this->SetVacancy($_REQUEST['data']);

		        if ($GLOBALS['JsHttpRequest']) {
		        	if (! $vacancy_id) {
		        		$GLOBALS['_RESULT']['err'] = true;
		        	} else {
		        	    $GLOBALS['_RESULT'] = $this->GetVacancy($vacancy_id);
		        	}
		        	exit;
		        }
		        //Module::go_back();
		        header("Location: ".$baseurl."&action=uservacancies");
		        exit;
		    	break;
			/**
		     * Удалить вакансию
		     */
			case 'delvacancy':
		        if (! $this->CheckUserVacancy($_REQUEST['id'])) {
		            header("Location: ".$baseurl."&action=uservacancies&err");
		            exit;
		        }
		        $del = $this->DelVacancy($_REQUEST['id']);

		        if ($GLOBALS['JsHttpRequest']) {
		        	if (! $del) {
		        		$GLOBALS['_RESULT']['err'] = true;
		        	} else {
		        	    $GLOBALS['_RESULT'] = true;
		        	}
		        	exit;
		        }
		        Module::go_back();
		        header("Location: ".$baseurl."&action=uservacancies");
		        exit;
		    	break;

// Default...
			default:
				if (is_object($tpl)) $tpl->prepare();
				break;
			}
//------------------------------- конец обработки действий с сайта -----------------------------//
		} else {
//------------------------------ обработка действий из админ части -----------------------------//            
			if (!isset($tpl)) {
			    $main->message_die('Не подключен класс для работы с шаблонами');
			}

			switch ($action) {
		    case 'prp':
		    	if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $request_step;
				$main->include_main_blocks('_properties.html', $this->tpl_path);
				$tpl->prepare();
				$tpl->assign(Array(
					"MSG_Information"	=> $main->_msg["Information"],
					"MSG_Value"			=> $main->_msg["Value"],
					"MSG_Save"			=> $main->_msg["Save"],
					"MSG_Cancel"		=> $main->_msg["Cancel"],
				));
		        if (!$request_step || $request_step == 1) {
					$tpl->assign(array('form_action'	=> $baseurl,
									   'step'			=> 2,
									   'lang'			=> $lang,
									   'name'			=> $this->module_name,
									   'action'			=> 'prp'));
					$prp_html = $main->getModuleProperties($this->module_name);
		            $this->main_title = $this->_msg["Controls"];
				} elseif (2 == $request_step) {
		        	$main->setModuleProperties($this->module_name, $_POST);
					header('Location: '.$baseurl.'&action=prp&step=1');
				}
		    	break;

			case 'block_prp':
				global $request_sub_action, $request_block_id;
		        $arr  = $this->getEditLink($request_sub_action, $request_block_id);
				$cont = 'var container = document.getElementById(\'target_span\');
		    		  	 container.innerHTML	= "'.$this->getPropertyFields($arr).'";
		    		  	 material_id			= "'.$arr['material_id'].'";
		    		  	 material_url			= "'.$arr['material_url'].'";
		    		  	 changeAction();
		    	      	 setURL("property1")';
				header('Content-Length: '.strlen($cont));
		    	echo $cont;
		    	exit;
		    	break;

            case 'properties':
                if (!$permissions['e']) $main->message_access_denied($siteusres->module_name, $action);
                global $module_id, $request_field, $title;

                $main->include_main_blocks('_block_properties.html', 'main');
                $tpl->prepare();

                if ($main->show_actions($request_field, '', $this->block_main_module_actions, $this->block_module_actions)) {
                    $main->show_linked_pages($module_id, $request_field);
                }

                $tpl->assign(array(
                    '_ROOT.title'		=> $title,
                    '_ROOT.username'	=> $_SESSION['session_login'],
                    '_ROOT.password'	=> $_SESSION['session_password'],
                    '_ROOT.name'		=> $this->module_name,
                    '_ROOT.lang'		=> $lang,
                ));
                $this->main_title	= $this->_msg["Block_properties"];
                break;

		    /**
		     * Справочники
		     */
			case 'ref':
		        if (!$permissions["e"]) {
		            $main->message_access_denied($this->module_name, $action);
		        }
				$main->include_main_blocks_2($this->module_name."_ref.html", $this->tpl_path);
				$tpl->prepare();
				$tpl->assign(Array(
					"MSG_Add_reference"            => $this->_msg["Add_reference"],
					"MSG_Edit_reference"           => $this->_msg["Edit_reference"],
					"MSG_Del_reference"            => $this->_msg["Del_reference"],
					"MSG_Reference"                => $this->_msg["Reference"],
					"MSG_Name"                     => $this->_msg["Name"],
					"MSG_Delete"                   => $this->_msg["Delete"],
					"MSG_Edit"                     => $this->_msg["Edit"],
					"MSG_Confirm_delete_record"    => $this->_msg["Confirm_delete_record"],
					"MSG_Value"                    => $this->_msg["Value"],
					"MSG_Values"                   => $this->_msg["Values"],
					"MSG_Add_value"                => $this->_msg["Add_value"],
					"MSG_Edit_value"               => $this->_msg["Edit_value"],
					"MSG_Del_value"                => $this->_msg["Del_value"],
					"MSG_Num"                      => $this->_msg["Num"],
					"MSG_Value"			=> $main->_msg["Value"],
					"MSG_Save"			=> $main->_msg["Save"],
					"MSG_Cancel"		=> $main->_msg["Cancel"],
					"MSG_Del"      		=> $main->_msg["Del"],
					"MSG_Ed"       		=> $main->_msg["Ed"],

					"baseurl"  => $baseurl
				));

				$this->ShowRefList();

				$this->main_title = $this->_msg["References"];
		    	break;

		    /**
		     * Добавить/редактировать справочник
		     */
			case 'setref':
		        if (!$permissions["e"]) {
		            $main->message_access_denied($this->module_name, $action);
		        }

		        $err = false;
		        if ($_REQUEST['id']) {
		            if (! $this->SetReference($_REQUEST['id'], $_REQUEST['title'])) {
		                $err = true;
		            } else {
		                $ref_id = $request_id;
		            }
		        } else {
		            $ref_id =  $this->AddReference($_REQUEST['title']);
		            if (! $ref_id) {
		                $err = true;
		            }
		        }
		        if ($GLOBALS['JsHttpRequest']) {
		        	if ($err) {
		        		$GLOBALS['_RESULT']['err'] = true;
		        	} else {
		        	    $GLOBALS['_RESULT'] = $this->GetReference($ref_id);
		        	}
		        	exit;
		        }

		        header("Location: ".$baseurl."&action=ref");

		    	break;

		    /**
		     * Удалить справочник
		     */
			case 'delref':
		        if (!$permissions["d"]) {
		            $main->message_access_denied($this->module_name, $action);
		        }

		        $err = $this->DelReference($_REQUEST['id']) ? false : true;
		        if ($GLOBALS['JsHttpRequest']) {
		        	if ($err) {
		        		$GLOBALS['_RESULT']['err'] = true;
		        	} else {
		        	    $GLOBALS['_RESULT']['id'] = $_REQUEST['id'];
		        	}
		        	exit;
		        }

		        header("Location: ".$baseurl."&action=ref");

		    	break;

		    /**
		     * Получить данный по справочнику
		     */
			case 'getref':
		        if (!$permissions["r"]) {
		            $main->message_access_denied($this->module_name, $action);
		        }

		        $ref = $this->GetReference($_REQUEST['id']);
		        $err = $ref ? false : true;
		        if (! $err) {
		        	$ref['vals'] = $this->GetReferenceValList($_REQUEST['id']);
		        }
		        if ($GLOBALS['JsHttpRequest']) {
		        	if ($err) {
		        		$GLOBALS['_RESULT']['err'] = true;
		        	} else {
		        	    $GLOBALS['_RESULT'] = $ref;
		        	}
		        	exit;
		        }

		        header("Location: ".$baseurl."&action=ref");

		    	break;

		    /**
		     * Добавить/редактировать значение справочника
		     */
			case 'setrefval':
		        if (!$permissions["e"]) {
		            $main->message_access_denied($this->module_name, $action);
		        }

		        $err = false;
		        if ($_REQUEST['id']) {
		            if (! $this->SetReferenceVal($_REQUEST['id'], $_REQUEST['title'], $_REQUEST['num'])) {
		                $err = true;
		            } else {
		                $val_id = $_REQUEST['id'];
		            }
		        } else {
		            $val_id =  $this->AddReferenceVal($_REQUEST['ref_id'], $_REQUEST['title'], $_REQUEST['num']);
		            if (! $val_id) {
		                $err = true;
		            }
		        }
		        if ($GLOBALS['JsHttpRequest']) {
		        	if ($err) {
		        		$GLOBALS['_RESULT']['err'] = true;
		        	} else {
		        	    $GLOBALS['_RESULT'] = $this->GetReferenceVal($val_id);
		        	}
		        	exit;
		        }

		        header("Location: ".$baseurl."&action=ref");

		    	break;

		    /**
		     * Удалить значение справочника
		     */
			case 'delrefval':
		        if (!$permissions["d"]) {
		            $main->message_access_denied($this->module_name, $action);
		        }

		        $err = $this->DelReferenceVal($_REQUEST['id']) ? false : true;
		        if ($GLOBALS['JsHttpRequest']) {
		        	if ($err) {
		        		$GLOBALS['_RESULT']['err'] = true;
		        	} else {
		        	    $GLOBALS['_RESULT']['id'] = $_REQUEST['id'];
		        	}
		        	exit;
		        }

		        header("Location: ".$baseurl."&action=ref");

		    	break;

		    /**
		     * Резюме
		     */
			case 'resume':
		        if (!$permissions["r"]) {
		            $main->message_access_denied($this->module_name, $action);
		        }
				$main->include_main_blocks_2($this->module_name."_".$action.".html", $this->tpl_path);
				$tpl->prepare();
				$tpl->assign(Array(
					"MSG_Add_resume"               => $this->_msg["Add_resume"],
					"MSG_Edit_resume"              => $this->_msg["Edit_resume"],
					"MSG_Del_resume"               => $this->_msg["Del_resume"],
					"MSG_City"                     => $this->_msg["City"],
					"MSG_Activity"                 => $this->_msg["Activity"],
					"MSG_Education"                => $this->_msg["Education"],
					"MSG_Experience"               => $this->_msg["Experience"],
					"MSG_Schedule"                 => $this->_msg["Schedule"],
					"MSG_Post"                     => $this->_msg["Post"],
					"MSG_Contact"                  => $this->_msg["Contact"],
					"MSG_Age"                      => $this->_msg["Age"],
					"MSG_Salary"                   => $this->_msg["Salary"],
					"MSG_Practice"                 => $this->_msg["Practice"],
					"MSG_Recommend"                => $this->_msg["Recommend"],
					"MSG_Select"                   => $this->_msg["Select"],
					"MSG_Unimportant"              => $this->_msg["Unimportant"],

					"MSG_Delete"                   => $this->_msg["Delete"],
					"MSG_Edit"                     => $this->_msg["Edit"],
					"MSG_Confirm_delete_record"    => $this->_msg["Confirm_delete_record"],
					"MSG_Save"			=> $main->_msg["Save"],
					"MSG_Cancel"		=> $main->_msg["Cancel"],
					"MSG_Del"      		=> $main->_msg["Del"],
					"MSG_Ed"       		=> $main->_msg["Ed"],

					"baseurl"  => $baseurl
				));
				Module::show_select('block_ref_city', 0, 'name', $this->GetReferenceValList($CONFIG['job_ref_city_id']));
				Module::show_select('block_ref_activity', 0, 'name', $this->GetReferenceValList($CONFIG['job_ref_activity_id']));
				Module::show_select('block_ref_schedule', 0, 'name', $this->GetReferenceValList($CONFIG['job_ref_schedule_id']));
				Module::show_select('block_ref_education', 0, 'name', $this->GetReferenceValList($CONFIG['job_ref_education_id']));
				Module::show_select('block_ref_experience', 0, 'name', $this->GetReferenceValList($CONFIG['job_ref_experience_id']));

				$this->ShowResumeList($_REQUEST['start'], $CONFIG['job_max_rows'], array('order' => $CONFIG['job_admin_order_by']));

				$this->main_title = $this->_msg["Resume"];
		    	break;

		    /**
		     * Добавить/редактировать резюме
		     */
			case 'setresume':
		        if (!$permissions["e"]) {
		            $main->message_access_denied($this->module_name, $action);
		        }
		        $resume_id = $this->SetResume($_REQUEST['data']);

		        if ($GLOBALS['JsHttpRequest']) {
		        	if (! $resume_id) {
		        		$GLOBALS['_RESULT']['err'] = true;
		        	} else {
		        	    $GLOBALS['_RESULT'] = $this->GetResume($resume_id);
		        	}
		        	exit;
		        }
		        header("Location: ".$baseurl."&action=resume");
		        exit;
		    	break;

		    /**
		     * Получить данный резюме
		     */
			case 'getresume':
		        if (!$permissions["r"]) {
		            $main->message_access_denied($this->module_name, $action);
		        }

		        $resume = $this->GetResume($_REQUEST['id']);
		        if ($GLOBALS['JsHttpRequest']) {
		        	if ($resume) {
		        		$GLOBALS['_RESULT'] = $resume;
		        	} else {
		        	    $GLOBALS['_RESULT']['err'] = true;
		        	}
		        	exit;
		        }

		        header("Location: ".$baseurl."&action=resume");

		    	break;

		    /**
		     * Удалить резюме
		     */
			case 'delresume':
		        if (!$permissions["d"]) {
		            $main->message_access_denied($this->module_name, $action);
		        }

		        $err = $this->DelResume($_REQUEST['id']) ? false : true;
		        if ($GLOBALS['JsHttpRequest']) {
		        	if ($err) {
		        		$GLOBALS['_RESULT']['err'] = true;
		        	} else {
		        	    $GLOBALS['_RESULT']['id'] = $_REQUEST['id'];
		        	}
		        	exit;
		        }

		        header("Location: ".$baseurl."&action=resume");

		    	break;
		    /**
		     * Редактирование прав резюме
		     */
			case 'resumerights':
				if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $request_id, $request_start;
				if (!$this->test_item_rights("e", "id", 'user_work_resume', $request_id, true))
					$main->message_access_denied($this->module_name, $action);

				if (! $this->show_rights_form(
				    'user_work_resume', "post", $request_id,
				    "&id=".$request_id, $this->_msg["Resume"], "saveresumerights")
				) {
					header('Location: '.$baseurl."&action=resume".($request_start>1 ? "&start=".intval($request_start) : ""));
				}
				break;

			/**
			 * Сохранить права доступа к резюме
			 */
			case 'saveresumerights':
				if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $request_id, $request_rights, $request_start;
				if (!$this->test_item_rights("e", "id", 'user_work_resume', $request_id, true))
					$main->message_access_denied($this->module_name, $action);

				$this->save_rights_form('user_work_resume', $request_id, $request_rights);
				if ($GLOBALS['JsHttpRequest']) {
					$GLOBALS['_RESULT'] = array(
					   "res"	=> 1,
					   "id"	=> $request_id,
				    );
				} else {
					header('Location: '.$baseurl."&action=resume".($request_start>1 ? "&start=".intval($request_start) : ""));
				}
				exit;
				break;

		    /**
		     * Вакансии
		     */
			case 'vacancy':
		        if (!$permissions["r"]) {
		            $main->message_access_denied($this->module_name, $action);
		        }
				$main->include_main_blocks_2($this->module_name."_".$action.".html", $this->tpl_path);
				$tpl->prepare();
				$tpl->assign(Array(
					"MSG_Add_vacancy"              => $this->_msg["Add_vacancy"],
					"MSG_Edit_vacancy"             => $this->_msg["Edit_vacancy"],
					"MSG_Del_vacancy"              => $this->_msg["Del_vacancy"],
					"MSG_City"                     => $this->_msg["City"],
					"MSG_Activity"                 => $this->_msg["Activity"],
					"MSG_Education"                => $this->_msg["Education"],
					"MSG_Experience"               => $this->_msg["Experience"],
					"MSG_Schedule"                 => $this->_msg["Schedule"],
					"MSG_Schedule"                 => $this->_msg["Schedule"],
					"MSG_Vacancy_category"         => $this->_msg["Vacancy_category"],
					"MSG_Category"                 => $this->_msg["Category"],
					"MSG_Post"                     => $this->_msg["Post"],
					"MSG_Contact"                  => $this->_msg["Contact"],
					"MSG_Age"                      => $this->_msg["Age"],
					"MSG_Salary"                   => $this->_msg["Salary"],
					"MSG_Practice"                 => $this->_msg["Practice"],
					"MSG_Recommend"                => $this->_msg["Recommend"],
					"MSG_Select"                   => $this->_msg["Select"],
					"MSG_Unimportant"              => $this->_msg["Unimportant"],
					"MSG_Company"                  => $this->_msg["Company"],
					"MSG_Charge"                   => $this->_msg["Charge"],

					"MSG_Delete"                   => $this->_msg["Delete"],
					"MSG_Edit"                     => $this->_msg["Edit"],
					"MSG_Confirm_delete_record"    => $this->_msg["Confirm_delete_record"],
					"MSG_Save"			=> $main->_msg["Save"],
					"MSG_Cancel"		=> $main->_msg["Cancel"],
					"MSG_Del"      		=> $main->_msg["Del"],
					"MSG_Ed"       		=> $main->_msg["Ed"],

					"baseurl"  => $baseurl
				));
				Module::show_select('block_ref_city', 0, 'name', $this->GetReferenceValList($CONFIG['job_ref_city_id']));
				Module::show_select('block_ref_activity', 0, 'name', $this->GetReferenceValList($CONFIG['job_ref_activity_id']));
				Module::show_select('block_ref_schedule', 0, 'name', $this->GetReferenceValList($CONFIG['job_ref_schedule_id']));
				Module::show_select('block_ref_education', 0, 'name', $this->GetReferenceValList($CONFIG['job_ref_education_id']));
				Module::show_select('block_ref_experience', 0, 'name', $this->GetReferenceValList($CONFIG['job_ref_experience_id']));
				Module::show_select('block_ref_vcnc_ctgr', 0, 'name', $this->GetReferenceValList($CONFIG['job_ref_vcnc_ctgr_id']));

				$this->ShowVacancyList($_REQUEST['start'], $CONFIG['job_max_rows'], array('order' => $CONFIG['job_admin_order_by']), $action);

				$this->main_title = $this->_msg["Vacancy"];
		    	break;

		    /**
		     * Добавить/редактировать вакансию
		     */
			case 'setvacancy':

		        if (!$permissions["e"]) {
		            $main->message_access_denied($this->module_name, $action);
		        }
		        $resume_id = $this->SetVacancy($_REQUEST['data']);

		        if ($GLOBALS['JsHttpRequest']) {
		        	if (! $resume_id) {
		        		$GLOBALS['_RESULT']['err'] = true;
		        	} else {
		        	    $GLOBALS['_RESULT'] = $this->GetVacancy($resume_id);
		        	}
		        	exit;
		        }
		        header("Location: ".$baseurl."&action=vacancy");
		        exit;
		    	break;

		    /**
		     * Получить данный вакансии
		     */
			case 'getvacancy':
		        if (!$permissions["r"]) {
		            $main->message_access_denied($this->module_name, $action);
		        }

		        $resume = $this->GetVacancy($_REQUEST['id']);
		        if ($GLOBALS['JsHttpRequest']) {
		        	if ($resume) {
		        		$GLOBALS['_RESULT'] = $resume;
		        	} else {
		        	    $GLOBALS['_RESULT']['err'] = true;
		        	}
		        	exit;
		        }

		        header("Location: ".$baseurl."&action=vacancy");

		    	break;

		    /**
		     * Удалить вакансию
		     */
			case 'delvacancy':
		        if (!$permissions["d"]) {
		            $main->message_access_denied($this->module_name, $action);
		        }

		        $err = $this->DelVacancy($_REQUEST['id']) ? false : true;
		        if ($GLOBALS['JsHttpRequest']) {
		        	if ($err) {
		        		$GLOBALS['_RESULT']['err'] = true;
		        	} else {
		        	    $GLOBALS['_RESULT']['id'] = $_REQUEST['id'];
		        	}
		        	exit;
		        }

		        header("Location: ".$baseurl."&action=vacancy");

		    	break;
		    /**
		     * Редактирование прав вакансии
		     */
			case 'vacancyrights':
				if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $request_id, $request_start;
				if (!$this->test_item_rights("e", "id", 'user_work_vacancy', $request_id, true))
					$main->message_access_denied($this->module_name, $action);

				if (! $this->show_rights_form(
				    'user_work_vacancy', "post", $request_id,
				    "&id=".$request_id, $this->_msg["Vacancy"], "savevacancyrights")
				) {
					header('Location: '.$baseurl."&action=vacancy".($request_start>1 ? "&start=".intval($request_start) : ""));
				}
				break;

			/**
			 * Сохранить права доступа к вакансии
			 */
			case 'savevacancyrights':
				if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $request_id, $request_rights, $request_start;
				if (!$this->test_item_rights("e", "id", 'user_work_vacancy', $request_id, true))
					$main->message_access_denied($this->module_name, $action);

				$this->save_rights_form('user_work_vacancy', $request_id, $request_rights);
				if ($GLOBALS['JsHttpRequest']) {
					$GLOBALS['_RESULT'] = array(
					   "res"	=> 1,
					   "id"	=> $request_id,
				    );
				} else {
					header('Location: '.$baseurl."&action=vacancy".($request_start>1 ? "&start=".intval($request_start) : ""));
				}
				exit;
				break;
			/**
			 * Отключить публикацию вакансии
			 */
			case "vacancysuspend":
				if (!$permissions["p"]) $main->message_access_denied($this->module_name, $action);
				global $request_id, $request_start;
				if (!$this->test_item_rights("p", "id", 'user_work_vacancy', $request_id, true))
					$main->message_access_denied($this->module_name, $action);

				if ($main->suspend('user_work_vacancy', $request_id)) {
				    @$cache->delete_cache_files();
				    if ($GLOBALS['JsHttpRequest']) {
    					$GLOBALS['_RESULT'] = array(
    					   "active"	=> 0,
    					   "id"	=> $request_id,
    				    );
    				    exit;
    				}
				} else if ($GLOBALS['JsHttpRequest']) {
					$GLOBALS['_RESULT']['err'] = true;
					exit;
				}
				header('Location: '.$baseurl."&action=vacancy".($request_start>1 ? "&start=".intval($request_start) : ""));
				exit;
				break;
			/**
			 * Включение публикации вакансии
			 */
			case "vacancyactivate":
				if (!$permissions["p"]) {
				    $main->message_access_denied($this->module_name, $action);
				}
				global $request_id, $request_start;
				if (!$this->test_item_rights("p", "id", 'user_work_vacancy', $request_id, true))
					$main->message_access_denied($this->module_name, $action);

				if ($main->activate('user_work_vacancy', $request_id)) {
				    @$cache->delete_cache_files();
				    if ($GLOBALS['JsHttpRequest']) {
    					$GLOBALS['_RESULT'] = array(
    					   "active"	=> 1,
    					   "id"	=> $request_id,
    				    );
    				    exit;
    				}
				} else if ($GLOBALS['JsHttpRequest']) {
					$GLOBALS['_RESULT']['err'] = true;
					exit;
				}
				header('Location: '.$baseurl."&action=vacancy".($request_start>1 ? "&start=".intval($request_start) : ""));
				exit;
				break;
			/**
			 * Отключить публикацию резюме
			 */
			case "resumesuspend":
				if (!$permissions["p"]) $main->message_access_denied($this->module_name, $action);
				global $request_id, $request_start;
				if (!$this->test_item_rights("p", "id", 'user_work_resume', $request_id, true))
					$main->message_access_denied($this->module_name, $action);

				if ($main->suspend('user_work_resume', $request_id)) {
				    @$cache->delete_cache_files();
				    if ($GLOBALS['JsHttpRequest']) {
    					$GLOBALS['_RESULT'] = array(
    					   "active"	=> 0,
    					   "id"	=> $request_id,
    				    );
    				    exit;
    				}
				} else if ($GLOBALS['JsHttpRequest']) {
					$GLOBALS['_RESULT']['err'] = true;
					exit;
				}
				header('Location: '.$baseurl."&action=resume".($request_start>1 ? "&start=".intval($request_start) : ""));
				exit;
				break;
			/**
			 * Включение публикации резюме
			 */
			case "resumeactivate":
				if (!$permissions["p"]) {
				    $main->message_access_denied($this->module_name, $action);
				}
				global $request_id, $request_start;
				if (!$this->test_item_rights("p", "id", 'user_work_resume', $request_id, true))
					$main->message_access_denied($this->module_name, $action);

				if ($main->activate('user_work_resume', $request_id)) {
				    @$cache->delete_cache_files();
				    if ($GLOBALS['JsHttpRequest']) {
    					$GLOBALS['_RESULT'] = array(
    					   "active"	=> 1,
    					   "id"	=> $request_id,
    				    );
    				    exit;
    				}
				} else if ($GLOBALS['JsHttpRequest']) {
					$GLOBALS['_RESULT']['err'] = true;
					exit;
				}
				header('Location: '.$baseurl."&action=resume".($request_start>1 ? "&start=".intval($request_start) : ""));
				exit;
				break;

// Default...
			default:
				$main->include_main_blocks();
				$tpl->prepare();
			}
//--------------------------- конец обработки действий из админ части --------------------------//
		}
	}

	function getPropertyFields() {
		GLOBAL $request_site_target, $request_sub_action;
		if ('' != $request_sub_action) {

			$tpl = $this->getTmpProperties();

			switch ($request_sub_action) {
				default:
					$tpl->newBlock('block_properties_none');
					$tpl->assign(Array(
						"MSG_No" => $this->_msg["No"],
					));
					break;
			}
			return $this->getOutputContent($tpl->getOutputContent());
		}
		return FALSE;
	}

	function getEditLink($sub_action = NULL, $block_id = NULL) {
		GLOBAL $request_name, $db, $lang, $server;
		$block_id	= (int)$block_id;
		if ($sub_action && $block_id) {
			$db->query('SELECT	property1,
								property2,
								property3,
								property4,
								property5
							FROM '.$this->table_prefix.'_pages_blocks
							WHERE id = '.$block_id);
			if ($db->nf() > 0) {
				$db->next_record();
				$arr[]	= $db->f('property1');
				$arr[]	= $db->f('property2');
				$arr[]	= $db->f('property3');
				$arr[]	= $db->f('property4');
				$arr[]	= $db->f('property5');

				switch ($sub_action) {
					case 'list':
						$link['material_url']	= '/admin.php?lang='.$lang.'&name='.$request_name.'&action=list&menu=false&category=';
						$link['material_id']	= $arr[0];
						break;

					case 'vacancies_field_list':
						$link['material_url']	= '/admin.php?lang='.$lang.'&name='.$request_name.'&action=editfield&menu=false&field=';
						$link['material_id']	= $arr[0];
						break;
				}
				return $link;
			}

			switch ($sub_action) {
				case 'list':
					$link['material_url']	= '/admin.php?lang='.$lang.'&name='.$request_name.'&action=list&menu=false&category=';
					$link['material_id']	= '';
					break;

				case 'categorys_list':
					$link['material_url']	= '/admin.php?lang='.$lang.'&name='.$request_name.'&action=editfield&menu=false&field=';
					$link['material_id']	= '';
					break;
			}
			return $link;
		}
		return FALSE;
	}

	/**
	 * Получить массив сфер деятельности
	 * @param int $selected_field Текущая сфера деятельности
	 * @return mixed
	 */
	function getFields($selected_field = '')
	{   global $CONFIG, $db, $baseurl;

		$selected_field	= (int)$selected_field;
		$db->query('SELECT * FROM '.$this->table_prefix.'_vacancies_fields ORDER BY id');
		if ($db->nf() > 0) {
			while($db->next_record()) {
				if ($db->f('id') == $selected_field) {
					$selected = ' selected';
					$this->addition_to_path	= $db->f('name');
					$this->main_title		= $db->f('name');
				} else {
					$selected = '';
				}
				$arr[]	= array('field_name'		=> $db->f('name'),
								'field_link'		=> $baseurl.'&action=field_list&field='.$db->f('id'),
								'field_edit_link'	=> $baseurl.'&action=editfield&field='.$db->f('id'),
								'cfield_del_link'	=> $baseurl.'&action=delfield&field='.$db->f('id'),
								'field'				=> $db->f('id'),
								'selected'				=> $selected,
								);
			}
			return $arr;
		}
		return FALSE;
	}

	/**
	 * Существует ли справочник
	 *
	 * @param int $id
	 * @return boolean
	 */
	function ReferenceExist($id)
	{
		global $db;
		$id = (int) $id;
		$db->query("SELECT id FROM `user_work_reference` WHERE id=".$id);

		return $db->nf() ? true : false;
	}

	/**
	 * Добавить справочник
	 *
	 * @param name $name
	 * @return mixed false or id добавленного справочника
	 */
	function AddReference($name)
	{
		global $db;

		$name = $db->escape($name);
		if (! $name) {
			return false;
		}
		$db->query("INSERT INTO `user_work_reference` SET name='".$name."'");

		return $db->lid();
	}

	/**
	 * Изменить название справочника
	 *
	 * @param int $id
	 * @param name $name
	 * @return boolean
	 */
	function SetReference($id, $name)
	{
		global $db;
		$id = (int) $id;
		$name = $db->escape($name);
		if (! $name) {
			return false;
		}
		$db->query("UPDATE `user_work_reference` SET name='".$name."' WHERE id=".$id);

		return $db->Errno ? false : true;
	}

	/**
	 * Удалить справочник
	 *
	 * @param int $id
	 * @return boolean
	 */
	function DelReference($id)
	{
		global $db;
		$id = (int) $id;
		$db->query("DELETE FROM `user_work_reference` WHERE id=".$id);
		if ($db->affected_rows()) {
		    $db->query("DELETE FROM `user_work_reference_val` WHERE ref_id=".$id);
		    return true;
		}
		return false;
	}

	/**
	 * Удалить значение из справочника
	 *
	 * @param int $id
	 * @return boolean
	 */
	function DelReferenceVal($id)
	{
		global $db;
		$id = (int) $id;
		$db->query("DELETE FROM `user_work_reference_val` WHERE id=".$id);
		return $db->affected_rows() ? true : false;
	}

	/**
	 * Добавить значение в справочник
	 *
	 * @param int $ref_id
	 * @param string $val_name
	 * @param int $val_num
	 * @return mixed false или id добавленного справочника
	 */
	function AddReferenceVal($ref_id, $val_name, $val_num)
	{
		global $db;
		$ref_id = (int) $ref_id;
		$val_name = $db->escape($val_name);
		$val_num = (int) $val_num;
		if ($this->ReferenceExist($ref_id) || ! $val_name) {
			$db->query("INSERT INTO user_work_reference_val SET ref_id=".$ref_id
			    .", name='".$val_name."', num=".$val_num);
			return $db->affected_rows() ? $db->lid() : false;
		}
		return false;
	}

	/**
	 * Изменить значение в справочнике
	 *
	 * @param int $id
	 * @param string $val_name
	 * @param int $val_num
	 * @return boolean
	 */
	function SetReferenceVal($id, $val_name, $val_num)
	{
		global $db;
		$id = (int) $id;
		$val_name = $db->escape($val_name);
		$val_num = (int) $val_num;
		if (! $val_name) {
			return false;
		}
		$db->query("UPDATE user_work_reference_val SET name='".$val_name."', num=".$val_num
		    ." WHERE id=".$id);
		return $db->Errno ? false : true;
	}

	/**
	 * Получить справочник
	 *
	 * @param int $id
	 * @return mixed false или массив ['id', 'name']
	 */
	function GetReference($id)
	{
	    global $db;
	    $id = (int) $id;
	    $db->query("SELECT * FROM `user_work_reference` WHERE id=".$id);
	    if ($db->nf()) {
	        $db->next_record();
	        return array('id' => $db->f('id'), 'name' => $db->f('name'));
	    }
	    return false;
	}

	/**
	 * Получить список значений справочника
	 *
	 * @param int $id
	 * @return array
	 */
	function GetReferenceValList($id)
	{
	    global $db;
	    $id = (int) $id;
	    $ret = array();
	    $db->query("SELECT * FROM user_work_reference_val WHERE ref_id=".$id." ORDER BY num, name");
	    while ($db->next_record()) {
	        $id = $db->f('id');
	        $ret[$id] = array('id' => $id, 'name' => $db->f('name'), 'num' => $db->f('num'));
	    }
	    return $ret;
	}

	/**
	 * Получить список справочников
	 *
	 * @return mixed Массив справочников или false
	 */
	function GetReferenceList()
	{
	    global $db;
	    return $db->getArrayOfResult("SELECT * FROM `user_work_reference` ORDER BY name");
	}

	/**
	 * Показать сисок справочников
	 *
	 */
	function ShowRefList()
	{
		global $tpl;
		$l = $this->GetReferenceList();
		if ($l) {
		    $tpl->newBlock('block_ref_list');
		    $tpl->assign(array(
    		    "MSG_Reference"   => $this->_msg["Reference"],
    			"MSG_Del"        => $this->_msg["Del"],
    			"MSG_Ed"         => $this->_msg["Ed"],
    		));
		    foreach ($l as $key => $val) {
		        $tpl->newBlock('block_ref');
		    	$tpl->assign(array(
		    	    'id' => $val['id'],
		    	    'name' => $val['name'],
		    	    'MSG_Confirm_delete_record' => $this->_msg['Confirm_delete_record'],
		    	    'MSG_Delete' => $this->_msg['Delete'],
		    	    'MSG_Edit' => $this->_msg['Edit'],
		    	));
		    }
		}
	}

	/**
	 * Получить значение справочника
	 *
	 * @param int $id
	 * @return mixed false или массив ['id', 'name', 'num']
	 */
	function GetReferenceVal($id)
	{
	    global $db;
	    $id = (int) $id;
	    $db->query("SELECT * FROM `user_work_reference_val` WHERE id=".$id);
	    if ($db->nf()) {
	        $db->next_record();
	        return array('id' => $db->f('id'), 'name' => $db->f('name'), 'num' => $db->f('num'));
	    }
	    return false;
	}

	/**
	 * Существует ли резюму
	 *
	 * @param int $id
	 * @return boolean
	 */
	function ResumeExist($id)
	{
		global $db;

		$db->query("SELECT id FROM `user_work_resume` WHERE id=".intval($id));

		return $db->nf() ? true : false;
	}

	/**
	 * Добавить/изменить резюме
	 *
	 * @param array $data
	 * @return mixed false OR id резюме
	 */
	function SetResume($data, $block_id = 0)
	{
		global $db;

		$insert = array();
		if ($data['id']) {
			$insert['id'] = (int) $data['id'];
			if (! $this->ResumeExist($insert['id'])) {
				return false;
			}
		}
		$insert['post'] = My_Sql::escape(strip_tags($data['post']));
		if (! $insert['post']) {
			return false;
		}
		$insert['contact'] = My_Sql::escape(strip_tags($data['contact']));
		if (! $insert['contact']) {
			return false;
		}
		$insert['age'] = My_Sql::escape(strip_tags($data['age']));
		if (! $insert['age']) {
			return false;
		}
		$insert['salary'] = My_Sql::escape(strip_tags($data['salary']));
		if (! $insert['salary']) {
			return false;
		}
		$insert['ref_city'] = intval($data['ref_city']);
		if (! $insert['ref_city']) {
			return false;
		}
		$insert['ref_activity'] = intval($data['ref_activity']);
		if (! $insert['ref_activity']) {
			return false;
		}
		$insert['ref_education'] = intval($data['ref_education']);
		if (! $insert['ref_education']) {
			return false;
		}
		$insert['ref_experience'] = intval($data['ref_experience']);
		if (! $insert['ref_experience']) {
			return false;
		}
		$insert['ref_schedule'] = intval($data['ref_schedule']);
		if (! $insert['ref_schedule']) {
			return false;
		}
		$insert['education'] = My_Sql::escape(nl2br(strip_tags($data['education'])));
		if (! $insert['education']) {
			return false;
		}
		$insert['experience'] = My_Sql::escape(nl2br(strip_tags($data['experience'])));
		if (! $insert['experience']) {
			return false;
		}
		$insert['practice'] = My_Sql::escape(nl2br(strip_tags($data['practice'])));
		if (! $insert['practice']) {
			return false;
		}
		$insert['recommend'] = $data['recommend'] ? My_Sql::escape(strip_tags($data['recommend'])) : '';
		$insert['active'] = $data['active'] ? 1 : 0;
		
		if (! $insert['id']) {
		    $insert['owner_id'] = $_SESSION["siteuser"]["id"];
		    list($insert['usr_group_id'], $insert['rights']) = $this->get_group_and_rights('job_default_rights', $block_id);
		}

		$query = "";
		foreach ($insert as $key => $val) {
			$query .= "`".$key."`='".$val."', ";
		}
		if ($insert['id']) {
		    $db->query("UPDATE `user_work_resume` SET ".substr($query, 0, -2)." WHERE id=".$insert['id']);
		    return $insert['id'];
		} else {
		    $db->query("INSERT INTO `user_work_resume` SET ".substr($query, 0, -2));
		    return $db->lid();
		}
	}

	/**
	 * Получить резюме
	 *
	 * @param int $id
	 * @return mixed false или массив полей резюме
	 */
	function GetResume($id)
	{
	    global $db;

	    $res = $db->getArrayOfResult("SELECT * FROM `user_work_resume` WHERE id=".intval($id)
	       .(! $this->is_admin ? " AND active=1" : ""));
	    if (is_array($res)) {
	        return $res[0];
	    }
	    return false;
	}

	/**
	 * Удалить резюме
	 *
	 * @param int $id
	 * @return boolean
	 */
	function DelResume($id)
	{
	    global $db;

	    if (!$this->test_item_rights("d", "id", "user_work_resume", $id, false)) {
	        $main->message_access_denied($this->module_name, $action);
	    }

	    $db->query("DELETE FROM `user_work_resume` WHERE id=".intval($id));
	    return  $db->affected_rows() ? true : false;
	}

	/**
	 * Получить список резюме
	 *
	 * @param mixed $start
	 * @param mixed $rows
	 * @param array $filter
	 * @return mixed
	 */
	function GetResumeList($start, $rows, $filter = array())
	{
	    global $db, $baseurl, $CONFIG;
		$fltr = array();

		if (false !== $start && false !== $rows) {
			$start = $start >= 1 ? (int) $start : 1;
			$rows = $rows > 1 ? (int) $rows : $CONFIG['job_max_rows'];
		}
		if (isset($filter['ref_city']) && $filter['ref_city']) {
			$fltr[] = "r.ref_city=".intval($filter['ref_city']);
		}
		if (isset($filter['ref_activity']) && $filter['ref_activity']) {
			$fltr[] = "r.ref_activity=".intval($filter['ref_activity']);
		}
		if (! $this->is_admin) {
			$fltr[] = "r.active=1";
		}
		$order = isset($filter['order']) && $filter['order']
		    ? "r.".$db->escape($filter['order'])
		    : "r.last_upd DESC";
		$total_cnt = $this->get_list_with_rights(
		    "r.*, u.username, u.email", "user_work_resume r LEFT JOIN core_users u ON u.id=owner_id", "r",
		    implode(" AND ", $fltr), $order, "",
		    $start, $rows, true
		);
		$pages_cnt = ceil($total_cnt/$rows);
		if ($db->nf() > 0) {
			while($db->next_record()) {
				$id		= $db->f('id');
				$is_owner = $db->f("is_owner");
				$rights = $db->f("user_rights");
				$ref_val_list = $this->GetReferenceVals(array(
				    $db->Record['ref_city'],
				    $db->Record['ref_activity'],
				    $db->Record['ref_education'],
				    $db->Record['ref_experience'],
				    $db->Record['ref_schedule']
				));

				$arr[] = $db->Record
				    + array(
				        'ref_city_val' => $ref_val_list[$db->Record['ref_city']]['name'],
				        'ref_activity_val' => $ref_val_list[$db->Record['ref_activity']]['name'],
				        'ref_education_val' => $ref_val_list[$db->Record['ref_education']]['name'],
				        'ref_experience_val' => $ref_val_list[$db->Record['ref_experience']]['name'],
				        'ref_schedule_val' => $ref_val_list[$db->Record['ref_schedule']]['name'],
				        'link' => $baseurl."&action=resume&id=".$db->Record['id']
				    );
			}
			return array($arr, $pages_cnt, $total_cnt);
		}

		return false;
	}

	/**
	 * Показать список резюме
	 *
	 * @param mixed $start
	 * @param mixed $rows
	 * @param array $filter
	 * @param string $action
	 */
	function ShowResumeList($start, $rows, $filter = array(), $action = '')
	{
		global $tpl, $main;
		$start = $start >= 1 ? (int) $start : 1;
		$l = $this->GetResumeList($start, $rows, $filter);
		if ($l) {
		    $tpl->newBlock('block_resume_list');
		    $tpl->assign(array(
		        "MSG_Rights"      => $main->_msg["Rights"],
    		    "MSG_Reference"   => $this->_msg["Reference"],
    		    "MSG_Del"         => $this->_msg["Del"],
    		    "MSG_Ed"          => $this->_msg["Ed"],
    		    "MSG_Activ"       => $this->_msg["Activ"],
    		    "MSG_User"        => $this->_msg["User"],
    		    "MSG_Post"        => $this->_msg["Post"],
    		    "MSG_City"        => $this->_msg["City"],
    		    "MSG_Activity"    => $this->_msg["Activity"],
    		    "MSG_Updated"     => $this->_msg["Updated"],
    		    "cnt"             => $l[2]
    		));
    		$start_query = $start > 1 ? "&start=".intval($start) : '';
    		$url_query = '';
    		foreach ($filter as $key => $val) {
    			$url_query .= "&data[".htmlspecialchars($key)."]=".htmlspecialchars($val);
    		}
		    foreach ($l[0] as $key => $val) {
		        $tpl->newBlock('block_resume');
		        $val['link'] .= $url_query.$start_query;
		    	$tpl->assign($val);
		    	if ($this->is_admin) {
    		    	$this->show_block_by_rights(
    		    	    $val['id'],
    		    	    $val['active'],
    		    	    $val['is_owner'],
    		    	    $val['user_rights'],
    		    	    $baseurl,
    		    	    '',
    		    	    array()
    		    	);
		    	}
		    }

		    $action = ($action ? $action : 'ressume').$url_query;
		    if ($l[1]) {
		        $main->_show_nav_block($l[1], null, 'action='.$action, $start);
		        $tpl->gotoBlock('nav');
		        $tpl->assign('MSG_Pages', $this->_msg['Pages']);
		    }
		} else {
		    $tpl->newBlock('block_resume_list_empty');
		}
	}

	/**
	 * Получить список значений справочника
	 *
	 * @param array $id_list
	 * @return mixed false OR [val_id => [id, name, num]]
	 */
	function GetReferenceVals($id_list)
	{
		global $db1;

		static $val_list = array();

		if (empty($val_list)) {
			$db1->query("SELECT * FROM `user_work_reference_val`");
    	    while ($db1->next_record()) {
    	        $id = $db1->f('id');
    	        $val_list[$id] = array('id' => $id, 'name' => $db1->f('name'), 'num' => $db1->f('num'));
    	    }
		}

		if (!is_array($id_list) || empty($id_list)) {
	    	return false;
	    }

	    $ret = array();
	    foreach ($id_list as $key => $val) {
	        if (array_key_exists($val, $val_list)) {
	        	$ret[$val] = $val_list[$val];
	        }
	    }
	    return $ret;
	}

	/**
	 * Существует ли вакансия
	 *
	 * @param int $id
	 * @return boolean
	 */
	function VacancyExist($id)
	{
		global $db;

		$db->query("SELECT id FROM `user_work_vacancy` WHERE id=".intval($id));

		return $db->nf() ? true : false;
	}

	/**
	 * Добавить/изменить вакансию
	 *
	 * @param array $data
	 * @return mixed false OR id вакансии
	 */
	function SetVacancy($data, $block_id = 0)
	{
		global $db;

		$insert = array();
		if ($data['id']) {
			$insert['id'] = (int) $data['id'];
			if (! $this->VacancyExist($insert['id'])) {
				return false;
			}
		}
		$insert['company'] = My_Sql::escape(strip_tags($data['company']));
		if (! $insert['company']) {
			return false;
		}
		$insert['post'] = My_Sql::escape(strip_tags($data['post']));
		if (! $insert['post']) {
			return false;
		}
		$insert['contact'] = My_Sql::escape(strip_tags($data['contact']));
		if (! $insert['contact']) {
			return false;
		}
		$insert['age'] = My_Sql::escape(strip_tags($data['age']));
		if (! $insert['age']) {
			return false;
		}
		$insert['salary'] = My_Sql::escape(strip_tags($data['salary']));
		if (! $insert['salary']) {
			return false;
		}
		$insert['ref_city'] = intval($data['ref_city']);
		if (! $insert['ref_city']) {
			return false;
		}
		$insert['ref_activity'] = intval($data['ref_activity']);
		if (! $insert['ref_activity']) {
			return false;
		}
		$insert['ref_education'] = intval($data['ref_education']);
		if (! $insert['ref_education']) {
			return false;
		}
		$insert['ref_experience'] = intval($data['ref_experience']);
		if (! $insert['ref_experience']) {
			return false;
		}
		$insert['ref_schedule'] = intval($data['ref_schedule']);
		if (! $insert['ref_schedule']) {
			return false;
		}
		$insert['ref_vcnc_ctgr'] = intval($data['ref_vcnc_ctgr']);
		if (! $insert['ref_vcnc_ctgr']) {
			return false;
		}
		$insert['charge'] = My_Sql::escape(nl2br(strip_tags($data['charge'])));
		if (! $insert['charge']) {
			return false;
		}
		
		$insert['active'] = $data['active'] ? 1 : 0;

		if (! $insert['id']) {
		    $insert['owner_id'] = $_SESSION["siteuser"]["id"];
		    list($insert['usr_group_id'], $insert['rights']) = $this->get_group_and_rights('job_default_rights', $block_id);
		}
		$query = "";
		foreach ($insert as $key => $val) {
			$query .= "`".$key."`='".$val."', ";
		}
		if ($insert['id']) {
		    $db->query("UPDATE `user_work_vacancy` SET ".substr($query, 0, -2)." WHERE id=".$insert['id']);
		    return $insert['id'];
		} else {
		    $db->query("INSERT INTO `user_work_vacancy` SET ".substr($query, 0, -2));
		    return $db->lid();
		}
	}

	/**
	 * Получить вакансию
	 *
	 * @param int $id
	 * @return mixed false или массив полей вакансии
	 */
	function GetVacancy($id)
	{
	    global $db;

	    $res = $db->getArrayOfResult("SELECT * FROM `user_work_vacancy` WHERE id=".intval($id)
	       .(! $this->is_admin ? " AND active=1" : ""));
	    if (is_array($res)) {
	        return $res[0];
	    }
	    return false;
	}

	/**
	 * Удалить вакансию
	 *
	 * @param int $id
	 * @return boolean
	 */
	function DelVacancy($id)
	{
	    global $db;

	    if (!$this->test_item_rights("d", "id", "user_work_vacancy", $id, false)) {
	        $main->message_access_denied($this->module_name, $action);
	    }

	    $db->query("DELETE FROM `user_work_vacancy` WHERE id=".intval($id));
	    return  $db->affected_rows() ? true : false;
	}

	/**
	 * Получить список вакансия
	 *
	 * @param mixed $start
	 * @param mixed $rows
	 * @param array $filter
	 * @return mixed
	 */
	function GetVacancyList($start, $rows, $filter = array())
	{
	    global $db, $baseurl, $CONFIG;
		$fltr = array();

		$start = $start >= 1 ? (int) $start : 1;
		$rows = $rows > 1 ? (int) $rows : $CONFIG['job_max_rows'];

		if (isset($filter['owner_id']) && $filter['owner_id']) {
			$fltr[] = "v.owner_id=".intval($filter['owner_id']);
		}
		if (isset($filter['ref_city']) && $filter['ref_city']) {
			$fltr[] = "v.ref_city=".intval($filter['ref_city']);
		}
		if (isset($filter['ref_activity']) && $filter['ref_activity']) {
			$fltr[] = "v.ref_activity=".intval($filter['ref_activity']);
		}
		if (! $this->is_admin) {
			$fltr[] = "v.active=1";
		}
		$order = isset($filter['order']) && $filter['order']
		    ? "v.".$db->escape($filter['order'])
		    : "v.last_upd DESC";
		$total_cnt = $this->get_list_with_rights(
		    "v.*, u.username, u.email", "user_work_vacancy v LEFT JOIN core_users u ON u.id=owner_id", "v",
		    implode(" AND ", $fltr), $order, "",
		    $start, $rows, true
		);
		$pages_cnt = ceil($total_cnt/$rows);
		if ($db->nf() > 0) {
			while($db->next_record()) {
				$id		= $db->f('id');
				$is_owner = $db->f("is_owner");
				$rights = $db->f("user_rights");
				$ref_val_list = $this->GetReferenceVals(array(
				    $db->Record['ref_city'],
				    $db->Record['ref_activity'],
				    $db->Record['ref_vcnc_ctgr'],
				    $db->Record['ref_education'],
				    $db->Record['ref_experience'],
				    $db->Record['ref_schedule']
				));

				$arr[] = $db->Record
				    + array(
				        'ref_city_val' => $ref_val_list[$db->Record['ref_city']]['name'],
				        'ref_activity_val' => $ref_val_list[$db->Record['ref_activity']]['name'],
				        'ref_category_val' => $ref_val_list[$db->Record['ref_vcnc_ctgr']]['name'],
				        'ref_education_val' => $ref_val_list[$db->Record['ref_education']]['name'],
				        'ref_experience_val' => $ref_val_list[$db->Record['ref_experience']]['name'],
				        'ref_schedule_val' => $ref_val_list[$db->Record['ref_schedule']]['name'],
				        'link' => $baseurl."&action=vacancy&id=".$db->Record['id']
				    );
			}
			return array($arr, $pages_cnt, $total_cnt);
		}

		return false;
	}

	/**
	 * Имеет ли пользователь выкансии
	 *
	 * @param int $user_id
	 * @return boolean
	 */
	function hasUserVacncy($user_id = 0)
	{
	    global $db;
		$ret = $this->get_list_with_rights(
		    "v.id", "user_work_vacancy AS v", "v",
		    "v.owner_id=".intval($user_id)." AND v.active", "", "",
		    1, 1
		);
		return $db->nf() ? true : false;
	}

	/**
	 * Показать список вакансий
	 *
	 * @param mixed $start
	 * @param mixed $rows
	 * @param array $filter
	 * @param string $action
	 */
	function ShowVacancyList($start, $rows, $filter = array(), $action = '')
	{
		global $tpl, $main, $baseurl;
		$l = $this->GetVacancyList($start, $rows, $filter);
		$start = $start >= 1 ? (int) $start : 1;
		if ($l) {
		    $tpl->newBlock('block_vacancy_list');
		    $tpl->assign(array(
		        "MSG_Rights"      => $main->_msg["Rights"],
    		    "MSG_Reference"   => $this->_msg["Reference"],
    		    "MSG_Del"         => $this->_msg["Del"],
    		    "MSG_Ed"          => $this->_msg["Ed"],
    		    "MSG_Activ"       => $this->_msg["Activ"],
    		    "MSG_User"        => $this->_msg["User"],
    		    "MSG_Post"        => $this->_msg["Post"],
    		    "MSG_City"        => $this->_msg["City"],
    		    "MSG_Category"    => $this->_msg["Category"],
    		    "MSG_Activity"    => $this->_msg["Activity"],
    		    "MSG_Updated"     => $this->_msg["Updated"],
    		    "cnt"             => $l[2]
    		));
    		$start_query = $start > 1 ? "&start=".$start : "";
    		$url_query = '';
    		foreach ($filter as $key => $val) {
    			$url_query .= "&data[".htmlspecialchars($key)."]=".htmlspecialchars($val);
    		}
		    foreach ($l[0] as $key => $val) {
		        $tpl->newBlock('block_vacancy');
		        $val['link'] .= $url_query.$start_query;
		    	$tpl->assign($val + array('baseurl' => $baseurl));
    		    if ($val['is_owner']) {
    		    	$tpl->newBlock('block_vacancy_edit');
    		    	$tpl->assign($val + array('baseurl' => $baseurl));
    		    }
		    	if ($this->is_admin) {
		    		$this->show_block_by_rights(
    		    	    $val['id'],
    		    	    $val['active'],
    		    	    $val['is_owner'],
    		    	    $val['user_rights'],
    		    	    $baseurl,
    		    	    '',
    		    	    array()
    		    	);
		    	}
		    }

		    $action = ($action ? $action : 'ressume').$url_query;
		    if ($l[1]) {
		        $main->_show_nav_block($l[1], null, 'action='.$action, $start);
		        $tpl->gotoBlock('nav');
		        $tpl->assign('MSG_Pages', $this->_msg['Pages']);
		    }
		} else {
		    $tpl->newBlock('block_vacancy_list_empty');
		}
	}

	/**
	 * Получить резюме пользователя.
	 * Если $user_id не указан, пользователь авторизован, возращается его резюме.
	 * Иначе false/
	 *
	 * @param int $user_id
	 * @return mixed
	 */
	function GetUserResume($user_id = 0)
	{
		global $db;
		$user_id = $user_id
		  ? (int) $user_id
		  : (isset($_SESSION["siteuser"]["id"]) ? $_SESSION["siteuser"]["id"] : 0);
	    $res = $db->getArrayOfResult("SELECT * FROM `user_work_resume` WHERE owner_id=".intval($user_id));
	    if (is_array($res)) {
	        return $res[0];
	    }
	    return false;
	}

	/**
	 * Показать форму добавления/редактирования резюме пользователя
	 *
	 */
	function ShowUserResumeForm()
	{
		global $tpl, $CONFIG, $baseurl;

		require_once(RP."mod/siteusers/lib/class.SiteusersPrototype.php");
		if (! $_SESSION["siteuser"]["is_authorized"]) {
			$tpl->newBlock('block_access_deny');
			$tpl->assign(Array(
					"reg_url"	=> $baseurl,
		  ));
			return;
		}
		$tpl->newBlock('block_form');
		$tpl->assign(array(
		    'baseurl' => $baseurl,
		    'referer' => htmlspecialchars($_SERVER['HTTP_REFERER'])
		));
		$user_resume = $this->GetUserResume();
		if (! $user_resume) {
			$tpl->newBlock('block_add');
		} else {
		    $tpl->assign($user_resume);
		    $tpl->newBlock('block_edit');
		    $tpl->assign($user_resume + array('baseurl' => $baseurl));
		}
		Module::show_select('block_ref_city', $user_resume['ref_city'], 'name', $this->GetReferenceValList($CONFIG['job_ref_city_id']));
		Module::show_select('block_ref_activity', $user_resume['ref_activity'], 'name', $this->GetReferenceValList($CONFIG['job_ref_activity_id']));
		Module::show_select('block_ref_schedule', $user_resume['ref_schedule'], 'name', $this->GetReferenceValList($CONFIG['job_ref_schedule_id']));
		Module::show_select('block_ref_education', $user_resume['ref_education'], 'name', $this->GetReferenceValList($CONFIG['job_ref_education_id']));
		Module::show_select('block_ref_experience', $user_resume['ref_experience'], 'name', $this->GetReferenceValList($CONFIG['job_ref_experience_id']));
	}

	/**
	 * Может ли текущий пользователь добавлять/редактировать резюме
	 *
	 * @param int $resume_id
	 * @return boolean
	 */
	function CheckUserResume($resume_id = 0)
	{
		global $db;

		if (! $_SESSION["siteuser"]["is_authorized"]) {
			return false;
		}
		$user_resume = $this->GetUserResume();
		/* Может ли пользователь редактировать резюме */
		if ($resume_id && !$user_resume) {
		    /* У пользоватиеля нет резюме */
			return false;
		}
		if ($resume_id && $user_resume && $user_resume['id'] != $resume_id) {
		    /* Чужое резюме */
			return false;
		}

		/* Может ли пользователь добавлять резюме */
		if (!$resume_id && $user_resume) {
			/* У пользователя уже есть резюме */
			return false;
		}
		return true;
	}

	/**
	 * Показать форму добавления/редактирования вакансии пользователя
	 *
	 */
	function ShowUserVacancyForm($vacancy_id = 0)
	{
		global $tpl, $CONFIG, $baseurl;

		if (! $_SESSION["siteuser"]["is_authorized"]) {
			$tpl->newBlock('block_access_deny');
			return;
		}
		$vacancy_id = (int) $vacancy_id;
		if ($vacancy_id) {
			$vacancy = $this->GetVacancy($vacancy_id);
			if (!$vacancy || $vacancy['owner_id'] != $_SESSION["siteuser"]["id"]) {
				$tpl->newBlock('block_access_deny');
				return;
			}
		}
		$tpl->newBlock('block_form');
		$tpl->assign('baseurl', $baseurl);
		if (! $vacancy_id) {
			$tpl->newBlock('block_add');
		} else {
		    $tpl->assign($vacancy);
		    $tpl->newBlock('block_edit');
		}
		Module::show_select('block_ref_city', $vacancy['ref_city'], 'name', $this->GetReferenceValList($CONFIG['job_ref_city_id']));
		Module::show_select('block_ref_activity', $vacancy['ref_activity'], 'name', $this->GetReferenceValList($CONFIG['job_ref_activity_id']));
		Module::show_select('block_ref_schedule', $vacancy['ref_schedule'], 'name', $this->GetReferenceValList($CONFIG['job_ref_schedule_id']));
		Module::show_select('block_ref_education', $vacancy['ref_education'], 'name', $this->GetReferenceValList($CONFIG['job_ref_education_id']));
		Module::show_select('block_ref_experience', $vacancy['ref_experience'], 'name', $this->GetReferenceValList($CONFIG['job_ref_experience_id']));
		Module::show_select('block_ref_vcnc_ctgr', $vacancy['ref_vcnc_ctgr'], 'name', $this->GetReferenceValList($CONFIG['job_ref_vcnc_ctgr_id']));
	}

	/**
	 * Может ли текущий пользователь добавлять/редактировать вакансию
	 *
	 * @param int $vacancy_id
	 * @return boolean
	 */
	function CheckUserVacancy($vacancy_id = 0)
	{
		global $db;

		if (! $_SESSION["siteuser"]["is_authorized"]) {
			return false;
		}
		/* Может ли пользователь редактировать резюме */
		$vacancy_id = (int) $vacancy_id;
		if ($vacancy_id) {
			$vacancy = $this->GetVacancy($vacancy_id);
			if (!$vacancy || ($vacancy && $vacancy['owner_id'] != $_SESSION["siteuser"]["id"])) {
			    /* нет такой вакансии или вакансия пренадлежит не текущему пользователю */
				return false;
			}
		}

		return true;
	}

	/**
	 * Показать форму поиска резюме
	 */
	function ShowResumeSrchForm($transurl, $cur_city = 0, $cur_activity = 0)
	{
	    global $tpl, $CONFIG;

		$tpl->newBlock('block_form');
		$tpl->assign(array(
		    'transurl' => $transurl,
		    'resume_count' => $this->GetResumeCount(),
		));
		$cur_city = $cur_city > 0 ? (int) $cur_city : 0;
		$cur_activity = $cur_activity > 0 ? (int) $cur_activity : 0;
		Module::show_select('block_ref_city', $cur_city, 'name', $this->GetReferenceValList($CONFIG['job_ref_city_id']));
		Module::show_select('block_ref_activity', $cur_activity, 'name', $this->GetReferenceValList($CONFIG['job_ref_activity_id']));

		require_once(RP."mod/siteusers/lib/class.SiteusersPrototype.php");
		$tpl->newBlock(
		    $_SESSION["siteuser"]["is_authorized"] && $this->GetUserResume()
		        ? 'block_edit_link'
		        : 'block_add_link'
		);
		$tpl->assign('link', $transurl."&action=userresume");
	}

	/**
	 * Показать форму поиска вакансий
	 */
	function ShowVacancySrchForm($transurl, $cur_city = 0, $cur_activity = 0)
	{
	    global $tpl, $CONFIG;

		$tpl->newBlock('block_form');
		$tpl->assign(array(
		    'transurl' => $transurl,
		    'vacancy_count' => $this->GetVacancyCount()
		));
		$cur_city = $cur_city > 0 ? (int) $cur_city : 0;
		$cur_activity = $cur_activity > 0 ? (int) $cur_activity : 0;
		Module::show_select('block_ref_city', $cur_city, 'name', $this->GetReferenceValList($CONFIG['job_ref_city_id']));
		Module::show_select('block_ref_activity', $cur_activity, 'name', $this->GetReferenceValList($CONFIG['job_ref_activity_id']));

		require_once(RP."mod/siteusers/lib/class.SiteusersPrototype.php");
		$tpl->newBlock(
		    $_SESSION["siteuser"]["is_authorized"] && $this->GetVacancyList(0, 0, array('owner_id' => $_SESSION["siteuser"]["id"]))
		        ? 'block_edit_link'
		        : 'block_add_link'
		);
		$tpl->assign('link', $transurl."&action=uservacancies");
	}
	/**
	 * Показать вакансию
	 */
	function ShowVacancy($vacancy, $request = '', $start = 0)
	{
		global $tpl, $baseurl;

		if (!$vacancy) {
			$tpl->newBlock('block_not_exist');
			return;
		}
		$q = $start > 1 ? "&start=".intval($start) : '';
		if (is_array($request)) {
			foreach ($request as $key => $val) {
				$q .= "&data[".htmlspecialchars($key)."]=".htmlspecialchars($val);
			}
		}
		$tpl->newBlock('block_vacancy');
		$ref_val_list = $this->GetReferenceVals(array(
		    $vacancy['ref_city'],
		    $vacancy['ref_activity'],
		    $vacancy['ref_vcnc_ctgr'],
		    $vacancy['ref_education'],
		    $vacancy['ref_experience'],
		    $vacancy['ref_schedule']
		));
		$tpl->assign($vacancy + array(
		    'ref_city_val' => $ref_val_list[$vacancy['ref_city']]['name'],
		    'ref_activity_val' => $ref_val_list[$vacancy['ref_activity']]['name'],
		    'ref_category_val' => $ref_val_list[$vacancy['ref_vcnc_ctgr']]['name'],
		    'ref_education_val' => $ref_val_list[$vacancy['ref_education']]['name'],
		    'ref_experience_val' => $ref_val_list[$vacancy['ref_experience']]['name'],
		    'ref_schedule_val' => $ref_val_list[$vacancy['ref_schedule']]['name'],
		    'list_link' => $baseurl.$q
		));
		$this->addition_to_path[$vacancy['post']] = '';
	}

	/**
	 * Показать резюме
	 */
	function ShowResume($resume, $request = '', $start = 0)
	{
		global $tpl, $baseurl;

		$q = $start > 1 ? "&start=".intval($start) : '';
		if (is_array($request)) {
			foreach ($request as $key => $val) {
				$q .= "&data[".htmlspecialchars($key)."]=".htmlspecialchars($val);
			}
		}
		$tpl->assign(array('_ROOT.list_link' => $baseurl.$q));

		if (!$resume) {
			$tpl->newBlock('block_not_exist');
			$tpl->assign(array('list_link' => $baseurl.$q));
			return;
		}
		$tpl->newBlock('block_resume');
		$ref_val_list = $this->GetReferenceVals(array(
		    $resume['ref_city'],
		    $resume['ref_activity'],
		    $resume['ref_education'],
		    $resume['ref_experience'],
		    $resume['ref_schedule']
		));
		$tpl->assign($resume + array(
		    'ref_city_val' => $ref_val_list[$resume['ref_city']]['name'],
		    'ref_activity_val' => $ref_val_list[$resume['ref_activity']]['name'],
		    'ref_education_val' => $ref_val_list[$resume['ref_education']]['name'],
		    'ref_experience_val' => $ref_val_list[$resume['ref_experience']]['name'],
		    'ref_schedule_val' => $ref_val_list[$resume['ref_schedule']]['name'],
		    'list_link' => $baseurl.$q
		));
		if ($resume['owner_id'] == $_SESSION["siteuser"]["id"]) {
			$tpl->newBlock('block_resume_edit');
			$tpl->assign(array(
			    'edit_link' => $baseurl."&action=userresume",
			    'del_link' => $baseurl."&action=delresume&id=".$resume['id']
			));
		}

		$this->addition_to_path[$resume['post']] = '';
	}
	/**
	 * Получить кол-во вакансий
	 *
	 * @return unknown
	 */
	function GetVacancyCount()
	{
		global $db;

		$db->query('SELECT COUNT(*) FROM user_work_vacancy WHERE active');
		$db->next_record();
		return $db->Record[0];
	}
	/**
	 * Получить кол-во резюме
	 *
	 * @return unknown
	 */
	function GetResumeCount()
	{
		global $db;

		$db->query('SELECT COUNT(*) FROM user_work_resume WHERE active');
		$db->next_record();
		return $db->Record[0];
	}
}
?>