<?php
class SitelinksPrototype extends Module {

	var $main_title;
	var $table_prefix;
	var $addition_to_path;
	var $module_name				= 'sitelinks';
	var $default_action				= 'show';
	var $admin_default_action		= 'showctg';
	var $tpl_path					= 'mod/sitelinks/tpl/';
	var $block_module_actions		= array();
	var $block_main_module_actions	= array();
	var $site_status                = array();
	var $tree_indent_ch             = "-";

	function SitelinksPrototype($action = '', $transurl = '', $properties = array(), $prefix = NULL, $rewrite_mod_params = NULL)
	{
		global $main, $tpl, $tpl_path, $baseurl, $cache, $lc, $CONFIG, $PAGE, $server, $lang, $permissions;

		/* Get $action, $tpl_name, $permissions */
		extract( $this->init(array(
		    'server' => $server, 'lang' => $lang, 'prefix' => $prefix,
		    'action' => $action, 'tpl_name' => $properties['tpl']
		)), EXTR_OVERWRITE);
		
		$this->block_module_actions			= array('list'  	=> $this->_msg["Show_categories_list"],
		        'tree'   	=> $this->_msg["Show_categories_tree"],
		        'new'    	=> $this->_msg["Show_adding_site_form"],
		        'show'		=> $this->_msg["Show_links_list"],
		);
		$this->block_main_module_actions	= array('list'  	=> $this->_msg["Show_categories_list"],
		        'tree'   	=> $this->_msg["Show_categories_tree"],
		        'new'    	=> $this->_msg["Show_adding_site_form"],
		        'show'		=> $this->_msg["Show_links_list"],
		);
		$this->site_status					= array(0  => $this->_msg["New"],
		        1  => $this->_msg["Activated"],
		        2  => $this->_msg["Confirmed"],
		        3  => $this->_msg["Canceled"],
		);
		
		$def_ctg_id = (int)$properties[1];
		$rows = (int)$properties[2];
		$rows = $properties[2] > 1 ? (int)$properties[2] : $CONFIG['sitelinks_max_rows'];
		
		if ('only_create_object' == $action) {
		    return;
		}
		
		if ($this->actionExists($action)) {
		    $this->doAction($action);
		    return;
		}
		
		if (! self::is_admin()) {		    
//---------------------------------- обработка действий с сайта --------------------------------//
			switch ($action) {
            /* Показывать список категорий */
			case "list":
				global $request_ctg_id, $request_ctg_order;
				$request_ctg_id = (int)$request_ctg_id;
				$main->include_main_blocks($this->module_name . "_list.html", "main");
				$tpl->prepare();
				$ctg_id = isset($request_ctg_id) ? $request_ctg_id : $def_ctg_id;
				$this->showCtgList($transurl, $ctg_id, $request_ctg_order);

				break;

			/* Показывать дерево категорий */
			case "tree":
				global $request_ctg_id;
				$request_ctg_id = (int)$request_ctg_id;
				$main->include_main_blocks($this->module_name . "_tree.html", "main");
				$tpl->prepare();
				$ctg_id = isset($request_ctg_id) ? $request_ctg_id : $def_ctg_id;
				$ctg_tree = $this->getGtgTree(0, $request_ctg_order, TRUE);
				$url = $transurl . ("?" == substr($transurl, -1) ? "" : "&");
				$url .= "action=show&ctg_id=";

				$tree_html = $this->showCtgTree($ctg_tree, $url, $ctg_id);
				$tpl->assign('tree', $tree_html);

				break;

			/* Показывать список ссылок по категориям */
			case "show":
				global $request_ctg_id, $request_ctg_order, $request_site_order, $request_start, $request_parent;
				$request_ctg_id = (int)$request_ctg_id;
				$main->include_main_blocks($this->module_name . "_show.html", "main");
				$tpl->prepare();

				$ctg_id = isset($request_ctg_id) ? $request_ctg_id : $def_ctg_id;
				$this->showCtgList($transurl, $ctg_id, $request_ctg_order);

				$link = "action=show&ctg_id=".$ctg_id."&parent=".$request_parent;
				$link .= "&ctg_order=".$request_ctg_order."&site_order=".$request_site_order;
				$this->showSiteList($ctg_id, $request_site_order, $request_start, $link);

				break;

			/* Показывать форму добавления сайта */
			case "new":
				global $request_ctg_id, $request_ctg_order, $request_site_order, $request_start, $request_parent, $request_encoding;
				$request_ctg_id = (int)$request_ctg_id;
				$main->include_main_blocks($this->module_name . "_add.html", "main");
				$tpl->prepare();

				$ctg_id = isset($request_ctg_id) ? $request_ctg_id : $def_ctg_id;
				$encoding = isset($request_encoding) ? $request_encoding : '';
				$this->showSiteForm($transurl, $ctg_id, $encoding);

				break;

			/* Сформировать изображение для подтверждения */
			case "captcha":
				include RP . "/inc/captcha/lib.image.php";
                $str = $CONFIG["sitelinks_captcha_symbols"];
                for($i = 0; $i < $CONFIG["sitelinks_captcha_wordlength"]; $i++) {
                	$code[] = substr($str, rand(0, abo_strlen($str) - 1), 1);
                }
                $_SESSION['sitelinks_captcha'] = $text = implode("", $code);

                $image_width = $CONFIG["sitelinks_captcha_width"];
                $image_height = $CONFIG["sitelinks_captcha_height"];
                $font_uri = $CONFIG["sitelinks_captcha_fonts"];
                $font_size = $CONFIG["sitelinks_captcha_fontsize"];
                $font_depth = $CONFIG["sitelinks_captcha_fontdepth"];
                $bgcolor = $CONFIG["sitelinks_captcha_bgcolor"];
                $color = $CONFIG["sitelinks_captcha_color"];
                $color2 = $CONFIG["sitelinks_captcha_color2"];

                $img = new CryptPng($image_width, $image_height);

                if($img->create())
                {
                	$img->apply(new GradientEffect($bgcolor[0], $bgcolor[1], $bgcolor[2]));
                	$img->apply(new GridEffect(2, $bgcolor[0], $bgcolor[1], $bgcolor[2]));
                	$img->apply(new DotEffect());
                	$t = new TextEffect($text, $font_size, $font_depth, $color, $color2);
                	foreach($font_uri as $k => $v)
                	{
                		$t->addFont($v);
                	}
                	$img->apply($t);
                	$img->apply(new DotEffect());
                	$img->render();
                }
                exit;

			/* Проверить URL сайта, URL и код обратной ссылкой и код подтверждения  */
			case "check_form_data":
			    global $request_url, $request_back_url, $request_code_id, $request_captcha, $request_encoding;

			    $request_url = $this->trimUrl($request_url);
			    $request_back_url = $this->trimUrl($request_back_url);
			    $request_code_id = (int) $request_code_id;

    			$GLOBALS['_RESULT'] =
    			    array(
    			        "result" => $this->checkFormData(
    			            $request_url,
    			            $request_back_url,
    			            $request_code_id,
    			            $request_captcha,
    			            $request_encoding
    			        )
    			    );

                exit;

			/* Добавить сайт */
			case "add":
			    global $request_url, $request_back_url, $request_code_id, $request_captcha, $request_ctg_id, $request_title, $request_dscr, $request_email, $request_note, $request_encoding;
			    $request_ctg_id = (int)$request_ctg_id;
			    $main->include_main_blocks($this->module_name . "_add.html", "main");
				$tpl->prepare();
				$check = $this->checkFormData(
				    $request_url,
				    $request_back_url,
		            $request_code_id,
		            $request_captcha,
		            $request_encoding
		        );
		        if (1 == $check &&
		            $site_id = $this->addSite(
    				    $request_ctg_id,
    				    $request_code_id,
    				    $request_url,
    				    $request_title,
    				    $request_dscr,
    				    $request_email,
    				    $request_back_url,
    				    $request_note)
				) {
    			    unset($_SESSION['sitelinks_code']);
    			    unset($_SESSION['sitelinks_captcha']);
    	        	$tpl->newBlock('block_msg');

    	        	$site = $this->getSite($site_id);
    	        	$assign = array(
    	        	    'web_address' => $CONFIG['web_address'],
             		        'sitename_rus' => $CONFIG['sitename_rus'],
             		        'contacn_email' => $CONFIG['sitelinks_recipient'],
             		        'activation_link' => 'http://'.$_SERVER['HTTP_HOST'].$transurl.("?" == substr($transurl, -1) ? "" : "&").'action=activation&code='.$site['activation_code'].'&nocash',
    	        	);
    	        	$this->sendMail($site['email'], "Активация сайта", "block_activation", $assign);

    	        } else {
    	        	$tpl->newBlock('block_err');
    	        }

				break;

			/* Активация сайта  */
			case "activation":
		    global $request_code;
		    $main->include_main_blocks($this->module_name . "_activation.html", "main");
			  $tpl->prepare();
		    if ($this->activateSite($request_code)) {
		        $tpl->newBlock("block_ok");
		    } else {
		        $tpl->newBlock("block_no");
		    }

		    break;

// Default...
			default:
				$main->no_such_page();
				$tpl->prepare();
			}
//------------------------------- конец обработки действий с сайта -----------------------------//
		} else {
//------------------------------ обработка действий из админ части -----------------------------//            
			if (!isset($tpl)) {
			    $main->message_die('Не подключен класс для работы с шаблонами');
			}

			if ('add_code' != $action && !$code_cnt = $this->getLinkCodeCount()) {
			    if($action == 'showctg') $action = 'codes';
			}

			switch ($action) {
		    case 'prp':

		    	if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $request_step;

				$main->include_main_blocks('_properties.html', $this->tpl_path);
				$tpl->prepare();
				$tpl->assign(Array(
					"MSG_Information"	=> $main->_msg["Information"],
					"MSG_Value"			=> $main->_msg["Value"],
					"MSG_Save"			=> $main->_msg["Save"],
					"MSG_Cancel"		=> $main->_msg["Cancel"],
				));
		        if (!$request_step || $request_step == 1) {
					$tpl->assign(
					    array(
					        'form_action'	=> $baseurl,
					        'step'			=> 2,
					        'lang'			=> $lang,
					        'name'			=> $this->module_name,
					        'action'		=> 'prp'
					    )
					);
					$prp_html = $main->getModuleProperties($this->module_name);
		            $this->main_title = $this->_msg["Controls"];
				} elseif (2 == $request_step) {
		        	$main->setModuleProperties($this->module_name, $_POST);
					header('Location: '.$baseurl.'&action=prp&step=1');
				}

		    	break;

			case 'block_prp':

				global $request_sub_action, $request_block_id;
		    	$arr  = $this->getEditLink($request_sub_action, $request_block_id);
		    	$cont = 'var container = document.getElementById(\'target_span\');
		    		  	 container.innerHTML	= "'.$this->getPropertyFields().'";
		    		  	 material_id			= "'.$arr['material_id'].'";
		    		  	 material_url			= "'.$arr['material_url'].'";
		    		  	 changeAction();
		    	      	 setURL("property1");';
				header('Content-Length: '.abo_strlen($cont));
		    	echo $cont;
		    	exit;

		    	break;

		    // Редактирование свойств блока
			case 'properties':

				if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $module_id, $request_field, $request_block_id, $title;

				$main->include_main_blocks('_block_properties.html', 'main');
				$tpl->prepare();
				if ($main->show_actions($request_field, '', $this->block_main_module_actions, $this->block_module_actions)) {
					$main->show_linked_pages($module_id, $request_field);
				}

				$tpl->assign(
				    array(
				        '_ROOT.title'		=> $title,
				        '_ROOT.username'	=> $_SESSION['session_login'],
				        '_ROOT.password'	=> $_SESSION['session_password'],
				        '_ROOT.name'		=> $this->module_name,
				        '_ROOT.lang'		=> $lang,
				        '_ROOT.block_id'	=> $request_block_id
				    )
				);

				$this->main_title	= $this->_msg["Block_properties"];
				break;

		    /* Сайты для утверждения */
			case 'new':

				if (!$permissions['r']) $main->message_access_denied($this->module_name, $action);
				global $request_start;
				$main->include_main_blocks_2($this->module_name.'_new.html', $this->tpl_path);
				$tpl->prepare();
				$this->showNewSiteList($request_start);
				$this->main_title	= $this->_msg["Sites_confirmation"];

				break;

		    /* Вывод списка кодов */
			case 'codes':

				if (!$permissions['r']) $main->message_access_denied($this->module_name, $action);
				global $request_start;
				$main->include_main_blocks_2($this->module_name."_codes.html", $this->tpl_path);
				$tpl->prepare();
				$tpl->assign(Array(
					"MSG_Add_code" => $this->_msg["Add_code"],
					"MSG_Add" => $this->_msg["Add"],
					"MSG_Links_HTML_source" => $this->_msg["Links_HTML_source"],
					"MSG_Save" => $this->_msg["Save"],
					"MSG_Cancel" => $this->_msg["Cancel"],
					"MSG_Add_code" => $this->_msg["Add_code"],
					"MSG_Edit_code" => $this->_msg["Edit_code"],
					"MSG_Enter_HTML_source" => $this->_msg["Enter_HTML_source"],
					"MSG_Suspend" => $this->_msg["Suspend"],
					"MSG_Activate" => $this->_msg["Activate"],
				));

				$this->showLinkCodes($request_start);

				$this->main_title = $this->_msg["HTML_source"];

			    break;

		    /* Добавить код */
			case 'add_code':

			    if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
			    global $request_code, $request_start;
				$main->include_main_blocks_2($this->module_name."_codes.html", $this->tpl_path);
				$tpl->prepare();

				$this->addLinkCode($request_code);
				$this->showLinkCodes($request_start);

				$this->main_title = $this->_msg["HTML_source"];

			    break;

			/* Изменить код */
			case 'edit_code':

			    if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
			    global $request_id, $request_code, $request_start;
				$main->include_main_blocks_2($this->module_name."_codes.html", $this->tpl_path);
				$tpl->prepare();

				$this->setLinkCode($request_id, array('code' => $request_code));
				$this->showLinkCodes($request_start);

				$this->main_title = $this->_msg["HTML_source"];

			    break;

		    /* Удалить код */
			case 'del_code':

			    if (!$permissions["d"]) $main->message_access_denied($this->module_name, $action);
			    global $request_id, $request_start;
				$main->include_main_blocks_2($this->module_name."_codes.html", $this->tpl_path);
				$tpl->prepare();

				$this->delLinkCode($request_id);
				$this->showLinkCodes($request_start);

				$this->main_title = $this->_msg["HTML_source"];

			    break;

			/* Отключить публикацию кода */
			case 'suspend_code':

			    if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
			    global $request_id;
			    if ($this->setLinkCode($request_id, array('active' => 0))) {
					$GLOBALS['_RESULT'] = array(
						"code_id"		=> $request_id,
						"active"	=> 0,
					);
			    }
			    exit;

		    /* Включить публикацию кода */
			case 'activate_code':

		    if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
		    global $request_id;
		    if ($this->setLinkCode($request_id, array('active' => 1))) {
    			$GLOBALS['_RESULT'] = array(
    				"code_id"		=> $request_id,
    				"active"	=> 1,
    			);
		    }
		    exit;

		    /* Вывод списка кодов для выбора*/
			case 'select_code':

		    if (!$permissions["r"]) $main->message_access_denied($this->module_name, $action);
				global $request_start;
				$main->include_main_blocks_2($this->module_name."_select_code.html", $this->tpl_path);
				$tpl->prepare();
				$tpl->assign(Array(
					"MSG_Close_window" => $this->_msg["Close_window"],
				));
				$this->showLinkCodes($request_start, TRUE, 'menu=false&action='.$action);
				$this->main_title = $this->_msg["HTML_source"];

		    break;

		    /* Показать категории  */
			case 'showctg':

				if (!$permissions['r']) $main->message_access_denied($this->module_name, $action);
				global $request_ctg_id, $request_ctg_order, $request_site_order, $request_start;
				$main->include_main_blocks_2($this->module_name.'_categories.html', $this->tpl_path);
				$tpl->prepare();
				$tpl->assign(Array(
					"MSG_Add_category" => $this->_msg["Add_category"],
					"MSG_Add_site" => $this->_msg["Add_site"],
					"MSG_Add_category" => $this->_msg["Add_category"],
					"MSG_Category_name" => $this->_msg["Category_name"],
					"MSG_Save" => $this->_msg["Save"],
					"MSG_Cancel" => $this->_msg["Cancel"],
					"MSG_Add_category_to" => $this->_msg["Add_category_to"],
					"MSG_Edit_category" => $this->_msg["Edit_category"],
					"MSG_Enter_category_name" => $this->_msg["Enter_category_name"],
					"MSG_Suspend" => $this->_msg["Suspend"],
					"MSG_Activate" => $this->_msg["Activate"],
					"MSG_Set_status" => $this->_msg["Set_status"],
					"MSG_Suspend_feedback_check" => $this->_msg["Suspend_feedback_check"],
					"MSG_Mark_as" => $this->_msg["Mark_as"],
					"MSG_Deleting_category" => $this->_msg["Deleting_category"],
				));
				$this->showCategory($request_ctg_id, $request_ctg_order, $request_site_order, $request_start);

				$this->main_title	= $this->_msg["Sites"];

				break;

		    /* Добавить категорию  */
			case 'add_ctg':

				if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $request_ctg_id, $request_title, $request_ctg_order;
				$main->include_main_blocks_2($this->module_name.'_categories.html', $this->tpl_path);
				$tpl->prepare();

				$this->addCategory($request_ctg_id, $request_title);
				$this->showCategory($request_ctg_id, $request_ctg_order);

				$this->main_title	= $this->_msg["Sites_catalogue"];
                header('Location: '.$baseurl.'&action=showctg&ctg_id='.$request_ctg_id);
				break;

		    /* Отредактировать категорию  */
			case 'edit_ctg':

				if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $request_edit_ctg_id, $request_ctg_id, $request_title, $request_ctg_order;
				$main->include_main_blocks_2($this->module_name.'_categories.html', $this->tpl_path);
				$tpl->prepare();

				$this->setCategory($request_edit_ctg_id, array('title' => $request_title));
				header('Location: '.$baseurl.'&action=showctg');
				break;

		    /* Удалить категорию  */
			case 'del_ctg':

				if (!$permissions['d']) $main->message_access_denied($this->module_name, $action);
				global $request_ctg_id, $parent_id;
				$main->include_main_blocks_2($this->module_name.'_categories.html', $this->tpl_path);
				$tpl->prepare();

				$parent_id = $this->delCategory($request_ctg_id);
				$this->showCategory($parent_id);

                header('Location: '.$baseurl.'&action=showctg&ctg_id='.$parent_id);
				break;

			/* Добавить сайт  */
			case 'new_site':

				if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $request_ctg_id, $request_site_id;
				$main->include_main_blocks_2($this->module_name."_edit.html", $this->tpl_path);
				$tpl->prepare();
				$tpl->assign(Array(
					"MSG_Choose_HTML_source" => $this->_msg["Choose_HTML_source"],
					"MSG_Enter_email" => $this->_msg["Enter_email"],
					"MSG_Enter_site_description" => $this->_msg["Enter_site_description"],
					"MSG_Site_description_too_long" => $this->_msg["Site_description_too_long"],
					"MSG_Enter_site_name" => $this->_msg["Enter_site_name"],
					"MSG_Site_name_too_long" => $this->_msg["Site_name_too_long"],
					"MSG_Enter_site_URL" => $this->_msg["Enter_site_URL"],
					"MSG_Enter_URL_with_backlink" => $this->_msg["Enter_URL_with_backlink"],
					"MSG_URLs_differs" => $this->_msg["URLs_differs"],
					"MSG_Site_URL" => $this->_msg["Site_URL"],
					"MSG_Site_name" => $this->_msg["Site_name"],
					"MSG_Site_description" => $this->_msg["Site_description"],
					"MSG_Contact_email" => $this->_msg["Contact_email"],
					"MSG_URL_with_backlink" => $this->_msg["URL_with_backlink"],
					"MSG_Backlink_HTML_source" => $this->_msg["Backlink_HTML_source"],
					"MSG_Select" => $this->_msg["Select"],
					"MSG_Notice" => $this->_msg["Notice"],
					"MSG_Date_create" => $this->_msg["Date_create"],
					"MSG_Feedback_check" => $this->_msg["Feedback_check"],
					"MSG_check" => $this->_msg["check"],
					"MSG_not_check" => $this->_msg["not_check"],
					"MSG_Site_status" => $this->_msg["Site_status"],
					"MSG_required_fields" => $this->_msg["required_fields"],
					"MSG_Save" => $this->_msg["Save"],
					"MSG_Cancel" => $this->_msg["Cancel"],
				));

				$this->showSiteFormAdm($request_ctg_id, $request_site_id);

				$this->main_title	= $this->_msg["Add_site"];

				break;

		    /* Добавить сайт  */
			case 'add_site':

				if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $request_ctg_id, $request_code_id, $request_url, $request_title, $request_dscr,
				    $request_email, $request_back_url, $request_note, $request_status, $request_check_url;
				$main->include_main_blocks_2($this->module_name."_edit.html", $this->tpl_path);
				$tpl->prepare();
				$tpl->assign(Array(
					"MSG_Choose_HTML_source" => $this->_msg["Choose_HTML_source"],
					"MSG_Enter_email" => $this->_msg["Enter_email"],
					"MSG_Enter_site_description" => $this->_msg["Enter_site_description"],
					"MSG_Site_description_too_long" => $this->_msg["Site_description_too_long"],
					"MSG_Enter_site_name" => $this->_msg["Enter_site_name"],
					"MSG_Site_name_too_long" => $this->_msg["Site_name_too_long"],
					"MSG_Enter_site_URL" => $this->_msg["Enter_site_URL"],
					"MSG_Enter_URL_with_backlink" => $this->_msg["Enter_URL_with_backlink"],
					"MSG_URLs_differs" => $this->_msg["URLs_differs"],
					"MSG_Site_URL" => $this->_msg["Site_URL"],
					"MSG_Site_name" => $this->_msg["Site_name"],
					"MSG_Site_description" => $this->_msg["Site_description"],
					"MSG_Contact_email" => $this->_msg["Contact_email"],
					"MSG_URL_with_backlink" => $this->_msg["URL_with_backlink"],
					"MSG_Backlink_HTML_source" => $this->_msg["Backlink_HTML_source"],
					"MSG_Select" => $this->_msg["Select"],
					"MSG_Notice" => $this->_msg["Notice"],
					"MSG_Date_create" => $this->_msg["Date_create"],
					"MSG_Feedback_check" => $this->_msg["Feedback_check"],
					"MSG_check" => $this->_msg["check"],
					"MSG_not_check" => $this->_msg["not_check"],
					"MSG_Site_status" => $this->_msg["Site_status"],
					"MSG_required_fields" => $this->_msg["required_fields"],
					"MSG_Save" => $this->_msg["Save"],
					"MSG_Cancel" => $this->_msg["Cancel"],
				));

				$site_id = $this->addSite(
				    $request_ctg_id,
				    $request_code_id,
				    $request_url,
				    $request_title,
				    $request_dscr,
				    $request_email,
				    $request_back_url,
				    $request_note,
				    $request_status,
				    $request_check_url
				);
				if ($site_id) {
					header("Location: ".$baseurl."&action=edit_site&ctg_id=".$request_ctg_id."&site_id=".$site_id);
					exit;
				}
				$this->showSiteFormAdm($request_ctg_id, $site_id);

				$this->main_title	= $this->_msg["Edit_site"];

				break;

			/* Добавить сайт  */
			case 'edit_site':

				if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $request_ctg_id, $request_site_id;
				$main->include_main_blocks_2($this->module_name."_edit.html", $this->tpl_path);
				$tpl->prepare();
				$tpl->assign(Array(
					"MSG_Choose_HTML_source" => $this->_msg["Choose_HTML_source"],
					"MSG_Enter_email" => $this->_msg["Enter_email"],
					"MSG_Enter_site_description" => $this->_msg["Enter_site_description"],
					"MSG_Site_description_too_long" => $this->_msg["Site_description_too_long"],
					"MSG_Enter_site_name" => $this->_msg["Enter_site_name"],
					"MSG_Site_name_too_long" => $this->_msg["Site_name_too_long"],
					"MSG_Enter_site_URL" => $this->_msg["Enter_site_URL"],
					"MSG_Enter_URL_with_backlink" => $this->_msg["Enter_URL_with_backlink"],
					"MSG_URLs_differs" => $this->_msg["URLs_differs"],
					"MSG_Site_URL" => $this->_msg["Site_URL"],
					"MSG_Site_name" => $this->_msg["Site_name"],
					"MSG_Site_description" => $this->_msg["Site_description"],
					"MSG_Contact_email" => $this->_msg["Contact_email"],
					"MSG_URL_with_backlink" => $this->_msg["URL_with_backlink"],
					"MSG_Backlink_HTML_source" => $this->_msg["Backlink_HTML_source"],
					"MSG_Select" => $this->_msg["Select"],
					"MSG_Notice" => $this->_msg["Notice"],
					"MSG_Date_create" => $this->_msg["Date_create"],
					"MSG_Feedback_check" => $this->_msg["Feedback_check"],
					"MSG_check" => $this->_msg["check"],
					"MSG_not_check" => $this->_msg["not_check"],
					"MSG_Site_status" => $this->_msg["Site_status"],
					"MSG_required_fields" => $this->_msg["required_fields"],
					"MSG_Save" => $this->_msg["Save"],
					"MSG_Cancel" => $this->_msg["Cancel"],
				));

				$this->showSiteFormAdm($request_ctg_id, $request_site_id);

				$this->main_title	= $this->_msg["Edit_site"];

				break;

		    /* Удалить сайт  */
			case 'del_site':

				if (!$permissions['d']) $main->message_access_denied($this->module_name, $action);
				global $request_site_id, $request_ctg_id;
				$main->include_main_blocks_2($this->module_name."_edit.html", $this->tpl_path);
				$tpl->prepare();

				$site_id = $this->delSite($request_site_id);
				header("Location: ".$baseurl."&action="
				    .(false === strpos($_SERVER["HTTP_REFERER"], "showctg")
				    ? "new" : "showctg&ctg_id=".$request_ctg_id));
				exit;

				break;

			/* Редактировать сайт  */
			case 'update_site':

				if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $request_ctg_id, $request_code_id, $request_url, $request_title, $request_dscr,
						$request_email, $request_back_url, $request_note, $request_status, $request_active,
						$request_check_url, $request_confirmed, $request_site_id;
				$main->include_main_blocks_2($this->module_name."_edit.html", $this->tpl_path);
				$tpl->prepare();

				$param = array();
				if (isset($request_ctg_id))		$param['ctg_id'] = $request_ctg_id;
				if (isset($request_code_id))	$param['code_id'] = $request_code_id;
				if (isset($request_url)) 		$param['url'] = $request_url;
				if (isset($request_title))		$param['title'] = $request_title;
				if (isset($request_dscr))		$param['dscr'] = $request_dscr;
				if (isset($request_email))		$param['email'] = $request_email;
				if (isset($request_back_url))	$param['back_url'] = $request_back_url;
				if (isset($request_note))		$param['note'] = $request_note;
				if (isset($request_status))		$param['status'] = $request_status;
				if (isset($request_active))		$param['active'] = $request_active;
				if (isset($request_check_url))	$param['check_url'] = $request_check_url;
				if (isset($request_confirmed))	$param['confirmed'] = $request_confirmed;

				$res = $this->setSite($request_site_id, $param);
				if ($res) {
					header("Location: ".$baseurl."&action=edit_site&ctg_id=".$request_ctg_id."&site_id=".$request_site_id);
					exit;
				}
				$this->showSiteFormAdm($request_ctg_id, $request_site_id);

				$this->main_title	= $this->_msg["Sites_catalogue"];

				break;

			/* Отключить публикацию сайта */
			case 'suspend_site':

			    if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
				global $request_id;
			    if ($this->setSite($request_id, array('active' => 0))) {
					$GLOBALS['_RESULT'] = array(
						"site_id" => $request_id,
						"active" => 0,
					);
			    }
			    exit;

		    /* Включить публикацию сайта */
			case 'activate_site':

			    if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
				global $request_id;
			    if ($this->setSite($request_id, array('active' => 1))) {
					$GLOBALS['_RESULT'] = array(
						"site_id" => $request_id,
						"active" => 1,
					);
			    }
			    exit;

		    /* Изменить состояние сайта */
			case 'set_status':

			    if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
				global $request_id, $request_status, $request_JsHttpRequest;
			    if ($this->setSite($request_id, array('status' => $request_status))) {
			        if (2 == $request_status || 3 == $request_status) {
			            $site = $this->getSite($request_id);
			            $assign = array(
			        	    'web_address' => $CONFIG['web_address'],
		       		        'sitename_rus' => $CONFIG['sitename_rus'],
		       		        'contacn_email' => $CONFIG['sitelinks_recipient']
			        	);
			            $this->sendMail(
			                $site['email'],
			                2 == $request_status ? $this->_msg["Site_confirmation"] : $this->_msg["Site_canceling"],
			                2 == $request_status ? 'block_confirmation' : 'block_rejection',
			                $assign);
			        }
			        if (isset($request_JsHttpRequest)) {
		    			$GLOBALS['_RESULT'] = array(
		    				"site_id" => $request_id,
		    				"status" => $request_status,
		    			);
		    			exit;
			        } else {
			            header("Location: ".$baseurl."&action=new");
			            exit;
			        }
			    }

			    $main->include_main_blocks();
				$tpl->prepare();
				break;

			/* Отключить проверку обратной ссылки */
			case 'check_url_off':

			    if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
				global $request_id;
			    if ($this->setSite($request_id, array('check_url' => 0))) {
					$GLOBALS['_RESULT'] = array(
						"site_id" => $request_id,
						"check_url" => 0,
					);
			    }
			    exit;

		    /* Включить проверку обратной ссылки */
			case 'check_url_on':

			    if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
				global $request_id;
			    if ($this->setSite($request_id, array('check_url' => 1))) {
					$GLOBALS['_RESULT'] = array(
						"site_id" => $request_id,
						"check_url" => 1,
					);
			    }
			    exit;

			/* Отметить как - не найден код обратной ссылки */
			case 'confirm_off':

			    if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
				global $request_id;
			    if ($this->setSite($request_id, array('confirmed' => 0))) {
					$GLOBALS['_RESULT'] = array(
						"site_id" => $request_id,
						"confirm" => 0,
					);
			    }
			    exit;

		    /* Отметить как - найден код обратной ссылки  */
			case 'confirm_on':

			    if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
				global $request_id;
			    if ($this->setSite($request_id, array('confirmed' => 1))) {
					$GLOBALS['_RESULT'] = array(
						"site_id" => $request_id,
						"confirm" => 1,
					);
			    }
			    exit;

		    /* Операции */
			case 'opr':

			    if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
			    global $request_send;
			    $main->include_main_blocks_2($this->module_name."_opr.html", $this->tpl_path);
				$tpl->prepare();
				$tpl->assign(Array(
					"MSG_Enter_mail_subject" => $this->_msg["Enter_mail_subject"],
					"MSG_Enter_mail_body" => $this->_msg["Enter_mail_body"],
					"MSG_Get_all_emails" => $this->_msg["Get_all_emails"],
					"MSG_Send_mails" => $this->_msg["Send_mails"],
					"MSG_Site_status" => $this->_msg["Site_status"],
					"MSG_All" => $this->_msg["All"],
					"MSG_Mail_subject" => $this->_msg["Mail_subject"],
					"MSG_Mail_body" => $this->_msg["Mail_body"],
					"MSG_Begin_send" => $this->_msg["Begin_send"],
				));
				$tpl->assign(
				    array(
				        'get_emails_link' => $baseurl.'&action=get_emails',
				        'cron_path' => dirname(__FILE__)."/cron.php",
				        'form_action' => $baseurl.'&action=send_emails',
				    )
				);

				Main::show_list($this->site_status, 'block_status', -1);
				if (isset($request_send)) {
					$tpl->newBlock('block_send_ok');
					$tpl->assign(Array(
						"MSG_Mails_sent_num" => $this->_msg["Mails_sent_num"],
					));
					$tpl->assign('send', $request_send);
				}

				$this->main_title	= $this->_msg["Subscription"];

				break;

		    /* Выгрузить все Email */
			case 'get_emails':

			    if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);

			    header('Content-Type: application/x-csv');
				header('Expires: '.gmdate('D, d M Y H:i:s').' GMT');
				header('Content-Disposition: inline; filename=SitelinkEmails.csv');
				header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
				header('Pragma: public');
				echo implode("\n", $this->getEmails());
				exit;

				break;

		    /* Разослать письма  */
			case 'send_emails':

				if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $request_sbj, $request_txt_content, $request_status;

				$send = $this->distribution($request_sbj, $request_txt_content, $request_status);

				header("Location: ".$baseurl."&action=opr&send=".$send);
				exit;

				break;

			/* Инфо */
			case 'info':

			    if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
			    $main->include_main_blocks_2($this->module_name."_info.html", $this->tpl_path);
			    $tpl->prepare();
				$tpl->assign(Array(
					"MSG_Info_backlink_check" => $this->_msg["Info_backlink_check"],
					"MSG_by_schedule_in" => $this->_msg["by_schedule_in"],
					"MSG_Scheduler" => $this->_msg["Scheduler"],
					"MSG_Script_check_all_confirmed_sites" => $this->_msg["Script_check_all_confirmed_sites"],
					"MSG_Period_defined_by" => $this->_msg["Period_defined_by"],
					"MSG_controls" => $this->_msg["controls"],
					"MSG_of_module" => $this->_msg["of_module"],
				));
			    $tpl->assign(
			        array (
			            'cron_path' => "mod/sitelinks/cron.php",
			            'baseurl' => $baseurl,
			            'lang' => $lang
			        )
			    );

				$this->main_title	= $this->_msg["Feedback_check"];

				break;

		// Создание объекта для дальнейшего использования
			case 'only_create_object':

				break;

		    /* Default */
			default:

				$main->include_main_blocks();
				$tpl->prepare();
			}
//--------------------------- конец обработки действий из админ части --------------------------//
		}
	}



	/**
	 * Получить HTML-код ссылки
	 *
	 * @param int $id
	 * @return mixed
	 */
	function getLinkCode($id = 0)
	{   global $db;

	    $where = $id > 0 ? "C.id=".intval($id) : "C.active";
	    $query = "SELECT C.*, COUNT(S.id) AS site_cnt";
	    $query .= " FROM ".$this->table_prefix."_sitelinks_codes AS C";
	    $query .= " LEFT JOIN ".$this->table_prefix."_sitelinks AS S ON C.id=S.code_id";
	    $query .= " WHERE ".$where." GROUP BY C.id ORDER BY site_cnt, C.id LIMIT 1";
		$db->query($query);
		if ($db->next_record()) {
			return array(
			    'id' => $db->f('id'),
			    'code' => $db->f('code'),
			    'active' => $db->f('active'),
			    'site_cnt' => $db->f('site_cnt')
			);
		}

		return FALSE;
	}



	/**
	 * Получить список HTML-кодов ссылок
	 *
	 * @param int $page
	 * @param boolean $active
	 * @return array
	 */
	function getLinkCodeList($page, $active = FALSE)
	{   global $db, $CONFIG;

		$page = $page > 1 ? (int) $page : 1;
		$link_on_page = $CONFIG['sitelinks_max_rows'] > 1 ? (int) $CONFIG['sitelinks_max_rows'] : 5;
		$where = $active ? " WHERE C.active" : "";

		$ret = array();
		$query = "SELECT C.id, C.code, C.active, COUNT(L.id) AS cnt FROM";
		$query .= " ".$this->table_prefix."_sitelinks_codes AS C";
		$query .= " LEFT JOIN ".$this->table_prefix."_sitelinks AS L ON C.id=L.code_id";
		$query .= $where." GROUP BY C.id ORDER BY id DESC";
		$query .= " LIMIT ".($page - 1)*$link_on_page.", ".$link_on_page;
		$db->query($query);
		while ($db->next_record()) {
		    $ret[] = array(
		        'id' => $db->f('id'),
		        'code' => $db->f('code'),
		        'active' => $db->f('active'),
		        'site_count' => $db->f('cnt')
		    );
		}

		return $ret;
	}

	/**
	 * Получить кол-во HTML-кодов ссылок
	 *
	 * @param boolean $active
	 * @return int
	 */
	function getLinkCodeCount($active = FALSE)
	{   global $db;

	    $where = $active ? " WHERE active" : "";
		$db->query("SELECT COUNT(*) AS cnt FROM ".$this->table_prefix."_sitelinks_codes".$where);
		if ($db->next_record()) {
			return $db->f('cnt');
		}

		return 0;
	}

	/**
	 * Получить категорию
	 *
	 * @param int $id
	 * @return mixed
	 */
	function getCategory($id)
	{   global $db;

	    $query = "SELECT C.*, P.title AS parent_title";
	    $query .= " FROM ".$this->table_prefix."_sitelinks_categories AS C";
	    $query .= " LEFT JOIN ".$this->table_prefix."_sitelinks_categories AS P";
	    $query .= " ON C.parent_id=P.id WHERE C.id=".intval($id);
		$db->query($query);
		if ($db->next_record()) {
		    $ctg_id = $db->f($ctg_id);
			return array(
			    'id' => $id,
			    'title' => $db->f('title'),
			    'create_date' => $db->f('create_date'),
			    'parent_id' => $db->f('parent_id'),
			    'parent_title' => $db->f('parent_title')
			);
		}

		return FALSE;
	}

	/**
	 * Получить список категорий
	 *
	 * @param int $parent_id
	 * @param string $order
	 * @param boolean $active
	 * @return boolean
	 */
	function getCtgList($parent_id, $order, $active = false)
	{   global $db, $CONFIG;

	    $ord = $this->getCtgOrderBy($order);

	    $ret = array();
	    $query = "SELECT * FROM ".$this->table_prefix."_sitelinks_categories";
	    $query .= " WHERE parent_id=".intval($parent_id)." ORDER BY ".$ord;
	    $db->query($query);
	    while ($db->next_record()) {
	        $ctg_id = $db->f('id');
	    	$ret[] = array(
	    	    'id' => $ctg_id,
	    	    'title' => $db->f('title'),
	    	    'date' => $db->f('create_date'),
	    	    'site_cnt' => $this->getCtgSiteCnt($ctg_id, $active),
	    	);
	    }

	    return $ret;
	}

	/**
	 * Отобразить список дочерних категорий
	 *
	 * @param string $transurl
	 * @param int $parent_id
	 * @param string $order
	 * @return unknown
	 */
	function showCtgList($transurl, $parent_id, $order)
	{   global $tpl, $CONFIG;

	    $url = $transurl . ("?" == substr($transurl, -1) ? "" : "&");
		if (!$parent_id) {
			$parent_id = 0;
			$tpl->newBlock('block_ctg');
			$tpl->assign(
    		    array(
    		        'id' => '',
    		        'title' => $CONFIG['sitelinks_root_title'],
    		        'add_site_link' => $url."action=new"
    		    )
    		);
		} else {
		    $ctg = $this->getCategory($parent_id);
    		if (!$ctg) {
    			return FALSE;
    		}
    		$tpl->newBlock('block_ctg');
    		$tpl->assign(
    		    array(
    		        'id' => $ctg['id'],
    		        'title' => $ctg['title'],
    		        'add_site_link' => $url."action=new&ctg_id=".$ctg['id']
    		    )
    		);
    		$tpl->newBlock('block_ctg_parent');
    		$tpl->assign(
    		    array(
    		        'parent_id' => $ctg['parent_id'],
    		        'parent_title' => $ctg['parent_id'] ? $ctg['parent_title'] : $CONFIG['sitelinks_root_title'],
    		        'parent_list_link' => $url."action=list&ctg_id=".$ctg['parent_id'],
    		        'parent_show_link' => $url."action=show&ctg_id=".$ctg['parent_id'],
    		        'id' => $ctg['id'],
    		        'title' => $ctg['title']
    		    )
    		);
		}

		$ctg_list = $this->getCtgList($parent_id, $order, TRUE);
		if (is_array($ctg_list)) {
			$tpl->newBlock('block_ctg_list');
			foreach ($ctg_list as $key => $val) {
				$tpl->newBlock('block_one_ctg');
        		$tpl->assign(
        		    array(
        		        'id' => $val['id'],
        		        'title' => $val['title'],
        		        'list_link' => $url."action=list&ctg_id=".$val['id'],
        		        'show_link' => $url."action=show&ctg_id=".$val['id']."&parent=".$parent_id,
        		        'site_cnt' => $val['site_cnt']
        		    )
        		);
			}
		}
	}

	/**
	 * Получить параметр сортировки катагорий
	 *
	 * @param string $order
	 * @return string
	 */
	function getCtgOrderBy($order)
	{   global $CONFIG;

	    static $order_list = array(
	        'title' => 'title',
	        '-title' => 'title DESC',
	        'date' => 'create_date',
	        '-date' => 'create_date DESC',
	        'site' => 'site_cnt',
	        '-site' => 'site_cnt DESC'
	    );

	    $order = array_key_exists($order, $order_list) ? $order : $CONFIG['sitelinks_ctg_order_by'];
	    return  $order_list[$order];

	}

	/**
	 * Получить список идентификаторов дочерних катагорий
	 *
	 * @param unknown_type $root_id
	 * @return unknown
	 */
	function getSubCtgIdList($root_id = 0)
	{   static $tree = array(), $level = 0;
	    global $CONFIG;

	    $db 			= new My_Sql;
        $db->Database 	= $CONFIG['db_database'];
        $db->Host 		= $CONFIG['db_host'];
        $db->User 		= $CONFIG['db_user'];
        $db->Password 	= $CONFIG['db_password'];

		$root_id = $root_id > 0 ? (int) $root_id : 0;

		$query = "SELECT id FROM ".$this->table_prefix."_sitelinks_categories ";
	    $query .= " WHERE parent_id=".$root_id;

	    $db->query($query);
	    $level++;
	    while ($db->next_record()) {
	        $ctg_id = $db->f('id');
	    	$tree[] = $ctg_id;
	    	$this->getSubCtgIdList($ctg_id);
	    }
	    $level--;

	    if (!$level) {
	        $ret = $tree;
	    	$tree = array();

	    	return $ret;
	    }
	}

	/**
	 * Получить кол-во сайтов в категории и всех её дочерних категориях
	 *
	 * @param int $root_id
	 * @param boolean $active
	 * @return int
	 */
	function getCtgSiteCnt($root_id, $active = false)
	{   global $CONFIG;

	    $db 			= new My_Sql;
        $db->Database 	= $CONFIG['db_database'];
        $db->Host 		= $CONFIG['db_host'];
        $db->User 		= $CONFIG['db_user'];
        $db->Password 	= $CONFIG['db_password'];

		$ctg_list = $this->getSubCtgIdList($root_id);
		array_push($ctg_list, (int) $root_id);

		$where = $active ? " AND active AND status=2 AND confirmed" : "";

		$query = "SELECT COUNT(*) AS cnt FROM ".$this->table_prefix."_sitelinks";
		$query .= " WHERE category_id IN (".implode(", ", $ctg_list).")".$where;
		$db->query($query);
		if ($db->next_record()) {
			return $db->f('cnt');
		}

		return 0;
	}

	/**
	 * Получить дерево разделов
	 *
	 * @param int $root_id
	 * @param string $order
	 * @return array
	 */
	function getGtgTree($root_id = 0, $order = '', $active = false)
	{   static $tree = array(), $level = 0;
	    global $CONFIG;

	    $db 			= new My_Sql;
        $db->Database 	= $CONFIG['db_database'];
        $db->Host 		= $CONFIG['db_host'];
        $db->User 		= $CONFIG['db_user'];
        $db->Password 	= $CONFIG['db_password'];

		$root_id = $root_id > 0 ? (int) $root_id : 0;
		$order = $this->getCtgOrderBy($order);

	    $query = "SELECT *";
	    $query .= " FROM ".$this->table_prefix."_sitelinks_categories";
	    $query .= " WHERE parent_id=".$root_id." ORDER BY ".$order;
	    $db->query($query);
	    $level++;
	    while ($db->next_record()) {
	        $ctg_id = $db->f('id');
	    	$tree[] = array(
	    	    'parent_id' => $db->f('parent_id'),
	    	    'id' => $ctg_id,
	    	    'title' => $db->f('title'),
	    	    'date' => $db->f('create_date'),
	    	    'site_cnt' => $this->getCtgSiteCnt($ctg_id, $active),
	    	    'level' => $level
	    	);
	    	$this->getGtgTree($ctg_id, $order, $active);
	    }
	    $level--;

	    if (!$level) {
	        $ret = $tree;
	    	$tree = array();

	    	return $ret;
	    }
	}

	/**
	 * Показать дерево категорий
	 *
	 * @param array $tree
	 * @return string
	 */
	function showCtgTree($tree, $href, $curent_id = 0)
	{
		if (!is_array($tree) || count($tree) == 0 ) {
			return;
		}

		$ret = '';
		$level = 0;
		foreach ($tree as $key => $item) {
			if ($item['level'] > $level) {
				$level++;
				$ret .= "<ul ".(1 == $item['level'] ? " id=\"mn\"" : "").">\n";
			}
			while($item['level'] < $level) {
				$level--;
				$ret .= "</ul>\n";
			}
			$ret .= "<li".($curent_id == $item['id'] ? " class=\"current\"" : "").">";
			$ret .= "<a href=\"".$href.$item['id']."&parent=".$item['parent_id']."\">";
			$ret .= $item['title']." [".$item['site_cnt']."]";
			$ret .= "</a>";
			//$ret .= "</li>\n";
		}
		$ret .= "</ul>\n";

		return $ret;
	}

	/**
	 * Получить список родительских категорий
	 *
	 * @param int $ctg_id
	 * @return mixed
	 */
	function getGtgParentList($ctg_id)
	{   static $parents = array();
	    global $CONFIG;

	    $db 			= new My_Sql;
        $db->Database 	= $CONFIG['db_database'];
        $db->Host 		= $CONFIG['db_host'];
        $db->User 		= $CONFIG['db_user'];
        $db->Password 	= $CONFIG['db_password'];

		$ctg_id = $ctg_id > 0 ? (int) $ctg_id : 0;

	    $query = "SELECT P.* FROM";
	    $query .= " ".$this->table_prefix."_sitelinks_categories AS CH,";
	    $query .= " ".$this->table_prefix."_sitelinks_categories AS P";
	    $query .= " WHERE CH.id=".$ctg_id." AND CH.parent_id=P.id";
	    $db->query($query);
	    if ($db->next_record()) {
	        $ctg_id = $db->f('id');
	        $parent_id = $db->f('parent_id');
	    	$parents[] = array(
	    	    'parent_id' => $parent_id,
	    	    'id' => $ctg_id,
	    	    'title' => $db->f('title'),
	    	    'date' => $db->f('create_date')
	    	);
	    	if (0 == $parent_id) {
	    		$ret = array_reverse($parents);
        	    $parents = array();

        	    return $ret;
	    	}

	    	return $this->getGtgParentList($ctg_id);
	    }
	}

	/**
	 * Удалить http:// из строки
	 *
	 * @param string $url
	 * @return string
	 */
	function trimUrl($url)
	{
		return preg_replace(array("/http:\/\//i", "/\s/"), array("", ""), $url);
	}

	/**
	 * Проверить URL сайта и URL обратной ссылки
	 *
	 * @param string $url
	 * @param string $back_url
	 * @todo Порверить валидность и существование
	 * @return boolean
	 */
	function isValidSiteUrl($url, $back_url)
	{
		return !$back_url || !$url || FALSE === strpos($back_url, $url) ? FALSE : TRUE;
	}

	/**
	 * Имеет ли строка допустимую длинну
	 *
	 * @param string $str
	 * @param int $max_length
	 * @param int $min_length
	 * @return boolean
	 */
	function isValidStr($str, $min_length, $max_length)
	{
		$max = (int) $max_length;
		$min = (int) $min_length;
		$len = abo_strlen($str);

		return (0 == $len || ($max > 0 && $len > $max) || ($min > 0 && $len < $min))
		    ? FALSE
		    : TRUE;
	}

	/**
	 * Получить ссылку
	 *
	 * @param int $id
	 * @return mixed
	 */
	function getSite($id)
	{   global $db;

	    $query = "SELECT S.*, C.title AS ctg_title, H.code";
	    $query .= " FROM ".$this->table_prefix."_sitelinks AS S";
	    $query .= " LEFT JOIN ".$this->table_prefix."_sitelinks_categories AS C ON S.category_id=C.id";
	    $query .= " LEFT JOIN ".$this->table_prefix."_sitelinks_codes AS H ON S.code_id=H.id";
	    $query .= " WHERE S.id=".intval($id);
		$db->query($query);
		if ($db->next_record()) {
			return array(
			    'id' => $db->f('id'),
			    'ctg_id' => $db->f('category_id'),
			    'url' => $db->f('url'),
			    'title' => $db->f('title'),
			    'dscr' => $db->f('dscr'),
			    'email' => $db->f('email'),
			    'back_url' => $db->f('back_url'),
			    'note' => $db->f('note'),
			    'tcy' => $db->f('tcy'),
			    'create_date' => $db->f('create_date'),
			    'code_id' => $db->f('code_id'),
			    'status' => $db->f('status'),
			    'active' => $db->f('active'),
			    'check_url' => $db->f('check_url'),
			    'confirmed' => $db->f('confirmed'),
			    'ctg_title' => $db->f('ctg_title'),
			    'code' => $db->f('code'),
			    'activation_code' => $db->f('activation_code')
			);
		}

		return FALSE;
	}

	/**
	 * Добавить сайт
	 *
	 * @param int $ctg_id
	 * @param int $code_id
	 * @param string $url
	 * @param string $title
	 * @param string $dscr
	 * @param string $email
	 * @param string $back_url
	 * @param string $note
	 * @param int $status
	 * @param int $check_url
	 * @return mixed
	 */
	function addSite(
	    $ctg_id,
	    $code_id,
	    $url,
	    $title,
	    $dscr,
	    $email,
	    $back_url,
	    $note,
	    $status = 0,
	    $check_url = 1
	)
	{   global $db, $CONFIG;

	    $ctg = $this->getCategory($ctg_id);
	    $code = $this->getLinkCode($code_id);
	    $site_url = My_sql::escape($this->trimUrl($url));
	    $site_title = My_sql::escape($title);
	    $site_dscr = My_sql::escape($dscr);
	    $site_email = My_sql::escape($email);
	    $site_back_url = My_sql::escape($this->trimUrl($back_url));
	    $site_note = My_sql::escape($note);
	    $site_status = array_key_exists($status, $this->site_status) ? $status : 0;
	    $site_tcy = $this->getTcy($site_url);
	    $site_check_url = $check_url ? 1 : 0;

	   if (
		    !is_array($ctg) || !is_array($code)
		    || !$site_email || !$this->isValidSiteUrl($site_url, $site_back_url)
		    || !$this->isValidStr($site_title, $CONFIG['sitelinks_min_title'], $CONFIG['sitelinks_max_title'])
		    || !$this->isValidStr($site_dscr, $CONFIG['sitelinks_min_dscr'], $CONFIG['sitelinks_max_dscr'])
		) {
		    return FALSE;
		}

		$query = "INSERT INTO ".$this->table_prefix."_sitelinks";
		$query .= " (category_id, url, title, dscr,";
		$query .= " email, back_url, note, tcy,";
		$query .= " check_date, create_date, code_id, status, check_url,";
		$query .= " active, confirmed, activation_code)";
		$query .= " VALUES";
		$query .= " (".$ctg['id'].", '".$site_url."', '".$site_title."', '".$site_dscr."',";
		$query .= " '".$site_email."','".$site_back_url."','".$site_note."', ".$site_tcy.",";
		$query .= " NOW(), NOW(), ".$code['id'].", ".$site_status.", ".$site_check_url.",";
		$query .= " 1, 1, '".md5(time())."')";
		$db->query($query);

		return $db->lid();
	}

	function urlExists($url)
	{
		global $db;
		$db->query("SELECT id FROM {$this->table_prefix}_sitelinks WHERE url='".My_sql::escape($this->trimUrl($url))."'");
		return $db->nf() ? true : false;
	}

	/**
	 * Получить параметр сортировки сайтов
	 *
	 * @param string $order
	 * @return string
	 */
	function getSiteOrderBy($order)
	{   global $CONFIG;

	    static $order_list = array(
	        'date' => 'create_date',
	        '-date' => 'create_date DESC',
	        'tcy' => 'tcy',
	        '-tcy' => 'tcy DESC'
	    );

	    $order = array_key_exists($order, $order_list) ? $order : $CONFIG['sitelinks_order_by'];
	    return  $order_list[$order];

	}

	/**
	 * Получить список сайтов
	 *
	 * @param imt $ctg_id
	 * @param int $page
	 * @param string $order
	 * @param boolean $active
	 * @return array
	 */
	function getSiteList($ctg_id, $page, $order, $active = false)
	{   global $db, $CONFIG;

	    $ord = $this->getSiteOrderBy($order);
	    $p = $page > 1 ? (int) $page : 1;
		$link_on_page = $CONFIG['sitelinks_max_rows'] > 1 ? (int) $CONFIG['sitelinks_max_rows'] : 5;
		$where = $active ? " AND S.active AND S.status=2 AND S.confirmed" : "";

	    $ret = array();
	    $query = "SELECT S.*, H.code";
	    $query .= " FROM ".$this->table_prefix."_sitelinks AS S LEFT JOIN";
	    $query .= " ".$this->table_prefix."_sitelinks_codes AS H ON S.code_id=H.id";
	    $query .= " WHERE S.category_id=".intval($ctg_id).$where." ORDER BY S.".$ord;
	    $query .= " LIMIT ".($p - 1)*$link_on_page.", ".$link_on_page;
		$db->query($query);

	    while ($db->next_record()) {
	    	$ret[] = array(
	    	    'id' => $db->f('id'),
			    'ctg_id' => $db->f('category_id'),
			    'url' => $db->f('url'),
			    'title' => $db->f('title'),
			    'dscr' => $db->f('dscr'),
			    'email' => $db->f('email'),
			    'back_url' => $db->f('back_url'),
			    'note' => $db->f('note'),
			    'tcy' => $db->f('tcy'),
			    'date' => $db->f('create_date'),
			    'code_id' => $db->f('code_id'),
			    'status' => $db->f('status'),
			    'active' => $db->f('active'),
			    'check_url' => $db->f('check_url'),
			    'confirmed' => $db->f('confirmed'),
			    'code' => $db->f('code')
	    	);
	    }

	    return $ret;
	}

	/**
	 * Получить кол-во сайтов в категории
	 *
	 * @param int $ctg_id
	 * @param boolean $active
	 * @return unknown
	 */
	function getSiteCnt($ctg_id, $active = false)
	{   global $db;

		$where = $active ? " AND active AND status=2 AND confirmed" : "";

		$query = "SELECT COUNT(*) AS cnt FROM ".$this->table_prefix."_sitelinks WHERE category_id=".intval($ctg_id).$where;
		$db->query($query);
		if ($db->next_record()) {
			return $db->f('cnt');
		}

		return 0;
	}

	/**
	 * Отобразить список сайтов
	 *
	 * @param int $ctg_id
	 * @param string $order
	 * @param int $page
	 * @param string $link
	 */
	function showSiteList($ctg_id, $order, $page, $link)
	{   global $tpl, $baseurl, $CONFIG;

		$site_list = $this->getSiteList($ctg_id, $page, $order, TRUE);

		if (is_array($site_list) && count($site_list)) {
		    $site_cnt = $this->getSiteCnt($ctg_id, TRUE);
			$tpl->newBlock('block_site_list');
			$start = $page > 1 ? (int) $page : 1;
			$num = ($start - 1)*$CONFIG['sitelinks_max_rows'];
	    	foreach ($site_list as $key => $site) {

	    	    $tpl->newBlock('block_one_site');
	    		$tpl->assign(
	    		    array(
	    		        'id' => $site['id'],
	    		        'title' => $site['title'],
	    		        'title_ecpape' => str_replace(array("\"", "'"), array("&quot;", "&#146;"), $site['title']),
	    		        'date' => $site['date'],
	    		        'url' => $site['url'],
	    		        'dscr' => $site['dscr'],
	    		        'date' => $site['date'],
	    		        'num' => ++$num
	    		    )
	    		);
	    	}

	    	Main::_show_nav_block(
	            ceil($site_cnt/$CONFIG['sitelinks_max_rows']),
	            'nav',
	            $link."&site_order=".$order,
	            $start
	        );
		}
	}

	/**
	 * Отобразить форму добавления сайта
	 *
	 * @param strint $transurl
	 * @param int $ctg_id
	 * @return mixed
	 */
	function showSiteForm($transurl, $ctg_id, $encoding)
	{   global $tpl, $CONFIG;

	    $code = $this->getLinkCode(isset($_SESSION['sitelinks_code']) ? $_SESSION['sitelinks_code'] : 0);
	    if (!$code) {
	        return;
	    }
	    $tpl->newBlock('block_add');
	    $_SESSION['sitelinks_code'] = $code['id'];
	    $url = $transurl . ("?" == substr($transurl, -1) ? "" : "&");	    
	    $form_action = $url."&action=add";

	    $title_limit = '';
	    if ($CONFIG['sitelinks_max_title'] > 0 && $CONFIG['sitelinks_min_title'] > 0) {
	    	$title_limit = "(" . $this->_msg["not_less_than"] . " ".$CONFIG['sitelinks_min_title'].", " . $this->_msg["not_more_than"] . " ".$CONFIG['sitelinks_max_title']." " . $this->_msg["symbols"] . ")";
	    } elseif ($CONFIG['sitelinks_min_title'] > 0) {
	    	$title_limit = "(" . $this->_msg["not_less_than"] . " ".$CONFIG['sitelinks_min_title']." " . $this->_msg["symbols"] . ")";
	    } elseif ($CONFIG['sitelinks_max_title'] > 0) {
	    	$title_limit = "(" . $this->_msg["not_more_than"] . " ".$CONFIG['sitelinks_max_title']." " . $this->_msg["symbols"] . ")";
	    }

	    $dscr_limit = '';
	    if ($CONFIG['sitelinks_max_dscr'] > 0 && $CONFIG['sitelinks_min_dscr'] > 0) {
	    	$dscr_limit = "(" . $this->_msg["not_less_than"] . " ".$CONFIG['sitelinks_min_dscr'].", не более ".$CONFIG['sitelinks_max_dscr']." " . $this->_msg["symbols"] . ")";
	    } elseif ($CONFIG['sitelinks_min_dscr'] > 0) {
	    	$dscr_limit = "(" . $this->_msg["not_less_than"] . " ".$CONFIG['sitelinks_min_dscr']." " . $this->_msg["symbols"] . ")";
	    } elseif ($CONFIG['sitelinks_max_dscr'] > 0) {
	    	$dscr_limit = "(" . $this->_msg["not_more_than"] . " ".$CONFIG['sitelinks_max_dscr']." " . $this->_msg["symbols"] . ")";
	    }

	    $tpl->assign(
   	        array(
   	            'form_action' => $form_action,
   	            'transurl' => $url,
   	            'min_title' => $CONFIG['sitelinks_min_title'],
   	            'max_title' => $CONFIG['sitelinks_max_title'],
   	            'title_limit' => $title_limit,
   	            'min_dscr' => $CONFIG['sitelinks_min_dscr'],
   	            'max_dscr' => $CONFIG['sitelinks_max_dscr'],
   	            'dscr_limit' => $dscr_limit,
   	            'ctg_id' => $ctg_id,
   	            'code_id' => $code['id'],
   	            'code' => $code['code'],
   	            'captcha_src' => $url."&action=captcha&".md5(time())
       	    )
       	);
		
       	$ctg_tree = $this->getGtgTree(0, '', TRUE);
		foreach ($ctg_tree as $key => $val) {
			$tpl->newBlock('block_ctg_tree');
			$tpl->assign(
				array(
				    'id' => $val['id'],
					'title' => $val['title'],
					'indent' => "|".str_pad("", $val['level'], $this->tree_indent_ch),
					'selected' => $val['id'] == $ctg_id ? 'selected' : ''
				)
			);
		}
		foreach ($CONFIG['sitelinks_encodings'] as $val) {
			$tpl->newBlock('block_encode_list');
			$tpl->assign(
				array(
					'title' => $val,
					'selected' => $val==$encoding ? 'selected' : ''
				)
			);
		}
	}

	/**
	 * Проверить данные формы добавления сйта
	 *
	 * @param string $p_url      URL сайта
	 * @param string $p_back_url URL страницы с обратной ссылкой
	 * @param int    $p_code_id  Id  кода ссылки
	 * @param string $p_captcha  код подтверждения
	 * @param string $p_encoding  кодировка страницы с обратной ссылкой не найден
	 * @return int 1 - ок
	 *             -1 - неверный код подтверждения
	 *             -2 - не указан код ссылки
	 *             -3 - не найден код ссылки с Id = $p_code_id
	 *             -4 - URL-ы не соответствуют
	 *             -5 - URL сайта не найден
	 *             -6 - URL страницы с обратной ссылкой не найден
	 *             -7 - на страницы с обратной ссылкой не найден код ссылки
	 *             -8 - не определена кодировка URL страницы с обратной ссылкой
	 *             -9 - cайт уже зарегистрирован в каталоге
	 */
	function checkFormData($p_url, $p_back_url, $p_code_id, $p_captcha, $p_encoding = '')
	{   global $CONFIG;

	    $url = $this->trimUrl($p_url);
		$back_url = $this->trimUrl($p_back_url);
		$code_id = (int) $p_code_id;

	    if ($_SESSION['sitelinks_captcha'] != $p_captcha) {
	        return -1;
	    } elseif ($code_id < 1) {
	        return -2;
	    } elseif (!$code = $this->getLinkCode($code_id)) {
	        return -3;
	    } elseif (!$this->isValidSiteUrl($url, $back_url)) {
	        return -4;
	    } elseif ($this->urlExists($url)) {
	        return -9;
	    } else {
	        $url = "http://".$url;
            $fp = @fopen($url, 'r');
            if (!is_resource($fp)) {
             	return -5;
            } else {
                fclose($fp);
                switch ($this->checkBackLink($back_url, $code['code'], $p_encoding)) {
                    case -1:
                        return -6;
                    case -2:
                        return -8;
                    case 0:
                        return -7;
                }
           }
        }

        return 1;
	}

	/**
	 * Проверить наличие кода обратной ссылки
	 *
	 * @param string $back_url  URL страницы с обратной ссылкой
	 * @param string $html_code HTML код обратной ссылки
	 * @return int -2 не определена кодировка URL страницы с обратной ссылкой
	 *             -1 URL страницы с обратной ссылкой не найден<b></b>
	 *              0 на страницы с обратной ссылкой не найден код ссылки
	 *              1 код найден
	 */
	function checkBackLink($back_url, $html_code, $encoding = '')
	{   global $CONFIG;

	    $encoding = in_array($encoding, $CONFIG['sitelinks_encodings']) ? $encoding : '';
        $content = $this->getUrlContent('http://'.$back_url);
        $content['encoding'] = $content['encoding'] ? $content['encoding'] : $encoding;
		if (!$content) {
	    	return -1;
	    } else if(!$content['encoding']) {
	        return -2;
	    } else {
	        $cont = $content['body'];
	        if ($content['encoding'] && 'UTF-8' != $content['encoding']) {
	        	$cont = iconv($content['encoding'], 'UTF-8', $cont);
	        }
	        /* Определение кодировки */
	        $patt = array(
	            "/\n/",
   	            "/&nbsp;/i",
   	        );
   	        $repl = array(
   	            " ",
   	            " ",
   	        );
   	        $cont =  preg_replace($patt, $repl, strtolower($cont));
   	        $code =  preg_replace($patt, $repl, strtolower($html_code));
	        $patt = array(
                "/<head>.*<\/head>/",
   	            "/<!--.*-->/U",
   	            "/<script[^>]*>.*<\/script>/U",
   	            "/\s+/",
   	        );
   	        $repl = array(
   	            "",
   	            "",
   	            "",
   	            " "
   	        );
   	        $cont =  preg_replace($patt, $repl, $cont);
   	        $code = preg_replace("/\s+/", " ", $code);
   	        if (FALSE === strpos($cont, $code)) {
   	            return 0;
   	        }
	    }

	    return 1;
	}

	/**
	 * Получить содержимое и кодировку html страница по url
	 *
	 * @param string $url
	 * @return mixed false OR array('body', 'encoding')
	 */
	function getUrlContent($url)
	{
	    $ret = 0;
		if (extension_loaded('sockets')) {
			$ret = $this->getSocketsUrlContrnt($url);
		}
		return $ret;
	}

	/**
	 * Получить содержимое и кодировку  html страница по url чкркз сокет
	 *
	 * @param string $url
	 * @return mixed false OR array('body', 'encoding')
	 */
	function getSocketsUrlContrnt($url)
	{
	    $ret = false;
	    $url_info = parse_url($url);
	    if (! empty($url_info['host'])) {
	    	$fp = @fsockopen($url_info['host'], 80, $errno, $errstr);
    		if ($fp) {
                $out = "GET ".$url_info['path'].($url_info['query'] ? "?".$url_info['query'] : '')." HTTP/1.1\r\n";
                $out .= "Host: ".$url_info['host']."\r\n";
                $out .= "Connection: Close\r\n\r\n";
                fwrite($fp, $out);
                $encoding = '';
                $s = fgets($fp, 128);
                $x = explode(" ", $s);
                if (2 == $x[1]{0}) { /* HTTP/1.0 200 OK */
                    /* Чтение заголовока */
                    while (!feof($fp) && ($s = fgets($fp, 128)) && "\x0D\x0A" != $s) {
                        if (preg_match('/Content\-Type:\s+text\/html;\s+charset\s*=\s*([\w-]+)/i', $s, $matches)) {
                        	$encoding = $matches[1];
                        }
                    }
                    /* Чтение тела */
                    while (!feof($fp)) {
                        $ret .= fgets($fp, 8192);
                    }
                    if (!$encoding) {
                    	$encoding = $this->getEncodingByMeta($ret);
                    }
                    $ret = array('body' => $ret, 'encoding' => strtoupper($encoding));
                }
                fclose($fp);
    		}
	    }

		return $ret;
	}

	/**
	 * Получить кодировку по метатегу
	 *
	 * @param string $text
	 * @return mixed falase OR string encoding
	 */
	function getEncodingByMeta($text)
	{
	    $ret = false;
		if (preg_match("/<meta\s*([^>]*)http\-equiv\s*=\s*[\"']?content\-type[\"']?([^>]*)>/i", $text, $matches)) {
		    $patt = "/content\s*=\s*[\"']([^>]*)[\"']/i";
		    if (preg_match($patt, $matches[1], $m1) || preg_match($patt, $matches[2], $m2)) {
		        $matches = $m1 ? $m1 : $m2;
		        if (preg_match("/charset\s*=\s*([\w-]+)/i", $matches[1], $m1)) {
		            $ret = $m1[1];
		        }
		    }
		}

		return $ret;
	}

	/**
	 * Активация сайта
	 *
	 * @param string $a_code
	 * @return boolean
	 */
	function activateSite($a_code)
	{   global $db, $CONFIG, $lang;

	    $query = "SELECT S.*, C.title AS ctg_title FROM ".$this->table_prefix."_sitelinks AS S";
	    $query .= " LEFT JOIN ".$this->table_prefix."_sitelinks_categories AS C";
	    $query .= " ON S.category_id=C.id WHERE activation_code='".My_Sql::escape($a_code)."' AND status=0";
		$db->query($query);
		if (0 == $db->nf()) {
			return FALSE;
		}
		$db->next_record();
		$assign =  array(
		    'id' => $db->f('id'),
		    'ctg_id' => $db->f('category_id'),
		    'url' => $db->f('url'),
		    'title' => $db->f('title'),
		    'dscr' => $db->f('dscr'),
		    'email' => $db->f('email'),
		    'back_url' => $db->f('back_url'),
		    'note' => $db->f('note'),
		    'create_date' => $db->f('create_date'),
		    'ctg_title' => $db->f('ctg_title'),
		    'tcy' => $db->f('tcy'),
		    'web_address' => $CONFIG['web_address'],
            'sitename_rus' => $CONFIG['sitename_rus'],
            'contacn_email' => $CONFIG['sitelinks_recipient'],
            'activation_link' => 'http://'.$_SERVER['HTTP_HOST']."/admin.php?lang=".$lang."&name=sitelinks&action=new"
		);

	    $query = "UPDATE ".$this->table_prefix."_sitelinks SET status=1 WHERE id=".$assign['id'];
	    $db->query($query);
    	$this->sendMail(
    	    $CONFIG['sitelinks_recipient'],
    	    $this->_msg["Site_activated_on"] . " ".$CONFIG['sitename_rus'],
    	    "block_admin_activation",
    	    $assign
    	);

	    return true;
	}

	/**
	 * Отправить письмо
	 *
	 * @param string $to
	 * @param string $sbj
	 * @param string $block_name
	 * @param array $assign
	 */
	function sendMail($to, $sbj, $block_name, $assign)
	{   global $CONFIG;

		$tpl = new AboTemplate(RP.'tpl/'.SITE_PREFIX.'/sitelinks_mails.html');
        $tpl->prepare();
   		$tpl->newBlock($block_name);
   		$tpl->assign($assign);

   		require_once(RP.'/inc/class.Mailer.php');
   		$mail = new Mailer();
        $mail->CharSet		= $CONFIG['email_charset'];
        $mail->ContentType	= 'text/html';
		$mail->From			= $CONFIG['sitelinks_recipient'];
		$mail->FromName		= $CONFIG['sitename_rus'];
		$mail->Mailer		= 'mail';
        $mail->Subject		= $sbj;
		$mail->Body			= $tpl->getOutputContent();
       	$mail->to[0][0]     = $to;
       	$mail->Send();
	}

    /**
     * Получить индекс цитирования сайта
     *
     * @param string $url
     * @return int
     */
    function getTcy($url)
    {
        $array_urlink = parse_url($url);
        $cont = @file_get_contents("http://bar-navig.yandex.ru/u?ver=2&lang=1049&url=http://".$url."&target=_No__Name:5&show=1&thc=0");
        if (FALSE !== $cont && preg_match("/<tcy[^>]+value=\"(\d{1,7})\"[^>]*>/is", $cont, $match)) {
            return $match[1];
        }

        return 0;
    }

	function getPropertyFields() {
		GLOBAL $request_sub_action, $baseurl;
		if ('' != $request_sub_action) {

			$tpl = $this->getTmpProperties();

			switch ($request_sub_action) {
				case 'list':
					$tpl->newBlock('block_properties');
					$tpl->newBlock('block_list');
					$tpl->assign(Array(
						"MSG_Parent_category" => $this->_msg["Parent_category"],
						"MSG_Root_section" => $this->_msg["Root_section"],
					));
					$ctg_tree = $this->getGtgTree();
					foreach ($ctg_tree as $key => $val) {
						$tpl->newBlock('block_ctg_tree');
						$tpl->assign(
						    array(
						        'id' => $val['id'],
						        'title' => abo_str_crop($val['title']),
						        'indent' => abo_str_crop("|".str_pad("", $val['level'], $this->tree_indent_ch))
						    )
						);
					}
					break;

				default:
					$tpl->newBlock('block_properties_none');
					$tpl->assign(Array(
						"MSG_No" => $this->_msg["No"],
					));
					break;
			}
			return $this->getOutputContent($tpl->getOutputContent());
		}
		return FALSE;
	}

	function getEditLink($sub_action = NULL, $block_id = NULL) {
		GLOBAL $request_name, $db, $lang, $server;
		$block_id	= (int)$block_id;
		if ($sub_action && $block_id) {
			$db->query('SELECT	property1,
								property2,
								property3,
								property4,
								property5
							FROM '.$server.$lang.'_pages_blocks
							WHERE id = '.$block_id);
			if ($db->nf() > 0) {
				$db->next_record();
				$arr[]	= $db->f('property1');
				$arr[]	= $db->f('property2');
				$arr[]	= $db->f('property3');
				$arr[]	= $db->f('property4');
				$arr[]	= $db->f('property5');

				switch ($sub_action) {
					case 'list':
						$link['material_url']	= '/admin.php?lang='.$lang.'&name='.$request_name.'&action=list&menu=false&category=';
						$link['material_id']	= $arr[0];
						break;
				}
				return $link;
			}

			switch ($sub_action) {
				case 'list':
					$link['material_url']	= '/admin.php?lang='.$lang.'&name='.$request_name.'&action=list&menu=false&category=';
					$link['material_id']	= '';
					break;
			}
			return $link;
		}
		return FALSE;
	}

	/**
	 * Добавить HTML-код ссылки
	 *
	 * @param string $code
	 * @param boolean $active
	 * @return boolean
	 */
	function addLinkCode($code, $active = TRUE)
	{   global $db;

	    $code = My_Sql::escape($code);
	    if ('' === $code) {
	    	return FALSE;
	    }
	    $active = $active ? "1" : "0";
	    $query = "INSERT INTO ".$this->table_prefix."_sitelinks_codes (code, active)";
	    $query .= " VALUES ('".$code."', ".$active.")";

		return $db->query($query);
	}

	/**
	 * Удалить HTML-код ссылки
	 *
	 * @param int $code_id
	 * @return boolean
	 */
	function delLinkCode($code_id)
	{   global $db;

		$code = $this->getLinkCode($code_id);
		if (!is_array($code) || $code['site_cnt'] > 0) {
			return FALSE;
		}

		return $db->query("DELETE FROM ".$this->table_prefix."_sitelinks_codes WHERE id=".$code['id']);
	}

	/**
	 * Изменить HTML-код ссылки
	 *
	 * @param int   $id
	 * @param array $param
	 * @return boolean
	 */
	function setLinkCode($id, $param)
	{   global $db;

	    if (!$this->getLinkCode($id)) {
	    	return FALSE;
	    }
	    $set = isset($param['code']) && '' !== $param['code']
	        ? "code='".My_Sql::escape($param['code'])."'"
	        : '';
	    if (isset($param['active'])) {
	    	$set .= ($set ? ", " : "")."active=" . ($param['active'] ? "1" : "0");
	    }

		return $set
		    ? $db->query("UPDATE ".$this->table_prefix."_sitelinks_codes SET ".$set." WHERE id=".intval($id))
		    : FALSE;
	}

	/**
	 * Показать коды ссылок
	 *
	 * @param int $page
	 * @param boolean $activ
	 * @param string $request_action
	 */
	function showLinkCodes($page, $activ = FALSE, $link = 'action=codes')
	{   global $tpl, $CONFIG, $baseurl;

	    $tpl->assign(
	        array(
	            'form_action' => $baseurl,
	            'action' => "add_code",
	        )
	    );
	    if ($code_cnt = $this->getLinkCodeCount($activ)) {
	        $tpl->newBlock('block_link_codes');
			$tpl->assign(Array(
				"MSG_Activ" => $this->_msg["Activ"],
				"MSG_Ed" => $this->_msg["Ed"],
				"MSG_HTML_source" => $this->_msg["HTML_source"],
				"MSG_Links_with_HTML_num" => $this->_msg["Links_with_HTML_num"],
				"MSG_Del" => $this->_msg["Del"],
			));
	        $code_list = $this->getLinkCodeList($page, $activ);
	        foreach ($code_list as $key => $code) {
	            $status_text = ($code['active'] ? "отключить" : "включить")." публикацию";
	            $status_img = "ico_sw".($code['active'] ? "of" : "on").".gif";

	            $tpl->newBlock('block_link_code');
				$tpl->assign(Array(
					"MSG_Edit" => $this->_msg["Edit"],
					"MSG_Confirm_delete_this_source" => $this->_msg["Confirm_delete_this_source"],
					"MSG_Delete" => $this->_msg["Delete"],
					"MSG_Select" => $this->_msg["Select"],
				));
	            $tpl->assign(
        	        array(
        	            'id' => $code['id'],
        	            'code' => $code['code'],
        	            'active' => $code['active'],
        	            'site_count' => $code['site_count'],
        	            'status_img' => $status_img,
        	            'status_text' => $status_text,
        	            'edit_link' => $baseurl."&action=edit_code&id=".$code['id']
        	        )
        	    );
        	    if (0 == $code['site_count']) {
        	    	$tpl->newBlock('block_del');
        	    	$tpl->assign('del_link', $baseurl."&action=del_code&id=".$code['id']);
        	    }
	        }
	        Main::_show_nav_block(
	            ceil($code_cnt/$CONFIG['sitelinks_max_rows']),
	            'nav',
	            $link,
	            $page > 1 ? (int) $page : 1
	        );
			$tpl->assign(Array(
				"MSG_Pages" => $this->_msg["Pages"],
			));
	    }
	}

    /**
     * Добавить категорию
     *
     * @param int $parent_id
     * @param string $title
     * @return boolean
     */
	function addCategory($parent_id, $title)
	{   global $db;

	    $parent_id = $parent_id > 0 ?(int) $parent_id : 0;
	    $title = My_Sql::escape($title);

		if ( '' === $title || ($parent_id > 0 && !$this->getCategory($parent_id)) ) {
		    return FALSE;
		}

		$query = "INSERT INTO ".$this->table_prefix."_sitelinks_categories";
		$query .= " (parent_id, title, create_date) VALUES";
		$query .= " (".$parent_id.", '".$title."', NOW())";

		return $db->query($query);
	}

	/**
	 * Изменить категорию
	 *
	 * @param int $id
	 * @param array $param
	 * @return boolean
	 */
	function setCategory($id, $param)
	{   global $db;

	    if (!$this->getCategory($id)) {
	    	return FALSE;
	    }
	    $set = isset($param['title']) && '' !== $param['title']
	        ? "title='".My_Sql::escape($param['title'])."'"
	        : '';
	    if ( isset($param['parent_id'])
	        && (0 === $param['parent_id'] || is_array($this->getCategory($param['parent_id'])) )
	    ) {
	    	$set .= ($set ? ", " : "")."parent_id=" . (int)$param['parent_id'];
	    }

		return $set
		    ? $db->query("UPDATE ".$this->table_prefix."_sitelinks_categories SET ".$set." WHERE id=".intval($id))
		    : FALSE;
	}

	/**
	 * Удалить категорию
	 *
	 * @param int $id
	 * @return boolean
	 */
	function delCategory($id)
	{   global $db;

	    $ctg = $this->getCategory($id);
	    if (!$ctg) {
	    	return FALSE;
	    }

	    $ctg_list = array_merge(array((int) $id), (array) $this->getSubCtgIdList($id));
	    $ctg_list = implode(", ", $ctg_list);

	    $db->query("DELETE FROM ".$this->table_prefix."_sitelinks WHERE category_id IN(".$ctg_list.")");
	    $db->query("DELETE FROM ".$this->table_prefix."_sitelinks_categories WHERE id IN(".$ctg_list.")");

	    return $ctg['parent_id'];
	}

	/**
	 * Получить список сайтов для утверждения
	 *
	 * @param int $page
	 * @return array
	 */
	function getNewSiteList($page)
	{   global $db, $CONFIG;

	    $p = $page > 1 ? (int) $page : 1;
		$link_on_page = $CONFIG['sitelinks_max_rows'] > 1 ? (int) $CONFIG['sitelinks_max_rows'] : 5;

	    $ret = array();
	    $query = "SELECT S.*, C.title AS ctg_title FROM";
	    $query .= " ".$this->table_prefix."_sitelinks AS S, ".$this->table_prefix."_sitelinks_categories AS C";
	    $query .= " WHERE S.category_id=C.id AND status=1 LIMIT ".($p - 1)*$link_on_page.", ".$link_on_page;
		$db->query($query);

	    while ($db->next_record()) {
	    	$ret[] = array(
	    	    'id' => $db->f('id'),
			    'ctg_id' => $db->f('category_id'),
			    'url' => $db->f('url'),
			    'title' => $db->f('title'),
			    'dscr' => $db->f('dscr'),
			    'email' => $db->f('email'),
			    'back_url' => $db->f('back_url'),
			    'note' => $db->f('note'),
			    'tcy' => $db->f('tcy'),
			    'date' => $db->f('create_date'),
			    'code_id' => $db->f('code_id'),
			    'status' => $db->f('status'),
			    'active' => $db->f('active'),
			    'check_url' => $db->f('check_url'),
			    'confirmed' => $db->f('confirmed'),
			    'ctg_title' => $db->f('ctg_title')
	    	);
	    }

	    return $ret;
	}

	/**
	 * Получить кол-во сайтов для утверждения
	 *
	 * @return int
	 */
	function getNewSiteCnt()
	{   global $db;

		$query = "SELECT COUNT(*) AS cnt FROM ".$this->table_prefix."_sitelinks WHERE status=1";
		$db->query($query);
		if ($db->next_record()) {
			return $db->f('cnt');
		}

		return 0;
	}

	function showNewSiteList($page = 1)
	{   global $tpl, $CONFIG, $baseurl;

	    $site_list = $this->getNewSiteList($page);
		if (count($site_list) > 0) {
		    $tpl->newBlock('block_new');
			$tpl->assign(Array(
				"MSG_Suspend" => $this->_msg["Suspend"],
				"MSG_Activate" => $this->_msg["Activate"],
			));
		    $site_cnt = $this->getNewSiteCnt();

		    $tpl->assign(
    	        array('form_action' => $baseurl)
    	    );

		    $this->showSiteListAdm($site_list);
		    Main::_show_nav_block(
                ceil(((int) $site_cnt)/$CONFIG['sitelinks_max_rows']),
                'nav',
                "&action=new",
                $page > 1 ? (int) $page : 1
            );
			$tpl->assign(Array(
				"MSG_Pages" => $this->_msg["Pages"],
			));
		} else {
		    $tpl->newBlock('block_empty');
			$tpl->assign(Array(
				"MSG_No_sites_for_confirmation" => $this->_msg["No_sites_for_confirmation"],
			));
		}
	}

	/**
	 * Удалить сайт
	 *
	 * @param int $id
	 * @return boolean
	 */
	function delSite($id)
	{   global $db;

	    $site = $this->getSite($id);
	    if (!$site) {
	    	return FALSE;
	    }

	    $ctg_list = array_merge(array((int) $id), (array) $this->getSubCtgIdList($id));
	    $ctg_list = implode(", ", $ctg_list);

	    return $db->query("DELETE FROM ".$this->table_prefix."_sitelinks WHERE id=".(int) $id);
	}

	/**
	 * Изменить свойства сайта
	 *
	 * @param int $id
	 * @param array $param
	 * @return boolean
	 */
	function setSite($id, $param)
	{   global $db, $CONFIG;

	    $site = $this->getSite($id);
	    if (!$site) {
	    	return FALSE;
	    }

	    $set = array();

	    if (isset($param['ctg_id'])) {
	        $ctg = $this->getCategory($param['ctg_id']);
	        if (!$ctg) {
	        	return FALSE;
	        }
	    	$set[] = "category_id=".(int) $param['ctg_id'];
	    }

	    if (isset($param['code_id'])) {
	        $code = $this->getLinkCode($param['code_id']);
	        if (!$code) {
	        	return FALSE;
	        }
	    	$set[] = "code_id=".(int) $param['code_id'];
	    }

	    if ( isset($param['url']) || isset($param['back_url']) ) {
	    	$new_url = isset($param['url']) ? $this->trimUrl($param['url']) : $site['url'];
	    	$new_back_url = isset($param['back_url']) ? $this->trimUrl($param['back_url']) : $site['back_url'];
	    	if (!$this->isValidSiteUrl($new_url, $new_back_url)) {
	    		return FALSE;
	    	}
	    	$set[] = "url='".My_sql::escape($new_url)."'";
	    	$set[] = "back_url='".My_sql::escape($new_back_url)."'";
	    }

	    if (isset($param['title'])) {
	    	if (!$this->isValidStr($param['title'], $CONFIG['sitelinks_min_title'], $CONFIG['sitelinks_max_title'])) {
	    		return FALSE;
	    	}
	    	$set[] = "title='".My_sql::escape($param['title'])."'";
	    }

	    if (isset($param['dscr'])) {
	    	if (!$this->isValidStr($param['dscr'], $CONFIG['sitelinks_min_dscr'], $CONFIG['sitelinks_max_dscr'])) {
	    		return FALSE;
	    	}
	    	$set[] = "dscr='".My_sql::escape($param['dscr'])."'";
	    }

	    if (isset($param['email'])) {
	    	if (!$param['email']) {
	    		return FALSE;
	    	}
	    	$set[] = "email='".My_sql::escape($param['email'])."'";
	    }

	    if (isset($param['note'])) {
	    	$set[] = "note='".My_sql::escape($param['note'])."'";
	    }

	    if (isset($param['tcy'])) {
	    	$set[] = "tcy=".((int) $param['tcy']);
	    }

	    if (isset($param['status'])) {
	    	$set[] = "status=".(array_key_exists($param['status'], $this->site_status) ? $param['status'] : $site['status']);
	    }

	    if (isset($param['active'])) {
	    	$set[] = "active=".($param['active'] ? 1 : 0);
	    }

	    if (isset($param['check_url'])) {
	    	$set[] = "check_url=".($param['check_url'] ? 1 : 0);
	    }

	    if (isset($param['confirmed'])) {
	    	$set[] = "confirmed=".($param['confirmed'] ? 1 : 0);
	    }

	    if (isset($param['check_date'])) {
	    	$set[] = "check_date=NOW()";
	    }

		return count($set) > 0
		    ? $db->query("UPDATE ".$this->table_prefix."_sitelinks SET ".implode(", ", $set)." WHERE id=".intval($id))
		    : FALSE;

	}

    /**
     * Отобразить категорию.
     * Отобразить список подкатегорий и сайтов.
     *
     * @param int $ctg_id
     * @param string $ctg_order
     * @param string $site_order
     * @param int $page
     */
	function showCategory($ctg_id, $ctg_order = '', $site_order = '', $page = 1)
	{   global $tpl, $CONFIG, $baseurl;

	    $ctg_id = $ctg_id > 0 ? (int) $ctg_id : 0;
	    $ctg_title = $this->_msg["Root"];
	    if ($ctg_id > 0) {
	    	$ctg = $this->getCategory($ctg_id);
	    	$ctg_title = $ctg['title'];
	    }
	    $tpl->assign(
	        array(
	            'form_action' => $baseurl,
	            'action' => "add_ctg",
	            'ctg_id' => $ctg_id,
	            'ctg_title' => $ctg_title,
	            'ctg_title_ecpape' => str_replace(array("\"", "'"), array("&quot;", "&#146;"), $ctg_title),
	            'add_site' => $baseurl."&action=new_site&ctg_id=".$ctg_id
	        )
	    );

	    $this->showPath($ctg_id);

	    $this->showCtgListAdm($ctg_id, $ctg_order);

	    $link = "&action=showctg&ctg_id=".$ctg_id."&ctg_order=".$ctg_order;
	    $site_list = $this->getSiteList($ctg_id, $page, $site_order);
	    $site_cnt = $this->getSiteCnt($ctg_id);
	    $this->showSiteListAdm($site_list);
	    Main::_show_nav_block(
            ceil(((int) $site_cnt)/$CONFIG['sitelinks_max_rows']),
            'nav',
            $link."&site_order=".$site_order,
            $page > 1 ? (int) $page : 1
        );
		$tpl->assign(Array(
			"MSG_Pages" => $this->_msg["Pages"],
		));
	}

	/**
	 * Показать список категорий
	 *
	 * @param int $parent_id
	 * @param string $order
	 */
	function showCtgListAdm($parent_id, $order)
	{   global $tpl, $baseurl;

	    $ctg_list = $this->getCtgList($parent_id, $order);
	    if (count($ctg_list) > 0) {
	    	$tpl->newBlock('block_categories');
			$tpl->assign(Array(
				"MSG_Ed" => $this->_msg["Ed"],
				"MSG_Category" => $this->_msg["Category"],
				"MSG_Links_num" => $this->_msg["Links_num"],
				"MSG_Date" => $this->_msg["Date"],
				"MSG_Actions" => $this->_msg["Actions"],
				"MSG_Del" => $this->_msg["Del"],
			));
	    	foreach ($ctg_list as $key => $ctg) {
	    		$tpl->newBlock('block_categorie');
				$tpl->assign(Array(
					"MSG_Edit" => $this->_msg["Edit"],
					"MSG_Add_category" => $this->_msg["Add_category"],
					"MSG_Add_site" => $this->_msg["Add_site"],
					"MSG_Delete" => $this->_msg["Delete"],
				));
	    		$tpl->assign(
	    		    array(
	    		        'id' => $ctg['id'],
	    		        'title' => $ctg['title'],
	    		        'title_ecpape' => str_replace(array("\"", "'"), array("&quot;", "&#146;"), $ctg['title']),
	    		        'date' => $ctg['date'],
	    		        'site_cnt' => $ctg['site_cnt'],
	    		        'del_ctr_link' => $baseurl."&action=del_ctg&ctg_id=".$ctg['id'],
	    		        'ctg_link' => $baseurl."&action=showctg&ctg_id=".$ctg['id'],
	    		        'add_site' => $baseurl."&action=new_site&ctg_id=".$ctg['id']
	    		    )
	    		);
	    	}
	    }

	}

	/**
	 * Показать список сайтов
	 *
	 * @param array  $site_list
	 */
	function showSiteListAdm($site_list)
	{   global $tpl, $baseurl, $CONFIG;

		if (is_array($site_list) && count($site_list)) {
			$tpl->newBlock('block_sites');
			$tpl->assign(Array(
				"MSG_Sites" => $this->_msg["Sites"],
				"MSG_Backlink" => $this->_msg["Backlink"],
				"MSG_checking" => $this->_msg["checking"],
				"MSG_Backlink_not_checking" => $this->_msg["Backlink_not_checking"],
				"MSG_Backlink_HTML_source" => $this->_msg["Backlink_HTML_source"],
				"MSG_Backlink_found" => $this->_msg["Backlink_found"],
				"MSG_found" => $this->_msg["found"],
				"MSG_Backlink_not_found" => $this->_msg["Backlink_not_found"],
				"MSG_not_found" => $this->_msg["not_found"],
				"MSG_Activ" => $this->_msg["Activ"],
				"MSG_Ed" => $this->_msg["Ed"],
				"MSG_Title" => $this->_msg["Title"],
				"MSG_URL" => $this->_msg["URL"],
				"MSG_Email" => $this->_msg["Email"],
				"MSG_Date" => $this->_msg["Date"],
				"MSG_tIQ" => $this->_msg["tIQ"],
				"MSG_Status" => $this->_msg["Status"],
				"MSG_Wrk" => $this->_msg["Wrk"],
				"MSG_Del" => $this->_msg["Del"],
			));
	    	foreach ($site_list as $key => $site) {

	    	    $active_text = ($site['active'] ? $this->_msg["Suspend"] : $this->_msg["Activate"])."";
	            $active_img = "ico_sw".($site['active'] ? "of" : "on").".gif";
	            $check_url_text = ($site['check_url'] ? $this->_msg["Suspend_feedback_check"] : $this->_msg["Activate_feedback_check"])."";
	            $check_url_img = "b_select".($site['check_url'] ? "" : "_off").".gif";
	            $confirm_text = $this->_msg["Mark_as"] . " - ".($site['confirmed'] ? $this->_msg["feedback_not_found"] : $this->_msg["feedback_found"]) . "";
	            $confirm_img = "ico_".($site['confirmed'] ? "" : "broke")."link.gif";

	    		$tpl->newBlock('block_site');
				$tpl->assign(Array(
					"MSG_Edit" => $this->_msg["Edit"],
					"MSG_New" => $this->_msg["New"],
					"MSG_Activated" => $this->_msg["Activated"],
					"MSG_Confirmed" => $this->_msg["Confirmed"],
					"MSG_Canceled" => $this->_msg["Canceled"],
					"MSG_Confirm_delete_site" => $this->_msg["Confirm_delete_site"],
					"MSG_Delete" => $this->_msg["Delete"],
					"MSG_Confirm_confirm_site" => $this->_msg["Confirm_confirm_site"],
					"MSG_сonfirm" => $this->_msg["confirm"],
					"MSG_Confirm_reject_site" => $this->_msg["Confirm_reject_site"],
					"MSG_reject" => $this->_msg["reject"],
				));
	    		$tpl->assign(
	    		    array(
	    		        'id' => $site['id'],
	    		        'title' => $site['title'],
	    		        'title_ecpape' => str_replace(array("\"", "'"), array("&quot;", "&#146;"), $site['title']),
	    		        'date' => $site['date'],
	    		        'url' => $site['url'],
	    		        'email' => $site['email'],
	    		        'tcy' => $site['tcy'],
	    		        'status' => $this->site_status[$site['status']],
	    		        'status_id' => $site['status'],
        	            'active' => $site['active'] ? 1 : 0,
        	            'check_url' => $site['check_url'] ? 1 : 0,
        	            'confirm' => $site['confirmed'] ? 1 : 0,
        	            'selected_status_0' => 0 == $site['status'] ? 'selected' : '',
        	            'selected_status_1' => 1 == $site['status'] ? 'selected' : '',
        	            'selected_status_2' => 2 == $site['status'] ? 'selected' : '',
        	            'selected_status_3' => 3 == $site['status'] ? 'selected' : '',
	    		        'active_img' => $active_img,
        	            'active_text' => $active_text,
        	            'check_url_img' => $check_url_img,
        	            'check_url_text' => $check_url_text,
        	            'confirm_img' => $confirm_img,
        	            'confirm_text' => $confirm_text,
	    		        'edit_link' => $baseurl."&action=edit_site&ctg_id=".$site['ctg_id']."&site_id=".$site['id'],
	    		        'del_link' => $baseurl."&action=del_site&ctg_id=".$site['ctg_id']."&site_id=".$site['id'],
	    		        'baseurl' => $baseurl
	    		    )
	    		);
	    	}
		}
	}

	/**
	 * Отобразить путь по дереву разделов
	 *
	 * @param int $ctg_id
	 */
	function showPath($ctg_id)
	{   global $tpl, $baseurl;

		$path = $this->getGtgParentList($ctg_id);
	    if ($ctg_id > 0) {
	    	$tpl->newBlock('block_path');
   	    	$tpl->assign(
   	        array(
   	            'title' => $this->_msg["Root"],
   	            'link' => $baseurl."&action=showctg"
       	        )
       	    );
	    }
	    if (is_array($path)) {
    	    foreach ($path as $key => $val) {
    	    	$tpl->newBlock('block_path');
    	    	$tpl->assign(
    	        array(
    	            'title' => $val['title'],
    	            'link' => $baseurl."&action=showctg&ctg_id=".$val['id']
        	        )
        	    );
    	    }
	    }
	    $tpl->gotoBlock('_ROOT');
	}

	/**
	 * Отобразить форму добавления/изменения ссылки
	 *
	 * @param int $ctg_id
	 * @param int $link_id
	 * @return mixed
	 */
	function showSiteFormAdm($ctg_id, $site_id)
	{   global $tpl, $baseurl, $CONFIG;

	    $ctg = $this->getCategory($ctg_id);
	    if (FALSE == $ctg) {
	    	header("Location: ".$baseurl."&action=showctg");
	    	exit;
	    }

	    $this->showPath($ctg_id);
	    $site = $this->getSite($site_id);
	    $form_action = $baseurl."&action=" . (is_array($site) ? "update_site" : "add_site");

	    $title_limit = '';
	    if ($CONFIG['sitelinks_max_title'] > 0 && $CONFIG['sitelinks_min_title'] > 0) {
	    	$title_limit = "(" . $this->_msg["not_less_than"] . " ".$CONFIG['sitelinks_min_title'].", " . $this->_msg["not_more_than"] . " ".$CONFIG['sitelinks_max_title']." " . $this->_msg["symbols"] . ")";
	    } elseif ($CONFIG['sitelinks_min_title'] > 0) {
	    	$title_limit = "(" . $this->_msg["not_less_than"] . " ".$CONFIG['sitelinks_min_title']." " . $this->_msg["symbols"] . ")";
	    } elseif ($CONFIG['sitelinks_max_title'] > 0) {
	    	$title_limit = "(" . $this->_msg["not_more_than"] . " ".$CONFIG['sitelinks_max_title']." " . $this->_msg["symbols"] . ")";
	    }

	    $dscr_limit = '';
	    if ($CONFIG['sitelinks_max_dscr'] > 0 && $CONFIG['sitelinks_min_dscr'] > 0) {
	    	$dscr_limit = "(" . $this->_msg["not_less_than"] . " ".$CONFIG['sitelinks_min_dscr'].", " . $this->_msg["not_more_than"] . " ".$CONFIG['sitelinks_max_dscr']." " . $this->_msg["symbols"] . ")";
	    } elseif ($CONFIG['sitelinks_min_dscr'] > 0) {
	    	$dscr_limit = "(" . $this->_msg["not_less_than"] . " ".$CONFIG['sitelinks_min_dscr']." " . $this->_msg["symbols"] . ")";
	    } elseif ($CONFIG['sitelinks_max_dscr'] > 0) {
	    	$dscr_limit = "(" . $this->_msg["not_more_than"] . " ".$CONFIG['sitelinks_max_dscr']." " . $this->_msg["symbols"] .")";
	    }

	    $check_url_on = "checked";
	    $check_url_off = "";

	    if (is_array($site) && !$site['check_url']) {
	    	$check_url_on = "";
	    	$check_url_off = "checked";
	    }
	    $code = $this->getLinkCode(isset($_SESSION['sitelinks_code']) ? $_SESSION['sitelinks_code'] : 0);
	    $_SESSION['sitelinks_code'] = $code['id'];
	    $tpl->assign(
   	        array(
   	            'baseurl' => $baseurl,
   	            'form_action' => $form_action,
   	            'min_title' => $CONFIG['sitelinks_min_title'],
   	            'max_title' => $CONFIG['sitelinks_max_title'],
   	            'title_limit' => $title_limit,
   	            'min_dscr' => $CONFIG['sitelinks_min_dscr'],
   	            'max_dscr' => $CONFIG['sitelinks_max_dscr'],
   	            'dscr_limit' => $dscr_limit,
   	            'ctg_id' => $ctg['id'],
   	            'ctg_title' => $ctg['title'],
   	            'check_url_on' => $check_url_on,
   	            'check_url_off' => $check_url_off,
   	            'code_id' => $code['id'],
   	            'code' => $code['code'],
       	    )
       	);

       	if (is_array($site)) {
       		$tpl->assign($site);
       	}

       	Main::show_list($this->site_status, 'block_status', isset( $site['status']) ? $site['status'] : 0);
	}

	/**
	 * Получить список всех Email
	 *
	 * @return mixed
	 */
	function getEmails()
	{   global $db, $CONFIG;

	    $db->query("SELECT email FROM ".$this->table_prefix."_sitelinks");
	    $ret = FALSE;
	    while ($db->next_record()) {
	    	$ret[] = $db->f('email');
	    }

	    return $ret;
	}

	/**
	 * Получить список сайтов у которых нужно проверить коды обратных ссылок
	 *
	 * @return mixed false - не найдено сайтов для проверки
	 *               array - многомерный массив если найдены
	 */
	function getCheckedSites()
	{   global $db, $CONFIG;

	    $limit = $CONFIG['sitelinks_check_cnt'] >= 1 ? " LIMIT ".((int) $CONFIG['sitelinks_check_cnt']) : "";
	    $where = $CONFIG['sitelinks_check_period'] < 1
	        ? "check_date < NOW()"
	        : "check_date < NOW() - INTERVAL ".((int)$CONFIG['sitelinks_check_period'])." DAY";
	    $query = "SELECT S.id, back_url, code_id, code, confirmed, tcy";
	    $query .= " FROM ".$this->table_prefix."_sitelinks AS S,";
	    $query .= " ".$this->table_prefix."_sitelinks_codes AS C WHERE S.active AND check_url";
	    $query .= " AND status = 2 AND code_id=C.id AND ".$where.$limit;
	    //echo $query."<hr>";
	    $db->query($query);
	    $ret = FALSE;
	    while ($db->next_record()) {
	        $code_id = $db->f('code_id');
	    	$ret['sites'][$db->f('id')] = array(
	    	    'url' => $db->f('back_url'),
	    	    'code_id' => $code_id,
	    	    'confirmed' => $db->f('confirmed'),
	    	    'tcy' => $db->f('tcy')
	    	);
	    	if (!isset($ret['codes'][$code_id])) {
	    	    $ret['codes'][$code_id] = $db->f('code');
	    	}
	    }

	    return $ret;

	}

	/**
	 * Разослать письма
	 *
	 * @param string $sbj
	 * @param string $body
	 * @param string $site_status
	 * @return int
	 */
	function distribution($sbj, $body, $site_status)
	{   global $db, $CONFIG;

	    require_once(RP.'/inc/class.Mailer.php');
   		$mail = new Mailer();
        $mail->CharSet		= $CONFIG['email_charset'];
        $mail->ContentType	= 'text/html';
		$mail->From			= $CONFIG['sitelinks_recipient'];
		$mail->FromName		= $CONFIG['sitename_rus'];
		$mail->Mailer		= 'mail';
        $mail->Subject		= $sbj;
		$mail->Body			= $body;

	    $where = array_key_exists($site_status, $this->site_status) ? " WHERE status=".(int)$site_status : "";
	    $query = "SELECT email FROM ".$this->table_prefix."_sitelinks".$where;
	    $db->query($query);
	    $ret = 0;
	    while ($db->next_record()) {
	        $ret++;
	        $mail->to[0][0] = $db->f('email');
	        $mail->Send();
	    }

	    return $ret;
	}
}

?>