<?php
class SupportPrototype extends Module {

    var $main_title;
    var $table_prefix;
    var $addition_to_path;
    var $module_name				= 'support';
    var $tpl_path					= 'mod/support/tpl/';
    var $block_module_actions		= array();
    var $block_main_module_actions	= array();
    var $default_action				= "tickets";
    var $admin_default_action		= 'tickets';
    var $_msg	                  	= array();
    var $status_list	            = array(
        1 => 'новый вопрос',
        2 => 'обработан',
        3 => 'повторный вопрос',
        4 => 'в работе',
        5 => 'закрыт клиентом',
        6 => 'закрыт автоматически');
    var $disallowed_types = array();
    var $finish_date = false;

    function SupportPrototype($action = '', $transurl = '', $properties = array(), $prefix = NULL, $rewrite_mod_params = NULL, $adminurl = NULL, $noadmin = false)
    {
        global $main, $tpl, $tpl_path, $baseurl, $cache, $lc, $CONFIG, $PAGE, $server, $lang, $permissions, $_RESULT;
        static $updated = false;

        /* Get $action, $tpl_name, $permissions */
        extract( $this->init(array(
                'server' => $server, 'lang' => $lang, 'prefix' => $prefix,
                'action' => $action, 'tpl_name' => $properties['tpl']
        )), EXTR_OVERWRITE);
        
        $this->block_module_actions = array(
                'tickets' => $this->_msg['Tickets'],
                'ask' => $this->_msg['Ask_question']
        );
        $this->block_main_module_actions = array(
                'tickets' => $this->_msg['Tickets'],
                'ask' => $this->_msg['Ask_question']
        );
        
        if (!$updated) {
        	$updated = true;
        	$this->updateTickets();
        }

        if ('none' == $action) {
            return;
        }
        if ('only_create_object' == $action) {
            return;
        }
        
        if ($this->actionExists($action)) {
            $this->doAction($action);
            return;
        }
        if (! self::is_admin()) {

            $level_id = $this->getUserLevel($_SESSION["siteuser"]["id"]);
            $this->finish_date = $this->getFinishDate();
            //---------------------------------- обработка действий с сайта --------------------------------//
            $_baseurl = $baseurl.(false === strpos($baseurl, '?') ? "?" : "&");
            $_transurl = $transurl.(false === strpos($transurl, '?') ? "?" : "&");
            if ((!$this->finish_date || !$level_id) && 'deny' != $action) {
                0 == $PAGE['field']
                ? header("Location: ".$_baseurl."action=deny")
                : header("Location: ".Core::formPageLink($CONFIG["support_page_link"], $CONFIG["support_page_address"], $lang, 1)."action=deny");
            }
            switch ($action) {
                /**/
                case "tickets":
                    global $request_start;
                    $main->include_main_blocks($this->module_name."_".$action.".html", "main");
                    $tpl->prepare();
                    $this->ShowTicketList(
                        $this->getTicketList(array(
                            'user' => $_SESSION["siteuser"]["id"],
                            'count' => $CONFIG['support_site_max_rows'],
                            'start' => $request_start
                        )),
                        $this->getTicketCount(array('user' => $_SESSION["siteuser"]["id"])),
                        $request_start,
                        $CONFIG['support_site_max_rows']
                    );
                    break;
                    /**/
                case "ticket":
                    global $request_id;
                    $main->include_main_blocks($this->module_name."_".$action.".html", "main");
                    $tpl->prepare();
                    $ticket = $this->showTicket($tpl, $request_id, $_SESSION["siteuser"]["id"]);
                    break;
                    /**/
                case "ask":
                    $main->include_main_blocks($this->module_name."_".$action.".html", "main");
                    $tpl->prepare();
                    $lvl = $this->getLevel($level_id);
                    $tpl->assign(array(
                        'form_action' => $_transurl."action=addticket",
                        'transurl' => $_transurl,
                        'baseurl' => $_baseurl,
                        'level_id' => $level_id,
                        'level_title' => $lvl['title'],
                        'finish_date' => $this->finish_date,
                    ));
                    Module::show_select('block_category_row', 0, 'title', $this->getCategoryList());
                    break;
                    /**/
                case "addticket":
                    global $request_data;
                    if ($this->addTicket($request_data)) {
                        header('Location: '.$_baseurl."action=tickets");
                    } else {
                        header('Location: '.$_baseurl."action=ask");
                    }
                    break;
                    /**/
                case "addquestion":
                    global $request_data;
                    if ($this->addQuestion($request_data) || !$request_data['ticket_id']) {
                        header('Location: '.$_baseurl."action=tickets");
                    } else {
                        header('Location: '.$_baseurl."action=ticket&id=".$request_data['ticket_id']);
                    }
                    break;
                    /**/
                case "setestimate":
                    global $request_ticket_id, $request_estimate;
                    $ticket = $this->getTicket($request_ticket_id);
                    if ($ticket) {
                        $this->setTicketEstimate($request_ticket_id, $request_estimate);
                        header('Location: '.$_baseurl."action=ticket&id=".$ticket['id']);
                    } else {
                        header('Location: '.$_baseurl."action=tickets");
                    }
                    break;
                    /**/
                case "closeticket":
                    global $request_ticket_id;
                    $this->setTicketStatus($request_ticket_id, 5);
                    header('Location: '.$_baseurl."action=tickets");
                    break;
                    /**/
                case "getfile":
                    global $request_file;
                    if (!$this->getFile($request_file)) {
                    	$main->include_main_blocks($this->module_name."_".$action.".html", "main");
                    	$tpl->prepare();
                    }
                    break;
                    /**/
                case "deny":
                    $main->include_main_blocks($this->module_name."_".$action.".html", "main");
                    $tpl->prepare();
                    break;
                    /**/
                case "edit":
                    global $request_ticket_id, $request_question_id, $request_is_ticket, $request_txt;
                    $main->include_main_blocks($this->module_name."_".$action.".html", "main");
                    $tpl->prepare();
                    
                    if ($request_question_id) {
                        $item = $this->getQuestion($request_question_id);
                        $ticket_id = (int)$item['ticket_id'];
                        $question_id = (int)$item['id'];
                    } else {
                        $item = $this->getTicket($request_ticket_id);
                        $ticket_id = (int)$item['id'];
                        $question_id = 0;
                    }
                    if ($item && $item['editable']) {
                        if ($request_txt) {
                            if ($question_id) {
                                $this->setQuestionTxt($question_id, $request_txt);
                            } else {
                                $this->setTicketTxt($ticket_id, $request_txt);
                            }
                            Module::go_back($baseurl.'action=ticket&id='.$ticket_id);
                        }
                        
                        $tpl->newBlock('block_edit');
                        $tpl->assign(array(
                            'ticket_id' => $ticket_id,
                            'question_id' => $question_id,
                            'baseurl' => $baseurl,
                            'is_ticket' => $request_is_ticket ? 1 : 0,
                            'txt' => $item['txt']
                        ));
                    }
                    break;
                default:
                    if (is_object($tpl)) $tpl->prepare();
                    return;
            }
            //------------------------------- конец обработки действий с сайта -----------------------------//
        } else {
            //------------------------------ обработка действий из админ части -----------------------------//            
            if (!isset($tpl)) {
                $main->message_die('Не подключен класс для работы с шаблонами');
            }
            switch ($action) {
                case 'prp':
                    if (!$permissions['e']) {
                        $main->message_access_denied($this->module_name, $action);
                    }
                    global $request_step;
                    $main->include_main_blocks('_properties.html', $this->tpl_path);
                    $tpl->prepare();
                    $tpl->assign(Array(
                        "MSG_Information"	=> $main->_msg["Information"],
                        "MSG_Value"			=> $main->_msg["Value"],
                        "MSG_Save"			=> $main->_msg["Save"],
                        "MSG_Cancel"		=> $main->_msg["Cancel"],
                    ));
                    if (!$request_step || $request_step == 1) {
                        $tpl->assign(array(
                            'form_action' => $baseurl,
                            'step'			=> 2,
                            'lang'			=> $lang,
                            'name'			=> $this->module_name,
                            'action'			=> 'prp'
                        ));
                        $prp_html = $main->getModuleProperties($this->module_name);
                        $this->main_title = $this->_msg["Controls"];
                    } elseif (2 == $request_step) {
                        $main->setModuleProperties($this->module_name, $_POST);
                        header('Location: '.$baseurl.'&action=prp&step=1');
                    }
                    break;

                case 'block_prp':
                    global $request_sub_action, $request_block_id;
                    $arr   = $this->getEditLink($request_sub_action, $request_block_id);
                    $cont = 'var container = document.getElementById(\'target_span\');
		    		  	 container.innerHTML = "'.$this->getPropertyFields().'";
		    		  	 material_id		  = "'.$arr['material_id'].'";
		    		  	 material_url		  = "'.$arr['material_url'].'";
		    		  	 changeAction();
		    	      	 setURL("property1");';
                    header('Content-Length: '.strlen($cont));
                    echo $cont;
                    exit;
                    break;

                case 'properties':
                    if (!$permissions['e']) $main->message_access_denied($siteusres->module_name, $action);
                    global $module_id, $request_field, $title;
                    $main->include_main_blocks('_block_properties.html', 'main');
                    $tpl->prepare();

                    if ($main->show_actions($request_field, '', $this->block_main_module_actions, $this->block_module_actions)) {
                        $main->show_linked_pages($module_id, $request_field);
                    }

                    $tpl->assign(array(	'_ROOT.title'		=> $title,
                        '_ROOT.username'	=> $_SESSION['session_login'],
                        '_ROOT.password'	=> $_SESSION['session_password'],
                        '_ROOT.name'		=> $this->module_name,
                        '_ROOT.lang'		=> $lang,
                    ));
                    $this->main_title	= $this->_msg["Block_properties"];
                    break;

                    /* Заявки */
                case 'tickets':
                    if (!$permissions["r"]) {
                        $main->message_access_denied($this->module_name, $action);
                    }
                    global $request_start, $request_f;
                    $main->include_main_blocks_2($this->module_name."_".$action.".html", $this->tpl_path);
                    $tpl->prepare();

                    $filter = array(
                        'count' => $CONFIG['support_max_rows'],
                        'start' => $request_start
                    );
                    if (isset($request_f)) {
                         $request_f = (array)$request_f;
                         $filter = array_merge($filter, $request_f);
                         $f = array();
                         foreach ($request_f as $key => $val) {
                             if ($val) {
                                 $f[] = $key{0}."=".$val;
                             }
                         }
                         if (!empty($f)) {
                             setcookie('f', implode("|", $f), time() + 3600*24*30, '/admin.php');
                         } else {
                             setcookie('f', '', time() - 3600*24, '/admin.php');
                         }
                    } else if (isset($_COOKIE['f'])) {
                        $f = explode("|", $_COOKIE['f']);
                        foreach ($f as $val) {
                        	list($k, $v) = explode("=", $val);
                        	if ($v) {
                        		switch ($k) {
                        			case 'p':
                        				$request_f['pct'] = $v;
                        				break;
                        			case 'l':
                        				$request_f['level'] = $v;
                        				break;
                        			case 'c':
                        				$request_f['category'] = $v;
                        				break;
                        			case 's':
                        				$request_f['status'] = $v;
                        				break;
                        			case 'm':
                        				$request_f['manager'] = $v;
                        				break;
                        			case 'u':
                        				$request_f['user'] = $v;
                        				break;
                        			case 'f':
                        				$request_f['f'] = $v;
                        				break;
                        			case 't':
                        				$request_f['t'] = $v;
                        				break;
                        			case 'e':
                        				$request_f['estimate'] = $v;
                        				break;
                        		}
                        	}
                        }
                        $filter = array_merge($filter, $request_f);
                    }
                    $tpl->assign(Array(
                        "MSG_Tickets" => $this->_msg["Tickets"],
                        "MSG_Title" => $this->_msg["Title"],
                        "MSG_Category" => $this->_msg["Category"],
                        "MSG_Status" => $this->_msg["Status"],
                        "MSG_Created" => $this->_msg["Created"],
                        "MSG_Modifited" => $this->_msg["Modifited"],
                        "MSG_User" => $this->_msg["User"],
                        "MSG_Manager" => $this->_msg["Manager"],
                        "MSG_Level" => $this->_msg["Level"],
                        "MSG_Simophor" => $this->_msg["Simophor"],
                        "MSG_Status" => $this->_msg["Status"],
                        "MSG_Estimate" => $this->_msg["Estimate"],
                        "MSG_Del" => $this->_msg["Del"],
                        "MSG_Select" => $this->_msg["Select"],
                        "MSG_Cancel" => $this->_msg["Cancel"],
                        "MSG_Delete" => $this->_msg["Delete"],
                        "MSG_Period" => $this->_msg["Period"],
                        "MSG_From" => $this->_msg["From"],
                        "MSG_To" => $this->_msg["To"],

                         "baseurl" => $baseurl,
                         "lang" => $lang,
                         "start" => $request_start,
                         "t" => $request_f['t'],
                         "f" => $request_f['f'],
                    ));
                    $simophor_list = array(
                        1 => array('title' => $this->_msg['<50'], 'color' => '#0F0'),
                        2 => array('title' => $this->_msg['>50'], 'color' => '#FF0'),
                        3 => array('title' => $this->_msg['Behind'], 'color' => '#F00'),
                    );
                    Module::show_select('block_category_row', $request_f['category'], 'title', $this->getCategoryList());
                    Module::show_select('block_simophor_row', $request_f['pct'], 'color', $simophor_list);
                    Module::show_select('block_level_row', $request_f['level'], 'title', $this->getLevelList());
                    Module::show_select('block_status_row', $request_f['status'], 'title', $this->getStatusList());
                    Module::show_select('block_manager_row', $request_f['manager'], 'username', $this->getManagerList());
                    Module::show_select('block_user_row', $request_f['user'], 'username', $this->getUserList());
                    Module::show_select('block_estimate_row', $request_f['estimate'], 'title', $this->getEstimateList());
                    if ($this->ShowTicketList(
                        $this->getTicketList($filter),
                        $this->getTicketCount($filter),
                        $request_start,
                        $CONFIG['support_max_rows'],
                        $filter)
                    ) {
                        $tpl->gotoBlock('block_tickets_list');
                        $tpl->assign(Array(
                            "MSG_Tickets" => $this->_msg["Tickets"],
                            "MSG_Title" => $this->_msg["Title"],
                            "MSG_Category" => $this->_msg["Category"],
                            "MSG_Status" => $this->_msg["Status"],
                            "MSG_Created" => $this->_msg["Created"],
                            "MSG_Modifited" => $this->_msg["Modifited"],
                            "MSG_User" => $this->_msg["User"],
                            "MSG_Manager" => $this->_msg["Manager"],
                            "MSG_Level" => $this->_msg["Level"],
                            "MSG_Simophor" => $this->_msg["Simophor"],
                            "MSG_Status" => $this->_msg["Status"],
                            "MSG_Estimate" => $this->_msg["Estimate"],
                            "MSG_Del" => $this->_msg["Del"],
                            "MSG_Select" => $this->_msg["Select"],
                            "MSG_Cancel" => $this->_msg["Cancel"],
                            "MSG_Delete" => $this->_msg["Delete"],

                            "baseurl" => $baseurl,
                        ));
                    }

                    $this->main_title = $this->_msg["Tickets"];
                    break;

                    /**/
                case "ticket":
                    global $request_id, $db;
                    $main->include_main_blocks_2($this->module_name."_".$action.".html", $this->tpl_path);
                    $tpl->prepare();
                    $ticket = $this->showTicket($tpl, $request_id);
                    if ($ticket) {
                        $db->set("{$this->table_prefix}_support_ticket", array('editable' => 0), array('id' => $ticket['id']));
                        $db->set("{$this->table_prefix}_support_question", array('editable' => 0), array('ticket_id' => $ticket['id']));                        
                    }
                    $this->main_title = $this->_msg["Ticket"]." № ".intval($request_id);
                    break;

                    /* Справочники */
                case 'hdbks':
                    if (!$permissions["r"]) {
                        $main->message_access_denied($this->module_name, $action);
                    }
                    
                    global $request_ctgr_id, $request_lvl_id, $request_estm_id;
                    $isset_id = $request_ctgr_id || $request_lvl_id || $request_estm_id;

                    require_once(RP."inc/lib/json_extension_api.inc");

                    $main->include_main_blocks_2($this->module_name."_".$action.".html", $this->tpl_path);
                    $tpl->prepare();
                    $tpl->assign(Array(
                        "MSG_Ed" => $this->_msg["Ed"],
                        "MSG_Edit" => $this->_msg["Edit"],
                        "MSG_Del" => $this->_msg["Del"],
                        "MSG_Delete" => $this->_msg["Delete"],
                        "MSG_Add" => $this->_msg["Add"],
                        "MSG_Save" => $this->_msg["Save"],
                        "MSG_Select" => $this->_msg["Select"],
                        "MSG_Cancel" => $this->_msg["Cancel"],

                        "MSG_Categories" => $this->_msg["Categories"],
                        "MSG_Category" => $this->_msg["Category"],
                        "MSG_Levels" => $this->_msg["Levels"],
                        "MSG_Level" => $this->_msg["Level"],
                        "MSG_Estimaties" => $this->_msg["Estimaties"],
                        "MSG_Estimate" => $this->_msg["Estimate"],
                        "MSG_Title" => $this->_msg["Title"],
                        "MSG_Name" => $this->_msg["Name"],
                        "MSG_Number" => $this->_msg["Number"],
                        "MSG_Answer_time" => $this->_msg["Answer_time"],
                        "MSG_Close_time" => $this->_msg["Close_time"],
                        "MSG_User_group" => $this->_msg["User_group"],
                        "MSG_Work_time" => $this->_msg["Work_time"],
                        "MSG_24hour" => $this->_msg["24hour"],
                        "MSG_Free_day" => $this->_msg["Free_day"],
                        "MSG_Work_hour" => $this->_msg["Work_hour"],
                        "MSG_Off_time" => $this->_msg["Off_time"],
                        "MSG_Monday" => $this->_msg["Monday"],
                        "MSG_Tuesday" => $this->_msg["Tuesday"],
                        "MSG_Wednesday" => $this->_msg["Wednesday"],
                        "MSG_Thursday" => $this->_msg["Thursday"],
                        "MSG_Friday" => $this->_msg["Friday"],
                        "MSG_Saturday" => $this->_msg["Saturday"],
                        "MSG_Sunday" => $this->_msg["Sunday"],

                        "css_ctgr_form_dispay" => $request_ctgr_id ? 'block' : 'none',
                        "css_ctgr_list_dispay" => $isset_id ? 'none' : 'block',
                        "css_estm_form_dispay" => $request_estm_id ? 'block' : 'none',
                        "css_estm_list_dispay" => $isset_id ? 'none' : 'block',
                        "css_lvl_form_dispay" => $request_lvl_id ? 'block' : 'none',
                        "css_lvl_list_dispay" => $isset_id ? 'none' : 'block',

                        "baseurl" => $baseurl,
                        "tickets_groups_list" => json_encode($this->getTicketGroupsIds())
                    ));
                    if ($request_ctgr_id) {
                        $this->showHdbkItem($this->getCategory($request_ctgr_id), 'ctgr_');
                    }
                    if ($request_estm_id) {
                        $this->showHdbkItem($this->getEstimate($request_estm_id), 'estm_');
                    }
                    if ($request_lvl_id) {
                        $lvl = $this->getLevel($request_lvl_id);
                        if ($lvl) {                            
                            $this->showHdbkItem($lvl, 'lvl_');
                            if ($sched = $this->getLevelSchedule($request_lvl_id)) {
                                foreach ($sched as $val) {
                                	$o_f = explode(":", $val['open_from']);
                                    $o_t = explode(":", $val['open_to']);
                                    $b_f = explode(":", $val['break_from']);
                                    $b_t = explode(":", $val['break_to']);
                                	$tpl->assign(array(
                                	    "open_{$val['day']}_24_checked" => 24 == $val['type'] ? 'checked' : '',
                                	    "open_{$val['day']}_1_checked" => 1 == $val['type'] ? 'checked' : '',
                                	    "open_{$val['day']}_0_checked" => 0 == $val['type'] ? 'checked' : '',
                                	    "open_{$val['day']}_from_h" => $o_f[0],
                                	    "open_{$val['day']}_from_m" => $o_f[1],
                                	    "open_{$val['day']}_to_h" => $o_t[0],
                                	    "open_{$val['day']}_to_m" => $o_t[1],
                                	    "break_{$val['day']}_from_h" => $b_f[0],
                                	    "break_{$val['day']}_from_m" => $b_f[1],
                                	    "break_{$val['day']}_to_h" => $b_t[0],
                                	    "break_{$val['day']}_to_m" => $b_t[1],
                                	));
                                }
                            }
                        }                        
                    }
                    require_once(RP."mod/siteusers/lib/class.SiteusersPrototype.php");
                    $u = new SiteusersPrototype('only_create_object');
                    $u->show_groups('block_user_group', isset($lvl['group_id']) ? array($lvl['group_id']) : array());
                    $this->showHdbkList($this->getCategoryList(1), 'block_categories');
                    $this->showHdbkList($this->getLevelList(1), 'block_levels');
                    $this->showHdbkList($this->getEstimateList(1), 'block_estimaties');
                    $this->main_title = $this->_msg["Hdbks"];
                    break;
                    /**/
                case "statistics":
                    global $request_f, $request_t, $request_m, $request_u;
                    $main->include_main_blocks_2($this->module_name."_".$action.".html", $this->tpl_path);
                    $tpl->prepare();
                    $this->showStatistic($request_f, $request_t, $request_m, $request_u);
                    Module::show_select('block_manager_row', $request_m, 'username', $this->getManagerList());
                    Module::show_select('block_user_row', $request_u, 'username', $this->getUserList());
                    $this->main_title = $this->_msg["Statistics"];
                    break;

                case 'users':
                    if (!$permissions["r"]) {
                        $main->message_access_denied($this->module_name, $action);
                    }
                    global $request_start, $request_q;
                    $main->include_main_blocks_2($this->module_name."_".$action.".html", $this->tpl_path);
                    $tpl->prepare();
                    $tpl->assign(Array(
                        "MSG_Find" => $this->_msg["Find"],
                        "MSG_Search" => $this->_msg["Search"],
                        "baseurl" => $baseurl,
                        "q" => $request_q,
                        "lang" => $lang,
                        "start" => $request_start
                    ));
                    $filter = array(
                        'q' => $request_q,
                        'on_page' => $CONFIG['support_max_users'],
                        'start' => $request_start,
                    );
                    $this->showHdbkList($this->getModulesUserList($filter), 'block_users');

                    $count = $this->getModulesUserCount($filter);
                    if ($count > $CONFIG['support_max_users']) {
                    	$url = $baseurl."&action=".$action;
                    	$pages = ceil($count/$CONFIG['support_max_users']);
                        if (!empty($filter)) {
                            foreach ($filter as $key => $val) {
                                if ('on_page' != $key && 'start' != $key && $val) {
                                    $url .= "&{$key}=".$val;
                                }
                            }
                        }
                        $start_page = $request_start > 1 && $request_start <= $pages ? (int)$request_start : 1;
                        Main::_show_nav_block($pages, 'nav', $url, $start_page);
                        $tpl->gotoBlock('nav');
                        $tpl->assign("MSG_Pages", $this->_msg["Pages"]);
                    }
                    $this->main_title = $this->_msg["Users"];
                    break;
                    /*  */
                case 'setdate':
                    if (!$permissions["e"]) {
                        $main->message_access_denied($this->module_name, $action);
                    }
                    global $request_date;
                    $this->setFinishDate($request_date);
                    Module::go_back();
                    header("Location: ".$baseurl."&action=users");
                    exit;
                    break;
                    /*  */
                case 'setcategory':
                    if (!$permissions["e"]) {
                        $main->message_access_denied($this->module_name, $action);
                    }
                    global $request_data;
                    $this->setCategory($request_data);
                    header("Location: ".$baseurl."&action=hdbks");
                    exit;
                    break;

                    /*  */
                case 'setlevel':
                    if (!$permissions["e"]) {
                        $main->message_access_denied($this->module_name, $action);
                    }
                    global $request_data;
                    $this->setLevel($request_data);
                    header("Location: ".$baseurl."&action=hdbks");
                    exit;
                    break;

                    /*  */
                case 'setestimate':
                    if (!$permissions["e"]) {
                        $main->message_access_denied($this->module_name, $action);
                    }
                    global $request_data;
                    $this->setEstimate($request_data);
                    header("Location: ".$baseurl."&action=hdbks");
                    exit;
                    break;

                    /*  */
                case 'delcategory':
                    if (!$permissions["e"]) {
                        $main->message_access_denied($this->module_name, $action);
                    }
                    global $request_id;
                    $this->delCategory($request_id);
                    header("Location: ".$baseurl."&action=hdbks");
                    exit;
                    break;

                    /*  */
                case 'dellevel':
                    if (!$permissions["e"]) {
                        $main->message_access_denied($this->module_name, $action);
                    }
                    global $request_id;
                    $this->delLevel($request_id);
                    header("Location: ".$baseurl."&action=hdbks");
                    exit;
                    break;

                    /*  */
                case 'delestimate':
                    if (!$permissions["e"]) {
                        $main->message_access_denied($this->module_name, $action);
                    }
                    global $request_id;
                    $this->delEstimate($request_id);
                    header("Location: ".$baseurl."&action=hdbks");
                    exit;
                    break;

                    /*  */
                case 'addanswer':
                    if (!$permissions["e"]) {
                        $main->message_access_denied($this->module_name, $action);
                    }
                    global $request_data;
                    if ($this->addAnswer($request_data) || !$request_data['ticket_id']) {
                        header("Location: ".$baseurl."&action=tickets");
                    } else {
                        header("Location: ".$baseurl."&action=ticket&id=".$request_data['ticket_id']);
                    }
                    exit;
                    break;

                case "getfile":
                    global $request_file;
                    if (!$this->getFile($request_file)) {
                    	$main->include_main_blocks_2($this->module_name."_".$action.".html", $this->tpl_path);
                    	$tpl->prepare();
                    }
                    break;

                case "delfile":
                    global $request_file;
                    $ticket_id = $this->getTicketIdByFileId($request_file);
                    if ($ticket_id) {
                        if (!$this->delFile($request_file)) {
                        	$main->include_main_blocks_2($this->module_name."_getfile.html", $this->tpl_path);
                        	$tpl->prepare();
                        	break;
                        }
                    }
                    header("Location: ".$baseurl."&action=ticket&id=".$ticket_id);
                    exit;

                    /*  */
                case 'delticket':
                    if (!$permissions["d"]) {
                        $main->message_access_denied($this->module_name, $action);
                    }
                    global $request_id, $request_check;
                    $this->delTicket($request_check ? $request_check : $request_id);
                    header("Location: ".$baseurl."&action=tickets");
                    exit;
                    break;
                    /*  */
                case 'setnotes':
                    if (!$permissions["e"]) {
                        $main->message_access_denied($this->module_name, $action);
                    }
                    global $request_date;
                    $this->setUserNotes($request_date);
                    Module::go_back();
                    header("Location: ".$baseurl."&action=users");
                    exit;
                    break;
                    // Default...
                    /*  */
                case 'setanswer':
                    if (!$permissions["e"]) {
                        $main->message_access_denied($this->module_name, $action);
                    }
                    global $request_id, $request_txt;
                    $this->setAnswerTxt($request_id, $request_txt);
                    Module::go_back();
                    exit;
                    break;
                default:
                    $main->include_main_blocks();
                    $tpl->prepare();
            }
            //--------------------------- конец обработки действий из админ части --------------------------//
        }
    }

    function getPropertyFields() {
        GLOBAL $request_sub_action;
        if ('' != $request_sub_action) {

            $tpl = $this->getTmpProperties();

            switch ($request_sub_action) {
                default:
                    $tpl->newBlock('block_properties_none');
                    $tpl->assign(Array(
                        "MSG_No" => $this->_msg["No"],
                    ));
                    break;
            }
            return $this->getOutputContent($tpl->getOutputContent());
        }
        return FALSE;
    }

    function getCategory($id)
    {
        global $db;

        $db->query("SELECT * FROM {$this->table_prefix}_support_category WHERE id=".intval($id));
        $ret = false;
        if ($db->nf()) {
            $db->next_record();
            $ret = $db->Record;
        }
        return $ret;
    }

    function getLevel($id)
    {
        global $db;

        $db->query("SELECT * FROM {$this->table_prefix}_support_level WHERE id=".intval($id));
        $ret = false;
        if ($db->nf()) {
            $db->next_record();
            $ret = $db->Record;
        }
        return $ret;
    }

    function getEstimate($id)
    {
        global $db;

        $db->query("SELECT * FROM {$this->table_prefix}_support_estimate WHERE id=".intval($id));
        $ret = false;
        if ($db->nf()) {
            $db->next_record();
            $ret = $db->Record;
        }
        return $ret;
    }

    function categoryExists($id)
    {
        global $db;

        $db->query("SELECT id FROM {$this->table_prefix}_support_category WHERE id=".intval($id));
        return $db->nf() ? true : false;
    }

    function levelExists($id)
    {
        global $db;

        $db->query("SELECT id FROM {$this->table_prefix}_support_level WHERE id=".intval($id));
        return $db->nf() ? true : false;
    }

    function estimateExists($id)
    {
        global $db;

        $db->query("SELECT id FROM {$this->table_prefix}_support_estimate WHERE id=".intval($id));
        return $db->nf() ? true : false;
    }

    function ticketExists($id)
    {
        global $db;

        $db->query("SELECT id FROM {$this->table_prefix}_support_ticket WHERE id=".intval($id));
        return $db->nf() ? true : false;
    }

    function delCategory($id)
    {
        global $db;
        $id = intval($id);
        $db->query("SELECT id FROM {$this->table_prefix}_support_ticket WHERE category_id={$id} LIMIT 1");
        $ret = false;
        if (!$db->nf()) {
            $db->query("DELETE FROM {$this->table_prefix}_support_category WHERE id={$id}");
            $ret = $db->affected_rows() ? true : false;
        }

        return $ret;
    }

    function delLevel($id)
    {
        global $db;
        $id = intval($id);
        $db->query("SELECT id FROM {$this->table_prefix}_support_ticket WHERE level_id={$id} LIMIT 1");
        $ret = false;
        if (!$db->nf()) {
            $db->query("DELETE FROM {$this->table_prefix}_support_level WHERE id={$id}");
            $ret = $db->affected_rows() ? true : false;
        }

        return $ret;
    }

    function delEstimate($id)
    {
        global $db;
        $id = intval($id);
        $db->query("SELECT id FROM {$this->table_prefix}_support_answer WHERE id={$id} LIMIT 1");
        $ret = false;
        if (!$db->nf()) {
            $db->query("DELETE FROM {$this->table_prefix}_support_estimate WHERE id={$id}");
            $ret = $db->affected_rows() ? true : false;
        }

        return $ret;
    }

    function setCategory($data)
    {
        global $db;

        $data['title'] = My_Sql::escape($data['title']);
        $data['number'] = (int) $data['number'];
        $ret = false;
        if (! empty($data['title'])) {
            if ($data['id']) {
                if ($this->categoryExists($data['id'])) {
                    $db->query("UPDATE {$this->table_prefix}_support_category SET title='"
                    .$data['title']."', number={$data['number']} WHERE id=".intval($data['id']));
                    $ret = true;
                }
            } else {
                $db->query("INSERT INTO {$this->table_prefix}_support_category SET title='{$data['title']}', number={$data['number']}");
                $ret = $db->affected_rows() ? $db->lid() : false;
            }
        }
        return $ret;
    }

    function setEstimate($data)
    {
        global $db;

        $data['title'] = My_Sql::escape($data['title']);
        $data['number'] = (int) $data['number'];
        $ret = false;
        if (! empty($data['title'])) {
            if ($data['id']) {
                if ($this->estimateExists($data['id'])) {
                    $db->query("UPDATE {$this->table_prefix}_support_estimate SET title='"
                    .$data['title']."', number={$data['number']} WHERE id=".intval($data['id']));
                    $ret = true;
                }
            } else {
                $db->query("INSERT INTO {$this->table_prefix}_support_estimate SET title='{$data['title']}', number={$data['number']}");
                $ret = $db->affected_rows() ? $db->lid() : false;
            }
        }
        return $ret;
    }

    function setLevel($data)
    {
        global $db;

        $data['title'] = My_Sql::escape($data['title']);
        $data['answ_min'] = (int) $data['answ_min'];
        $data['cls_min'] = (int) $data['cls_min'];
        $data['group'] = (int) $data['group'];
        $data['number'] = (int) $data['number'];
        require_once(RP."mod/siteusers/lib/class.SiteusersPrototype.php");
        $u = new SiteusersPrototype('only_create_object');
        $ret = $id = false;
        if (! empty($data['title']) && $data['answ_min'] > 0 && $data['cls_min'] > 0
            && $data['group'] > 0 && $u->getGroup($data['group'])
        ) {
            if ($data['id']) {
                if ($this->levelExists($data['id'])) {
                    $id = intval($data['id']);
                    $db->query("UPDATE {$this->table_prefix}_support_level SET title='"
                    .$data['title']."', answ_min={$data['answ_min']}, cls_min="
                    .$data['cls_min'].", group_id={$data['group']}, number={$data['number']} WHERE id="
                    .$id);
                    $ret = true;
                }
            } else if (!$this->isSetLevelsGroup($data['group'])) {
                $db->query("INSERT INTO {$this->table_prefix}_support_level SET title='{$data['title']}', answ_min="
                .$data['answ_min'].", cls_min={$data['cls_min']}, group_id={$data['group']}, number={$data['number']}");
                if ($db->affected_rows()) {
                    $ret = $id = $db->lid();
                } else {
                    $ret = false;
                }
            }
        }
        if ($id) {
            $db->query("DELETE FROM {$this->table_prefix}_support_level_schedule WHERE level_id={$id}");
            for ($i = 1; $i<8; $i++) {
                $type = 24 == $data['open'][$i]['type'] ? 24 : 0;
                $open_from = $open_to = $break_from = $break_to = '';
                if (1 == $data['open'][$i]['type'] ) {
                    $type = 1;
                    $open_from = $this->toTime($data['open'][$i]['from_h'], $data['open'][$i]['from_m']);
                    $open_to = $this->toTime($data['open'][$i]['to_h'], $data['open'][$i]['to_m']);
                    $break_from = $this->toTime($data['break'][$i]['from_h'], $data['break'][$i]['from_m']);
                    $break_to = $this->toTime($data['break'][$i]['to_h'], $data['break'][$i]['to_m']);
                    $open_from_f = $this->time2Float($open_from);
                    $open_to_f = $this->time2Float($open_to);
                    $break_from_f = $this->time2Float($break_from);
                    $break_to_f = $this->time2Float($break_to);
                    if ($open_from_f > $open_to_f) {
                        $x = $open_to;
                        $open_to = $open_from;
                        $open_from = $x;
                    }
                    if ($break_from_f > $break_to_f) {
                        $x = $break_to;
                        $break_to = $break_from;
                        $break_from = $x;
                    }
                    if ($break_from_f < $open_from_f || $break_from_f > $open_to_f
                        || $break_to_f < $open_from_f || $break_to_f > $open_to_f
                    ) {
                        $break_to = $break_from = '0';
                        
                    }
                }
                $db->query("INSERT INTO {$this->table_prefix}_support_level_schedule "
                    ."(level_id, `day`, `type`, open_from, open_to, break_from, break_to) VALUES ("
                    ."{$id}, {$i}, '{$type}', '{$open_from}', '{$open_to}', '{$break_from}', '{$break_to}')");
            }
        }
        return $ret;
    }

    function getCategoryList($with_ticket_count = 0)
    {
        global $db;

        $db->query(
            !$with_ticket_count
            ? "SELECT * FROM {$this->table_prefix}_support_category ORDER BY number, title"
            : "SELECT C.*, COUNT(T.id) AS ticket_count FROM {$this->table_prefix}_support_category AS C"
                ." LEFT JOIN {$this->table_prefix}_support_ticket AS T ON T.category_id=C.id "
                ." GROUP BY C.id ORDER BY C.number, C.title");
        $ret = false;
        while ($db->next_record()) {
            $ret[$db->Record['id']] = $db->Record;
        }
        return $ret;
    }

    function getLevelList($with_ticket_count = 0)
    {
        global $db;

        $db->query(
            !$with_ticket_count
            ? "SELECT L.*, G.name AS group_name FROM {$this->table_prefix}_support_level AS L"
                ." LEFT JOIN core_groups AS G ON L.group_id=G.id ORDER BY number, title"
            : "SELECT L.*, G.name AS group_name, COUNT(T.id) AS ticket_count FROM "
                .$this->table_prefix."_support_level AS L LEFT JOIN core_groups AS G ON L.group_id=G.id"
                ." LEFT JOIN {$this->table_prefix}_support_ticket AS T ON T.level_id=L.id "
                ." GROUP BY L.id ORDER BY L.number, L.title");
        $ret = false;
        while ($db->next_record()) {
            $ret[$db->Record['id']] = $db->Record;
        }
        return $ret;
    }

    function getEstimateList($with_ticket_count = 0)
    {
        global $db;

        $db->query(
            !$with_ticket_count
            ? "SELECT * FROM {$this->table_prefix}_support_estimate ORDER BY number, title"
            : "SELECT E.*, COUNT(T.id) AS ticket_count FROM {$this->table_prefix}_support_estimate AS E"
                ." LEFT JOIN {$this->table_prefix}_support_ticket AS T ON T.level_id=E.id "
                ." GROUP BY E.id ORDER BY E.number, E.title");
        $ret = false;
        while ($db->next_record()) {
            $ret[$db->Record['id']] = $db->Record;
        }
        return $ret;
    }

    function getStatusList()
    {
        $ret = false;
        foreach ($this->status_list as $key => $val) {
            $ret[$key] = array('title' => $val);
        }
        return $ret;
    }

    function getUserList()
    {
        global $db;

        $db->query("SELECT DISTINCT T.user_id, U.username FROM {$this->table_prefix}_support_ticket AS T LEFT JOIN core_users AS U ON T.user_id=U.id ORDER BY username");
        $ret = false;
        while ($db->next_record()) {
            $ret[$db->Record['user_id']] = array(
                'user_id' => $db->Record['user_id'],
                'username' => $db->Record['username']
            );
        }
        return $ret;
    }

    function getManagerList()
    {
        global $db;

        $db->query("SELECT DISTINCT T.manager_id, U.username FROM {$this->table_prefix}_support_ticket AS T LEFT JOIN core_users AS U ON T.manager_id=U.id WHERE T.manager_id>0 ORDER BY username");
        $ret = false;
        while ($db->next_record()) {
            $ret[$db->Record['manager_id']] = array(
                'user_id' => $db->Record['manager_id'],
                'username' => $db->Record['username']
            );
        }
        return $ret;
    }

    function getModulesUserList($filter = array())
    {
        global $db;

        $ret = false;
        $group_ids = $this->getTicketGroupsIds();
        if (!empty($group_ids)) {
            $where = array();
            $limit = '';
            if (isset($filter['q']) && $filter['q']) {
                $q = $db->escape(str_replace(array('%', '_'), array('\%', '\_'), $filter['q']));
            	$where[] = "(U.username LIKE '%{$q}%' OR U.email LIKE '%{$q}%')";
            }
            if (isset($filter['on_page']) && $filter['on_page'] >= 1) {
                $q = isset($filter['start']) && $filter['start'] > 1 ? (int)$filter['start'] : 1;
                $p = (int) $filter['on_page'];
            	$limit = ' LIMIT '.(($q-1)*$p).','.$p;
            }
            $lvls = $this->getLevelList();
            $db->query("SELECT U.id, U.username, U.email,"
                ." DATE_FORMAT(SU.finish_date, '%d-%m-%Y') AS finish_date,"
                ." IF(finish_date AND finish_date>NOW(), 1, 0) AS active,"
                ." GROUP_CONCAT(DISTINCT group_id SEPARATOR ',') AS groups"
                ." FROM core_users AS U"
                ." LEFT JOIN core_users_groups AS UG ON U.id=UG.user_id"
                ." LEFT JOIN {$this->table_prefix}_support_user AS SU ON U.id=SU.user_id"
                ." WHERE U.id IN (SELECT DISTINCT user_id FROM core_users_groups WHERE group_id IN (".implode(",", $group_ids).")) "
                .(!empty($where) ? " AND ".implode(" AND ", $where) : "")
                ." GROUP BY U.id ORDER BY U.username".$limit);
            while ($db->next_record()) {
                $groups = explode(",", $db->Record['groups']);
                $level_title = '';
                $level_id = 0;
                if ($lvls) {
                    while (!$level_id && list($key, $val) = each($lvls)) {
                        if (in_array($val['group_id'], $groups)) {
                            $level_id = $val['id'];
                            $level_title = $val['title'];
                        }
                    }
                }
                reset($lvls);
                $ret[$db->Record['id']] = array(
                    'id' => $db->Record['id'],
                    'username' => $db->Record['username'],
                    'email' => $db->Record['email'],
                    'finish_date' => $db->Record['finish_date'],
                    'active' => $db->Record['active'],
                    'groups' => $db->Record['groups'],
                    'level_id' => $level_id,
                    'level_title' => $level_title,
                    'active_state' => $db->Record['active'] ? '' : '_off',
                    'active_title' => $db->Record['active'] ? $this->_msg['Active'] : $this->_msg['No_active'],
                );
            }
        }
        return $ret;
    }

    function getModulesUserCount($filter = array())
    {
        global $db;

        $ret = false;
        $group_ids = $this->getTicketGroupsIds();
        if (!empty($group_ids)) {
            $where = array();
            $limit = '';
            if (isset($filter['q']) && $filter['q']) {
                $q = $db->escape(str_replace(array('%', '_'), array('\%', '\_'), $filter['q']));
            	$where[] = "(U.username LIKE '%{$q}%' OR U.email LIKE '%{$q}%')";
            }
            $db->query("SELECT COUNT(*) FROM core_users AS U"
                ." WHERE id IN (SELECT DISTINCT user_id FROM core_users_groups WHERE group_id IN (".implode(",", $group_ids).")) "
                .(!empty($where) ? " AND ".implode(" AND ", $where) : ""));
            if ($db->next_record()) {
                $ret = $db->Record[0];
            }
        }
        return $ret;
    }

    function isSetLevelsGroup($group_id)
    {
        global $db;

        $db->query("SELECT id FROM {$this->table_prefix}_support_level WHERE group_id=".intval($group_id));
        return $db->nf() ? true : false;
    }

    /**
     * Get levels id by users id
     *
     * @param int $user_id
     * @return mixed false OR int - level id
     */
    function getUserLevel($user_id)
    {
        global $db;

        $ret = false;
        if ($user_id > 0) {
            require_once(RP."mod/siteusers/lib/class.SiteusersPrototype.php");
            $u = new SiteusersPrototype('only_create_object');
            $usr_grps = $u->getUserGroups($user_id);
            if ($usr_grps) {
                $usr_grps_ids = array();
                foreach ($usr_grps as $val) {
                    $usr_grps_ids[] = $val['id'];
                }
                $lvls = $this->getLevelList();
                if ($lvls) {
                    while (!$ret && list($key, $val) = each($lvls)) {
                        if (in_array($val['group_id'], $usr_grps_ids)) {
                            $ret = $val['id'];
                        }
                    }
                }
            }
        }

        return $ret;
    }

    function getFinishDate()
    {
    	global $db;

        $ret = false;
    	$db->query("SELECT DATE_FORMAT(finish_date, '%d-%m-%Y') FROM {$this->table_prefix}_support_user"
    	    ." WHERE finish_date>NOW() AND user_id=".intval($_SESSION['siteuser']['id']));
    	if ($db->next_record()) {
    		$ret = $db->Record[0];
    	}
    	return $ret;
    }

    function addTicket($data)
    {
        global $db;

        $ret = false;
        $level_id = $this->getUserLevel($_SESSION["siteuser"]["id"]);
        $data['title'] = My_Sql::escape(strip_tags($data['title']));
        $data['txt'] = My_Sql::escape(htmlspecialchars($data['txt']));
        $data['ctgr'] = intval($data['ctgr']);
        $data['notify'] = $data['notify'] ? 1 : 0;

        if ($level_id && $data['txt'] && array_key_exists($data['ctgr'], $this->getCategoryList()) ) {
            $data['title'] = $data['title'] ? $data['title'] : substr($data['title'], 0, 50)."...";
            $db->query("INSERT INTO {$this->table_prefix}_support_ticket SET "
            ."`category_id`={$data['ctgr']}, `level_id`={$level_id}, `title`='{$data['title']}', "
            ."`txt`='{$data['txt']}', `status`=1, `editable`=1, `last_time`=NOW(), `crt_time`=NOW(), "
            ."`user_id`={$_SESSION["siteuser"]["id"]}, `notify`={$data['notify']}");
            if ($db->affected_rows()) {
                $ret = true;
                $this->addTicketFiles($db->lid());
            }
        }

        return $ret;
    }

    function addTicketFiles($ticket_id)
    {
        return $this->addFiles($ticket_id, 'ticket');
    }

    function addFiles($owner_id, $type)
    {
        global $db, $CONFIG;

        $ticket_id = false;
    	if ('ticket' == $type) {
    		$owner = $this->getTicket($owner_id);
    		$ticket_id = $owner ? $owner['id'] : false;
    		$ins = "ticket_id={$ticket_id}, answer_id=0, question_id=0";
    	} elseif ('answer' == $type) {
    	    $owner = $this->getAnswer($owner_id);
    	    $ticket_id = $owner ? $owner['ticket_id'] : false;
    	    $ins = "ticket_id={$ticket_id}, answer_id=".intval($owner_id).", question_id=0";
    	} elseif ('question' == $type) {
    	    $owner = $this->getQuestion($owner_id);
    	    $ticket_id = $owner ? $owner['ticket_id'] : false;
    	    $ins = "ticket_id={$ticket_id}, answer_id=0, question_id=".intval($owner_id);
    	}
    	$ret = false;
    	if ($ticket_id && !empty($_FILES['supp_file'])) {
    		foreach ($_FILES['supp_file']['name'] as $key => $file_name) {
                $ext = array_pop(explode(".", $file_name));
                if ($ext && !array_key_exists($ext, $this->disallowed_types)
                    && !$_FILES['supp_file']['error'][$key]
                    && is_uploaded_file($_FILES['supp_file']['tmp_name'][$key])
                ) {
                    $new_name = md5($owner_id.$type.$_FILES['supp_file']['tmp_name'][$key].rand());
                    $dir_name = RP.$CONFIG['support_files_parh'].$this->table_prefix."/".substr($new_name, 0, 3);
                    $dir_exist = true;
                    if (!file_exists($dir_name)) {
                    	$dir_exist = @mkdir($dir_name) ? true : false;
                    }
                    if ($dir_exist && move_uploaded_file($_FILES['supp_file']['tmp_name'][$key], $dir_name."/".$new_name)) {
                        $db->query("INSERT INTO {$this->table_prefix}_support_file SET "
                        ."{$ins}, file='{$new_name}', file_name='{$file_name}'");
                        if ($db->affected_rows()) {
                            $ret = true;
                        } else {
                            @unlink($dir_name."/".$new_name);
                        }
                    }
                }
            }
    	}
        return $ret;
    }

    function getTicketCount($filter = array())
    {
        global $db;
        $where = array();
        if (isset($filter['user']) && $filter['user']) {
            $where[] = "T.user_id=".intval($filter['user']);
        }
        if (isset($filter['manager']) && $filter['manager']) {
            $where[] = "T.manager_id=".intval($filter['manager']);
        }
        if (isset($filter['category']) && $filter['category']) {
            $where[] = "T.category_id=".intval($filter['category']);
        }
        if (isset($filter['level']) && $filter['level']) {
            $where[] = "T.level_id=".intval($filter['level']);
        }
        if (isset($filter['status']) && $filter['status']) {
            $where[] = "T.status=".intval($filter['status']);
        }
        if (isset($filter['estimate']) && $filter['estimate']) {
            $where[] = "T.estimate_id=".intval($filter['estimate']);
        }
        if (isset($filter['pct']) && $filter['pct']) {
            if (1 == $filter['pct']) {
                $where[] = "IF(T.status IN (1,3), underway / ( L.answ_min * 60 ), 0)>0 AND IF(T.status IN (1,3), underway / ( L.answ_min * 60 ), 0)<=0.5";
            } else if (2 == $filter['pct']) {
                $where[] = "IF(T.status IN (1,3), underway / ( L.answ_min * 60 ), 0)>0.5 AND IF(T.status IN (1,3), underway / ( L.answ_min * 60 ), 0)<=1";
            } else if (3 == $filter['pct']) {
                $where[] = "IF(T.status IN (1,3), underway / ( L.answ_min * 60 ), 0)>1";
            }
        }
        if ($filter['f'] && $filter['t']) {
        	$where[] ="T.crt_time BETWEEN '".$this->formDate($filter['f'])."' AND '".$this->formDate($filter['t'])." 23:59:59'";
        } else if ($filter['f']) {
        	$where[] ="T.crt_time > '".$this->formDate($filter['f'])."'";
        } else if ($filter['t']) {
        	$where[] ="T.crt_time < '".$this->formDate($filter['t'])." 23:59:59'";
        }
        $db->query("SELECT COUNT(*) AS cnt FROM {$this->table_prefix}_support_ticket T "
            ." LEFT JOIN {$this->table_prefix}_support_level AS L ON T.level_id=L.id"
        .(!empty($where) ? " WHERE ".implode(" AND ", $where) : ""));
        $db->next_record();

        return $db->Record['cnt'];
    }

    function getTicketList($filter = array())
    {
        global $db, $CONFIG;

        $where = array();
        $order = "T.last_time DESC";
        $limit = "";
        if (isset($filter['user']) && $filter['user']) {
            $where[] = "T.user_id=".intval($filter['user']);
        }
        if (isset($filter['manager']) && $filter['manager']) {
            $where[] = "T.manager_id=".intval($filter['manager']);
        }
        if (isset($filter['category']) && $filter['category']) {
            $where[] = "T.category_id=".intval($filter['category']);
        }
        if (isset($filter['level']) && $filter['level']) {
            $where[] = "T.level_id=".intval($filter['level']);
        }
        if (isset($filter['status']) && $filter['status']) {
            $where[] = "T.status=".intval($filter['status']);
        }
        if (isset($filter['estimate']) && $filter['estimate']) {
            $where[] = "T.estimate_id=".intval($filter['estimate']);
        }
        if (isset($filter['pct']) && $filter['pct']) {
            if (1 == $filter['pct']) {
                $where[] = "IF(T.status IN (1,3), T.underway / ( L.answ_min * 60 ), 0)>0 AND IF(T.status IN (1,3), T.underway / ( L.answ_min * 60 ), 0)<=0.5";
            } else if (2 == $filter['pct']) {
                $where[] = "IF(T.status IN (1,3), T.underway / ( L.answ_min * 60 ), 0)>0.5 AND IF(T.status IN (1,3), T.underway / ( L.answ_min * 60 ), 0)<=1";
            } else if (3 == $filter['pct']) {
                $where[] = "IF(T.status IN (1,3), T.underway / ( L.answ_min * 60 ), 0)>1";
            }
        }
        if ($filter['f'] && $filter['t']) {
        	$where[] ="T.crt_time BETWEEN '".$this->formDate($filter['f'])."' AND '".$this->formDate($filter['t'])." 23:59:59'";
        } else if ($filter['f']) {
        	$where[] ="T.crt_time > '".$this->formDate($filter['f'])."'";
        } else if ($filter['t']) {
        	$where[] ="T.crt_time < '".$this->formDate($filter['t'])." 23:59:59'";
        }
        if (isset($filter['count']) && $filter['count'] > 1) {
            $filter['count'] = (int) $filter['count'];
            $limit = " LIMIT "
            .(isset($filter['start']) && $filter['start'] > 1 ? ($filter['start']-1)*$filter['count'].',' : '')
            .$filter['count'];
        }
        //echo implode(" AND ", $where);
        $db->query("SELECT T.id, T.category_id, T.level_id, T.title, T.txt, T.status, "
            ."DATE_FORMAT(T.last_time, '".$CONFIG['support_date_format']."') AS last_time, "
            ."DATE_FORMAT(T.crt_time, '".$CONFIG['support_date_format']."') AS crt_time, "
            ."T.user_id, T.manager_id, T.underway, C.title AS category_title, L.title AS level_title, "
            ."U.username AS user_username, M.username AS manager_username, "
            ." IF(T.status IN (1,3), T.underway / ( L.answ_min * 60 ), 0) AS pct"
            ." FROM {$this->table_prefix}_support_ticket AS T "
            ." LEFT JOIN {$this->table_prefix}_support_category AS C ON T.category_id=C.id"
            ." LEFT JOIN {$this->table_prefix}_support_level AS L ON T.level_id=L.id"
            ." LEFT JOIN core_users AS U ON T.user_id=U.id"
            ." LEFT JOIN core_users AS M ON T.manager_id=M.id"
            .(!empty($where) ? " WHERE ".implode(" AND ", $where) : "" )
            ."  ORDER BY ".$order.$limit);
        $ret = false;
        //echo $db->sql;
        while ($db->next_record()) {
            if (0 == $db->Record['pct']) {
                $color = "FFF";
            } else if ($db->Record['pct'] > 0 && $db->Record['pct'] <= 0.5) {
                $color = "0F0";
            } else if ($db->Record['pct'] > 0.5 && $db->Record['pct'] < 1) {
                $color = "FF0";
            } else {
                $color = "F00";
            }
            $ret[$db->Record['id']] = array(
                'id' => $db->Record['id'],
                'category_id' => $db->Record['category_id'],
                'level_id' => $db->Record['level_id'],
                'title' => $db->Record['title'],
                'txt' => nl2br($db->Record['txt']),
                'status_id' => $db->Record['status'],
                'status' => $this->status_list[$db->Record['status']],
                'last_time' => $db->Record['last_time'],
                'crt_time' => $db->Record['crt_time'],
                'user_id' => $db->Record['user_id'],
                'manager_id' => $db->Record['manager_id'],
                'category_title' => $db->Record['category_title'],
                'level_title' => $db->Record['level_title'],
                'user_username' => $db->Record['user_username'],
                'manager_username' => $db->Record['manager_username'],
                'pct' => number_format($db->Record['pct']*100, 1, ".", ''),
                'pct_color' => $color,
            );
        }
        return $ret;
    }

    function getTicket($id)
    {
        global $db, $CONFIG;
        $ret = false;

        $db->query("SELECT T.id, T.category_id, T.level_id, T.estimate_id, T.title, T.txt, T.status, T.editable, "
            ."DATE_FORMAT(T.last_time, '".$CONFIG['support_date_format']."') AS last_time, "
            ."DATE_FORMAT(T.crt_time, '".$CONFIG['support_date_format']."') AS crt_time, "
            ."DATE_FORMAT(T.upd_time, '".$CONFIG['support_date_format']."') AS upd_time, "
            ."T.user_id, T.manager_id, T.notify, T.underway, T.underway/60 AS downtime, "
            ."C.title AS category_title, L.title AS level_title, E.title AS estimate_title, "
            ."U.username AS user_username, U.email AS user_email, M.username AS manager_username, "
            ."M.email AS manager_email, "
            ."SU.notes, SU.finish_date"
            ." FROM {$this->table_prefix}_support_ticket AS T "
            ." LEFT JOIN {$this->table_prefix}_support_category AS C ON T.category_id=C.id"
            ." LEFT JOIN {$this->table_prefix}_support_level AS L ON T.level_id=L.id"
            ." LEFT JOIN {$this->table_prefix}_support_estimate AS E ON T.estimate_id=E.id"
            ." LEFT JOIN {$this->table_prefix}_support_user AS SU ON SU.user_id=T.user_id"
            ." LEFT JOIN core_users AS U ON T.user_id=U.id"
            ." LEFT JOIN core_users AS M ON T.manager_id=M.id"
            ." WHERE T.id=".intval($id));
        if ($db->next_record()) {
            $ret = array(
                'id' => $db->Record['id'],
                'category_id' => $db->Record['category_id'],
                'level_id' => $db->Record['level_id'],
                'estimate_id' => $db->Record['estimate_id'],
                'title' => $db->Record['title'],
                'txt' => nl2br($db->Record['txt']),
                'status_id' => $db->Record['status'],
                'status' => $this->status_list[$db->Record['status']],
                'editable' => $db->Record['editable'],
                'last_time' => $db->Record['last_time'],
                'crt_time' => $db->Record['crt_time'],
                'upd_time' => $db->Record['upd_time'],
                'user_id' => $db->Record['user_id'],
                'manager_id' => $db->Record['manager_id'],
                'notify' => $db->Record['notify'],
                'underway' => $db->Record['underway'],
                'downtime' => $db->Record['downtime'],
                'category_title' => $db->Record['category_title'],
                'level_title' => $db->Record['level_title'],
                'estimate_title' => $db->Record['estimate_title'],
                'user_username' => $db->Record['user_username'],
                'user_email' => $db->Record['user_email'],
                'manager_username' => $db->Record['manager_username'],
                'manager_email' => $db->Record['manager_email'],
                'notes' => $db->Record['notes'],
                'finish_date' => $db->Record['finish_date'],
            );
            $ret['files'] = $this->getTicketFiles($id);
            $ret['answers'] = $this->getTicketAnswers($id);
            $ret['questions'] = $this->getTicketQuestions($id);
        }
        return $ret;
    }

    function getTicketFiles($ticket_id)
    {
        return $this->getFiles($ticket_id, 'ticket');
    }

    function getFiles($owner_id, $type)
    {
        global $db;

        $where = '';
        if ('ticket' == $type) {
            $where = "ticket_id=".intval($owner_id)." AND question_id=0 AND answer_id=0";
        } elseif ('qnswer' == $type) {
            $where = "answer_id=".intval($owner_id);
        } elseif ('question' == $type) {
            $where = "question_id=".intval($owner_id);
        } elseif ('all' == $type) {
            $where = "ticket_id=".intval($owner_id);
        }
        $ret = false;
        if ($where) {
        	$db->query("SELECT * FROM {$this->table_prefix}_support_file WHERE {$where}");
            while ($db->next_record()) {
                $ret[$db->Record['id']] = array(
                'id' => $db->Record['id'],
                'file_name' => $db->Record['file_name'],
                'file' => $db->Record['file'],
                'ticket_id' => $db->Record['ticket_id'],
                'question_id' => $db->Record['question_id'],
                'answer_id' => $db->Record['answer_id'],
                );
            }
        }
        return $ret;
    }

    function showFiles($tpl, $list, $owner_id, $type)
    {
        global $baseurl, $CONFIG;

        if (!empty($list)) {
            $_baseurl = $baseurl.(false === strpos($baseurl, '?') ? "?" : "&");
            $ticket_url = Core::formPageLink($CONFIG["support_page_link"], $CONFIG["support_page_address"], $lang, 1);
            $find = false;
        	foreach ($list as $val) {
       			if (
       			    ('ticket' == $type && 0 == $val['question_id'] && 0 == $val['answer_id'])
       			    || ('answer' == $type && $owner_id == $val['answer_id'])
       			    || ('question' == $type && $owner_id == $val['question_id'])
       			) {
       				if (!$find) {
       				    $tpl->newBlock("block_{$type}_files");
       				    $tpl->assign('MSG_Attached_files', $this->_msg['Attached_files']);
       				    $find = true;
       				}
       				$tpl->newBlock("block_{$type}_file");
       				$tpl->assign(array(
       				    'id' => $val['id'],
       				    'ticket_id' => $val['ticket_id'],
       				    'question_id' => $val['question_id'],
       				    'answer_id' => $val['answer_id'],
       				    'file_name' => $val['file_name'],
       				    'link' => $_baseurl."action=getfile&file=".$val['id'],
       				    'query' => "action=getfile&file=".$val['id'],
                        'ticket_url' => $ticket_url,
       				    'del_link' => $_baseurl."action=delfile&file=".$val['id'],
       				    'domen' => $CONFIG['domen'],
       				    'MSG_Delete' => $this->_msg['Delete']
       				));
       			}
       		}
        }
    }

    function getTicketAnswers($ticket_id)
    {
        global $db, $CONFIG;

        $db->query("SELECT A.id, A.ticket_id, A.txt, A.manager_id,"
            ."DATE_FORMAT(A.last_time, '".$CONFIG['support_date_format']."') AS last_time, "
            ."DATE_FORMAT(A.crt_time, '".$CONFIG['support_date_format']."') AS crt_time, "
            ."UNIX_TIMESTAMP(A.last_time) AS last_time_ts, "
            ."UNIX_TIMESTAMP(A.crt_time) AS crt_time_ts, "
            ."U.username FROM {$this->table_prefix}_support_answer AS A"
            ." LEFT JOIN core_users AS U ON A.manager_id=U.id "
            ."WHERE A.ticket_id=".intval($ticket_id)." ORDER BY crt_time");
        $ret = false;
        while ($db->next_record()) {
            $ret[$db->Record['id']] = array(
                'id' => $db->Record['id'],
                'ticket_id' => $db->Record['ticket_id'],
                'txt' => nl2br($db->Record['txt']),
                'crt_time' => $db->Record['crt_time'],
                'last_time' => $db->Record['last_time'],
                'crt_time_ts' => $db->Record['crt_time_ts'],
                'last_time_ts' => $db->Record['last_time_ts'],
                'user_id' => $db->Record['manager_id'],
                'username' => $db->Record['username']
            );
        }
        return $ret;
    }

    function getTicketQuestions($ticket_id)
    {
        global $db, $CONFIG;

        $db->query("SELECT id, ticket_id, txt, editable, "
            ."DATE_FORMAT(last_time, '".$CONFIG['support_date_format']."') AS last_time, "
            ."DATE_FORMAT(crt_time, '".$CONFIG['support_date_format']."') AS crt_time, "
            ."UNIX_TIMESTAMP(last_time) AS last_time_ts, "
            ."UNIX_TIMESTAMP(crt_time) AS crt_time_ts "
            ." FROM {$this->table_prefix}_support_question "
            ."WHERE ticket_id=".intval($ticket_id)." ORDER BY crt_time");
        $ret = false;
        while ($db->next_record()) {
            $ret[$db->Record['id']] = array(
                'id' => $db->Record['id'],
                'ticket_id' => $db->Record['ticket_id'],
                'txt' => nl2br($db->Record['txt']),
                'editable' => $db->Record['editable'],
                'crt_time' => $db->Record['crt_time'],
                'last_time' => $db->Record['last_time'],
                'crt_time_ts' => $db->Record['crt_time_ts'],
                'last_time_ts' => $db->Record['last_time_ts']
            );
        }
        return $ret;
    }

    function setTicketStatus($ticket_id, $status)
    {
        global $db;
        $ticket = $this->getTicket($ticket_id);
        $ret = false;
        if ($ticket && $status && array_key_exists($status, $this->status_list)
            && $ticket['status_id'] != $status
        ) {
            /*  */
            if ( (2 == $status || 4 == $status)
                && (2 != $ticket['status_id'] && 4 != $ticket['status_id'] ) /* Если заявка не обработана или в работе - то не учитывем статистику */
            ) {
            	$level = $this->getLevel($ticket['level_id']);
            	$pct = $ticket['downtime']/($level['answ_min']/100);
            	if ($pct <= 50) {
            		$type = 1;
            	} elseif ($pct <= 100) {
            	    $type = 2;
            	} else {
            	    $type = 0;
            	}
            	$db->query("INSERT INTO {$this->table_prefix}_support_log SET ticket_id={$ticket['id']}, "
            	    ."type={$type}, crt_time=NOW(), manager_id={$_SESSION['siteuser']['id']}, user_id={$ticket['user_id']}");
            }
            $upd = '';
            if (3 == $status) {
                $upd = ', underway=0';
            }
            $db->query("UPDATE {$this->table_prefix}_support_ticket SET "
                ."last_time=NOW(), status=".$status.$upd." WHERE id=".$ticket_id);
            $ret = $db->affected_rows() ? true : false;
        }
        return $ret;
    }

    function addAnswer($data)
    {
        global $db;

        $ret = false;
        $ticket = $this->getTicket($data['ticket_id']);
        $data['txt'] = My_Sql::escape(htmlspecialchars($data['txt']));
        if ($_SESSION['session_is_admin'] && $ticket
            && in_array($ticket['status_id'], array(1, 3, 4))
        ) {
            $answ_id = false;
            if ($data['txt']) {
                if ($data['id']) {
                    $answ = $this->getAnswer($data['id']);
                    if ($answ && $answ['ticket_id'] == $ticket['id']) {
                        $answ_id = intval($data['id']);
                    	$db->query("UPDATE {$this->table_prefix}_support_answer SET "
                            ."txt='{$data['txt']}', last_time=NOW(), manager_id=".$_SESSION['siteuser']['id']
                            ." WHERE id=".$answ_id);
                    }
                } else {
                    $db->query("INSERT INTO {$this->table_prefix}_support_answer SET "
                        ."ticket_id=".$ticket['id']
                        .", txt='{$data['txt']}', last_time=NOW(), crt_time=NOW(), manager_id="
                        .$_SESSION['siteuser']['id']);
                    if ($db->affected_rows()) {
                        $answ_id = $db->lid();
                    }
                }
            }

            if (4 == $data['status'] || $answ_id ) {
                $this->setTicketStatus(
                    $ticket['id'],
                    isset($data['status']) && 4 == $data['status'] ? 4 : 2
                );
            }

            if ($answ_id) {
                $this->addFiles($answ_id, 'answer');
                if (!$ticket['manager_id']) {
                	$db->query("UPDATE {$this->table_prefix}_support_ticket SET manager_id="
                	    .$_SESSION['siteuser']['id']." WHERE id=".$ticket['id']);
                }
                $this->notifyUser($ticket['id']);
                $ret = true;
            }
        }

        return $ret;
    }

    function addQuestion($data)
    {
        global $db;

        $ret = false;
        $ticket = $this->getTicket($data['ticket_id']);
        $data['txt'] = My_Sql::escape(htmlspecialchars($data['txt']));
        if ($ticket && $data['txt'] && $ticket['user_id'] == $_SESSION['siteuser']['id']
            && in_array($ticket['status_id'], array(2))
        ) {
            $db->query("INSERT INTO {$this->table_prefix}_support_question SET "
                ."ticket_id={$ticket['id']}, txt='{$data['txt']}', editable=1, last_time=NOW(), crt_time=NOW()");
            if ($db->affected_rows()) {
                $lid = $db->lid();
                $ret = $this->setTicketStatus($ticket['id'], 3);
                $this->addFiles($lid, 'question');
            }
        }

        return $ret;
    }

    function setTicketEstimate($ticket_id, $estimate)
    {
        global $db;
        $ticket_id = (int) $ticket_id;
        $estimate = (int) $estimate;
        $db->query("SELECT user_id FROM {$this->table_prefix}_support_ticket WHERE estimate_id=0 AND id=".$ticket_id);
        $ret = false;
        if ($db->nf()) {
            $db->next_record();
        	if ($db->Record['user_id'] == $_SESSION['siteuser']['id']
        	    && array_key_exists($estimate, $this->getEstimateList())
        	) {
        		$db->query("UPDATE {$this->table_prefix}_support_ticket SET estimate_id=".$estimate." WHERE id=".$ticket_id);
        		if ($db->affected_rows()) {
        			$ret = true;
        		}
        	}
        }
        return $ret;
    }

    function getAnswer($id)
    {
        global $db;
        $db->query("SELECT * FROM {$this->table_prefix}_support_answer WHERE id=".intval($id));
        $ret = false;
        if ($db->nf()) {
            $db->next_record();
            $ret = array(
                'id' => $db->Record['id'],
                'ticket_id' => $db->Record['ticket_id'],
                'txt' => $db->Record['txt'],
                'last_time`' => $db->Record['last_time'],
                'crt_time' => $db->Record['crt_time'],
                'user_id' => $db->Record['manager_id']
            );
        }
        return $ret;
    }

    function getQuestion($id)
    {
        global $db;
        $db->query("SELECT * FROM {$this->table_prefix}_support_question WHERE id=".intval($id));
        $ret = false;
        if ($db->nf()) {
            $db->next_record();
            $ret = array(
                'id' => $db->Record['id'],
                'ticket_id' => $db->Record['ticket_id'],
                'txt' => $db->Record['txt'],
                'editable' => $db->Record['editable'],
                'last_time`' => $db->Record['last_time'],
                'crt_time' => $db->Record['crt_time']
            );
        }
        return $ret;
    }

    function showTicket($tpl, $ticket_id, $user_id = 0)
    {
        global $baseurl, $CONFIG, $lang;

        $_baseurl = $baseurl.(false === strpos($baseurl, '?') ? "?" : "&");
        $ticket_url = Core::formPageLink($CONFIG["support_page_link"], $CONFIG["support_page_address"], $lang, 1);
        $ticket = $this->getTicket($ticket_id);
        if ($ticket) {
            if ($user_id > 0 && $ticket['user_id'] != $user_id) {
                $tpl->newBlock('block_deny');
            } else {
                $tpl->newBlock('block_ticket');
                $tpl->assign(array(
                    'MSG_Ticket' => $this->_msg['Ticket'],
                    'MSG_Category' => $this->_msg['Category'],
                    'MSG_Level' => $this->_msg['Level'],
                    'MSG_User' => $this->_msg['User'],
                    'MSG_Manager' => $this->_msg['Manager'],
                    'MSG_Title' => $this->_msg['Title'],
                    'MSG_Status' => $this->_msg['Status'],
                    'MSG_Created' => $this->_msg['Created'],
                    'MSG_Modifited' => $this->_msg['Modifited'],
                    'MSG_Last_modifited' => $this->_msg['Last_modifited'],
                    'MSG_Ticket_text' => $this->_msg['Ticket_text'],
                    'MSG_Attached_files' => $this->_msg['Attached_files'],
                    'MSG_Estimate' => $this->_msg['Estimate'],
                    'MSG_Company' => $this->_msg['Company'],
                    'MSG_Finish_date' => $this->_msg['Finish_date'],
                    'MSG_Fio' => $this->_msg['Fio'],
                    'MSG_Users_notes' => $this->_msg['Users_notes'],
                    'MSG_Save' => $this->_msg['Save'],
                    'baseurl' => $_baseurl,
                    'finish_date' => $ticket['finish_date'] ? $ticket['finish_date'] : $this->finish_date,
                    'domen' => $CONFIG['domen'],
                    'ticket_url' => $ticket_url,
                ));
                $tpl->assign($ticket + array(
                    'admin_user_link' => '/admin.php?lang='.$lang.'&name=siteusers&action=editsiteuser&id='.$ticket['user_id']
                ));
                if ('00' != substr($ticket['upd_time'], 0, 2) ) {
                    $tpl->newBlock('block_upd_time');
                    $tpl->assign(array(
                        'upd_time' => $ticket['upd_time'],
                        'MSG_Modifited' => $this->_msg['Modifited']
                    ));
                }
                if ($ticket['estimate_id']) {
                    $tpl->newBlock('block_estimate');
                    $tpl->assign(array(
                        'MSG_Estimate' => $this->_msg['Estimate'],
                        'estimate_id' => $ticket['estimate_id'],
                        'estimate_title' => $ticket['estimate_title']
                    ));
                } else if(!empty($ticket['answers'])) {
                    $tpl->newBlock('block_no_estimate');
                    $tpl->assign(array(
                        'ticket_id' => $ticket_id,
                        'answer_id' => $answ['id'],
                        'baseurl' => $_baseurl,
                        'ticket_url' => $ticket_url,
                        'domen' => $CONFIG['domen']
                    ));
                     Module::show_select('block_estimate_item', 0, 'title', $this->getEstimateList());
                }
                /* Get all ticket files */
                $files = $this->getFiles($ticket_id, 'all');
                $this->showFiles($tpl, $files, $ticket_id, 'ticket');
                if (in_array($ticket['status_id'], array(1, 3, 4)) && $_SESSION['session_is_admin']) {
                    $txt = '';
                    $answer_id = '';
                    if (4 == $ticket['status_id'] && !empty($ticket['answers'])) {
                        $answ = end($ticket['answers']);
                        $txt = $answ['txt'];
                        $answer_id = $answ['id'];
                        $answ = false;
                        reset($ticket['answers']);
                    }
                    $tpl->newBlock('block_answer_form');
                    $tpl->assign(array(
                        'ticket_id' => $ticket['id'],
                        'answer_id' => $answer_id,
                        'status2_checked' => 4 != $ticket['status_id']  ? 'checked' : '',
                        'status4_checked' => 4 == $ticket['status_id']  ? 'checked' : '',
                        'txt' => $txt,
                        'baseurl' => $_baseurl,
                        'ticket_url' => $ticket_url,
                        'domen' => $CONFIG['domen'],
                        'MSG_Status' => $this->_msg['Status'],
                        'MSG_Status2' => $this->_msg['Status2'],
                        'MSG_Status4' => $this->_msg['Status4'],
                        'MSG_Reply' => $this->_msg['Reply'],
                        'MSG_Delete' => $this->_msg['Delete'],
                        'MSG_Save' => $this->_msg['Save'],
                        'MSG_Attach_file' => $this->_msg['Attach_file']
                    ));
                }
                if (in_array($ticket['status_id'], array(2))) {
                    $tpl->newBlock('block_question_form');
                    $tpl->assign(array(
                        'ticket_id' => $ticket['id'],
                        'baseurl' => $_baseurl,
                        'ticket_url' => $ticket_url,
                        'domen' => $CONFIG['domen']
                    ));
                }
                if (in_array($ticket['status_id'], array(2, 5, 6))) {
                    $tpl->newBlock('block_back');
                    $back_link = $_baseurl."&action=tickets";
                    /*
                    if (isset($_SERVER['HTTP_REFERER']) ) {
                        $url = parse_url($_SERVER['HTTP_REFERER']);
                        if ($url && $_SERVER["HTTP_HOST"] == $url['host']) {
                        	$back_link = $url['path']."?".$url['query'];
                        }
                    }
                    */
                    $tpl->assign(array(
                        'MSG_Goto_ticket_list' => $this->_msg['Goto_ticket_list'],
                        'back_link' => $back_link,
                    ));
                }
                if (!in_array($ticket['status_id'], array(5, 6))) {
                    $tpl->newBlock('block_close_form');
                    $tpl->assign(array(
                        'ticket_id' => $ticket['id'],
                        'baseurl' => $_baseurl,
                        'domen' => $CONFIG['domen']
                    ));
                }
                if ($ticket['editable']) {
                    $tpl->newBlock('block_edit');
                    $tpl->assign(array(
                        'ticket_id' => $ticket['id'],
                        'baseurl' => $_baseurl,
                        'is_ticket' => 1
                    ));
                }
                if (!empty($ticket['answers'])) {
                    $tpl->newBlock('block_correspondence');
                    $tpl->assign(array(
                        'MSG_Correspondence' => $this->_msg['Correspondence']
                    ));
                    list(,$answ) = each($ticket['answers']);
                    if ($ticket['questions']) {
                        list(,$quest) = each($ticket['questions']);
                    } else {
                        $quest = false;
                    }
                    $editable_question = false;
                    $last_question_id = 0;
                    while ($answ || $quest) {
                        if ($answ && (!$quest || $answ['crt_time_ts'] <= $quest['crt_time_ts'])) {
                            $answ_id = $answ['id'];
                            $answ_txt = $answ['txt'];
                            $tpl->newBlock('block_correspondence_row');
                            $tpl->newBlock('block_answer');
                            $tpl->assign(array_merge(
                                array(
                                    'MSG_Answer' => $this->_msg['Answer'],
                                    'MSG_Estimate' => $this->_msg['Estimate'],
                                    'MSG_Manager' => $this->_msg['Manager'],
                                    'baseurl' => $_baseurl,
                                    'ticket_url' => $ticket_url,
                                    'domen' => $CONFIG['domen']),
                                $answ));
                            if ($answ['last_time'] != $answ['crt_time']) {
                                $tpl->newBlock('block_answer_modifited');
                                $tpl->assign(array_merge(
                                    array(
                                        'MSG_Modifited' => $this->_msg['Modifited'],
                                        'baseurl' => $_baseurl,
                                        'ticket_url' => $ticket_url,
                                        'domen' => $CONFIG['domen']),
                                    $answ));
                            }
                            $this->showFiles($tpl, $files, $answ['id'], 'answer');
                            list(,$answ) = each($ticket['answers']);
                            /* если это последний ответ */
                            if (! $answ) {
                                $tpl->newBlock('block_answer_edit_btn');
                                $tpl->assign(array(
                                    'MSG_Edit' => $this->_msg['Edit'],
                                    'baseurl' => $_baseurl,
                                     'ticket_id' => $ticket['id'],
                                     'id' => $answ_id
                                 ));
                                $tpl->newBlock('block_answer_edit_form');
                                $tpl->assign(array(
                                    'MSG_Save' => $this->_msg['Save'],
                                    'MSG_Cancel' => $this->_msg['Cancel'],
                                    'baseurl' => $_baseurl,
                                    'ticket_id' => $ticket['id'],
                                    'id' => $answ_id,
                                    'txt' => $answ_txt,
                                 ));
                            }
                        } else if ($quest) {
                            $tpl->newBlock('block_correspondence_row');
                            $tpl->newBlock('block_question');
                            $tpl->assign(array_merge(
                                array(
                                    'MSG_Question' => $this->_msg['Question'],
                                    'baseurl' => $_baseurl,
                                    'ticket_url' => $ticket_url,
                                    'domen' => $CONFIG['domen']),
                                $quest));

                            if ($quest['last_time'] != $quest['crt_time']) {
                                $tpl->newBlock('block_question_modifited');
                                $tpl->assign(array_merge(
                                    array(
                                        'MSG_Modifited' => $this->_msg['Modifited'],
                                        'baseurl' => $_baseurl,
                                        'ticket_url' => $ticket_url,
                                        'domen' => $CONFIG['domen']),
                                    $quest));
                            }
                            $this->showFiles($tpl, $files, $quest['id'], 'question');
                            $editable_question = $quest['editable'];
                            $last_question_id = $quest['id'];
                            list(,$quest) = each($ticket['questions']);
                        }
                    }
                    if ($editable_question) {
                        $tpl->newBlock('block_edit');
                        $tpl->assign(array(
                            'ticket_id' => $ticket['id'],
                            'baseurl' => $_baseurl,
                            'is_ticket' => 0,
                            'question_id' => $last_question_id,
                        ));
                    }
                }
            }
        }
        
        return $ticket;
    }

    function showHdbkList($list, $block_name)
    {
        global $tpl, $baseurl;
        if (! empty($list)) {
            $tpl->newBlock($block_name);
            $tpl->assign(Array(
                "MSG_Ed" => $this->_msg["Ed"],
                "MSG_Edit" => $this->_msg["Edit"],
                "MSG_Del" => $this->_msg["Del"],
                "MSG_Delete" => $this->_msg["Delete"],
                "MSG_Group" => $this->_msg["Group"],
                "MSG_Category" => $this->_msg["Category"],
                "MSG_Level" => $this->_msg["Level"],
                "MSG_Estimate" => $this->_msg["Estimate"],
                "MSG_Title" => $this->_msg["Title"],
                "MSG_Number" => $this->_msg["Number"],
                "MSG_Answer_time" => $this->_msg["Answer_time"],
                "MSG_Close_time" => $this->_msg["Close_time"],
                "MSG_User_group" => $this->_msg["User_group"],
                "MSG_Users" => $this->_msg["Users"],
                "MSG_User" => $this->_msg["User"],
                "MSG_Fio" => $this->_msg["Fio"],
                "MSG_Level" => $this->_msg["Level"],
                "MSG_Finish_date" => $this->_msg["Finish_date"],
                "MSG_Company" => $this->_msg["Company"],
                "MSG_Active" => $this->_msg["Active"],
                "MSG_Save" => $this->_msg["Save"],
                "baseurl" => $baseurl
            ));
            foreach ($list as $key => $val) {
                $tpl->newBlock($block_name."_row");
                $tpl->assign($val + array(
                    "baseurl" => $baseurl,
                    "MSG_Delete" => $this->_msg["Delete"],
                    "MSG_Category" => $this->_msg["Category"],
                    "MSG_Level" => $this->_msg["Level"],
                    "MSG_Estimate" => $this->_msg["Estimate"]
                ));
                if ($val['ticket_count']) {
                	$tpl->newBlock($block_name."_no_del");
                } else {
                    $tpl->newBlock($block_name."_del");
                }
                $tpl->assign($val + array(
                    "baseurl" => $baseurl,
                    "MSG_Delete" => $this->_msg["Delete"],
                    "MSG_Category" => $this->_msg["Category"],
                    "MSG_Level" => $this->_msg["Level"],
                    "MSG_Estimate" => $this->_msg["Estimate"]
                ));
            }
        }
    }

    function ShowTicketList($list, $full_count, $start_page = 1, $on_page = 0, $filter = array())
    {
        global $tpl, $CONFIG, $transurl, $baseurl, $lang;
        $ret = false;
        if (!empty($list)) {
            $ret = true;
            $_transurl = $transurl ? $transurl : $baseurl;
            $_transurl = $_transurl.(false === strpos($_transurl, "?") ? "?" : "&");
            $tpl->newBlock('block_tickets_list');
            $tpl->assign(array(
                'transurl' => $_transurl,
                'baseurl' => $baseurl,
                'finish_date' => $this->finish_date,
            ));
            foreach ($list as $val) {
                $tpl->newBlock('block_ticket');
                $tpl->assign($val + array(
                    'ticket_link' => $_transurl."action=ticket&id=".$val['id'],
                    'del_link' => $_transurl."action=delticket&id=".$val['id'],
                    'admin_user_link' => '/admin.php?lang='.$lang.'&name=siteusers&action=editsiteuser&id='.$val['user_id'],
                    'MSG_Delete' => $this->_msg['Delete'],
                ));
            }
            if ($full_count > 0) {
                $on_page = $on_page > 1 ? (int)$on_page : $CONFIG['support_max_rows'];
                $pages = ceil($full_count/$on_page);
                if ($pages > 1) {
                    $url = $transurl."action=tickets";
                    if (!empty($filter)) {
                        foreach ($filter as $key => $val) {
                            if ('count' != $key && 'start' != $key && $val) {
                                $url .= "&f[{$key}]=".$val;
                            }
                        }
                    }
                    $start_page = $start_page > 1 && $start_page <= $pages ? (int)$start_page : 1;
                    Main::_show_nav_block($pages, 'nav', $url, $start_page);
                    $tpl->assign('MSG_Pages', $this->_msg['Pages']);
                }
            }
        } else {
             $tpl->newBlock('block_tickets_empty');
             $tpl->assign(array(
                 'MSG_Show_all_tickets' => $this->_msg['Show_all_tickets'],
                 'MSG_Not_found' => $this->_msg['Not_found'],
                 'transurl' => $_transurl,
                 'baseurl' => $baseurl,
                 'finish_date' => $this->finish_date,
             ));
        }
        return $ret;
    }

    function showHdbkItem($item, $pref = '')
    {
        global $tpl;
        if (is_array($item) && !empty($item)) {
            foreach ($item as $key => $val) {
                $tpl->assign($pref.$key, $val);
            }
        }
    }

    function getFile($file_id)
    {
        global $db, $CONFIG;

        $db->query("SELECT F.*, T.user_id FROM {$this->table_prefix}_support_file AS F "
            ." INNER JOIN {$this->table_prefix}_support_ticket AS T ON F.ticket_id=T.id"
            ." WHERE F.id=".$file_id);
        $ret = false;
        if ($db->nf()) {
        	$db->next_record();
        	if ($_SESSION['session_is_admin'] || $_SESSION['siteuser']['id'] == $db->Record['user_id']) {
        	    $file_path = RP.$CONFIG['support_files_parh'].$this->table_prefix."/"
        	       .substr($db->Record['file'], 0, 3)."/".$db->Record['file'];
        	   if (! file_exists($file_path)) {
        	       header('http/1.0 404 not found');
        	   } else {
        	       header('http/1.1 200 ok');
        	       header('content-disposition: attachment; filename='.$db->Record['file_name']);
        	       header('last-modified: '.date('d, d m y h:i:s t', filemtime($file_path)));
        	       header('accept-ranges: bytes');
        	       header('content-length: '.filesize($file_path));
        	       header('content-type: application/octet-stream');
        	       echo file_get_contents($file_path);
        	   }
        	   exit;
        	}
        }

        return $ret;
    }

    function delFile($file_id)
    {
        global $db, $CONFIG;
        $file_id = (int)$file_id;
        $db->query("SELECT F.*, T.user_id FROM {$this->table_prefix}_support_file AS F "
            ." INNER JOIN {$this->table_prefix}_support_ticket AS T ON F.ticket_id=T.id"
            ." WHERE F.id=".$file_id);
        $ret = false;
        if ($db->nf()) {
        	$db->next_record();
        	if ($_SESSION['session_is_admin'] || $_SESSION['siteuser']['id'] == $db->Record['user_id']) {
        	    $dir_path = RP.$CONFIG['support_files_parh'].$this->table_prefix."/"
        	       .substr($db->Record['file'], 0, 3);
        	   if (file_exists($dir_path."/".$db->Record['file'])) {
        	       @unlink($dir_path."/".$db->Record['file']);
        	   }
        	   $files = glob($dir_path."/*", GLOB_NOSORT);
        	   if ( empty($files) ) {
        	       @rmdir($dir_path);
        	   }
        	   $db->query("DELETE FROM {$this->table_prefix}_support_file WHERE id=".$file_id);
        	   $ret = true;
        	}
        }

        return $ret;
    }

    function getTicketIdByFileId($file_id)
    {
        global $db;

    	$db->query("SELECT ticket_id FROM {$this->table_prefix}_support_file WHERE id=".intval($file_id));
    	$ret = false;
    	if ($db->next_record()) {
    		$ret = $db->Record['ticket_id'];
    	}

    	return $ret;
    }

    function updateTickets()
    {   static $updated = false;
        global $db, $db1;
        
        if (! $updated) {
            $updated = true;
            $db->query("UPDATE {$this->table_prefix}_support_ticket AS T, "
        	    .$this->table_prefix."_support_level AS L SET T.status=6 WHERE T.status=2 AND T.level_id=L.id"
        	    ." AND ( (UNIX_TIMESTAMP() - UNIX_TIMESTAMP(T.last_time)) > (L.cls_min*60))");
        	    
        	$db->query("SELECT id, level_id, UNIX_TIMESTAMP() AS now, UNIX_TIMESTAMP(last_time) AS last"
        	    ." FROM {$this->table_prefix}_support_ticket WHERE status=1 OR status=3 AND (UNIX_TIMESTAMP() - UNIX_TIMESTAMP(last_time)) > 30");
        	while ($db->next_record()) {        	    
        		$activ_time = $this->getActiveTime($db->Record['level_id'], $db->Record['last'], $db->Record['now']);
        		if ($activ_time > 0) {
        		    $db1->query("UPDATE {$this->table_prefix}_support_ticket SET last_time=NOW(), underway=underway+{$activ_time}"
        		    ." WHERE id=".$db->Record['id']);
        		}        		
        	}
        }
    }

    function getStatistic($from, $to, $manager, $user)
    {
        global $db;

        $ret = array();
        $filter = '';
        $date_filter = '';
        if ($from && $to) {
            $date_filter = " AND T.crt_time BETWEEN '".$this->formDate($from)."' AND '".$this->formDate($to)." 23:59:59'";
        } else if ($from) {
        	$date_filter =" AND T.crt_time > '".$this->formDate($from)."'";
        } else if ($to) {
        	$date_filter =" AND T.crt_time < '".$this->formDate($to)." 23:59:59'";
        }
        $filter = $date_filter;
        if ($manager >= 1) {
        	$filter .= " AND T.manager_id=".intval($manager);
        }
        if ($user >= 1) {
        	$filter .= " AND user_id=".intval($user);
        }
    	$db->query("SELECT COUNT(*) FROM {$this->table_prefix}_support_ticket T"
    	    ." WHERE 1".($filter ? $filter : ""));
    	$db->next_record();
    	$ret['tickets'] = $db->Record[0];
    	$tckt_pct = $ret['tickets']/100;

    	$db->query("SELECT COUNT(*) FROM {$this->table_prefix}_support_ticket T"
    	    ." WHERE estimate_id > 0".($filter ? $filter : ""));
    	$db->next_record();
    	$ret['estimates'] = $db->Record[0];
    	$estm_pct = $ret['estimates']/100;

    	$db->query("SELECT COUNT(*) FROM {$this->table_prefix}_support_answer T"
    	    .($user >= 1 ? " INNER JOIN {$this->table_prefix}_support_ticket ST ON T.ticket_id=ST.id" : "")
    	    ." WHERE 1".($filter ? $filter : ""));
    	$db->next_record();
    	$ret['answers'] = $db->Record[0];
    	$answ_pct = $ret['answers']/100;

    	$db->query("SELECT COUNT(*) FROM {$this->table_prefix}_support_question T"
    	    .($user >= 1 ? " INNER JOIN {$this->table_prefix}_support_ticket ST ON T.ticket_id=ST.id" : "")
    	    ." WHERE 1".($date_filter ? $date_filter : ""));
    	$db->next_record();
    	$ret['questions'] = $db->Record[0];
    	$qwst_pct = $ret['questions']/100;

    	$ret['process_0'] = 0; /* >100 */
    	$ret['process_1'] = 0; /* <=50 */
    	$ret['process_2'] = 0; /* <=100 */
    	$ret['process_all'] = 0;
    	$db->query("SELECT type, COUNT(id) AS count FROM {$this->table_prefix}_support_log T"
    	    ." WHERE 1".($filter ? $filter : "")." GROUP BY type");
    	while ($db->next_record()) {
    		$ret['process_'.$db->Record['type']] = $db->Record['count'];
    		$ret['process_all'] += $db->Record['count'];
    	}
    	$proc_pct = $ret['process_all']/100;
    	$ret['process_0_pct'] = $proc_pct ? number_format($ret['process_0']/$proc_pct, 2, '.', '') : "0";
    	$ret['process_1_pct'] = $proc_pct ? number_format($ret['process_1']/$proc_pct, 2, '.', '') : "0";
    	$ret['process_2_pct'] = $proc_pct ? number_format($ret['process_2']/$proc_pct, 2, '.', '') : "0";

    	$db->query("SELECT COUNT(*) FROM {$this->table_prefix}_support_ticket T"
    	    ." WHERE status IN (1,3)".($filter ? $filter : ""));
    	$db->next_record();
    	$ret['noprocess'] = $db->Record[0];
    	$noproc_pct = $ret['noprocess']/100;

    	$db->query("SELECT COUNT(*) FROM {$this->table_prefix}_support_ticket AS T"
    	    ." LEFT JOIN {$this->table_prefix}_support_level AS L ON T.level_id=L.id"
    	    ." WHERE IF(T.status IN (1,3), underway / ( L.answ_min * 60 ), 0) >= 0"
    	    ." AND IF(T.status IN (1,3), underway / ( L.answ_min * 60 ), 0) <= 0.5"
    	    .($filter ? $filter : ""));
    	$db->next_record();
    	$ret['noprocess_less_50'] = $db->Record[0];
    	$ret['noprocess_less_50_pct'] = $noproc_pct ? number_format($db->Record[0]/$noproc_pct, 2, '.', '') : "0";

    	$db->query("SELECT COUNT(*) FROM {$this->table_prefix}_support_ticket AS T"
    	    ." LEFT JOIN {$this->table_prefix}_support_level AS L ON T.level_id=L.id"
    	    ." WHERE IF(T.status IN (1,3), underway / ( L.answ_min * 60 ), 0) > 0.5"
    	    ." AND IF(T.status IN (1,3), underway / ( L.answ_min * 60 ), 0) <= 1"
    	    .($filter ? $filter : ""));
    	$db->next_record();
    	$ret['noprocess_less_100'] = $db->Record[0];
    	$ret['noprocess_less_100_pct'] = $noproc_pct ? number_format($db->Record[0]/$noproc_pct, 2, '.', '') : '0';

    	$db->query("SELECT COUNT(*) FROM {$this->table_prefix}_support_ticket AS T"
    	    ." LEFT JOIN {$this->table_prefix}_support_level AS L ON T.level_id=L.id"
    	    ." WHERE IF(T.status IN (1,3), underway / ( L.answ_min * 60 ), 0) > 1"
    	    .($filter ? $filter : ""));
    	$db->next_record();
    	$ret['noprocess_more_100'] = $db->Record[0];
    	$ret['noprocess_more_100_pct'] = $noproc_pct ? number_format($db->Record[0]/$noproc_pct, 2, '.', '') : '0';

    	$ret['category'] = array();
    	$db->query("SELECT C.id, C.title, COUNT(T.id) AS count FROM {$this->table_prefix}_support_category AS C"
    	    ." LEFT JOIN {$this->table_prefix}_support_ticket AS T ON C.id=T.category_id"
    	    .($filter ? $filter : "")." GROUP BY C.id");
    	while ($db->next_record()) {
    	    $ret['category'][$db->Record['id']] = array(
    	       'id' => $db->Record['id'],
    	       'title' => $db->Record['title'],
    	       'count' => $db->Record['count'],
    	       'pct' => $tckt_pct ? number_format($db->Record['count']/$tckt_pct, 2, '.', '') : '0',
    	    );
    	}

    	$ret['level'] = array();
    	$db->query("SELECT L.id, L.title, COUNT(T.id) AS count FROM {$this->table_prefix}_support_level AS L"
    	    ." LEFT JOIN {$this->table_prefix}_support_ticket AS T ON L.id=T.level_id"
    	    .($filter ? $filter : "")." GROUP BY L.id");
    	while ($db->next_record()) {
    	    $ret['level'][$db->Record['id']] = array(
    	       'id' => $db->Record['id'],
    	       'title' => $db->Record['title'],
    	       'count' => $db->Record['count'],
    	       'pct' => $tckt_pct ? number_format($db->Record['count']/$tckt_pct, 2, '.', '') : '0',
    	    );
    	}

    	$ret['estimate'] = array();
    	$db->query("SELECT E.id, E.title, COUNT(T.id) AS count FROM {$this->table_prefix}_support_estimate AS E"
    	    ." LEFT JOIN {$this->table_prefix}_support_ticket AS T ON E.id=T.estimate_id"
    	    .($filter ? $filter : "")." GROUP BY E.id");
    	while ($db->next_record()) {
    	    $ret['estimate'][$db->Record['id']] = array(
    	       'id' => $db->Record['id'],
    	       'title' => $db->Record['title'],
    	       'count' => $db->Record['count'],
    	       'pct' => $estm_pct ? number_format($db->Record['count']/$estm_pct, 2, '.', '') : '0',
    	    );
    	}

    	$ret['status'] = array();
    	$db->query("SELECT status, COUNT(id) AS count FROM {$this->table_prefix}_support_ticket T"
    	    ." WHERE 1 ".($filter ? $filter : "")." GROUP BY status");
    	foreach ($this->status_list as $key => $val) {
    	    if ($db->next_record()) {
    	        $ret['status'][$db->Record['status']] = array(
    	           'id' => $db->Record['status'],
    	           'title' => $this->status_list[$db->Record['status']],
    	           'count' => $db->Record['count'],
    	           'pct' => $tckt_pct ? number_format($db->Record['count']/$tckt_pct, 2, '.', '') : '0',
    	        );
    	    }
    	    if (!isset($ret['status'][$key])) {
    	        $ret['status'][$key] = array(
    	           'id' => $key,
    	           'title' => $this->status_list[$key],
    	           'count' => 0,
    	           'pct' => 0
    	        );
    	    }
    	}
    	return $ret;
    }

    function showStatistic($from, $to, $manager, $user)
    {
        global $tpl, $baseurl;

    	$s = $this->getStatistic($from, $to, $manager, $user);
    	$all = $s['tickets'] + $s['questions'] + $s['answers'];
        $all_pct = $all/100;
        $arr = array();
        foreach ($s['status'] as $key => $val) {
        	$arr['status'.$key] = $val['count'];
        	$arr['status'.$key."_pct"] = $val['pct'];
        }
    	$tpl->assign(array_merge($arr, array(
    	    'baseurl' => $baseurl,
    	    'MSG_Show' => $this->_msg['Show'],
    	    'MSG_Reset' => $this->_msg['Reset'],
    	    'MSG_Select' => $this->_msg['Select'],
    	    'MSG_From' => $this->_msg['From'],
    	    'MSG_To' => $this->_msg['To'],
    	    'MSG_Show_statistic' => $this->_msg['Show_statistic'],
    	    'MSG_Common_statistic' => $this->_msg['Common_statistic'],
    	    'MSG_Status_statistic' => $this->_msg['Status_statistic'],
    	    'MSG_All_tickets' => $this->_msg['All_tickets'],
    	    'MSG_Questions' => $this->_msg['Questions'],
    	    'MSG_Answers' => $this->_msg['Answers'],
    	    'MSG_Category_statistic' => $this->_msg['Category_statistic'],
    	    'MSG_Simophor_statistic' => $this->_msg['Simophor_statistic'],
    	    'MSG_No_reported_tickets' => $this->_msg['No_reported_tickets'],
    	    'MSG_Reported_tickets' => $this->_msg['Reported_tickets'],
    	    'MSG_All_no_report_tickets' => $this->_msg['All_no_report_tickets'],
    	    'MSG_All_report_tickets' => $this->_msg['All_report_tickets'],
    	    'MSG_All' => $this->_msg['All'],
    	    'MSG_No_report_less_50' => $this->_msg['No_report_less_50'],
    	    'MSG_No_report_less_100' => $this->_msg['No_report_less_100'],
    	    'MSG_Overdue' => $this->_msg['Overdue'],
    	    'MSG_Level_statistic' => $this->_msg['Level_statistic'],
    	    'MSG_Estimate_statistic' => $this->_msg['Estimate_statistic'],
    	    'MSG_Enter_period_or_manager' => $this->_msg['Enter_period_or_manager'],
    	    'MSG_Manager' => $this->_msg['Manager'],
    	    'MSG_User' => $this->_msg['User'],
    	    'MSG_Status1' => $this->_msg['Status1'],
    	    'MSG_Status2' => $this->_msg['Status2'],
    	    'MSG_Status3' => $this->_msg['Status3'],
    	    'MSG_Status4' => $this->_msg['Status4'],
    	    'MSG_Status5' => $this->_msg['Status5'],
    	    'MSG_Status6' => $this->_msg['Status6'],

    	    'f' => $from,
    	    't' => $to,
    	    'all' => $all,
    	    'tickets' => $s['tickets'],
    	    'questions' => $s['questions'],
    	    'answers' => $s['answers'],
    	    'tickets_pct' => $all? number_format($s['tickets']/$all_pct, 2, '.', '') : '0',
    	    'questions_pct' => $all ? number_format($s['questions']/$all_pct, 2, '.', '') : '0',
    	    'answers_pct' => $all ? number_format($s['answers']/$all_pct, 2, '.', '') : '0',
    	    'estimates' => $s['estimates'],
    	    'process' => $s['process_all'],
    	    'process_more_100' => $s['process_0'],
    	    'process_less_50' => $s['process_1'],
    	    'process_less_100' => $s['process_2'],
    	    'process_more_100_pct' => $s['process_0_pct'],
    	    'process_less_50_pct' => $s['process_1_pct'],
    	    'process_less_100_pct' => $s['process_2_pct'],
    	    'noprocess' => $s['noprocess'],
    	    'noprocess_less_50' => $s['noprocess_less_50'],
    	    'noprocess_less_100' => $s['noprocess_less_100'],
    	    'noprocess_more_100' => $s['noprocess_more_100'],
    	    'noprocess_less_50_pct' => $s['noprocess_less_50_pct'],
    	    'noprocess_less_100_pct' => $s['noprocess_less_100_pct'],
    	    'noprocess_more_100_pct' => $s['noprocess_more_100_pct'],
    	)));
    	foreach ($s['category'] as $key => $val) {
    		$tpl->newBlock('block_category');
    		$tpl->assign($val);
    	}
    	foreach ($s['level'] as $key => $val) {
    		$tpl->newBlock('block_level');
    		$tpl->assign($val);
    	}
    	foreach ($s['estimate'] as $key => $val) {
    		$tpl->newBlock('block_estimate');
    		$tpl->assign($val);
    	}
    }

    function delTicket($id)
    {
    	global $db, $CONFIG;
    	$ret = false;
    	if ($_SESSION['session_is_admin']) {
    	    $id = (array) $id;
        	$id = array_map('intval', $id);
        	$id = implode(",", $id);
    	    $db->query("DELETE FROM {$this->table_prefix}_support_ticket WHERE id IN ({$id})");
    	    if ($db->affected_rows()) {
        		$db->query("DELETE FROM {$this->table_prefix}_support_answer WHERE ticket_id IN ({$id})");
        		$db->query("DELETE FROM {$this->table_prefix}_support_question WHERE ticket_id IN ({$id})");
        		$db->query("SELECT file FROM {$this->table_prefix}_support_file WHERE ticket_id IN ({$id})");
        		while ($db->next_record()) {
        			if ($db->Record['file']) {
        			    $dir_name = RP.$CONFIG['support_files_parh'].$this->table_prefix."/".substr($db->Record['file'], 0, 3);
        			    if (file_exists($dir_name."/".$db->Record['file'])) {
        			    	@unlink($dir_name."/".$db->Record['file']);
        			    }
        			}
        		}
        		$db->query("DELETE FROM {$this->table_prefix}_support_file WHERE ticket_id IN ({$id})");
        		$db->query("DELETE FROM {$this->table_prefix}_support_log WHERE ticket_id IN ({$id})");
        		$ret = true;
    	    }
    	}

    	return $ret;
    }

    function getTicketGroupsIds()
    {
    	global $db;
    	static $ret = array();
    	if (empty($ret)) {
    		$db->query("SELECT id, group_id FROM {$this->table_prefix}_support_level");
        	while ($db->next_record()) {
        		$ret[$db->Record['id']] = $db->Record['group_id'];
        	}
    	}
    	return $ret;
    }

    function setFinishDate($date)
    {
    	global $db;

    	$ret = false;
    	if (is_array($date) && !empty($date)) {
    		$ids = array_keys($date);
    		$ids = array_map("intval", $ids);
    		$db->query("SELECT id FROM core_users WHERE id IN ("
    		    .implode(",", $ids).")");
    		if ($db->nf()) {
    		    $insert = array();
    			while ($db->next_record()) {
    			    if ($date[$db->Record['id']]) {
    			    	$insert[] = "({$db->Record['id']}, '{$this->formDate($date[$db->Record['id']])}')";
    			    }
    			}
    			if (!empty($insert)) {
    				$db->query("REPLACE INTO {$this->table_prefix}_support_user (user_id, finish_date) VALUES "
    				    .implode(", ", $insert));
    				$ret = true;
    			}
    		}
    	}
    	return $ret;
    }

    function notifyUser($ticket_id)
    {
        global $CONFIG;

    	$ticket = $this->getTicket($ticket_id);
    	if ($ticket && $ticket['notify']) {
    		$tpl = new AboTemplate(RP.'tpl/'.SITE_PREFIX.'/support_notify.html');
    		$tpl->prepare();
    		$this->showTicket($tpl, $ticket_id);
    		require_once(RP.'inc/class.Mailer.php');

    		$mail = new Mailer();
    		$mail->CharSet		= $CONFIG['email_charset'];
    		$mail->ContentType	= $CONFIG['support_email_type'];
    		$mail->From			= $CONFIG['return_email'];
    		$mail->FromName		= $CONFIG['sitename_rus'];
    		$mail->AddAddress($ticket['user_email']);
    		$mail->Subject		= $CONFIG['support_email_subj'];
    		$mail->Body			= $tpl->getOutputContent();
    		$mail->Send();
    	}
    }

    function formDate($date)
    {
    	$date = explode("-", $date);
    	return $date[2].'-'.$date[1].'-'.$date[0];
    }
    
    function setUserNotes($data)
    {   global $db;
        
        $data['notes'] = My_Sql::escape(htmlspecialchars($data['notes']));
        $ret = false;
        if ($data['user_id'] > 0) {
            $db->query("UPDATE {$this->table_prefix}_support_user SET notes='"
                .$data['notes']."' WHERE user_id=".intval($data['user_id']));
            $ret = (boolean) $db->affected_rows();
        }
    	return $ret;
    }
    
    function toTime($hour, $min)
    {
    	$hour = intval('0' == substr($hour, 0, 1) ? substr($hour, 1) : $hour);
    	$hour = $hour < 0 || $hour > 24 ? 0 : $hour;
    	$min = intval('0' == substr($min, 0, 1) ? substr($min, 1) : $min);
    	$min = $min < 0 || $min > 60 ? 0 : $min;
    	
    	return ($hour < 10 ? '0'.$hour : $hour).":".($min < 10 ? '0'.$min : $min);
    }
    
    function time2Float($str_time)
    {
        if ('0' == substr($str_time, 0, 1)) {
            $str_time = substr($str_time, 1);
        }
    	return floatval(str_replace(":", ".", $str_time));
    }
    
    function time2Sec($hour, $min, $sec)
    {
    	return $sec + 60*$min + 3600*$hour;
    }
    
    function strTime2Arr($time, $delim = ":")
    {
        $ret = explode($delim, $time);
    	return array(
    	   'h' => intval('0' == substr($ret[0], 0, 1) ? substr($ret[0], 1) : $ret[0]),
    	   'm' => intval('0' == substr($ret[1], 0, 1) ? substr($ret[1], 1) : $ret[1]),
    	   's' => intval('0' == substr($ret[2], 0, 1) ? substr($ret[2], 1) : $ret[2])
    	);
    }
    
    function getLevelSchedule($level_id)
    {   global $db;
    
        $ret = false;
        $db->query("SELECT * FROM {$this->table_prefix}_support_level_schedule WHERE level_id="
            .intval($level_id)." ORDER BY day");
        while ($db->next_record()) {
        	$ret[] = array(
        	    'level_id' => $db->Record['level_id'],
        	    'day' => $db->Record['day'],
        	    'type' => $db->Record['type'],
        	    'open_from' => $db->Record['open_from'],
        	    'open_to' => $db->Record['open_to'],
        	    'break_from' => $db->Record['break_from'],
        	    'break_to' => $db->Record['break_to'],
        	);
        }
    	
        return $ret;
    }
    
    function getLevelsSchedules()
    {   global $db1;
    
        $ret = false;
        $db1->query("SELECT * FROM {$this->table_prefix}_support_level_schedule ORDER BY level_id, day");

        while ($db1->next_record()) {
        	$ret[$db1->Record['level_id']][$db1->Record['day']] = array(
        	    'level_id' => $db1->Record['level_id'],
        	    'day' => $db1->Record['day'],
        	    'type' => $db1->Record['type'],
        	    'open_from' => $db1->Record['open_from'],
        	    'open_to' => $db1->Record['open_to'],
        	    'break_from' => $db1->Record['break_from'],
        	    'break_to' => $db1->Record['break_to'],
        	);
        }
        return $ret;
    }
    
    function getActiveTime($level, $start_time, $finish_time)
    {   static $schedules = false, $iter = 0, $ret = 0;
    
        if (0 == $iter) {
            $ret = 0;
        }
        if (!$schedules) {
            $schedules = $this->getLevelsSchedules();
        }
    	if ($sched = $schedules[$level]) {
    	    $start = explode(',', date('Y,n,j,z,w,G,i,s', $start_time));
    	    $start = array(
    	       'y' => $start[0],
    	       'n' => $start[1],
    	       'd' => $start[2],
    	       'z' => $start[3], /* 0 - 365 */
    	       'w' => 0 == $start[4] ? 7 : $start[4] , /* 1 - пн, .. 7 - вс */
    	       'h' => $start[5],
    	       'm' => intval('0' == substr($start[6], 0, 1) ? substr($start[6], 1) : $start[6]),
    	       's' => intval('0' == substr($start[7], 0, 1) ? substr($start[7], 1) : $start[7]),
    	    );
    	    $finish = explode(',', date('Y,n,j,z,w,G,i,s', $finish_time));
    	    $finish = array(
    	       'y' => $finish[0],
    	       'n' => $finish[1],
    	       'd' => $finish[2],
    	       'z' => $finish[3], /* 0 - 365 */
    	       'w' => 0 == $finish[4] ? 7 : $finish[4] , /* 1 - пн, .. 7 - вс */
    	       'h' => $finish[5],
    	       'm' => intval('0' == substr($finish[6], 0, 1) ? substr($finish[6], 1) : $finish[6]),
    	       's' => intval('0' == substr($finish[7], 0, 1) ? substr($finish[7], 1) : $finish[7]),
    	    );
    	    if ($start['y'] == $finish['y'] && $start['z'] == $finish['z']) {
    	        $ret += $this->getActiveTimeForDay(
    	            $sched[$start['w']],
    	            array('h' => $start['h'], 'm' => $start['m'], 's'=> $start['s']),
    	            array('h' => $finish['h'], 'm' => $finish['m'], 's'=> $finish['s'])
    	        );
    	    } else {
    	        $ret += $this->getActiveTimeForDay(
    	            $sched[$start['w']],
    	            array('h' => $start['h'], 'm' => $start['m'], 's'=> $start['s']),
    	            array('h' => 24, 'm' => 0, 's'=> 0)
    	        );
    	        $start_time = mktime(0, 0, 0, $start['n'], $start['d']+1, $start['y']);
    	        $iter++;
    	        $this->getActiveTime($level, $start_time, $finish_time);
    	        $iter--;
    	    }
    	        	    
    	    return $ret;
    	}
    	
    }
    
    /**
     * Enter description here...
     *
     * @param array $time_work
     * @param array $start_time - array('h' =>.., 'm' =>.., 's'=>..)
     * @param array $finish_time - array('h' =>.., 'm' =>.., 's'=>..)
     */
    function getActiveTimeForDay($time_work, $start_time, $finish_time)
    {
        $ret = 0;
        if (24 == $time_work['type']) {
            $ret = $this->time2Sec($finish_time['h'], $finish_time['m'], $finish_time['s'])
                - $this->time2Sec($start_time['h'], $start_time['m'], $start_time['s']);
        } else if (1 == $time_work['type']) {
            $start = $this->time2Sec($start_time['h'], $start_time['m'], $start_time['s']);
            $finish = $this->time2Sec($finish_time['h'], $finish_time['m'], $finish_time['s']);
            
            $open_from = $this->strTime2Arr($time_work['open_from']);
            $open_from = $this->time2Sec($open_from['h'], $open_from['m'], $open_from['s']);            
            
            $open_to = $this->strTime2Arr($time_work['open_to']);
            $open_to = $this->time2Sec($open_to['h'], $open_to['m'], $open_to['s']);
            
            $break_from = $this->strTime2Arr($time_work['break_from']);
            $break_from = $this->time2Sec($break_from['h'], $break_from['m'], $break_from['s']);
            
            $break_to = $this->strTime2Arr($time_work['break_to']);
            $break_to = $this->time2Sec($break_to['h'], $break_to['m'], $break_to['s']);
            
            if ($start < $open_from) {
                $start = $open_from;
            }
            if ($finish > $open_to) {
                $finish = $open_to;
            }
            if ( $break_from && $break_to) {
                $ret = 0;
                if ( ($start < $break_from && $finish < $break_from)
                    || ($start > $break_to && $finish > $break_to)
                ) {
                    $ret = $finish - $start;
                }
                if ($start < $break_from && $finish > $break_from) {
                    $ret += $break_from - $start;
                }
                if ($start < $break_to && $finish > $break_to) {
                    $ret += $finish - $break_to;
                }
            } else {
                $ret = $finish - $start;
            }
        }
        return $ret;
    }
    
    function sec2Time($sec, $delim = ":")
    {
    	$hour = floor($sec/3600);
        $min = floor(($sec - ($hour*3600))/60);
        $sec = $sec - ($hour*3600) - ($min*60);
        return "{$hour}{$delim}{$min}{$delim}{$sec}";
    }

    function setTicketTxt($ticket_id, $txt)
    {   global $db;
    
        $ticket_id = (int) $ticket_id;
        $txt = My_Sql::escape(htmlspecialchars($txt));
        $db->query("UPDATE {$this->table_prefix}_support_ticket SET txt='{$txt}', "
            ."last_time=NOW(), upd_time=NOW() WHERE id="
            .$ticket_id." AND editable=1 AND user_id=".intval($_SESSION["siteuser"]["id"]));

        return $db->affected_rows() ? true : false;
    }

    function setQuestionTxt($question_id, $txt)
    {   global $db;
    
        $question_id = (int) $question_id;
        $question = $this->getQuestion($question_id);
        $ticket = $this->getTicket(intval($question['ticket_id']));
        $txt = My_Sql::escape(htmlspecialchars($txt));
        $ret = false;
        if ($ticket && $ticket['user_id'] == $_SESSION["siteuser"]["id"]) {
            $db->query("UPDATE {$this->table_prefix}_support_question SET txt='{$txt}', "
            ."last_time=NOW(), upd_time=NOW() WHERE id=".$question_id." AND editable=1");
            $ret = $db->affected_rows() ? true : false;
        }        

        return $ret;
    }

    function setAnswerTxt($answer_id, $txt)
    {   global $db;
    
        $answer_id = (int) $answer_id;
        $txt = My_Sql::escape(htmlspecialchars($txt));
        $db->query("UPDATE {$this->table_prefix}_support_answer SET txt='{$txt}', "
            ."last_time=NOW() WHERE id=".$answer_id." AND manager_id=".intval($_SESSION["siteuser"]["id"]));
        return $db->affected_rows() ? true : false;
    }
}
?>