<?php

$MOD_TABLES[] = "CREATE TABLE `".$prefix."_support_category` (
  `id` INT UNSIGNED NOT NULL AUTO_INCREMENT,
  `title` VARCHAR(255) NOT NULL DEFAULT '',
  `number` TINYINT NOT NULL DEFAULT 0,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM";

$MOD_TABLES[] = "CREATE TABLE `".$prefix."_support_estimate` (
  `id` INT UNSIGNED NOT NULL AUTO_INCREMENT,
  `title` VARCHAR(255) NOT NULL DEFAULT '',
  `number` TINYINT NOT NULL DEFAULT 0,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM";

$MOD_TABLES[] = "CREATE TABLE `".$prefix."_support_level` (
  `id` INT UNSIGNED NOT NULL AUTO_INCREMENT,
  `title` VARCHAR(255) NOT NULL DEFAULT '',
  `answ_min` SMALLINT UNSIGNED NOT NULL DEFAULT 0,
  `cls_min` SMALLINT UNSIGNED NOT NULL DEFAULT 0,
  `number` TINYINT NOT NULL DEFAULT 0,
  `group_id` INT UNSIGNED NOT NULL DEFAULT 0,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM";

$MOD_TABLES[] = "CREATE TABLE `".$prefix."_support_level_schedule` (
  `level_id` INT UNSIGNED NOT NULL DEFAULT 0,
  day ENUM('1','2','3','4','5','6','7'),
  `type` ENUM('0','1','24'),  
  open_from TIME,
  open_to TIME,
  break_from TIME,
  break_to TIME,
  PRIMARY KEY (`level_id`, day)
) ENGINE=MyISAM";

$MOD_TABLES[] = "CREATE TABLE `".$prefix."_support_ticket` (
  `id` INT UNSIGNED NOT NULL AUTO_INCREMENT,
  `category_id` INT UNSIGNED NOT NULL DEFAULT 0,
  `level_id` INT UNSIGNED NOT NULL DEFAULT 0,
  `estimate_id` INT UNSIGNED NOT NULL DEFAULT 0,
  `title` VARCHAR(255) NOT NULL DEFAULT '',
  `txt` TEXT NOT NULL DEFAULT '',
  `status` TINYINT UNSIGNED NOT NULL DEFAULT 0,
  `editable` TINYINT UNSIGNED NOT NULL DEFAULT 0,
  `last_time` DATETIME NOT NULL,
  `crt_time` DATETIME NOT NULL,
  `upd_time` DATETIME NOT NULL,
  `user_id` INT UNSIGNED NOT NULL DEFAULT 0,
  `manager_id` INT UNSIGNED NOT NULL DEFAULT 0,
  `notify` TINYINT(1) UNSIGNED NOT NULL DEFAULT 0,
  `underway` INT UNSIGNED NOT NULL DEFAULT 0,
  PRIMARY KEY  (`id`),
  KEY (`category_id`),
  KEY (`level_id`),
  KEY (`estimate_id`),
  KEY (`user_id`),
  KEY (`crt_time`, `last_time`)
) ENGINE=MyISAM";

$MOD_TABLES[] = "CREATE TABLE `".$prefix."_support_answer` (
  `id` INT UNSIGNED NOT NULL AUTO_INCREMENT,
  `ticket_id` INT UNSIGNED NOT NULL DEFAULT 0,
  `txt` TEXT NOT NULL DEFAULT '',
  `last_time` DATETIME NOT NULL,
  `crt_time` DATETIME NOT NULL,
  `manager_id` INT UNSIGNED NOT NULL DEFAULT 0,
  PRIMARY KEY (`id`),
  KEY (`ticket_id`),
  KEY (`manager_id`)
) ENGINE=MyISAM";

$MOD_TABLES[] = "CREATE TABLE `".$prefix."_support_question` (
  `id` INT UNSIGNED NOT NULL AUTO_INCREMENT,
  `ticket_id` INT UNSIGNED NOT NULL DEFAULT 0,
  `txt` TEXT NOT NULL DEFAULT '',
  `editable` TINYINT UNSIGNED NOT NULL DEFAULT 0,
  `last_time` DATETIME NOT NULL,
  `crt_time` DATETIME NOT NULL,
  `upd_time` DATETIME NOT NULL,
  PRIMARY KEY  (`id`),
  KEY (`ticket_id`)
) ENGINE=MyISAM";

$MOD_TABLES[] = "CREATE TABLE `".$prefix."_support_file` (
  `id` INT UNSIGNED NOT NULL AUTO_INCREMENT,
  `ticket_id` INT UNSIGNED NOT NULL DEFAULT 0,
  `question_id` INT UNSIGNED NOT NULL DEFAULT 0,
  `answer_id` INT UNSIGNED NOT NULL DEFAULT 0,
  `file` VARCHAR(33) NOT NULL DEFAULT '',
  `file_name` VARCHAR(127) NOT NULL DEFAULT '',
  PRIMARY KEY  (`id`),
  KEY (`ticket_id`),
  KEY (`question_id`),
  KEY (`answer_id`)
) ENGINE=MyISAM";

$MOD_TABLES[] = "CREATE TABLE `".$prefix."_support_user` (
  `user_id` INT UNSIGNED NOT NULL,
  `finish_date` DATE NOT NULL,
  `notes` TEXT NOT NULL DEFAULT '',
  PRIMARY KEY  (`user_id`),
  KEY (`finish_date`)
) ENGINE=MyISAM";

$MOD_TABLES[] = "CREATE TABLE `".$prefix."_support_log` (
  `id` INT UNSIGNED NOT NULL AUTO_INCREMENT,
  `ticket_id` INT UNSIGNED NOT NULL DEFAULT 0,
  `type` TINYINT(1) UNSIGNED NOT NULL DEFAULT 0,
  `crt_time` DATETIME NOT NULL,
  `manager_id` INT UNSIGNED NOT NULL DEFAULT 0,
  `user_id` INT UNSIGNED NOT NULL DEFAULT 0,
  PRIMARY KEY  (`id`),
  KEY (`type`),
  KEY (`crt_time`),
  KEY (`manager_id`),
  KEY (`user_id`)
) ENGINE=MyISAM";
?>