<?php
require_once(RP.'inc/class.NsDbTree.php');
require_once(RP.'inc/class.TreeMenu.php');
require_once(RP.'mod/maps/lib/class.mapsDB.php');
class MapsPrototype extends Module {
    var $main_title;												// переопределяет title страницы, если модуль главный
    var $table_prefix;
    var $tpl_path			= 'mod/maps/tpl/';
    var $module_name		= 'maps';
    var $_msg				= array();
    var $block_module_actions		= array();
    var $block_main_module_actions	= array();
    var $default_action				= 'assortment';					// действие, выполняемое модулем по умолчанию
    var $admin_default_action		= 'assortment';
    var $addition_to_path	= array();								// добавляет к пути страницы строку, если модуль главный
    var $CDBT_fields		= array(
        'left'	=> 'cleft',
        'right'	=> 'cright',
        'level'	=> 'clevel',
	   'parent_id' => 'parent_id'
    );
    var $product_properties	= array();
    var $product_images		= array(
        array('title' => 'Big picture', 'field_name'	=> 'big_image', 'resize' => 0),
        array('title' => 'Small picture', 'field_name'	=> 'small_image', 'resize' => 0)
    );
    var $category_images	= array(
        array('title' => 'Big picture', 'field_name'	=> 'big_image', 'resize' => 0),
        array('title' => 'Small picture', 'field_name'	=> 'small_image', 'resize' => 0)
    );
    var $image_formats = array(
        'image/jpeg'	=> 'jpg',
        'image/jpg'		=> 'jpg',
        'image/pjpeg'	=> 'jpg',
        'image/gif'		=> 'gif',
        'image/x-png'	=> 'png',
        'image/png'		=> 'png',
        'message/rfc822'=> 'mht',
    );
    var $data_charset			 = 'utf-8'; // cp1251, koi8-r, iso-8859-1, utf-8
    var $default_zoom = 10;
    static $sWasShowItem = false;
    var $action_tpl = array(
	    'shwprd' => 'maps_product.html',
	    'assortment' => 'maps_products.html',
	    'list' => 'maps_list.html',
	);
    function MapsPrototype($action = '', $transurl = '?', $properties = array(), $prefix = NULL, $rewrite_mod_params = NULL, $adminurl = NULL, $noadmin = false) {
        GLOBAL	$main, $tpl, $tpl_path, $baseurl, $cache, $lc, $CONFIG, $PAGE, $core, $server, $lang, $request_clearcmplist, $permissions, $request_type, $_RESULT, $db;
        $this->transReplace($transurl);
        
        /* Get $action, $tpl_name, $permissions */
        extract( $this->init(array(
                'server' => $server, 'lang' => $lang, 'prefix' => $prefix,
                'action' => $action, 'tpl_name' => $properties['tpl']
        )), EXTR_OVERWRITE);
        
        $CONFIG['maps_img_path'] = str_replace('{SITE_PREFIX}', $this->table_prefix, $CONFIG['maps_img_path']);
        $CONFIG['maps_ptype_img_path'] = str_replace('{SITE_PREFIX}', $this->table_prefix, $CONFIG['maps_ptype_img_path']);
        $CONFIG['maps_ctg_img_path'] = str_replace('{SITE_PREFIX}', $this->table_prefix, $CONFIG['maps_ctg_img_path']);
        $CONFIG['maps_metro_img_path'] = str_replace('{SITE_PREFIX}', $this->table_prefix, $CONFIG['maps_metro_img_path']);
        
        // действия, которые пользователь имеет возможность задать для блока с данным модулем
        $this->block_module_actions	= array(
            'showtree'		=> $this->_msg["Show_maps_tree"],
            'showsearchform'=> $this->_msg["Show_search_form"],
            'showtoplevels'	=> $this->_msg["Show_top_levels"],
            'showmap'    	=> $this->_msg["Show_map"],
            'list'    	=> 'Показать список пунктов',
        );
        // если поле блока ЯВЛЯЕТСЯ полем главного модуля:
        $this->block_main_module_actions = array(
                'assortment'	=> $this->_msg["Show_maps_ctg"],
                'showtree'		=> $this->_msg["Show_maps_tree"],
                'showsearchform'=> $this->_msg["Show_search_form"],
                'showtoplevels'	=> $this->_msg["Show_top_levels"],
                'showmap'    	=> $this->_msg["Show_map"],
                'shwprd'    	=> $this->_msg["Show_item"],
                'list'    	=> 'Показать список пунктов',
        );
        $CDBT = new NsDbTree($this->table_prefix.'_maps_categories', 'id', $this->CDBT_fields);
        $max_rows = (int)$properties[1];											// показывать товаров на странице
        
        if ('only_create_object' == $action) {
            return;
        }                
        
        if (! self::is_admin()) {
            if($PAGE['dop_params'] && $PAGE['field']==0){
                if ($PAGE['dop_params'][2] && false!=($ID = $this->goodExists($PAGE['dop_params'][1],$PAGE['dop_params'][2],'good'))) {
                    $action = 'shwprd';
                    $GLOBALS['request_id'] = (int) $ID;
                    $PAGE['process_params'] = true;
                } elseif ($PAGE['dop_params'][1] && false!=($ID = $this->goodExists($PAGE['dop_params'][1],null,'ctg'))){
                    $action = 'assortment';
                    $GLOBALS['request_id'] = (int) $ID;
                    $PAGE['process_params'] = true;
                }		        
            }
            if ('mob' == $lang && ! $CONFIG['maps_geo_off'] && !$GLOBALS['request_id'] && in_array($action, array('assortment', 'list', 'metro'))) {
                $l = $this->getTree();
                /*
                if ($_SESSION['rates_region_title']) {
                    $city = abo_strtolower(preg_replace('/[\-\s]/', '', $_SESSION['rates_region_title']));
                    foreach ($l as $val) {
                        //echo $val['title']." == ".$city."<br>";
                        if (abo_strtolower(preg_replace('/[\-\s]/', '', $val['title'])) == $city) {
                            $GLOBALS['request_id'] = $val['id'];
                        }
                    }
                }
                */
                if (!$GLOBALS['request_id'] && $CONFIG['mod_geo_region_name']) {
                    $city = abo_strtolower(preg_replace('/[\-\s]/', '', $CONFIG['mod_geo_region_name']));
                    foreach ($l as $val) {
                        //echo $val['title']." == ".$city."<br>";
                        if (abo_strtolower(preg_replace('/[\-\s]/', '', $val['title'])) == $city) {
                            $GLOBALS['request_id'] = $val['id'];
                        }
                    }
                }                
            }
            if ($this->actionExists($action)) {
                $this->doAction($action);
                return;
            }
            //---------------------------------- обработка действий с сайта --------------------------------//
            switch ($action) {
                case 'showsearchform':
                    global $db, $request_action, $request_id, $request_sdata;
                    $request_id = (int) $request_id;
                    $main->include_main_blocks($this->module_name.'_searchform.html', 'main');
                    $tpl->prepare();
                    $prods = $this->getSearchProds( array(), 0, 0);
                    $nav_str = $prods["nav_str"];
                    unset($prods["nav_str"]);
                    $tpl->assign(array(
                        'transurl' => $transurl,
                        'form_action' => $transurl."&action=searchresult",
                        'action' => 'searchresult',
                        'pname'	=> trim($request_sdata["pname"]),
                        //'json_prod_list' => str_replace('\"', '\\\\"', json_encode($prods)),
                        'json_prod_list' => json_encode($prods),
                        'json_ptype_list' => json_encode($this->get_ptypes()),
                        'main_map_lat' => $CONFIG['maps_map_lat'],
                        'main_map_lng' => $CONFIG['maps_map_lng'],
                        'main_map_zoom' => $CONFIG['maps_map_zoom'],
                    ));
                    $this->show_ptypes(intval($request_sdata["ptype_id"]));
                    $categs = $this->getSubCategsForRootCateg('all');
                    $this->showCtgList($categs, $request_sdata["category"]);
                    break;
                    
                case "searchresult":
                    global $request_sdata, $request_start;
                    $main->include_main_blocks($this->module_name.'_products.html', 'main');
                    $tpl->prepare();
                    $prods = $this->getSearchProds($request_sdata, $CONFIG['maps_max_rows'], $request_start);
                    $nav_str = $prods["nav_str"];
                    unset($prods["nav_str"]);
                    $this->showProdList($prods);
                    if (is_array($prods) && !empty($prods)) {
                        $tpl->gotoBlock('block_products');
                        $tpl->assign(array(
                            //'json_prod_list' => str_replace('\"', '\\\\"', json_encode($prods))
                            'json_prod_list' => json_encode($prods),
                            'json_ptype_list' => json_encode($this->get_ptypes())
                        ));
                        if ($request_sdata['category']) {
                            $categ = $this->getCategory($request_sdata['category']);
                            $tpl->assign(array(
                                'categ_title' => $categ['title'],
                                'categ_id' => $request_id,
                                'categ_descr' => $categ['description'],
                                'baseurl' => $baseurl,
                                'cnt_compare_prod'	=> sizeof($_SESSION["compare_prod"]),
                                'categ_lat'	=> $categ['lat'],
                                'categ_lng'	=> $categ['lng'],
                                'categ_zoom'	=> $categ['zoom'],
                            ));
                        }
                        $tpl->assign(array(
                            //'json_prod_list' => str_replace('\"', '\\\\"', json_encode($prods)),
                            'json_prod_list' => json_encode($prods),
                            'json_ptype_list' => json_encode($this->get_ptypes()),
                            'main_map_lat' => $categ['lat'] && $categ['lng'] ? $categ['lat'] : $CONFIG['maps_map_lat'],
                            'main_map_lng' => $categ['lat'] && $categ['lng'] ? $categ['lng'] : $CONFIG['maps_map_lng'],
                            'main_map_zoom' => $categ['zoom'] ? $categ['zoom']  : $CONFIG['maps_map_zoom'],
                            'ptype_id' => isset($request_sdata['ptype_id']) ? (int)$request_sdata['ptype_id'] : 0,
                            'categ_title' => $categ['title'],
                            'categ_id' => $request_id,
                            'categ_descr' => $categ['description'],
                            'baseurl' => $baseurl,
                            'cnt_compare_prod'	=> sizeof($_SESSION["compare_prod"]),
                        ));
                        $main->_show_nav_string(
                        $nav_str['tables'],
                        ' AND '.$nav_str['where'],
                        'nav',
                        'action='.$action.$nav_str['search_params'],
                        $request_start, $CONFIG['maps_max_rows'],
                        '', '', 0, 0, $nav_str
                        );
                    } elseif(empty($categs)) {
                        $tpl->newBlock('block_products_absent');
                        $tpl->assign(array(
                            'absent_link' => $baseurl
                        ));
                    }
                    $this->main_title = $this->_msg["Search_results"];
                    break;

                case 'list':
                case 'assortment':
                    GLOBAL $request_id, $request_parent, $request_start, $request_type;
                    $max_rows	= $max_rows ? $max_rows : $CONFIG['maps_max_rows'];
                    $request_id	= (int)$request_id ? (int)$request_id	: $properties[2];
                    
                    $main->include_main_blocks($tpl_name, 'main');
                    $tpl->prepare();
                    $assign = array(
                        'baseurl' => $baseurl,
                        'transurl' => $transurl,
                        'action' => $action,
                        'ctgr_id' => $request_id
                    );
                    
                    $tpl->assign($assign);
                    
                    $filter = array('transurl' => $transurl);
                    if ($properties[4]) {
                        $filter['ptype'] = $properties[4];
                    }
                    if ($properties[3]) {
                        $filter['service'] = (array)$properties[3];
                    }
                    /*
                    $this->get_nav_path($request_id, $baseurl);
                    */                                        
                    $categ = $this->getCategory($request_id);
                    if($categ){
                        $tpl->assign(array(
                            'parent_title' => $categ['title'],
                            'parent_descr' => $categ['description'],
                            'baseurl' => $baseurl,
                            'transurl' => $transurl,
                            'action' => $action
                        ));
                        if ($categ['img'] && file_exists(RP.$CONFIG['maps_ctg_img_path'].$categ['img'])) {
                            $tpl->newBlock('ctgr_img');
                            $tpl->assign(array(
                                'path' => '/'.$CONFIG['maps_ctg_img_path'].$categ['img'],
                                'path_big' => '/'.$CONFIG['maps_ctg_img_path'].$categ['img_big'],
                            ));
                        }
                        //$PAGE['title'] = $categ["title"];
                    }
                    if ($categ["page_description"]) {
                        $PAGE['description'] = strip_tags($categ["page_description"]);
                    }
                    if ($categ["keywords"]) {
                        $PAGE['keywords'] = strip_tags($categ["keywords"]);
                    }
                    
                    $this->show_ptypes($request_type ? $request_type : 'first');
                    if ($categ['metro_id']) {
                        $tpl->newBlock('metro');
                        $tpl->assign($assign);
                        $tpl->newBlock('metro_list');
                    }
                    $categs = $this->getTree();
                    foreach ($categs as $item) {
                        $tpl->newBlock('level_'.$item['clevel']);
                        $tpl->assign($item + $assign + array(
                            'selected' => $item['id'] == $categ['id'] ? 'selected' : ''
                        ));
                    }
                    
                    $categs = $this->getSubCategsForRootCateg($request_id);
                    $this->showCtgList($categs);
                    if (!$request_start) $request_start = 1;
                    
                    $prods = $this->getProdsOfSubCategs($request_id, $max_rows, $request_start, $filter);
                    $this->showProdList($prods);
                    if (is_array($prods) && !empty($prods)) {
                        $tpl->gotoBlock('block_products');
                        $tpl->assign(array(
                            'categ_title' => $categ['title'],
                            'categ_id' => $request_id,
                            'categ_descr' => $categ['description'],
                            'ptype' => $filter['ptype'] ? intval($filter['ptype']) : 0,
                            'baseurl' => $baseurl,
                            'cnt_compare_prod'	=> sizeof($_SESSION["compare_prod"]),
                            'json_prod_list' => $prods ? json_encode($prods) : "[]",
                            'json_ptype_list' => json_encode($this->get_ptypes()),
                            'main_map_lat' => $categ['lat'] && $categ['lng'] ? $categ['lat'] : $CONFIG['maps_map_lat'],
                            'main_map_lng' => $categ['lat'] && $categ['lng'] ? $categ['lng'] : $CONFIG['maps_map_lng'],
                            'main_map_zoom' => $categ['zoom'] ? $categ['zoom'] : $CONFIG['maps_map_zoom']
                        ));                        
                        $main->_show_nav_string(
                            $this->table_prefix.'_maps_products',
                            ' AND active = 1'.($categ ? ' AND category_id='.$categ['id'] : ''),
                            'nav',
                            'action='.$action.($categ ? '&id='.$request_id : ''),
                            $request_start,
                            $max_rows,
                            '',
                            '',
                            0,
                            0);                       
                    } elseif(empty($categs)) {
                        $tpl->newBlock('block_products_absent');
                    }
                    $tpl->gotoBlock('_ROOT');
                    if ($categ['metro_id'] && $metro = $this->getMetro($categ['metro_id'])) {
                        $tpl->newBlock('metro_content');
                        $tpl->assign(array(
                            'file_path' => $metro['file_path'],
                            'file_height' => $metro['file_height'],
                            'file_width' => $metro['file_width'],
                        ));
                        $inf = $this->getMetroInfo($categ['metro_id']);
                        //print_r($inf);
                        foreach ($inf as $key => $val) {
                            $tpl->newBlock('block_metro');
                        	if ($val['prod']) {
                        	    $tpl->newBlock('metro_list_item');
                        	    $tpl->assign(array(
                        	        'id' => $val['id'],
                        	        'station' => $val['station'],
                        	    ));
                           	    $tpl->newBlock('block_metro_active');
                           	    $cntnt = preg_replace("/<span/i", '<span class="metro-'.$val['id'].'-active metro-dynamic"', $val['active_content'])
                       	            .preg_replace("/<span/i", '<span class="metro-'.$val['id'].' metro-dynamic metro-passive hide"', $val['content']);
                           	} else {
                           	    $tpl->newBlock('block_metro_pasive');
                           	    $cntnt = preg_replace("/<span/i", '<span class="metro-'.$val['id'].'"', $val['content']);
                           	}
                           	unset($inf[$key]['active_content']);
                            unset($inf[$key]['content']);
                           	$cntnt = preg_replace('/{metro_id}/', $val['id'], $cntnt);                    	
                           	$tpl->assign('content', $cntnt);
                        }
                        $tpl->assign('block_products.json_metro_inf', json_encode($inf));
                    } else {
                        $tpl->assign('block_products.json_metro_inf', '{}');
                    }
                    
                    if ($categ) {
                        //$this->main_title = $categ['ctg_name'];
                    }
                    break;
                    
                case "shwprd":
                    global $request_id, $request_prd_id, $request_ptp, $request_image_id, $request_print;
                    $main->include_main_blocks($this->module_name."_product.html", "main");
                    $tpl->prepare();
                    $prod = $this->getProduct($request_id);
                    
                    $assign = array(
                        'baseurl' => $baseurl,
                        'transurl' => $transurl,
                        'action' => $action,
                        'ctgr_id' => $prod[0]['category_id']
                    );
                    
                    $tpl->assign($assign);
                    
                    self::$sWasShowItem = true;
                    if ($prod[0]["description"]) {
                        $PAGE['description'] = $prod[0]["description"];
                    } elseif ($prod[0]["ctg_description"]) {
                        $PAGE['description'] = strip_tags($prod[0]["ctg_description"]);
                    }
                    if ($prod[0]["keywords"]) {
                        $PAGE['keywords'] = $prod[0]["keywords"];
                    } elseif ($prod[0]["ctg_keywords"]) {
                        $PAGE['keywords'] = strip_tags($prod[0]["ctg_keywords"]);
                    }
                    //$this->get_nav_path($prod[0]['category_id'], $baseurl, $request_id);
                    $this->addition_to_path[$prod[0]['product_categ']] = '';
                    if ($prod[0]['ctg_img'] && file_exists(RP.$CONFIG['maps_ctg_img_path'].$prod[0]['ctg_img'])) {
                        $tpl->newBlock('ctgr_img');
                        $tpl->assign(array(
                            'path' => '/'.$CONFIG['maps_ctg_img_path'].$prod[0]['ctg_img'],
                            'path_big' => '/'.$CONFIG['maps_ctg_img_path'].$prod[0]['ctg_img_big'],
                        ));
                    }
                    
                    $tpl->assign_array('block_product', $prod);
                    if ($prod[0]['phone']) {
                        $tpl->newBlock('block_prod_phone');
                        $tpl->assign(Array('phone' => $prod[0]['phone']));
                    }
                    if ($prod[0]['open']) {
                        $tpl->newBlock('block_prod_open');
                        $tpl->assign(Array('open' => $prod[0]['open']));
                    }                    
                    if ($prod[0]['email']) {
                        $tpl->newBlock('block_prod_email');
                        $tpl->assign(Array('email' => $prod[0]['email']));
                    }                    
                    if ($prod[0]['leader']) {
                        $tpl->newBlock('block_leader');
                        $tpl->assign($prod[0]);
                    }
                    if ($prod[0]["product_ptype_title"]) {
                        $tpl->newBlock('product_ptype');
                        $tpl->assign(array(
                            'ptype_id'	=> $prod[0]["ptype_id"],
                            'ptype_name'	=> $prod[0]["product_ptype_title"],
                            'ptype_link'	=> $prod[0]["product_ptype_link"],
                        ));
                        if ($prod[0]["product_ptype_link"]) {
                            $tpl->newBlock('block_product_ptype'.((strtolower(substr($prod[0]["product_ptype_link"], 0, 7)) === "http://") ? '' : '_local').'_link');
                            $tpl->assign(array(
                                'ptype_name'	=> $prod[0]["product_ptype_title"],
                                'ptype_link'	=> $prod[0]["product_ptype_link"],
                            ));
                        } else {
                            $tpl->newBlock('block_product_ptype_without_link');
                            $tpl->assign('ptype_name', $prod[0]["product_ptype_title"]);
                        }
                    }
                    $big_img_path = '/i/no_photo.gif';
                    if ($prod[0]['product_image_big'] && file_exists(RP.$CONFIG['maps_img_path'].$prod[0]['product_image_big'])) {
                        $tpl->newBlock('block_image_big');
                        $big_img_path = "/".$CONFIG['maps_img_path'].$prod[0]['product_image_big'];
                    } else {
                        $tpl->newBlock('block_image_big_no');
                    }
                    $tpl->assign('image_path', $big_img_path);
                    if ($prod[0]['product_image'] && file_exists(RP.$CONFIG['maps_img_path'].$prod[0]['product_image'])) {
                        $tpl->newBlock('block_image_middle');
                        $tpl->assign(array(
                            'image_path' => "/".$CONFIG['maps_img_path'].$prod[0]['product_image'],
                            'big_img_path' => $big_img_path
                        ));
                    } else {
                        $tpl->newBlock('block_image_middle_no');
                    }                    
                    if($prod[0]['lat'] && $prod[0]['lng']){
                        $tpl->newBlock('block_lat_lng');
                        $tpl->assign(array(
                            'lat'  =>$prod[0]['lat'],
                            'lng'  =>$prod[0]['lng'],
                            'zoom'  =>$prod[0]['zoom'],
                            'ptype_icon_path'  =>$prod[0]['ptype_icon_path'],
                        ));
                    }
                    if($prod[0]['product_inf']){
                        $tpl->newBlock('block_inf_ptype_'.$prod[0]['ptype_id']);
                        $tpl->assign(array(
                            'product_inf'  =>$prod[0]['product_inf']
                        ));
                    }
                    if($prod[0]['product_description']){
                        $tpl->newBlock('block_description');
                        $tpl->assign(array(
                            'product_description'  =>$prod[0]['product_description']
                        ));
                    }
                    $tpl->newBlock('block_ptype_'.$prod[0]['ptype_id']);
                    $tpl->assign($prod[0]);
                    /* Связанные товары */
                    /*
                    $concrn_list = $this->getConcernedProducts($request_id, TRUE);
                    if ($concrn_list) {
                        $tpl->newBlock('block_concernd');
                        $this->showConcernedProducts($request_id, $concrn_list);
                    }
                    */
                    if ($CONFIG['maps_count_hits']) {
                        Main::addHits($this->table_prefix."_maps_products", $request_id);
                    }
                    $tpl->assignList('stat_', $prod[0]['stat_list']);
                    $tpl->assignList('service_', $this->getServiceList(array('prod_id' => $prod[0]['id'])));
                    
                    $this->main_title = $prod[0]['product_title'];
                    /*
                    $newTitle = $this->getElementRZD ($request_id, 'good');
                    if(is_array($newTitle)){
                        @array_pop($newTitle); //выкинем название "Корень каталога"
                        list($prod_name,$rzd_name) = $newTitle;
                        $this->main_title = $prod_name;//sprintf("%s - обзор, отзывы, описание. Цена, купить %s. %s < %s",$prod_name,$prod_name,$rzd_name,$CONFIG['sitename']);
                    }
                    else {
                        $this->main_title = $prod[0]['product_title'];
                    }
                    list($prod_name, $rzd_name) = $newTitle;
                    $PAGE['alt_title'] = $this->main_title;//$prod[0]["product_title"];
                    */
                    break;
                    // Вывод дерева категорий
                case "showtree":
                    $main->include_main_blocks($this->module_name."_cat_tree.html", "main");
                    $tpl->prepare();
                    $html	= $this->get_tree_2($transurl, $properties[3]);
                    $tpl->assign(array("sub_menu_two" => $html));
                    break;
                    // Вывод 2х верхних уровней каталога
                case "showtoplevels":
                    global $db, $tpl, $request_id;
                    $main->include_main_blocks($this->module_name."_top_levels.html", "main");
                    $tpl->prepare();
                    $top_level = $this->getAllRootCategs();
                    foreach ($top_level as $key => $val) {
                        $tpl->newBlock('block_level1');
                        $tpl->assign(array(
                            'link' => $transurl . ($CONFIG['rewrite_mod']&&$this->transReplace($null)) ? $transurl.$this->getElementPath($val['categ_id'], 'ctg') : $transurl."action=assortment&id=" . $val['categ_id'],
                            'title' => $val['categ_name'],
                            'desc' => $val['desc']
                        ));
                        if ($val['img'] && file_exists(RP.$CONFIG['maps_ctg_img_path'].$val['img'])) {
                            $tpl->newBlock("block_level1_img");
                            $tpl->assign("path", "/".$CONFIG['maps_ctg_img_path'].$val['img']);
                        }
                        if ($properties[3]) {
                            $tpl->newBlock("block_level1_cnt");
                            $tpl->assign("cnt", $this->getProdCount($val['categ_id'], 1));
                        }
                        if($top_level_2 = $this->getSubCategsForRootCateg($val['categ_id'])) {
                            foreach ($top_level_2 as $k => $v) {
                                $tpl->newBlock('block_level2');
                                $no = "no";
                                if ($request_id == $v['ctg_id']) {
                                    $no = "";
                                }
                                $tpl->newBlock('block_level2_'.$no.'active');
                                $tpl->assign(array(
                                    'link' => $transurl . ($CONFIG['rewrite_mod']&&$this->transReplace($null)) ? $transurl.$this->getElementPath($v['ctg_id'], 'ctg') : $transurl."action=assortment&id=" . $v['ctg_id'],
                                    'title' => $v['ctg_name'],
                                    'desc' => $v['ctg_descr']
                                ));
                                if ($v['ctg_img'] && file_exists(RP.$CONFIG['maps_ctg_img_path'].$v['ctg_img'])) {
                                    $tpl->newBlock("block_level2_".$no."active_img");
                                    $tpl->assign("path", "/".$CONFIG['maps_ctg_img_path'].$v['ctg_img']);
                                }
                                if ($properties[3]) {
                                    $tpl->newBlock("block_level2_".$no."active_cnt");
                                    $tpl->assign("cnt", $this->getProdCount( $v['ctg_id'], 1));
                                }
                            }
                        }
                    }
                    break;
                case "showmap":
                    global $request_sdata, $request_start;
                    $main->include_main_blocks($this->module_name.'_map.html', 'main');
                    $tpl->prepare();
                    //$prods = $this->getSearchProds(array(), 0 , 0);
                    //unset($prods["nav_str"]);
                    $tpl->assign(array(
                        //'json_prod_list' => json_encode($prods),
                        'json_ptype_list' => json_encode($this->get_ptypes())
                    ));
                    if (!self::$sWasShowItem) {
                        $this->show_ptypes();
                    }
                    break;
                    // Default...
                default:
                    if (is_object($tpl)) $tpl->prepare();
                    return;
            }
            //------------------------------- конец обработки действий с сайта -----------------------------//
        } else {
            $this->admin = true;
            //------------------------------ обработка действий из админ части -----------------------------//
            if (!isset($tpl)) {
                $main->message_die('Не подключен класс для работы с шаблонами');
            }
            $valid_acts = array('block_prp', 'properties');
            if (!in_array($action, $valid_acts) && 'rus' != $lang) {
                $main->message_die('Наполнение модуля осуществляется через <a href="/admin.php?lang=rus&name=maps">Москву</a>');
            }
            if (empty($action)) {
                $action = $this->admin_default_action;
            }
            switch ($action) {
                case 'prp':
                    if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
                    global $request_step;
                    $main->include_main_blocks('_properties.html', $this->tpl_path);
                    $tpl->prepare();
                    $tpl->assign(Array(
                    "MSG_Information"	=> $main->_msg["Information"],
                    "MSG_Value"			=> $main->_msg["Value"],
                    "MSG_Save"			=> $main->_msg["Save"],
                    "MSG_Cancel"		=> $main->_msg["Cancel"],
                    ));
                    if (!$request_step || $request_step == 1) {
                        $tpl->assign(array('form_action'	=> $baseurl,
                        'step'			=> 2,
                        'lang'			=> $lang,
                        'name'			=> $this->module_name,
                        'action'			=> 'prp'));
                        $prp_html = $main->getModuleProperties($this->module_name);
                        $this->main_title = $this->_msg["Controls"];
                    } elseif (2 == $request_step) {
                        $main->setModuleProperties($this->module_name, $_POST);
                        header('Location: '.$baseurl.'&action=prp&step=1');
                    }
                    break;
                case 'block_prp':
                    global $request_sub_action, $request_block_id;
                    $arr  = $this->getEditLink($request_sub_action, $request_block_id);
                    $cont = 'var container = document.getElementById(\'target_span\');
		    			 container.innerHTML = "'.$this->getPropertyFields().'";
		    		  	 material_id		  = "'.$arr['material_id'].'";
		    		  	 material_url		  = "'.$arr['material_url'].'";
		    		  	 changeAction();
		    	      	 setURL("property2");';
                    header('Content-Length: '.strlen($cont));
                    echo $cont;
                    exit;
                    break;
                    // Показ каталога
                case 'assortment':
                    if (!$permissions['r']) $main->message_access_denied($this->module_name, $action);
                    global $request_id, $request_start, $request_order;
                    $id		= (int)$request_id;
                    $start	= (int)$request_start;
                    if ($id == 0)	$id		= 1;
                    if (!$start)	$start	= 1;
                    $ctg_owners = $this->get_category_owners($id);
                    $main->include_main_blocks_2($this->module_name.'_assortment.html', $this->tpl_path);
                    $tpl->prepare();
                    $level = $this->show_nav_path($id, $baseurl);
                    $this->show_add_to_current($level, $id);
                    $this->show_categories($id, null, null, $ctg_owners);
                    $pages_cnt = $this->show_products($request_id, $baseurl, $CONFIG['maps_max_rows'], $start, $request_order, $ctg_owners);
                    if ($pages_cnt) {
                        $order_link = $request_order ? "&order=".$request_order : "";
                        $main->_show_nav_block($pages_cnt, null, "action=".$action."&id=".$id.$order_link, $start);
                        $tpl->assign(Array(
                        "MSG_Pages" => $this->_msg["Pages"],
                        ));
                    }
                    $this->main_title	= $this->_msg["Categories_goods"];
                    break;
                    // Результат поиска
                case 'search':
                    if (!$permissions['r']) {
                        $main->message_access_denied($this->module_name, $action);
                    }
                    global $request_id, $request_start, $request_search, $request_order;
                    $id    = (int)$request_id ? (int)$request_id : 1;
                    $start = (int)$request_start ? (int)$request_start : 1;
                    $main->include_main_blocks_2($this->module_name.'_assortment.html', $this->tpl_path);
                    $tpl->prepare();
                    $ctg_owners = $this->get_category_owners($id);
                    $level = $this->show_nav_path($id, $baseurl);
                    $this->show_add_to_current($level, $id);
                    $this->show_categories($id, null, null, $ctg_owners);
                    $request_search = trim($request_search);
                    if ($search = preg_replace("/\s+/", "&nbsp;", $request_search)) {
                        $search = explode("&nbsp;", $search);
                        $where = '';
                        foreach ($search as $word) {
                            $where .= "product_title LIKE '%".My_Sql::escape($word)."%' AND ";
                        }
                        $where = substr($where, 0, -5);
                        if ($where && $this->show_search_result($id,
                            $request_search,
                            $baseurl,
                            $CONFIG['maps_max_rows'],
                            $start,
                            $request_order)
                        ) {
                            $where = ' AND category_id = '.$id.' AND ('.$where.')';
                            $order_link = $request_order ? "&order=".$request_order : "";
                            $main->_show_nav_string($this->table_prefix.'_maps_products',
                            $where,
                            '',
                            'action='.$action.'&id='.$id."&search=".trim($request_search).$order_link,
                            $start,
                            $CONFIG['maps_max_rows'],
                            $CONFIG['maps_prod_order_by'],
                            '',
                            1,
                            0);
                        } else {
                            $tpl->newBlock('block_no_search');
                            $tpl->assign(Array(
                            "MSG_Not_found" => $this->_msg["Not_found"],
                            "MSG_Go_back" => $this->_msg["Go_back"],
                            ));
                        }
                    }
                    $this->main_title	= $this->_msg["Categories_goods"];
                    break;
                    // Перемещение элементов каталога
                case 'changecatgr':
                    if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
                    global $request_new_ctgr, $request_check, $request_new_ctgr, $request_category_id;
                    if ($this->changCatgrOfProducts($request_new_ctgr, $request_check)) {
                        header("Location: $baseurl&action=assortment&id=".(int)$request_new_ctgr);
                    } else {
                        header("Location: $baseurl&action=assortment&id=".(int)$request_category_id);
                    }
                    exit;
                    break;
                    // Добавление категории
                case "addcat":
                    if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
                    global $request_step, $request_id, $request_start, $request_block_id, $request_metro_id;
                    $ctg_owners = $this->get_category_owners($request_id);
                    if ($request_id > 1) {
                        list($allow, $ctg_rights) = $this->test_item_rights("e", "id", $this->table_prefix."_maps_categories",
                        $request_id, false, $ctg_owners, true);
                        if (!$allow) $main->message_access_denied($this->module_name, $action);
                    } else {
                        $ctg_rights = $CONFIG["maps_default_rights"];
                    }
                    $main->include_main_blocks_2($this->module_name."_edit_category.html", $this->tpl_path);
                    $tpl->prepare();
                    $tpl->assign(Array(
                        "MSG_Category_name_not_filled" => $this->_msg["Category_name_not_filled"],
                        "MSG_Map_key" => $CONFIG['maps_map_key'],
                        "MSG_Name" => $this->_msg["Name"],
                        "MSG_Goods_group_default" => $this->_msg["Goods_group_default"],
                        "MSG_Select_group" => $this->_msg["Select_group"],
                        "MSG_Description" => $this->_msg["Description"],
                        "MSG_Delete" => $this->_msg["Delete"],
                        "MSG_Page_description" => $this->_msg["Page_description"],
                        "MSG_Keywords" => $this->_msg["Keywords"],
                        "MSG_required_fields" => $this->_msg["required_fields"],
                        "MSG_Save" => $this->_msg["Save"],
                        "MSG_Cancel" => $this->_msg["Cancel"],
                        "MSG_Alias" => $this->_msg["Alias"],
                        "MSG_Alias_Info" => $this->_msg["Alias_Info"],
                        "MSG_Lat" => $this->_msg["Lat"],
                        "MSG_Lng" => $this->_msg["Lng"],
                        "MSG_Zoom" => $this->_msg["Zoom"],
                        "MSG_Show" => $this->_msg["Show"],
                        "MSG_Select_coord_msg" => $this->_msg["Select_coord_msg"]
                    ));
                    if (!$request_step || $request_step == 1) {
                        $tpl->assign(array(
                        "_ROOT.form_action"		=>	"$baseurl&action=addcat&start=$request_start",
                        "_ROOT.referer"			=>	$_SERVER['HTTP_REFERER'],
                        "_ROOT.id"				=>	$request_id,
                        "_ROOT.cancel_link"		=>	"javascript:history.back();",
                        "_ROOT.str_path"		=>	"/admin/?name=maps&action=str",
                        'maps_map_lat' => $CONFIG['maps_map_lat'],
                        'maps_map_lng' => $CONFIG['maps_map_lng'],
                        'maps_map_zoom' => $CONFIG['maps_map_zoom'],
                        'small_image_width' => $CONFIG['maps_product_small_image_size']['width'],
                        'small_image_height' => $CONFIG['maps_product_small_image_size']['height'],
                        ));
                        $tpl->newBlock('block_ctg_image');
                        $tpl->assign(array(
                            'image_title'				=>	$this->_msg["Category_image"],
                            'field_name'				=>	'img',
                        ));
                        
                        Module::show_select('metro_list', $CC->metro_id, 'title', $this->getMetroList());
                        
                        $this->main_title = $this->_msg["Create_new_category"];
                        break;
                    } else if ($request_step == 2) {
                        $block_id = intval(substr($request_block_id, 10));
                        $lid = $this->add_catalog($ctg_rights, $block_id);
                        if ($lid) @$cache->delete_cache_files();
                        header("Location: $baseurl&action=assortment&id=$request_id");
                        exit;
                        break;
                    }
                    break;
                    // Редактирование категории.
                case "editcat":
                    if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
                    global $request_step, $request_start, $request_id, $request_parent, $request_metro_id;
                    $ctg_owners = $this->get_category_owners($request_parent);
                    if (!$this->test_item_rights("e", "id", $this->table_prefix."_maps_categories", $request_id, false, $ctg_owners))
                    $main->message_access_denied($this->module_name, $action);
                    $main->include_main_blocks_2($this->module_name."_edit_category.html", $this->tpl_path);
                    $tpl->prepare();
                    $tpl->assign(Array(
                        "MSG_Category_name_not_filled" => $this->_msg["Category_name_not_filled"],
                        "MSG_Map_key" => $CONFIG['maps_map_key'],
                        "MSG_Name" => $this->_msg["Name"],
                        "MSG_Goods_group_default" => $this->_msg["Goods_group_default"],
                        "MSG_Select_group" => $this->_msg["Select_group"],
                        "MSG_Description" => $this->_msg["Description"],
                        "MSG_Delete" => 'вапавап',
                        "MSG_Page_description" => $this->_msg["Page_description"],
                        "MSG_Keywords" => $this->_msg["Keywords"],
                        "MSG_required_fields" => $this->_msg["required_fields"],
                        "MSG_Save" => $this->_msg["Save"],
                        "MSG_Cancel" => $this->_msg["Cancel"],
                        "MSG_Alias" => $this->_msg["Alias"],
                        "MSG_Alias_Info" => $this->_msg["Alias_Info"],
                        "MSG_Lat" => $this->_msg["Lat"],
                        "MSG_Lng" => $this->_msg["Lng"],
                        "MSG_Zoom" => $this->_msg["Zoom"],
                        "MSG_Show" => $this->_msg["Show"],
                        "MSG_Select_coord_msg" => $this->_msg["Select_coord_msg"]
                    ));
                    if (!$request_step || $request_step == 1) {
                        $tpl->assign(array(
                            "_ROOT.form_action"		=>	"$baseurl&action=editcat&start=$request_start",
                            "_ROOT.referer"			=>	$_SERVER['HTTP_REFERER'],
                            "_ROOT.id"				=>	$request_id,
                            "_ROOT.cancel_link"		=>	"javascript:history.back();",
                            "_ROOT.str_path"		=>	"/admin/?name=maps&action=str"
                        ));
                        $this->main_title = $this->_msg["Edit_category"];
                        if (!$this->show_category($request_id, $baseurl)) { // если нет такой записи то редирект
                            header("Location: $baseurl&action=assortment");
                            exit;
                        }
                        break;
                    } else if ($request_step == 2) {
                        if ($this->edit_catalog()) {
                            @$cache->delete_cache_files();
                        }
                        $CDBT	=	new NsDbTree($this->table_prefix.'_maps_categories', 'id', $this->CDBT_fields);
                        $parent = $CDBT->getParent($request_id);
                        header('Location: '.$baseurl.'&action=assortment&id='.$parent[0]);
                        exit;
                        break;
                    }
                    break;
                    // Удаление категории с вложениями.
                case "delcat":
                    if (!$permissions["d"]) $main->message_access_denied($this->module_name, $action);
                    global $request_step, $request_start, $request_id, $request_parent;
                    $ctg_owners = $this->get_category_owners($request_parent);
                    if (!$this->test_item_rights("d", "id", $this->table_prefix."_maps_categories", $request_id, false, $ctg_owners))
                    $main->message_access_denied($this->module_name, $action);
                    // Удаление категории, первый шаг
                    if (!$request_step || $request_step == 1) {
                        $main->include_main_blocks_2($this->module_name.'_del_category.html', $this->tpl_path);
                        $tpl->prepare();
                        $tpl->assign(array(
                        "MSG_Removing_category" => $this->_msg["Removing_category"],
                        "MSG_deletes_its_goods" => $this->_msg["deletes_its_goods"],
                        "MSG_Confirm_delete_category" => $this->_msg["Confirm_delete_category"],
                        "MSG_Delete" => $this->_msg["Delete"],
                        "MSG_Cancel" => $this->_msg["Cancel"],
                        '_ROOT.form_action'		=>	 $baseurl.'&action=delcat&start='.$request_start,
                        '_ROOT.id'				=>	 $request_id,
                        '_ROOT.parent'			=>	 $request_parent,
                        '_ROOT.cancel_link'		=>	 'javascript:history.back();',
                        ));
                        $this->show_category($request_id, $baseurl);
                        $this->main_title = $this->_msg["Category_delete"];
                        break;
                        // Удаление категории, шаг второй
                    } else if ($request_step == 2) {
                        //$this->delete_products($this->table_prefix.'_catalog_products', $where = 'AND category_id='.$request_id);
                        $parent = $this->delete_catalog($request_id);
                        @$cache->delete_cache_files();
                        header("Location: $baseurl&action=assortment&id=".$parent[0]);
                        exit;
                    }
                    $this->main_title = "Категории товаров";
                    break;
                    // поднятие каталога вверх на $shift позиций
                case "upcat":
                    if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
                    global $request_shift, $request_rank, $request_clevel, $request_id;
                    $ctg_owners = $this->get_category_owners($request_parent);
                    if (!$this->test_item_rights("p", "id", $this->table_prefix."_maps_categories", $request_id, false, $ctg_owners))
                    $main->message_access_denied($this->module_name, $action);
                    if (is_numeric($request_shift) && $request_shift != $request_rank) {
                        $shift = (int)$request_shift;
                    } else {
                        $shift = (int)$request_rank;
                    }
                    if ($main->change_order('up', $this->table_prefix.'_maps_categories', "rank", $request_rank, $shift, "clevel = $request_clevel AND")) {
                        @$cache->delete_cache_files();
                    }
                    $CDBT	=	new NsDbTree($this->table_prefix.'_maps_categories', 'id', $this->CDBT_fields);
                    $parent	=	$CDBT->getParent($request_id);
                    header("Location: $baseurl&action=assortment&id=".$parent[0]);
                    exit;
                    break;
                    // опускание каталога вверх на $shift позиций
                case "downcat":
                    if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
                    global $request_shift, $request_rank, $request_clevel, $request_id;
                    $ctg_owners = $this->get_category_owners($request_parent);
                    if (!$this->test_item_rights("p", "id", $this->table_prefix."_maps_categories", $request_id, false, $ctg_owners))
                    $main->message_access_denied($this->module_name, $action);
                    if (is_numeric($request_shift) && $request_shift != $request_rank) {
                        $shift = (int)$request_shift;
                    } else {
                        $shift = (int)$request_rank;
                    }
                    if ($main->change_order('down', $this->table_prefix.'_maps_categories', 'rank', $request_rank, $shift, "clevel = $request_clevel AND" )) {
                        @$cache->delete_cache_files();
                    }
                    $CDBT	=	new NsDbTree($this->table_prefix.'_maps_categories', 'id', $this->CDBT_fields);
                    $parent	=	$CDBT->getParent($request_id);
                    header("Location: $baseurl&action=assortment&id=".$parent[0]);
                    exit;
                    break;
                    // Выключение публикации категории
                case "csuspend":
                    if (!$permissions["p"]) $main->message_access_denied($this->module_name, $action);
                    global $request_id;
                    $ctg_owners = $this->get_category_owners($request_parent);
                    if (!$this->test_item_rights("p", "id", $this->table_prefix."_maps_categories", $request_id, false, $ctg_owners))
                    $main->message_access_denied($this->module_name, $action);
                    if ($main->suspend($this->table_prefix.'_maps_categories', $request_id, 'active')) @$cache->delete_cache_files();
                    $CDBT	=	new NsDbTree($this->table_prefix.'_maps_categories', 'id', $this->CDBT_fields);
                    $parent	=	$CDBT->getParent($request_id);
                    header("Location: $baseurl&action=assortment&id=".$parent[0]);
                    exit;
                    break;
                    // Включение публикации категории
                case "cactivate":
                    if (!$permissions['p']) $main->message_access_denied($this->module_name, $action);
                    global $request_id;
                    $ctg_owners = $this->get_category_owners($request_parent);
                    if (!$this->test_item_rights("p", "id", $this->table_prefix."_maps_categories", $request_id, false, $ctg_owners))
                    $main->message_access_denied($this->module_name, $action);
                    if ($main->activate($this->table_prefix.'_maps_categories', $request_id, "active")) @$cache->delete_cache_files();
                    $CDBT	=	new NsDbTree($this->table_prefix.'_maps_categories', 'id', $this->CDBT_fields);
                    $parent	=	$CDBT->getParent($request_id);
                    header("Location: $baseurl&action=assortment&id=".$parent[0]);
                    exit;
                    break;
                    // поднятие каталога вверх на $shift позиций
                case "productup":
                    if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
                    global $request_shift, $request_rank, $request_category_id;
                    if (is_numeric($request_shift) && $request_shift != $request_rank) {
                        $shift = (int)$request_shift;
                    } else {
                        $shift = (int)$request_rank;
                    }
                    if ($main->change_order('up', $this->table_prefix.'_maps_products', 'rank', $request_rank, $shift, "category_id = $request_category_id AND" )) {
                        @$cache->delete_cache_files();
                    }
                    header("Location: ".($_SERVER['HTTP_REFERER'] ? $_SERVER['HTTP_REFERER'] : $baseurl."&action=assortment&id=".$request_category_id));
                    exit;
                    break;
                    // опускание каталога вверх на $shift позиций
                case "productdown":
                    if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
                    global $request_shift, $request_rank, $request_category_id;
                    if (is_numeric($request_shift) && $request_shift != $request_rank) {
                        $shift = (int)$request_shift;
                    } else {
                        $shift = (int)$request_rank;
                    }
                    if ($main->change_order('down', $this->table_prefix.'_maps_products', 'rank', $request_rank, $shift, "category_id = $request_category_id AND" )) {
                        @$cache->delete_cache_files();
                    }
                    header("Location: ".($_SERVER['HTTP_REFERER'] ? $_SERVER['HTTP_REFERER'] : $baseurl."&action=assortment&id=".$request_category_id));
                    exit;
                    break;
                    // Редактирование прав категории
                case 'editctgrights':
                    if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
                    global $request_id, $request_parent, $request_start;
                    $ctg_owners = $this->get_category_owners($request_parent);
                    if (!$this->test_item_rights("e", "id", $this->table_prefix."_maps_categories", $request_id, true, $ctg_owners, false, true))
                    $main->message_access_denied($this->module_name, $action);
                    if (!$this->show_rights_form($this->table_prefix."_maps_categories", "title", $request_id,
                    "&id=".$request_id."&parent=".$request_parent, $this->_msg["Category"], "savectgrights")) {
                        header('Location: '.$baseurl.'&action=assortment&id='.$request_parent.'&start='.$request_start);
                    }
                    if ($request_type == "JsHttpRequest") {
                        require_once RP."inc/class.JsHttpRequest.php";
                        $JsHttpRequest =& new JsHttpRequest("utf-8");
                    }
                    break;
                    // Сохранение прав категории
                case 'savectgrights':
                    if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
                    global $request_id, $request_parent, $request_start, $request_rights;
                    $ctg_owners = $this->get_category_owners($request_parent);
                    if (!$this->test_item_rights("e", "id", $this->table_prefix."_maps_categories", $request_id, true, $ctg_owners, false, true))
                    $main->message_access_denied($this->module_name, $action);
                    $this->save_rights_form($this->table_prefix."_maps_categories", $request_id, $request_rights);
                    if ($request_type == "JsHttpRequest") {
                        require_once RP."inc/class.JsHttpRequest.php";
                        $JsHttpRequest =& new JsHttpRequest("utf-8");
                        $_RESULT = array(
                        "res"	=> 1,
                        "category"	=> $request_parent,
                        );
                    } else {
                        header('Location: '.$baseurl.'&action=assortment&id='.$request_parent.'&start='.$request_start);
                    }
                    exit;
                    break;
                    // Выключение публикации продукта
                case "psuspend":
                    if (!$permissions["p"]) $main->message_access_denied($this->module_name, $action);
                    global $request_id, $request_category_id;
                    if ($main->suspend($this->table_prefix.'_maps_products', $request_id, "active")) @$cache->delete_cache_files();
                    header("Location: ".($_SERVER['HTTP_REFERER'] ? $_SERVER['HTTP_REFERER'] : $baseurl."&action=assortment&id=".$request_category_id));
                    exit;
                    break;
                    // Включение публикации продукта
                case "pactivate":
                    if (!$permissions["p"]) $main->message_access_denied($this->module_name, $action);
                    global $request_id, $request_category_id;
                    if ($main->activate($this->table_prefix.'_maps_products', $request_id, "active")) @$cache->delete_cache_files();
                    header("Location: ".($_SERVER['HTTP_REFERER'] ? $_SERVER['HTTP_REFERER'] : $baseurl."&action=assortment&id=".$request_category_id));
                    exit;
                    break;
                    // Добавление производителя
                case 'addptype':
                    if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
                    global $request_step, $request_ptypename, $request_link;
                    $main->include_main_blocks_2($this->module_name."_edit_ptype.html", $this->tpl_path);
                    $tpl->prepare();
                    $tpl->assign(Array(
                    "MSG_Producer_name_not_filled" => $this->_msg["Producer_name_not_filled"],
                    "MSG_Good_producer" => $this->_msg["Good_producer"],
                    "MSG_Link" => $this->_msg["Link"],
                    "MSG_Icon" => $this->_msg["Icon"],
                    "MSG_required_fields" => $this->_msg["required_fields"],
                    "MSG_Save" => $this->_msg["Save"],
                    "MSG_Cancel" => $this->_msg["Cancel"],
                    ));
                    if (!$request_step || $request_step == 1) {
                        $tpl->assign("_ROOT.form_action", "$baseurl&action=addptype");
                        $this->main_title = $this->_msg["Add_producer"];
                    } else if ($request_step == 2) {
                        $this->add_ptype($request_ptypename, $request_link);
                        header("Location: ".$baseurl."&action=showptypes");
                    }
                    break;
                    // Вывод производителя
                case 'showptypes':
                    if (!$permissions["r"]) $main->message_access_denied($this->module_name, $action);
                    $main->include_main_blocks_2($this->module_name."_ptypes.html", $this->tpl_path);
                    $tpl->prepare();
                    $tpl->assign(Array(
                    "MSG_Add_producer" => $this->_msg["Add_producer"],
                    "MSG_Ed" => $this->_msg["Ed"],
                    "MSG_Producers" => $this->_msg["Producers"],
                    "MSG_Del" => $this->_msg["Del"],
                    ));
                    $tpl->assign(array('add_ptype' => '?lang='.$lang.'&name=maps&action=addptype'));
                    $this->show_ptypes();
                    $this->main_title = $this->_msg["Producers"];
                    break;
                    // Изменение производителя
                case 'editptype':
                    if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
                    global $request_id;
                    $main->include_main_blocks_2($this->module_name."_edit_ptype.html", $this->tpl_path);
                    $tpl->prepare();
                    $tpl->assign(Array(
                    "MSG_Producer_name_not_filled" => $this->_msg["Producer_name_not_filled"],
                    "MSG_Good_producer" => $this->_msg["Good_producer"],
                    "MSG_Link" => $this->_msg["Link"],
                    "MSG_Icon" => $this->_msg["Icon"],
                    "MSG_required_fields" => $this->_msg["required_fields"],
                    "MSG_Save" => $this->_msg["Save"],
                    "MSG_Cancel" => $this->_msg["Cancel"],
                    ));
                    $tpl->assign(array(
                        "_ROOT.form_action"	=>	$baseurl.'&action=updateptype',
                    ));
                    $this->show_ptype($request_id);
                    $this->main_title = $this->_msg["Edit_producer"];
                    break;
                case 'updateptype':
                    if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
                    global $request_ptypename, $request_link, $request_id, $request_del_icon;
                    $this->update_ptype($request_ptypename, $request_link, $request_id, $request_del_icon);
                    header("Location: ".$baseurl."&action=showptypes");
                    exit;
                    break;
                    // Удаление производителя
                case 'delptype':
                    if (!$permissions["d"]) $main->message_access_denied($this->module_name, $action);
                    global $request_step, $request_id;
                    // Удаление группы, первый шаг
                    if (!$request_step || $request_step == 1) {
                        $main->include_main_blocks_2($this->module_name."_del_ptype.html", $this->tpl_path);
                        $tpl->prepare();
                        $tpl->assign(Array(
                        "MSG_Removing_producer" => $this->_msg["Removing_producer"],
                        "MSG_unsets_its_goods_ptype" => $this->_msg["unsets_its_goods_ptype"],
                        "MSG_Confirm_delete_producer" => $this->_msg["Confirm_delete_producer"],
                        "MSG_Delete" => $this->_msg["Delete"],
                        "MSG_Cancel" => $this->_msg["Cancel"],
                        ));
                        $tpl->assign(
                        array(
                        "_ROOT.form_action"	=>	$baseurl."&action=delptype&step=2&id=".$request_id,
                        )
                        );
                        $this->show_ptype($request_id);
                        $this->main_title = $this->_msg["Producer_delete"];
                        // Удаление группы, шаг второй
                    } else if ($request_step == 2) {
                        if ($this->delete_ptype($request_id)) @$cache->delete_cache_files();
                        header("Location: ".$baseurl."&action=showptypes");
                        exit;
                    }
                    break;
                    // Добавление продукта
                case 'addproduct':
                    if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
                    global $request_id, $request_parent, $request_start, $request_step,
                    $request_group_id, $request_prp_val, $request_currency,
                    $request_price_1, $request_price_2, $request_price_3, $request_price_4, $request_price_5,
                    $request_ptype_id, $request_pcode, $request_pname, $request_info, $request_txt_content,
                    $request_description, $request_keywords, $request_availability, $request_full_description,
                    $request_block_id, $request_lat, $request_lng, $request_zoom,
                    $request_addr, $request_phone, $request_open, $request_e_mail,
                    $request_metro, $request_leader, $request_stat_id, $request_service;

                    $parent = $request_step == 2 ? $request_parent : $request_id;
                    $ctg_owners = $this->get_category_owners($parent);
                    list($allow, $ctg_rights) = $this->test_item_rights("e", "id", $this->table_prefix."_maps_categories",
                        $parent, false, $ctg_owners, true);
                    if (!$allow) {
                        $main->message_access_denied($this->module_name, $action);
                    }
                    $ctgr = $this->getCategory($parent);
                    
                    $main->include_main_blocks_2($this->module_name.'_edit_product.html', $this->tpl_path);
                    $tpl->prepare();
                    $tpl->assign(Array(
                        "MSG_GoodID_must_be_positive" => $this->_msg["GoodID_must_be_positive"],
                        "MSG_Group_ID_is" => $this->_msg["Group_ID_is"],
                        "MSG_Enter_good_name" => $this->_msg["Enter_good_name"],
                        "MSG_Map_key" => $CONFIG['maps_map_key'],
                        "MSG_Choose_producer" => $this->_msg["Choose_producer"],
                        "MSG_Choose_currency" => $this->_msg["Choose_currency"],
                        "MSG_Good_code" => $this->_msg["Good_code"],
                        "MSG_articul" => $this->_msg["articul"],
                        "MSG_Name" => $this->_msg["Name"],
                        "MSG_Good_producer" => $this->_msg["Good_producer"],
                        "MSG_Select_producer" => $this->_msg["Select_producer"],
                        "MSG_Short_description" => $this->_msg["Short_description"],
                        "MSG_Full_description" => $this->_msg["Full_description"],
                        "MSG_Page_description" => $this->_msg["Page_description"],
                        "MSG_Keywords" => $this->_msg["Keywords"],
                        "MSG_Currency" => $this->_msg["Currency"],
                        "MSG_Select_currency" => $this->_msg["Select_currency"],
                        "MSG_Retail_price" => $this->_msg["Retail_price"],
                        "MSG_Partner_price" => $this->_msg["Partner_price"],
                        "MSG_Dealer_price" => $this->_msg["Dealer_price"],
                        "MSG_Price" => $this->_msg["Price"],
                        "MSG_Presence" => $this->_msg["Presence"],
                        "MSG_required_fields" => $this->_msg["required_fields"],
                        "MSG_Save" => $this->_msg["Save"],
                        "MSG_Cancel" => $this->_msg["Cancel"],
                        "MSG_Alias" => $this->_msg["Alias"],
                        "MSG_Alias_Info" => $this->_msg["Alias_Info"],
                        "MSG_Lat" => $this->_msg["Lat"],
                        "MSG_Lng" => $this->_msg["Lng"],
                        "MSG_Zoom" => $this->_msg["Zoom"],
                        "MSG_Addr" => $this->_msg["Addr"],
                        "MSG_Phone" => $this->_msg["Phone"],
                        "MSG_Open" => $this->_msg["Open"],
                        "MSG_Show" => $this->_msg["Show"],
                        "MSG_Select_coord_msg" => $this->_msg["Select_coord_msg"],
                        "ctgr_title" => $ctgr['title'],
                        'maps_map_lat' => $ctgr['lat']>0 ? $ctgr['lat'] : $CONFIG['maps_map_lat'],
                        'maps_map_lng' => $ctgr['lng']>0 ? $ctgr['lng'] : $CONFIG['maps_map_lng'],
                        'maps_map_zoom' => $ctgr['zoom']>0 ? $ctgr['zoom'] : $CONFIG['maps_map_zoom'],
                    ));
                    $level = $this->show_nav_path($request_id, $baseurl);
                    if ($level > $CONFIG['maps_max_level']) {
                        header('Location: '.$baseurl.'&action=assortment&parent='.$request_parent.'&start='.$request_start);
                        exit;
                    }
                    $tpl->newBlock('block_product_image');
                    $tpl->assign(array(
                        'lang'			=>  $lang,
                        'image_title'	=>	$this->_msg["Insert_middle_image"],
                        'image_exists'	=>	'',
                        'field_name'	=>	'image_middle',
                        'image_name'	=>	$this->_msg["Image_name"],
                        "MSG_Delete" => $this->_msg["Delete"],
                    ));
                    $tpl->newBlock('block_product_image_generated');
                    $tpl->assign(array(
                        'lang'			=>  $lang,
                        'image_title'	=>	$this->_msg["Insert_middle_image"],
                        'image_exists'	=>	'',
                        'field_name'	=>	'image_middle',
                        'image_name'	=>	$this->_msg["Image_name"],
                        "MSG_Generated" =>  $this->_msg["Generated"],
                    ));
                    $tpl->newBlock('block_product_image');
                    $tpl->assign(array(
                        'lang'			=>  $lang,
                        'image_title'	=>	$this->_msg["Insert_big_image"],
                        'image_exists'	=>	'',
                        'field_name'	=>	'image_big',
                        'image_name'	=>	$this->_msg["Image_name"],
                        "MSG_Delete" => $this->_msg["Delete"],
                    ));
                    $this->show_ptypes();
                    if ($ctgr['metro_id']) {
                        $tpl->newBlock('metro');
                        $this->showStatList($this->getMetroStatList($ctgr['metro_id']));
                    }
                    
                    $tpl->assignList('service_', $this->getServiceList(), $assign);
                    
                    if (!$request_step || $request_step == 1) {
                        $tpl->assign(array(
                            '_ROOT.form_action'	=> $baseurl.'&action=addproduct',
                            '_ROOT.parent'		=> $request_id,
                            '_ROOT.cancel_link'	=> 'javascript:history.back();',
                            '_ROOT.web_address' =>  $CONFIG['web_address'],
                        ));
                        $this->main_title = $this->_msg["Add_good"];
                        break;
                    } else if ($request_step == 2) {
                        $block_id = intval(substr($request_block_id, 10));
                        $lid = $this->add_product(
                        $request_parent,
                        $request_group_id,
                        $request_stat_id,
                        $request_service,
                        $request_prp_val,
                        $_FILES['prp_pic'],
                        $request_currency,
                        $request_price_1,
                        $request_price_2,
                        $request_price_3,
                        $request_price_4,
                        $request_price_5,
                        (int)$request_ptype_id,
                        $request_pcode,
                        $request_pname,
                        $request_info,
                        $request_txt_content,
                        $request_description,
                        $request_keywords,
                        $request_availability,
                        $request_lat,
                        $request_lng,
                        $request_zoom,
                        $request_addr,
                        $request_phone,
                        $request_open,
                        $request_leader,
                        $ctg_rights,
                        $block_id, $request_e_mail);
                        if ($lid) {
                            $lc->add_internal_links($this->module_name,
                            $this->table_prefix.'maps_products',
                            'full_description',
                            $lid,
                            'ссылка в каталоге',
                            $request_full_description);
                            @$cache->delete_cache_files();
                        }
                        header('Location: '.$baseurl.'&action=assortment&id='.$request_parent.'&start='.$request_start);
                        exit;
                    }
                    break;
                    
                // Изменение продукта
                case 'editproduct':
                    if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
                    global $request_id, $request_category_id, $request_start, $request_category_id, $request_parent,
                    $request_e_mail;
                    $ctg_owners = $this->get_category_owners($request_category_id);
                    if (!$this->test_item_rights("e", "id", $this->table_prefix."_maps_products", $request_id, false, $ctg_owners))
                    $main->message_access_denied($this->module_name, $action);
                    $prod = $this->show_product_2($request_id);
                    if (!$prod['product_title']) {
                        header('Location: '.$baseurl.'&action=addproduct');
                        exit;
                    }
                    $ctgr = $this->getCategory($prod['category_id']);
                    $main->include_main_blocks_2($this->module_name.'_edit_product.html', $this->tpl_path);
                    $tpl->prepare();
                    $tpl->assign(Array(
                        "ctgr_title" => $ctgr['title'],
                        "MSG_GoodID_must_be_positive" => $this->_msg["GoodID_must_be_positive"],
                        "MSG_Group_ID_is" => $this->_msg["Group_ID_is"],
                        "MSG_Enter_good_name" => $this->_msg["Enter_good_name"],
                        "MSG_Map_key" => $CONFIG['maps_map_key'],
                        "MSG_Choose_producer" => $this->_msg["Choose_producer"],
                        "MSG_Choose_currency" => $this->_msg["Choose_currency"],
                        "MSG_Good_code" => $this->_msg["Good_code"],
                        "MSG_articul" => $this->_msg["articul"],
                        "MSG_Name" => $this->_msg["Name"],
                        "MSG_Good_producer" => $this->_msg["Good_producer"],
                        "MSG_Select_producer" => $this->_msg["Select_producer"],
                        "MSG_Short_description" => $this->_msg["Short_description"],
                        "MSG_Full_description" => $this->_msg["Full_description"],
                        "MSG_Page_description" => $this->_msg["Page_description"],
                        "MSG_Keywords" => $this->_msg["Keywords"],
                        "MSG_Currency" => $this->_msg["Currency"],
                        "MSG_Select_currency" => $this->_msg["Select_currency"],
                        "MSG_Retail_price" => $this->_msg["Retail_price"],
                        "MSG_Partner_price" => $this->_msg["Partner_price"],
                        "MSG_Dealer_price" => $this->_msg["Dealer_price"],
                        "MSG_Price" => $this->_msg["Price"],
                        "MSG_Presence" => $this->_msg["Presence"],
                        "MSG_required_fields" => $this->_msg["required_fields"],
                        "MSG_Save" => $this->_msg["Save"],
                        "MSG_Cancel" => $this->_msg["Cancel"],
                        "MSG_Alias" => $this->_msg["Alias"],
                        "MSG_Alias_Info" => $this->_msg["Alias_Info"],
                        "MSG_Lat" => $this->_msg["Lat"],
                        "MSG_Lng" => $this->_msg["Lng"],
                        "MSG_Zoom" => $this->_msg["Zoom"],
                        "MSG_Addr" => $this->_msg["Addr"],
                        "MSG_Phone" => $this->_msg["Phone"],
                        "MSG_Open" => $this->_msg["Open"],
                        "MSG_Show" => $this->_msg["Show"],
                        "MSG_Select_coord_msg" => $this->_msg["Select_coord_msg"],
                    ));
                    $level		= $this->show_nav_path($request_category_id, $baseurl, $request_id);
                    $tpl->assign(array(
                        'text'						=> str_replace('"', "&quot;", $prod['product_description']),
                        'product_id'				=> $prod['id'],
                        'product_code'				=> $prod['product_code'],
                        'product_name'				=> str_replace('"', "&quot;", $prod['product_title']),
                        'product_alias'				=> $prod['alias'],
                        'product_inf'				=> str_replace('"', "&quot;", $prod['product_inf']),
                        'page_description'			=> str_replace('"', "&quot;", $prod['description']),
                        'page_keywords'				=> str_replace('"', "&quot;", $prod['keywords']),
                        'lat'         				=> $prod['lat'],
                        'lng'         				=> $prod['lng'],
                        'zoom'        				=> $prod['zoom'],
                        'e_mail' => $prod['e_mail'],
                        'addr'         				=> str_replace('"', "&quot;", $prod['addr']),
                        'phone'         			=> str_replace('"', "&quot;", $prod['phone']),
                        'open'        				=> str_replace('"', "&quot;", $prod['open']),
                        "_ROOT.form_action"			=> $baseurl.'&action=updateproduct&start='.$request_start,
                        "_ROOT.parent"				=> $request_category_id,
                        "_ROOT.referer"				=> $_SERVER['HTTP_REFERER'],
                        "_ROOT.cancel_link"			=> $baseurl.'&action=assortment&parent='.$request_parent,
                        "baseurl"					=> $baseurl,
                        'leader_checked'			=> $prod['leader'] ? 'checked' : '',
                        'currency'        			=> htmlspecialchars($prod['currency']),
                    ));
                    $tpl->assign(array(
                        'lang'       => $lang,
                        'doLoad'     => $do_load,
                        'product_id' => $request_id
                    ));
                    $tpl->newBlock('block_product_image');
                    $image_middle = "";
                    if ($prod['image_middle']) {
                        $image_middle = '<a target="new" href="'.$CONFIG['maps_img_path'].$prod['image_middle'].'">' . $this->_msg["Look"] . '</a>';
                    }
                    $tpl->assign(array(
                        'image_title'	=>	$this->_msg["Middle_image"],
                        'image_exists'	=>	$image_middle,
                        'field_name'	=>	'image_middle',
                        'image_name'	=>	$prod['image_middle'],
                        "MSG_Delete" => $this->_msg["Delete"],
                    ));
                    $tpl->newBlock('block_product_image_generated');
                    $tpl->assign(array(
                        'lang'			=>  $lang,
                        'image_title'	=>	$this->_msg["Insert_middle_image"],
                        'image_exists'	=>	'',
                        'field_name'	=>	'image_middle',
                        'image_name'	=>	$this->_msg["Image_name"],
                        "MSG_Generated" =>  $this->_msg["Generated"],
                    ));
                    $tpl->newBlock('block_product_image');
                    $image_big = "";
                    if ($prod['image_big']) {
                        $image_big = '<a target="new" href="'.$CONFIG['maps_img_path'].$prod['image_big'].'">' . $this->_msg["Look"] . '</a>';
                    }
                    $tpl->assign(array(
                        'image_title'	=>	$this->_msg["Big_image"],
                        'image_exists'	=>	$image_big,
                        'field_name'	=>	'image_big',
                        'image_name'	=>	$prod['image_big'],
                        'MSG_Delete' => $this->_msg['Delete'],
                    ));
                    $this->show_ptypes($prod['ptype_id']);
                    /* Связанные товары */
                    $tpl->newBlock('block_concernd_prod');
                    $tpl->assign(Array(
                    "MSG_Add" => $this->_msg["Add"],
                    "MSG_Assigned_goods" => $this->_msg["Assigned_goods"],
                    "MSG_Good_Id" => $this->_msg["Good_Id"],
                    ));
                    $concrn_list = $this->getConcernedProducts($request_id);
                    if ($concrn_list) {
                        $tpl->newBlock('block_concernd');
                        $tpl->assign(Array(
                        "MSG_Ed" => $this->_msg["Ed"],
                        "MSG_ID" => $this->_msg["ID"],
                        "MSG_Name" => $this->_msg["Name"],
                        "MSG_Activ" => $this->_msg["Activ"],
                        "MSG_Del" => $this->_msg["Del"],
                        ));
                        $this->showConcernedProducts($request_id, $concrn_list);
                    }
                    if ($ctgr['metro_id']) {
                        $tpl->newBlock('metro');
                        $this->showStatList($this->getMetroStatList($ctgr['metro_id']), $prod['stat_id']);
                    }
                    $prod_service_list = $this->getServiceList(array('prod_id' => $prod['id']));
                    $tpl->assignList('service_', $this->getServiceList(array('checked' => array_keys($prod_service_list))), $assign);
                    
                    $this->main_title = $this->_msg["Edit_good"];
                    break;
                    
                case 'updateproduct':
                    if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
                    global $request_id, $request_group_id, $request_prp_val,
                    $request_prp_pic, $request_prp_pic_del, $request_currency,
                    $request_price_1, $request_price_2, $request_price_3, $request_price_4, $request_price_5,
                    $request_ptype_id, $request_pcode, $request_pname, $request_info,
                    $request_txt_content, $request_description, $request_keywords, $request_availability,
                    $request_del_image_middle, $request_del_pics, $request_parent, $request_start,
                    $request_lat, $request_lng, $request_zoom,
                    $request_addr, $request_phone, $request_open, $request_e_mail,
                    $request_metro, $request_leader, $request_stat_id, $request_service;

                    $ctg_owners = $this->get_category_owners($request_parent);
                    if (!$this->test_item_rights("e", "id", $this->table_prefix."_maps_products", $request_id, false, $ctg_owners))
                    $main->message_access_denied($this->module_name, $action);
                    $request_id = (int)$request_id;
                    if ($this->update_product($request_id,
                    $request_group_id,
                    $request_stat_id,
                    $request_service,
                    $request_prp_val,
                    $request_prp_pic,
                    $request_prp_pic_del,
                    $request_currency,
                    $request_price_1,
                    $request_price_2,
                    $request_price_3,
                    $request_price_4,
                    $request_price_5,
                    (int)$request_ptype_id,
                    $request_pcode,
                    $request_pname,
                    $request_info,
                    $request_txt_content,
                    $request_description,
                    $request_keywords,
                    $request_availability,
                    $request_lat,
                    $request_lng,
                    $request_zoom,
                    $request_addr,
                    $request_phone,
                    $request_open,
                    $request_leader,
                    $request_del_image_middle,
                    $request_del_big_middle,
                    $request_del_pics, $request_e_mail
                    )) {
                        @$cache->delete_cache_files();
                    }
                    header('Location: '.$baseurl.'&action=assortment&id='.$request_parent.'&start='.$request_start);
                    break;
                    // Удаление продукта
                case "delproduct":
                    if (!$permissions["d"]) $main->message_access_denied($this->module_name, $action);
                    global $request_id, $request_category_id, $request_start;
                    $ctg_owners = $this->get_category_owners($request_category_id);
                    if (!$this->test_item_rights("d", "id", $this->table_prefix."_maps_products", $request_id, false, $ctg_owners))
                    $main->message_access_denied($this->module_name, $action);
                    if ($this->delete_product($request_id)) {
                        $lc->delete_internal_links($this->module_name, $CONFIG["maps_products_table"], $request_id);
                        @$cache->delete_cache_files();
                    }
                    header("Location: ".$baseurl."&action=assortment&id=".$request_category_id."&start=".$request_start);
                    break;
                case "suspendctg_checked":
                    if (!$permissions["p"]) $main->message_access_denied($this->module_name, $action);
                    $ctg_owners = $this->get_category_owners($request_parent);
                    global $request_check;
                    if(is_array($request_check) && sizeof($request_check)>0){
                        foreach($request_check as $_v){
                            if($this->test_item_rights("p", "id", $this->table_prefix."_maps_categories", $_v, false, $ctg_owners)){
                                if ($main->suspend($this->table_prefix.'_maps_categories', $_v, 'active')) @$cache->delete_cache_files();
                            }
                        }
                    }
                    $CDBT	=	new NsDbTree($this->table_prefix.'_maps_categories', 'id', $this->CDBT_fields);
                    $parent	=	$CDBT->getParent($_v);
                    header("Location: $baseurl&action=assortment&id=".$parent[0]);
                    exit;
                    break;
                case "activatectg_checked":
                    if (!$permissions["p"]) $main->message_access_denied($this->module_name, $action);
                    $ctg_owners = $this->get_category_owners($request_parent);
                    global $request_check;
                    if(is_array($request_check) && sizeof($request_check)>0){
                        foreach($request_check as $_v){
                            if($this->test_item_rights("p", "id", $this->table_prefix."_maps_categories", $_v, false, $ctg_owners)){
                                if ($main->activate($this->table_prefix.'_maps_categories', $_v, 'active')) @$cache->delete_cache_files();
                            }
                        }
                    }
                    $CDBT	=	new NsDbTree($this->table_prefix.'_maps_categories', 'id', $this->CDBT_fields);
                    $parent	=	$CDBT->getParent($_v);
                    header("Location: $baseurl&action=assortment&id=".$parent[0]);
                    exit;
                    break;
                case "deletectg_checked":
                    if (!$permissions["d"]) $main->message_access_denied($this->module_name, $action);
                    global $request_start, $request_id, $request_parent, $request_check;
                    $ctg_owners = $this->get_category_owners($request_parent);
                    if(is_array($request_check) && sizeof($request_check)>0){
                        foreach($request_check as $_v){
                            if(!$parent){
                                $CDBT	=	new NsDbTree($this->table_prefix.'_maps_categories', 'id', $this->CDBT_fields);
                                $parent	=	$CDBT->getParent($_v);
                                unset($CDBT);
                            }
                            if ($this->test_item_rights("d", "id", $this->table_prefix."_maps_categories", $_v, false, $ctg_owners)){
                                $this->delete_products($where = 'AND category_id='.$_v);
                                $parent = $this->delete_catalog($_v);
                            }
                        }
                        @$cache->delete_cache_files();
                    }
                    header("Location: $baseurl&action=assortment&id=".$parent[0]);
                    exit;
                    break;
                case "deleteprod_checked":
                    if (!$permissions["d"]) $main->message_access_denied($this->module_name, $action);
                    global $request_start, $request_id, $request_parent, $request_check;
                    if(is_array($request_check) && sizeof($request_check)>0){
                        foreach($request_check as $_v){
                            $this->delete_products($where = 'AND id='.$_v);
                        }
                        @$cache->delete_cache_files();
                    }
                    header("Location: ".$baseurl."&action=assortment&id=".$request_id.($start ? "&start=".$request_start : ""));
                    exit;
                    break;
                case "suspendprod_checked":
                    if (!$permissions["p"]) $main->message_access_denied($this->module_name, $action);
                    global $request_start, $request_check, $request_id;
                    if(is_array($request_check) && sizeof($request_check)>0){
                        foreach($request_check as $_v){
                            if ($main->suspend($this->table_prefix.'_maps_products', $_v, 'active')) @$cache->delete_cache_files();
                        }
                    }
                    header("Location: $baseurl&action=assortment&id=".$request_id.($start ? "&start=".$request_start : ""));
                    exit;
                    break;
                case "activateprod_checked":
                    if (!$permissions["p"]) $main->message_access_denied($this->module_name, $action);
                    global $request_start, $request_check, $request_id;
                    if(is_array($request_check) && sizeof($request_check)>0){
                        foreach($request_check as $_v){
                            if ($main->activate($this->table_prefix.'_maps_products', $_v, 'active')) @$cache->delete_cache_files();
                        }
                    }
                    header("Location: ".$baseurl."&action=assortment&id=".$request_id.($start ? "&start=".$request_start : ""));
                    exit;
                    break;
                    // Добавить связанный товар
                case "addconcrn":
                    if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
                    global $request_id, $request_concrn_id, $request_category_id;
                    $ctg_owners = $this->get_category_owners($request_category_id);
                    if (!$this->test_item_rights("e", "id", $this->table_prefix."_maps_products", $request_id, false, $ctg_owners))
                    $main->message_access_denied($this->module_name, $action);
                    $this->addConcernedProduct($request_id, $request_concrn_id);
                    header("Location: ".$baseurl."&&action=editproduct&id=".$request_id."&category_id=".$request_category_id);
                    exit;
                    break;
                    // Удалить связанный товар
                case "delconcrn":
                    if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
                    global $request_id, $request_concrn_id, $request_category_id;
                    $ctg_owners = $this->get_category_owners($request_category_id);
                    if (!$this->test_item_rights("d", "id", $this->table_prefix."_maps_products", $request_id, false, $ctg_owners))
                    $main->message_access_denied($this->module_name, $action);
                    $this->delConcernedProduct($request_id, $request_concrn_id);
                    header("Location: ".$baseurl."&&action=editproduct&id=".$request_id."&category_id=".$request_category_id);
                    exit;
                    break;
                    // Редактирование прав товара
                case 'editrights':
                    if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
                    global $request_id, $request_category_id, $request_start;
                    if (!$this->test_item_rights("e", "id", $this->table_prefix."_maps_products", $request_id, true))
                    $main->message_access_denied($this->module_name, $action);
                    if (!$this->show_rights_form($this->table_prefix."_maps_products", "product_title", $request_id,
                    "&id=".$request_id."&category_id=".$request_category_id."&start=".$request_start, $this->_msg["Good"])) {
                        header('Location: '.$baseurl.'&action=assortment&id='.$request_category_id.'&start='.$request_start);
                    }
                    if ($request_type == "JsHttpRequest") {
                        require_once RP."inc/class.JsHttpRequest.php";
                        $JsHttpRequest =& new JsHttpRequest("utf-8");
                    }
                    break;
                    // Сохранение прав товара
                case 'saverights':
                    if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
                    global $request_id, $request_category_id, $request_start, $request_rights;
                    if (!$this->test_item_rights("e", "id", $this->table_prefix."_maps_products", $request_id, true))
                    $main->message_access_denied($this->module_name, $action);
                    $this->save_rights_form($this->table_prefix."_maps_products", $request_id, $request_rights);
                    if ($request_type == "JsHttpRequest") {
                        require_once RP."inc/class.JsHttpRequest.php";
                        $JsHttpRequest =& new JsHttpRequest("utf-8");
                        $_RESULT = array(
                        "res"	=> 1,
                        "id"	=> $request_id,
                        );
                    } else {
                        header('Location: '.$baseurl.'&action=assortment&id='.$request_category_id.'&start='.$request_start);
                    }
                    exit;
                    break;
                    // Редактирование свойств блока
                case 'properties':
                    if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
                    global $module_id, $request_field, $request_block_id, $title;
                    $main->include_main_blocks('_block_properties.html', 'main');
                    $tpl->prepare();
                    if ($main->show_actions($request_field, '', $this->block_main_module_actions, $this->block_module_actions)) {
                        $main->show_linked_pages($module_id, $request_field);
                    }
                    $tpl->assign(array( '_ROOT.title'		=> $title,
                    '_ROOT.username'	=> $_SESSION['session_login'],
                    '_ROOT.password'	=> $_SESSION['session_password'],
                    '_ROOT.name'		=> $this->module_name,
                    '_ROOT.lang'		=> $lang,
                    '_ROOT.block_id'	=> $request_block_id,
                    ));
                    $this->main_title	= $this->_msg["Block_properties"];
                    // Load JsHttpRequest backend.
                    require_once RP."inc/class.JsHttpRequest.php";
                    // Create main library object. You MUST specify page encoding!
                    $JsHttpRequest =& new JsHttpRequest("utf-8");
                    break;
                    // Создание объекта для дальнейшего использования
                    
                case 'metro':
                    if (!$permissions['r']) {
                        $main->message_access_denied($this->module_name, $action);
                    }
                    $main->include_main_blocks_2("{$this->module_name}_{$action}.html", $this->tpl_path);
                    $tpl->assignInclude('metroset', $this->tpl_path . $this->module_name . "_metroset.html" );
                    $tpl->prepare();

                    $assign = array(
                        'baseurl' => $baseurl,
                        'action' => $action,
                    );
                    $tpl->assign($assign);
                    
                    $tpl->assignList('metro_', $this->getMetroList(), $assign);
                    
                    $this->main_title	= "Метро";
                    break;
                    
                case 'metroset':
                    if (!$permissions['e']) {
                        $main->message_access_denied($this->module_name, $action);
                    }
                    
                    if (! empty($_POST)) {
                        $this->setMetro($_POST);
                        Module::go_back($baseurl.'&action=metro');
                    }                    
                    
                    $metro = $this->getMetro($_GET['id']);
                    if (!$metro) {
                        Module::go_back($baseurl.'&action=metro');
                    }
                    $main->include_main_blocks_2("{$this->module_name}_{$action}.html", $this->tpl_path);
                    $tpl->prepare();
                    
                    $assign = array(
                        'baseurl' => $baseurl,
                        'action' => $action,
                        'id' => $metro['id'],
                        'title' => $metro['title'],
                        'file' => $metro['file'],
                        'file_path' => $metro['file_path'],
                    );
                    $tpl->assign($assign);
                    
                    if ($metro['file']) {
                        $tpl->newBlock('file');
                        $tpl->assign($assign);
                    }
                    
                    $this->main_title	= "Редактировать карту метро";
                    break;
                    
                case 'metrodel':
                    if (!$permissions['d']) {
                        $main->message_access_denied($this->module_name, $action);
                    }
                    
                    $this->delMetro($_GET['id']);
                    Module::go_back();

                    break;
                    
                case 'metrostat':
                    if (!$permissions['r']) {
                        $main->message_access_denied($this->module_name, $action);
                    }
                    
                    $metro = $this->getMetro($_GET['id']);
                    if (!$metro) {
                        Module::go_back($baseurl.'&action=metro');
                    }
                    
                    $main->include_main_blocks_2("{$this->module_name}_{$action}.html", $this->tpl_path);
                    $tpl->assignInclude('metrostatset', $this->tpl_path . $this->module_name . "_metrostatset.html" );
                    $tpl->prepare();

                    $assign = array(
                        'baseurl' => $baseurl,
                        'action' => $action,
                        'metro_id' => $metro['id'],
                    );
                    $tpl->assign($assign);
                    
                    $tpl->assignList('metrostat_', $this->getMetroStatList($_GET['id']), $assign);
                    
                    $this->main_title	= 'Станции метро &mdash; '.$metro['title'];
                    break;
                    
                case 'metrostatset':
                    if (!$permissions['e']) {
                        $main->message_access_denied($this->module_name, $action);
                    }
                    
                    if (! empty($_POST)) {
                        $id = $this->setMetroStat($_POST);
                        if ($id) {
                            $stat = $this->getMetroStat($id);
                            Module::go_back($baseurl.'&action=metrostat&id='.$stat['metro_id']);
                        } else {
                            Module::go_back($baseurl.'&action=metro');
                        }
                    }                    
                    
                    $stat = $this->getMetroStat($_GET['id']);
                    if (!$stat) {
                        Module::go_back($baseurl.'&action=metro');
                    }
                    $main->include_main_blocks_2("{$this->module_name}_{$action}.html", $this->tpl_path);
                    $tpl->prepare();
                    
                    $assign = array(
                        'baseurl' => $baseurl,
                        'action' => $action
                    ) + $stat;
                    $tpl->assign($assign);
                    
                    $this->main_title	= "Редактировать станцию метро &mdash; {$stat['station']}";
                    break;
                    
                case 'metrostatdel':
                    if (!$permissions['d']) {
                        $main->message_access_denied($this->module_name, $action);
                    }
                    
                    $this->delMetroStat($_GET['id']);
                    Module::go_back();

                    break;
                    
            case 'import':
                if (!$permissions["r"]) {
                    $main->message_access_denied($this->module_name, $action);
                }
                $main->include_main_blocks_2($this->module_name."_".$action.".html", $this->tpl_path);
                $tpl->prepare();
                
                $tpl->assign(array(
                    'baseurl' => $baseurl,
                    'action' => $action,
                ));
                $this->show_ptypes();
                if ($_POST['import'] && $_POST['ptype']>0 && is_uploaded_file($_FILES['csv_file']['tmp_name'])
                    && ($fp = fopen($_FILES['csv_file']['tmp_name'], 'r'))
                ) {
                    $ptype = (int)$_POST['ptype'];
                    $ctgr_list = array();
                    $metro_list = array();
                    $item_list = array();
                    $db->query("SELECT id, title FROM ".$this->table_prefix."_maps_categories");
                    while ($db->next()) {
                        $ctgr_list[$db->Record['id']] = abo_strtolower($db->Record['title']);
                        $ctgr_list[$db->Record['id']] = preg_replace("/\W/u", '', $ctgr_list[$db->Record['id']]);
                    }
                    $db->query("SELECT id, station FROM ".$this->table_prefix."_maps_metro_stat");
                    while ($db->next()) {
                        $metro_list[$db->Record['id']] = abo_strtolower($db->Record['station']);
                    }
                    $db->query("SELECT id FROM ".$this->table_prefix."_maps_products WHERE ptype_id=".$ptype);
                    while ($db->next()) {
                        $item_list[] = $db->Record['id'];
                    }
                    if ($_POST['clear'] && !empty($item_list)) {
                        $db->query("DELETE FROM ".$this->table_prefix."_maps_products WHERE ptype_id=".$ptype);
                        $db->query("DELETE FROM ".$this->table_prefix."_maps_prod_stat WHERE prod_id IN (".implode(',', $item_list).")");
                    }
                    //print_r($item_list); echo "\n<hr>\n";
                    $row = 0;
                    $msg = '';
                    $item_cnt = 0;
                    $ctgr_cnt = 0;
                    while (($data = fgetcsv($fp, 2049, ";")) !== FALSE) {
                        $row++;                        
                        foreach ($data as $key => $val) {                            
                            $data[$key] = iconv('WINDOWS-1251', 'UTF-8', trim($val));
                        }
                        /**
                         * $data = ['Город', 'Низвание', 'Адресс', 'Время работы']
                         */
                        $city = preg_replace("/^г\.\s*/u", '', $data[0]);
                        $_city = preg_replace("/\W/u", '', abo_strtolower($city));
                        $parent_id = array_search($_city, $ctgr_list);
                        if (! $parent_id) {
                            $query = $city;
                            $ret = file_get_contents('http://geocode-maps.yandex.ru/1.x/?results=1&format=json&geocode='.urlencode($query));
                            $ret = json_decode($ret);
                            $lat = 0;
                            $lng = 0;
                            if (count($ret->response->GeoObjectCollection->featureMember)) {
                                $pos = $ret->response->GeoObjectCollection->featureMember[0]->GeoObject->Point->pos;
                                $pos = explode(' ', $pos);
                                $lng = $pos[0];
                                $lat = $pos[1];
                            } else {
                                $msg .= "Стр. {$row}.Не определены координаты объекта - \"{$query}\".<br>";
                            }
                            //echo "Регоин - ".$query." {$lng} {$lat}<br>";                            
                            $db->set($this->table_prefix."_maps_categories", array(
                                'parent_id' => 1,
                                'active' => 1,
                                'title' => $city,
                                //'rank' => 60+$row,
                                'owner_id' => 1,
                                'usr_group_id' => 1,
                                'rights' => 4081,
                                'lng' => $lng,
                                'lat' => $lat,
                                'zoom' => $CONFIG['maps_map_zoom']
                            ));
                            $ctgr_cnt++;
                            $parent_id = $db->lid();
                            $ctgr_list[$parent_id] = $_city;
                        }

                        $item_id = 0;
                        if (! $item_id) {
                            $query = $data[0].', '.$data[2];
                            $ret = file_get_contents('http://geocode-maps.yandex.ru/1.x/?results=1&format=json&geocode='.urlencode($query));
                            $ret = json_decode($ret);
                            $lat = 0;
                            $lng = 0;
                            if (count($ret->response->GeoObjectCollection->featureMember)) {
                                $pos = $ret->response->GeoObjectCollection->featureMember[0]->GeoObject->Point->pos;
                                $pos = explode(' ', $pos);
                                $lng = $pos[0];
                                $lat = $pos[1];
                            } else {
                                $msg .= "Стр. {$row}.Не определены координаты объекта - \"{$query}\".<br>";
                            }                            
                            //echo "Объект - ".$query." {$lng} {$lat}<br>";
                            $open = abo_strtolower($data[3]);
                            $db->set($this->table_prefix."_maps_products", array(
                                    'category_id' => $parent_id,
                                    'active' => 1,
                                    'group_id' => 0,
                                    'ptype_id' => $ptype,
                                    'product_title' => $data[1],
                                    'addr' => $data[2],
                                    'open' => 'да' == $open ? 'Круглосуточно' : ('нет' == $open ? '' : $data[3]),
                                    'leader' => 'да' == $open ? 1 : 0,
                                    'product_inf' => '',
                                    'product_description' => '',
                                    'e_mail' => '',
                                    'owner_id' => 1,
                                    'usr_group_id' => 1,
                                    'rights' => 4081,
                                    'lng' => $lng,
                                    'lat' => $lat,
                                    'zoom' => $CONFIG['maps_map_zoom']+2
                            ));
                            $msg .= "Стр. {$row}. Добавлен пункт - `{$data[1]}`, ".$query."<br>";
                            $item_cnt++;
                        }
                        //print_r($data); echo "<hr>";
                    }
                    $CDBT = new NsDbTree($this->table_prefix."_maps_categories", "id", $this->CDBT_fields);
                    $CDBT->fixTree();
                    $ret = true;
                    $msg .= "Загружено категорий - {$ctgr_cnt}, товаров - {$item_cnt}.";
                    fclose($fp);
                    $tpl->newBlock('msg');
                    $tpl->assign(array(
                        'msg' => $msg
                    ));
                }

                $this->main_title = "Импорт";
                break;
                    
            case 'service_list':
                if (!$permissions["r"]) {
                    $main->message_access_denied($this->module_name, $action);
                }
                $main->include_main_blocks_2($this->module_name."_".$action.".html", $this->tpl_path);
                $tpl->assignInclude('form', $this->tpl_path . $this->module_name . "_service_set.html" );
                $tpl->prepare();
                
                $assign = array(
                    'baseurl' => $baseurl,
                    'action' => $action,
                );
                $tpl->assign($assign);
                
                $tpl->assignList('service_', $this->getServiceList(), $assign);
                
                $this->main_title = $this->_msg['service_list'];
                break;
                
            case 'service_set':
                if (!$permissions['e']) {
                    $main->message_access_denied($this->module_name, $action);
                }
                
                if (! empty($_POST)) {
                    $this->setService($_POST);
                    Module::go_back($baseurl.'&action=service_list');
                }
                
                $service = $this->getService($_GET['id']);
                if (!$service) {
                    Module::go_back($baseurl.'&action=service_list');
                }
                $main->include_main_blocks_2("{$this->module_name}_{$action}.html", $this->tpl_path);
                $tpl->prepare();
                
                $assign = array(
                    'baseurl' => $baseurl,
                    'action' => $action,
                    'id' => $service['id'],
                    'title' => $service['title'],
                    'file' => $service['file'],
                    'file_path' => $service['file_path'],
                );
                $tpl->assign($assign);
                
                if ($service['file_path']) {
                    $tpl->newBlock('file');
                    $tpl->assign($assign);
                }
                
                $this->main_title	= "Редактировать услугу";
                break;
                
            case 'service_set_rank':
                if (!$permissions['e']) {
                    $main->message_access_denied($this->module_name, $action);
                }
                
                if (! empty($_POST['rank'])) {
                    global $db;
                    foreach ($_POST['rank'] as $id => $val) {
                        $db->set($this->table_prefix . '_maps_service', array(
                            'rank' => (int)$val
                        ), array('id' => (int)$id));
                    }
                }
                Module::go_back($baseurl.'&action=service_list');
                
            case 'service_del':
                if (!$permissions['d']) {
                    $main->message_access_denied($this->module_name, $action);
                }
                
                $this->delService($_GET['id']);
                Module::go_back();
                
                    break;
                
                default:
                    $main->include_main_blocks();
                    $tpl->prepare();
            }
            //--------------------------- конец обработки действий из админ части --------------------------//
        }
    }
    function get_tree_2($transurl, $show_count) {
        global $db, $CONFIG, $server, $lang;
        $show_count;
        $query = $show_count
        ? 'SELECT C.id, C.parent_id, C.title, C.clevel, C.rank, COUNT(P.id) as cnt FROM ' . $server . $lang . '_maps_categories AS C
			   LEFT JOIN ' . $server . $lang . '_maps_categories AS C1 ON ( C1.cleft >=  C.cleft AND C1.cright <=  C.cright)
			   LEFT JOIN ' . $server . $lang . '_maps_products AS P ON category_id=C1.id AND P.active=1 WHERE C.active=1
			   GROUP BY C.id ORDER BY C.rank, C.id'
        : 'SELECT id, parent_id, title, clevel, rank FROM ' . $server . $lang . '_maps_categories WHERE active=1 ORDER BY rank, id';
        $db->query($query);
        if ($db->nf() > 0) {
            for ($i=0; $i < $db->nf(); $i++) {
                $db->next_record();
                $category[$i]['id']		= $db->f('id');
                $category[$i]['parent_id'] = $db->f('parent_id');
                $category[$i]['name']	  = $db->f('title');
                $category[$i]['level']	 = $db->f('clevel');
                $category[$i]['cnt']	 = $show_count ? $db->f('cnt') : 0;
            }
            $html = $this->get_sub_tree($category, $transurl, 1, 0, $show_count);
        } else {
            $html = '';
        }
        return $html;
    }
    function get_sub_tree($array, $transurl, $id = 0, $level = 0, $show_count = 0) {
        static $mod;
        if(!isset($mod)) {
            $mod = $GLOBALS['CONFIG']['rewrite_mod']&&$this->transReplace($null);
        }
        $html = $level == 0 ? '<ul id="mn">' : '<ul>';
        for ($i=0; $i < ($iii = sizeof($array)); $i++) {
            if ((($id == $array[$i]['parent_id']) && ($array[$i]['level'] == ($level+1))) || (($id == $array[$i]['parent_id']) && ($level == 0))) {
                $array_id		= $array[$i]['id'];
                $array_level	= $array[$i]['level'];
                $sub_html = $this->get_sub_tree($array, $transurl, $array_id, $array_level, $show_count);
                $cnt = $array[$i]['cnt'] ? " (".$array[$i]['cnt'].")" : "";
                $link = ($mod)
                ? $transurl . $this->getElementPath($array[$i]['id'], 'ctg')
                : $transurl . 'id='.$array[$i]['id'].'&action=assortment&level='.$array[$i]['level'].'&parent='.$array[$i]['id'];
                if ($array[$i]['id'] == $_GET['parent']) {
                    @$html .= '<li class="current"><a href="'.$link.'">'.$array[$i]['name'].'</a>'.$cnt.$sub_html.'</li>';
                } else {
                    @$html .= '<li><a href="'.$link.'">'.$array[$i]['name'].'</a>'.$cnt.$sub_html.'</li>';
                }
            }
        }
        $html .= '</ul>';
        $html == '<ul id="mn"></ul>' ? $html = '' : $html;
        $html == '<ul></ul>' ? $html = '' : $html;
        return $html;
    }
    function getCategsTree() {
        GLOBAL $CONFIG, $server, $lang, $db;
        $db->query('SELECT id, title, clevel FROM '.$this->table_prefix.'_maps_categories WHERE active = 1 AND clevel > 0 ORDER BY cleft');
        if ($db->nf() > 0) {
            for ($i = 0; $i < $db->nf(); $i++) {
                $db->next_record();
                $arr[$i]['id']   = $db->f('id');
                $arr[$i]['title'] = $db->f('title');
                $arr[$i]['level'] = $db->f('clevel');
            }
            return $arr;
        }
        return FALSE;
    }
    function getSearchProds($search_data, $max_rows, $start) {
        global $db, $server, $lang, $CONFIG, $baseurl;
        $this->transReplace($baseurl);
        $pname		= trim($search_data["pname"]);
        $ptype_id	= (int)$search_data["ptype_id"];
        $price1		= (int)$search_data["pprice1"]*100;
        $price2		= (int)$search_data["pprice2"]*100;
        $max_rows	= (int)$max_rows;
        $start		= (int)$start ? ($start - 1) : $start = 0;
        $category_id	= (int)$search_data["category"];
        if ($pname) {
            $line .= ' AND p.product_title LIKE "%'.$pname.'%"';
            $tbl['search_params'] .= "&sdata[pname]=".$pname;
        }
        if ($ptype_id) {
            $line .= ' AND p.ptype_id='.$ptype_id;
            $tbl['search_params'] .= "&sdata[ptype_id]=".$ptype_id;
        }
        if ($category_id) {
            $line .= ' AND p.category_id = '.$category_id;
            $tbl['search_params'] .= "&sdata[category]=".$category_id;
        }
        $tbl['tables']	= $this->table_prefix.'_maps_products p, '.$this->table_prefix.'_maps_ptypes pt ';
        $tbl['where']	= ' p.active = 1 AND p.ptype_id=pt.id'.$line;

        $query = 'SELECT p.id, p.product_title, p.product_inf, p.image_middle, p.image_big,
						   p.price_1, p.price_2, p.price_3, p.price_4, p.price_5, p.currency,
						   p.lat, p.lng, p.zoom, p.addr, p.phone, p.open, ptype_id, leader, pt.ptype_name,
						    pt.link  AS ptype_link, pt.icon  AS ptype_icon
					FROM '.$tbl['tables'].'
					WHERE '.$tbl['where']
        .($max_rows ? ' LIMIT '.($start*$max_rows).', '.$max_rows : '');
        $db->query($query);
        $row_cnt = $db->nf();
        if ($row_cnt > 0) {
            $start_nn = $start*$max_rows;
            for ($i = 0; $i < $db->nf(); $i++) {
                $db->next_record();
                $img = $db->f('image_middle');
                $img = $img && file_exists(RP.$CONFIG['maps_img_path'].$img) ? '/'.$CONFIG['maps_img_path'].$img : "";
                $b_img = $db->f('image_big');
                $b_img = $b_img && file_exists(RP.$CONFIG['maps_img_path'].$b_img) ? '/'.$CONFIG['maps_img_path'].$b_img : "";
                $arr[$i]['prod_num']		= $start_nn+$i+1;
                $arr[$i]['prod_id']			= $prod_id = $db->f('id');
                $arr[$i]['prod_link']		= ($CONFIG['rewrite_mod']) ? $baseurl.$this->getElementPath($prod_id, 'good') : $baseurl.'&action=shwprd&id='.$prod_id;
                $arr[$i]['prod_title']		= $db->f('product_title');
                $arr[$i]['prod_descr']		= $db->f('product_inf');
                $arr[$i]['prod_image']		= $img;
                $arr[$i]['prod_image_big']	= $b_img;
                $arr[$i]['prod_availability']	= $db->f('product_availability');
                $arr[$i]['group_title']		= $db->f('group_title');
                $arr[$i]['ptype_id']		= $db->f('ptype_id');
                $arr[$i]['ptype_name']		= $db->f('ptype_name');
                $arr[$i]['ptype_link']		= $db->f('ptype_link');
                $arr[$i]['ptype_icon']		= $db->f('ptype_icon');
                $arr[$i]['ptype_icon_path']		= $arr[$i]['ptype_icon'] && file_exists(RP.$CONFIG['maps_ptype_img_path'].$arr[$i]['ptype_icon'])
                    ? "/".$CONFIG['maps_ptype_img_path'].$arr[$i]['ptype_icon']
                    : "";
                $arr[$i]['prod_lat']		= $db->f('lat');
                $arr[$i]['prod_lng']		= $db->f('lng');
                $arr[$i]['prod_zoom']		= $db->f('zoom');
                $arr[$i]['prod_zoom'] = $arr[$i]['prod_zoom'] ? $arr[$i]['prod_zoom'] : $this->default_zoom;
                $arr[$i]['prod_addr']		= $db->f('addr');
                $arr[$i]['prod_phone']		= $db->f('phone');
                $arr[$i]['prod_open']		= $db->f('open');
                $arr[$i]['leader'] = $db->f('leader');
            }
        }
        $arr["nav_str"] = $tbl;
        if ($max_rows) {
            //временная заглушка на количество страниц в результатах поиска
            $db->query('SELECT COUNT(p.id) AS cnt FROM '.$tbl['tables'].' WHERE '.$tbl['where']);
            $db->next_record();
            $row_cnt = $db->Record['cnt'];
        }
        $arr["nav_str"]["result"] = $row_cnt;
        unset($sql);
        $db->free();
        //
        return $arr;
    }
    function getProduct($id) {
        global $db, $server, $lang, $CONFIG, $baseurl;
        $id = (int)$id;
        if (!$id) {
            return FALSE;
        }
        $db->query('SELECT	a.id AS id,
							a.category_id AS category_id,
							a.ptype_id AS ptype_id,
							a.product_code AS product_code,
							a.product_title AS product_title,
							a.product_inf AS product_inf,
							a.product_description AS product_description,
							a.image_middle AS image_middle,
							a.image_big AS image_big,
							a.product_availability AS product_availability,
							a.active AS active,
							a.rank AS rank,
							a.leader,
							a.lat,
							a.lng,
							a.zoom,
							a.addr,
							a.phone,
							a.open,
                            a.e_mail,
							a.description AS description,
							a.keywords AS keywords,
							b.ptype_name	AS ptype_title,
							b.link	AS ptype_link,
							b.icon	AS ptype_icon,
							c.title AS categ_title,
							c.page_description AS ctg_description,
							c.keywords AS ctg_keywords,
                            c.img AS ctg_img, c.img_big AS ctg_img_big
						FROM '.$this->table_prefix.'_maps_products a
						JOIN '.$this->table_prefix.'_maps_categories c
						LEFT JOIN '.$this->table_prefix.'_maps_ptypes b ON a.ptype_id = b.id
						WHERE a.id = '.$id.' AND
							  a.active = 1 AND
							  a.category_id = c.id');
        if ($db->next()) {
                $i = 0;
                $arr[$i]['id']						= $db->f('id');
                $arr[$i]['category_id']				= $db->f('category_id');
                $arr[$i]['product_categ']			= $db->f('categ_title');
                $arr[$i]['ptype_id']				= $db->f('ptype_id');
                $arr[$i]['product_ptype_title']		= $db->f('ptype_title');
                $arr[$i]['product_ptype_link']		= $db->f('ptype_link');
                $arr[$i]['ptype_icon']      		= $db->f('ptype_icon');
                $arr[$i]['ptype_icon_path']		= $arr[$i]['ptype_icon'] && file_exists(RP.$CONFIG['maps_ptype_img_path'].$arr[$i]['ptype_icon'])
                    ? "/".$CONFIG['maps_ptype_img_path'].$arr[$i]['ptype_icon']
                    : "";
                $arr[$i]['product_title']			= $db->f('product_title');
                $arr[$i]['product_code']		    = $db->f('code');
                $arr[$i]['product_inf']				= $db->f('product_inf');
                $arr[$i]['product_description']		= $db->f('product_description');
                $arr[$i]['product_image']			= $db->f('image_middle');
                $arr[$i]['product_image_big']		= $db->f('image_big');
                $arr[$i]['product_availability']	= $db->f('product_availability');
                $arr[$i]['active']					= $db->f('active');
                $arr[$i]['rank']					= $db->f('rank');
                $arr[$i]['leader']					= $db->f('leader');
                $arr[$i]['description']				= $db->f('description');
                $arr[$i]['keywords']				= $db->f('keywords');
                $arr[$i]['spisok']					= $baseurl.'&action=assortment&id='.$db->f('category_id');
                $arr[$i]['ctg_description']			= $db->f('ctg_description');
                $arr[$i]['ctg_keywords']			= $db->f('ctg_keywords');
                $arr[$i]['ctg_img']			= $db->f('ctg_img');
                $arr[$i]['ctg_img_big']	    = $db->f('ctg_img_big');
                $arr[$i]['lat']			= $db->f('lat');
                $arr[$i]['lng']			= $db->f('lng');
                $arr[$i]['zoom']			= $db->f('zoom') ? $db->f('zoom') : $this->default_zoom;
                $arr[$i]['addr']			= $db->f('addr');
                $arr[$i]['phone']			= $db->f('phone');
                $arr[$i]['open']			= $db->f('open');
                $arr[$i]['email']			= $db->f('e_mail');
                $db->query("SELECT id, station, color FROM {$this->table_prefix}_maps_metro_stat S INNER JOIN {$this->table_prefix}_maps_prod_stat PS"
                    ." ON S.id=PS.stat_id WHERE prod_id=".$db->Record['id']
                );
                while ($db->next_record()) {
                    $arr[$i]['stat_list'][$db->Record['id']] = array(
                        'id' => $db->Record['id'],
                        'station' => $db->Record['station'],
                        'color' => $db->Record['color']
                    );
                }
            return $arr;
        }
        return FALSE;
    }
    function getCategory($id = NULL) {
        global $db, $baseurl;
        $db->query('SELECT * FROM '.$this->table_prefix.'_maps_categories WHERE id = '.intval($id));
        $ret = false;
        if ($db->next()) {
            $ret = $db->Record;
            $ret['category_link'] = $baseurl.'&action=assortment&id='.$db->Record['id'];
        }
        return $ret;
    }
    function getProdsOfSubCategs($ctgr_id = NULL, $how = '', $start = 1, $filter = array()) {
        global $db, $server, $lang, $CONFIG, $baseurl;
        $clause = '';
        if ($ctgr_id >= 1) {
            $clause = ' category_id='.intval($ctgr_id).' AND';
        }
        if ($filter['ptype']>0) {
            $clause .= ' ptype_id='.intval($filter['ptype']).' AND';
        }
        if ($filter['service'] && is_array($filter['service'])) {
            $service = array();
            foreach ($filter['service'] as $val) {
                if ($val > 0) {
                    $service[] = $val;
                }
            }
            if ($service) {
                $clause .= ' service_id IN ('.implode(',', $service).') AND';
            }
        }
        $how = (int)$how;
        if (!$start) {$start = 0;} else {$start -= 1;}
        if (is_numeric($how)) {
            $start   *= $how;
            $how      = ', '.$how;
        } else {$how = '';}

        $db->query('SELECT DISTINCT P.id, product_title, product_inf, product_description, image_middle, image_big,
product_availability, lat, lng, zoom, addr, phone, open, e_mail, leader, currency,
ptype_id, ptype_name, PT.link as ptype_link, PT.icon as ptype_icon
FROM '.$this->table_prefix.'_maps_products AS P
LEFT JOIN '.$this->table_prefix.'_maps_ptypes AS PT ON P.ptype_id = PT.id
LEFT JOIN '.$this->table_prefix.'_maps_prod_service AS S ON S.prod_id = P.id
WHERE'.$clause.' P.active = 1
ORDER BY P.'.$CONFIG['maps_prod_order_by'].' LIMIT '.$start.$how);
        //echo $db->sql."<br>";
        if ($db->nf() > 0) {
            $_baseurl = preg_replace('/[\?&]$/', '', $filter['transurl'] ? $filter['transurl'] : $baseurl); 
            $patt = array("/^пр\.\s+/iu", "/^ул\.\s+/iu", "/^с\.\s+/iu", "/^проспект\s+/iu");
            for($i = 0; $i < $db->nf(); $i++) {
                $db->next_record();
                $img = $db->f('image_middle');
                $img = $img && file_exists(RP.$CONFIG['maps_img_path'].$img) ? "/".$CONFIG['maps_img_path'].$img : "";
                $b_img = $db->f('image_big');
                $b_img = $b_img && file_exists(RP.$CONFIG['maps_img_path'].$b_img) ? "/".$CONFIG['maps_img_path'].$b_img : "";
                $prod_id = $db->f('id');
                $ids[] = $prod_id;
                $arr[$prod_id]['prod_num']			= ($i+1);
                $arr[$prod_id]['prod_id']				= $prod_id;
                $arr[$prod_id]['prod_link']			= $_baseurl.$this->getElementPath($prod_id, 'good');
                $arr[$prod_id]['prod_title']			= $db->f('product_title');
                $arr[$prod_id]['prod_descr']			= nl2br($db->f('product_inf'));
                $arr[$prod_id]['prod_image']			= $img;
                $arr[$prod_id]['prod_image_big']		= $b_img;
                $arr[$prod_id]['']	= $db->f('product_availability');
                $arr[$prod_id]['prod_description']	= $db->f('product_description');
                $arr[$prod_id]['add_to_cart_link']	= $add_to_cart_link.$prod_id;
                $arr[$prod_id]['ptype_id']			= $db->f('ptype_id');
                $arr[$prod_id]['ptype_name']			= $db->f('ptype_name');
                $arr[$prod_id]['ptype_link']			= $db->f('ptype_link');
                $arr[$prod_id]['ptype_icon']			= $db->f('ptype_icon');
                $arr[$prod_id]['ptype_icon_path']		= $arr[$prod_id]['ptype_icon'] && file_exists(RP.$CONFIG['maps_ptype_img_path'].$arr[$prod_id]['ptype_icon'])
                    ? "/".$CONFIG['maps_ptype_img_path'].$arr[$prod_id]['ptype_icon']
                    : "";
                $arr[$prod_id]['prod_lat']		= $db->f('lat');
                $arr[$prod_id]['prod_lng']		= $db->f('lng');
                $arr[$prod_id]['prod_zoom']		= $db->f('zoom');
                $arr[$prod_id]['prod_zoom'] = $arr[$prod_id]['prod_zoom'] ? $arr[$prod_id]['prod_zoom'] : $this->default_zoom;
                $arr[$prod_id]['prod_addr']		= $db->f('addr');
                $arr[$prod_id]['prod_addr_clean']		= preg_replace($patt, '', $arr[$prod_id]['prod_addr']);
                $arr[$prod_id]['prod_phone']		= $db->f('phone');
                $arr[$prod_id]['prod_open']		= $db->f('open');
                $arr[$prod_id]['prod_email']		= $db->f('e_mail');                
                $arr[$prod_id]['leader']		= $db->f('leader');
                $arr[$prod_id]['leader_str']	= $db->f('leader') ? 'Круглосуточно' : '';
                $arr[$prod_id]['currency']		= $db->f('currency');
                //if (preg_match("/.*(\#[0-9a-f]{3,6});.*/i", $db->Record['metro_content'], $m)) {
                //    $arr[$prod_id]['metro_color'] = $m[1];
                //}
            }
            
            $db->query("SELECT prod_id, S.* FROM {$this->table_prefix}_maps_metro_stat S INNER JOIN {$this->table_prefix}_maps_prod_stat PS"
                ." ON S.id=PS.stat_id WHERE prod_id IN (".implode(',', $ids).")"
            );
            while ($db->next_record()) {
                $arr[$db->Record['prod_id']]['stat_list'][$db->Record['id']] = array(
                    'id' => $db->Record['id'],
                    'station' => $db->Record['station'],
                    'color' => $db->Record['color'],
                );
            }
            
            $db->query("SELECT prod_id, S.* FROM {$this->table_prefix}_maps_service S INNER JOIN {$this->table_prefix}_maps_prod_service PS"
                ." ON S.id=PS.service_id WHERE prod_id IN (".implode(',', $ids).")"
            );
            while ($db->next_record()) {
                $arr[$db->Record['prod_id']]['service_list'][$db->Record['id']] = array(
                    'id' => $db->Record['id'],
                    'title' => $db->Record['title'],
                    'file' => $db->Record['file']
                );
            }
            
            if ('addr' == $CONFIG['maps_prod_order_by']) {
                uksort($arr, create_function('$a,$b', 'return strncasecmp($a[\'prod_addr_clean\'], $b[\'prod_addr_clean\'], 3);'));
            }
            return $arr;
        }
        
        return FALSE;
    }
    function getSubCategsForRootCateg($prp = NULL) {
        global $db, $server, $lang, $baseurl, $CONFIG;
        $this->transReplace($baseurl);
        $columns = 3;
        if (is_numeric($prp)) {
            $db->query('SELECT id, title, description, img
                               FROM '.$this->table_prefix.'_maps_categories
                               WHERE parent_id = '.((int)$prp).' AND active = 1
                               ORDER BY '.$CONFIG['maps_ctg_order_by']);
        } else if ('all' == $prp) {
            $db->query('SELECT id, title, img
                               FROM '.$this->table_prefix.'_maps_categories
                               WHERE clevel = 1 AND active = 1
                               ORDER BY '.$CONFIG['maps_ctg_order_by']);
        }
        if ($db->nf() > 0) {
            for($i = 0; $i < $db->nf(); $i++) {
                $db->next_record();
                $arr[$i]['ctg_id']		= $db->f('id');
                if($CONFIG['rewrite_mod'] && $this->transReplace($null)){
                    $link = $baseurl. $this->getElementPath($db->f("id"), 'ctg');
                }
                else {
                    $link = $baseurl.'&action=assortment&id='.$db->f('id');
                }
                $arr[$i]['ctg_link']	= $link;
                $arr[$i]['ctg_id']	= $db->f('id');
                $arr[$i]['ctg_name']	= $db->f('title');
                $arr[$i]['ctg_descr']	= $db->f('description');
                $arr[$i]['ctg_img']		= $db->f('img');
                if($i % $columns == 0)
                $arr[$i]['row_start'] = "<tr>";
                else
                $arr[$i]['row_start'] = "";
                if($i % $columns == $columns - 1)
                $arr[$i]['row_end'] = "</tr>";
                else
                $arr[$i]['row_end'] = "";
            }
            return $arr;
        }
        return FALSE;
    }
    // вывести навигационную строчку, отображающую путь к текущей категории
    function show_nav_path($id = 1, $transurl = "?", $product_id = 0) {
        GLOBAL $tpl;
        list($level, $path) = $this->get_nav_path($id, $transurl, $product_id);
        $tpl->assign(array(
        '_ROOT.path'	=>	$path,
        ));
        return $level;
    }
    // получить навигационную строчку, отображающую путь к текущей категории
    // строчка вида Каталог >> Бытовая техника >> Пылесосы... и т.д.
    // функция также возвращает уровень вложенности $level для данного элемента
    function get_nav_path($id, $transurl = '?', $product_id = 0, $wh = '') {
        GLOBAL $server, $lang, $CONFIG;
        if(!$this->admin) $this->transReplace($transurl);
        $id				= (int)$id;
        $product_id		= (int)$product_id;
        $arr			= array();
        $separator		= $CONFIG['nav_separator'];
        $path			= '';
        $level			= 0;
        $i				= 0;
        $CC = new MapsCategories_DB($this->table_prefix.'_maps_categories', 'id');
        if (!isset($CC2)) {
            $CC2	=$CC->_clone();
        }
        $CC2->load(1);
        $root = ($CC2->id) ? '<a href="'.$transurl.'&action=assortment&id=0" class="header1">'.str_replace('\\', '', $CC2->title).'</a>' : '<span class="modul">'.str_replace('\\', '', $CC2->title).'</span>';
        
        if ($product_id) {
            $CD = new MapsData_DB($this->table_prefix.'_maps_products', 'id');
            $CD->load($product_id);
            $path[] = '<span class="modul">'.$CD->product_title.'</span>';
            $this->addition_to_path[$CD->product_title] = '';
        }
        
        if ($id != "1") {
            while ($id) {
                $level++;
                $CC->load($id);
                if ($CC->id) {
                    $name = str_replace("\\", "", $CC->title);
                    $this->addition_to_path[$name] = (!$this->admin && $CONFIG['rewrite_mod'])
                    ? $transurl.$this->getElementPath($CC->id,'ctg')
                    : $transurl.'&action=assortment&id='.$CC->id;
                    if ($i == 0 && !$product_id) {
                        $path[] = sprintf('<span class="modul">%s</span>',$name);
                    } else {
                        $path[] = (!$this->admin && $CONFIG['rewrite_mod'])
                        ? sprintf('<a href="%s/%s">%s</a>', $transurl, $this->getElementPath($id,'ctg'), $name)
                        : sprintf('<a href="%s&%s">%s</a>', $transurl, 'action=assortment&id='.$CC->id, $name);
                    }
                    if ($CC->parent_id != 1) {
                        $id = $CC->parent_id;
                    } else {
                        $id = null;
                    }
                    $i++;
                }
            }
        }
        if(is_array($path)){
            $path_ret = implode($separator, array_reverse($path));
        }
        $path_ret = ($root && $path_ret) ? $root . $separator . $path_ret : $root . $path_ret;
        $this->addition_to_path = array_reverse($this->addition_to_path);
        
        return array($level, $path_ret);        
    }
    // функция для вывода таблицы категорий/разделов
    function show_categories($cid = 1, $transurl = null, $selected_category = null, $ctg_owners = 0) {
        global $main, $CONFIG, $tpl, $baseurl, $db, $group_action;
        $CC = new MapsCategories_DB($this->table_prefix.'_maps_categories', 'id');
        if (!isset($transurl)) $transurl = $baseurl;
        if (eregi("admin.php",$_SERVER['PHP_SELF'])) $admin = 1;
        if (!isset($admin)) $active_str = " AND active = 1";
        if ($cid) $cid = intval($cid);
        $this->get_list_with_rights(
        "c.*", $this->table_prefix."_maps_categories c", "c",
        "clevel != 0 AND parent_id = ".$cid." ".$active_str, "", "rank ASC",
        1, 0, false, $ctg_owners, true);
        while ($db->next_record()) $temp[] = $db->Record;
        $is_first = $temp[0]["id"];
        $is_last = $temp[count($temp)-1]["id"];
        if (count($temp) > 0) {
            $level = $CC->getLevel($cid);
            $tpl->newBlock("block_categories");
            $tpl->assign(array(
            "block_categories.MSG_Activ" => $this->_msg["Activ"],
            "block_categories.MSG_Ed" => $this->_msg["Ed"],
            "block_categories.MSG_Rights" => $main->_msg["Rights"],
            "block_categories.MSG_Section" => $this->_msg["Section"],
            "block_categories.MSG_Order" => $this->_msg["Order"],
            "block_categories.MSG_Add" => $this->_msg["Add"],
            "block_categories.MSG_Del" => $this->_msg["Del"],
            "clevel" =>	 $level,
            ));
            $h = ceil(count($CC)/2);
            $actions = array(   "addctg"	=> "addcat",
                "ctg_max_lvl"	=> $CONFIG["maps_max_level"],
                "addprd"	=> "addproduct",
                "addprdmsg"	=> $this->_msg["Add_good"],
                "edit"		=> "editcat",
                "editrights"=> "editctgrights",
                "activate"	=>	array("cactivate","csuspend"),
                "delete"	=> "delcat",
                "confirm_delete"	=> $this->_msg["Confirm_delete_record"]
            );
            foreach($temp as $k=>$v) {
                $change_status		= $v["active"] ? "csuspend" : "cactivate";
                if ($is_first == $v["id"]) {
                    $img_up = "ico_ligrup.gif";
                    $first = 1;
                } else {
                    $img_up = "ico_listup.gif";
                    $first = 0;
                }
                if ($is_last == $v["id"]) {
                    $img_down = "ico_ligrdw.gif";
                    $last = 1;
                } else {
                    $img_down = "ico_listdw.gif";
                    $last = 0;
                }
                $adm_actions = $this->get_actions_by_rights($transurl."&id=".$v["id"]."&parent=".$v["parent_id"], $v["active"], $v["is_owner"], $v["user_rights"], $actions);
                $tpl->newBlock("block_category");
                $tpl->assign(array(
                    "block_category.MSG_Category_ID" => $this->_msg["Category_ID"],
                    "block_category.MSG_Move_up" => $this->_msg["Move_up"],
                    "block_category.MSG_Move_down" => $this->_msg["Move_down"],
                    'id'					=> $v["id"],
                    'category_id'			=> $v["id"],
                    'category_name'			=> str_replace("\\", "", $v["title"]),
                    'category_description'	=> str_replace("\\", "", $v["description"]),
                    'cat_link'				=> $transurl."&action=assortment&id=".$v["id"],
                    'ctg_link'				=> $transurl.'action=assortment&id='.$v['id'],
                    'cat_add_action'		=>	$adm_actions["addctg_action"],
                    'prd_add_action'		=>	$adm_actions["addprd_action"],
                    'cat_edit_action'		=>	$adm_actions["edit_action"],
                    'cat_edit_rights_action'=>	$adm_actions["edit_rights_action"],
                    'cat_del_action'		=>	$adm_actions["delete_action"],
                    'change_status_action'	=>	$adm_actions["change_status_action"],
                    'cat_up_link'			=> $transurl."&action=upcat&id=".$v["id"]."&parent=".$v["parent_id"]."&rank=".$v["rank"],
                    'cat_down_link'			=> $transurl."&action=downcat&id=".$v["id"]."&parent=".$v["parent_id"]."&rank=".$v["rank"],
                    'img_down'				=> $img_down,
                    'img_up'				=> $img_up,
                    'is_first'				=> $first,
                    'is_last'				=> $last,
                    'selected'				=> ($v["id"] == $selected_category) ? " selected" : "",
                    'rank'					=> $v["rank"],
                    'clevel'				=> $v["clevel"],
                ));
                if ($adm_actions["rights"]["d"] || $adm_actions["rights"]["p"]) {
                    $tpl->newBlock('block_ctg_check');
                    $tpl->assign("category_id", $v["id"]);
                    $group_action = true;
                }
                $i++;
            }
            $tpl->gotoBlock('block_categories');
            $tpl->assign(Array(
            "group_action" 		=> $transurl."&action=gr_act&parent=".$cid,
            "MSG_Choose_action" => $this->_msg["Choose_action"],
            "MSG_Activate" 		=> $this->_msg["Activate"],
            "MSG_Suspend" 		=> $this->_msg["Suspend"],
            "MSG_Delete" 		=> $this->_msg["Delete"],
            "MSG_Execute" 		=> $this->_msg["Execute"],
            ));
            return TRUE;
        }
        return FALSE;
    }
    // функция для вывода информации о категории по id
    function show_category($id, $transurl, $blockname = "") {
        GLOBAL $server, $lang, $CONFIG, $main, $tpl, $baseurl;
        if (eregi("admin.php",$_SERVER['PHP_SELF'])) $admin = 1;
        $id = intval($id);
        if (!$id) return 0;
        $CC = new MapsCategories_DB($this->table_prefix.'_maps_categories', 'id');
        $CC->load($id);
        if (count($CC) > 0) {
            if ($admin) {
                $title					= str_replace("\\", "", htmlspecialchars($CC->title));
                $alias			        = preg_replace("~[^a-z0-9_-]~i", "", $CC->alias);
                $description			= str_replace("\\", "", htmlspecialchars($CC->description));
                $page_description		= str_replace("\\", "", htmlspecialchars($CC->page_description));
                $keywords				= str_replace("\\", "", htmlspecialchars($CC->keywords));
                $lat    				= str_replace("\\", "", htmlspecialchars($CC->lat));
                $lng    				= str_replace("\\", "", htmlspecialchars($CC->lng));
                $zoom   				= (int) $CC->zoom;
            } else {
                $cname					= str_replace("\\", "", $CC->title);
                $description			= str_replace("\\", "", $CC->description);
                $page_description		= str_replace("\\", "", $CC->page_description);
                $keywords				= str_replace("\\", "", $CC->keywords);
                $lat    				= str_replace("\\", "", htmlspecialchars($CC->lat));
                $lng    				= str_replace("\\", "", htmlspecialchars($CC->lng));
                $zoom   				= (int) $CC->zoom;
                $this->main_title		= $cname;
            }
            if ($blockname) $tpl->newBlock($blockname);
            $tpl->assign(array(
                'id'							=>	$CC->id,
                'title'						=>	$title,
                'alias'                       =>  $alias,
                'description'					=>	$description,
                'category_link'				=>	"$transurl&action=assortment&id=".$CC->id,
                'rank'						=>	$CC->rank,
                'lat' 						=>	$lat,
                'lng' 						=>	$lng,
                'zoom'						=>	$zoom,
                'page_description'			=>	$page_description,
                'page_keywords'				=>	$keywords,
                'small_image_width' => $CONFIG['maps_product_small_image_size']['width'],
                'small_image_height' => $CONFIG['maps_product_small_image_size']['height'],
            ));
            if ($CC->img) {
                $tpl->newBlock('block_ctg_image');
                $tpl->assign(array(
                    'image_title'				=>	$this->_msg["Category_image"],
                    'image_exists'			=>	($CC->img)
                        ? '<a href="/'.$CONFIG["maps_img_path"]."categories/".$CC->img.'" target="_blank">' . $this->_msg["Look_image"] . '</a>'
                        : '',
                    'field_name'				=>	'img',
                    'image_name'				=>	$CC->img,
                    "MSG_Delete"	=> $this->_msg["Delete"],
                    'img' => $CC->img,
                    'img_path' => '/'.$CONFIG["maps_ctg_img_path"].$CC->img,
                    'img_big' => $CC->img_big,
                    'img_big_path' => '/'.$CONFIG["maps_ctg_img_path"].$CC->img_big,
                ));
            }
            //$this->show_download_images($this->category_images, $CONFIG["downloads_dll_img_path"], "block_dll_image", $CC);
            Module::show_select('metro_list', $CC->metro_id, 'title', $this->getMetroList());
            $this->main_title = $title;
            return $title;
        }
        return 0;
    }
    // функция для получения информации о владельцах категории по id
    function get_category_owners($id) {
        global $db;
        if ($id == 0) return 0;
        $ret = 0;
        $db->query("SELECT id, parent_id, owner_id FROM ".$this->table_prefix."_maps_categories");
        if ($db->nf()) {
            while ($db->next_record()) {
                $parents[$db->f("id")] = array("parent_id" => $db->f("parent_id"), "owner_id" => $db->f("owner_id"));
            }
            $ret = array();
            while ($id) {
                if (!in_array($parents[$id]["owner_id"], $ret)) $ret[] = $parents[$id]["owner_id"];
                $id = $parents[$id]["parent_id"];
            }
        }
        return $ret;
    }
    function show_tree($id = 0)
    {
        global $CONFIG, $db, $tpl, $transurl, $server, $lang;
        $sql = "SELECT * FROM " . $server . $lang . "_maps_categories WHERE parent_id = '" . (integer)$id . "' ORDER BY rank";
        $db->query($sql);
        if($db->nf())
        {
            $dbcopy = Array();
            for($i = 0; $i < $db->nf(); $i++)
            {
                $db->next_record();
                $dbcopy[$i]->id = $db->f("id");
                $dbcopy[$i]->title = $db->f("title");
            }
            //			$tpl->newBlock("block_tree_ul");
            //			$tpl->newBlock("block_tree_ul_start");
            if($id == 1) {
                $str .= '<ul id="ul_' . $id . '" style="display: block;">';
            } else {
                $str .= '<ul id="ul_' . $id . '" style="display: none;">';
            }
            foreach($dbcopy as $k => $v)
            {
                $str .= '<li>';
                $tmp = $this->show_tree($v->id);
                if($tmp) {
                    $str .= '<a href="#" onclick="openNode(' . $v->id . ', this); return false;">[+]</a>';
                } else {
                    $str .= '[&nbsp;&nbsp;&nbsp;]';
                }
                $str .= '<a href="' . $transurl . "?action=assortment&id=" . $v->id . '">' . $v->title . '</a>';
                $str .= $tmp;
                $str .= '</li>';
            }
            $str .= '</ul>';
        }
        return $str;
    }
    function get_tree($type, $parent = 0, $transurl = '?', $admin = 0, $active = FALSE) {
        GLOBAL $CONFIG, $db, $tpl, $namem, $baseurl, $server, $lang;
        $str = '';
        $arr = $this->get_node($parent, $active);
        if (count($arr)) {
            $str = implode(',', $arr);
            $str = 'AND id IN ('.$str.')';
        }
        $active_str = $active ? " AND active" : "";
        $db->query('SELECT * FROM '.$this->table_prefix.'_maps_categories WHERE !ISNULL(parent_id) '.$str.$active_str.' ORDER BY clevel, '.$CONFIG['maps_ctg_order_by']);
        if ($db->nf() > 0) {
            $icon		= 'folder.gif';
            $open_icon	= 'folderopen.gif';
            $menu  = new HTML_TreeMenu();
            $first = 1; // указатель на первой позиции в выборке из БД
            while($db->next_record()) {
                $id		= $db->f('id');
                $pid	= $db->f('parent_id');
                $cname	= $db->f('title');
                $level	= $db->f('level');
                $alias	= $db->f('alias');
                if ($type != 'tree') {
                    $text = $cname;
                    $link = $id;
                } else {
                    $a			= ($admin) ? $baseurl : $transurl;
                    if($CONFIG['rewrite_mod'] && !$admin){
                        $ctg_link = substr($transurl,0,strpos($transurl,'?'));
                        $ctg_link .= sprintf('%s/', ($alias)?$alias:$id);
                    } else {
                        $ctg_link	= $a.'&action=assortment&id='.$id;
                    }
                    if ($id != $parent) $cname = sprintf('<a href="%s">%s</a>', $ctg_link, $cname);
                    $text = sprintf('%s', $cname);
                    $link = '';
                }
                $array	= array('text' => $text,
                'link' => $link,
                'icon' => $icon,
                'expandedIcon' => $open_icon);
                if ($pid == 0) {
                    $node[$id]	= new HTML_TreeNode($array);
                    $menu->addItem($node[$id]);
                } else if ($pid != 0 && $first == 1) {
                    $node[$id]	= new HTML_TreeNode($array);
                    $menu->addItem($node[$id]);
                } else {
                    if (is_object($node[$pid])) $node[$id] = &$node[$pid]->addItem(new HTML_TreeNode($array));
                }
                $first = 0;
            }
            if ($type != 'tree') {
                $listBox	= &new HTML_TreeMenu_Listbox($menu);
                $html		= $listBox->toHTML();
            } else {
                $treeMenu	= &new HTML_TreeMenu_DHTML($menu, array('images'		=> '/'.$CONFIG['tree_img_path'],
                'defaultClass'	=> 'treeMenuDefault'));
                $html		= $treeMenu->toHTML();
            }
            return $html;
        }
        return FALSE;
    }
    function get_node($id = NULL, $arr = NULL, $active = FALSE) {
        GLOBAL $db, $server, $lang, $CONFIG;
        $id = (int)$id;
        if (!$id) return array();
        // $arr - массив с id-никами элемента и его дочерних элементов
        if (!in_array($id, $arr)) {
            array_push($arr, $id); $str = implode(',', $arr);
        }
        $next = 0;
        $active_str = $active ? " AND active" : "";
        $db->query('SELECT id FROM '.$this->table_prefix.'_maps_categories WHERE !ISNULL(parent_id) AND parent_id IN ('.$str.')'.$active_str.' GROUP BY id ORDER BY clevel, '.$CONFIG['maps_ctg_order_by']);
        if ($db->nf() > 0) {
            while($db->next_record()) {
                if (!in_array($db->f('id'), $arr)) {
                    array_push($arr,$db->f('id'));
                    $next = 1;
                }
            }
            if ($next) return $this->get_node($id, $arr);
        }
        return $arr;
    }
    function ReadLevel($id,$level=0) {
        global $server, $lang, $baseurl, $tpl;
        $CC = new MapsCategories_DB($this->table_prefix.'_maps_categories', 'id');
        $str = "";
        $list=$CC->listAll($id);
        foreach($list as $r){
            $CC->load($r[id]);
            $subitems=$this->ReadLevel($r[id],$level+1);
            $str.="<li><a href=\"#\"></a><a href=\"".$baseurl."&action=assortment&id=".$r["id"]."\" class=\"lnk\">".str_replace("\\", "", $r["title"])."</a>";
            if ($subitems) $str .= "\n<ul>\n".$subitems."</ul>\n";
            $str.="</li>\n";
        }
        return ($str);
    }
    // функция вывода списка продуктов заданной категории
    function show_products ($category = null, $transurl = null, $max_rows = 10, $start = 1, $order_by = '', $ctg_owners = 0)
    {
        global $main, $db, $lang, $tpl, $baseurl, $CONFIG, $group_action;
        if (!isset($category)) return FALSE;
        if (eregi("admin.php",$_SERVER['PHP_SELF'])) $admin = 1;
        $ord_vals = array(
            'id' => 'id',
            'title' => 'product_title',
            'availability' => 'product_availability',
            'rank' => 'rank',
            'active' => 'active',
            'leader' => 'leader',
            'hits' => 'hits'
        );
        $order = 0 === strpos($order_by, "-") ? " DESC" : "";
        $order_by = $order ? substr($order_by, 1) : $order_by;
        if (in_array($order_by, array_keys($ord_vals))) {
            $order = $ord_vals[$order_by].$order;
        } else {
            $order = self::is_admin() ? 'rank' : $CONFIG['maps_prod_order_by'];
        }
        if (!$admin) $active_str = " AND active = 1";
        $total = $this->get_list_with_rights(
            "a.*, a.id AS product_id, a.category_id AS product_category, a.active AS product_active,"
            ."a.rank AS product_rank, a.leader AS product_leader, a.hits AS product_hits, pt.ptype_name",
        $this->table_prefix."_maps_products a LEFT JOIN {$this->table_prefix}_maps_ptypes pt ON a.ptype_id=pt.id", "a",
        "a.category_id = ".$category.$active_str, "", $order,
        $start, $max_rows,
        $admin ? true : false, $ctg_owners);
        $pages_cnt = ceil($total/$max_rows);
        if (!$db->nf()) return FALSE;
        while ($db->next_record()) $cat_products[] = $db->Record;
        $desc = 0 === strpos($order_by, "-") ? TRUE : FALSE;
        $oredr_by = $desc ? substr($order_by, 1) : $order_by;
        $id_order           = (!$desc && 'id' == $oredr_by ? "-" : "").'id';
        $title_order        = (!$desc && 'title' == $oredr_by ? "-" : "").'title';
        $availability_order = (!$desc && 'availability' == $oredr_by ? "-" : "").'availability';
        $rank_order         = (!$desc && 'rank' == $oredr_by ? "-" : "").'rank';
        $active_order       = (!$desc && 'active' == $oredr_by ? "-" : "").'active';
        $leader_order       = (!$desc && 'leader' == $oredr_by ? "-" : "").'leader';
        $hits_order         = (!$desc && 'hits' == $oredr_by ? "-" : "").'hits';
        $id_order_mark           = 'id' != $oredr_by ? "" : ($desc ? "<img src=\"/i/admin/darr.gif\" alt=\"\" border=\"0\">" : "<img src=\"/i/admin/uarr.gif\" alt=\"\" border=\"0\">");
        $title_order_mark        = 'title' != $oredr_by ? "" : ($desc ? "<img src=\"/i/admin/darr.gif\" alt=\"\" border=\"0\">" : "<img src=\"/i/admin/uarr.gif\" alt=\"\" border=\"0\">");
        $availability_order_mark = 'availability' != $oredr_by ? "" : ($desc ? "<img src=\"/i/admin/darr.gif\" alt=\"\" border=\"0\">" : "<img src=\"/i/admin/uarr.gif\" alt=\"\" border=\"0\">");
        $rank_order_mark         = 'rank' != $oredr_by ? "" : ($desc ? "<img src=\"/i/admin/darr.gif\" alt=\"\" border=\"0\">" : "<img src=\"/i/admin/uarr.gif\" alt=\"\" border=\"0\">");
        $active_order_mark       = 'active' != $oredr_by ? "" : ($desc ? "<img src=\"/i/admin/darr.gif\" alt=\"\" border=\"0\">" : "<img src=\"/i/admin/uarr.gif\" alt=\"\" border=\"0\">");
        $leader_order_mark       = 'leader' != $oredr_by ? "" : ($desc ? "<img src=\"/i/admin/darr.gif\" alt=\"\" border=\"0\">" : "<img src=\"/i/admin/uarr.gif\" alt=\"\" border=\"0\">");
        $hits_order_mark         = 'hits' != $oredr_by ? "" : ($desc ? "<img src=\"/i/admin/darr.gif\" alt=\"\" border=\"0\">" : "<img src=\"/i/admin/uarr.gif\" alt=\"\" border=\"0\">");
        $id_order_mark2           = 'id' != $oredr_by ? "" : " class=\"order_curr\"";
        $title_order_mark2        = 'title' != $oredr_by ? "" : " class=\"order_curr\"";
        $availability_order_mark2 = 'availability' != $oredr_by ? "" : " class=\"order_curr\"";
        $rank_order_mark2         = 'rank' != $oredr_by ? "" : " class=\"order_curr\"";
        $active_order_mark2       = 'active' != $oredr_by ? "" : " class=\"order_curr\"";
        $leader_order_mark2       = 'leader' != $oredr_by ? "" : " class=\"order_curr\"";
        $hits_order_mark2         = 'hits' != $oredr_by ? "" : " class=\"order_curr\"";
        $tpl->newBlock("block_product_table");
        $tpl->assign(array(
        "MSG_Goods_list" => $this->_msg["Goods_list"],
        "MSG_Select_category" => $this->_msg["Select_category"],
        "MSG_Confirm_move_good_to" => $this->_msg["Confirm_move_good_to"],
        "MSG_No_selected_goods" => $this->_msg["No_selected_goods"],
        "MSG_Empty_field" => $this->_msg["Empty_field"],
        "MSG_Seek" => $this->_msg["Seek"],
        "MSG_Activ" => $this->_msg["Activ"],
        "MSG_Ed" => $this->_msg["Ed"],
        "MSG_Rights" => $main->_msg["Rights"],
        "MSG_ID" => $this->_msg["ID"],
        "MSG_Title" => $this->_msg["Title"],
        "MSG_Presence" => $this->_msg["Presence"],
        "MSG_Order" => $this->_msg["Order"],
        "MSG_Leader" => $this->_msg["Leader"],
        "MSG_Shows" => $this->_msg["Shows"],
        "MSG_Del" => $this->_msg["Del"],
        "MSG_Select_category_for_move" => $this->_msg["Select_category_for_move"],
        "MSG_Move" => $this->_msg["Move"],
        "action_lang" => $lang,
        "change_catgr_action" => $baseurl."&action=changecatgr",
        "category_id" => $category,
        "search_action" => $baseurl."&action=search&id=".$category,
        "baseurl" => $baseurl,
        "id_order" => $baseurl."&action=assortment&id=".$category."&order=".$id_order,
        "title_order" => $baseurl."&action=assortment&id=".$category."&order=".$title_order,
        "availability_order" => $baseurl."&action=assortment&id=".$category."&order=".$availability_order,
        "rank_order" => $baseurl."&action=assortment&id=".$category."&order=".$rank_order,
        "active_order" => $baseurl."&action=assortment&id=".$category."&order=".$active_order,
        "leader_order" => $baseurl."&action=assortment&id=".$category."&order=".$leader_order,
        "hits_order" => $baseurl."&action=assortment&id=".$category."&order=".$hits_order,
        "id_order_mark" => $id_order_mark,
        "title_order_mark" => $title_order_mark,
        "availability_order_mark" => $availability_order_mark,
        "rank_order_mark" => $rank_order_mark,
        "active_order_mark" => $active_order_mark,
        "leader_order_mark" => $leader_order_mark,
        "hits_order_mark" => $hits_order_mark,
        "id_order_mark2" => $id_order_mark2,
        "title_order_mark2" => $title_order_mark2,
        "availability_order_mark2" => $availability_order_mark2,
        "rank_order_mark2" => $rank_order_mark2,
        "active_order_mark2" => $active_order_mark2,
        "leader_order_mark2" => $leader_order_mark2,
        "hits_order_mark2" => $hits_order_mark2,
        "MSG_Choose_action" => $this->_msg["Choose_action"],
        "MSG_Activate" 		=> $this->_msg["Activate"],
        "MSG_Suspend" 		=> $this->_msg["Suspend"],
        "MSG_Delete" 		=> $this->_msg["Delete"],
        "MSG_Execute" 		=> $this->_msg["Execute"],
        ));
        $is_first = $cat_products[0]["product_id"];
        $is_last = $cat_products[count($cat_products)-1]["product_id"];
        $actions = array(	"edit"		=> "editproduct",
        "editrights"=> "editrights",
        "activate"	=>	array("pactivate","psuspend"),
        "select"	=> "changeleader",
        "delete"	=> "delproduct",
        "confirm_delete"	=> $this->_msg["Confirm_delete_record"]
        );
        foreach ($cat_products as $product) {
            $tpl->newBlock("block_product_row");
            $img_up   = "ico_listup.gif";
            $first    = 0;
            $img_down = "ico_listdw.gif";
            $last     = 0;
            $actions["select_title"]=	$product["product_leader"] ? $this->_msg["Confirm_unset_leader"] : $this->_msg["Confirm_set_leader"];
            $actions["select_img"]	=	$product["product_leader"] ? "b_select.gif" : "b_select_off.gif";
            $adm_actions	= $this->get_actions_by_rights($transurl."&id=".$product['product_id'].'&category_id='.$product['product_category'].'&rank='.$product['product_rank'], $product["active"], $product["is_owner"], $product["user_rights"], $actions);
            $tpl->assign(array(
            "MSG_Move_up"			=> $this->_msg["Move_up"],
            "MSG_Move_down"			=> $this->_msg["Move_down"],
            "product_id"			=>	$product["product_id"],
            "product_name"			=>	$product["product_title"],
            "product_hits"			=>	$product["product_hits"],
            "product_currency"		=>	$product["currency"],
            "product_price_1"		=>	(float)($product["price_1"]/100),
            "product_price_2"		=>	(float)($product["price_2"]/100),
            "product_price_3"		=>	(float)($product["price_3"]/100),
            "product_availability"	=>	$product["product_availability"] ? $product["product_availability"] : "&nbsp;",
            "product_rank"			=>	$product["product_rank"],
            "product_edit_action"	=>	$adm_actions["edit_action"],
            "product_edit_rights_action"	=>	$adm_actions["edit_rights_action"],
            "product_del_action"	=>	$adm_actions["delete_action"],
            "change_status_action"	=>	$adm_actions["change_status_action"],
            "leader_action"			=>	$adm_actions["select_action"],
            "product_link"			=>	$transurl.'action=shwprd&prd_id='.$product['product_id'].'&id='.$product['product_category'],
            "img_dwn"				=>	$img_down,
            "img_up"				=>	$img_up,
            "is_first"				=>	$first,
            "is_last"				=>	$last,
            "product_up_link"		=>	"$transurl&action=productup&id=".$product["product_id"]."&category_id=".$product["product_category"]."&rank=".$product["product_rank"],
            "product_down_link"		=>	"$transurl&action=productdown&id=".$product["product_id"]."&category_id=".$product["product_category"]."&rank=".$product["product_rank"],
            "ptype_id"              => $product['ptype_id'],
            "ptype_name"            => $product['ptype_name'],
            "addr"            => $product['addr'],
            ));
            if ($adm_actions["rights"]["d"] || $adm_actions["rights"]["p"]) {
                $tpl->newBlock('block_check');
                $tpl->assign("product_id", $product["product_id"]);
                $group_action = true;
            }
        }
        /**
		 * Вывод дерева категорий
		 */
        $catgr_tree = $this->getCategsTree();
        foreach ($catgr_tree as $ctgr) {
            $tpl->newBlock("block_catgr_tree");
            $ctgr_title = "";
            for ($i = 1; $i < $ctgr['level']; $i++) {
                $ctgr_title .= "&nbsp;&nbsp;";
            }
            $ctgr_title .= $ctgr['title'];
            $tpl->assign(array(
            'ctgr_id' => $ctgr['id'],
            'ctgr_title' => $ctgr_title
            ));
        }
        return $pages_cnt;
    }
    // функция вывода списка продуктов согласно критериям поиска
    function show_search_result ($category, $search_str, $transurl = null, $max_rows = 10, $start = 1, $order_by = '') {
        global $main, $db, $server, $lang, $tpl, $baseurl, $CONFIG;
        if (!$search_str = trim($search_str)) {
            return FALSE;
        }
        $search = preg_replace("/\s+/", "&nbsp;", $search_str);
        $search = explode("&nbsp;", $search);
        $where = '';
        foreach ($search as $word) {
            $where .= "product_title LIKE '%".My_Sql::escape($word)."%' AND ";
        }
        $where = substr($where, 0, -5);
        $ord_vals = array('id' => 'id',
        'title' => 'product_title',
        'availability' => 'product_availability',
        'rank' => 'rank',
        'active' => 'active',
        'leader' => 'leader',
        'hits' => 'hits');
        $order = 0 === strpos($order_by, "-") ? " DESC" : "";
        $order_key = $order ? substr($order_by, 1) : $order_by;
        if (in_array($order_key, array_keys($ord_vals))) {
            $order = $ord_vals[$order_key].$order;
        } else {
            $order = $CONFIG['maps_prod_order_by'];
        }
        $cat_products = array();
        $total = $this->get_list_with_rights(
        "a.*, a.id AS product_id, a.category_id AS product_category, a.active AS product_active,
								a.rank AS product_rank, a.leader AS product_leader, a.hits AS product_hits",
        $this->table_prefix."_maps_products a", "a",
        "category_id = ".$category." AND ".$where, "", $order,
        $start, $max_rows,
        $admin ? true : false, $ctg_owners);
        $pages_cnt = ceil($total/$max_rows);
        if (!$db->nf()) return FALSE;
        while ($db->next_record()) $cat_products[] = $db->Record;
        if (!count($cat_products)) {
            return FALSE;
        }
        $desc = 0 === strpos($order_by, "-") ? TRUE : FALSE;
        $oredr_by = $desc ? substr($order_by, 1) : $order_by;
        $id_order           = (!$desc && 'id' == $oredr_by ? "-" : "").'id';
        $title_order        = (!$desc && 'title' == $oredr_by ? "-" : "").'title';
        $availability_order = (!$desc && 'availability' == $oredr_by ? "-" : "").'availability';
        $rank_order         = (!$desc && 'rank' == $oredr_by ? "-" : "").'rank';
        $active_order       = (!$desc && 'active' == $oredr_by ? "-" : "").'active';
        $leader_order       = (!$desc && 'leader' == $oredr_by ? "-" : "").'leader';
        $hits_order         = (!$desc && 'hits' == $oredr_by ? "-" : "").'hits';
        $id_order_mark           = 'id' != $oredr_by ? "" : ($desc ? "<img src=\"/i/admin/darr.gif\" alt=\"\" border=\"0\">" : "<img src=\"/i/admin/uarr.gif\" alt=\"\" border=\"0\">");
        $title_order_mark        = 'title' != $oredr_by ? "" : ($desc ? "<img src=\"/i/admin/darr.gif\" alt=\"\" border=\"0\">" : "<img src=\"/i/admin/uarr.gif\" alt=\"\" border=\"0\">");
        $availability_order_mark = 'availability' != $oredr_by ? "" : ($desc ? "<img src=\"/i/admin/darr.gif\" alt=\"\" border=\"0\">" : "<img src=\"/i/admin/uarr.gif\" alt=\"\" border=\"0\">");
        $rank_order_mark         = 'rank' != $oredr_by ? "" : ($desc ? "<img src=\"/i/admin/darr.gif\" alt=\"\" border=\"0\">" : "<img src=\"/i/admin/uarr.gif\" alt=\"\" border=\"0\">");
        $active_order_mark       = 'active' != $oredr_by ? "" : ($desc ? "<img src=\"/i/admin/darr.gif\" alt=\"\" border=\"0\">" : "<img src=\"/i/admin/uarr.gif\" alt=\"\" border=\"0\">");
        $leader_order_mark       = 'leader' != $oredr_by ? "" : ($desc ? "<img src=\"/i/admin/darr.gif\" alt=\"\" border=\"0\">" : "<img src=\"/i/admin/uarr.gif\" alt=\"\" border=\"0\">");
        $hits_order_mark         = 'hits' != $oredr_by ? "" : ($desc ? "<img src=\"/i/admin/darr.gif\" alt=\"\" border=\"0\">" : "<img src=\"/i/admin/uarr.gif\" alt=\"\" border=\"0\">");
        $id_order_mark2           = 'id' != $oredr_by ? "" : " class=\"order_curr\"";
        $title_order_mark2        = 'title' != $oredr_by ? "" : " class=\"order_curr\"";
        $availability_order_mark2 = 'availability' != $oredr_by ? "" : " class=\"order_curr\"";
        $rank_order_mark2         = 'rank' != $oredr_by ? "" : " class=\"order_curr\"";
        $active_order_mark2       = 'active' != $oredr_by ? "" : " class=\"order_curr\"";
        $leader_order_mark2       = 'leader' != $oredr_by ? "" : " class=\"order_curr\"";
        $hits_order_mark2         = 'hits' != $oredr_by ? "" : " class=\"order_curr\"";
        $tpl->newBlock("block_product_table");
        $tpl->assign(array(
        "MSG_Goods_list" => $this->_msg["Goods_list"],
        "MSG_Select_category" => $this->_msg["Select_category"],
        "MSG_Confirm_move_good_to" => $this->_msg["Confirm_move_good_to"],
        "MSG_No_selected_goods" => $this->_msg["No_selected_goods"],
        "MSG_Empty_field" => $this->_msg["Empty_field"],
        "MSG_Seek" => $this->_msg["Seek"],
        "MSG_Activ" => $this->_msg["Activ"],
        "MSG_Ed" => $this->_msg["Ed"],
        "MSG_Rights" => $main->_msg["Rights"],
        "MSG_ID" => $this->_msg["ID"],
        "MSG_Title" => $this->_msg["Title"],
        "MSG_Presence" => $this->_msg["Presence"],
        "MSG_Order" => $this->_msg["Order"],
        "MSG_Leader" => $this->_msg["Leader"],
        "MSG_Shows" => $this->_msg["Shows"],
        "MSG_Del" => $this->_msg["Del"],
        "MSG_Select_category_for_move" => $this->_msg["Select_category_for_move"],
        "MSG_Move" => $this->_msg["Move"],
        "action_lang" => $lang,
        "change_catgr_action" => $baseurl."&action=changecatgr",
        "category_id" => $category,
        "search_action" => $baseurl."&action=search&id=".$category,
        "search_str" => $search_str,
        "baseurl" => $baseurl,
        "id_order" => $baseurl."&action=search&id=".$category."&search=".$search_str."&order=".$id_order,
        "title_order" => $baseurl."&action=search&id=".$category."&search=".$search_str."&order=".$title_order,
        "availability_order" => $baseurl."&action=search&id=".$category."&search=".$search_str."&order=".$availability_order,
        "rank_order" => $baseurl."&action=search&id=".$category."&search=".$search_str."&order=".$rank_order,
        "active_order" => $baseurl."&action=search&id=".$category."&search=".$search_str."&order=".$active_order,
        "leader_order" => $baseurl."&action=search&id=".$category."&search=".$search_str."&order=".$leader_order,
        "hits_order" => $baseurl."&action=search&id=".$category."&search=".$search_str."&order=".$hits_order,
        "id_order_mark" => $id_order_mark,
        "title_order_mark" => $title_order_mark,
        "availability_order_mark" => $availability_order_mark,
        "rank_order_mark" => $rank_order_mark,
        "active_order_mark" => $active_order_mark,
        "leader_order_mark" => $leader_order_mark,
        "hits_order_mark" => $hits_order_mark,
        "id_order_mark2" => $id_order_mark2,
        "title_order_mark2" => $title_order_mark2,
        "availability_order_mark2" => $availability_order_mark2,
        "rank_order_mark2" => $rank_order_mark2,
        "active_order_mark2" => $active_order_mark2,
        "leader_order_mark2" => $leader_order_mark2,
        "hits_order_mark2" => $hits_order_mark2
        ));
        $is_first = $cat_products[0]["id"];
        $is_last = $cat_products[count($cat_products)-1]["id"];
        //echo $query."<hr>".count($cat_products);exit;
        $actions = array(	"edit"		=> "editproduct",
        "editrights"=> "editrights",
        "activate"	=>	array("pactivate","psuspend"),
        "select"	=> "changeleader",
        "delete"	=> "delproduct",
        "confirm_delete"	=> $this->_msg["Confirm_delete_record"]
        );
        foreach ($cat_products as $product) {
            $tpl->newBlock("block_product_row");
            $img_up   = "ico_listup.gif";
            $first    = 0;
            $img_down = "ico_listdw.gif";
            $last     = 0;
            $actions["select_title"]=	$product["product_leader"] ? $this->_msg["Confirm_unset_leader"] : $this->_msg["Confirm_set_leader"];
            $actions["select_img"]	=	$product["product_leader"] ? "b_select.gif" : "b_select_off.gif";
            $adm_actions	= $this->get_actions_by_rights($transurl."&id=".$product['product_id'].'&category_id='.$product['product_category'].'&rank='.$product['product_rank'], $product["active"], $product["is_owner"], $product["user_rights"], $actions);
            $tpl->assign(array(
            "MSG_Move_up"			=> $this->_msg["Move_up"],
            "MSG_Move_down"			=> $this->_msg["Move_down"],
            "product_id"			=>	$product["product_id"],
            "product_name"			=>	$product["product_title"],
            "product_hits"			=>	$product["product_hits"],
            "product_currency"		=>	$product["currency"],
            "product_price_1"		=>	(float)($product["price_1"]/100),
            "product_price_2"		=>	(float)($product["price_2"]/100),
            "product_price_3"		=>	(float)($product["price_3"]/100),
            "product_availability"	=>	$product["product_availability"] ? $product["product_availability"] : "&nbsp;",
            "product_rank"			=>	$product["product_rank"],
            "product_edit_action"	=>	$adm_actions["edit_action"],
            "product_edit_rights_action"	=>	$adm_actions["edit_rights_action"],
            "product_del_action"	=>	$adm_actions["delete_action"],
            "change_status_action"	=>	$adm_actions["change_status_action"],
            "leader_action"			=>	$adm_actions["select_action"],
            "product_link"			=>	$transurl.'action=shwprd&prd_id='.$product['product_id'].'&id='.$product['product_category'],
            "img_dwn"				=>	$img_down,
            "img_up"				=>	$img_up,
            "is_first"				=>	$first,
            "is_last"				=>	$last,
            "product_up_link"		=>	"$transurl&action=productup&id=".$product["product_id"]."&category_id=".$product["product_category"]."&rank=".$product["product_rank"],
            "product_down_link"		=>	"$transurl&action=productdown&id=".$product["product_id"]."&category_id=".$product["product_category"]."&rank=".$product["product_rank"],
            ));
            if ($adm_actions["rights"]["d"] || $adm_actions["rights"]["p"]) {
                $tpl->newBlock('block_check');
                $tpl->assign("product_id", $product["product_id"]);
            }
        }
        /**
		 * Вывод дерева категорий
		 */
        $catgr_tree = $this->getCategsTree();
        foreach ($catgr_tree as $ctgr) {
            $tpl->newBlock("block_catgr_tree");
            $ctgr_title = "";
            for ($i = 1; $i < $ctgr['level']; $i++) {
                $ctgr_title .= "&nbsp;&nbsp;";
            }
            $ctgr_title .= $ctgr['title'];
            $tpl->assign(array(
            'ctgr_id' => $ctgr['id'],
            'ctgr_title' => $ctgr_title
            ));
        }
        $tpl->newBlock("block_search_on");
        $tpl->assign(array("category_id" => $category,
        "baseurl" => $baseurl,
        "MSG_Back_to_goods_list" => $this->_msg['Back_to_goods_list']
        )
        );
        return TRUE;
    }

    function show_product_2($id) {
        global $server, $lang, $db, $CONFIG;
        $id = (int)$id;
        $query 	= 'SELECT * FROM '.$this->table_prefix.'_maps_products WHERE id='.$id;
        $db->query($query);
        if ($db->nf() > 0) {
            $db->next_record();
            $array['id']					= $db->f('id');
            $array['category_id']			= $db->f('category_id');
            $array['group_id']				= $db->f('group_id');
            $array['ptype_id']				= $db->f('ptype_id');
            $array['product_code']			= htmlspecialchars($db->f('product_code'));
            $array['product_title']			= htmlspecialchars($db->f('product_title'));
            $array['alias']			        = htmlspecialchars($db->f('alias'));
            $array['product_inf']           = htmlspecialchars($db->f('product_inf'));
            $array['product_description']	= $db->f('product_description');
            $array['description']			= $db->f('description');
            $array['keywords']				= $db->f('keywords');
            $array['currency']				= $db->f('currency');
            $array['price_1']				= (float)($db->f('price_1')/100);
            $array['price_2']				= (float)($db->f('price_2')/100);
            $array['price_3']				= (float)($db->f('price_3')/100);
            $array['price_4']				= (float)($db->f('price_4')/100);
            $array['price_5']				= (float)($db->f('price_5')/100);
            $array['image_middle']			= $db->f('image_middle');
            $array['image_big']				= $db->f('image_big');
            $array['product_availability']	= htmlspecialchars($db->f('product_availability'));
            $array['active']				= $db->f('active');
            $array['rank']					= $db->f('rank');
            $array['lat']					= $db->f('lat');
            $array['lng']					= $db->f('lng');
            $array['zoom']					= $db->f('zoom');
            $array['addr']					= $db->f('addr');
            $array['phone']					= $db->f('phone');
            $array['open']					= $db->f('open');
            $array['e_mail'] = $db->f('e_mail');
            $array['metro_id'] = $db->f('metro_id');
            $array['leader'] = $db->f('leader');
            $array['stat_id'] = $db->fetchColumn($this->table_prefix.'_maps_prod_stat', 'stat_id', array('clause' => array('prod_id' => $id)));
        }
        return $array;
    }
    /**
	 * Получить список лидеров продаж для категории
	 * @param $ctgr_id	ID категории
	 * @return mixed	FALSE - если категория не найдена, не указан ID или не содержит лидеров продаж
	 * 					array() - список лидеров продаж, в противном случае
	 */
    function getCategoriesLeades($ctgr_id = NULL, $maxrows = 5, $transurl = "?", $t = true)
    {   global $db, $CONFIG, $baseurl;
    $this->transReplace($transurl);
    if ((integer)$ctgr_id) {
        $compare = ($t) ? ' = ' : ' != ';
        $clause = "category_id ".$compare.(integer)$ctgr_id;
    } else {
        $clause = "1";
    }
    if(!$maxrows)
    $maxrows = -1;
    $clnt_price = 'prod_price_'.(@$_SESSION['siteuser']['client_type'] ? $_SESSION['siteuser']['client_type'] : '1');
    $db->query('SELECT p.*, pt.ptype_name, pt.link as ptype_link
					FROM '.$this->table_prefix.'_maps_products p
					LEFT JOIN '.$this->table_prefix.'_maps_ptypes pt ON p.ptype_id = pt.id
          WHERE '.$clause.' AND active = 1 AND leader
          ORDER BY rank DESC'.($maxrows == -1 ? '' : ' LIMIT 0,' . $maxrows));
    if ($db->nf() > 0) {
        $add_to_cart_link = Core::formPageLink($CONFIG['shop_page_link'], $CONFIG['shop_page_address'], $lang);
        $add_to_cart_link .= (FALSE === strpos($add_to_cart_link, "?") ? "?" : "&")."action=addtocart&id=";
        for($i = 0; $i < $db->nf(); $i++) {
            $db->next_record();
            $img = $db->f('image_middle');
            $img = $img && file_exists(RP.'/'.$CONFIG['maps_img_path'].$img) ? '/'.$CONFIG['maps_img_path'].$img : '';
            $b_img = $db->f('image_big');
            $b_img = $b_img && file_exists(RP.'/'.$CONFIG['maps_img_path'].$b_img) ? '/'.$CONFIG['maps_img_path'].$b_img : '';
            $arr[$i]['prod_num']		= ($i+1);
            $arr[$i]['prod_id']			= $prod_id = $db->f('id');
            $arr[$i]['prod_link']		= ($CONFIG['rewrite_mod']) ? $transurl . $this->getElementPath($prod_id, 'good') : $transurl.'&action=shwprd&id='.$prod_id;
            $arr[$i]['prod_title']		= $db->f('product_title');
            $arr[$i]['prod_descr']		= $db->f('product_inf');
            $arr[$i]['prod_image']		= $img;
            $arr[$i]['prod_image_big']	= $b_img;
            $arr[$i]['prod_price_1']	= $this->getCostWithTaxes($db->f('price_1')/100);
            $arr[$i]['prod_price_2']	= $this->getCostWithTaxes($db->f('price_2')/100);
            $arr[$i]['prod_price_3']	= $this->getCostWithTaxes($db->f('price_3')/100);
            $arr[$i]['prod_price_4']	= $this->getCostWithTaxes($db->f('price_4')/100);
            $arr[$i]['prod_price_5']	= $this->getCostWithTaxes($db->f('price_5')/100);
            $arr[$i]['prod_price']		= $arr[$i][$clnt_price];
            $arr[$i]['prod_currency']	= $CONFIG['maps_currencies'][$db->f('currency')];
            $arr[$i]['prod_currency_name']	= $this->currencies[$db->f('currency')];
            $arr[$i]['prod_availability']	= $db->f('product_availability');
            $arr[$i]['prod_ptype_name']	= $db->f('ptype_name');
            $arr[$i]['prod_ptype_link']	= $db->f('ptype_link');
            $arr[$i]['add_to_cart_link']= $add_to_cart_link . $prod_id;
        }
        return $arr;
    }
    return FALSE;
    }
    /**
	 * Получить список лидеров продаж
	 */
    function getLeades()
    {   global $db, $CONFIG, $baseurl;
    $this->transReplace($baseurl);
    $clnt_price = 'prod_price_'.(@$_SESSION['siteuser']['client_type'] ? $_SESSION['siteuser']['client_type'] : '1');
    $db->query('SELECT * FROM '.$this->table_prefix.'_maps_products
                    WHERE active = 1 AND leader
                    ORDER BY rank DESC');
    if ($db->nf() > 0) {
        $add_to_cart_link = Core::formPageLink($CONFIG['shop_page_link'], $CONFIG['shop_page_address'], $lang);
        $add_to_cart_link .= (FALSE === strpos($add_to_cart_link, "?") ? "?" : "&")."action=addtocart&id=";
        for($i = 0; $i < $db->nf(); $i++) {
            $db->next_record();
            $arr[$i]['prod_num']		= ($i+1);
            $arr[$i]['prod_id']			= $prod_id = $db->f('id');
            $arr[$i]['prod_link']		= ($CONFIG['rewrite_mod']) ? $baseurl.$this->getElementPath($db->f('id'), 'good') : $baseurl.'&action=shwprd&id='.$db->f('id');
            $arr[$i]['prod_title']		= $db->f('product_title');
            $arr[$i]['prod_descr']		= $db->f('product_inf');
            $arr[$i]['prod_image']		= '/'.$CONFIG['maps_img_path'].$db->f('image_middle');
            $arr[$i]['prod_price_1']	= $this->getCostWithTaxes($db->f('price_1')/100);
            $arr[$i]['prod_price_2']	= $this->getCostWithTaxes($db->f('price_2')/100);
            $arr[$i]['prod_price_3']	= $this->getCostWithTaxes($db->f('price_3')/100);
            $arr[$i]['prod_price']		= $arr[$i][$clnt_price];
            $arr[$i]['prod_currency']	= $CONFIG['maps_currencies'][$db->f('currency')];
            $arr[$i]['add_to_cart_link']= $add_to_cart_link.$prod_id;
        }
        return $arr;
    }
    return FALSE;
    }

    /**
	 * Получить связанных соваров
	 *
	 * @param int     $prod_id ID товара
	 * @param boolean $active  Флаг - только опубликованные товары
	 * @return mixed false/array
	 */
    function getConcernedProducts($prod_id, $active = FALSE)
    {
        global $db, $tpl, $CONFIG;
        $prod_id = (int)$prod_id;
        if ($prod_id < 1) {
            return FALSE;
        }
        $active_str = $active ? " AND active" : "";
        $query = "SELECT C.*, product_title, category_id, product_inf, currency, price_1, price_2, price_3,";
        $query .= " price_4, price_5, image_middle, image_big, product_availability, active, ptype_name, PT.link AS ptype_link FROM ";
        $query .= " ".$this->table_prefix."_maps_concerned_products AS C LEFT JOIN";
        $query .= " ".$this->table_prefix."_maps_products AS P ON C.concrn_id = P.id LEFT JOIN ";
        $query .= " ".$this->table_prefix."_maps_ptypes AS PT ON P.ptype_id = PT.id ";
        $query .= " WHERE C.prod_id = ".$prod_id.$active_str." ORDER BY rank";
        $db->query($query);
        if (!$db->nf()) {
            return FALSE;
        }
        $ret = array();
        while ($db->next_record()) {
            $ret[] = array('concrn_id'    => $db->f('concrn_id'),
            'concrn_title' => $db->f('product_title'),
            'category_id'  => $db->f('category_id'),
            'active'       => $db->f('active'),
            'rank'         => $db->f('rank'),
            'product_inf'  => $db->f('product_inf'),
            'currency'     => $CONFIG['maps_currencies'][$db->f('currency')],
            'price_1'      => $db->f('price_1'),
            'price_2'      => $db->f('price_2'),
            'price_3'      => $db->f('price_3'),
            'price_4'      => $db->f('price_4'),
            'price_5'      => $db->f('price_5'),
            'image_middle' => $db->f('image_middle'),
            'image_big'	=> $db->f('image_big'),
            'availability' => $db->f('product_availability'),
            'ptype_name'	  => $db->f('ptype_name'),
            'ptype_link'	  => $db->f('ptype_link'),
            );
        }
        return $ret;
    }
    /**
	 * Отобразить связанные товары
	 *
	 * @param int $prod_id
	 * @param array $prod_list
	 * @return boolean
	 */
    function showConcernedProducts($prod_id, $prod_list)
    {
        global $tpl, $baseurl, $CONFIG;
        $this->transReplace($baseurl);
        $prod_id = (int) $prod_id;
        if (!is_array($prod_list) || !count($prod_list) || $prod_id < 1) {
            return FALSE;
        }
        $clnt_price = 'price_'.(@$_SESSION['siteuser']['client_type'] ? $_SESSION['siteuser']['client_type'] : '1');
        foreach ($prod_list as $key=>$prod) {
            $tpl->newBlock('block_concrn_row');
            $tpl->assign(array('id' => $prod['concrn_id'],
            'title' => $prod['concrn_title'],
            'category_id'	=> $prod['category_id'],
            'prod_link'		=> ($CONFIG['rewrite_mod']) ? $baseurl.$this->getElementPath($prod['concrn_id'], 'good') : $baseurl.'&action=shwprd&id='.$prod['concrn_id'],
            'product_inf'	=> $prod['product_inf'],
            'currency'		=> $prod['currency'],
            'currency_name'	=> $this->currencies[$prod['currency']],
            'price_1'		=> $this->getCostWithTaxes($prod['price_1']/100),
            'price_2'		=> $this->getCostWithTaxes($prod['price_2']/100),
            'price_3'		=> $this->getCostWithTaxes($prod['price_3']/100),
            'price_4'		=> $this->getCostWithTaxes($prod['price_4']/100),
            'price_5'		=> $this->getCostWithTaxes($prod['price_5']/100),
            'price'			=> $this->getCostWithTaxes($prod[$clnt_price]/100),
            'availability'	=> $prod['availability'],
            'ptype_name'		=> $prod['ptype_name'],
            'ptype_link'		=> $prod['ptype_link'],
            'add_to_cart_action' => Core::formPageLink($CONFIG['shop_page_link'],$CONFIG['shop_page_address'], $lang),
            'action'			=> 'addtocart',
            'active'			=> $prod['active'] ? $this->_msg['Yes'] : $this->_msg['No'],
            'del_link'		=> $baseurl.'&action=delconcrn&id='.$prod_id.'&concrn_id='.$prod['concrn_id'].'&category_id='.$prod['category_id'],
            'edit_link'		=> $baseurl.'&action=editproduct&id='.$prod['concrn_id'].'&category_id='.$prod['category_id'],
            "MSG_Edit"		=> $this->_msg["Edit"],
            "MSG_Confirm_delete_assigned_rec" => $this->_msg["Confirm_delete_assigned_rec"],
            "MSG_Delete"	=> $this->_msg["Delete"],
            )
            );
            if ($prod['ptype_link']) {
                $tpl->newBlock('block_concrn_ptype'.((strtolower(substr($prod['ptype_link'], 0, 7)) === "http://") ? '' : '_local').'_link');
                $tpl->assign(array(
                'ptype_name' => $prod['ptype_name'],
                'ptype_link' => $prod['ptype_link'],
                ));
            } else if ($prod['ptype_name']) {
                $tpl->newBlock('block_concrn_ptype_without_link');
                $tpl->assign('ptype_name', $prod['ptype_name']);
            }
            if ($prod['image_middle'] && file_exists(RP.$CONFIG['maps_img_path'].$prod['image_middle'])) {
                $tpl->newBlock('block_concrn_image_middle');
                $tpl->assign(array(
                'image_path'	=> "/".$CONFIG['maps_img_path'].$prod['image_middle'],
                'img_alt'		=> htmlspecialchars($prod['concrn_title']),
                'prod_link'		=> ($CONFIG['rewrite_mod']) ? $baseurl.$this->getElementPath($prod['concrn_id'], 'good') : $baseurl.'&action=shwprd&id='.$prod['concrn_id'],
                ));
            } else {
                $tpl->newBlock('block_concrn_image_middle_no');
            }
            if ($prod['image_big'] && file_exists(RP.$CONFIG['maps_img_path'].$prod['image_big'])) {
                $tpl->newBlock('block_concrn_image_big');
                $tpl->assign(array(
                'image_path'	=> "/".$CONFIG['maps_img_path'].$prod['image_big'],
                'img_alt'		=> htmlspecialchars($prod['concrn_title']),
                'prod_link'		=> ($CONFIG['rewrite_mod']) ? $baseurl.$this->getElementPath($prod['concrn_id'], 'good') : $baseurl.'&action=shwprd&id='.$prod['concrn_id'],
                ));
            } else {
                $tpl->newBlock('block_concrn_image_big_no');
            }
            if ($prod['availability']) {
                $tpl->newBlock('block_concrn_prd_availability');
                $tpl->assign('availability', $prod['availability']);
            }
        }
        return TRUE;
    }
    function get_ptypes()
    {
    	global $db, $CONFIG;
    	$db->query('SELECT * FROM '.$this->table_prefix.'_maps_ptypes ORDER BY ptype_name');
    	$ret = array();
    	while($db->next_record()) {
    	    $ret[$db->Record['id']] = array(
    	       'id' => $db->Record['id'],
    	       'ptype_name' => $db->Record['ptype_name'],
    	       'link' => $db->Record['link'],
    	       'icon' => $db->Record['icon'],
    	       'icon_path' => ($db->Record['icon'] && file_exists(RP.$CONFIG['maps_ptype_img_path'].$db->Record["icon"])
    	           ? '/'.$CONFIG['maps_ptype_img_path'].$db->Record["icon"]
    	           : '')
    	    );
    	}

    	return $ret;
    }
    // функция для отображения производителей
    function show_ptypes($selected_ptype = '')
    {
        global $CONFIG, $db, $tpl, $baseurl;
        $selected_ptype = (int)$selected_ptype;
        $db->query('SELECT * FROM '.$this->table_prefix.'_maps_ptypes ORDER BY id');
        if ($db->nf() > 0) {
            $tpl->newBlock("block_ptypes");
            $i = 0;
            while($db->next_record()) {
                // вывод на экран списка
                $i++;
                $selected = ($db->f("id") == $selected_ptype) || (1 == $i && 'first' == $selected_ptype) ? " selected" : "";
                $tpl->newBlock("block_ptype");
                $tpl->assign(Array(
                    "MSG_Edit" => $this->_msg["Edit"],
                    "MSG_Delete" => $this->_msg["Delete"],
                ));
                $assign = array(
                    'ptype_name' =>	$db->f("ptype_name"),
                    'link' =>	$db->f("link"),
                    'ptype_link'  =>	$baseurl.'&action=showptype&id='.$db->f("id"),
                    'ptype_id' =>	$db->f('id'),
                    'selected' =>	$selected,
                    'checked' =>	$selected ? 'checked' : ''
                );
                $tpl->assign($assign + array(
                    'ptype_edit_link' =>	$baseurl.'&action=editptype&id='.$db->f("id"),
                    'ptype_del_link' =>	$baseurl.'&action=delptype&id='.$db->f("id"),
                ));
                if ($db->f("link")) {
                    $tpl->newBlock('block_ptype_link');
                    $tpl->assign(array(
                        'ptype_title' => $db->f("ptype_name"),
                        'ptype_link' => $db->f("link"),
                    ));
                } else if ($db->f("ptype_name")) {
                    $tpl->newBlock('block_ptype_without_link');
                    $tpl->assign('ptype_title', $db->f("ptype_name"));
                }
                if ($db->Record["icon"] && file_exists(RP.$CONFIG['maps_ptype_img_path'].$db->Record["icon"])) {
                	$tpl->newBlock('block_ptype_icon');
                	$assign['icon_path'] = "/".$CONFIG['maps_ptype_img_path'].$db->Record["icon"];
                } else {
                    $tpl->newBlock('block_ptype_no_icon');
                }
                $tpl->assign($assign);
            }
            return $db->nf();
        }
        return FALSE;
    }

    function getPropertyFields() {
        GLOBAL $request_site_target, $request_sub_action;
        if ('' != $request_sub_action) {
            $tpl = $this->getTmpProperties();
            switch ($request_sub_action) {
                case 'list':
                case 'assortment':
                    $tpl->newBlock('block_properties');
                    $tpl->newBlock('block_properties_ctg_list');
                    $tpl->assign(Array(
                    "MSG_Show_category" => $this->_msg["Show_category"],
                    "MSG_All_categories" => $this->_msg["All_categories"],
                    ));
                    //$tpl->assign_array('block_properties_ctg', $this->getAllRootCategs());
                    $list = $this->getTree();
                    array_shift($list);
                    $tpl->assign_array('block_properties_ctg', $list);
                    if ('showcatmenu' != $request_sub_action) {
                        $tpl->newBlock('block_properties_prods');
                        $tpl->assign(Array(
                        "MSG_Goods_per_page" => $this->_msg["Goods_per_page"],
                        ));
                    }
                    $tpl->newBlock('block_page_edit');
                    $tpl->assign(Array(
                        "MSG_Go_to_edit" => $this->_msg["Go_to_edit"],
                        "site_target" => $request_site_target,
                    ));
                    $tpl->assignList('ptype_', $this->get_ptypes());
                    $tpl->assignList('service_', $this->getServiceList());
                    /*
                    if ('showcatmenu' == $request_sub_action) {
                        $tpl->newBlock('block_properties_prod_cnt');
                        $tpl->assign(Array(
                        "MSG_Show_prod_cnt" => $this->_msg["Show_prod_cnt"],
                        "MSG_No" => $this->_msg["No"],
                        "MSG_Yes" => $this->_msg["Yes"],
                        ));
                    }
                    */
                    break;
                case "showtoplevels":
                case "showtree":
                    $tpl->newBlock('block_properties');
                    $tpl->newBlock('block_properties_prod_cnt');
                    $tpl->assign(Array(
                    "MSG_Show_prod_cnt" => $this->_msg["Show_prod_cnt"],
                    "MSG_No" => $this->_msg["No"],
                    "MSG_Yes" => $this->_msg["Yes"],
                    ));
                    break;
                case "showsearchform":
                    break;
                default:
                    $tpl->newBlock('block_properties_none');
                    $tpl->assign(Array(
                    "MSG_No" => $this->_msg["No"],
                    ));
                    break;
            }
            return $this->getOutputContent($tpl->getOutputContent());
        }
        return FALSE;
    }
    function getEditLink($sub_action = NULL, $block_id = NULL) {
        GLOBAL $request_name, $db, $lang, $server;
        $block_id	= (int)$block_id;
        if ($sub_action && $block_id) {
            $db->query('SELECT	property1,
								property2,
								property3,
								property4,
								property5
							FROM '.$this->table_prefix.'_pages_blocks
							WHERE id = '.$block_id);
            if ($db->nf() > 0) {
                $db->next_record();
                $arr[]	= $db->f('property1');
                $arr[]	= $db->f('property2');
                $arr[]	= $db->f('property3');
                $arr[]	= $db->f('property4');
                $arr[]	= $db->f('property5');
                switch ($sub_action) {
                    case 'assortment': case 'showcatmenu':
                        $link['material_url']	= '/admin.php?lang='.$lang.'&name='.$request_name.'&action=assortment&menu=false&id=';
                        $link['material_id']	= $arr[1];
                        break;
                }
                return $link;
            }
            switch ($sub_action) {
                case 'assortment': case 'showcatmenu':
                    $link['material_url']	= '/admin.php?lang='.$lang.'&name='.$request_name.'&action=assortment&menu=false&id=';
                    $link['material_id']	= '';
                    break;
            }
            return $link;
        }
        return FALSE;
    }
    /**
 * Получение корневых категорий
 */
    function getAllRootCategs() {
        GLOBAL $CONFIG, $server, $lang, $db;
        $db->query('SELECT * FROM '.$this->table_prefix.'_maps_categories WHERE clevel = 1 AND active = 1 ORDER BY '.$CONFIG['maps_ctg_order_by']);
        if ($db->nf() > 0) {
            for ($i = 0; $i < $db->nf(); $i++) {
                $db->next_record();
                $arr[$i]['categ_id']   = $db->f('id');
                $arr[$i]['categ_name'] = $db->f('title');
                $arr[$i]['desc'] = $db->f('description');
                $arr[$i]['img'] = $db->f('img');
            }
            return $arr;
        }
        return FALSE;
    }

    // функция для показа строки с функциональностью добавления
    // товара или подкатегории в данную категорию
    function show_add_to_current($level, $parent) {
        global $lang, $CONFIG, $tpl, $name, $baseurl;
        if (0 < $level) {
            $product_add_link = $baseurl.'&action=addproduct&id='.$parent;
            $product_add_img  = '<img src="/'.$CONFIG["admin_img_path"].'ico_addprod.gif" alt="' . $this->_msg["Add_good"] . '" title="' . $this->_msg["Add_good"] . '" width=17 height=18 border=0 valign="absmiddle">&nbsp;' . $this->_msg["Add_good"] . '';
            $product_add	  = '<a class="add_btn" href="'.$product_add_link.'"><span>'.$product_add_img.'</span></a>';
        } else {
            $product_add = '';
        }
        $cat_add_link = $baseurl.'&action=addcat&id='.$parent;
        $cat_add_img  = '<img src="'.$CONFIG["admin_img_path"].'ico_addcat.gif" alt="' . $this->_msg["Add_category"] . '" title="' . $this->_msg["Add_category"] . '" width=17 height=18 border=0>&nbsp;' . $this->_msg["Add_category"] . '';
        $cat_add	  = '<a class="add_btn" href="'.$cat_add_link.'"><span>'.$cat_add_img.'</span></a>';
        $tpl->assign(array(
        'add_to_current'	=>	$cat_add.' '.$product_add,
        ));
        return TRUE;
    }
    // функция для добавления категории
    function add_catalog($item_rights, $block_id = 0) {
        global $request_id, $request_title, $request_txt_content, $request_rank,
        $request_description, $request_keywords, $request_alias,
        $request_lat, $request_lng, $request_zoom, $request_metro_id,
        $server, $lang, $main, $db, $CONFIG;
        
        $id			 = (int)$request_id;
        $title		 = $db->escape(trim($request_title));
        $alias		 = $this->translit($request_alias);
        if(empty($alias)) $alias = null;
        $description = trim(repl_entities($request_txt_content));
        $page_description = $db->escape(trim($request_description));
        $keywords	 = $db->escape(trim($request_keywords));
        list($max_rank, $min_rank) = $main->get_max_min_rank($this->table_prefix.'_maps_categories');
        $rank = $max_rank + 1;
        if (!isset($id)) $id	= 1;
        if($id == 1) {
            $db->query("SELECT id FROM " . $server . $lang . "_maps_categories WHERE id = 1 LIMIT 1");
            if(!$db->nf()) {
                $db->query("INSERT INTO " . $server . $lang . "_maps_categories (id, active, title, rank) VALUES ('1', '1', '" . $this->_msg["maps_root"] . "', '1')");
            }
        }
        $owner_id = $_SESSION["siteuser"]["id"];
        list($group_id, $rights) = $this->get_group_and_rights('maps_default_rights', $block_id);
        $arr = array(
        "title" => "$title", "parent_id" => $id, 'metro_id' => (int)$request_metro_id,
        "description" => "$description", "page_description" => "$page_description",
        "keywords" => "$keywords", "rank" => "$rank", "active" => "1",
        "owner_id" => $owner_id, "usr_group_id" => $group_id, "rights" => $rights,
        "lat" => $db->escape(trim($request_lat)), "lng" => $db->escape(trim($request_lng)),
        "zoom" => intval($request_zoom));
        if($alias){$arr['alias'] = $alias;}
        $CDBT = new NsDbTree($this->table_prefix.'_maps_categories', 'id', $this->CDBT_fields);
        if ($id = $CDBT->insert( $id,  $arr) ) {
            $this->setCtgrImg($id);
            return $id;
        } else {
            return FALSE;
        }
    }
    // функция для редактирования категории
    function edit_catalog() {
        global $request_id, $request_title, $request_txt_content,
        $request_rank, $request_alias, $request_del_img, $request_description,
        $request_keywords, $request_lat, $request_lng, $request_zoom, $request_metro_id,
        $server, $lang, $db, $CONFIG;
        $id			 = (int)$request_id;
        $rank		 = (int)$request_rank;
        $title		 = $db->escape(trim($request_title));
        $description = trim(repl_entities($request_txt_content));
        $alias       = $this->translit($request_alias);
        $page_description = $db->escape(trim($request_description));
        $keywords	 = $db->escape(trim($request_keywords));
        $CDBT = new NsDbTree($this->table_prefix."_maps_categories", "id", $this->CDBT_fields);
        $arr = array(
        "title" => "$title", "metro_id" => (int)$request_metro_id, "description" => "$description",
        "page_description" => "$page_description", "keywords" => "$keywords",
        "lat" => $db->escape(trim($request_lat)), "lng" => $db->escape(trim($request_lng)),
        "zoom" => intval($request_zoom));
        if(!empty($alias))  $arr["alias"] = $alias;
        $CDBT->update( $id,  $arr);
        
        $this->setCtgrImg($id, $request_del_img);

        return true;
    }
    // функция для удаления категории
    // ---------------------------------------------------------
    function delete_catalog($id) {
        global $request_id, $server, $lang, $main, $db, $CONFIG;
        $CDBT				=	new NsDbTree($this->table_prefix.'_maps_categories', 'id', $this->CDBT_fields);
        $id					=	(int)$id;
        if (!$id) return FALSE;
        $parent				=	$CDBT->getParent($id);
        $chieldArray		=	$CDBT->enumChildrenAll($id);
        // удаление картинок категорий
        $ids = implode(",", $chieldArray);
        $ids = ($ids) ? $id.",".$ids : $id;
        $query = "SELECT img FROM ".$this->table_prefix."_maps_categories WHERE id IN (".$ids.") AND LENGTH(img) > 0";
        $db->query($query);
        while ($db->next_record()) {
            if ($db->f('img')) {
                @unlink($CONFIG["maps_ctg_img_path"].$db->f('img'));
            }
            if ($db->f('img_big')) {
                @unlink($CONFIG["maps_ctg_img_path"].$db->f('img_big'));
            }
        }
        $del_cat_check	= array();
        foreach($chieldArray as $ID) {
            if ($CDBT->delete($ID)) {
                $del_cat_check[1][$ID] = 1;
                $this->del_ctgr_products($ID);
            } else {
                $del_cat_check[0][$ID] = 0;
            }
        }
        if ($CDBT->delete($id)) {
            $del_cat_check[1][$id] = 1;
            $this->del_ctgr_products($id);
        } else {
            $del_cat_check[0][$id] = 0;
        }
        $deleted = count($del_cat_check[1]);
        $errors = count($del_cat_check[0]);
        if ($errors) {
            $main->message_die($this->_msg["ATTENTION_Delete_error"] . " " . $this->_msg["Deleted_categories"] . ": $deleted, " . $this->_msg["Errors"] . ": $errors. ".arr($chieldArray, $this->_msg["Array_with_deleting_IDs"]));
        }
        return $parent;
    }
    /**
	 * Удаление товаров категории
	 *
	 * @param int $ctgr_id
	 * @return boolean
	 */
    function del_ctgr_products($ctgr_id)
    {
        global $server, $lang, $db, $CONFIG;
        $ctgr_id = (int) $ctgr_id;
        if ($ctgr_id < 1) {
            return FALSE;
        }
        /* Получаем список идентификаторов и изображений товаров категории */
        $prod_ids = array();
        $prod_imgs = array();
        $query = "SELECT id, image_middle, image_big FROM ".$this->table_prefix."_maps_products WHERE category_id=".$ctgr_id;
        //echo $query;
        $db->query($query);
        if ($db->nf() > 0) {
            while($db->next_record()) {
                $prod_ids[] = $db->f('id');
                $prod_imgs[] = array($db->f('image_middle'), $db->f('image_big'));
            }
        } else {
            return FALSE;
        }
        /* Удаляем изображения товаров категории */
        foreach ($prod_imgs as $k => $img) {
            if ($img[0]) {
                @unlink(RP.$CONFIG['maps_img_path'].$img[0]);
            }
            if ($img[1]) {
                @unlink(RP.$CONFIG['maps_img_path'].$img[1]);
            }
        }
        /* Удаляем товары из БД */
        $query = "DELETE FROM ".$this->table_prefix."_maps_products WHERE category_id=".$ctgr_id;
        $db->query($query);
        return FALSE;
    }
    function get_ptype($id)
    {
    	global $db, $CONFIG;

    	$ret = $db->getArrayOfResult('SELECT * FROM '.$this->table_prefix.'_maps_ptypes WHERE id = '.$id);
    	if ($ret) {
    	    if ($ret[0]['icon'] && file_exists(RP.$CONFIG['maps_ptype_img_path'].$ret[0]['icon'])) {
    	    	$ret[0]['icon_path'] = $CONFIG['maps_ptype_img_path'].$ret[0]['icon'];
    	    }
    	    return $ret[0];
    	}

    	return false;
    }
    // функция для вывода информации о типе товара
    function show_ptype($id) {
        global $CONFIG, $tpl, $baseurl;

        $ptype = $this->get_ptype($id);
        if ($ptype) {
            $assign = array(
                'ptype_id'	=>	$ptype['id'],
                'ptype_name'	=>	htmlspecialchars($ptype['ptype_name']),
                'link'		=>	htmlspecialchars($ptype['link']),
                'ptype_link'	=>	$baseurl.'&action=showptype&id='.$ptype['id'],
            );
            $tpl->assign($assign);
            if ($ptype['icon_path']) {
            	$tpl->newBlock('block_ptype_icon');
            	$assign['icon_path'] = "/".$ptype['icon_path'];
            	$assign['MSG_Delete'] = $this->_msg['Delete'];
            } else {
            	$tpl->newBlock('block_ptype_no_icon');
            }
            $tpl->assign($assign);
            return $ptype['ptype_name'];
        }
        return 0;
    }
    // функция для добавления типа товара
    function add_ptype($ptypename = '', $link = '') {
        global $db, $CONFIG, $main;
        $ptypename	= $db->escape(trim($ptypename));
        $link		= $db->escape(trim($link));
        if (!$ptypename) return FALSE;
        $db->query("INSERT INTO ".$this->table_prefix."_maps_ptypes (ptype_name, link) VALUES ('"
            .$ptypename."', '".$link."')");
        $lid =  $db->affected_rows() > 0 ? $db->lid() : FALSE;
        if ($lid && isset($_FILES['icon']) && $_FILES['icon']['tmp_name']) {
        	$icon = $main->upload_file(
        	    'icon',
                $CONFIG['files_img_max_size'],
                $CONFIG['maps_ptype_img_path'],
                '',
                $this->image_formats
            );
            if ($icon) {
            	$db->query("UPDATE ".$this->table_prefix."_maps_ptypes SET icon='".$db->escape($icon)."' WHERE id=".$lid);
            }
            return $lid;
        }

        return false;
    }
    // функция для обновления типа товара
    function update_ptype($ptypename = '', $link = '', $id = '', $del_icon = false) {
        global $CONFIG, $db, $main;
        $id			= (int)$id;
        $ptypename	= $db->escape(trim($ptypename));
        $link		= $db->escape(trim($link));
        $ptype = $this->get_ptype($id);

        if (!$ptypename || !$ptype) return FALSE;
        $icon = $ptype['icon'];
        if ($del_icon) {
            $icon = '';
            if ($ptype['icon_path']) {
                @unlink(RP."/".$ptype['icon_path']);
                $ptype['icon_path'] = '';
            }
        }
        if (isset($_FILES['icon']) && $_FILES['icon']['tmp_name']) {
            if ($ptype['icon_path']) {
                @unlink(RP."/".$ptype['icon_path']);
                $ptype['icon_path'] = '';
                $icon = '';
            }
            $upld_icon = $main->upload_file(
                'icon',
                $CONFIG['files_img_max_size'],
                $CONFIG['maps_ptype_img_path'],
                '',
                $this->image_formats
            );
            if ($upld_icon) {
            	$icon = $upld_icon;
            }
        }
        $db->query('UPDATE '.$this->table_prefix.'_maps_ptypes SET ptype_name = "'
            .$ptypename.'", link = "'.$link.'", icon="'.$icon.'" WHERE id='.$id);
        return ($db->affected_rows() > 0) ? 1 : 0;
    }

    // функция для удаления тип товара
    function delete_ptype($id) {
        global $CONFIG, $db;
        $id = (int)$id;
        $ptype = $this->get_ptype($id);

        if (!$ptype) return FALSE;
        if ($ptype['icon_path']) {
            @unlink(RP."/".$ptype['icon_path']);
        }
        if ($this->delete_entry($this->table_prefix.'_maps_ptypes', $id)) {
            $query = 'UPDATE '.$this->table_prefix.'_maps_products SET ptype_id = 0 WHERE ptype_id = '.$id;
            $db->query($query);
            return TRUE;
        }
        return FALSE;
    }
    // метод для добавления продукта в категори
    function add_product($category_id,
    $group_id,
    $stat_id,
    $service,
    $prp_val,
    $prp_pic,
    $request_currency,
    $request_price_1,
    $request_price_2,
    $request_price_3,
    $request_price_4,
    $request_price_5,
    $ptype_id, $pcode, $pname, $info,
    $full_description, $description, $keywords,
    $availability,
    $lat, $lng, $zoom,
    $addr,
    $phone,
    $open,
    $leader,
    $item_rights, $block_id = 0, $e_mail = '')
    {
        global $CONFIG, $main, $db, $server, $lang, $request_alias;
        $pname 			  = $db->escape(trim($pname));
        if (!@$pname) return FALSE;
        $category_id 	  = (int)$category_id;
        $group_id 		  = (int)$group_id;
        $ptype_id 		  = (int)$ptype_id;
        $price_1		  = (int)($request_price_1*100);
        $price_2		  = (int)($request_price_2*100);
        $price_3		  = (int)($request_price_3*100);
        $price_4		  = (int)($request_price_4*100);
        $price_5		  = (int)($request_price_5*100);
        $currency 		  = $db->escape(trim($request_currency));
        $lang 			  = $db->escape(trim($lang));
        $pcode 			  = $db->escape(trim($pcode));
        $info             = $db->escape(trim($info));
        $full_description = $db->escape(repl_entities($full_description));
        $description	  = $db->escape(trim($description));
        $keywords		  = $db->escape(trim($keywords));
        $availability 	  = $db->escape(substr(trim($availability), 0, 10));
        $lat    		  = (float)$lat;
        $lng    		  = (float)$lng;
        $zoom    		  = (float)$zoom;
        $addr             = $db->escape(trim($addr));
        $phone             = $db->escape(trim($phone));
        $open             = $db->escape(trim($open));
        $e_mail = $db->escape(trim($e_mail));
        $alias            = $this->translit($request_alias);
        $owner_id = $_SESSION["siteuser"]["id"];
        $db->query("SELECT usr_group_id FROM ".$this->table_prefix."_maps_categories WHERE id=".$category_id);
        if (!$db->next_record() || ! $this->isValidAlias($category_id, $alias)) {
            return false;
        }
        $alias            = (empty($alias)) ? 'NULL' : "'{$alias}'";
        list($usr_group_id, $rights) = $this->get_group_and_rights('catalog_default_rights', $block_id, $db->f("usr_group_id"));
        $rights = $item_rights ? $item_rights : $rights;
        // Получить значение rank (порядок следования в каталоге)
        list($max_rank, $min_rank) = $main->get_max_min_rank($this->table_prefix.'_maps_products');
        $rank = $max_rank + 1;
        $db->query("INSERT INTO ".$this->table_prefix."_maps_products (
														  category_id,
														  group_id,
														  ptype_id,
														  product_code,
														  product_title,
                              alias,
                              product_inf,
														  product_description,
														  currency,
														  price_1,
														  price_2,
														  price_3,
														  price_4,
														  price_5,
														  product_availability,
														  description,
														  keywords,
														  rank,
														  owner_id,
														  usr_group_id,
														  rights,
														  lat,
														  lng,
														  zoom,
														  addr,
														  phone,
														  open,
                                                          leader,
														  e_mail
														 )
											VALUES (".$category_id.",
													".$group_id.",
													".$ptype_id.",
													'".$pcode."',
													'".$pname."',
													".$alias.",
													'".$info."',
													'".$full_description."',
													'".$currency."',
													'".$price_1."',
													'".$price_2."',
													'".$price_3."',
													'".$price_4."',
													'".$price_5."',
													'".$availability."',
													'".$description."',
													'".$keywords."',
													'".$rank."',
													".$owner_id.",
													".$usr_group_id.",
													".$rights.",
													".$lat.",
													".$lng.",
													".$zoom.",
													'".$addr."',
													'".$phone."',
													'".$open."',
                                                    ".($leader ? 1 : 0).",
													'$e_mail'
												   )");
        if ($db->affected_rows() > 0) {
            $lid = $db->lid();
            $this->check_path($CONFIG["maps_img_path"]);
            // закачаем картинки
            $update_img_str = $this->upload_catalog_images('image_middle', $CONFIG["maps_img_path"], $lid);
            $update_img_str .= $this->upload_catalog_images('image_big', $CONFIG["maps_img_path"], $lid, 'image_big', 'big');
            $db->query("UPDATE ".$this->table_prefix."_maps_products SET product_title='".$pname."' ".$update_img_str." WHERE id=".$lid);
            
            $this->setItemStat($lid, $stat_id);
            $this->setItemService($lid, $service);
            
            return $lid;
        }
    }
    // функция для обновления товара в базе данных
    function update_product($id,
    $group_id,
    $stat_id,
    $service,
    $prp_val,
    $prp_pic,
    $prp_pic_del,
    $prp_curr,
    $price_1,
    $price_2,
    $price_3,
    $price_4,
    $price_5,
    $ptype_id,
    $pcode,
    $pname,
    $info,
    $full_description,
    $description,
    $keywords,
    $availability,
    $lat, $lng, $zoom,
    $addr, $phone, $open,
    $leader,
    $del_img_middle,
    $del_img_big,
    $del_pic,
    $e_mail = '')
    {
        global $CONFIG, $db, $server, $lang, $request_alias;
        $id 				= ($id) ? (int)$id : 0;
        $group_id			= (int)$group_id;
        $ptype_id			= (int)$ptype_id;
        $price_1			= (int)($price_1*100);
        $price_2			= (int)($price_2*100);
        $price_3			= (int)($price_3*100);
        $price_4			= (int)($price_4*100);
        $price_5			= (int)($price_5*100);
        $prp_curr			= $db->escape(trim($prp_curr));
        $lang				= $db->escape(trim($lang));
        $pcode				= $db->escape(trim($pcode));
        $pname				= $db->escape(trim($pname));
        $short_description	= $db->escape(trim($short_description));
        $info               = $db->escape(trim($info));
        $full_description	= $db->escape(repl_entities($full_description));
        $description		= $db->escape(trim($description));
        $keywords			= $db->escape(trim($keywords));
        $availability		= $db->escape(trim($availability));
        $lat    		  = (float)$lat;
        $lng    		  = (float)$lng;
        $zoom    		  = (float)$zoom;
        $addr             = $db->escape(trim($addr));
        $phone             = $db->escape(trim($phone));
        $open             = $db->escape(trim($open));
        $alias            = $this->translit($request_alias);
        $db->query("SELECT category_id FROM {$this->table_prefix}_maps_products WHERE id=".$id);
        if (!@$id || !@$pname || !$db->nf()) {
            return FALSE;
        }
        if (! $this->isValidAlias($db->Record['category_id'], $alias, $id)) {
            return FALSE;
        }
        $alias            = (empty($alias)) ? 'NULL' : "'{$alias}'";
        $query = "UPDATE ".$this->table_prefix."_maps_products
					SET group_id = '$group_id',
						ptype_id = '$ptype_id',
						currency = '$prp_curr',
						price_1	 = '$price_1',
						price_2	 = '$price_2',
						price_3	 = '$price_3',
						price_4	 = '$price_4',
						price_5	 = '$price_5',
						product_code = '$pcode',
						product_title = '$pname',
                        alias = $alias,
                        product_inf = '$info',
						product_description = '$full_description',
						product_availability = '$availability',
						description	= '$description',
						keywords = '$keywords',
						lat=".$lat.",
						lng=".$lng.",
						zoom=".$zoom.",
						addr='".$addr."',
						phone='".$phone."',
						open='".$open."',
						leader=".($leader ? 1 : 0).",
						`e_mail` = '$e_mail'
					WHERE id = ".$id;
        $db->query($query);
        
        $this->setItemStat($id, $stat_id);
        $this->setItemService($id, $service);
        
        $update_img_str = $update_big_img_str = '';
        $update_big_img_str = $this->upload_catalog_images('image_big', $CONFIG["maps_img_path"], $id, 'image_big', 'big');
        $update_img_str = $this->upload_catalog_images('image_middle', $CONFIG["maps_img_path"], $id);
        if ($del_img_big || $del_img_middle || $update_img_str || $update_big_img_str) {
            $query = "SELECT * FROM ".$this->table_prefix."_maps_products WHERE id=".$id;
            $db->query($query);
            $db->next_record();
            $im = $db->f('image_middle');
            $ib = $db->f('image_big');
            if ($im && ($del_img_middle || $update_img_str)) {
                @unlink(RP.$CONFIG["maps_img_path"].$im);
                $update_img_str = $update_img_str ? $update_img_str : ", image_middle = ''";
            }
            if ($ib && ($update_big_img_str || $update_big_img_str)) {
                @unlink(RP.$CONFIG["maps_img_path"].$ib);
                $update_big_img_str = $update_big_img_str ? $update_big_img_str : ", image_big = ''";
            }
        }
        if ($update_img_str || $update_big_img_str) {
            $db->query("UPDATE ".$this->table_prefix."_maps_products SET product_title='".$pname."' ".$update_img_str.$update_big_img_str." WHERE id=".$id);
        }

        return TRUE;
    }

    function isValidAlias($ctgr_id, $alias, $except_prod = 0)
    {   global $db;

        $ret = true;
        $a = My_Sql::escape($alias);
        if ($a && 'null' != strtolower($a) ) {
        	$db->query("SELECT id FROM {$this->table_prefix}_maps_products WHERE category_id="
        	    .intval($ctgr_id).($except_prod ? " AND id<>".intval($except_prod) : "")
        	    ." AND (alias='{$a}' OR (alias IS NULL AND id='{$a}') )");
        	$ret = $db->nf() ? false : true;
        }

        return $ret;
    }
    /**
	 * Удаление картинки товара
	 * @param $id - индекс товар
	 * @param $type - тип удалаемой картинки large или small
	 */
    function delete_product_image($id, $type) {
        global $CONFIG, $db, $server, $lang;
        $id   = (int)$id;
        $lang = $db->escape(trim($lang));
        $type = $db->escape(trim($type));
        if (!@isset($id) || !@$type) return FALSE;
        $query = "SELECT * FROM ".$this->table_prefix."_maps_products WHERE id=".$id;
        $db->query($query);
        $db->next_record();
        if (@unlink($CONFIG["maps_img_path"].$db->f('product_image_'.$type))) {
            $query = "UPDATE ".$this->table_prefix."_maps_products
						SET product_image_".$type." = ''
						WHERE id = ".$id;
            $db->query($query);
        }
        return TRUE;
    }
    // Удаления товара из базы данных
    function delete_product($id = 0) {
        global $CONFIG, $db, $server, $lang;
        $id    = (int)$id;
        $lang  = $db->escape(trim($lang));
        $table = $db->escape(trim($table));
        if (!$id) return FALSE;
        $record = array();
        // получим имена всех картинок
        $db->query('SELECT * FROM '.$this->table_prefix.'_maps_products WHERE id = '.$id);
        if ($db->nf() > 0) {
            $db->next_record();
            $small = $db->f("image_middle");
            $big = $db->f("image_big");
            if ($small) {
                @unlink(RP.$CONFIG['maps_img_path'].$small);
            }
            if ($big) {
                @unlink(RP.$CONFIG['maps_img_path'].$big);
            }
        }
        $db->query('DELETE FROM '.$this->table_prefix.'_maps_products WHERE id = '.$id);
        $db->query('DELETE FROM '.$this->table_prefix.'_maps_prod_stat WHERE prod_id = '.$id);

        return TRUE;
    }
    // функция для удаления товаров из базы данных
    function delete_products($table, $where = '') {
        global $CONFIG, $db, $lang;
        $lang	= $db->escape(trim($lang));
        $table	= $db->escape(trim($table));
        $where	= $db->escape(trim($where));
        if (!@$table || !@$where) return FALSE;
        $query = 'SELECT * FROM '.$this->table_prefix.'_maps_products WHERE 1=1 '.$where;
        $db->query($query);
        if ($db->nf() > 0) {
            $ids = array();
            for ($i=0; $i<$db->nf(); $i++) {
                $db->next_record();
                $ids[] = $db->Record['id'];

                if ($db->Record['image_middle']) {
                    @unlink(RP.$CONFIG['maps_img_path'].$db->Record['image_middle']);
                }
                if ($db->Record['image_big']) {
                    @unlink(RP.$CONFIG['maps_img_path'].$db->Record['image_big']);
                }
            }
            $db->query('DELETE FROM '.$this->table_prefix.'_maps_prod_stat WHERE id IN ('.implode(',', $ids).')');
        }
        return TRUE;
    }
    // функция для загрузки картинок для товара
    function upload_catalog_images($img, $path, $id, $field_name='image_middle', $img_type = 'image')
    {   global $CONFIG, $main, $db;
    
        $id    = (int)$id;
        if (!@$id || !@$path) {
            return FALSE;
        }
        $id = str_pad($id, 5, "0", STR_PAD_LEFT);
        $imagenames_array	= array();
        $update_img_str		= '';
        if($field_name=='image_middle' && $_REQUEST['cr_image_middle']=='1' && @is_file(RP.$CONFIG['maps_img_path'].$_REQUEST['image_big_name'])){
            $image_big = $_REQUEST['image_big_name']; $image = $_REQUEST['image_middle_name'];
            $this->check_image($image_big, $image);
            return  ", image_middle = '".$image."'";
        }
        foreach ($_FILES[$img] as $field => $arr) {
                // загрузить картинку
                if ($arr && ($field == 'name')) {
                    $set_file_name = $id.'_'.$img_type.'_'.$arr;
                    $imagename = $main->upload_file($img,
                        $CONFIG['files_img_max_size'],
                        $path,
                        '',
                        $this->image_formats,
                        $set_file_name
                    );
                    if ($imagename) {
                        // подогнать по ширине
                        //							if ($arr["resize"]) @$main->resize_by_width($imagename, $path, $arr["resize"]);
                        //							$imagenames_array[] = $imagename;
                        $update_img_str .= ", ".$field_name." = '".$imagename."'";
                    }
                }
        }
        return $update_img_str;
    }

    // функция для удаления записи из базы данных
    function delete_entry($table = "", $id = 0) {
        global $CONFIG, $db, $lang;
        $lang  = $db->escape(trim($lang));
        $table = $db->escape(trim($table));
        $id    = (int)$id;
        if (!@$id || !@$table) return FALSE;
        $query = 'DELETE FROM '.$table.' WHERE id='.$id;
        $db->query($query);
        return ($db->affected_rows() > 0) ? TRUE : FALSE;
    }

    /**
	 * Изменить свойство товара - лидер продаж
	 * @param int $id	Id товара
	 * @return boolean
	 */
    function changeLeader($id)
    {   global $db;
    if (!$id = (int)$id) {
        return FALSE;
    }
    $db->query('UPDATE '.$this->table_prefix.'_maps_products
		        	SET leader = IF (leader, 0, 1) WHERE id = '.$id);
    return $db->affected_rows() ? TRUE : FALSE;
    }
    /**
	 * Сменить категорию у товаров
	 *
	 * @param int	$new_ctgr	ID новой категории
	 * @param array	$prod_list	Массив идентификаторов товаров
	 * @return boolean
	 */
    function changCatgrOfProducts($new_ctgr, $prod_list)
    {
        global $db;

        $ctgr = $this->getCategory($new_ctgr);
        if (!$ctgr) {
            return FALSE;
        }
        if (!is_array($prod_list)) {
            return FALSE;
        }
        $ids = "";
        foreach ($prod_list as $prod_id) {
            $ids .= (int) $prod_id.", ";
        }
        if (!$ids = substr($ids, 0, -2)) {
            return FALSE;
        }
        $query = "UPDATE ".$this->table_prefix."_maps_products SET category_id=".$new_ctgr." WHERE id IN (".$ids.")";
        $db->query($query);
        return TRUE;
    }
    /**
	 * Добавить связанный товар
	 *
	 * @param int $prod_id
	 * @param int $concrn_id
	 * @return boolean
	 */
    function addConcernedProduct($prod_id, $concrn_id)
    {
        global $db;
        $prod_id = (int)$prod_id;
        $concrn_id = (int)$concrn_id;
        if (0 >= $prod_id || 0 >= $concrn_id || $prod_id == $concrn_id) {
            return FALSE;
        }
        $query = "SELECT id FROM ".$this->table_prefix."_maps_products WHERE id IN (".$prod_id.", ".$concrn_id.")";
        $db->query($query);
        if ($db->nf() < 2) {
            return FALSE;
        }
        $query = "REPLACE INTO ".$this->table_prefix."_maps_concerned_products SET prod_id=".$prod_id.", concrn_id=".$concrn_id;
        $db->query($query);
        if (!$db->nf()) {
            return FALSE;
        }
        return TRUE;
    }
    function delConcernedProduct($prod_id, $concrn_id)
    {
        global $db;
        $prod_id = (int)$prod_id;
        $concrn_id = (int)$concrn_id;
        $query = "SELECT prod_id FROM ".$this->table_prefix."_maps_concerned_products WHERE prod_id=".$prod_id." AND concrn_id=".$concrn_id;
        $db->query($query);
        if (!$db->nf()) {
            return FALSE;
        }
        $query = "DELETE FROM ".$this->table_prefix."_maps_concerned_products WHERE prod_id=".$prod_id." AND concrn_id=".$concrn_id;
        $db->query($query);
        return TRUE;
    }

    function my_iconv($charset_from, $charset_to, $str){
        if ($ret = iconv($charset_from, $charset_to, $str)) {
            return $ret;
        }
        $str_arr = explode(" ", $str);
        for ($i=0; $i < sizeof($str_arr); $i++) {
            $str_arr[$i] = iconv($charset_from, $charset_to, $str_arr[$i]);
        }
        return implode(" ", $str_arr);
    }
    function conv_str($str){
        switch ($this->data_charset) {
            case 'cp1251':
                return $this->my_iconv("WINDOWS-1251", "UTF-8", $str);
            case 'koi8-r':
                return $this->my_iconv("KOI8-R", "UTF-8", $str);
            case 'iso-8859-1':
                return $this->my_iconv("ISO-8859-1", "UTF-8", $str);
            default:
                return $str;
        }
    }
    function conv_str_from_utf8($str){
        switch ($this->data_charset) {
            case 'cp1251':
                return $this->my_iconv("UTF-8", "WINDOWS-1251", $str);
            case 'koi8-r':
                return $this->my_iconv("UTF-8", "KOI8-R", $str);
            case 'iso-8859-1':
                return $this->my_iconv("UTF-8", "ISO-8859-1", $str);
            default:
                return $str;
        }
    }
    /**
	 * Получить Id всех дочерних разделов
	 *
	 * @param int $id
	 * @param boolean $active  true - только опубликованные
	 * @return array
	 */
    function getChildIds($id, $active = true)
    {   global $db;
    $id = (int)$id;
    $query = "SELECT CH.id FROM ".$this->table_prefix."_maps_categories AS P, ";
    $query .= $this->table_prefix."_maps_categories AS CH";
    $query .= " WHERE P.id=".$id." AND CH.cleft >= P.cleft AND CH.cright <= P.cright";
    $query .= $active ? " AND CH.active" : "";
    $ret = array();
    $db->query($query);
    while ($db->next_record()) {
        $ret[] = $db->f('id');
    }
    return $ret;
    }
    /**
	 * Кол-во товаров в катагории и всех её подкатегориях
	 *
	 * @param int $id
	 * @param boolean $active true - только опубликованные каткгории и товары
	 * @return int
	 */
    function getProdCount($id, $active = true)
    {   global $db;
    $id = (int)$id;
    $child_ids = $this->getChildIds($id, $active);
    $query = 'SELECT COUNT(*) AS cnt FROM '.$this->table_prefix.'_maps_products';
    $query .= ' WHERE category_id IN ('.$id;
    $query .= (count($child_ids) ? ', '.implode(', ', $child_ids).')' : ')').($active ? " AND active" : "");
    $db->query($query);
    if ($db->next_record()) {
        return $db->f('cnt');
    }
    return 0;
    }
    function showCtgList($ctg_list, $curr_ctg_id = NULL){
        global $tpl, $CONFIG;
        if (is_array($ctg_list)) {
            $tpl->newBlock('block_categories');
            foreach ($ctg_list as $key => $val) {
                $tpl->newBlock('block_category_row');
                $tpl->assign(
                array(
                'ctg_id'    => $val['ctg_id'],
                'ctg_link'  => $val['ctg_link'],
                'ctg_name'  => $val['ctg_name'],
                'ctg_descr' => $val['ctg_descr'],
                'ctg_img'   => $val['ctg_img'],
                'row_start' => $val['row_start'],
                'row_end'   => $val['row_end'],
                'selected'   => $curr_ctg_id == $val['ctg_id'] ? 'selected' : '',
                )
                );
                if ($val['ctg_img'] && file_exists(RP.$CONFIG['maps_ctg_img_path'].$val['ctg_img'])) {
                    $tpl->newBlock('block_category_img');
                    $tpl->assign(array(
                        'ctg_id' => $val['ctg_id'],
                        'ctg_link' => $val['ctg_link'],
                        'ctg_name' => $val['ctg_name'],
                        'img' => "/".$CONFIG['maps_ctg_img_path'].$val['ctg_img']
                    ));
                }
            }
        }
    }
    function showLeadersList($list)
    {
        global $tpl, $CONFIG;
        if (is_array($list)) {
            $tpl->newBlock('block_leaders');
            foreach ($list as $k => $prod_info) {
                $tpl->newBlock('block_leader_row');
                $tpl->assign($prod_info);
                if (!is_array($_SESSION["compare_prod"])
                || !in_array($prod_info["prod_id"], $_SESSION["compare_prod"])
                ) {
                    $tpl->newBlock('block_leader_compare_elements');
                    $tpl->assign("prod_id", $prod_info["prod_id"]);
                } else {
                    $tpl->newBlock('block_leader_compare_elements_no');
                }
                if ($prod_info["prod_image"]) {
                    $tpl->newBlock('block_leader_img');
                    $tpl->assign(
                    array(
                    "img"	=> $prod_info["prod_image"],
                    "prod_title"	=> htmlspecialchars($prod_info["prod_title"]),
                    "prod_link"	=> $prod_info["prod_link"],
                    ));
                } else {
                    $tpl->newBlock('block_leader_img_no');
                }
                if ($prod_info["prod_image_big"]) {
                    $tpl->newBlock('block_leader_img_big');
                    $tpl->assign(
                    array(
                    "img"	=> $prod_info["prod_image_big"],
                    "prod_title"	=> htmlspecialchars($prod_info["prod_title"]),
                    "prod_link"	=> $prod_info["prod_link"],
                    ));
                } else {
                    $tpl->newBlock('block_leader_img_big_no');
                }
                if ($prod_info["prod_ptype_link"]) {
                    $tpl->newBlock('block_leader_ptype'.((strtolower(substr($prod_info["prod_ptype_link"], 0, 7)) === "http://") ? '' : '_local').'_link');
                    $tpl->assign(array(
                    'ptype_name'	=> $prod_info["prod_ptype_name"],
                    'ptype_link'	=> $prod_info["prod_ptype_link"],
                    ));
                } else if ($prod_info["prod_ptype_name"]) {
                    $tpl->newBlock('block_leader_ptype_without_link');
                    $tpl->assign('ptype_name', $prod_info["prod_ptype_name"]);
                }
                if ($prod_info["prod_availability"]) {
                    $tpl->newBlock('block_leader_availability');
                    $tpl->assign("availability", $prod_info["prod_availability"]);
                }
            }
        }
    }
    function showProdList($list)
    {
        global $tpl, $CONFIG;
        if (is_array($list) && !empty($list)) {
            $tpl->newBlock('block_products');
            foreach ($list as $k => $prod_info) {
                $tpl->newBlock('block_product_row');
                $tpl->assign($prod_info);
                if ($prod_info["prod_image"]) {
                    $tpl->newBlock('block_product_img');
                    $tpl->assign(array(
                        "img"		=> $prod_info["prod_image"],
                        "prod_title"	=> htmlspecialchars($prod_info["prod_title"]),
                        "prod_link"	=> $prod_info["prod_link"],
                        "prod_id"	=> $prod_info["prod_id"],
                    ));
                } else {
                    $tpl->newBlock('block_product_img_no');
                }
                if ($prod_info["prod_image_big"]) {
                    $tpl->newBlock('block_product_img_big');
                    $tpl->assign( array(
                        "img"		=> $prod_info["prod_image_big"],
                        "prod_title"	=> htmlspecialchars($prod_info["prod_title"]),
                        "prod_link"	=> $prod_info["prod_link"],
                    ));
                } else {
                    $tpl->newBlock('block_product_img_big_no');
                }
                if ($prod_info["ptype_link"]) {
                    $tpl->newBlock('block_product_ptype'.((strtolower(substr($prod_info["ptype_link"], 0, 7)) === "http://") ? '' : '_local').'_link');
                    $tpl->assign(array(
                    'ptype_name'	=> $prod_info["ptype_name"],
                    'ptype_link'	=> $prod_info["ptype_link"],
                    ));
                } else if ($prod_info["ptype_name"]) {
                    $tpl->newBlock('block_product_ptype_without_link');
                    $tpl->assign('ptype_name', $prod_info["ptype_name"]);
                }
                if ($prod_info["prod_availability"]) {
                    $tpl->newBlock('block_product_availability');
                    $tpl->assign("prod_availability", $prod_info["prod_availability"]);
                }
                if ($prod_info["prod_phone"]) {
                    $tpl->newBlock('prod_phone');
                    $tpl->assign($prod_info);
                }
                if ($prod_info["prod_lat"] && $prod_info["prod_lng"]) {
                    $tpl->newBlock('block_lat_lng');
                    $tpl->assign(array(
                    'lat' => $prod_info["prod_lat"],
                    'lng' => $prod_info["prod_lng"],
                    'zoom' => $prod_info["prod_zoom"] > 0 ? $prod_info["prod_zoom"] : $this->default_zoom,
                    ));
                }
                if ($prod_info['stat_list']) {
                    $tpl->assignList('metro_stat_', $prod_info['stat_list']);
                }
            }
        }
    }
    function goodExists($dir,$good,$type){
        global $db1; $ds = explode('/',$dir);
        if(sizeof(array_filter($ds))!=sizeof($ds)){return false;}
        $query = "select id, parent_id, if(alias is not null,alias,id) as path from `{$this->table_prefix}_maps_categories` having path IN ('".implode("','",$ds)."') order by clevel";
        $db1->query($query); $parent = 1;
        if($db1->nf()){
            while($db1->next_record()){
                if($db1->f('parent_id')!=$parent){return false;}
                $parent = $current = $db1->f('id');
            }
        }
        if($type == 'ctg'){return $current;}
        $query = "select id, if(alias is not null and alias!='',alias,id) as path ".
        " from `{$this->table_prefix}_maps_products` where category_id='{$current}' having path='{$good}' ";
        $db1->query($query);
        if($db1->nf()!=1){return false;}
        $db1->next_record();
        $ret = $db1->f('id');
        return $ret;
    }
    function getElementPath($id, $type){
        if(!in_array($type, array('good','ctg')) || empty($id)){return false;}
        static $path = array('good'=>array(),'ctg'=>array());
        if($path[$type][$id]){return $path[$type][$id];}
        $db = $GLOBALS['db1'];
        $tables = array(
        'good'  => $this->table_prefix.'_maps_products',
        'ctg'   => $this->table_prefix.'_maps_categories'
        );
        if($type == 'good'){
            $sql = "select id, category_id, if(alias is not null and alias!='',alias,id) as path from {$tables['good']} where id ";
            $sql .= (is_array($id)) ? " in(".implode(',',$id).")" : "= {$id}";
            $db->query($sql);
            if(!$db->nf()){return false;}
            while($db->next_record()){$ids_goods[$db->f('id')] = array('id'=>$db->f('id'),'parent'=>$db->f('category_id'), 'alias'=>$db->f('path'));}
        }
        if($type == 'ctg' || is_array($ids_goods)){
            $ctg = is_array($ids_goods) ? array_unique(array_map(create_function('$a','return $a["parent"];'),$ids_goods)) : array($id);
        }
        if(is_array($ctg)){
            $ids_ctg = array();
            while(false!=($r = array_diff($ctg, array_merge(array_keys($path['ctg']),array_keys($ids_ctg))))){
                $sql = "select id, parent_id, if(alias is not null and alias!='',alias,id) as path from {$tables['ctg']} where id in(".implode(',',$r).")";
                $db->query($sql);
                if(!$db->nf()){break;}
                while($db->next_record()){
                    $ids_ctg[$db->f('id')] = array('id'=>$db->f('id'),'parent'=>$db->f('parent_id'), 'alias'=>$db->f('path'));
                    if(!in_array($db->f('parent_id'), array_merge($ctg, array_keys($path['ctg']), array_keys($ids_ctg)))){$ctg[] = $db->f('parent_id');}
                }
            }
            foreach($ids_ctg as $k=>$v){
                if(!$path['ctg'][$k]) $this->setPath($k, $ids_ctg, $path['ctg']);
            }
        }
        if(is_array($ids_goods)){
            foreach($ids_goods as $k=>$v){
                if(!$path['good'][$k] && $path['ctg'][($v['parent'])]){$path['good'][$k] = sprintf('%s/%s.html', $path['ctg'][($v['parent'])], $v['alias']);}
            }
        }
        if(!is_array($id)){return $path[$type][$id];}
        else {
            foreach($id as $v){ $ret[$v] = $path[$type][$v];}
            return $ret;
        }
    }
    function setPath($k, $arr, &$path){
        if($arr[$k]['parent']>1 && !$path[($arr[$k]['parent'])]) $this->setPath($arr[$k]['parent'], $arr, $path);
        if($k>1) $path[$k] = ($path[($arr[$k]['parent'])]) ? sprintf('%s/%s', $path[($arr[$k]['parent'])], $arr[$k]['alias']) : $arr[$k]['alias'];
    }
    function transReplace(&$transurl){
        global $CONFIG; static $ret;
        if(empty($transurl)) return $ret;
        if($CONFIG['rewrite_mod']){
            $transurl = (false!==($pos=strpos($transurl,'?'))) ? substr($transurl,0, $pos) : $transurl;
            $ret = 1;
        }
    }
    function check_path($dir){
        if(is_dir(RP.$dir)) return true;
        $prev = substr($dir, 0, strrpos($dir, '/'));
        if($this->check_path($prev)){@mkdir(RP.$dir, 0777);}
    }
    function check_image(&$from, &$to, $id = null){
        if(!function_exists('img_resize')){require_once(RP.'inc/img.php');}
        global $CONFIG; static $types;
        if(!$types){
            $types = array(
            'image/jpeg' => 'jpg',
            'image/gif'  => 'gif',
            'image/x-png'=> 'png',
            );
        }
        if(empty($from) || !is_file(RP.$CONFIG['maps_img_path'].$from)){$from=NULL; return false;}
        if(!empty($to) && is_file(RP.$CONFIG['maps_img_path'].$to)){return true;}
        $type = getimagesize(RP.$CONFIG['maps_img_path'].$from);
        if(!$type || !$types[($type['mime'])]){return false;}
        $img = (!empty($to)) ? $to : sprintf('%s_%s.%s',$id ? $id : uniqid(''), 'middle', $types[($type['mime'])]);
        $IMG = array (
            'old_path' => RP.$CONFIG['maps_img_path'].$from,
            'new_path' => RP.$CONFIG['maps_img_path'].$img,
            'width'    => $CONFIG['maps_product_small_image_size']['width'],
            'height'   => $CONFIG['maps_product_small_image_size']['height'],
            #			'resize'   => "fixed",
            'bg_color' => "#ffffff",
            'extExists'	=> true,
        );
        $resize = img_resize ($IMG);
        $to = ($resize) ? $img : NULL;
        return true;
    }
    function translit($STRING){
        $russ=array(
        "ё"=>"yo", "Ё"=>"yo", "й"=>"y",  "Й"=>"y",  "ц"=>"z",  "Ц"=>"z",  "у"=>"u", "У"=>"u",
        "к"=>"k",  "К"=>"k",  "е"=>"e",  "Е"=>"e",  "н"=>"n",  "Н"=>"n",  "г"=>"g", "Г"=>"g",
        "ш"=>"sh", "Ш"=>"sh", "щ"=>"sh", "Щ"=>"sh", "з"=>"z",  "З"=>"z",  "х"=>"h", "Х"=>"h",
        "ъ"=>"`",  "Ъ"=>"`",  "ф"=>"f",  "Ф"=>"f",  "ы"=>"i",  "Ы"=>"i",  "в"=>"v", "В"=>"v",
        "а"=>"a",  "А"=>"a",  "п"=>"p",  "П"=>"p",  "р"=>"r",  "Р"=>"r",	 "о"=>"o", "О"=>"o",
        "л"=>"l",  "Л"=>"l",  "д"=>"d",  "Д"=>"d",  "ж"=>"zh", "Ж"=>"zh", "э"=>"e", "Э"=>"e",
        "я"=>"ya", "Я"=>"ya", "ч"=>"ch", "Ч"=>"ch", "с"=>"s",  "С"=>"s", "м"=>"m", "М"=>"m",
        "и"=>"i",  "И"=>"i",  "т"=>"t",  "Т"=>"t",  "ь"=>"",   "Ь"=>"",	 "б"=>"b", "Б"=>"b",
        "ю"=>"yu", "Ю"=>"yu", " "=>"_"
        );
        $text = strtolower (strtr ($STRING, $russ));
        return ereg_replace("[^A-Za-z0-9\._\-]", "", $text);
    }
    function UTF8toCP1251($str){
        static $table = array("\xD0\x81" => "\xA8", // Ё
        "\xD1\x91" => "\xB8", // ё
        );
        return preg_replace(
        '#([\xD0-\xD1])([\x80-\xBF])#se',
        'isset($table["$0"]) ? $table["$0"] : chr(ord("$2")+("$1" == "\xD0" ? 0x30 : 0x70))',
        $str
        );
    }
    function getElementRZD ($id, $type){
        if(!in_array($type, array('good','ctg')) || empty($id)){return false;}
        $ret = array(); $db = $GLOBALS['db1'];
        $tables = array(
        'good'  => $this->table_prefix.'_maps_products',
        'ctg'   => $this->table_prefix.'_maps_categories'
        );
        if($type == 'good'){
            $sql = "select id, category_id, product_title from {$tables['good']} where id={$id} limit 1";
            $db->query($sql);
            if(!$db->nf()){return false;}
            while($db->next_record()){$ret[] = $db->f('product_title'); $id=$db->f('category_id');}
        }
        $sql = "select t2.id, t2.title from {$tables['ctg']} t1 inner join {$tables['ctg']} t2 on(t1.cleft>=t2.cleft AND t1.cright<=t2.cright) ".
        "where t1.id=$id order by t2.clevel desc ";
        $db->query($sql);
        if(!$db->nf()){return false;}
        while($db->next_record()){$ret[] = $db->f('title');}
        return $ret;
    }

        /*
    function getMetroLst()
    {   global $db, $CONFIG;

        $ret = false;
        $db->query("SELECT M.*, COUNT(P.id) AS cnt FROM {$this->table_prefix}_maps_metro M LEFT JOIN {$this->table_prefix}_maps_products P ON metro_id=M.id GROUP BY M.id ORDER BY station");
        while ($db->next_record()) {
            $ret[$db->Record['id']] = array(
                'id' => $db->Record['id'],
                'station' => $db->Record['station'],
                'content' => $db->Record['content'],
                'color' => $db->Record['color'],
                'active_content' => $db->Record['active_content'],
                'cnt' => $db->Record['cnt']
            );
        }
        return $ret;
    }

    function showMetroLst($tpl, $list, $transurl, $curr_metro = 0)
    {
    	if (! empty($list)) {
    	    $tpl->newBlock('block_metro_list');
    	    foreach ($list as $item) {
    	    	$tpl->newBlock('block_metro');
    	    	$item['transurl'] = $transurl;
    	    	$item['selected'] = $curr_metro == $item['id'] ? 'selected' : '';
    	    	$tpl->assign($item);
    	    }
    	}
    }
    
    function setMetro($data)
    {   global $db, $CONFIG;
        $ret = false;
        if (isset($data['station']) && $data['station']) {
            $id = isset($data['id']) ? (int) isset($data['id']) : 0;
            $db->query("REPLACE INTO {$this->table_prefix}_maps_metro (id, station, content, active_content, color) VALUES ("
                .(isset($data['id']) ? (int) $data['id'] : 0)
                .",'".My_Sql::escape($data['station'])."',  '".My_Sql::escape($data['content'])."', '"
                .My_Sql::escape($data['active_content'])."', '"
                .My_Sql::escape($data['color'])."')");       
        	$ret = $db->affected_rows();
        }
        return $ret;
    }

    function getMetro($id)
    {   global $db;

        $ret = false;
        $db->query("SELECT * FROM {$this->table_prefix}_maps_metro WHERE id=".intval($id));
        if ($db->next_record()) {
            $ret = array(
                'id' => $db->Record['id'],
                'station' => $db->Record['station'],
                'content' => $db->Record['content'],
                'active_content' => $db->Record['active_content'],
                'color' => $db->Record['color'],
            );
        }
        return $ret;
    }
    
    function delMetro($id)
    {   global $db;

        $db->query("DELETE FROM {$this->table_prefix}_maps_metro WHERE id=".intval($id));
        $ret = $db->affected_rows() ? true : false;
        return $ret;
    }
    
    function setProdMetro($metro_id, $prod_id)
    {   global $db;

        $ret = false;
        if ($metro_id > 0 && $prod_id > 0) {
            $db->query("UPDATE {$this->table_prefix}_maps_products SET metro_id=".intval($metro_id)
                ." WHERE id=".intval($prod_id));
            $ret = $db->affected_rows();
        }        
        return $ret;
    }
    
    function getMetroInfo()
    {   global $db, $CONFIG, $baseurl;
        $this->transReplace($baseurl);
    	$ret = $this->getMetroLst();
        $db->query("SELECT a.*, b.ptype_name, b.link , b.icon FROM {$this->table_prefix}_maps_products a LEFT JOIN "
            .$this->table_prefix."_maps_ptypes b ON a.ptype_id = b.id WHERE metro_id<>0 AND a.active=1");
        while ($db->next_record()) {
            if ($ret[$db->Record['metro_id']]) {
                $ret[$db->Record['metro_id']]['prod'][$db->Record['id']] = array(
                    'id' => $db->Record['id'],
                    'title' => $db->Record['product_title'],
                    'inf' => nl2br($db->Record['product_inf']),
                    'description' => $db->Record['product_description'],
                    'ptype_id' => $db->Record['ptype_id'],
                    'ptype_name' => $db->Record['ptype_name'],
                    'ptype_link' => $db->Record['link'],
                    'ptype_icon' => $db->Record['icon'],
                    'ptype_icon_path' => $db->Record['icon'] && file_exists(RP.$CONFIG['maps_ptype_img_path'].$db->Record['icon'])
                        ? "/".$CONFIG['maps_ptype_img_path'].$db->Record['icon']
                        : "",
                    'addr' => $db->Record['addr'],
                    'phone' => $db->Record['phone'],
                    'open' => $db->Record['open'],
                    'email' => $db->Record['e_mail'],
                    'leader' => $db->Record['leader'],
                    'link' => ($CONFIG['rewrite_mod']) ? $baseurl.$this->getElementPath($db->Record['id'], 'good') : $baseurl.'&action=shwprd&id='.$db->Record['id']
                );
            }
        }
        return $ret;
    }
    */
    
    function getMetro ($id)
    {
        global $db, $CONFIG;
        
        $ret = $db->fetchOne($this->table_prefix . '_maps_metro', 
        array('clause' => array('id' => $id)));
        $ret['file_path'] = '';
        $ret['file_width'] = 0;
        $ret['file_height'] = 0;
        if ($ret['file'] &&
         file_exists(RP . $CONFIG['maps_metro_img_path'] . $ret['file'])) {
            $ret['file_path'] = $CONFIG['maps_metro_img_path'] . $ret['file'];
            $s = getimagesize(RP . $CONFIG['maps_metro_img_path'] . $ret['file']);
            $ret['file_width'] = $s[0];
            $ret['file_height'] = $s[1];
        }
        
        return $ret;
    }

    function getMetroList ()
    {
        global $db, $CONFIG;
        
        $ret = $db->fetchAll($this->table_prefix . '_maps_metro', array(), 'id');
        return $ret;
    }

    function delMetro ($id)
    {
        global $db, $CONFIG;
        
        $ret = false;
        $metro = $this->getMetro($id);
        if ($metro) {
            $db->del($this->table_prefix . '_maps_metro', array('id' => $id));
            $db->del($this->table_prefix . '_maps_metro_stat', 
            array('metro_id' => $id));
            if ($metro['file_path'] && file_exists(RP . $metro['file_path'])) {
                unlink(RP . $metro['file_path']);
            }
            $ret = true;
        }
        
        return $ret;
    }

    function setMetro ($data)
    {
        global $db, $CONFIG;
        
        $ret = false;
        
        if ($data['title']) {
            $id = 0;
            if ($data['id']) {
                $metro = $this->getMetro($data['id']);
                if ($metro) {
                    $set = array('title' => $data['title']);
                    if ($metro['file_path'] && $data['filedel']) {
                        $set['file'] = '';
                        unlink(RP . $metro['file_path']);
                    }
                    $db->set($this->table_prefix . '_maps_metro', $set, 
                    array('id' => $metro['id']));
                    $id = $metro['id'];
                }
            } else {
                $db->set($this->table_prefix . '_maps_metro', array('title' => $data['title']));
                $id = $db->lid();
            }
            if ($id && $_FILES['file']['tmp_name']) {
                if ($metro && $metro['file'] && file_exists(RP . $CONFIG['maps_metro_img_path'] . $metro['file'] )) {
                    unlink(RP . $CONFIG['maps_metro_img_path'] . $metro['file']);
                }
                if (file_exists(RP . $CONFIG['maps_metro_img_path'] . $_FILES['file']['name'])) {
                    $file_name = md5($id . time()) . substr($_FILES['file']['name'], strpos($_FILES['file']['name'], '.'));
                } else {
                    $file_name = $_FILES['file']['name'];
                }
                if (move_uploaded_file($_FILES['file']['tmp_name'], RP . $CONFIG['maps_metro_img_path'] . $file_name)) {
                    $db->set($this->table_prefix . '_maps_metro', array('file' => $file_name), array('id' => $id));
                }
            }
            $ret = $id;
        }
        
        return $ret;
    }

    function getMetroStat ($id)
    {
        global $db, $CONFIG;
        
        return $db->fetchOne($this->table_prefix . '_maps_metro_stat',  array('clause' => array('id' => $id)));
    }

    function getMetroStatList ($metro_id)
    {
        global $db, $CONFIG;
        
        return $db->fetchAll($this->table_prefix . '_maps_metro_stat', array('clause' => array('metro_id' => $metro_id), 'order' => 'station'), 'id');
    }

    function delMetroStat ($id)
    {
        global $db, $CONFIG;
        
        return $db->del($this->table_prefix . '_maps_metro_stat', array('id' => $id));
    }

    function setMetroStat ($data)
    {
        global $db, $CONFIG;
        
        $ret = false;
        
        if ($data['metro_id'] && $data['station']) {
            $set = array(
                'metro_id' => $data['metro_id'], 
                'station' => $data['station'],
                'color' => $data['color'],
                'content' => $data['content'], 
                'active_content' => $data['active_content']
            );
            if ($data['id']) {
                $db->set($this->table_prefix . '_maps_metro_stat', $set, array('id' => $data['id']));
                $ret = $data['id'];
            } else {
                $db->set($this->table_prefix . '_maps_metro_stat', $set);
                $ret = $db->lid();
            }
        }
        
        return $ret;
    }

    function getStatLst ($metro_id)
    {
        global $db, $CONFIG;
        
        $ret = false;
        $db->query("SELECT S.*, COUNT(P.prod_id) AS cnt FROM {$this->table_prefix}_maps_metro_stat S LEFT JOIN"
            ." {$this->table_prefix}_maps_prod_stat P ON P.stat_id=S.id WHERE S.metro_id=" 
            .intval($metro_id) . " GROUP BY S.id ORDER BY station");
        while ($db->next_record()) {
            $ret[$db->Record['id']] = array('id' => $db->Record['id'], 
            'station' => $db->Record['station'],
            'color' => $db->Record['color'],
            'content' => $db->Record['content'], 
            'active_content' => $db->Record['active_content'], 
            'cnt' => $db->Record['cnt']);
        }
        return $ret;
    }

    function getMetroInfo ($metro_id)
    {
        global $db, $CONFIG, $baseurl;
        
        $ret = $this->getStatLst($metro_id);
        
        if ($ret) {
            $this->transReplace($baseurl);
            $stat_ids = array_keys($ret);
            $db->query("SELECT a.*, stat_id, b.ptype_name, b.link , b.icon"
                ." FROM {$this->table_prefix}_maps_prod_stat ps"
                ." INNER JOIN {$this->table_prefix}_maps_products a ON ps.prod_id=a.id"
                ." LEFT JOIN ".$this->table_prefix."_maps_ptypes b ON a.ptype_id = b.id WHERE stat_id IN ("
                .implode(',', $stat_ids) . ")"
            );
            while ($db->next()) {
                if ($ret[$db->Record['stat_id']]) {
                    $ret[$db->Record['stat_id']]['prod'][$db->Record['id']] = array(
                    'id' => $db->Record['id'], 
                    'title' => $db->Record['product_title'], 
                    'inf' => nl2br($db->Record['product_inf']), 
                    'description' => $db->Record['product_description'], 
                    'ptype_id' => $db->Record['ptype_id'], 
                    'ptype_name' => $db->Record['ptype_name'], 
                    'ptype_link' => $db->Record['link'], 
                    'ptype_icon' => $db->Record['icon'], 
                    'ptype_icon_path' => $db->Record['icon'] &&
                     file_exists(
                    RP . $CONFIG['maps_ptype_img_path'] . $db->Record['icon']) ? "/" .
                     $CONFIG['maps_ptype_img_path'] . $db->Record['icon'] : "", 
                    'addr' => $db->Record['addr'], 
                    'phone' => $db->Record['phone'], 
                    'open' => $db->Record['open'], 
                    'email' => $db->Record['e_mail'],
                    'leader' => $db->Record['leader'],
                    'link' => $db->Record['url'] ? $db->Record['url'] : ($CONFIG['rewrite_mod'] ? $baseurl .
                     $this->getElementPath($db->Record['id'], 'good') : $baseurl .
                     '&action=shwprd&id=' . $db->Record['id']));
                }
            }
        }
        return $ret;
    }

    function setItemStat ($item_id, $stats_ids = array())
    {
        global $db;
        
        $item_id = (int) $item_id;
        $db->del($this->table_prefix . '_maps_prod_stat', 
        array('prod_id' => $item_id));
        $stats_ids = array_map('intval', $stats_ids);
        if (! empty($stats_ids)) {
            $db->query(
            "INSERT INTO {$this->table_prefix}_maps_prod_stat (prod_id, stat_id) VALUES ({$item_id}," .
             implode("), ({$item_id},", $stats_ids) . ")");
        }
    }

    function showStatList ($list, $checked = array())
    {
        global $tpl;
        
        $i = 0;
        $c = floor(count($list) / 6);
        foreach ($list as $val) {
            if (0 == $i % $c) {
                $tpl->newBlock('stat_list_group');
            }
            $i ++;
            $tpl->newBlock('stat_list');
            $tpl->assign($val + array('checked' => is_array($checked) && in_array($val['id'], $checked) ? 'checked' : ''));
        }
    }
    
    function getTree()
    {   global $db, $CONFIG;

        include_once RP.'inc/class.Tree.php';
        
        $tree = new AboTree(1);
        $db->query("SELECT * FROM {$this->table_prefix}_maps_categories WHERE active=1 AND parent_id ORDER BY clevel, ".$CONFIG['maps_ctg_order_by']);
        while ($db->next()) {
            $tree->addNode($db->Record['parent_id'], $db->Record['id'], $db->Record);
        }
        return $tree->toList();
    }
    
    function setCtgrImg($ctgr_id, $del_img = false)
    {   global $CONFIG, $db;
        
        $ctgr = $this->getCategory($ctgr_id);
        if ($ctgr) {
            $path = RP.$CONFIG['maps_ctg_img_path'];
            if ($del_img) {
                if ($ctgr['img'] && file_exists($path.$ctgr['img'])) {
                    unlink($path.$ctgr['img']);
                }
                if ($ctgr['img_big'] && file_exists(RP.$CONFIG['maps_ctg_img_path'].$ctgr['img_big'])) {
                    unlink($path.$ctgr['img_big']);
                }
                $db->set($this->table_prefix.'_maps_categories', array(
                    'img' => '', 'img_big' => ''
                ), array('id' => $ctgr_id));
            }
            if (is_uploaded_file($_FILES['img_big']['tmp_name'])) {               
                $set_file_name = $ctgr_id.'_big.'.Main::getFileExt($_FILES['img_big']['name']);
                $big_img_file = '';
                if (Main::generateImage(
                        $_FILES['img_big']['tmp_name'],
                        $path.$set_file_name)
                ) {
                    $big_img_file = $set_file_name;
                }
                $img_file = '';
                if (is_uploaded_file($_FILES['img']['tmp_name'])) {
                    $file = $_FILES['img']['tmp_name'];
                    $set_file_name = $ctgr_id.'.'.Main::getFileExt($_FILES['img']['name']);
                } else {
                    $file = $_FILES['img_big']['tmp_name'];
                    $set_file_name = $ctgr_id.'.'.Main::getFileExt($_FILES['img_big']['name']);
                }                
                if (Main::generateImage(
                        $file,
                        $path.$set_file_name,
                        $CONFIG['maps_product_small_image_size'])
                ) {
                    $img_file = $set_file_name;
                }
                $db->set($this->table_prefix.'_maps_categories', array(
                        'img' => $img_file, 'img_big' => $big_img_file
                ), array('id' => $ctgr_id));
            }
        }
    }
    
    function getService($id)
    {
        global $db, $CONFIG;
    
        $ret = $db->fetchOne($this->table_prefix . '_maps_service',
                array('clause' => array('id' => $id)));
        $ret['file_path'] = '';
        $ret['file_width'] = 0;
        $ret['file_height'] = 0;
        if ($ret['file'] && file_exists(RP . $ret['file'])) {
            $ret['file_path'] = $ret['file'];
            $s = getimagesize(RP .  $ret['file']);
            $ret['file_width'] = $s[0];
            $ret['file_height'] = $s[1];
        }
    
        return $ret;
    }
    
    function getServiceList ($filter = array())
    {
        global $db, $CONFIG;
        $ret = array();
        $db->query('SELECT S.* FROM '.$this->table_prefix . '_maps_service S'
             .($filter['prod_id'] ? ' INNER JOIN '.$this->table_prefix . '_maps_prod_service PS ON PS.service_id=S.id WHERE PS.prod_id='.intval($filter['prod_id']) : '')
             .' ORDER BY rank');
        while ($db->next()) {
            $d = $db->Record;
            $d['file_path'] = $d['file'] && file_exists(RP . $d['file']) ? $d['file'] : '';
            $d['checked'] = $filter['checked'] && in_array($d['id'], $filter['checked']) ? 'checked' : '';
            $ret[$d['id']] = $d;
        }
        return $ret;
    }
    
    function delService ($id)
    {
        global $db, $CONFIG;
    
        $ret = false;
        $service = $this->getService($id);
        if ($service) {
            $db->del($this->table_prefix . '_maps_service', array('id' => $id));
            $ret = true;
        }
    
        return $ret;
    }
    
    function setService($data)
    {
        global $db, $CONFIG;
    
        $ret = false;
    
        if ($data['title']) {
            $id = 0;
            $set = array(
                'title' => $data['title'],
                'file' => $data['file'],
                'dscr' => $data['dscr']
            );
            if ($data['id']) {
                $service = $this->getService($data['id']);
                if ($service) {
                    $db->set($this->table_prefix . '_maps_service', $set,
                            array('id' => $service['id']));
                    $id = $service['id'];
                }
            } else {
                $db->set($this->table_prefix . '_maps_service', $set);
                $id = $db->lid();
            }
            $ret = $id;
        }
    
        return $ret;
    }

    function setItemService($item_id, $service_ids = array())
    {
        global $db;
        
        $item_id = (int) $item_id;
        $db->del($this->table_prefix . '_maps_prod_service', array('prod_id' => $item_id));
        $service_ids = array_map('intval', $service_ids);
        if (! empty($service_ids)) {
            $db->query("INSERT INTO {$this->table_prefix}_maps_prod_service (prod_id, service_id) VALUES ({$item_id},"
                .implode("), ({$item_id},", $service_ids) . ")");
        }
    }
}
?>