UPDATE `modules` SET `title` = 'Интерактивные карты' WHERE `id` = 32

CREATE TABLE IF NOT EXISTS `{site_prefix}_maps_metro` (
    `id` int unsigned NOT NULL auto_increment,
    `title` varchar(63) NOT NULL,
    `file` varchar(63) NOT NULL,
    PRIMARY KEY  (`id`)
) ENGINE=MyISAM;

CREATE TABLE IF NOT EXISTS `{site_prefix}_maps_metro_stat` (
    `id` int unsigned NOT NULL auto_increment,
    `metro_id` int unsigned NOT NULL DEFAULT 0,
    `station` varchar(63) NOT NULL,
    content TEXT,
    active_content TEXT,
    `color` varchar(8) DEFAULT '',
    PRIMARY KEY  (`id`),
    KEY  (`metro_id`)
) ENGINE=MyISAM;

CREATE TABLE IF NOT EXISTS `{site_prefix}_maps_prod_stat` (
    `prod_id` int unsigned NOT NULL DEFAULT 0,
    `stat_id` int unsigned NOT NULL DEFAULT 0,
    PRIMARY KEY (`prod_id`, `stat_id`)
) ENGINE=MyISAM;


CREATE TABLE IF NOT EXISTS `{site_prefix}_maps_service` (
	`id` int unsigned NOT NULL auto_increment,
	`rank` int NOT NULL NULL DEFAULT 0,
	`title` varchar(255) NOT NULL DEFAULT '',
	`file` varchar(63) NOT NULL,
	`dscr` TEXT,
PRIMARY KEY  (`id`)
) ENGINE=MyISAM;

CREATE TABLE IF NOT EXISTS `{site_prefix}_maps_prod_service` (
	`prod_id` int unsigned NOT NULL DEFAULT 0,
	`service_id` int unsigned NOT NULL DEFAULT 0,
	PRIMARY KEY (`prod_id`, `service_id`)
) ENGINE=MyISAM;

ALTER TABLE `{site_prefix}_maps_categories` ADD `metro_id` INT UNSIGNED NOT NULL DEFAULT '0' AFTER `parent_id`, ADD INDEX ( `metro_id` );

INSERT INTO `{site_prefix}_maps_metro` (`id`, `title`, `file`) VALUES (1, 'Москва', 'tube.gif'), (2, 'Санкт-Петербург', 'spb-metro.gif'), (3, 'Самара', 'tube_samara.gif');

INSERT INTO `{site_prefix}_maps_metro_stat` (`id`, `metro_id`, `station`, `content`, `active_content`, `color`) VALUES
(1, 1, 'Улица Подбельского', '<span style="margin:93px 0pt 0pt 665px;">Ул. Подбельского</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 93px 0pt 0pt 641px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:93px 0pt 0pt 665px;" onmouseover="gMetro.show({metro_id});">Ул. Подбельского</span>', '#cd0506'),
(2, 1, 'Черкизовская', '<span style="margin: 128px 0pt 0pt 665px;">Черкизовская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 128px 0pt 0pt 641px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:128px 0pt 0pt 665px;" onmouseover="gMetro.show({metro_id});">Черкизовская</span>', '#cd0506'),
(3, 1, 'Преображенская пл.', '<span style="margin: 163px 0pt 0pt 665px; line-height:1em;">Преображенская<br />площадь</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 163px 0pt 0pt 641px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:163px 0pt 0pt 665px; line-height:1em;" onmouseover="gMetro.show({metro_id});">Преображенская<br />площадь</span>', '#cd0506'),
(4, 1, 'Сокольники', '<span style="margin: 210px 0pt 0pt 665px; ">Сокольники</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 210px 0pt 0pt 641px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 210px 0pt 0pt 665px;" onmouseover="gMetro.show({metro_id});">Сокольники</span>', '#cd0506'),
(5, 1, 'Красносельская', '<span style="margin: 253px 0pt 0pt 647px;">Красносельская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 253px 0pt 0pt 623px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:253px 0pt 0pt 647px;" onmouseover="gMetro.show({metro_id});">Красносельская</span>', '#cd0506'),
(6, 1, 'Комсомольская (радиальная)', '<span style="margin: 275px 0pt 0pt 622px;">Комсомольская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 275px 0pt 0pt 598px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:275px 0pt 0pt 622px;" onmouseover="gMetro.show({metro_id});">Комсомольская</span>', '#cd0506'),
(7, 1, 'Чистые Пруды', '<span style="margin: 348px 0pt 0pt 549px; line-height:1em;">Чистые<br />Пруды</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 348px 0pt 0pt 525px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:348px 0pt 0pt 549px; line-height:1em;" onmouseover="gMetro.show({metro_id});">Чистые<br />Пруды</span>', '#cd0506'),
(8, 1, 'Красные ворота', '<span style="margin: 317px 0pt 0pt 582px;">Красные ворота</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 317px 0pt 0pt 558px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:317px 0pt 0pt 582px;" onmouseover="gMetro.show({metro_id});">Красные ворота</span>', '#cd0506'),
(9, 1, 'Лубянка', '<span style="margin: 394px 0pt 0pt 505px;">Лубянка</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 394px 0pt 0pt 481px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:394px 0pt 0pt 505px;" onmouseover="gMetro.show({metro_id});">Лубянка</span>', '#cd0506'),
(10, 1, 'Охотный ряд', '<span style="margin: 431px 0pt 0pt 387px; line-height:1em; text-align:right;">Охотный<br />ряд</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 442px 0pt 0pt 432px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:431px 0pt 0pt 387px; line-height:1em; text-align:right;" onmouseover="gMetro.show({metro_id});">Охотный<br />ряд</span>', '#cd0506'),
(11, 1, 'Библиотека им.Ленина', '<span style="margin: 497px 0pt 0pt 409px; line-height: 10px;">Библиотека <br>им.Ленина</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 485px 0pt 0pt 390px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:497px 0pt 0pt 409px; line-height: 10px;" onmouseover="gMetro.show({metro_id});">Библиотека <br>им.Ленина</span>', '#cd0506'),
(12, 1, 'Кропоткинская', '<span style="margin: 556px 0pt 0pt 344px;">Кропоткинская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 543px 0pt 0pt 330px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:556px 0pt 0pt 344px;" onmouseover="gMetro.show({metro_id});">Кропоткинская</span>', '#cd0506'),
(13, 1, 'Парк культуры (кольцевая)', '<span style="margin: 606px 0pt 0pt 300px; line-height:1em;">Парк<br />культуры</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 588px 0pt 0pt 313px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:606px 0pt 0pt 300px; line-height:1em;" onmouseover="gMetro.show({metro_id});">Парк<br />культуры</span>', '#7f0000'),
(14, 1, 'Парк культуры (радиальная)', '<span style="margin: 572px 0pt 0pt 332px; line-height:1em;">Парк<br />культуры</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 562px 0pt 0pt 312px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:572px 0pt 0pt 332px; line-height:1em;" onmouseover="gMetro.show({metro_id});">Парк<br />культуры</span>', '#cd0506'),
(15, 1, 'Фрунзенская', '<span style="margin: 595px 0pt 0pt 208px;">Фрунзенская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 600px 0pt 0pt 273px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:595px 0pt 0pt 208px;" onmouseover="gMetro.show({metro_id});">Фрунзенская</span>', '#cd0506'),
(16, 1, 'Спортивная', '<span style="margin: 630px 0pt 0pt 187px;">Спортивная</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 614px 0pt 0pt 205px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:630px 0pt 0pt 187px;" onmouseover="gMetro.show({metro_id});">Спортивная</span>', '#cd0506'),
(17, 1, 'Воробьевы горы', '<span style="margin: 646px 0pt 0pt 158px;">Воробьевы горы</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 646px 0pt 0pt 134px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:646px 0pt 0pt 158px;" onmouseover="gMetro.show({metro_id});">Воробьевы горы</span>', '#cd0506'),
(18, 1, 'Университет', '<span style="margin: 675px 0pt 0pt 129px;">Университет</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 675px 0pt 0pt 105px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:675px 0pt 0pt 129px;" onmouseover="gMetro.show({metro_id});">Университет</span>', '#cd0506'),
(19, 1, 'Проспект  Вернадского', '<span style="margin: 704px 0pt 0pt 100px;">Проспект Вернадского</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 704px 0pt 0pt 76px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:704px 0pt 0pt 100px;" onmouseover="gMetro.show({metro_id});">Проспект Вернадского</span>', '#cd0506'),
(20, 1, 'Юго-западная', '<span style="margin: 733px 0pt 0pt 70px;">Юго-западная</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 733px 0pt 0pt 46px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:733px 0pt 0pt 70px;" onmouseover="gMetro.show({metro_id});">Юго-западная</span>', '#cd0506'),
(21, 1, 'Комсомольская (кольцевая)', '<span style="margin: 294px 0pt 0pt 622px;">Комсомольская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 294px 0pt 0pt 598px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:294px 0pt 0pt 622px;" onmouseover="gMetro.show({metro_id});">Комсомольская</span>', '#7f0000'),
(22, 1, 'Новокосино', '<span style="margin: 356px 0pt 0pt 826px;">Новокосино</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 356px 0pt 0pt 802px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:356px 0pt 0pt 826px;" onmouseover="gMetro.show({metro_id});">Новокосино</span>', '#ffdd03'),
(23, 1, 'Новогиреево', '<span style="margin: 378px 0pt 0pt 805px;">Новогиреево</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 378px 0pt 0pt 781px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:378px 0pt 0pt 805px;" onmouseover="gMetro.show({metro_id});">Новогиреево</span>', '#ffdd03'),
(24, 1, 'Перово', '<span style="margin: 395px 0pt 0pt 788px;">Перово</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 395px 0pt 0pt 764px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:395px 0pt 0pt 788px;" onmouseover="gMetro.show({metro_id});">Перово</span>', '#ffdd03'),
(25, 1, 'Шоссе  Энтузиастов', '<span style="margin: 415px 0pt 0pt 769px;">Шоссе Энтузиастов</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 415px 0pt 0pt 745px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:415px 0pt 0pt 769px;" onmouseover="gMetro.show({metro_id});">Шоссе Энтузиастов</span>', '#ffdd03'),
(26, 1, 'Авиамоторная', '<span style="margin: 435px 0pt 0pt 749px;">Авиамоторная</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 435px 0pt 0pt 725px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:435px 0pt 0pt 749px;" onmouseover="gMetro.show({metro_id});">Авиамоторная</span>', '#ffdd03'),
(27, 1, 'Площадь Ильича', '<span style="margin: 459px 0pt 0pt 723px;">Площадь Ильича</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 459px 0pt 0pt 699px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:459px 0pt 0pt 723px;" onmouseover="gMetro.show({metro_id});">Площадь Ильича</span>', '#ffdd03'),
(28, 1, 'Марксистская', '<span style="margin: 510px 0pt 0pt 677px;">Марксистская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 503px 0pt 0pt 655px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:510px 0pt 0pt 677px;" onmouseover="gMetro.show({metro_id});">Марксистская</span>', '#ffdd03'),
(29, 1, 'Третьяковская (желтая)', '<span style="margin: 566px 0pt 0pt 431px;">Третьяковская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 566px 0pt 0pt 508px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:566px 0pt 0pt 431px;" onmouseover="gMetro.show({metro_id});">Третьяковская</span>', '#ffdd03'),
(30, 1, 'Медведково', '<span style="margin: 2px 0pt 0pt 561px;">Медведково</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 2px 0pt 0pt 537px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:2px 0pt 0pt 561px;" onmouseover="gMetro.show({metro_id});">Медведково</span>', '#ff7f00'),
(31, 1, 'Бабушкинская', '<span style="margin: 21px 0pt 0pt 561px;">Бабушкинская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 21px 0pt 0pt 537px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:21px 0pt 0pt 561px;" onmouseover="gMetro.show({metro_id});">Бабушкинская</span>', '#ff7f00'),
(32, 1, 'Свиблово', '<span style="margin: 40px 0pt 0pt 561px;">Свиблово</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 40px 0pt 0pt 537px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:40px 0pt 0pt 561px;" onmouseover="gMetro.show({metro_id});">Свиблово</span>', '#ff7f00'),
(33, 1, 'Ботанический сад', '<span style="margin: 60px 0pt 0pt 561px;">Ботанический сад</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 60px 0pt 0pt 537px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:60px 0pt 0pt 561px;" onmouseover="gMetro.show({metro_id});">Ботанический сад</span>', '#ff7f00'),
(34, 1, 'ВДНХ', '<span style="margin: 130px 0pt 0pt 561px;">ВДНХ</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 130px 0pt 0pt 537px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:130px 0pt 0pt 561px;" onmouseover="gMetro.show({metro_id});">ВДНХ</span>', '#ff7f00'),
(35, 1, 'Алексеевская', '<span style="margin: 155px 0pt 0pt 561px;">Алексеевская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 155px 0pt 0pt 537px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:155px 0pt 0pt 561px;" onmouseover="gMetro.show({metro_id});">Алексеевская</span>', '#ff7f00'),
(36, 1, 'Рижская', '<span style="margin: 180px 0pt 0pt 561px;">Рижская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 180px 0pt 0pt 537px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:180px 0pt 0pt 561px;" onmouseover="gMetro.show({metro_id});">Рижская</span>', '#ff7f00'),
(37, 1, 'Проспект Мира (радиальная)', '<span style="margin: 216px 0pt 0pt 540px;">Проспект Мира</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 215px 0pt 0pt 516px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:216px 0pt 0pt 540px;" onmouseover="gMetro.show({metro_id});">Проспект Мира</span>', '#ff7f00'),
(38, 1, 'Проспект Мира (кольцевая)', '<span style="margin: 235px 0pt 0pt 540px;">Проспект Мира</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 235px 0pt 0pt 516px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:235px 0pt 0pt 540px;" onmouseover="gMetro.show({metro_id});">Проспект Мира</span>', '#7f0000'),
(39, 1, 'Сухаревская', '<span style="margin: 278px 0pt 0pt 492px;">Сухаревская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 278px 0pt 0pt 468px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:278px 0pt 0pt 492px;" onmouseover="gMetro.show({metro_id});">Сухаревская</span>', '#ff7f00'),
(40, 1, 'Тургеневская', '<span style="margin: 349px 0pt 0pt 436px;">Тургеневская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 349px 0pt 0pt 503px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:349px 0pt 0pt 436px;" onmouseover="gMetro.show({metro_id});">Тургеневская</span>', '#ff7f00'),
(41, 1, 'Китай-город', '<span style="margin: 433px 0pt 0pt 484px;">Китай-город</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 433px 0pt 0pt 547px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:433px 0pt 0pt 484px;" onmouseover="gMetro.show({metro_id});">Китай-город</span>', '#ff7f00'),
(42, 1, 'Третьяковская (оранжевая)', '<span style="margin: 553px 0pt 0pt 422px;">Третьяковская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 553px 0pt 0pt 493px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:553px 0pt 0pt 422px;" onmouseover="gMetro.show({metro_id});">Третьяковская</span>', '#ff7f00'),
(43, 1, 'Октябрьская (радиальная)', '<span style="margin: 597px 0pt 0pt 387px;">Октябрьская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 597px 0pt 0pt 364px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:597px 0pt 0pt 387px;" onmouseover="gMetro.show({metro_id});">Октябрьская</span>', '#ff7f00'),
(44, 1, 'Октябрьская (кольцевая)', '<span style="margin: 633px 0pt 0pt 345px;">Октябрьская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 617px 0pt 0pt 365px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:633px 0pt 0pt 345px;" onmouseover="gMetro.show({metro_id});">Октябрьская</span>', '#7f0000'),
(45, 1, 'Шаболовская', '<span style="margin: 646px 0pt 0pt 341px;">Шаболовская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 646px 0pt 0pt 317px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:646px 0pt 0pt 341px;" onmouseover="gMetro.show({metro_id});">Шаболовская</span>', '#ff7f00'),
(46, 1, 'Ленинский проспект', '<span style="margin: 667px 0pt 0pt 320px; ">Ленинский проспект</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 667px 0pt 0pt 296px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:667px 0pt 0pt 320px;" onmouseover="gMetro.show({metro_id});">Ленинский проспект</span>', '#ff7f00'),
(47, 1, 'Академическая', '<span style="margin: 689px 0pt 0pt 298px;">Академическая</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 689px 0pt 0pt 274px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:689px 0pt 0pt 298px;" onmouseover="gMetro.show({metro_id});">Академическая</span>', '#ff7f00'),
(48, 1, 'Профсоюзная', '<span style="margin: 714px 0pt 0pt 287px;">Профсоюзная</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 714px 0pt 0pt 263px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:714px 0pt 0pt 287px;" onmouseover="gMetro.show({metro_id});">Профсоюзная</span>', '#ff7f00'),
(49, 1, 'Новые Черемушки', '<span style="margin: 734px 0pt 0pt 287px;">Новые Черемушки</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 734px 0pt 0pt 263px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:734px 0pt 0pt 287px;" onmouseover="gMetro.show({metro_id});">Новые Черемушки</span>', '#ff7f00'),
(50, 1, 'Калужская', '<span style="margin: 754px 0pt 0pt 287px;">Калужская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 754px 0pt 0pt 263px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:754px 0pt 0pt 287px;" onmouseover="gMetro.show({metro_id});">Калужская</span>', '#ff7f00'),
(51, 1, 'Беляево', '<span style="margin: 775px 0pt 0pt 287px;">Беляево</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 775px 0pt 0pt 263px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:775px 0pt 0pt 287px;" onmouseover="gMetro.show({metro_id});">Беляево</span>', '#ff7f00'),
(52, 1, 'Коньково', '<span style="margin: 795px 0pt 0pt 287px;">Коньково</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 795px 0pt 0pt 263px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:795px 0pt 0pt 287px;" onmouseover="gMetro.show({metro_id});">Коньково</span>', '#ff7f00'),
(53, 1, 'Теплый стан', '<span style="margin: 815px 0pt 0pt 287px;">Теплый стан</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 815px 0pt 0pt 263px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:815px 0pt 0pt 287px;" onmouseover="gMetro.show({metro_id});">Теплый стан</span>', '#ff7f00'),
(54, 1, 'Ясенево', '<span style="margin: 835px 0pt 0pt 287px;">Ясенево</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 835px 0pt 0pt 263px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:835px 0pt 0pt 287px;" onmouseover="gMetro.show({metro_id});">Ясенево</span>', '#ff7f00'),
(55, 1, 'Новоясеневская', '<span style="margin: 858px 0pt 0pt 287px;">Новоясеневская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 858px 0pt 0pt 263px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:858px 0pt 0pt 287px;" onmouseover="gMetro.show({metro_id});">Новоясеневская</span>', '#ff7f00'),
(56, 1, 'Достоевская', '<span style="margin: 187px 0pt 0pt 458px;">Достоевская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 187px 0pt 0pt 434px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:187px 0pt 0pt 458px;" onmouseover="gMetro.show({metro_id});">Достоевская</span>', '#8cce3a'),
(57, 1, 'Марьина Роща', '<span style="margin: 160px 0pt 0pt 458px;">Марьина Роща</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 160px 0pt 0pt 434px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:160px 0pt 0pt 458px;" onmouseover="gMetro.show({metro_id});">Марьина Роща</span>', '#8cce3a'),
(58, 1, 'Трубная', '<span style="margin: 306px 0pt 0pt 432px;">Трубная</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 306px 0pt 0pt 408px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:306px 0pt 0pt 432px;" onmouseover="gMetro.show({metro_id});">Трубная</span>', '#8cce3a'),
(59, 1, 'Сретенский бульвар', '<span style="margin: 308px 0pt 0pt 500px;line-height: 10px; text-align:center;">Сретенский<br>бульвар</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 330px 0pt 0pt 515px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:308px 0pt 0pt 500px;line-height: 10px; text-align:center;" onmouseover="gMetro.show({metro_id});">Сретенский<br>бульвар</span>', '#8cce3a'),
(60, 1, 'Чкаловская', '<span style="margin: 413px 0pt 0pt 570px;">Чкаловская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 401px 0pt 0pt 622px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:413px 0pt 0pt 570px;" onmouseover="gMetro.show({metro_id});">Чкаловская</span>', '#8cce3a'),
(61, 1, 'Римская', '<span style="margin: 478px 0pt 0pt 723px;">Римская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 478px 0pt 0pt 699px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:478px 0pt 0pt 723px;" onmouseover="gMetro.show({metro_id});">Римская</span>', '#8cce3a'),
(62, 1, 'Крестьянская застава', '<span style="margin: 556px 0pt 0pt 731px; line-height:1em;">Крестьянская<br /> застава</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 556px 0pt 0pt 707px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:556px 0pt 0pt 731px; line-height:1em;" onmouseover="gMetro.show({metro_id});">Крестьянская<br /> застава</span>', '#8cce3a'),
(63, 1, 'Дубровка', '<span style="margin: 621px 0pt 0pt 731px;">Дубровка</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 621px 0pt 0pt 707px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:621px 0pt 0pt 731px;" onmouseover="gMetro.show({metro_id});">Дубровка</span>', '#8cce3a'),
(64, 1, 'Кожуховская', '<span style="margin: 647px 0pt 0pt 731px;">Кожуховская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 647px 0pt 0pt 707px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:647px 0pt 0pt 731px;" onmouseover="gMetro.show({metro_id});">Кожуховская</span>', '#8cce3a'),
(65, 1, 'Печатники', '<span style="margin: 674px 0pt 0pt 731px;">Печатники</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 674px 0pt 0pt 707px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:674px 0pt 0pt 731px;" onmouseover="gMetro.show({metro_id});">Печатники</span>', '#8cce3a'),
(66, 1, 'Волжская', '<span style="margin: 700px 0pt 0pt 731px;">Волжская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 700px 0pt 0pt 707px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:700px 0pt 0pt 731px;" onmouseover="gMetro.show({metro_id});">Волжская</span>', '#8cce3a'),
(67, 1, 'Люблино', '<span style="margin: 727px 0pt 0pt 731px;">Люблино</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 727px 0pt 0pt 707px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:727px 0pt 0pt 731px;" onmouseover="gMetro.show({metro_id});">Люблино</span>', '#8cce3a'),
(68, 1, 'Братиславская', '<span style="margin: 753px 0pt 0pt 731px;">Братиславская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 753px 0pt 0pt 707px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:753px 0pt 0pt 731px;" onmouseover="gMetro.show({metro_id});">Братиславская</span>', '#8cce3a'),
(69, 1, 'Марьино', '<span style="margin: 780px 0pt 0pt 731px;">Марьино</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 780px 0pt 0pt 707px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:780px 0pt 0pt 731px;" onmouseover="gMetro.show({metro_id});">Марьино</span>', '#8cce3a'),
(70, 1, 'Борисово', '<span style="margin: 807px 0pt 0pt 731px;">Борисово</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 807px 0pt 0pt 707px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:807px 0pt 0pt 731px;" onmouseover="gMetro.show({metro_id});">Борисово</span>', '#8cce3a'),
(71, 1, 'Шипиловская', '<span style="margin: 833px 0pt 0pt 731px;">Шипиловская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 833px 0pt 0pt 707px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:833px 0pt 0pt 731px;" onmouseover="gMetro.show({metro_id});">Шипиловская</span>', '#8cce3a'),
(72, 1, 'Зябликово', '<span style="margin: 861px 0pt 0pt 731px;">Зябликово</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 861px 0pt 0pt 707px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:861px 0pt 0pt 731px;" onmouseover="gMetro.show({metro_id});">Зябликово</span>', '#8cce3a'),
(73, 1, 'Алтуфьево', '<span style="margin: 2px 0pt 0pt 350px;">Алтуфьево</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 2px 0pt 0pt 326px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:2px 0pt 0pt 350px;" onmouseover="gMetro.show({metro_id});">Алтуфьево</span>', '#a2a5b4'),
(74, 1, 'Бибирево', '<span style="margin: 21px 0pt 0pt 350px;">Бибирево</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 21px 0pt 0pt 326px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:21px 0pt 0pt 350px;" onmouseover="gMetro.show({metro_id});">Бибирево</span>', '#a2a5b4'),
(75, 1, 'Отрадное', '<span style="margin: 39px 0pt 0pt 350px;">Отрадное</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 39px 0pt 0pt 326px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:39px 0pt 0pt 350px;" onmouseover="gMetro.show({metro_id});">Отрадное</span>', '#a2a5b4'),
(76, 1, 'Владыкино', '<span style="margin: 57px 0pt 0pt 350px;">Владыкино</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 57px 0pt 0pt 326px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:57px 0pt 0pt 350px;" onmouseover="gMetro.show({metro_id});">Владыкино</span>', '#a2a5b4'),
(77, 1, 'Петровско-Разумовская', '<span style="margin: 76px 0pt 0pt 350px; ">Петровско-Разумовская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 76px 0pt 0pt 326px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:76px 0pt 0pt 350px; " onmouseover="gMetro.show({metro_id});">Петровско-Разумовская</span>', '#a2a5b4'),
(78, 1, 'Тимирязевская', '<span style="margin: 99px 0pt 0pt 350px;">Тимирязевская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 99px 0pt 0pt 326px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:99px 0pt 0pt 350px;" onmouseover="gMetro.show({metro_id});">Тимирязевская</span>', '#a2a5b4'),
(79, 1, 'Дмитровская', '<span style="margin: 153px 0pt 0pt 350px;">Дмитровская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 153px 0pt 0pt 326px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:153px 0pt 0pt 350px;" onmouseover="gMetro.show({metro_id});">Дмитровская</span>', '#a2a5b4'),
(80, 1, 'Савеловская', '<span style="margin: 180px 0pt 0pt 350px;">Савеловская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 180px 0pt 0pt 326px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:180px 0pt 0pt 350px;" onmouseover="gMetro.show({metro_id});">Савеловская</span>', '#a2a5b4'),
(81, 1, 'Менделеевская', '<span style="margin: 209px 0pt 0pt 352px;">Менделеевская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 222px 0pt 0pt 346px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:209px 0pt 0pt 352px;" onmouseover="gMetro.show({metro_id});">Менделеевская</span>', '#a2a5b4'),
(82, 1, 'Новослободская', '<span style="margin: 257px 0pt 0pt 355px;">Новослободская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 242px 0pt 0pt 347px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:257px 0pt 0pt 355px;" onmouseover="gMetro.show({metro_id});">Новослободская</span>', '#7f0000'),
(83, 1, 'Цветной бульвар', '<span style="margin: 291px 0pt 0pt 352px; line-height:1em; text-align:right;">Цветной<br />бульвар</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 291px 0pt 0pt 395px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:291px 0pt 0pt 352px; line-height:1em; text-align:right;" onmouseover="gMetro.show({metro_id});">Цветной<br />бульвар</span>', '#a2a5b4'),
(84, 1, 'Чеховская', '<span style="margin: 360px 0pt 0pt 404px;">Чеховская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 353px 0pt 0pt 382px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:360px 0pt 0pt 404px;" onmouseover="gMetro.show({metro_id});">Чеховская</span>', '#a2a5b4'),
(85, 1, 'Боровицкая', '<span style="margin: 518px 0pt 0pt 388px;">Боровицкая</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 504px 0pt 0pt 382px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:518px 0pt 0pt 388px;" onmouseover="gMetro.show({metro_id});">Боровицкая</span>', '#a2a5b4'),
(86, 1, 'Полянка', '<span style="margin: 596px 0pt 0pt 473px;">Полянка</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 596px 0pt 0pt 449px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:596px 0pt 0pt 473px;" onmouseover="gMetro.show({metro_id});">Полянка</span>', '#a2a5b4'),
(87, 1, 'Добрынинская', '<span style="margin: 615px 0pt 0pt 412px;">Добрынинская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 630px 0pt 0pt 437px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:615px 0pt 0pt 412px;" onmouseover="gMetro.show({metro_id});">Добрынинская</span>', '#7f0000'),
(88, 1, 'Серпуховская', '<span style="margin: 645px 0pt 0pt 475px;">Серпуховская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 645px 0pt 0pt 451px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:645px 0pt 0pt 475px;" onmouseover="gMetro.show({metro_id});">Серпуховская</span>', '#a2a5b4');
INSERT INTO `{site_prefix}_maps_metro_stat` (`id`, `metro_id`, `station`, `content`, `active_content`, `color`) VALUES
(89, 1, 'Тульская', '<span style="margin: 671px 0pt 0pt 475px;">Тульская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 671px 0pt 0pt 451px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:671px 0pt 0pt 475px;" onmouseover="gMetro.show({metro_id});">Тульская</span>', '#a2a5b4'),
(90, 1, 'Нагатинская', '<span style="margin: 696px 0pt 0pt 475px;">Нагатинская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 696px 0pt 0pt 451px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:696px 0pt 0pt 475px;" onmouseover="gMetro.show({metro_id});">Нагатинская</span>', '#a2a5b4'),
(91, 1, 'Нагорная', '<span style="margin: 720px 0pt 0pt 475px;">Нагорная</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 720px 0pt 0pt 451px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:720px 0pt 0pt 475px;" onmouseover="gMetro.show({metro_id});">Нагорная</span>', '#a2a5b4'),
(92, 1, 'Нахимовский проспект', '<span style="margin: 751px 0pt 0pt 475px; line-height: 10px;">Нахимовский<br />проспект</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 751px 0pt 0pt 451px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:751px 0pt 0pt 475px; line-height: 10px;" onmouseover="gMetro.show({metro_id});">Нахимовский<br />проспект</span>', '#a2a5b4'),
(93, 1, 'Севастопольская', '<span style="margin: 803px 0pt 0pt 475px;">Севастопольская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 803px 0pt 0pt 451px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:803px 0pt 0pt 475px;" onmouseover="gMetro.show({metro_id});">Севастопольская</span>', '#a2a5b4'),
(94, 1, 'Чертановская', '<span style="margin: 831px 0pt 0pt 475px;">Чертановская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 831px 0pt 0pt 451px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:831px 0pt 0pt 475px;" onmouseover="gMetro.show({metro_id});">Чертановская</span>', '#a2a5b4'),
(95, 1, 'Южная', '<span style="margin: 858px 0pt 0pt 465px;">Южная</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 858px 0pt 0pt 440px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:858px 0pt 0pt 465px;" onmouseover="gMetro.show({metro_id});">Южная</span>', '#a2a5b4'),
(96, 1, 'Улица академика Янгеля', '<span style="margin: 896px 0pt 0pt 426px;">Улица академика Янгеля</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin:896px 0pt 0pt 402px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:896px 0pt 0pt 426px;" onmouseover="gMetro.show({metro_id});">Улица академика Янгеля</span>', '#a2a5b4'),
(97, 1, 'Аннино', '<span style="margin: 887px 0pt 0pt 357px;">Аннино</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 903px 0pt 0pt 365px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:887px 0pt 0pt 357px;" onmouseover="gMetro.show({metro_id});">Аннино</span>', '#a2a5b4'),
(98, 1, 'Бульвар Дмитрия  Донского', '<span style="margin: 921px 0pt 0pt 246px;line-height: 10px;">Бульвар<br>Дмитрия Донского</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 903px 0pt 0pt 227px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:921px 0pt 0pt 246px;line-height: 10px;" onmouseover="gMetro.show({metro_id});">Бульвар<br>Дмитрия Донского</span>', '#a2a5b4'),
(99, 1, 'Пражская', '<span style="margin: 877px 0pt 0pt 446px;">Пражская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 877px 0pt 0pt 422px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:877px 0pt 0pt 446px;" onmouseover="gMetro.show({metro_id});">Пражская</span>', '#a2a5b4'),
(100, 1, 'Улица  Старокачаловская', '<span style="margin: 875px 0pt 0pt 130px;line-height:1em; text-align:right;">Улица<br />Старокачаловская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 888px 0pt 0pt 218px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:875px 0pt 0pt 130px;line-height:1em; text-align:right;" onmouseover="gMetro.show({metro_id});">Улица<br />Старокачаловская</span>', '#a2a5b4'),
(101, 1, 'Улица  Скобелевская', '<span style="margin: 922px 0pt 0pt 122px; line-height:1em; text-align:center;">Улица<br />Скобелевская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 904px 0pt 0pt 148px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:922px 0pt 0pt 122px; line-height:1em; text-align:center;" onmouseover="gMetro.show({metro_id});">Улица<br />Скобелевская</span>', '#a2a5b4'),
(102, 1, 'Бульвар адмирала  Ушакова', '<span style="margin: 884px 0pt 0pt 55px; line-height:1em; text-align:center;">Бульвар<br />адмирала Ушакова</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin:  904px 0pt 0pt 90px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:884px 0pt 0pt 55px; line-height:1em; text-align:center;" onmouseover="gMetro.show({metro_id});">Бульвар<br />адмирала Ушакова</span>', '#a2a5b4'),
(103, 1, 'Улица  Горчакова', '<span style="margin: 922px 0pt 0pt 41px;line-height:1em; text-align:center;">Улица<br />Горчакова</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 904px 0pt 0pt 58px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:922px 0pt 0pt 41px; line-height:1em; text-align:center;" onmouseover="gMetro.show({metro_id});">Улица<br />Горчакова</span>', '#a2a5b4'),
(104, 1, 'Бунинская  аллея', '<span style="margin: 884px 0pt 0pt 3px; line-height:1em; text-align:center;">Бунинская<br />аллея</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 904px 0pt 0pt 18px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:884px 0pt 0pt 3px;line-height:1em; text-align:center; " onmouseover="gMetro.show({metro_id});">Бунинская<br />аллея</span>', '#a2a5b4'),
(105, 1, 'Каховская', '<span style="margin: 774px 0pt 0pt 401px;">Каховская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 788px 0pt 0pt 434px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:774px 0pt 0pt 401px;" onmouseover="gMetro.show({metro_id});">Каховская</span>', '#29b1a6'),
(106, 1, 'Варшавская', '<span style="margin: 774px 0pt 0pt 486px;">Варшавская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 789px 0pt 0pt 500px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:774px 0pt 0pt 486px;" onmouseover="gMetro.show({metro_id});">Варшавская</span>', '#29b1a6'),
(107, 1, 'Каширская (Замоскворецкая линия)', '<span style="margin: 716px 0pt 0pt 607px;">Каширская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 716px 0pt 0pt 583px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:716px 0pt 0pt 607px;" onmouseover="gMetro.show({metro_id});">Каширская</span>', '#0a6f20'),
(108, 1, 'Речной вокзал', '<span style="margin: 75px 0pt 0pt 239px;">Речной вокзал</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 75px 0pt 0pt 215px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:75px 0pt 0pt 239px;" onmouseover="gMetro.show({metro_id});">Речной вокзал</span>', '#0a6f20'),
(109, 1, 'Водный стадион', '<span style="margin: 119px 0pt 0pt 239px;">Водный стадион</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 119px 0pt 0pt 215px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:119px 0pt 0pt 239px;" onmouseover="gMetro.show({metro_id});">Водный стадион</span>', '#0a6f20'),
(110, 1, 'Войковская', '<span style="margin: 151px 0pt 0pt 239px;">Войковская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 151px 0pt 0pt 215px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:151px 0pt 0pt 239px;" onmouseover="gMetro.show({metro_id});">Войковская</span>', '#0a6f20'),
(111, 1, 'Сокол', '<span style="margin: 184px 0pt 0pt 239px;">Сокол</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 184px 0pt 0pt 215px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:184px 0pt 0pt 239px;" onmouseover="gMetro.show({metro_id});">Сокол</span>', '#0a6f20'),
(112, 1, 'Аэропорт', '<span style="margin: 218px 0pt 0pt 252px;">Аэропорт</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 226px 0pt 0pt 233px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:218px 0pt 0pt 252px;" onmouseover="gMetro.show({metro_id});">Аэропорт</span>', '#0a6f20'),
(113, 1, 'Динамо', '<span style="margin: 243px 0pt 0pt 279px;">Динамо</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 253px 0pt 0pt 259px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:243px 0pt 0pt 279px;" onmouseover="gMetro.show({metro_id});">Динамо</span>', '#0a6f20'),
(114, 1, 'Белорусская (радиальная)', '<span style="margin: 282px 0pt 0pt 220px;">Белорусская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 272px 0pt 0pt 280px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:282px 0pt 0pt 220px;" onmouseover="gMetro.show({metro_id});">Белорусская</span>', '#0a6f20'),
(115, 1, 'Белорусская (кольцевая)', '<span style="margin: 309px 0pt 0pt 235px;">Белорусская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 295px 0pt 0pt 281px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:309px 0pt 0pt 235px;" onmouseover="gMetro.show({metro_id});">Белорусская</span>', '#7f0000'),
(116, 1, 'Маяковская', '<span style="margin: 332px 0pt 0pt 276px;">Маяковская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 330px 0pt 0pt 336px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:332px 0pt 0pt 276px;" onmouseover="gMetro.show({metro_id});">Маяковская</span>', '#0a6f20'),
(117, 1, 'Тверская', '<span style="margin: 360px 0pt 0pt 316px;">Тверская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 353px 0pt 0pt 360px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:360px 0pt 0pt 316px;" onmouseover="gMetro.show({metro_id});">Тверская</span>', '#0a6f20'),
(118, 1, 'Театральная', '<span style="margin: 455px 0pt 0pt 468px;">Театральная</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 457px 0pt 0pt 447px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:455px 0pt 0pt 468px;" onmouseover="gMetro.show({metro_id});">Театральная</span>', '#0a6f20'),
(119, 1, 'Новокузнецкая', '<span style="margin: 536px 0pt 0pt 537px;">Новокузнецкая</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 543px 0pt 0pt 515px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:536px 0pt 0pt 537px;" onmouseover="gMetro.show({metro_id});">Новокузнецкая</span>', '#0a6f20'),
(120, 1, 'Павелецкая (кольцевая)', '<span style="margin: 566px 0pt 0pt 560px;">Павелецкая</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 581px 0pt 0pt 573px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:566px 0pt 0pt 560px;" onmouseover="gMetro.show({metro_id});">Павелецкая</span>', '#7f0000'),
(121, 1, 'Павелецкая (радиальная)', '<span style="margin: 601px 0pt 0pt 597px;">Павелецкая</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 601px 0pt 0pt 573px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:601px 0pt 0pt 597px;" onmouseover="gMetro.show({metro_id});">Павелецкая</span>', '#0a6f20'),
(122, 1, 'Автозаводская', '<span style="margin: 645px 0pt 0pt 607px;">Автозаводская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 645px 0pt 0pt 583px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:645px 0pt 0pt 607px;" onmouseover="gMetro.show({metro_id});">Автозаводская</span>', '#0a6f20'),
(123, 1, 'Коломенская', '<span style="margin: 681px 0pt 0pt 607px;">Коломенская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 681px 0pt 0pt 583px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:681px 0pt 0pt 607px;" onmouseover="gMetro.show({metro_id});">Коломенская</span>', '#0a6f20'),
(124, 1, 'Каширская (Каховская линия:)', '<span style="margin: 735px 0pt 0pt 535px;">Каширская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 732px 0pt 0pt 600px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:735px 0pt 0pt 535px;" onmouseover="gMetro.show({metro_id});">Каширская</span>', '#29b1a6'),
(125, 1, 'Кантемировская', '<span style="margin: 770px 0pt 0pt 615px;">Кантемировская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 770px 0pt 0pt 591px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:770px 0pt 0pt 615px;" onmouseover="gMetro.show({metro_id});">Кантемировская</span>', '#0a6f20'),
(126, 1, 'Царицыно', '<span style="margin: 794px 0pt 0pt 638px;">Царицыно</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 794px 0pt 0pt 614px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:794px 0pt 0pt 638px;" onmouseover="gMetro.show({metro_id});">Царицыно</span>', '#0a6f20'),
(127, 1, 'Орехово', '<span style="margin: 818px 0pt 0pt 663px;">Орехово</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 819px 0pt 0pt 639px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:818px 0pt 0pt 663px;" onmouseover="gMetro.show({metro_id});">Орехово</span>', '#0a6f20'),
(128, 1, 'Домодедовская', '<span style="margin: 851px 0pt 0pt 588px;">Домодедовская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 845px 0pt 0pt 664px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:851px 0pt 0pt 588px;" onmouseover="gMetro.show({metro_id});">Домодедовская</span>', '#0a6f20'),
(129, 1, 'Красногвардейская', '<span style="margin: 877px 0pt 0pt 598px;">Красногвардейская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 874px 0pt 0pt 693px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:877px 0pt 0pt 598px;" onmouseover="gMetro.show({metro_id});">Красногвардейская</span>', '#0a6f20'),
(131, 1, 'Планерная', '<span style="margin: 142px 0pt 0pt 130px;">Планерная</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 142px 0pt 0pt 106px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:142px 0pt 0pt 130px;" onmouseover="gMetro.show({metro_id});">Планерная</span>', '#92007b'),
(132, 1, 'Сходненская', '<span style="margin: 182px 0pt 0pt 130px;">Сходненская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 182px 0pt 0pt 106px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:182px 0pt 0pt 130px;" onmouseover="gMetro.show({metro_id});">Сходненская</span>', '#92007b'),
(133, 1, 'Тушинская', '<span style="margin:211px 0pt 0pt 130px;">Тушинская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 211px 0pt 0pt 106px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:211px 0pt 0pt 130px;" onmouseover="gMetro.show({metro_id});">Тушинская</span>', '#92007b'),
(134, 1, 'Щукинская', '<span style="margin: 239px 0pt 0pt 130px;">Щукинская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 239px 0pt 0pt 106px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:239px 0pt 0pt 130px;" onmouseover="gMetro.show({metro_id});">Щукинская</span>', '#92007b'),
(135, 1, 'Октябрьское поле', '<span style="margin: 266px 0pt 0pt 130px;">Октябрьское поле</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 266px 0pt 0pt 106px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:266px 0pt 0pt 130px;" onmouseover="gMetro.show({metro_id});">Октябрьское поле</span>', '#92007b'),
(136, 1, 'Полежаевская', '<span style="margin: 293px 0pt 0pt 130px;">Полежаевская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 293px 0pt 0pt 106px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 293px 0pt 0pt 130px;" onmouseover="gMetro.show({metro_id});">Полежаевская</span>', '#92007b'),
(137, 1, 'Беговая', '<span style="margin: 327px 0pt 0pt 143px;">Беговая</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 337px 0pt 0pt 123px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:327px 0pt 0pt 143px;" onmouseover="gMetro.show({metro_id});">Беговая</span>', '#92007b'),
(138, 1, 'Улица 1905 года', '<span style="margin: 352px 0pt 0pt 178px; line-height:1em; text-align:center;">Улица<br />1905 года</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin:373px 0pt 0pt 186px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:352px 0pt 0pt 178px; line-height:1em; text-align:center;" onmouseover="gMetro.show({metro_id});">Улица<br />1905 года</span>', '#92007b'),
(139, 1, 'Краснопресненская', '<span style="margin: 402px 0pt 0pt 255px;">Краснопресненская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 393px 0pt 0pt 237px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:402px 0pt 0pt 255px;" onmouseover="gMetro.show({metro_id});">Краснопресненская</span>', '#7f0000'),
(140, 1, 'Баррикадная', '<span style="margin: 387px 0pt 0pt 265px;">Баррикадная</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 373px 0pt 0pt 257px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:387px 0pt 0pt 265px;" onmouseover="gMetro.show({metro_id});">Баррикадная</span>', '#92007b'),
(141, 1, 'Пушкинская', '<span style="margin: 387px 0pt 0pt 355px;">Пушкинская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 373px 0pt 0pt 371px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:387px 0pt 0pt 355px;" onmouseover="gMetro.show({metro_id});">Пушкинская</span>', '#92007b'),
(142, 1, 'Кузнецкий мост', '<span style="margin: 393px 0pt 0pt 422px; line-height:1em; text-align:right;">Кузнецкий<br />мост</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 373px 0pt 0pt 464px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:393px 0pt 0pt 422px; line-height:1em; text-align:right;" onmouseover="gMetro.show({metro_id});">Кузнецкий<br />мост</span>', '#92007b'),
(143, 1, 'Китай-город (таганско-краснопресненская)', '<span style="margin: 416px 0pt 0pt 475px;">Китай-город</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 416px 0pt 0pt 540px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:416px 0pt 0pt 475px;" onmouseover="gMetro.show({metro_id});">Китай-город</span>', '#92007b'),
(144, 1, 'Таганская (радиальная)', '<span style="margin: 527px 0pt 0pt 610px;">Таганская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 512px 0pt 0pt 633px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:527px 0pt 0pt 610px;" onmouseover="gMetro.show({metro_id});">Таганская</span>', '#92007b'),
(145, 1, 'Таганская (кольцевая)', '<span style="margin: 502px 0pt 0pt 586px;">Таганская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 495px 0pt 0pt 633px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:502px 0pt 0pt 586px;" onmouseover="gMetro.show({metro_id});">Таганская</span>', '#7f0000'),
(146, 1, 'Пролетарская', '<span style="margin: 571px 0pt 0pt 621px;">Пролетарская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 569px 0pt 0pt 694px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:571px 0pt 0pt 621px;" onmouseover="gMetro.show({metro_id});">Пролетарская</span>', '#92007b'),
(147, 1, 'Текстильщики', '<span style="margin: 597px 0pt 0pt 788px;">Текстильщики</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 610px 0pt 0pt 772px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:597px 0pt 0pt 788px;" onmouseover="gMetro.show({metro_id});">Текстильщики</span>', '#92007b'),
(148, 1, 'Кузьминки', '<span style="margin: 617px 0pt 0pt 809px;">Кузьминки</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 625px 0pt 0pt 788px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:617px 0pt 0pt 809px;" onmouseover="gMetro.show({metro_id});">Кузьминки</span>', '#92007b'),
(149, 1, 'Рязанский проспект', '<span style="margin: 668px 0pt 0pt 824px; line-height:1em;">Рязанский<br /> проспект</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 668px 0pt 0pt 800px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:668px 0pt 0pt 824px; line-height:1em;" onmouseover="gMetro.show({metro_id});">Рязанский<br /> проспект</span>', '#92007b'),
(150, 1, 'Выхино', '<span style="margin: 704px 0pt 0pt 824px;">Выхино</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) no-repeat scroll 0% 0% transparent; margin: 704px 0pt 0pt 800px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:704px 0pt 0pt 824px;" onmouseover="gMetro.show({metro_id});">Выхино</span>', '#92007b'),
(151, 1, 'Лермонтовский проспект', '<span style="margin: 731px 0pt 0pt 824px; line-height:1em;">Лермонтовский<br /> проспект </span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 731px 0pt 0pt 800px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:731px 0pt 0pt 824px; line-height:1em;" onmouseover="gMetro.show({metro_id});">Лермонтовский<br /> проспект </span>', '#92007b'),
(152, 1, 'Волгоградский  проспект', '<span style="margin: 575px 0pt 0pt 744px;">Волгоградский проспект</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 588px 0pt 0pt 730px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:575px 0pt 0pt 744px;" onmouseover="gMetro.show({metro_id});">Волгоградский проспект</span>', '#92007b'),
(153, 1, 'Щелковская', '<span style="margin: 136px 0pt 0pt 777px;">Щелковская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 136px 0pt 0pt 753px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:136px 0pt 0pt 777px;" onmouseover="gMetro.show({metro_id});">Щелковская</span>', '#072889'),
(154, 1, 'Первомайская', '<span style="margin: 170px 0pt 0pt 777px;">Первомайская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 170px 0pt 0pt 754px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:170px 0pt 0pt 777px;" onmouseover="gMetro.show({metro_id});">Первомайская</span>', '#072889'),
(155, 1, 'Измайловская', '<span style="margin: 205px 0pt 0pt 777px;">Измайловская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 205px 0pt 0pt 753px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:205px 0pt 0pt 777px;" onmouseover="gMetro.show({metro_id});">Измайловская</span>', '#072889'),
(156, 1, 'Партизанская', '<span style="margin: 239px 0pt 0pt 777px;">Партизанская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 239px 0pt 0pt 753px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:239px 0pt 0pt 777px;" onmouseover="gMetro.show({metro_id});">Партизанская</span>', '#072889'),
(157, 1, 'Семеновская', '<span style="margin: 281px 0pt 0pt 758px;">Семеновская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 279px 0pt 0pt 734px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:281px 0pt 0pt 758px;" onmouseover="gMetro.show({metro_id});">Семеновская</span>', '#072889'),
(158, 1, 'Электрозаводская', '<span style="margin: 312px 0pt 0pt 728px;">Электрозаводская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 310px 0pt 0pt 703px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:312px 0pt 0pt 728px;" onmouseover="gMetro.show({metro_id});">Электрозаводская</span>', '#072889'),
(159, 1, 'Бауманская', '<span style="margin: 346px 0pt 0pt 692px;">Бауманская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 346px 0pt 0pt 668px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:346px 0pt 0pt 692px;" onmouseover="gMetro.show({metro_id});">Бауманская</span>', '#072889'),
(160, 1, 'Курская (радиальная)', '<span style="margin: 364px 0pt 0pt 600px;">Курская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 378px 0pt 0pt 632px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:364px 0pt 0pt 600px;" onmouseover="gMetro.show({metro_id});">Курская</span>', '#072889'),
(161, 1, 'Курская (кольцевая)', '<span style="margin: 388px 0pt 0pt 668px;">Курская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 392px 0pt 0pt 645px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:388px 0pt 0pt 668px;" onmouseover="gMetro.show({metro_id});">Курская</span>', '#7f0000'),
(162, 1, 'Площадь  Революции', '<span style="margin: 484px 0pt 0pt 477px;">Пл. Революции</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 470px 0pt 0pt 462px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:484px 0pt 0pt 477px;" onmouseover="gMetro.show({metro_id});">Пл.  Революции</span>', '#072889'),
(163, 1, 'Арбатская (арбатско-покровская)', '<span style="margin: 475px 0pt 0pt 294px;">Арбатская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 485px 0pt 0pt 344px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:475px 0pt 0pt 294px;" onmouseover="gMetro.show({metro_id});">Арбатская</span>', '#072889'),
(164, 1, 'Смоленская (арбатско-покровская)', '<span style="margin: 500px 0pt 0pt 260px;">Смоленская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 506px 0pt 0pt 320px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:500px 0pt 0pt 260px;" onmouseover="gMetro.show({metro_id});">Смоленская</span>', '#072889'),
(165, 1, 'Киевская (арбатско-покровская)', '<span style="margin: 547px 0pt 0pt 190px;">Киевская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 535px 0pt 0pt 228px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:547px 0pt 0pt 190px;" onmouseover="gMetro.show({metro_id});">Киевская</span>', '#072889'),
(166, 1, 'Киевская (кольцевая)', '<span style="margin: 520px 0pt 0pt 211px;">Киевская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 520px 0pt 0pt 255px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:520px 0pt 0pt 211px;" onmouseover="gMetro.show({metro_id});">Киевская</span>', '#7f0000'),
(167, 1, 'Парк Победы', '<span style="margin: 560px 0pt 0pt 128px; line-height:1em; ">Парк<br />Победы</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin:536px 0pt 0pt 125px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:560px 0pt 0pt 128px; line-height:1em; " onmouseover="gMetro.show({metro_id});">Парк<br />Победы</span>', '#072889'),
(168, 1, 'Славянский бульвар', '<span style="margin: 555px 0pt 0pt 46px; line-height: 10px;">Славянский<br>бульвар</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 536px 0pt 0pt 63px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:555px 0pt 0pt 46px; line-height: 10px;" onmouseover="gMetro.show({metro_id});">Славянский<br>бульвар</span>', '#072889'),
(169, 1, 'Кунцевская (арбатско-покровская)', '<span style="margin: 313px 0pt 0pt 29px;">Кунцевская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 313px 0pt 0pt 5px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:313px 0pt 0pt 29px;" onmouseover="gMetro.show({metro_id});">Кунцевская</span>', '#072889'),
(170, 1, 'Молодежная', '<span style="margin: 282px 0pt 0pt 29px;">Молодежная</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 282px 0pt 0pt 5px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:282px 0pt 0pt 29px;" onmouseover="gMetro.show({metro_id});">Молодежная</span>', '#072889'),
(171, 1, 'Крылатское', '<span style="margin: 252px 0pt 0pt 29px;">Крылатское</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 252px 0pt 0pt 5px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:252px 0pt 0pt 29px;" onmouseover="gMetro.show({metro_id});">Крылатское</span>', '#072889'),
(172, 1, 'Строгино', '<span style="margin: 223px 0pt 0pt 29px;">Строгино</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 223px 0pt 0pt 5px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:223px 0pt 0pt 29px;" onmouseover="gMetro.show({metro_id});">Строгино</span>', '#072889'),
(173, 1, 'Мякинино', '<span style="margin: 192px 0pt 0pt 29px;">Мякининская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 192px 0pt 0pt 5px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:192px 0pt 0pt 29px;" onmouseover="gMetro.show({metro_id});">Мякининская</span>', '#072889'),
(174, 1, 'Волоколамская', '<span style="margin: 164px 0pt 0pt 29px;">Волоколамская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 164px 0pt 0pt 5px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:164px 0pt 0pt 29px;" onmouseover="gMetro.show({metro_id});">Волоколамская</span>', '#072889'),
(175, 1, 'Митино', '<span style="margin: 136px 0pt 0pt 29px;">Митино</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 136px 0pt 0pt 5px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:136px 0pt 0pt 29px;" onmouseover="gMetro.show({metro_id});">Митино</span>', '#072889'),
(176, 1, 'Кунцевская (филевская)', '<span style="margin: 329px 0pt 0pt 46px;">Кунцевская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 329px 0pt 0pt 22px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:329px 0pt 0pt 46px;" onmouseover="gMetro.show({metro_id});">Кунцевская</span>', '#069cd3');
INSERT INTO `{site_prefix}_maps_metro_stat` (`id`, `metro_id`, `station`, `content`, `active_content`, `color`) VALUES
(177, 1, 'Пионерская', '<span style="margin:355px 0pt 0pt 46px  ;">Пионерская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 355px 0pt 0pt 22px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:355px 0pt 0pt 46px;" onmouseover="gMetro.show({metro_id});">Пионерская</span>', '#069cd3'),
(178, 1, 'Филевский Парк', '<span style="margin: 377px 0pt 0pt 46px;">Филевский Парк</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 377px 0pt 0pt 22px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:377px 0pt 0pt 46px;" onmouseover="gMetro.show({metro_id});">Филевский Парк</span>', '#069cd3'),
(179, 1, 'Багратионовская', '<span style="margin: 400px 0pt 0pt 46px;">Багратионовская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 400px 0pt 0pt 22px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:400px 0pt 0pt 46px;" onmouseover="gMetro.show({metro_id});">Багратионовская</span>', '#069cd3'),
(180, 1, 'Фили', '<span style="margin: 423px 0pt 0pt 46px;">Фили</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 423px 0pt 0pt 22px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:423px 0pt 0pt 46px;" onmouseover="gMetro.show({metro_id});">Фили</span>', '#069cd3'),
(181, 1, 'Кутузовская', '<span style="margin: 446px 0pt 0pt 46px;">Кутузовская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 446px 0pt 0pt 22px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:446px 0pt 0pt 46px;" onmouseover="gMetro.show({metro_id});">Кутузовская</span>', '#069cd3'),
(182, 1, 'Студенческая', '<span style="margin: 519px 0pt 0pt 39px;">Студенческая</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 505px 0pt 0pt 65px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 519px 0pt 0pt 39px;" onmouseover="gMetro.show({metro_id});">Студенческая</span>', '#069cd3'),
(183, 1, 'Международная', '<span style="margin: 425px 0pt 0pt 154px;">Международная</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 425px 0pt 0pt 130px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 425px 0pt 0pt 154px;" onmouseover="gMetro.show({metro_id});">Международная</span>', '#069cd3'),
(184, 1, 'Выставочная', '<span style="margin: 471px 0pt 0pt 154px;">Выставочная</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 471px 0pt 0pt 130px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 471px 0pt 0pt 154px;" onmouseover="gMetro.show({metro_id});">Выставочная</span>', '#069cd3'),
(185, 1, 'Киевская (филевская)', '<span style="margin: 493px 0pt 0pt 190px;">Киевская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 503px 0pt 0pt 230px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 493px 0pt 0pt 190px;" onmouseover="gMetro.show({metro_id});">Киевская</span>', '#069cd3'),
(186, 1, 'Смоленская (филевская)', '<span style="margin: 488px 0pt 0pt 273px;">Смоленская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 478px 0pt 0pt 255px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 488px 0pt 0pt 273px;" onmouseover="gMetro.show({metro_id});">Смоленская</span>', '#069cd3'),
(187, 1, 'Арбатская (филевская)', '<span style="margin: 465px 0pt 0pt 303px;">Арбатская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 453px 0pt 0pt 338px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 465px 0pt 0pt 303px;" onmouseover="gMetro.show({metro_id});">Арбатская</span>', '#069cd3'),
(188, 1, 'Александровский сад', '<span style="margin: 435px 0pt 0pt 296px; line-height:1em; text-align:right;">Александровский<br />сад</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 452px 0pt 0pt 380px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 435px 0pt 0pt 296px; line-height:1em; text-align:right;" onmouseover="gMetro.show({metro_id});">Александровский<br />сад</span>', '#069cd3'),
(189, 2, 'Приморская', '<span style="margin:311px 0pt 0pt 35px;">Приморская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin:311px 0pt 0pt 10px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 311px 0pt 0pt 35px;" onmouseover="gMetro.show({metro_id});">Приморская</span>', '#069e5e'),
(190, 2, 'Василеостровская', '<span style="margin: 365px 0pt 0pt 48px;">Василеостровская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin:349px 0pt 0pt 80px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 365px 0pt 0pt 48px;" onmouseover="gMetro.show({metro_id});">Василеостровская</span>', '#069e5e'),
(191, 2, 'Гостиный двор', '<span style="margin: 368px 0pt 0pt 281px; line-height:1em;">Гостиный<br /> двор</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:349px 0pt 0pt 276px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 368px 0pt 0pt 281px; line-height:1em;" onmouseover="gMetro.show({metro_id});">Гостиный<br /> двор</span>', '#069e5e'),
(192, 2, 'Маяковская', '<span style="margin: 330px 0pt 0pt 358px;">Маяковская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:349px 0pt 0pt 406px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 330px 0pt 0pt 358px;" onmouseover="gMetro.show({metro_id});">Маяковская</span>', '#069e5e'),
(193, 2, 'Площадь Александра Невского-I', '<span style="margin: 435px 0pt 0pt 605px; line-height:1em;">Пл. Александра<br /> Невского-I</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:435px 0pt 0pt 581px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 435px 0pt 0pt 605px; line-height:1em;" onmouseover="gMetro.show({metro_id});">Пл. Александра<br /> Невского-I</span>', '#069e5e'),
(194, 2, 'Елизаровская', '<span style="margin: 481px 0pt 0pt 605px;">Елизаровская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:481px 0pt 0pt 581px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 481px 0pt 0pt 605px;" onmouseover="gMetro.show({metro_id});">Елизаровская</span>', '#069e5e'),
(195, 2, 'Ломоносовская', '<span style="margin:512px 0pt 0pt 605px;">Ломоносовская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:512px 0pt 0pt 581px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 512px 0pt 0pt 605px;" onmouseover="gMetro.show({metro_id});">Ломоносовская</span>', '#069e5e'),
(196, 2, 'Пролетарская', '<span style="margin: 546px 0pt 0pt 605px;">Пролетарская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:546px 0pt 0pt 581px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 546px 0pt 0pt 605px;" onmouseover="gMetro.show({metro_id});">Пролетарская</span>', '#069e5e'),
(197, 2, 'Обухово', '<span style="margin: 579px 0pt 0pt 605px;">Обухово</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:579px 0pt 0pt 581px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 579px 0pt 0pt 605px;" onmouseover="gMetro.show({metro_id});">Обухово</span>', '#069e5e'),
(198, 2, 'Рыбацкое', '<span style="margin: 611px 0pt 0pt 605px;">Рыбацкое</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:611px 0pt 0pt 581px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 611px 0pt 0pt 605px;" onmouseover="gMetro.show({metro_id});">Рыбацкое</span>', '#069e5e'),
(199, 2, 'Улица Дыбенко', '<span style="margin: 572px 0pt 0pt 719px;">Улица Дыбенко</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:572px 0pt 0pt 695px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 572px 0pt 0pt 719px;" onmouseover="gMetro.show({metro_id});">Улица Дыбенко</span>', '#de7207'),
(200, 2, 'Пр-т Большевиков', '<span style="margin: 539px 0pt 0pt 719px; line-height:1em;">Проспект<br /> большевиков</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:539px 0pt 0pt 695px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 539px 0pt 0pt 719px; line-height:1em;" onmouseover="gMetro.show({metro_id});">Проспект<br /> большевиков</span>', '#de7207'),
(201, 2, 'Ладожская', '<span style="margin: 506px 0pt 0pt 719px;">Ладожская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:506px 0pt 0pt 695px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 506px 0pt 0pt 719px;" onmouseover="gMetro.show({metro_id});">Ладожская</span>', '#de7207'),
(202, 2, 'Новочеркасская', '<span style="margin: 461px 0pt 0pt 701px;">Новочеркасская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:468px 0pt 0pt 677px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 461px 0pt 0pt 701px;" onmouseover="gMetro.show({metro_id});">Новочеркасская</span>', '#de7207'),
(203, 2, 'Площадь Александра Невского-II', '<span style="margin: 475px 0pt 0pt 495px; line-height:1em;">Пл. Александра<br /> Невского - 2</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:453px 0pt 0pt 563px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 475px 0pt 0pt 495px; line-height:1em;" onmouseover="gMetro.show({metro_id});">Пл. Александра<br /> Невского-2</span>', '#de7207'),
(204, 2, 'Лиговский пр-т', '<span style="margin: 430px 0pt 0pt 461px; line-height:1em;">Лиговский<br /> проспект</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:453px 0pt 0pt 473px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 430px 0pt 0pt 461px; line-height:1em;" onmouseover="gMetro.show({metro_id});">Лиговский<br /> проспект</span>', '#de7207'),
(205, 2, 'Достоевская', '<span style="margin: 437px 0pt 0pt 335px;">Достоевская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:453px 0pt 0pt 350px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 437px 0pt 0pt 335px;" onmouseover="gMetro.show({metro_id});">Достоевская</span>', '#de7207'),
(206, 2, 'Спасская', '<span style="margin: 468px 0pt 0pt 278px;">Спасская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:453px 0pt 0pt 270px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 468px 0pt 0pt 278px;" onmouseover="gMetro.show({metro_id});">Спасская</span>', '#de7207'),
(207, 2, 'Парнас', '<span style="margin: 60px 0pt 0pt 281px;">Парнас</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:60px 0pt 0pt 257px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 60px 0pt 0pt 281px;" onmouseover="gMetro.show({metro_id});">Парнас</span>', '#0196ff'),
(208, 2, 'Пр-т Просвещения', '<span style="margin: 89px 0pt 0pt 281px; line-height:1em;">Проспект<br /> Просвещения</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:89px 0pt 0pt 257px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 89px 0pt 0pt 281px; line-height:1em;" onmouseover="gMetro.show({metro_id});">Проспект<br /> Просвещения</span>', '#0196ff'),
(209, 2, 'Озерки', '<span style="margin: 127px 0pt 0pt 281px;">Озерки</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:127px 0pt 0pt 257px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 127px 0pt 0pt 281px;" onmouseover="gMetro.show({metro_id});">Озерки</span>', '#0196ff'),
(210, 2, 'Удельная', '<span style="margin: 158px 0pt 0pt 281px;">Удельная</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin:158px 0pt 0pt 257px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 158px 0pt 0pt 281px;" onmouseover="gMetro.show({metro_id});">Удельная</span>', '#0196ff'),
(211, 2, 'Пионерская', '<span style="margin: 189px 0pt 0pt 281px ;">Пионерская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:189px 0pt 0pt 257px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 189px 0pt 0pt 281px;" onmouseover="gMetro.show({metro_id});">Пионерская</span>', '#0196ff'),
(212, 2, 'Черная речка', '<span style="margin: 219px 0pt 0pt 281px;">Черная речка</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:219px 0pt 0pt 257px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 219px 0pt 0pt 281px;" onmouseover="gMetro.show({metro_id});">Черная речка</span>', '#0196ff'),
(213, 2, 'Петроградская', '<span style="margin: 251px 0pt 0pt 281px;">Петроградская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:251px 0pt 0pt 257px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 251px 0pt 0pt 281px;" onmouseover="gMetro.show({metro_id});">Петроградская</span>', '#0196ff'),
(214, 2, 'Горьковская', '<span style="margin: 281px 0pt 0pt 281px;">Горьковская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:281px 0pt 0pt 257px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 281px 0pt 0pt 281px;" onmouseover="gMetro.show({metro_id});">Горьковская</span>', '#0196ff'),
(215, 2, 'Невский проспект', '<span style="margin: 324px 0pt 0pt 281px; line-height:1em;">Невский<br /> проспект</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:330px 0pt 0pt 257px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:324px 0pt 0pt 281px; line-height:1em;" onmouseover="gMetro.show({metro_id});">Невский<br />  проспект</span>', '#0196ff'),
(216, 2, 'Сенная площадь', '<span style="margin: 415px 0pt 0pt 280px; line-height:1em;">Сенная<br /> площадь</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:429px 0pt 0pt 256px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 415px 0pt 0pt 280px; line-height:1em;" onmouseover="gMetro.show({metro_id});">Сенная<br /> площадь</span>', '#0196ff'),
(217, 2, 'Технологический институт-II', '<span style="margin: 555px 0pt 0pt 170px; line-height:1em;">Технологический<br /> институт - 2</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:559px 0pt 0pt 257px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 555px 0pt 0pt 170px; line-height:1em;" onmouseover="gMetro.show({metro_id});">Технологический<br /> институт - 2</span>', '#0196ff'),
(218, 2, 'Технологический институт-I', '<span style="margin: 585px 0pt 0pt 281px; line-height:1em;">Технологический<br /> институт - 1</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:584px 0pt 0pt 257px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 585px 0pt 0pt 281px; line-height:1em;" onmouseover="gMetro.show({metro_id});">Технологический<br /> институт - 1</span>', '#d71635'),
(219, 2, 'Фрунзенская', '<span style="margin: 611px 0pt 0pt 281px;">Фрунзенская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:611px 0pt 0pt 257px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 611px 0pt 0pt 281px;" onmouseover="gMetro.show({metro_id});">Фрунзенская</span>', '#0196ff'),
(220, 2, 'Московские ворота', '<span style="margin: 642px 0pt 0pt 281px; line-height:1em;">Московские<br /> ворота</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:642px 0pt 0pt 257px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 642px 0pt 0pt 281px; line-height:1em;" onmouseover="gMetro.show({metro_id});">Московские<br /> ворота</span>', '#0196ff'),
(221, 2, 'Электросила', '<span style="margin: 679px 0pt 0pt 281px;">Электросила</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:679px 0pt 0pt 257px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 679px 0pt 0pt 281px;" onmouseover="gMetro.show({metro_id});">Электросила</span>', '#0196ff'),
(222, 2, 'Парк Победы', '<span style="margin: 709px 0pt 0pt 281px;">Парк Победы</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:709px 0pt 0pt 257px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 709px 0pt 0pt 281px;" onmouseover="gMetro.show({metro_id});">Парк Победы</span>', '#0196ff'),
(223, 2, 'Московская', '<span style="margin: 740px 0pt 0pt 281px;">Московская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:740px 0pt 0pt 257px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 740px 0pt 0pt 281px;" onmouseover="gMetro.show({metro_id});">Московская</span>', '#0196ff'),
(224, 2, 'Звездная', '<span style="margin: 775px 0pt 0pt 281px;">Звездная</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:775px 0pt 0pt 257px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 775px 0pt 0pt 281px;" onmouseover="gMetro.show({metro_id});">Звездная</span>', '#0196ff'),
(225, 2, 'Купчино', '<span style="margin: 806px 0pt 0pt 281px;">Купчино</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:806px 0pt 0pt 257px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 806px 0pt 0pt 281px;" onmouseover="gMetro.show({metro_id});">Купчино</span>', '#0196ff'),
(226, 2, 'Волковская', '<span style="margin: 584px 0pt 0pt 406px;">Волковская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin:597px 0pt 0pt 387px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 584px 0pt 0pt 406px;" onmouseover="gMetro.show({metro_id});">Волковская</span>', '#73057d'),
(227, 2, 'Обводной канал', '<span style="margin: 550px 0pt 0pt 373px;">Обводной канал</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:561px 0pt 0pt 352px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 550px 0pt 0pt 373px;" onmouseover="gMetro.show({metro_id});">Обводной канал</span>', '#73057d'),
(228, 2, 'Звенигородская', '<span style="margin: 512px 0pt 0pt 223px;">Звенигородская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:512px 0pt 0pt 303px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 512px 0pt 0pt 223px;" onmouseover="gMetro.show({metro_id});">Звенигородская</span>', '#73057d'),
(229, 2, 'Садовая', '<span style="margin: 468px 0pt 0pt 213px;">Садовая</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:453px 0pt 0pt 244px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 468px 0pt 0pt 213px;" onmouseover="gMetro.show({metro_id});">Садовая</span>', '#73057d'),
(230, 2, 'Комендантский пр-т', '<span style="margin: 90px 0pt 0pt 151px; line-height:1em;">Комендантский<br /> проспект</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:90px 0pt 0pt 127px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 90px 0pt 0pt 151px; line-height:1em;" onmouseover="gMetro.show({metro_id});">Комендантский<br /> проспект</span>', '#73057d'),
(231, 2, 'Старая деревня', '<span style="margin: 129px 0pt 0pt 151px; line-height:1em;">Старая<br />  деревня</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:129px 0pt 0pt 127px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 129px 0pt 0pt 151px; line-height:1em;" onmouseover="gMetro.show({metro_id});">Старая<br /> деревня</span>', '#73057d'),
(232, 2, 'Крестовский остров', '<span style="margin: 182px 0pt 0pt 151px; line-height:1em;">Крестовский<br /> остров</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:182px 0pt 0pt 127px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 182px 0pt 0pt 151px; line-height:1em;" onmouseover="gMetro.show({metro_id});">Крестовский<br /> остров</span>', '#73057d'),
(233, 2, 'Чкаловская', '<span style="margin: 236px 0pt 0pt 151px;">Чкаловская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:236px 0pt 0pt 127px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 236px 0pt 0pt 151px;" onmouseover="gMetro.show({metro_id});">Чкаловская</span>', '#73057d'),
(234, 2, 'Спортивная', '<span style="margin: 281px 0pt 0pt 151px;">Спортивная</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:281px 0pt 0pt 127px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin: 281px 0pt 0pt 151px;" onmouseover="gMetro.show({metro_id});">Спортивная</span>', '#73057d'),
(235, 2, 'Девяткино', '<span style="margin:  60px 0pt 0pt 446px;">Девяткино</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:60px 0pt 0pt 422px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:  60px 0pt 0pt 446px;" onmouseover="gMetro.show({metro_id});">Девяткино</span>', '#d71635'),
(236, 2, 'Гражданский пр-т', '<span style="margin:  89px 0pt 0pt 446px; line-height:1em;">Гражданский<br /> проспект</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:89px 0pt 0pt 422px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:  89px 0pt 0pt 446px; line-height:1em;" onmouseover="gMetro.show({metro_id});">Гражданский<br /> проспект</span>', '#d71635'),
(237, 2, 'Академическая', '<span style="margin:  128px 0pt 0pt 446px;">Академическая</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:128px 0pt 0pt 422px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:  128px 0pt 0pt 446px;" onmouseover="gMetro.show({metro_id});">Академическая</span>', '#d71635'),
(238, 2, 'Политехническая', '<span style="margin:  158px 0pt 0pt 446px;">Политехническая</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:158px 0pt 0pt 422px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:  158px 0pt 0pt 446px;" onmouseover="gMetro.show({metro_id});">Политехническая</span>', '#d71635'),
(239, 2, 'Площадь Мужества', '<span style="margin:  189px 0pt 0pt 446px;">Площадь Мужества</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:189px 0pt 0pt 422px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:  189px 0pt 0pt 446px;" onmouseover="gMetro.show({metro_id});">Площадь Мужества</span>', '#d71635'),
(240, 2, 'Лесная', '<span style="margin:  220px 0pt 0pt 446px;">Лесная</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:220px 0pt 0pt 422px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:  220px 0pt 0pt 446px;" onmouseover="gMetro.show({metro_id});">Лесная</span>', '#d71635'),
(241, 2, 'Выборгская', '<span style="margin:  250px 0pt 0pt 446px;">Выборгская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:250px 0pt 0pt 422px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:  250px 0pt 0pt 446px;" onmouseover="gMetro.show({metro_id});">Выборгская</span>', '#d71635'),
(242, 2, 'Площадь Ленина', '<span style="margin:  281px 0pt 0pt 446px;">Площадь Ленина</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:281px 0pt 0pt 422px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:  281px 0pt 0pt 446px;" onmouseover="gMetro.show({metro_id});">Площадь Ленина</span>', '#d71635'),
(243, 2, 'Чернышевская', '<span style="margin:  322px 0pt 0pt 446px;">Чернышевская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:322px 0pt 0pt 422px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:  322px 0pt 0pt 446px;" onmouseover="gMetro.show({metro_id});">Чернышевская</span>', '#d71635'),
(244, 2, 'Площадь Восстания', '<span style="margin:  368px 0pt 0pt 446px;  line-height:1em">Площадь<br /> Восстания</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:365px 0pt 0pt 422px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:  368px 0pt 0pt 446px; line-height:1em;" onmouseover="gMetro.show({metro_id});">Площадь<br /> Восстания</span>', '#d71635'),
(245, 2, 'Владимирская', '<span style="margin:  471px 0pt 0pt 390px;">Владимирская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:470px 0pt 0pt 366px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:  471px 0pt 0pt 390px;" onmouseover="gMetro.show({metro_id});">Владимирская</span>', '#d71635'),
(246, 2, 'Пушкинская', '<span style="margin:  512px 0pt 0pt 350px;">Пушкинская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:512px 0pt 0pt 326px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:  512px 0pt 0pt 350px;" onmouseover="gMetro.show({metro_id});">Пушкинская</span>', '#d71635'),
(247, 2, 'Балтийская', '<span style="margin:  611px 0pt 0pt 163px;">Балтийская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:619px 0pt 0pt 223px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:  611px 0pt 0pt 163px;" onmouseover="gMetro.show({metro_id});">Балтийская</span>', '#d71635'),
(248, 2, 'Нарвская', '<span style="margin:  643px 0pt 0pt 144px;">Нарвская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin:651px 0pt 0pt 192px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:  643px 0pt 0pt 144px;" onmouseover="gMetro.show({metro_id});">Нарвская</span>', '#d71635'),
(249, 2, 'Кировский завод', '<span style="margin:678px 0pt 0pt 124px; line-height:1em; text-align:right;">Кировский<br /> завод</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:678px 0pt 0pt 180px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:678px 0pt 0pt 124px; line-height:1em;text-align:right; " onmouseover="gMetro.show({metro_id});">Кировский<br /> завод</span>', '#d71635'),
(250, 2, 'Автово', '<span style="margin:717px 0pt 0pt 140px;">Автово</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin:717px 0pt 0pt 180px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:717px 0pt 0pt 140px;" onmouseover="gMetro.show({metro_id});">Автово</span>', '#d71635'),
(251, 2, 'Ленинский пр-т', '<span style="margin:749px 0pt 0pt 122px; text-align:right; line-height:1em;">Ленинский<br /> проспект</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:749px 0pt 0pt 180px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:749px 0pt 0pt 122px; text-align:right; line-height:1em;" onmouseover="gMetro.show({metro_id});">Ленинский<br /> проспект</span>', '#d71635'),
(252, 2, 'Пр-т Ветеранов', '<span style="margin:788px 0pt 0pt 126px; line-height:1em; text-align:right;">Проспект<br /> Ветеранов</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent;margin:788px 0pt 0pt 180px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:788px 0pt 0pt 126px; line-height:1em; text-align:right;" onmouseover="gMetro.show({metro_id});">Проспект<br /> Ветеранов</span>', '#d71635'),
(256, 3, 'Российская', '<span style="margin: 130px 0pt 0pt 91px;">Российская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 125px 0pt 0pt 151px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:130px 0pt 0pt 91px;" onmouseover="gMetro.show({metro_id});">Российская</span>', '#d71635'),
(257, 3, 'Московская', '<span style="margin: 160px 0pt 0pt 118px;">Московская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 155px 0pt 0pt 179px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:160px 0pt 0pt 118px;" onmouseover="gMetro.show({metro_id});">Московская</span>', '#d71635'),
(258, 3, 'Гагаринская', '<span style="margin: 189px 0pt 0pt 147px;">Гагаринская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 183px 0pt 0pt 209px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:189px 0pt 0pt 147px;" onmouseover="gMetro.show({metro_id});">Гагаринская</span>', '#d71635'),
(259, 3, 'Спортивная', '<span style="margin: 218px 0pt 0pt 176px;">Спортивная</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 212px 0pt 0pt 237px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:218px 0pt 0pt 176px;" onmouseover="gMetro.show({metro_id});">Спортивная</span>', '#d71635'),
(260, 3, 'Советская', '<span style="margin: 247px 0pt 0pt 213px;">Советская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 242px 0pt 0pt 267px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:247px 0pt 0pt 213px;" onmouseover="gMetro.show({metro_id});">Советская</span>', '#d71635'),
(263, 3, 'Кировская', '<span style="margin: 290px 0pt 0pt 402px;">Кировская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 298px 0pt 0pt 379px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:290px 0pt 0pt 402px;" onmouseover="gMetro.show({metro_id});">Кировская</span>', '#d71635'),
(265, 3, 'Юнгородок', '<span style="margin: 312px 0pt 0pt 423px;">Юнгородок</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 319px 0pt 0pt 399px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:312px 0pt 0pt 423px;" onmouseover="gMetro.show({metro_id});">Юнгородок</span>', '#d71635'),
(273, 3, 'Победа', '<span style="margin: 270px 0pt 0pt 250px;">Победа</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 263px 0pt 0pt 288px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:270px 0pt 0pt 250px;" onmouseover="gMetro.show({metro_id});">Победа</span>', '#d71635'),
(286, 3, 'Безымянка', '<span style="margin: 267px 0pt 0pt 378px;">Безымянка</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 275px 0pt 0pt 356px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:267px 0pt 0pt 378px;" onmouseover="gMetro.show({metro_id});">Безымянка</span>', '#d71635'),
(288, 2, 'Адмиралтейская', '<span style="margin:415px 0pt 0pt 115px;">Адмиралтейская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin:403px 0pt 0pt 193px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:415px 0pt 0pt 115px;" onmouseover="gMetro.show({metro_id});">Адмиралтейская</span>', '#73057d'),
(289, 2, 'Бухарестская', '<span style="margin:627px 0pt 0pt 422px;">Бухарестская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin:627px 0pt 0pt 398px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:627px 0pt 0pt 422px;" onmouseover="gMetro.show({metro_id});">Бухарестская</span>', '#73057d');
INSERT INTO `{site_prefix}_maps_metro_stat` (`id`, `metro_id`, `station`, `content`, `active_content`, `color`) VALUES
(290, 2, 'Международная', '<span style="margin:663px 0pt 0pt 422px;">Международная</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin:663px 0pt 0pt 398px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:663px 0pt 0pt 422px;" onmouseover="gMetro.show({metro_id});">Международная</span>', '#73057d'),
(291, 2, 'Проспект Славы', '<span style="margin:698px 0pt 0pt 422px;">Проспект Славы</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin:698px 0pt 0pt 398px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:698px 0pt 0pt 422px;" onmouseover="gMetro.show({metro_id});">Проспект Славы</span>', '#73057d'),
(292, 2, 'Дунайская', '<span style="margin:729px 0pt 0pt 422px;">Дунайская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin:729px 0pt 0pt 398px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:729px 0pt 0pt 422px;" onmouseover="gMetro.show({metro_id});">Дунайская</span>', '#73057d'),
(293, 2, 'Шушары', '<span style="margin:761px 0pt 0pt 422px;">Шушары</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin:761px 0pt 0pt 398px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:761px 0pt 0pt 422px;" onmouseover="gMetro.show({metro_id});">Шушары</span>', '#73057d'),
(294, 1, 'Жулебино', '<span style="margin: 764px 0pt 0pt 824px;">Жулебино</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 764px 0pt 0pt 800px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:764px 0pt 0pt 824px;" onmouseover="gMetro.show({metro_id});">Жулебино</span>', '#92007b'),
(295, 1, 'Алма-Атинская', '<span style="margin: 898px 0pt 0pt 635px;">Алма-Атинская</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 896px 0pt 0pt 713px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:898px 0pt 0pt 635px;" onmouseover="gMetro.show({metro_id});">Алма-Атинская</span>', '#0a6f20'),
(296, 1, 'Битцевский парк', '<span style="margin: 851px 0pt 0pt 161px;">Битцевский парк</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 858px 0pt 0pt 244px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:851px 0pt 0pt 161px;" onmouseover="gMetro.show({metro_id});">Битцевский парк</span>', '#a2a5b4'),
(297, 1, 'Лесопарковая', '<span style="margin: 885px 0pt 0pt 248px;">Лесопарковая</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin: 874px 0pt 0pt 230px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:885px 0pt 0pt 248px;" onmouseover="gMetro.show({metro_id});">Лесопарковая</span>', '#a2a5b4'),
(298, 1, 'Пятницкое шоссе', '<span style="margin: 98px 0pt 0pt 29px; line-height:1em; ">Пятницкое<br />шоссе</span>', '<span id="anchor-{metro_id}" style="background: url(/i/metro-marker.png) repeat scroll 0% 0% transparent; margin:98px 0pt 0pt 5px; width: 20px; height: 20px;" onmouseover="gMetro.show({metro_id});"></span>\r\n<span style="margin:98px 0pt 0pt 29px; line-height:1em; " onmouseover="gMetro.show({metro_id});">Пятницкое<br />шоссе</span>', '#072889');
