<?php
if (file_exists(RP."/mod/shop/wm_config.php")) {
    $NEW = false;
    require_once(RP."/mod/shop/wm_config.php");
    if ($NEW) {
        $CONFIG = array_merge($CONFIG, $NEW);
        unset($NEW);
    }
}

if (file_exists(RP."/mod/shop/assist_config.php")) {
    $NEW = false;
    require_once(RP."/mod/shop/assist_config.php");
    if ($NEW) {
        $CONFIG = array_merge($CONFIG, $NEW);
        unset($NEW);
    }
}

if (file_exists(RP."/mod/shop/ya_money_config.php")) {
    $NEW = false;
    require_once(RP."/mod/shop/ya_money_config.php");
    if ($NEW) {
        $CONFIG = array_merge($CONFIG, $NEW);
        unset($NEW);
    }
}

if (file_exists(RP."/mod/shop/robokassa_config.php")) {
    $NEW = false;
    require_once(RP."/mod/shop/robokassa_config.php");
    if ($NEW) {
        $CONFIG = array_merge($CONFIG, $NEW);
        unset($NEW);
    }
}

if (file_exists(RP."/mod/shop/payonline_config.php")) {
    $NEW = false;
    require_once(RP."/mod/shop/payonline_config.php");
    if ($NEW) {
        $CONFIG = array_merge($CONFIG, $NEW);
        unset($NEW);
    }
}

include_once RP.'mod/catalog/lib/class.Catalog.php';

function to_str(&$value) {
  if (is_array($value) || is_object($value)) {
    return "";
  }
  $value = strval($value);
  return $value;
}

function to_int(&$value) {
  if (is_int( $value )) {
    return $value;
  }
  $internal = intval($value);
  if (strval($internal) != $value) {
    return 0;
  }
  return $internal;
}

function to_float(&$value) {
  return floatval( $value );
}

function to_bool(&$value) {
  if (is_bool( $value )) {
    return $value;
  }
  if ($value == 1) {
    return true;
  }
  return false;
}

function to_array(&$value) {
  if (is_array($value)) {
    return $value;
  }
  return array();
}

class ShopPrototype extends Module {

	var $main_title;
	var $table_prefix;
	var $addition_to_path;
	var $module_name				= 'shop';
	var $default_action				= 'show_users_discounts';
	var $admin_default_action		= 'orders';
	var $tpl_path					= 'mod/shop/tpl/';
	var $block_module_actions		= array();
	var $block_main_module_actions	= array();
	var $client_types				= array();
	var $data_charset				= 'utf-8'; // cp1251, koi8-r, iso-8859-1, utf-8
	var $allow_img_typs = array('image/gif', 'image/jpeg', 'image/png', 'image/pjpeg', 'image/x-png');

	function ShopPrototype($action = '', $transurl = '?', $properties = array(), $prefix = NULL, $rewrite_mod_params = NULL) {
		global $main, $tpl, $tpl_path, $baseurl, $cache, $lc, $CONFIG, $PAGE, $core, $server, $lang, $permissions;
		
		/* Get $action, $tpl_name, $permissions */
		extract( $this->init(array(
		        'server' => $server, 'lang' => $lang, 'prefix' => $prefix,
		        'action' => $action, 'tpl_name' => $properties['tpl']
		)), EXTR_OVERWRITE);
		
		$this->block_module_actions		= array();
		$this->block_main_module_actions= array('showcart'	=> $this->_msg["Order_and_cart"]);
		
		$this->currencies				= $CONFIG['catalog_currencies'];
		$this->client_types				= $CONFIG['siteusers_client_types'];
		
		if ('only_create_object' == $action) {
		    return;
		}
		
		if ($this->actionExists($action)) {
		    $this->doAction($action);
		    return;
		}
		
		if (! self::is_admin()) {	  
//---------------------------------- обработка действий с сайта --------------------------------//
			switch ($action) {
			    
			case 'payonlineReturn':
			    $main->include_main_blocks($this->module_name.'_'.$action.'.html', 'main');
			    $tpl->prepare();
			    break;

			case 'payonlineFail':
			    $main->include_main_blocks($this->module_name.'_'.$action.'.html', 'main');
			    $tpl->prepare();
			    if (isset($_REQUEST['ErrorCode'])) {
			        $tpl->newBlock('ErrorCode'.intval($_REQUEST['ErrorCode']));
			    }
			    break;

			case 'payonlineCallBack':
			    //$main->include_main_blocks($this->module_name.'_'.$action.'.html', 'main');
			    //$tpl->prepare();
			    //print_r($_REQUEST); echo "<hr>";
			
			    $main->include_main_blocks($this->module_name.'_payonline_mail.html', 'main');
			    $tpl->prepare();
			 
			    $request_param = '';
			    foreach ($_REQUEST as $key => $val) {
			        $request_param .= $key.': '.$val."<br>";
			    }
			
			    $block_name = 'err';
			    if ($_REQUEST['OrderId'] && $_REQUEST['SecurityKey']
			           && $_REQUEST['SecurityKey'] == md5('DateTime='.$_REQUEST['DateTime'].'&TransactionID='.$_REQUEST['TransactionID'].'&OrderId='.$_REQUEST['OrderId'].'&Amount='.$_REQUEST['Amount'].'&Currency='.$_REQUEST['Currency'].'&PrivateSecurityKey='.$CONFIG['payonline_PrivateSecurityKey'])
			    ) {
			        if ($_REQUEST['ErrorCode']) {
			            $block_name = 'fail';
			            $this->setOrderStatus($_REQUEST['OrderId'], 8, $request_param);
			        } else {
			            $block_name = 'ok';
			            $this->setOrderStatus($_REQUEST['OrderId'], 7, $request_param);
			        }
			    }
			    $tpl->newBlock($block_name);
			    $tpl->assign($_REQUEST + array('request_param' => $request_param));
			    require_once(RP.'/inc/class.Mailer.php');
			    $mail = new Mailer();
			    $mail->CharSet		= 'UTF-8';
			    $mail->ContentType	= 'text/html';
			    $mail->From			= $CONFIG['return_email'];
			    $mail->FromName		= $_SERVER['HTTP_HOST'];
			    $mail->Mailer		= 'mail';
			    $mail->Subject		= "Обработка запроса от PayOnline на сайте ".$_SERVER['HTTP_HOST'];
			    $mail->Body			= $tpl->getOutputContent();
			    $mail->to[0][0] = $CONFIG['shop_order_recipient'];
			    $mail->Send();
			    exit;
			    break;
			    
// Показать корзину
			case "showcart":
				global $request_id, $request_start, $request_parent, $lang;

				$main->include_main_blocks($this->module_name.'_cart.html', 'main');
				$tpl->prepare();
				$this->showCart();
				$this->showDeliveryList($baseurl, $_SESSION['order']['delivery_id']);
				$this->main_title = $this->_msg["Cart"];
				break;

// Добавить в корзину
			case "addtocart":
				global $request_id, $request_p, $request_qty;
				if ($this->add_to_cart($request_id, $request_qty, $request_p)) {
					$this->recalculate_cart();
					$url = $core->formPageLink($CONFIG['catalog_page_link'], $CONFIG['catalog_page_address'], $lang);
					$url .= (FALSE == strpos($url, "?") ? "?" : "&");
					if ($GLOBALS['JsHttpRequest']) {
						$GLOBALS['_RESULT'] = array(
						    'cost' => Catalog::formatPrice($_SESSION["order"]["cost"]),
						    'total' => $_SESSION["order"]["total"],
						    'currency' => $CONFIG['catalog_currencies'][$CONFIG['shop_order_concurency']]
						);
						exit;
					}
					Module::go_back();
					header('Location: http://'.$_SERVER['HTTP_HOST'].$url.'action=shwprd&id='.$request_id);
					exit;
				} else {
				    if ($GLOBALS['JsHttpRequest']) {
						$GLOBALS['_RESULT'] = false;
						exit;
					}
					$main->show_result_message($this->_msg["Selected_good_absent"]);
				}
				break;

// Пересчитать корзину
			case "recal":
				global $request_prod_id, $request_delivery;
				$this->recalculate_cart($request_prod_id, $request_delivery);
				Module::go_back();
				header('Location: '.$baseurl.'&action=showcart');
				break;

// Удалить элемент
			case "delete":
				global $request_id, $request_key, $lang;
				if ($this->delete_item_from_cart($request_id, $request_key)) {
				    $this->recalculate_cart();
				}
				header('Location: '.$baseurl);
				exit;
				break;

// Очистить корзину
			case "del_all":
				global $request_id, $request_start, $request_parent, $lang;
				if ($this->delete_item_from_cart()) {
					$this->recalculate_cart();
				}
				header('Location: '.$transurl.'&action=showcart&id='.$request_id.'&parent='.$request_parent);
				exit;
				break;

// Повторить заказ пользователя
			case "repeat":
				global $request_id, $lang;
				$result = $this->repeat_order($request_id);
				if ($result) {
					$this->recalculate_cart();
					header('Location: '.$transurl.'&action=showcart');
				} else {
					$main->show_result_message($this->_msg["Cannot_repeat_order"]);
				}
				break;

// Оформить заказ
			case "processorder":
				global $request_index, $request_id, $request_start, $request_parent, $request_step, $lang,
					   $request_customer, $request_email, $request_phone, $request_country, $request_region,
					   $request_city, $request_zip_code, $request_address, $request_payment_type, $request_organization,
					   $request_inn, $request_rs, $request_ks, $request_bank, $request_bik, $request_additional,
					   $request_prod_id, $request_delivery, $request_notify;
				
				if (isset($request_prod_id) && is_array($request_prod_id)) {
					$this->recalculate_cart($request_prod_id, $request_delivery);
				}
				if (!$request_step || $request_step == 1) {
				    
				    $main->include_main_blocks($this->module_name.'_process_order.html', 'main');
				    $tpl->prepare();
				    
					if (is_array($_SESSION['order'])) {
					    $tpl->newBlock('block_process_order');
					    if (!$_SESSION['siteuser']['is_authorized']) {
					        $tpl->newBlock('no_auth_user');
					        $tpl->assign(array(
					            'email' => $_SESSION['orderinfo']['email'] ? $_SESSION['orderinfo']['email'] : '',
					            'newuser_checked' => isset($_SESSION['orderinfo']) && !$_SESSION['orderinfo']['reguser'] ? 'checked' : '',
					            'reguser_checked' => $_SESSION['orderinfo']['reguser'] ? 'checked' : '',
					            'step_cnt' => 4,				            
					        ));
					        $tpl->gotoBlock('block_process_order');
					    }
					    $assign = array(
					        'transurl'	=> $transurl,
					        'process_order_action'	=> $transurl.'&action=processorder',
					        'customer' => $_SESSION['orderinfo']['fio'] ? $_SESSION['orderinfo']['fio'] 
					            : ($_SESSION['siteuser']['is_authorized'] ? "{$_SESSION['siteuser']['surname']} {$_SESSION['siteuser']['firstname']}" : ''),
							'phone' => $_SESSION['orderinfo']['phone'] ? $_SESSION['orderinfo']['phone'] : $_SESSION['siteuser']['phone'],
							'address' => $_SESSION['orderinfo']['address'] ? $_SESSION['orderinfo']['address'] : $_SESSION['siteuser']['address'],
							'info' => $_SESSION['orderinfo']['info'],
							'organization' => $_SESSION['orderinfo']['organization'] ? $_SESSION['orderinfo']['organization'] : $_SESSION['siteuser']['company'],							
							'inn' => $_SESSION['orderinfo']['inn'] ? $_SESSION['orderinfo']['fio'] : $_SESSION['siteuser']['inn'],
							'rs' => $_SESSION['orderinfo']['rs'] ? $_SESSION['orderinfo']['rs'] : $_SESSION['siteuser']['rs'],
							'ks' => $_SESSION['orderinfo']['ks'] ? $_SESSION['orderinfo']['ks'] : $_SESSION['siteuser']['ks'],
							'bank' => $_SESSION['orderinfo']['bank'] ? $_SESSION['orderinfo']['bank'] : $_SESSION['siteuser']['bank'],
							'bik' => $_SESSION['orderinfo']['bik'] ? $_SESSION['orderinfo']['bik'] : $_SESSION['siteuser']['bik'],
							'css_display_step0' => $_SESSION['siteuser']['is_authorized'] ? 'none' : 'auto',
							'css_display_step1' => $_SESSION['siteuser']['is_authorized'] ? 'auto' : 'none',
							'css_class_disabled_step1' => $_SESSION['siteuser']['is_authorized'] ? '' : 'disabled',
							'css_display_yur' => $_SESSIONN['orderinfo']['yur'] ? 'block' : 'none',
							'step_cnt' => 4,
							'step_12' => 2,
							'step_23' => 3,
							'step_34' => 4,
						);
						if ($_SESSION['siteuser']['is_authorized']) {
						    $assign['step_cnt'] = 3;
						    $assign['step_12'] = 1;
						    $assign['step_23'] = 2;
						    $assign['step_34'] = 3;
						}
						$tpl->assign($assign);
						if ($_SESSION['siteuser']['is_authorized']) {
							$this->main_title = $this->_msg["Process_order_for_user"] . ' '.$_SESSION['siteuser']['surname'].' '.$_SESSION['siteuser']['firstname'];
						} else {
							$this->main_title = $this->_msg["Process_order"];
						}
						if ($CONFIG['shop_pay_type_cash']) {
						    $tpl->newBlock('pay_type_cash');
						}
						if ($CONFIG['shop_pay_type_sbr']) {
						    $tpl->newBlock('pay_type_sbr');
						}
						if ($CONFIG['shop_pay_type_non_cash']) {
						    $tpl->newBlock('pay_type_non_cash');
						}
						if ($CONFIG['shop_WM_activ']) {
						    $tpl->newBlock('pay_type_wm');
    						/* Если оплата WebMoney - учитываем скидку/надбавку */
    						if ($CONFIG['shop_WM_discount']) {
    							$tpl->newBlock('block_webmoney_discount');
    							$tpl->assign('webmoney_discount', ($CONFIG['shop_WM_discount'] > 0 ? "+" : "").$CONFIG['shop_WM_discount']);
    						}
						}
						if ($CONFIG['shop_assist_activ']) {
						    $tpl->newBlock('pay_type_assist');
    						/* Если оплата ASSIST - учитываем скидку/надбавку */
    						if ($CONFIG['shop_assist_discount']) {
    							$tpl->newBlock('block_assist_discount');
    							$tpl->assign('assist_discount', ($CONFIG['shop_assist_discount'] > 0 ? "+" : "").$CONFIG['shop_assist_discount']);
    						}
						}
						
					    if ($CONFIG['shop_ya_money_activ'] && $CONFIG['ya_money_uid']) {
						    $tpl->newBlock('pay_type_ya_money');
						}
						
						if ($CONFIG['shop_robokassa_activ'] && $CONFIG['shop_robokassa_login']) {
						    $tpl->newBlock('pay_type_robokassa');
						}
						
						if ($CONFIG['shop_payonline_activ']) {
						    $tpl->newBlock('pay_type_payonline');
						}
						
						$this->showCart();
						$this->showDelivery($_SESSION['order']['delivery_id']);
					} else {
						$tpl->newBlock('block_no_order');
					}
				// Оформление заказа, шаг второй
				} else if ($request_step == 2) {
					$order_id = $this->process_order($request_customer,
													 $request_email,
													 $request_phone,
													 $request_country,
													 $request_region,
													 $request_city,
													 $request_zip_code,
													 $request_address,
													 $request_payment_type,
													 $request_organization,
													 $request_inn,
													 $request_rs,
													 $request_ks,
													 $request_bank,
													 $request_bik,
													 $request_additional,
													 $request_notify);
					if (! $_SESSION['siteuser']['is_authorized']) {
					    $user = Module::load_mod('siteusers', 'only_create_object');
					    $_REQUEST["confirm_password"] = $_REQUEST["password"];
					    $_REQUEST["siteusername"] = $_REQUEST["email"];
					    $res = $user->add_siteuser(1);
					    $user->login_siteuser($_REQUEST["email"], $_REQUEST["password"]);
					}
					$main->include_main_blocks($this->module_name.'_process_order.html', 'main');
					$tpl->prepare();
					
					if ($order_id) {
						$order = $this->getOrder($order_id);
						$tpl->newBlock('block_order');
						$tpl->assign($order);

						/* Если оплата WebMoney - учитываем скидку/надбавку */
						if (4 == $order['pay_type_id'] && $CONFIG['shop_WM_discount']) {
							$tpl->newBlock('webmoney_discount');
							$tpl->assign('webmoney_discount', ($CONFIG['shop_WM_discount'] > 0 ? "+" : "").$CONFIG['shop_WM_discount']);
						}

						/* Если оплата ASSIST - учитываем скидку/надбавку */
						if (5 == $order['pay_type_id'] && $CONFIG['shop_assist_discount']) {
							$tpl->newBlock('assist_discount');
							$tpl->assign('assist_discount', ($CONFIG['shop_assist_discount'] > 0 ? "+" : "").$CONFIG['shop_assist_discount']);
						}

						/** Способ оплаты **/
						switch ($order['pay_type_id']) {
							/** квитанция Сбербанк **/
							case 2:
								$tpl->newBlock('block_sbr');
								$compn_info = $this->getCompanyInfo();
								$compn_info['sbr_ticket_link'] = $baseurl.('&' == substr($baseurl, -1) ? '' : '&')."action=sbr_ticket&id=".$order_id;
								$compn_info['number'] = $order_id;
								$tpl->assign($compn_info);
								break;

							/** банковский перевод **/
							case 3:
								$tpl->newBlock('block_bank');
								$compn_info = $this->getCompanyInfo();
								$compn_info['number'] = $order_id;
								$tpl->assign($compn_info);
								break;

							/** Webmoney **/
							case 4:
								if (
									$order['cost'] > 0
									&& $CONFIG['shop_WM_purse']
									&& in_array($CONFIG['shop_WM_currency'], array('RUR', 'USD', 'EUR'))
									&& $CONFIG['shop_WM_activ']
								) {
									/* Сумма заказа в валюте кошелька webmoney*/
									$wm_amount = ShopPrototype::exchange($order['cost'], $order['currency_id'], $CONFIG['shop_WM_currency']);
									$wm_amount = number_format($wm_amount, "2", ".", "");
									$tpl->newBlock('block_webmoney');
									$tpl->assign(
										array(
											'wm_amount'	=> $wm_amount,
											'wm_payment_no'	=> $order['order_id'],
											'wm_payee_purse'	=> $CONFIG['shop_WM_purse'] ,
											'order_sum' => $order['cost'],
											'wm_success_url'	=> $CONFIG['shop_WM_success_url'],
                            				'wm_fail_url'		=> $CONFIG['shop_WM_fail_url'],
                            				'wm_result_url'		=> "http://".$_SERVER['HTTP_HOST'].$CONFIG['shop_WM_result_url'],
										)
									);
								}
								break;

							/** ASSIST **/
							case 5:
								if (
									$order['cost'] > 0
									&& $CONFIG['shop_assist_idp']
									&& in_array($CONFIG['shop_assist_currency'], array('RUR', 'USD', 'EUR'))
									&& $CONFIG['shop_assist_activ']
								) {
									/* Сумма заказа в валюте ASSIST */
									$assist_amount = ShopPrototype::exchange($order['cost'], $order['currency_id'], $CONFIG['shop_assist_currency']);
									number_format($wm_amount, "2", ".", "");
									$tpl->newBlock('block_assist');
									$tpl->assign(
										array(
											'assist_amount'			=> $assist_amount,
											'assist_order_id'		=> $order['order_id'],
											'assist_shop_id'		=> $CONFIG['shop_assist_idp'],
											'assist_currency'		=> $CONFIG['shop_assist_currency'],
											'assist_success_url'	=> "http://".$_SERVER['HTTP_HOST'].$CONFIG['shop_assist_result_url'],
											'assist_fail_url'		=> $CONFIG['shop_assist_fail_url'],
											'order_sum'				=> $order['cost'],
										)
									);
								}
								break;

							/** ya_money **/
							case 6:
								if (
									$order['cost'] > 0
									&& $CONFIG['ya_money_uid']
								) {
									/* Сумма заказа в валюте рублях */
									$amount = self::exchange($order['cost'], $order['currency_id'], 'RUR');
									$amount = abo_float($amount);
									$tpl->newBlock('block_ya_money');
									$tpl->assign(array(
										'amount'	=> $amount,
										'order_id'	=> $order['order_id'],
										'ya_money_uid'	=> $CONFIG['ya_money_uid'] ,
										'order_sum' => $order['cost'],
										'host' => $_SERVER['HTTP_HOST'],
										'order_title' => urlencode("Заказ №{$order['order_id']}, на сайте {$_SERVER['HTTP_HOST']}")
									));
								}
								break;
								
							/** ROBOKASSA **/
    			            case 8:
    			                if (
    			                $order['cost'] > 0
    			                && $CONFIG['shop_robokassa_login']
    			                && $CONFIG['shop_robokassa_activ']
    			                ) {
    			                    /* Сумма заказа в валюте ROBOKASSA */
    			                    $robokassa_amount = ShopPrototype::exchange($order['cost_noformat'], $order['currency_id'], $CONFIG['shop_robokassa_currency']);
    			                    $robokassa_amount = number_format($robokassa_amount, "2", ".", "");
    			                    $tpl->newBlock('block_robokassa');
    			                    $tpl->newBlock($CONFIG['shop_robokassa_test_mode'] ? 'block_robokassa_test_mod' : 'block_robokassa_real_mod');
    			                    $tpl->assign(array(
    			                        'robokassa_amount'			=> $robokassa_amount,
    			                        'order_id'		=> $order['order_id'],
    			                        'robokassa_login'		=> $CONFIG['shop_robokassa_login'],
    			                        'robokassa_currency'		=> $CONFIG['shop_robokassa_currency'],			                        
    			                        'order_sum'				=> $order['cost'],
    			                        'form_script' => $this->getRobakassaForm($robokassa_amount, $order['order_id']),
    			                        'signature' => $this->getRobokassaSignature($robokassa_amount, $order['order_id']),
    			                        'robokassa_url' => $CONFIG['shop_robokassa_test_mode']
    			                            ? $CONFIG['shop_robokassa_test_url']
    			                            : $CONFIG['shop_robokassa_real_url'] 
    			                    ));
    			                }
    			                break;
								
							/** PayOnline **/
    			            case 9:
    			                if (
    			                $order['cost'] > 0
    			                && $CONFIG['shop_payonline_activ']
    			                && $CONFIG['payonline_MerchantId']
    			                ) {
    			                    /* Сумма заказа в валюте PayOnline */
    			                    $amount = self::exchange($order['cost'], $order['currency_id'], 'RUR');
									$amount = number_format($amount, 2, '.', '');
									$tpl->newBlock('block_payonline');
									//$order_desc = urlencode("Заказ {$order['order_id']}, на сайте {$_SERVER['HTTP_HOST']}");
									$order_desc = "Заказ номер {$order['order_id']}";
									$shop_link = 'http://'.$_SERVER['HTTP_HOST'].$core->formPageLink($CONFIG["shop_page_link"], $CONFIG["shop_page_address"], $lang, 1).'action=';
									$tpl->assign(array(
										'amount'	=> $amount,
										'order_id'	=> $order['order_id'],
									    'redirect' => $CONFIG['payonline_redirect'],
										'MerchantId'	=> $CONFIG['payonline_MerchantId'] ,
										'order_sum' => $order['cost'],
										'host' => $_SERVER['HTTP_HOST'],
										'order_title' => $order_desc,
										'SecurityKey' => md5('MerchantId='.$CONFIG['payonline_MerchantId'].'&OrderId='.$order['order_id'].'&Amount='.$amount.'&Currency=RUB&OrderDescription='.$order_desc.'&PrivateSecurityKey='.$CONFIG['payonline_PrivateSecurityKey']),
									    'ReturnUrl' => $shop_link.'payonlineReturn',
									    'FailUrl' => $shop_link.'payonlineFail'
									));
    			                }
    			                break;
						}

						if ($_SESSION['siteuser']['is_authorized']) {
							$tpl->newBlock('block_is_auth');
							$link = Core::formPageLink($CONFIG['shop_page_link'], $CONFIG['shop_page_address'], $lang, 1);
							$link .= ('&' == substr($link, -1) ? '' : '&'). "action=orders";
							$tpl->assign('history_link', $link);
						}
						if ($order['delivery_cost']>0) {
						    $dlvr = $this->getDelivery($order['delivery_id']);
						    $tpl->newBlock('block_order_delivery');
						    $tpl->assign(array(
						        'delivery_cost' => $order['delivery_cost'],
						        'currency' => $CONFIG['catalog_currencies'][$CONFIG['shop_order_concurency']],
						        'title' => $dlvr['title'],
						        'dscr' => $dlvr['dscr'],
						    ));
						}
					} else {
						$tpl->newBlock('block_order_error');
					}

					$this->main_title = $this->_msg['Set_order'];
				}
				$this->addition_to_path = $this->_msg['Set_order'];
				break;

// Список заказов авторизованного пользователя
			case "orders":
				global $request_start, $lang;
				if ($_SESSION['siteuser']['id']) {
					$main->include_main_blocks($this->module_name.'_orders.html', 'main');
					$tpl->prepare();
					$start = ($request_start) ? $request_start : 1;
					$orders = $this->getAllOrders($_SESSION['siteuser']['id']);
					$tpl->assign_array('block_order', $orders);
				} else {
					$main->show_result_message($this->_msg["Info_orders_history"]);
				}
				$this->main_title = $this->_msg["Orders_history"];
				break;

// Показать информацию о заказе для авторизованного пользователя
			case 'vieworder':
				global $request_id, $request_start, $request_order_id, $lang;
				$order = $this->getOrder($request_id);
				if ($order && ( $_SESSION['siteuser']['is_authorized'] || session_id() == $order['session'] )) {
					$main->include_main_blocks($this->module_name.'_order.html', 'main');
					$tpl->prepare();
					$this->show_order($transurl, $request_id);
					//$tpl->assign('repeat_order', $baseurl.'&action=repeat&id='.$request_id);
					//$tpl->assign_array('block_item', $this->\derItems($request_id));
					//$this->main_title = 'История заказов';
				} else {
					$register_page	= $core->formPageLink($CONFIG['register_page_link'], $CONFIG['register_page_address'], $lang);
					header('Location: '.$register_page.'?action=loginform');
				}
				break;

// Квитанция для Сбербанка
			case 'sbr_ticket':
				global $request_id;
				$main->include_main_blocks($this->module_name.'_sbr_ticket.html', 'main');
				$tpl->prepare();
				$order = $this->getOrder($request_id);
				if ($order && ( $_SESSION['siteuser']['is_authorized'] || session_id() == $order['session'] )) {
					$tpl->newBlock('block_sbr');
					$tpl->assign(array_merge($this->getCompanyInfo(), $order));
				} else {
					$tpl->newBlock('block_no_access');
				}
				break;

// Квитанция для Сбербанка
			case 'ordering':
				global $request_id;
				$main->include_main_blocks($this->module_name.'_ordering.html', 'main');
				$tpl->prepare();
				$order = $this->getOrder($request_id);
				if ($_SESSION['siteuser']['is_authorized'] && $order) {
					$tpl->newBlock('block_ordering');
					$tpl->assign(array_merge($this->getCompanyInfo(), $order));
				} else {
					$tpl->newBlock('block_no_access');
				}
				break;
				
			case "login":
				if ($GLOBALS['JsHttpRequest']) {
				    $user = Module::load_mod('siteusers', 'only_create_object');
				    $res = $user->login_siteuser($_REQUEST['email'], $_REQUEST['pass']);
					$GLOBALS['_RESULT'] = true === $res 
					? array(
					   'id' => $_SESSION["siteuser"]["id"],
					   'siteusername' => $_SESSION["siteuser"]["siteusername"],
					   'email' => $_SESSION["siteuser"]["email"],
					) 
					: false;
				}
				exit;
				
			case "robokassa_result":
			    $sum = $_REQUEST["OutSum"];
			    $order_id = $_REQUEST["InvId"];
			    if ($this->isValidRobokassaResultSignature($_REQUEST["SignatureValue"], $_REQUEST["OutSum"], $order_id)) {
			        $err = !$this->setOrderStatus($order_id, $CONFIG['shop_robokass_paid_state']);
				} else {
				    $err = true;
				}
				
			    $tpl = new AboTemplate(RP.'tpl/'.SITE_PREFIX.'/'.$this->module_name.'_'.$action.'_mail.html');
			    $tpl->prepare();
			    $tpl->newBlock($err ? 'err' : 'ok');
			    $tpl->assign(array(
			        'date' => date('Y-m-d H:i'),
			        'order_id' => $order['order_id'],
			        'robokassa_sum' => $sum,
			        'robokassa_order_id' => $order_id,
			        'signature' => $_REQUEST["SignatureValue"],
			        'site_name' => $CONFIG['sitename_rus'],
			        'status_name' => $order['order_status'],
			        'host' => $CONFIG['host'],
			    ));
				
				$subject = "Результат обработки заказа №{$order_id}, сервисом ROBOKASSA, на сайте {$CONFIG['sitename_rus']}";
			    require_once(RP.'/inc/class.Mailer.php');
				$mail = new Mailer();
				$mail->CharSet		= $CONFIG['email_charset'];
				$mail->ContentType	= "text/html"; //$CONFIG['email_type'];
				$mail->From			= $CONFIG['shop_order_recipient'];
				$mail->Mailer		= 'mail';
				$mail->AddAddress($CONFIG['shop_order_recipient']);
				$mail->Subject		= $subject;
				$mail->Body			= $tpl->getOutputContent();
				$mail->Send();
				exit;
				break;
				
				
			case "robokassa_success":
			case "robokassa_fail":
			    $main->include_main_blocks($this->module_name.'_'.$action.'.html', 'main');
			    $tpl->prepare();
			    $sum = $_REQUEST["OutSum"];
			    $order_id = $_REQUEST["InvId"];
			    $tpl->assign(array(
			        'date' => date('Y-m-d H:i'),
			        'robokassa_sum' => $sum,
			        'robokassa_order_id' => $order_id,
			    ));
			    break;


// Default...
			default:
				if (is_object($tpl)) $tpl->prepare();
				return;
			}
//------------------------------- конец обработки действий с сайта -----------------------------//
		} else {
//------------------------------ обработка действий из админ части -----------------------------//            
			if (!isset($tpl)) {
			    $main->message_die('Не подключен класс для работы с шаблонами');
			}

			switch ($action) {

			  // Накопительные скидки.
				case 'show_users_discounts':
					if (!$permissions['e'])
					{
						$main->message_access_denied($siteusers->module_name, $action);
					}

					$main->include_main_blocks_2($this->module_name."_show_users_discounts.html", $this->tpl_path);
					$tpl->prepare();

					$tpl->assign(array(
						'_ROOT.lang' => $lang,
						'_ROOT.name' => $this->module_name,
					));

					$tpl->newBlock('block_shop_discounts');
					$tpl->assign(Array(
						"MSG_Enter_discount_name" => 'Введите наименование скидки!',
						"MSG_Enter_discount_criterion" => 'Введите критерий скидки!',
						"MSG_Activ" => 'Публ.',
						"MSG_Ed" => 'Ред.',
						"MSG_Groups" => 'Групп.',
						"MSG_Discount" => 'Скидка',
						"MSG_From" => 'От',
						"MSG_To" => 'До',
						"MSG_DiscountValue" => 'Величина',
						"MSG_Type" => 'Тип',
						"MSG_Del" => 'Удл.',
						"MSG_Period" => 'Период (мес.)',
						"add_link" => $baseurl.'&action=edit_discount&discount_id=0'
					));

					$raw_rows = to_array($this->GetUsersDiscounts(false));

					// Преобразуем значения.
					$rows = array();
					foreach ($raw_rows as $row)
					{
						$row['is_percent'] = to_int($row['is_percent']) ? '%' : 'абс.';
						$row['img_stat'] = to_int($row['active']) ? 'ico_swof.gif' : 'ico_swon.gif';
						$row['act_stat'] = to_int($row['active']) ? 'Оключить публикацию' : 'Включить публикацию';
						$row['set_activity_link'] = $baseurl.'&action=update_discount_activity&discount_id='.to_int($row['id']).'&set_active='.(to_int($row['active']) ? '0' : '1');
						$row['edit_users_groups_hint'] = 'Группы пользователей';
						$row['show_groups_link'] = $baseurl.'&action=show_users_groups&discount_id='.to_int($row['id']);
						$row['edit_discount_link'] = $baseurl.'&action=edit_discount&discount_id='.to_int($row['id']);
						$row['delete_discount_link'] = $baseurl.'&action=delete_discount&discount_id='.to_int($row['id']);

						$rows[] = $row;
					}

					reset($rows);
					foreach ($rows as $row)
					{
						$tpl->newBlock("block_discounts_list");
						$tpl->assign(Array(
							"MSG_Edit" => 'Редактировать',
							"MSG_Confirm_delete" => 'Вы действительно хотите удалить?',
							"MSG_Delete" => 'Удалить',
						));

						//print_r($row);
						$tpl->assign($row);
					}

					$this->main_title = 'Накопительные скидки';
					break;

				case 'show_users_groups':
					if (!$permissions['e'])
					{
						$main->message_access_denied($siteusers->module_name, $action);
					}

					global $request_discount_id;

					$request_discount_id = to_int($request_discount_id);
					$discount_row = $this->GetUsersDiscounts($request_discount_id);
					$discount_row = to_array($discount_row[0]);

					$main->include_main_blocks_2($this->module_name."_show_users_groups.html", $this->tpl_path);
					$tpl->prepare();

					$this->main_title = 'Группы, на которые распространяется скидка &laquo;'.
					htmlspecialchars(to_str($discount_row['name'])).'&raquo;';

					$tpl->newBlock('block_users_groups');
					$tpl->assign(array(
						'discount_id' => $request_discount_id,
						'form_action' => $baseurl.'&action=update_users_groups'
						)
					);

					$raw_rows = $this->GetGroupsWithDiscounts($request_discount_id);

					// Преобразуем значения.
					$rows = array();
					foreach ($raw_rows as $row)
					{
						$row['group_id'] = to_int($row['id']);
						$row['selected'] = to_int($row['users_discound_id']) ? 'checked' : '';
						$rows[] = $row;
					}

					//print_r($rows);

					reset($rows);
					foreach ($rows as $row)
					{
						$tpl->newBlock("block_group_list");
						$tpl->assign($row);
					}
					//print_r($raw_rows);

					break;

				case 'update_users_groups':
					global $request_discount_id;

					$request_discount_id = to_int($request_discount_id);

					// Очистим связь с группами данной скидки.
					$this->ClearGroupsOfDiscount($request_discount_id);

					// Список групп.
					$rows = $this->GetGroupsWithDiscounts($request_discount_id);
					$rows = to_array($rows);

					foreach ($rows as $row)
					{
						if (isset($_REQUEST['discount_group_'.to_int($row['id'])]))
						{
							$this->InsertDiscountForGroup($request_discount_id, to_int($row['id']));
						}
					}

					header('Location: '.$baseurl.'&action=show_users_discounts');
					break;

				case 'edit_discount':
					global $request_discount_id;

					$request_discount_id = to_int($request_discount_id);

					if ($request_discount_id)
					{
						// Редактирование скидки.
						$this->main_title = 'Редактирование скидки';
					}
					else
					{
						// Создание новой скидки.
						$this->main_title = 'Создание новой скидки';
					}

					$discount_row = $this->GetUsersDiscounts($request_discount_id);
					$discount_row = to_array($discount_row[0]);

					if (count($discount_row) > 0)
					{
						$discount_row['is_percent'] = to_int($discount_row['is_percent']) ? 'checked' : '';
					}

					$main->include_main_blocks_2($this->module_name."_edit_users_discount.html", $this->tpl_path);
					$tpl->prepare();

					$tpl->newBlock('block_edit_discount');
					$tpl->assign(array(
						'discount_id' => $request_discount_id,
						'form_action' => $baseurl.'&action=update_discount',
						'cancel_link' => $baseurl.'&action=show_users_discounts',
						)
					);

					$tpl->assign($discount_row);
					break;

				case 'update_discount':
					global $request_discount_id, $request_discount_name, $request_discount_min,
					$request_discount_max, $request_discount_interval, $request_discount_value;

					$request_discount_id = to_int($request_discount_id);
					$params = array();
					$params['id'] = $request_discount_id;
					$params['name'] = to_str($request_discount_name);
					$params['min'] = to_float($request_discount_min);
					$params['max'] = to_float($request_discount_max);
					$params['value'] = to_float($request_discount_value);
					$params['interval'] = to_int($request_discount_interval);
					$params['is_percent'] = isset($_REQUEST['discount_is_percent']) ? 1 : 0;

					$this->InsertDiscount($params);
					header('Location: '.$baseurl.'&action=show_users_discounts');
					break;

				case 'update_discount_activity':
					global $request_discount_id, $request_set_active;

					$request_discount_id = to_int($request_discount_id);
					$request_set_active = to_int($request_set_active);
					if ($request_discount_id)
					{
						$params = array();
						$params['id'] = $request_discount_id;
						$params['active'] = $request_set_active;
						$this->InsertDiscount($params);
					}

					header('Location: '.$baseurl.'&action=show_users_discounts');
					break;

				case 'delete_discount':
					global $request_discount_id;

					$request_discount_id = to_int($request_discount_id);
					if ($request_discount_id)
					{
						$this->DeleteDiscount($request_discount_id);
					}

					header('Location: '.$baseurl.'&action=show_users_discounts');
					break;

				case 'show_stat':
					global $request_period, $request_group;

					$request_period = to_int($request_period);
					$main->include_main_blocks_2($this->module_name."_show_stat.html", $this->tpl_path);
					$tpl->prepare();
					$tpl->assign('lang', $lang);
					/*
					$tpl->newBlock('block_sales_graph');

					$block_params = array(
					    'MSG_Users_group' => $this->_msg['Users_group'],
					    'MSG_All_groups' => $this->_msg['All_groups'],
					    'MSG_Period' => $this->_msg['Period'],
					    'MSG_From2' => $this->_msg['From2'],
					    'MSG_To2' => $this->_msg['To2'],
					    'MSG_Show' => $this->_msg['Show'],
					    'MSG_All' => $this->_msg['All'],
					    'MSG_No_auth_user' => $this->_msg['No_auth_user'],
					    'graph_path' => '/mod/shop/stat_graph.php?lang='.$lang
					);

					$tpl->assign($block_params);
					
					$mod_user = Module::load_mod('siteusers', 'only_create_object');
					if ($mod_user) {
					    $mod_user->show_groups('block_groups');
					}
					*/
					$this->main_title = $this->_msg['stat'];
					break;

				case 'statparam':
				    echo $this->getStatParamXml();
					exit;

				case 'statdata':
				    if ( (! isset($_REQUEST['from']) && !isset($_REQUEST['to'])) 
				        || (!$_REQUEST['from'] && !$_REQUEST['to']) 
				    ) {
                        $period = array(
                            'from' => date('d.m.Y', time()-(30*24*3600)),
                            'to' => date('d.m.Y')
                        );
                    } else {
                        $period = array(
                            'from' => $_REQUEST['from'],
                            'to' => $_REQUEST['to']
                        );
                    }
				    $ret = $this->GetOrderStat(
				        $period, 
				        isset($_REQUEST['usertype']) ? $_REQUEST['usertype'] : -1, 
				        isset($_REQUEST['status']) ? $_REQUEST['status'] : -1, 
				        isset($_REQUEST['manager']) ? $_REQUEST['manager'] : -1);
				    echo "<result>\n";
				    if ($ret) {
				        foreach ($ret as $val) {
				        	echo "<data><date>{$val['date']}</date><cnt>{$val['cnt']}</cnt><sum>{$val['sum']}</sum><cur>{$CONFIG['catalog_currencies'][$CONFIG['shop_order_concurency']]}</cur></data>\n";
				        }
				    }
				    echo "</result>\n";
					exit;
					
		    case 'prp':
		    	if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $request_step;
				$main->include_main_blocks('_properties.html', $this->tpl_path);
				$tpl->prepare();
				$tpl->assign(Array(
					"MSG_Information"	=> $main->_msg["Information"],
					"MSG_Value"			=> $main->_msg["Value"],
					"MSG_Save"			=> $main->_msg["Save"],
					"MSG_Cancel"		=> $main->_msg["Cancel"],
				));
		        if (!$request_step || $request_step == 1) {
					$tpl->assign(array('form_action'	=> $baseurl,
									   'step'			=> 2,
									   'lang'			=> $lang,
									   'name'			=> $this->module_name,
									   'action'			=> 'prp'));
					$prp_html = $main->getModuleProperties($this->module_name);
		            $this->main_title = $this->_msg["Controls"];
				} elseif (2 == $request_step) {
		        	$main->setModuleProperties($this->module_name, $_POST);
					header('Location: '.$baseurl.'&action=prp&step=1');
				}
		    	break;

			case 'block_prp':
				global $request_sub_action, $request_block_id;
		    	$arr  = $this->getEditLink($request_sub_action, $request_block_id);
		    	$cont = 'var container = document.getElementById(\'target_span\');
		    		  	 container.innerHTML = "'.$this->getPropertyFields().'";
		    		  	 material_id		  = "'.$arr['material_id'].'";
		    		  	 material_url		  = "'.$arr['material_url'].'";
		    		  	 changeAction();
		    	      	 setURL("property1");';
				header('Content-Length: '.strlen($cont));
		    	echo $cont;
		    	exit;
		    	break;

			case 'dsnt':
				if (!$permissions['e']) $main->message_access_denied($siteusers->module_name, $action);
				global $request_step, $request_start, $request_discount, $request_min, $request_max,
				    $request_discount_value, $request_is_percent, $request_id, $request_from_date, $request_to_date;
				$main->include_main_blocks_2($this->module_name."_discounts.html", $this->tpl_path);
				$tpl->prepare();
				if (!@$request_step || $request_step == 1) {
                    $tpl->newBlock('block_shop_discounts');
					$tpl->assign(Array(
						"MSG_Enter_discount_name" => $this->_msg["Enter_discount_name"],
						"MSG_Enter_discount_criterion" => $this->_msg["Enter_discount_criterion"],
						"MSG_Activ" => $this->_msg["Activ"],
						"MSG_Ed" => $this->_msg["Ed"],
						"MSG_Discount" => $this->_msg["Discount"],
						"MSG_From" => $this->_msg["From"],
						"MSG_To" => $this->_msg["To"],
						"MSG_Magnitude" => $this->_msg["Magnitude"],
						"MSG_Type" => $this->_msg["Type"],
						"MSG_Del" => $this->_msg["Del"],
						"MSG_From2" => $this->_msg["From2"],
						"MSG_To2" => $this->_msg["To2"],
					));
                    $discounts = $this->getDiscountsAdm($baseurl, $request_start);
                    $discounts = is_array($discounts) ? $discounts :array ();
					foreach($discounts as $k => $v)
					{
						$tpl->newBlock("block_discounts_list");
						$tpl->assign(Array(
							"MSG_Edit" => $this->_msg["Edit"],
							"MSG_Confirm_delete" => $this->_msg["Confirm_delete"],
							"MSG_Delete" => $this->_msg["Delete"],
						));
						$tpl->assign($v);
					}
                    $tpl->newBlock('block_shop_discount_add');
					$tpl->assign(Array(
						"MSG_Sum" => $this->_msg["Sum"],
						"MSG_Discount" => $this->_msg["Discount"],
						"MSG_From" => $this->_msg["From"],
						"MSG_To" => $this->_msg["To"],
						"MSG_Magnitude" => $this->_msg["Magnitude"],
						"MSG_Info_from_to" => $this->_msg["Info_from_to"],
						"MSG_see" => $this->_msg["see"],
						"MSG_module_controls" => $this->_msg["module_controls"],
						"MSG_Period" => $this->_msg["Period"],
						"MSG_From2" => $this->_msg["From2"],
						"MSG_To2" => $this->_msg["To2"],
					));
                    $tpl->assign(array(
                                        'action_title'	=> $this->_msg["Add_discount"],
                                        'action_text'	=> $this->_msg["Add"],
                    					'action_url'	=> $baseurl,
                                        'name'			=> 'shop',
                    					'action'		=> 'dsnt',
                    					'step'			=> '2',
                    					));
                    $main->_show_nav_string($server.$lang.'_shop_discounts', '', '', 'action='.$action, $request_start, $CONFIG['shop_max_rows'], $CONFIG['shop_order_by'], '');
					$tpl->assign(Array(
						"MSG_Pages" => $this->_msg["Pages"],
					));
				} elseif ($request_step == 2) {
					$this->addDiscounts($request_discount, $request_min, $request_max, $request_discount_value, $request_is_percent, $request_from_date, $request_to_date);
                	header('Location: '.$baseurl.'&action=dsnt&step=1');
				} elseif ($request_step == 3) {
                    $tpl->newBlock('block_shop_discounts');
					$tpl->assign(Array(
						"MSG_Enter_discount_name" => $this->_msg["Enter_discount_name"],
						"MSG_Enter_discount_criterion" => $this->_msg["Enter_discount_criterion"],
						"MSG_Activ" => $this->_msg["Activ"],
						"MSG_Ed" => $this->_msg["Ed"],
						"MSG_Discount" => $this->_msg["Discount"],
						"MSG_From" => $this->_msg["From"],
						"MSG_To" => $this->_msg["To"],
						"MSG_Magnitude" => $this->_msg["Magnitude"],
						"MSG_Type" => $this->_msg["Type"],
						"MSG_Del" => $this->_msg["Del"],
						"MSG_Period" => $this->_msg["Period"],
						"MSG_From2" => $this->_msg["From2"],
						"MSG_To2" => $this->_msg["To2"],
					));
                    $discounts = $this->getDiscountsAdm($baseurl, $request_start);
					foreach($discounts as $k => $v)
					{
						$tpl->newBlock("block_discounts_list");
						$tpl->assign(Array(
							"MSG_Edit" => $this->_msg["Edit"],
							"MSG_Confirm_delete" => $this->_msg["Confirm_delete"],
							"MSG_Delete" => $this->_msg["Delete"],
						));
						$tpl->assign($v);
					}
                    $tpl->newBlock('block_shop_discount_add');
					$tpl->assign(Array(
						"MSG_Sum" => $this->_msg["Sum"],
						"MSG_Discount" => $this->_msg["Discount"],
						"MSG_From" => $this->_msg["From"],
						"MSG_To" => $this->_msg["To"],
						"MSG_Magnitude" => $this->_msg["Magnitude"],
						"MSG_Info_from_to" => $this->_msg["Info_from_to"],
						"MSG_see" => $this->_msg["see"],
						"MSG_module_controls" => $this->_msg["module_controls"],
						"MSG_Period" => $this->_msg["Period"],
						"MSG_From2" => $this->_msg["From2"],
						"MSG_To2" => $this->_msg["To2"],
					));
                    $tpl->assign(array(
                                        'action_title'	=> 'Изменить скидку',
                                        'action_text'	=> 'Изменить',
                    					'action_url'	=> $baseurl,
                                        'name'			=> 'shop',
                    					'action'		=> 'dsnt',
                    					'step'			=> '4',
                    					));
                    $tpl->assign($this->getDiscount($request_id));
                    $main->_show_nav_string($server.$lang.'_shop_discounts', '', '', 'action='.$action, $request_start, $CONFIG['shop_max_rows'], $CONFIG['shop_order_by'], '');
				} elseif ($request_step == 4) {
                    if (!$request_start) $request_start = 1;
					$this->updateDiscount($request_id, $request_discount, $request_min, $request_max, $request_discount_value, $request_is_percent, $request_from_date, $request_to_date);
                	header('Location: '.$baseurl.'&action=dsnt&step=1&start='.$request_start);
				}
                $this->main_title = $this->_msg["Sum_discounts"];
				break;

// Включение скидки
			case 'dsnt_a':
                if (!$permissions['e']) $main->message_access_denied($siteusers->module_name, $action);
				global $request_start, $request_id;
                if (!$request_start) $request_start = 1;
                $this->setDiscountActive($request_id);
				header('Location: '.$baseurl.'&action=dsnt&step=1&start='.$request_start);
				break;

// Отключение скидки
			case 'dsnt_d':
                if (!$permissions['e']) $main->message_access_denied($siteusers->module_name, $action);
				global $request_start, $request_id;
                if (!$request_start) $request_start = 1;
                $this->setDiscountUnActive($request_id);
				header('Location: '.$baseurl.'&action=dsnt&step=1&start='.$request_start);
				break;

// Удаление скидки
			case 'dsnt_del':
                if (!$permissions['d']) $main->message_access_denied($siteusers->module_name, $action);
				global $request_id;
                $this->delDiscount($request_id);
				header('Location: '.$baseurl.'&action=dsnt&step=1');
				break;

// Список налогов
			case 'taxes':
				if (!$permissions['e']) $main->message_access_denied($siteusers->module_name, $action);
				global $request_step, $request_start, $request_tax, $request_percent, $request_rank, $request_id;
				$main->include_main_blocks_2($this->module_name."_taxes.html", $this->tpl_path);
				$tpl->prepare();
				if (!@$request_step || $request_step == 1) {
                    $tpl->newBlock('block_shop_taxes');
					$tpl->assign(Array(
						"MSG_Enter_tax_name" => $this->_msg["Enter_tax_name"],
						"MSG_Enter_tax_value" => $this->_msg["Enter_tax_value"],
						"MSG_Enter_tax_rank" => $this->_msg["Enter_tax_rank"],
						"MSG_Activ" => $this->_msg["Activ"],
						"MSG_Ed" => $this->_msg["Ed"],
						"MSG_Tax" => $this->_msg["Tax"],
						"MSG_Magnitude" => $this->_msg["Magnitude"],
						"MSG_Rank" => $this->_msg["Rank"],
						"MSG_Del" => $this->_msg["Del"],
					));
                    $taxes = $this->getTaxesAdm($baseurl, $request_start);
                    if(!is_array($taxes)){$taxes=array();}
					foreach($taxes as $k => $v)
					{
						$tpl->newBlock("block_tax_list");
						$tpl->assign(Array(
							"MSG_Edit" => $this->_msg["Edit"],
							"MSG_Confirm_delete" => $this->_msg["Confirm_delete"],
							"MSG_Delete" => $this->_msg["Delete"],
						));
						$tpl->assign($v);
					}
                    $tpl->newBlock('block_shop_tax_add');
					$tpl->assign(Array(
						"MSG_Name" => $this->_msg["Name"],
						"MSG_Rank" => $this->_msg["Rank"],
						"MSG_Create" => $this->_msg["Create"],
					));
                    $tpl->assign(array(
                                        'action_title'	=> $this->_msg["Add_tax"],
                                        'action_text'	=> $this->_msg["Add"],
                    					'action_url'	=> $baseurl,
                                        'name'			=> 'shop',
                    					'action'		=> 'taxes',
                    					'step'			=> '2',
                    					));
                    $main->_show_nav_string($server.$lang.'_shop_taxes', '', '', 'action='.$action, $request_start, $CONFIG['shop_max_rows'], $CONFIG['shop_order_by'], '');
					$tpl->assign(Array(
						"MSG_Pages" => $this->_msg["Pages"],
					));
				} elseif ($request_step == 2) {
					$this->addTax($request_tax, $request_percent, $request_rank);
                	header('Location: '.$baseurl.'&action=taxes&step=1');
				} elseif ($request_step == 3) {
                    $tpl->newBlock('block_shop_taxes');
					$tpl->assign(Array(
						"MSG_Enter_tax_name" => $this->_msg["Enter_tax_name"],
						"MSG_Enter_tax_value" => $this->_msg["Enter_tax_value"],
						"MSG_Enter_tax_rank" => $this->_msg["Enter_tax_rank"],
						"MSG_Activ" => $this->_msg["Activ"],
						"MSG_Ed" => $this->_msg["Ed"],
						"MSG_Tax" => $this->_msg["Tax"],
						"MSG_Magnitude" => $this->_msg["Magnitude"],
						"MSG_Rank" => $this->_msg["Rank"],
						"MSG_Del" => $this->_msg["Del"],
					));
                    $taxes = $this->getTaxesAdm($baseurl, $request_start);
					foreach($taxes as $k => $v)
					{
						$tpl->newBlock("block_tax_list");
						$tpl->assign(Array(
							"MSG_Edit" => $this->_msg["Edit"],
							"MSG_Confirm_delete" => $this->_msg["Confirm_delete"],
							"MSG_Delete" => $this->_msg["Delete"],
						));
						$tpl->assign($v);
					}
                    $tpl->newBlock('block_shop_tax_add');
					$tpl->assign(Array(
						"MSG_Name" => $this->_msg["Name"],
						"MSG_Rank" => $this->_msg["Rank"],
						"MSG_Create" => $this->_msg["Create"],
					));
//					$arr = $this->getTax($request_id);
                    $tpl->assign(array(
                                        'action_title'	=> $this->_msg["Change_tax"],
                                        'action_text'	=> $this->_msg["Change"],
                    					'action_url'	=> $baseurl,
                                        'name'			=> 'shop',
                    					'action'		=> 'taxes',
                    					'step'			=> '4',
                    					));
					$tpl->assign($this->getTax($request_id));
                    $main->_show_nav_string($server.$lang.'_shop_taxes', '', '', 'action='.$action, $request_start, $CONFIG['shop_max_rows'], $CONFIG['shop_order_by'], '');
				} elseif ($request_step == 4) {
                    if (!$request_start) $request_start = 1;
					$this->updateTax($request_id, $request_tax, $request_percent, $request_rank);
                	header('Location: '.$baseurl.'&action=taxes&step=1&start='.$request_start);
				}
                $this->main_title = $this->_msg["Taxes"];
				break;

// Включение налога
			case 'taxes_act':
                if (!$permissions['e']) $main->message_access_denied($siteusers->module_name, $action);
				global $request_start, $request_id;
                if (!$request_start) $request_start = 1;
                $this->setTaxActive($request_id);
				header('Location: '.$baseurl.'&action=taxes&step=1&start='.$request_start);
				break;

// Отключение налога
			case 'taxes_deac':
                if (!$permissions['e']) $main->message_access_denied($siteusers->module_name, $action);
				global $request_start, $request_id;
                if (!$request_start) $request_start = 1;
                $this->setTaxUnActive($request_id);
				header('Location: '.$baseurl.'&action=taxes&step=1&start='.$request_start);
				break;

// Удаление налога
			case 'taxes_del':
                if (!$permissions['d']) $main->message_access_denied($siteusers->module_name, $action);
				global $request_id;
                $this->delTax($request_id);
				header('Location: '.$baseurl.'&action=taxes&step=1');
				break;

// Список заказов
			case "orders":
				if (!$permissions["r"]) $main->message_access_denied($this->module_name, $action);
				global $request_start, $request_clrfilter;
				$start = ($request_start) ? $request_start : 1;
				$main->include_main_blocks_2($this->module_name."_orders.html", $this->tpl_path);
				$tpl->prepare();
				$tpl->assign(Array(
					"MSG_ID" => $this->_msg["ID"],
					"MSG_Date" => $this->_msg["Date"],
					"MSG_Customer" => $this->_msg["Customer"],
					"MSG_Email" => $this->_msg["Email"],
					"MSG_Sum" => $this->_msg["Sum"],
					"MSG_Discount" => $this->_msg["Discount"],
					"MSG_Currency" => $this->_msg["Currency"],
					"MSG_Order_status" => $this->_msg["Order_status"],
					"MSG_Orders_status" => $this->_msg["Orders_status"],
					"MSG_Responsible" => $this->_msg["Responsible"],
					"MSG_Del" => $this->_msg["Del"],
					"baseurl" => $baseurl,
				));
				if (isset($request_clrfilter)) {
				    unset($_SESSION['shop_fltr']);
				}
				$this->show_orders($baseurl, $start);
				// Функция для разбивки записей по страницам и вывода навигации по ним
				// Имена полей и их назначение :
				// ($table = таблица, $where = условие выборки, $blockname = имя блока,
				// $action = добавка к урл, $start = текущая страница/начало выборки,
				// $rows = кол-во строк, $order_by = порядок выборки, $separator = разделитель)
				$where = $this->getFilterCondition();
				$where = $where ? "AND ".$where : "";
				$main->_show_nav_string($server.$lang."_shop_orders AS O", $where, "", "action=".$action.$this->getFilterHref(), $start, $CONFIG["shop_max_rows"], "id DESC", "", 1, 0);
				$tpl->assign(Array(
					"MSG_Pages" => $this->_msg["Pages"],
				));
				$this->main_title = $this->_msg["Orders_list"];
				break;

// Показать историю заказов пользователя
			case "history":
				if (!$permissions["r"]) $main->message_access_denied($this->module_name, $action);
				global $request_start, $request_id;
				$start = ($request_start) ? $request_start : 1;
				$id = (int)$request_id;
				$main->include_main_blocks_2($this->module_name."_orders.html", $this->tpl_path);
				$tpl->prepare();
				$this->show_orders($baseurl, $start, "", "", $id);
				$main->_show_nav_string($server.$lang."_shop_orders", " AND siteuser_id = ".$id, "", "action=".$action."&id=".$id, $start, $CONFIG["shop_max_rows"], "id DESC", "", 1, 0);
				$this->main_title = $this->_msg["User_orders_list"];
				break;

// Удалить заказ
			case "delorder":
				if (!$permissions["d"]) $main->message_access_denied($this->module_name, $action);
				global $request_start, $request_id;
				$this->delete_order($request_id);
				header("Location: $baseurl&action=orders&start=$request_start");
				exit;
				break;

// Показать информацию о заказе
			case "vieworder":
				if (!$permissions["r"]) $main->message_access_denied($this->module_name, $action);
				global $request_start, $request_id;
				$main->include_main_blocks_2($this->module_name."_order.html", $this->tpl_path);
				$tpl->prepare();
				$tpl->assign(Array(
					"MSG_Date" => $this->_msg["Date"],
					"MSG_Customer" => $this->_msg["Customer"],
					"MSG_Type" => $this->_msg["Type"],
					"MSG_Phone" => $this->_msg["Phone"],
					"MSG_Email" => $this->_msg["Email"],
					"MSG_Address" => $this->_msg["Address"],
					"MSG_Jur_person" => $this->_msg["Jur_person"],
					"MSG_Payment" => $this->_msg["Payment"],
					"MSG_Adding_info" => $this->_msg["Adding_info"],
					"MSG_Ordered_products_list" => $this->_msg["Ordered_products_list"],
					"MSG_Product_ID" => $this->_msg["Product_ID"],
					"MSG_Name" => $this->_msg["Name"],
					"MSG_Code" => $this->_msg["Code"],
					"MSG_Price" => $this->_msg["Price"],
					"MSG_Inner_currency" => $this->_msg["Inner_currency"],
					"MSG_Qty" => $this->_msg["Qty"],
					"MSG_Sum" => $this->_msg["Sum"],
					"MSG_Order_sum_with_discount" => $this->_msg["Order_sum_with_discount"],
					"MSG_Order_sum" => $this->_msg["Order_sum"],
					"MSG_Discount_increase" => $this->_msg["Discount_increase"],
					"MSG_Total_order_sum" => $this->_msg["Total_order_sum"],
					"MSG_Webmoney_percent_included" => $this->_msg["Webmoney_percent_included"],
					"MSG_ASSIST_percent_included" => $this->_msg["ASSIST_percent_included"],
					"MSG_Order_status" => $this->_msg["Order_status"],
					"MSG_Save" => $this->_msg["Save"],
					"MSG_Cancel" => $this->_msg["Cancel"],
					"MSG_Notes" => $this->_msg["Notes"],
					"MSG_Print_order" => $this->_msg["Print_order"],
					"MSG_Delivery" => $this->_msg["Delivery"],
					"print_link" => $baseurl."&action=print&id=".$request_id."&menu=false"
				));
				$this->show_order($baseurl, $request_id, $request_start);
				break;
				
				
			case "print":
				if (!$permissions["r"]) $main->message_access_denied($this->module_name, $action);
				global $request_start, $request_id;
				$main->include_main_blocks_2($this->module_name."_print.html", $this->tpl_path);
				$tpl->prepare();
				$tpl->assign(Array(
					"MSG_Date" => $this->_msg["Date"],
					"MSG_Customer" => $this->_msg["Customer"],
					"MSG_Type" => $this->_msg["Type"],
					"MSG_Phone" => $this->_msg["Phone"],
					"MSG_Email" => $this->_msg["Email"],
					"MSG_Address" => $this->_msg["Address"],
					"MSG_Jur_person" => $this->_msg["Jur_person"],
					"MSG_Payment" => $this->_msg["Payment"],
					"MSG_Adding_info" => $this->_msg["Adding_info"],
					"MSG_Ordered_products_list" => $this->_msg["Ordered_products_list"],
					"MSG_Product_ID" => $this->_msg["Product_ID"],
					"MSG_Name" => $this->_msg["Name"],
					"MSG_Code" => $this->_msg["Code"],
					"MSG_Price" => $this->_msg["Price"],
					"MSG_Inner_currency" => $this->_msg["Inner_currency"],
					"MSG_Qty" => $this->_msg["Qty"],
					"MSG_Sum" => $this->_msg["Sum"],
					"MSG_Order_sum_with_discount" => $this->_msg["Order_sum_with_discount"],
					"MSG_Discount_increase" => $this->_msg["Discount_increase"],
					"MSG_Total_order_sum" => $this->_msg["Total_order_sum"],
					"MSG_Webmoney_percent_included" => $this->_msg["Webmoney_percent_included"],
					"MSG_ASSIST_percent_included" => $this->_msg["ASSIST_percent_included"],
					"MSG_Order_status" => $this->_msg["Order_status"],
					"MSG_Save" => $this->_msg["Save"],
					"MSG_Cancel" => $this->_msg["Cancel"],
					"MSG_Notes" => $this->_msg["Notes"],
				));
				$this->show_order($baseurl, $request_id, $request_start);
				break;

// Обновить статус заказа
			case "changestatus":
				if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
				global $request_start, $request_status, $request_id, $request_notes;
				$this->setOrderStatus($request_id, $request_status);
				$this->setOrderNotes($request_id, $request_notes);
				header('Location: '.$baseurl.'&action=orders&start='.$request_start);
				exit;
				break;

// Настройки платёжных систем
			case "pay_sys":
				if (!$permissions["e"]) $main->message_access_denied($this->module_name, $action);
				global $request_ok, $request_err;
				$main->include_main_blocks_2($this->module_name."_pay_sys.html", $this->tpl_path);
				$tpl->prepare();
				$tpl->assign(Array(
					"MSG_Payment_system_controls" => $this->_msg["Payment_system_controls"],
				));

				if (isset($request_ok)) {
					$tpl->newBlock('block_ok');
					$tpl->assign(Array(
						"MSG_Data_saved" => $this->_msg["Data_saved"],
					));
				} elseif (isset($request_err)) {
					$tpl->newBlock('block_err');
					$tpl->assign(Array(
						"MSG_Write_file_error" => $this->_msg["Write_file_error"],
					));
				}

				$tpl->newBlock('block_pay_sys_conf');
				$tpl->assign(Array(
					"MSG_Save" => $this->_msg["Save"],
					"MSG_Cancel" => $this->_msg["Cancel"],
				));
				$tpl->assign('form_action', $baseurl.'&action=set_pay_conf');
				$this->showWmConf();
				$this->showAssistConf();
				$this->showYaMoneyConf();
				$this->showRobokassaConf();
				$this->showPayOnlineConf();
				break;

// Настройки платёжных систем
			case "set_pay_conf":
				if (!$permissions["e"]) {
					$main->message_access_denied($this->module_name, $action);
				}

				header('Location: ' . $baseurl . '&action=pay_sys&' .( !$this->saveWmConf() || !$this->saveAssistConf() || !$this->saveYaMoneyConf() || !$this->saveRobokassaConf() || !$this->savePayOnlineConf()
				    ? 'err' : 'ok'));

				break;

// Выгрузка/загрузка XML
			case 'imp-exp':
				if (!$permissions['r']) $main->message_access_denied($this->module_name, $action);
				$main->include_main_blocks_2($this->module_name.'_import_export.html', $this->tpl_path);
				$tpl->prepare();

				if ($_SESSION["info_block_name"]) {
					$tpl->newBlock('block_info_box');
					$tpl->newBlock($_SESSION["info_block_name"]);
					unset($_SESSION["info_block_name"]);
					$tpl->assign(Array(
						"MSG_Info_export_success" => $this->_msg["Info_export_success"],
						"MSG_No_new_export_info" => $this->_msg["No_new_export_info"],
						"MSG_Info_import_success" => $this->_msg["Info_import_success"],
						"file" => "/".$_SESSION['import_file'],
					));
					unset($_SESSION['import_file']);
				}

				$tpl->newBlock('block_upload_xml');
				$tpl->assign(Array(
					"MSG_Upload_XML_file" => $this->_msg["Upload_XML_file"],
					"MSG_Upload" => $this->_msg["Upload"],
				));
				$tpl->assign(array(	'upload_xml_url'		=> $baseurl.'&action=uploadxml',));

				$tpl->newBlock('block_get_xml');
				$tpl->assign(Array(
					"MSG_Download_XML_file" => $this->_msg["Download_XML_file"],
					"MSG_Download" => $this->_msg["Download"],
					"MSG_All_orders" => $this->_msg["All_orders"],
				));
				$tpl->assign(array(	'upload_xml_url'	=> $baseurl.'&action=getxml',));

				$this->main_title	= $this->_msg["Import_Export_info"];
				break;

			case 'getxml':
				if (!$permissions['r']) $main->message_access_denied($this->module_name, $action);
				if ( ($file = $this->do_export_XML()) ) {
					$_SESSION["info_block_name"] = "block_info_download_success";
					$_SESSION["import_file"] = $file;
				} else {
					$_SESSION["info_block_name"] = "block_no_info_to_download";
				}

				header('Location: '.$baseurl.'&action=imp-exp');
				break;

		    case 'uploadxml':
		    	if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
		    	if ($_FILES['xml_user_file']['tmp_name'] && ($dom = domxml_open_file($_FILES['xml_user_file']['tmp_name']))) {
					$this->doImportXMLData($dom);
				}
				$_SESSION["info_block_name"] = "block_info_upload_success";

				header('Location: '.$baseurl.'&action=imp-exp');
				break;

		    case 'delivery':
		    	global $request_id;
		    	if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
		    	
		    	$main->include_main_blocks_2("{$this->module_name}_{$action}.html", $this->tpl_path);
				$tpl->prepare();
				
				$tpl->assign(array(
					"MSG_Delivery" => $this->_msg["Delivery"],
					"MSG_Title" => $this->_msg["Title"],
					"MSG_Delivery_cost" => $this->_msg["Delivery_cost"],
					"MSG_description" => $this->_msg["description"],
					"MSG_Cost" => $this->_msg["Cost"],
					"MSG_Save" => $this->_msg["Save"],
					"MSG_Cancel" => $this->_msg["Cancel"],
					"MSG_Add" => $this->_msg["Add"],
					"MSG_Ed" => $this->_msg["Ed"],
					"MSG_Del" => $this->_msg["Del"],
					"currency" => $CONFIG['shop_order_concurency'],
					"baseurl" => $baseurl
				));
				
				$show_list = $this->showDeliveryList($baseurl);
				$tpl->gotoBlock('_ROOT');				
				if ($request_id && ($dlvr = $this->getDelivery($request_id)) ) {
				    $tpl->assign($dlvr);
				}
				$tpl->assign(array(
					"css_form_dispay" => !$show_list || $dlvr ? '' : 'none',
					"css_list_dispay" => $show_list && !$dlvr ? '' : 'none',
				));
				$this->main_title = $this->_msg['Delivery'];
				break;

            case 'setdelivery':
                if (!$permissions["e"]) {
                    $main->message_access_denied($this->module_name, $action);
                }
                global $request_data;
                $this->setDelivery($request_data);
                header("Location: ".$baseurl."&action=delivery");
                exit;

            case 'deldelivery':
                if (!$permissions["d"]) {
                    $main->message_access_denied($this->module_name, $action);
                }
                global $request_id;
                $this->delDelivery($request_id);
                header("Location: ".$baseurl."&action=delivery");
                exit;

		    case 'status':
		    	global $request_id;
		    	if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
		    	
		    	$main->include_main_blocks_2("{$this->module_name}_{$action}.html", $this->tpl_path);
				$tpl->prepare();
				
				$tpl->assign(array(
					"MSG_Delivery" => $this->_msg["Delivery"],
					"MSG_Title" => $this->_msg["Title"],
					"MSG_Save" => $this->_msg["Save"],
					"MSG_Cancel" => $this->_msg["Cancel"],
					"MSG_Add" => $this->_msg["Add"],
					"MSG_Ed" => $this->_msg["Ed"],
					"MSG_Del" => $this->_msg["Del"],
					"MSG_Payable" => $this->_msg["Payable"],
					"baseurl" => $baseurl
				));
				
				$show_list = $this->showOrdStatusList($baseurl, false);
				$tpl->gotoBlock('_ROOT');				
				if ($request_id && ($status = $this->getOrdStatus($request_id)) ) {
				    $status['payable_checked'] = $status['payable'] ? 'checked' : '';
				    $tpl->assign($status);
				}
				$tpl->assign(array(
					"css_form_dispay" => !$show_list || $status ? '' : 'none',
					"css_list_dispay" => $show_list && !$status ? '' : 'none',
				));
				$this->main_title = $this->_msg['Orders_status'];
				break;

            case 'setstatus':
                if (!$permissions["e"]) {
                    $main->message_access_denied($this->module_name, $action);
                }
                global $request_data;
                $this->setOrdStatus($request_data);
                header("Location: ".$baseurl."&action=status");
                exit;

            case 'delstatus':
                if (!$permissions["d"]) {
                    $main->message_access_denied($this->module_name, $action);
                }
                global $request_id;
                $this->delOrdStatus($request_id);
                header("Location: ".$baseurl."&action=status");
                exit;

// Редактирование свойств (параметров) блока
			case 'properties':
				if (!$permissions['e']) $main->message_access_denied($this->module_name, $action);
				global $module_id, $request_field, $request_block_id, $title;
				$main->include_main_blocks('_block_properties.html', 'main');
				$tpl->prepare();

				if ($main->show_actions($request_field, '', $this->block_main_module_actions, $this->block_module_actions)) {
					$main->show_linked_pages($module_id, $request_field);
				}
				$tpl->assign(array(	'_ROOT.title'		=> $title,
									'_ROOT.username'	=> $_SESSION['session_login'],
									'_ROOT.password'	=> $_SESSION['session_password'],
									'_ROOT.name'		=> $this->module_name,
									'_ROOT.lang'		=> $lang,
									'_ROOT.block_id'	=> $request_block_id,
									));
				$this->main_title	= $this->_msg["Block_properties"];
				break;

// Default...
			default:
				$main->include_main_blocks();
				$tpl->prepare();
			}
//--------------------------- конец обработки действий из админ части --------------------------//
		}
	}

	function getTaxes($sum) {
		global $CONFIG, $db, $server, $lang;
		if ($sum) {
			$db->query('SELECT rank, sum(percent) value
							FROM '.$this->table_prefix.'_shop_taxes
							WHERE active = 1
							GROUP BY rank
							ORDER BY rank');
			if ($db->nf() > 0) {
				for ($i = 0; $i < $db->nf(); $i++) {
					$db->next_record();
					$arr[$i]['rank']		= $db->f('rank');
					$arr[$i]['value']		= $db->f('value');
				}
				return $arr;
			}
		}
		return FALSE;
	}

	function getSimpleDiscount($sum, $currency)
	{   global $CONFIG;

		$sum = ShopPrototype::exchange($sum, $currency, $CONFIG['shop_order_concurency']);
		$arr = $this->getDiscounts($sum);
		$discount = 0;
		$ret = false;
		if (is_array($arr)) {
			$cost = (float)$sum;
			$sum_discount = 0;
			for($i = 0; $i < sizeof($arr); $i++) {
				if ($arr[$i]['discount_is_percent'] == 1) {
					$sum_discount = (($arr[$i]['discount_value'])/100)*$cost;
				} else if ($arr[$i]['discount_is_percent'] == 0) {
					$sum_discount = $arr[$i]['discount_value'];
				}
				if ($sum_discount > $discount) {
					$discount = $sum_discount;
					$ret = $arr[$i];
					$ret['discount_sum'] = number_format(
					   ShopPrototype::exchange($discount, $CONFIG['shop_order_concurency'], $currency),
					   2, ".", "");
				}
			}
		}
		return $ret;
	}

	function getDiscounts($sum) {
		global $CONFIG, $db, $server, $lang;
		$sum = (float)$sum;
		if ($sum) {
			$db->query("SELECT * FROM {$this->table_prefix}_shop_discounts WHERE {$sum} "
			    ."BETWEEN min AND max AND IF(from_date AND from_date IS NOT NULL, NOW()>=from_date, 1) "
			    ."AND IF(to_date AND to_date IS NOT NULL, NOW()<DATE_ADD(to_date, INTERVAL 1 DAY), 1) "
			    ."AND active ORDER BY name");
			if ($db->nf() > 0) { 
				for ($i = 0; $i < $db->nf(); $i++) {
					$db->next_record();
					$arr[$i]['discount_id']			= $db->f('id');
					$arr[$i]['discount_name']		= $db->f('name');
					$arr[$i]['discount_value']		= $db->f('value');
					$arr[$i]['discount_min']		= $db->f('min');
					$arr[$i]['discount_max']		= $db->f('max');
					$arr[$i]['discount_is_percent']	= $db->f('is_percent');
				}
				return $arr;
			}
		}
		return FALSE;
	}

	/**
	 * Получить товары заказа
	 *
	 * @param unknown_type $order_id
	 * @return unknown
	 */
	function getOrderItems($order_id = NULL) {
		global $CONFIG, $db, $server, $lang, $baseurl, $core;
		$order_id		= (int)$order_id;
		$catalog_page	= $core->formPageLink($CONFIG['catalog_page_link'], $CONFIG['catalog_page_address'], $lang);
		if ($order_id) {
			$db->query('SELECT * FROM '.$this->table_prefix.'_shop_order_items WHERE order_id = '.$order_id);
			if ($db->nf() > 0) {
				for ($i = 0; $i < $db->nf(); $i++) {
					$db->next_record();
					$arr[$i]['item_id']			= $db->f('item_id');
					$arr[$i]['item_name']		= $db->f('item_name');
					$arr[$i]['item_price']		= ($db->f('item_price'));
					$arr[$i]['item_qty']		= $db->f('item_qty');
					$arr[$i]['item_currency']	= $CONFIG['catalog_currencies'][$db->f('item_currency')];
					$arr[$i]['item_cost']		= ($db->f('item_cost'));
					$arr[$i]['order_currency']	= $CONFIG['catalog_currencies'][$CONFIG['shop_order_concurency']];
					$arr[$i]['item_link']		= $catalog_page.'?action=shwprd&id='.$db->f('item_id');
				}
				return $arr;
			}
		}
		return FALSE;
	}

	function getOrder($order_id)
	{
		global $CONFIG, $db, $server, $lang, $baseurl, $core;

		$order_id		= (int)$order_id;

		$db->query('SELECT *, DATE_FORMAT(date, \''.$CONFIG['shop_date_format']
		    .'\') AS order_date, S.title AS order_status FROM '.$this->table_prefix.'_shop_orders O LEFT JOIN '
		    .$this->table_prefix.'_shop_order_status S ON status=S.id WHERE O.id = '.$order_id);

		include_once(RP."/inc/func.num2str.php");

		if ($db->nf() > 0) {
			$db->next_record();
			$pay_type = $db->f('pay_type');
			$sum = $db->f('sum');
			$cost = $db->f('total_sum');
			$discount = $db->f('discount');
			$discount = ($discount > 0 ? "+" : "").$discount;
			$cur = $db->f('currency');
			$arr['order_id']	= $order_id;
			$arr['number']		= $order_id;
			$arr['customer']	= $db->f('customer');
			$arr['delivery_id']	= $db->f('delivery_id');
			$arr['delivery_cost_noformat'] = $db->Record['delivery_cost'];
			$arr['delivery_cost']	= Catalog::formatPrice($db->f('delivery_cost'));
			$arr['sum_noformat'] = $sum;
			$arr['sum']			= Catalog::formatPrice($sum);
			$arr['sum_rur_noformat'] = ShopPrototype::exchange($sum, $cur, "RUR");
			$arr['sum_rur']		= Catalog::formatPrice($arr['sum_rur_noformat']);
			$arr['discount']	= $discount;
			$arr['total_sum_noformat']	= $cost;
			$arr['total_sum']	= Catalog::formatPrice($cost);
			$arr['cost_noformat']	= $cost;
			$arr['cost']		= Catalog::formatPrice($cost);
			$arr['cost_rur_noformat']	= ShopPrototype::exchange($cost, $cur, "RUR");
			$arr['cost_rur']	= Catalog::formatPrice($arr['cost_rur_noformat']);
			$arr['cost_rur_in_words'] = num2str($arr['cost_rur']);
			$arr['currency']	= $CONFIG['catalog_currencies'][$cur];
			$arr['currency_id']	= $cur;
			$arr['status']		= $db->f('status');
			$arr['order_status'] = $this->getStatusTitle($db->f('order_status'), $db->f('status'));
			$arr['pay_type_id']	= $pay_type;
			$arr['pay_type']	= $CONFIG['order_pay_types'][$pay_type];
			$arr['date']		= $db->f('order_date');
			$arr['nds']         = $CONFIG['shop_nds'];
			$arr['nds_cost']	= Catalog::formatPrice($arr['cost_rur']*$CONFIG['shop_nds']/100);
			$arr['sum_cost']	= Catalog::formatPrice($arr['sum_rur']*$CONFIG['shop_nds']/100);
			$arr['address']     = nl2br($db->f("address"));
			$arr['phone']       = $db->f("phone");
			$arr['organization'] = $db->f("organization") ? $db->f("organization") : "";
			$arr['jpinfo']      = nl2br($db->f("jpinfo"));
			$arr['addinfo']     = nl2br($db->f("addinfo"));
			$arr['session']     = nl2br($db->f("session"));
			$arr['notify']     = $db->f("notify");
			$arr['email']     = $db->f("email");

			return $arr;
		}
		return FALSE;
	}


	function getAllOrders($siteuser_id, $order = NULL) {
		global $CONFIG, $db, $server, $lang, $baseurl;
		$siteuser_id = (int)$siteuser_id;
		if ($siteuser_id) {
			$db->query('SELECT O.id, customer, DATE_FORMAT(date,"'.$CONFIG['shop_date_format'].'") date, status, sum, currency, discount, total_sum, S.title AS order_status, payable
							FROM '.$this->table_prefix.'_shop_orders O LEFT JOIN  '.$this->table_prefix.'_shop_order_status S ON status=S.id
							WHERE siteuser_id = '.$siteuser_id.'
							ORDER BY date DESC');
			if ($db->nf() > 0) {
				for ($i = 0; $i < $db->nf(); $i++) {
					$db->next_record();
					$discount = Main::process_price($db->f('discount'));
					$discount = ($discount > 0 ? "+" : "").$discount;
					$arr[$i]['order_id']			= $db->f('id');
					$arr[$i]['order_customer']		= $db->f('customer');
					$arr[$i]['order_organization']	= $db->f('organization');
					$arr[$i]['order_date']			= $db->f('date');
					$arr[$i]['order_status']		= $this->getStatusTitle($db->f('order_status'), $db->f('status'));
					$arr[$i]['order_payable']		= $db->f('payable');
					$arr[$i]['order_sum']			= Catalog::formatPrice($db->f('sum'));
					$arr[$i]['order_discount']		= $discount;
					$arr[$i]['order_cost']			= Catalog::formatPrice($db->f('total_sum'));
					$arr[$i]['order_currency']		= $CONFIG['catalog_currencies'][$db->f('currency')];
					$arr[$i]['order_link']			= $baseurl.'&action=vieworder&id='.$db->f('id');
				}
				return $arr;
			}
		}
		return FALSE;
	}

	// функция для вывода списка заказов
	function show_orders($transurl, $start = "", $rows = "", $order_by = "", $siteuser_id = "")
	{   global $CONFIG, $main, $db, $tpl, $server, $lang;

		$admin = Module::is_admin();

		$start = $start > 1 ? (int)$start : 1;
		$rows = !$rows || $rows < 1 ? $CONFIG["shop_max_rows"] : (int)$rows;
		$start_row = ($start - 1) * $rows;
		if (!$order_by) {
			$order_by = "id DESC";
		}

		if ($siteuser_id) {
			$query = "SELECT O.*, DATE_FORMAT(date,'".$CONFIG["shop_date_format"] . "') as date, S.title AS order_status
						FROM ".$this->table_prefix."_shop_orders O LEFT JOIN ".$this->table_prefix."_shop_order_status S ON status=S.id
						WHERE siteuser_id = $siteuser_id
						ORDER BY $order_by
						LIMIT $start_row,$rows";
		} else {
			if (!$admin) {
				return FALSE;
			}
			$this->showFilter();
			$filter = $this->getFilterCondition();
			$filter = $filter ? " WHERE ".$filter : "";
			$query = "SELECT O.*, DATE_FORMAT(date,'{$CONFIG["shop_date_format"]}') as date, "
			    ."S.title AS order_status, U.username AS manager_username "
			    ."FROM {$this->table_prefix}_shop_orders O LEFT JOIN "
			    .$this->table_prefix."_shop_order_status S ON O.status=S.id LEFT JOIN "
			    ."core_users U ON O.manager_id=U.id {$filter} "
			    ."ORDER BY O.{$order_by} LIMIT {$start_row},{$rows}";
		}
		$db->query($query);
		if ($db->nf() > 0) {
			$tpl->newBlock('block_basket');
			while($db->next_record()) {
				if ($db->f("email")) {
					$email = "<a href=\"mailto:" . $db->f("email") . "\">" . $db->f("email") . "</a>";
				} else {
					$email = "-";
				}
				$sum = $main->process_price($db->f("sum"));
				$cost = $main->process_price($db->f("total_sum"));
				$discount = $main->process_price($db->f("discount"));
				$discount = ($discount > 0 ? "+" : "").$discount;
				if (!$sum) $sum = "-";

				$user_id = $db->f("siteuser_id");
				$customer = $user_id
					? "<a href=\"/admin.php?lang=".$lang."&name=siteusers&action=editsiteuser&id=" . $user_id . "\">" . $db->f("customer") . "</a>"
					: $db->f("customer");

				$order_status = $this->getStatusTitle($db->f('order_status'), $db->f('status'));

				$tpl->newBlock('block_order');
				$tpl->assign(Array(
					"MSG_Confirm_delete_record" => $this->_msg["Confirm_delete_record"],
					"MSG_Delete" => $this->_msg["Delete"],
				));
				$id = $db->f("id");
				$tpl->assign(
					array(
						'order_id'			=>	$id,
						'order_customer'	=>	$customer,
						'order_status'		=>	$order_status,
						'order_address'		=>	nl2br($db->f("address")),
						'order_phone'		=>	$db->f("phone"),
						'order_organization'	=>	($db->f("organization")) ? " (".$db->f("organization").")" : "",
						'order_jpinfo'		=>	nl2br($db->f("jpinfo")),
						'order_addinfo'		=>	nl2br($db->f("addinfo")),
						'order_email'		=>	$email,
						'order_sum'			=>	$sum,
						'order_cost'		=>	$cost,
						'order_discount'	=>	$discount,
						'order_currency'	=>	$CONFIG['catalog_currencies'][$db->f("currency")],
						'order_date'		=>	$db->f("date"),
						'order_link'		=>	$transurl . "&action=vieworder&id=" . $id . "&start=". $start,
						'order_del_link'	=>	$transurl ."&action=delorder&id=" . $id . "&start=" . $start,
						'start'				=>	$start,
						'tr_color'			=>	$tr_color,
						'manager_username'  =>  $db->f("manager_username"),
						'manager_id'  =>  $db->f("manager_id"),
						'lang'  =>  $lang,
					)
				);
			}
			return TRUE;
		}
		return FALSE;
	}


	// вывести информацию о заказе по его id
	function show_order($transurl, $id = "", $start = "") {
		$id = (int)$id; if (!$id) return FALSE;
		global $CONFIG, $main, $db, $tpl, $baseurl, $core, $server, $lang;

		$admin = Module::is_admin();
		
		$status_list = $this->getOrdStatusList();
		if ($admin) {
			$query = "SELECT O.*, DATE_FORMAT(O.date,'" . $CONFIG["shop_date_format"]
			    . "') as date, COUNT(H.id) AS status_cnt, payable, S.title AS order_status"
			    ." FROM ".$this->table_prefix."_shop_orders AS O LEFT JOIN ".$this->table_prefix."_shop_order_history AS H"
			    ." ON O.id=H.order_id LEFT JOIN ".$this->table_prefix."_shop_order_status S ON status=S.id"
			    ." WHERE O.id = $id GROUP BY H.order_id";
			$db->query($query);
		} else if ($_SESSION["siteuser"]["id"]) {
			$query = "SELECT O.*, DATE_FORMAT(date,'" . $CONFIG["shop_date_format"] . "') as date, payable, S.title AS order_status
						FROM ".$this->table_prefix."_shop_orders O LEFT JOIN ".$this->table_prefix."_shop_order_status S ON status=S.id
						WHERE O.id = $id AND siteuser_id = {$_SESSION["siteuser"]["id"]}";
			$db->query($query);
		} else {
			return FALSE;
		}
		if ($db->nf() > 0) {
			$db->next_record();
			if ($db->f("email")) {
				$email = "<a href=\"mailto:" . $db->f("email") . "\">" . $db->f("email") . "</a>";
			} else {
				$email = "-";
			}
			$sum = $db->f("sum");
			$cost = $db->f("total_sum");
			$discount = $db->f("discount");
			$dlvr_cost = $db->f("delivery_cost");
			$dlvr_id = $db->f("delivery_id");
			if (!$sum) $sum = "-";

			$orders_history_link = "";
			$customer = $db->f("customer");
			if ($db->f("siteuser_id") && $admin) {
				$customer = $this->_msg["Registered_user"] . "<br><a href=\"/admin.php?lang={$lang}&name=siteusers&action=editsiteuser&id=" . $db->f("siteuser_id") . "\">" . $db->f("customer") . "</a>";
				$orders_history_link = "<br><a href=\"$transurl&action=history&id=" . $db->f("siteuser_id") . "\">" . $this->_msg["Show_user_orders"] . "</a>";
			}

			$status = $db->f("status");
			$order_status = 0 == $status ? $this->_msg['Default_status'] 
			    : ($db->f('order_status') ? $db->f('order_status') : $this->_msg['undef']);

			$shopping_cart_page = $core->formPageLink($CONFIG["shop_page_link"], $CONFIG["shop_page_address"], $lang);

			$cur = $db->f('currency');
			$status_action	= $admin ? $transurl.'&action=changestatus&start='.$start : "";
			$pay_type = $db->f("pay_type");
			$sum_rur = $sum * $_SESSION['catalog_rates'][$cur. '/RUR'];
			$cost_rur = $cost * $_SESSION['catalog_rates'][$cur. '/RUR'];
			//вывод на экран
			$tpl->assign(
				array(
					'order_id'				=>	$id,
					'order_status'			=>	$order_status,
					'order_customer'		=>	$customer,
					'order_customer_type'	=>	$db->f('type'),
					'order_address'			=>	nl2br($db->f("address")),
					'order_phone'			=>	$db->f("phone"),
					'order_email'			=>	$email,
					'order_organization'	=>	($db->f("organization")) ? " (".$db->f("organization").")" : "",
					'order_jpinfo'			=>	nl2br($db->f("jpinfo")),
					'order_addinfo'			=>	nl2br($db->f("addinfo")),
					'order_sum'				=>	Catalog::formatPrice($sum),
					'order_sum_rur'			=>	Catalog::formatPrice($sum_rur),
					'order_cost'			=>	Catalog::formatPrice($cost),
					'order_cost_rur'		=>	Catalog::formatPrice($cost_rur),
					'order_discount'		=>	$discount > 0 ? "+".Catalog::formatPrice($discount) : Catalog::formatPrice($discount),
					'order_currency'		=>	$CONFIG['catalog_currencies'][$cur],
					'order_delivery'		=>	Catalog::formatPrice($dlvr_cost),
					'delivery_currency'		=>	$CONFIG['catalog_currencies'][$CONFIG['shop_order_concurency']],
					'currency_id'			=>	$cur,
					'order_date'			=>	$db->f("date"),
					'order_info'			=>	$db->f("info"),
					'order_notes'			=>	$db->f("notes"),
					'order_payable'			=>	$db->f("payable"),
					'order_pay_type'		=>	$CONFIG['order_pay_types'][$pay_type],
					'repeat_order_link'		=>	$shopping_cart_page.'?action=repeat&id='.$id,
					'change_status_action'	=>	$status_action,
					'orders_history_link'	=>	$orders_history_link,
					'ordering_link'         =>  $transurl . "&action=ordering&id=" . $id,
				)
			);

			/* Если оплата WebMoney - учитываем скидку/надбавку */
			if (4 == $pay_type && $CONFIG['shop_WM_discount']) {
				$tpl->newBlock('block_webmoney_discount');
				$tpl->assign(array(
				    'webmoney_discount' => ($CONFIG['shop_WM_discount'] > 0 ? "+" : "").$CONFIG['shop_WM_discount'],
				    'MSG_Webmoney_percent_included' => $this->_msg['Webmoney_percent_included']
				));
			}
			/* Если оплата ASSIST - учитываем скидку/надбавку */
			if (5 == $pay_type && $CONFIG['shop_assist_discount']) {
				$tpl->newBlock('block_assist_discount');
				$tpl->assign(array(
				    'assist_discount' => ($CONFIG['shop_assist_discount'] > 0 ? "+" : "").$CONFIG['shop_assist_discount'],
				    'MSG_ASSIST_percent_included' => $this->_msg['ASSIST_percent_included']
				));
			}

			$this->main_title = $this->_msg["Order"] . " №: " . $id . " (".$order_status.")";
			$status_hist =  $admin && $db->f("status_cnt") ? TRUE : FALSE;
			$_SESSION["order"]["currency"] = $cur;

			/** Если не оплачено **/
			if (0 == $status || $db->f("payable")) {
				/** Способ оплаты **/
				switch ($pay_type) {
					/** квитанция Сбербанк **/
					case 2:
						$tpl->newBlock('block_sbr');
						$compn_info = $this->getCompanyInfo();
						$compn_info['sbr_ticket_link'] = $baseurl.('&' == substr($baseurl, -1) ? '' : '&')."action=sbr_ticket&id=".$id;
						$compn_info['number'] = $id;
						$tpl->assign($compn_info);
						break;

					/** банковский перевод **/
					case 3:
						$tpl->newBlock('block_bank');
						$compn_info = $this->getCompanyInfo();
						$compn_info['number'] = $id;
						$tpl->assign($compn_info);
						break;

					/** Webmoney **/
					case 4:
						if (
							$cost > 0
							&& $CONFIG['shop_WM_purse']
							&& in_array($CONFIG['shop_WM_currency'], array('RUR', 'USD', 'EUR'))
						) {
							/* Сумма заказа в валюте кошелька webmoney*/
							$wm_amount = $cost * $_SESSION['catalog_rates'][$cur . '/' . $CONFIG['shop_WM_currency']];
							$tpl->newBlock('block_webmoney');
							$tpl->assign(
								array(
									'wm_amount'	=> number_format($wm_amount, 2, ".", ""),
									'wm_payment_no'	=> $id,
									'wm_payee_purse'	=> $CONFIG['shop_WM_purse'] ,
									'order_sum' => $cost,
									'wm_success_url'	=> $CONFIG['shop_WM_success_url'],
									'wm_fail_url'		=> $CONFIG['shop_WM_fail_url'],
									'wm_result_url'		=> "http://".$_SERVER['HTTP_HOST'].$CONFIG['shop_WM_result_url'],
								)
							);
						}
						break;

					/** ASSIST **/
					case 5:
						if (
							$cost > 0
							&& $CONFIG['shop_assist_idp']
							&& in_array($CONFIG['shop_assist_currency'], array('RUR', 'USD', 'EUR'))
						) {
							/* Сумма заказа в валюте кошелька ASSIST */
							$assist_amount = $cost * $_SESSION['catalog_rates'][$cur . '/' . $CONFIG['shop_assist_currency']];
							$tpl->newBlock('block_assist');
							$tpl->assign(
								array(
									'assist_shop_id'		=> $CONFIG['shop_assist_idp'],
									'assist_order_id'		=> $id,
									'assist_amount'			=> $assist_amount,
									'assist_success_url'	=> "http://".$_SERVER['HTTP_HOST'].$CONFIG['shop_assist_result_url'],
									'assist_fail_url'		=> $CONFIG['shop_assist_fail_url'],
									'assist_currency'		=> $CONFIG['shop_assist_currency'],
								)
							);
						}
						break;
						
					/** ya_money **/
					case 6:
						if (
							$cost > 0
							&& $CONFIG['ya_money_uid']
						) {
							/* Сумма заказа в валюте рублях */
							$amount = self::exchange($cost, $cur, 'RUR');
							$amount = abo_float($amount);
							$tpl->newBlock('block_ya_money');
							$tpl->assign(array(
								'amount'	=> $amount,
								'order_id'	=> $id,
								'ya_money_uid'	=> $CONFIG['ya_money_uid'] ,
								'order_sum' => $cost,
								'host' => $_SERVER['HTTP_HOST'],
								'order_title' => urlencode("Заказ №{$id}, на сайте {$_SERVER['HTTP_HOST']}")
							));
						}
						break;
			    
			        /** ROBOKASSA **/
			        case 8:
			            if ($cost > 0
			                && $CONFIG['shop_robokassa_login']
			                && $CONFIG['shop_robokassa_activ']
			            ) {
			                /* Сумма заказа в валюте ROBOKASSA */
			                $robokassa_amount = ShopPrototype::exchange($cost, $cur, $CONFIG['shop_robokassa_currency']);
			                $robokassa_amount = number_format($robokassa_amount, "2", ".", "");
			                $tpl->newBlock('block_robokassa');
			                $tpl->newBlock($CONFIG['shop_robokassa_test_mode'] ? 'block_robokassa_test_mod' : 'block_robokassa_real_mod');
			                $tpl->assign(array(
			                        'robokassa_amount' => $robokassa_amount,
			                        'order_id' => $id,
			                        'robokassa_login' => $CONFIG['shop_robokassa_login'],
			                        'robokassa_currency' => $CONFIG['shop_robokassa_currency'],
			                        'order_sum' => $cost,
			                        'form_script' => $this->getRobakassaForm($robokassa_amount, $id),
			                        'signature' => $this->getRobokassaSignature($robokassa_amount, $id),
			                        'robokassa_url' => $CONFIG['shop_robokassa_test_mode']
    			                        ? $CONFIG['shop_robokassa_test_url']
    			                        : $CONFIG['shop_robokassa_real_url']
			                ));
			            }
			            break;
			            
			        /** PayOnline **/
			        case 9:
			            if (
			            $cost > 0
			            && $CONFIG['shop_payonline_activ']
			            && $CONFIG['payonline_MerchantId']
			            ) {
			                /* Сумма заказа в валюте PayOnline */
			                $amount = self::exchange($cost, $cur, 'RUR');
			                $amount = number_format($amount, 2, '.', '');
			                $tpl->newBlock('block_payonline');
			                //$order_desc = urlencode("Заказ {$order['order_id']}, на сайте {$_SERVER['HTTP_HOST']}");
			                $order_desc = "Заказ номер {$order['order_id']}";
			                $shop_link = 'http://'.$_SERVER['HTTP_HOST'].$core->formPageLink($CONFIG["shop_page_link"], $CONFIG["shop_page_address"], $lang, 1).'action=';
			                $tpl->assign(array(
			                    'amount'	=> $amount,
			                    'order_id'	=> $id,
			                    'redirect' => $CONFIG['payonline_redirect'],
			                    'MerchantId'	=> $CONFIG['payonline_MerchantId'] ,
			                    'order_sum' => $cost,
			                    'host' => $_SERVER['HTTP_HOST'],
			                    'order_title' => $order_desc,
			                    'SecurityKey' => md5('MerchantId='.$CONFIG['payonline_MerchantId'].'&OrderId='.$id.'&Amount='.$amount.'&Currency=RUB&OrderDescription='.$order_desc.'&PrivateSecurityKey='.$CONFIG['payonline_PrivateSecurityKey']),
			                    'ReturnUrl' => $shop_link.'payonlineReturn',
			                    'FailUrl' => $shop_link.'payonlineFail'
			                ));
			            }
				}
			}
			
			if ($dlvr_id) {
			    $dlvr = $this->getDelivery($dlvr_id);
			    $tpl->newBlock('block_order_delivery');
			    $tpl->assign(array(
			        'delivery_cost' => $dlvr_cost,
			        'currency' => $CONFIG['catalog_currencies'][$CONFIG['shop_order_concurency']],
			        'title' => $dlvr ? $dlvr['title'] : '',
			        'dscr' => $dlvr ? $dlvr['dscr'] : '',
			    ));
			}

			if ($admin) {
			    foreach ($status_list as $val) {
			    	$tpl->newBlock('block_order_status');
			    	$val['selected'] = $val['id'] == $status ? 'selected' : '';
			    	$tpl->assign($val);
			    }
			}

			$this->show_items($transurl, $id, $cur);

			if ($status_hist) {
				$tpl->newBlock('block_status_history');
				$tpl->assign(Array(
					"MSG_Status_changes_history" => $this->_msg["Status_changes_history"],
					"MSG_Time" => $this->_msg["Time"],
					"MSG_Old_stat" => $this->_msg["Old_stat"],
					"MSG_New_stat" => $this->_msg["New_stat"],
					"MSG_Info" => $this->_msg["Info"],
					"MSG_Responsible" => $this->_msg["Responsible"],
				));
				$query = "SELECT H.*, DATE_FORMAT(H.date,'".$CONFIG["shop_date_format"] . "') as date, username FROM "
				    .$this->table_prefix."_shop_order_history H LEFT JOIN core_users U ON manager_id=U.id  WHERE order_id=".$id
				    ." ORDER BY date";
				$db->query($query);
				while ($db->next_record()) {
					$tpl->newBlock('block_status_history_row');
					$tpl->assign(
						array(
							'date' => $db->f('date'),
							'old_status' => $status_list[$db->f('old_status')] ? $status_list[$db->f('old_status')]['title'] : $this->_msg['undef'],
							'new_status' => $status_list[$db->f('new_status')] ? $status_list[$db->f('new_status')]['title'] : $this->_msg['undef'],
							'info' => nl2br($db->f('info')),
							'responsible' => $db->f('username') ? $db->f('username') : 'n\a'
						)
					);
				}
			}

			return TRUE;
		}
		return FALSE;
	}


	// вывести информацию о заказанных товарах по id заказа
	function show_items($transurl, $id = "", $order_currency = "") {
		$id = intval($id); if (!$id) return 0;
		global $CONFIG, $main, $db, $tpl, $baseurl, $core, $server, $lang;
		$admin = Module::is_admin();

		$query = "SELECT * FROM ".$this->table_prefix."_shop_order_items WHERE order_id = $id ORDER BY id";
		$db->query($query);

		if ($db->nf() > 0) {
			while($db->next_record()) {

				$cost = $db->f("item_cost");
				$cost = Catalog::formatPrice($cost);
				if (!$cost) $cost = "-";

				$price = Catalog::formatPrice($db->f("item_price"));
				if (!$price) $price = "-";

				$catalog_page = $core->formPageLink($CONFIG["catalog_page_link"], $CONFIG["catalog_page_address"], $lang);
				$item_link = ($admin) ? "/admin.php?name=catalog&action=editproduct&id=".$db->f("item_id")
				: $catalog_page."?action=shwprd&id=".$db->f("item_id");


				//вывод на экран
				$info = unserialize($db->f("info"));
				$tpl->newBlock("block_item");
				$tpl->assign(array(
				    'item_id' => $db->f("item_id"),
					'item_name' => $db->f("item_name"),
					'item_link' => $item_link,
					'item_code' => $db->f("item_code"),
					'item_currency' => $CONFIG['catalog_currencies'][$db->f("item_currency")],
					'item_price' => $price,
					'item_rate' => $db->f("item_rate"),
					'item_qty' => $db->f("item_qty"),
					'item_info' => $info['dscr'],
					'item_cost' => $cost,
					'order_currency' =>	$CONFIG['catalog_currencies'][$order_currency]
				) );
			}
			return TRUE;
		}
		return FALSE;
	}

	function getBasketProds()
	{
		if (is_array($_SESSION["order"]["items"]) && sizeof($_SESSION["order"]["items"]) > 0) {
			foreach($_SESSION["order"]["items"] as $item_idx => $item_array) {
				$arr[] = $item_array;
			}
			return $arr;
		}
		return FALSE;
	}

	function getProdsForShowInBasket($item) {
		GLOBAL $CONFIG, $baseurl, $core;
		$sizeOfItem = sizeof($item);
		if (is_array($item) && $sizeOfItem > 0) {
			$catalog_page = $core->formPageLink($CONFIG['catalog_page_link'], $CONFIG['catalog_page_address'], $lang);
			for($i = 0; $i < $sizeOfItem; $i++) {
				if (3 == $_SESSION['siteuser']['client_type']) {
					$price = Main::process_price($item[$i]['price_3']);
				} elseif (2 == $_SESSION['siteuser']['client_type']) {
					$price = Main::process_price($item[$i]['price_2']);
				} else {
					$price = Main::process_price($item[$i]['price_1']);
				}
				$sum = number_format($price*$item[$i]['quantity'], 2, ".", "");
				$arr[$i]['item_id']				= $item[$i]['id'];
				$arr[$i]['item_name']			= $item[$i]['name'];
				$arr[$i]['item_currency']		= $CONFIG['catalog_currencies'][$item[$i]['currency']];
				$arr[$i]['item_cost']			= $sum;
				$arr[$i]['item_sum']			= $sum;
				$arr[$i]['item_price']			= $price;
				$arr[$i]['item_price_1']		= (float)($item[$i]['price_1']);
				$arr[$i]['item_price_2']		= (float)($item[$i]['price_2']);
				$arr[$i]['item_price_3']		= (float)($item[$i]['price_3']);
				$arr[$i]['item_availability']	= $item[$i]['availability'];
				$arr[$i]['item_quantity']		= $item[$i]['quantity'];
				$arr[$i]['item_razm']			= $item[$i]['razm'];
				$arr[$i]['item_link']			= $catalog_page.'&action=shwprd&id='.$item[$i]['id'];
				$arr[$i]['item_del_link']		= $baseurl.'&action=delete&id='.$item[$i]['id'].'&razm='.$item[$i]['razm'];
			}
			return $arr;
		}
		return FALSE;
	}

	// Функция для вывода корзины покупок
	function showCart() {
		global $CONFIG, $tpl, $lang, $transurl, $baseurl;
		if (is_array($_SESSION['order']['items']) && sizeof($_SESSION['order']['items']) > 0) {
		    $tpl->newBlock('block_cart');
		    $ctlg = Module::load_mod('catalog', 'only_create_object');
			$catalog_page = Core::formPageLink($CONFIG['catalog_page_link'], $CONFIG['catalog_page_address'], $lang);
			$tpl->assign(array(
			    'basket_recal' => $baseurl.'&action=recal',
			    'baseurl' => $baseurl,
			    'del_all' => $baseurl.'&action=del_all',
			    'discount_all' => $_SESSION['order']['discount'],
			    'currencie' => $CONFIG['catalog_currencies'][$CONFIG['shop_order_concurency']],
			    'item_all' => Catalog::formatPrice($_SESSION['order']['cost']).' '.$CONFIG['catalog_currencies'][$CONFIG['shop_order_concurency']],
			    'process_order' => $baseurl.'&action=processorder'
			));
			if ($_SESSION['order']['discount']) {
			    if ($_SESSION['order']['discount_is_simple']) {
			        $d = $this->getDiscount($_SESSION['order']['discount_id']);
			        if ($d) {
			        	$tpl->newBlock('block_simple_discount');
        				$tpl->assign(array(
        				    'id' => $_SESSION['order']['discount_id'],
        				    'name' => $d['discount'],
        				    'sum' => Catalog::formatPrice($_SESSION['order']['discount']),
        				    'currencie' => $arr['currencie']));
			        }
			    } else {
    				$d = $this->GetUsersDiscounts($_SESSION['order']['discount_id']);
			        if ($d && 1 == count($d)) {
			        	$tpl->newBlock('block_accumulative_discount');
        				$tpl->assign(array(
        				    'id' => $_SESSION['order']['discount_id'],
        				    'name' => $d[0]['name'],
        				    'sum' => Catalog::formatPrice($_SESSION['order']['discount']),
        				    'currencie' => $arr['currencie']));
			        }
			    }
			}
			$prod_list = $this->getCartProdList();
			$ord_prop_list = $ctlg->getOrderPropList();
		    foreach ($_SESSION["order"]["items"] as $key => $val) {
		    	foreach ($val as $k => $v) {
		    	    $prod_list[$key]['key'] = $v['key'];
		    	    $prod_list[$key]['link'] = CatalogPrototype::getProdLink(
		    	        $catalog_page,
		    	        $prod_list[$key]['prod_alias'],
		    	        $prod_list[$key]['id'],
		    	        $prod_list[$key]['ctgr_alias']);
		    	    $prod_list[$key]['del_link'] = $baseurl.'&action=delete&id='.$prod_list[$key]['id']
		    	       .($prod_list[$key]['key'] ? "&key={$prod_list[$key]['key']}" : "");
		    	    $prod_list[$key]['cnt'] = $v['cnt'];
		    	    $prod_list[$key]['cost'] = Catalog::formatPrice($prod_list[$key]['price']*$v['cnt']);
		    	    $prod_list[$key]['price'] = Catalog::formatPrice($prod_list[$key]['price']);
		    	    $tpl->newBlock('block_cart_item');
		    	    $tpl->assign($prod_list[$key]);
		    	    if ($prod_list[$key]['image'] && file_exists(RP.$CONFIG['catalog_img_path'].$prod_list[$key]['image'])) {
		    	        $tpl->newBlock('block_cart_item_img');
		    	        $prod_list[$key]['img_path'] = "/".$CONFIG['catalog_img_path'].$prod_list[$key]['image'];
		    	    } else {
		    	        $tpl->newBlock('block_cart_item_no_img');
		    	    }
		    	    $tpl->assign($prod_list[$key]);
		    	    if (! empty($v['prop'])) {
		    	        $tpl->newBlock('block_cart_item_prop_list');
		    	        foreach ($v['prop'] as $pk => $pv) {
		    	        	$tpl->newBlock('block_cart_item_prop');
		    	        	$tpl->assign(array(
		    	        	    'title' => $ord_prop_list[$pk]['title'],
		    	        	    'name' => $ord_prop_list[$pk]['name'],
		    	        	    'val' => $ord_prop_list[$pk]['val'][$pv],
		    	        	    'prop_id' => $pk,
		    	        	    'val_id' => $pv,
		    	        	));
		    	        }
		    	    }
		    	}		    	    		    	
		    }
		} else {		    
		    $tpl->newBlock('block_cart_empty');
		}
	}


	// Функция для повторения заказа
	function repeat_order($id) {
		global $CONFIG, $main, $db, $db2, $core, $server, $lang;

		$id = (int)$id; if (!$id) return FALSE;
		if (!$_SESSION["siteuser"]["id"]) return FALSE;
		$no_product_arr = array();

		$query = "SELECT * FROM ".$this->table_prefix."_shop_orders WHERE id = $id AND siteuser_id = {$_SESSION["siteuser"]["id"]}";
		$db->query($query);

		if (!($db->nf() > 0)) return FALSE;

		$result = 1;
		$db->next_record();
		$id = $db->f("id");

		$query = "SELECT * FROM ".$this->table_prefix."_shop_order_items WHERE order_id = $id";
		$db2->query($query);

		if ($db2->nf() > 0) {
			while($db2->next_record()) {
			    $info = unserialize($db2->f("info"));
				if (!$this->add_to_cart($db2->f("item_id"), $db2->f("item_qty"), $info['prop'])) {
				    $no_product_arr[] = $db2->f("item_name");
				}
			}

			// сформировать предупреждение о том, что товара/товаров нет в каталоге
			$c = count($no_product_arr);
			if ($c > 0) {
				$str = implode(", ", $no_product_arr);
				if ($c == 1) $result_message = $this->_msg["Now_good_absent"] . " $str.";
				else $result_message = $this->_msg["Now_goods_absent"] . ": $str.";
				if ($db2->nf() > 1) $result_message .= " " . $this->_msg["Another_goods_added_to_cart"];
				$result = -1;
				$_SESSION["order"]["result_message"] = $result_message;
			}
		}

		return $result;
	}


	// Функция для добавления товара в корзину покупок
	function add_to_cart($id = '', $cnt = '', $order_prop = false)
	{   global $CONFIG, $main, $db, $server, $lang;
	
		$id = (int)$id;
		$ctlg = Module::load_mod('catalog', 'only_create_object');
		if (!$id || !$ctlg) {
			return FALSE;
		}
		$prod = $ctlg->getProduct($id);
		if (! $prod) {
		    return false;
		}
		$cnt = $cnt > 1 ? (int)$cnt : 1;

		if (!isset($_SESSION["order"]["items"])) {
			$_SESSION["order"]["items"]	= array();
			$_SESSION["order"]["sum"]	= 0;
		}
		if (is_array($order_prop)) {
		    foreach ($order_prop as $key => $val) {
    			if (! $val) {
    			    unset($order_prop[$key]);
    			}
    		}
		}		
		/**
		 * $_SESSION["order"]["items"] = array(
		 *     product_id => array(
		 *         0 => array(
		 *             'prop' => array(prod_id => prod_val_id),
		 *             'key' => key_for_poperties_values,
		 *             'cnt' => count_of_products,
		 *         ),
		 *         ...
		 *     ),
		 *     ...
		 * );
		 * 
		 */
		$prop_key = $this->getPropKey($order_prop);
		if (in_array($id, array_keys($_SESSION["order"]["items"]))) {
		    $find = false;
		    foreach ($_SESSION["order"]["items"][$id] as $key => $val) {		        
		        if ($val['key'] == $prop_key) {
		            $find = true;
		            $_SESSION["order"]["items"][$id][$key]['cnt'] += $cnt; 
			 	}
		    }
		    if (!$find) {
		        $_SESSION["order"]["items"][$id][] = array(
    		        'prop' => $order_prop,
    		        'key' => $prop_key,
    		        'cnt' => $cnt
    		    );
		    }
		} else {
		    $_SESSION["order"]["items"][$id][] = array(
		        'prop' => $order_prop,
		        'key' => $prop_key,
		        'cnt' => $cnt
		    );
		}
		return TRUE;
	}

	// Функция для удаления одного товара из корзины покупок
	function delete_item_from_cart($id = '', $cart_key = '') {
	    $ret = false;
		if ($id && isset($_SESSION['order']['items'][$id])) {
			while (!$ret && list($key, $val) = each($_SESSION['order']['items'][$id])) {
				if ( ($cart_key && $cart_key == $val['key'] ) 
				    || (!$cart_key && !$val['key'])
				) {
				    unset($_SESSION['order']['items'][$id][$key]);
				    $ret = true;
				    if (0 == count($_SESSION['order']['items'][$id])) {
				    	unset($_SESSION['order']['items'][$id]);
				    }
				}		
			}
			if (0 == count($_SESSION['order']['items'])) {
			    unset($_SESSION['order']);
			}
		} else if (0 == func_num_args()) {
		    unset($_SESSION['order']);
		}
		return $ret;
	}


	/**
	 * Enter description here...
	 *
	 * @param unknown_type $customer
	 * @param unknown_type $email
	 * @param unknown_type $phone
	 * @param unknown_type $country
	 * @param unknown_type $region
	 * @param unknown_type $city
	 * @param unknown_type $zip_code
	 * @param unknown_type $address
	 * @param unknown_type $payment_type
	 * @param unknown_type $organization
	 * @param unknown_type $inn
	 * @param unknown_type $rs
	 * @param unknown_type $ks
	 * @param unknown_type $bank
	 * @param unknown_type $bik
	 * @param unknown_type $additional
	 * @return unknown
	 */
	function process_order($customer, $email, $phone, $country, $region, $city, 
	    $zip_code, $address, $payment_type, $organization, $inn, $rs, $ks, $bank,
	    $bik, $additional, $notify = 0
	) {   
	    global $CONFIG, $main, $lang, $db, $tpl, $tpl_path;

	    $email = !$email && $_SESSION['siteuser']['id'] ? $_SESSION['siteuser']['email'] : $email;
		if ($customer && $email && $payment_type && is_array($_SESSION['order'])) {
			$user_id		= (int)$_SESSION['siteuser']['id'];
			$user_type		= $_SESSION['siteuser']['client_type'] ? $_SESSION['siteuser']['client_type'] : 1;
			$sum			= (int)$_SESSION['order']['sum'];
			$custumer		= strip_tags($customer);
			$email			= strip_tags($email);
			$phone			= strip_tags($phone);
			$country		= strip_tags($country);
			$region			= strip_tags($region);
			$city			= strip_tags($city);
			$zip_code		= strip_tags($zip_code);
			$address		= strip_tags($address);
			$payment_type	= strip_tags($payment_type);
			$organization	= strip_tags($organization);
			$inn			= strip_tags($inn);
			$rs				= strip_tags($rs);
			$ks				= strip_tags($ks);
			$bank			= strip_tags($bank);
			$bik			= strip_tags($bik);
			$adds			= strip_tags($additional);

			if ($organization) {
				$_SESSION['siteuser']['company'] = $organization;
			}

			/* Если оплата WebMoney - учитываем скидку/надбавку */
			if (4 == $payment_type && $CONFIG['shop_WM_discount']) {
				//$_SESSION['order']['sum'] = $_SESSION['order']['sum'] + $_SESSION['order']['sum']*$CONFIG['shop_WM_discount']/100;

				/* Учитываем скидку/надбавку WebMoney */
				$_SESSION['order']['discount'] += $_SESSION['order']['cost']*$CONFIG['shop_WM_discount']/100;
				$_SESSION['order']['cost']		= $_SESSION['order']['sum'] + $_SESSION['order']['discount'];
			}

			/* Если оплата ASSIST - учитываем скидку/надбавку */
			if (5 == $payment_type && $CONFIG['shop_assist_discount']) {
				/* Учитываем скидку/надбавку WebMoney */
				$_SESSION['order']['discount'] += $_SESSION['order']['cost']*$CONFIG['shop_assist_discount']/100;
				$_SESSION['order']['cost']		= $_SESSION['order']['sum'] + $_SESSION['order']['discount'];
			}

			$_SESSION['order']['sum'] = number_format($_SESSION['order']['sum'], 2, ".", "");
			$_SESSION['order']['discount'] = number_format($_SESSION['order']['discount'], 2, ".", "");
			$_SESSION['order']['cost'] = number_format($_SESSION['order']['cost'], 2, ".", "");
            
            $dlvr = $this->getDelivery($_SESSION['order']['delivery_id']);

            //$tpl = new AboTemplate($tpl_path.$this->module_name.'_processorder_mail.html', true);
            Main::include_main_blocks($this->module_name.'_processorder_mail.html', 'main');
            $tpl->prepare();
            //$tpl->newBlock($block_name);
            $date = date('d-m-Y H:i');
            $assign = array(
                'site_name' => $CONFIG['sitename_rus'],
                'site_address' => $CONFIG['web_address'],
                'recipient' => $CONFIG['return_email'],
                'referer' => $_SERVER['HTTP_REFERER'],
                'date' => $date,
                'custumer' => $custumer ? $custumer : $__n,
                'phone' => $phone ? $phone : $__n,
                'zip_code' => $zip_code ? $zip_code : $__n,
                'region' => $region ? $region : $__n,
                'city' => $city ? $city : $__n,
                'address' => $address ? $address : $__n,
                'email' => $email ? $email : $__n,
                'payment_type' => $payment_type ? $CONFIG['order_pay_types'][$payment_type] : $__n,
                'organization' => $organization ? $organization : $__n,
                'inn' => $inn ? $inn : $__n,
                'rs' => $rs ? $rs : $__n,
                'ks' => $ks ? $ks : $__n,
                'bank' => $bank ? $bank : $__n,
                'bik' => $bik ? $bik : $__n,
                'adds' => $adds ? $adds : $__n,
                'curr' => $CONFIG['catalog_currencies'][$_SESSION['order']['currency']],
                'sum' => Catalog::formatPrice($_SESSION['order']['sum']),
                'discount' => Catalog::formatPrice($_SESSION['order']['discount']),
                'cost' => Catalog::formatPrice($_SESSION['order']['cost']),
                'dlvr_cost' => Catalog::formatPrice($dlvr['cost'])
            );
            
            $tpl->assign($assign);
            
            $__n =  $main->_msg["NO"];

			$org	= $organization			? $this->_msg["Organization"] . ': '.$organization."\n"	: $this->_msg["Organization"] .': '.$__n."\n";
			$org	.= $inn						? $this->_msg["INN_KPP"] . ': '.$inn."\n"				: $this->_msg["INN_KPP"] .': '.$__n."\n";
			$org	.= $rs						? $this->_msg["RS"] . ': '.$rs."\n"						: $this->_msg["RS"] .': '.$__n."\n";
			$org	.= $ks						? $this->_msg["KS"] . ': '.$ks."\n"						: $this->_msg["KS"] .': '.$__n."\n";
			$org	.= $bank					? $this->_msg["Bank"] . ': '.$bank."\n"					: $this->_msg["Bank"] . ': '.$__n."\n";
			$org	.= $bik						? $this->_msg["BIK"] . ': '.$bik."\n"					: $this->_msg["BIK"] .': '.$__n."\n";
			
			$adr	= $address					? $this->_msg["Address"] . ': '.$address."\n"	: $this->_msg["Address"].': '.$__n."\n";

			$ctlg = Module::load_mod('catalog', 'only_create_object');
			$prod_list = $this->getCartProdList();
			$ord_prop_list = $ctlg->getOrderPropList();
		    foreach ($_SESSION["order"]["items"] as $prod_id => $val) {
		        foreach ($val as $k => $v) {
		    	    $tpl->newBlock('goods');
		    	    $tpl->assign(array(
		    	        'id' => $prod_id,
		    	        'title' => $prod_list[$prod_id]['title'],
		    	        'curr' => $CONFIG['catalog_currencies'][$prod_list[$prod_id]['currency']],
		    	        'price' => Catalog::formatPrice($prod_list[$prod_id]['price']),
		    	        'cnt' => $v['cnt']
		    	    ));
    				if (! empty($v['prop'])) {
    				   $tpl->newBlock('prop_list');
    				    foreach ($v['prop'] as $pk => $pv) {
    				        $tpl->newBlock('prop_list_item');
        				    $tpl->assign(array(
        				        'title' => $ord_prop_list[$pk]['title'],
        				        'value' => $ord_prop_list[$pk]['val'][$pv]
        				    ));
        				}
    				}
		    	}
		    }

			/* Если оплата WebMoney - учитываем скидку/надбавку */
			if (4 == $payment_type && $CONFIG['shop_WM_discount']) {
			    $tpl->newBlock('webmoney');
			    $tpl->assign('discount', $CONFIG['shop_WM_discount']);
			}
			/* Если оплата ASSIST - учитываем скидку/надбавку */
			if (5 == $payment_type && $CONFIG['shop_assist_discount']) {
			    $tpl->newBlock('assist');
			    $tpl->assign('discount', $CONFIG['shop_assist_discount']);
			}
			
			$order_id = $this->add_order($adr, $org, $adds, $custumer, $email, $phone, $payment_type, $notify);
			
			$tpl->gotoBlock('_ROOT');
			$tpl->assign('order_id', $order_id);
			
			$subject = "{$this->_msg["Order"]} №{$order_id}. {$this->_msg['From']} {$custumer} {$this->_msg['on_site']} {$CONFIG['sitename_rus']}";
			
			$body = $tpl->getOutputContent();
			
			require_once(RP.'/inc/class.Mailer.php');
			$mail = new Mailer();
			
			$addr = $this->_msg["Order_confirmed"] . "\n\n".$addr;
			$mail = new Mailer();
			$mail->CharSet		= $CONFIG['email_charset'];
			$mail->ContentType	= "text/html"; //$CONFIG['email_type'];
			$mail->From			= $CONFIG['shop_order_recipient'];
			$mail->FromName		= $CONFIG['sitename_rus'];
			$mail->Mailer		= 'mail';
			$mail->AddAddress($email);
			$mail->Subject		= $subject;
			$mail->Body			= $body;
			$mail->Send();
			
			/*
			$tpl->newBlock('admin');
			$assign['edit_link'] = 'http://'.$_SERVER['HTTP_HOST'].'/admin.php?lang='.$lang.'&name=shop&action=vieworder&id='.$order_id;
			*/
			$tpl->assign($assign);
            $mail->CharSet		= $CONFIG['email_charset'];
            $mail->ContentType	= "text/html"; //$CONFIG['email_type'];
            $mail->From			= $email;
            $mail->Mailer		= 'mail';
            $mail->AddAddress($CONFIG['shop_order_recipient']);
            $mail->Subject		= $subject;
            $mail->Body			= $body;
            $mail->Send();
			
			unset($_SESSION['order']);

			return $order_id;
		}
		return FALSE;
	}

	function getAddress($data) {
		if ($data) {
			if ($data['index']) {
				$address .= $data['index'];
				$_SESSION['siteuser']['index'] = $data['index'];
			} else {
				$_SESSION['siteuser']['index'] = '';
			}
			if ($data['obl_kray'])	{
				if ($address) {$address .= ', ';}
				$address .= $data['obl_kray'];
				$_SESSION['siteuser']['obl_kray'] = $data['obl_kray'];
			} else {
				$_SESSION['siteuser']['obl_kray'] = '';
			}
			if ($data['region'])	{
				if ($address) {$address .= ', ';}
				$address .= $data['region'];
				$_SESSION['siteuser']['region'] = $data['region'];
			} else {
				$_SESSION['siteuser']['region'];
			}
			if ($data['naspunkt'])	{
				if ($address) {$address .= ', ';}
				$address .= $data['naspunkt'];
				$_SESSION['siteuser']['naspunkt'] = $data['naspunkt'];
			} else {
				$_SESSION['siteuser']['naspunkt'];
			}
			if ($data['address'])	{
				if ($address) {$address .= ', ';}
				$address .= $data['address'];
				$_SESSION['siteuser']['address'] = $data['address'];
			} else {
				$_SESSION['siteuser']['address'];
			}
			return $address;
		}
		return FALSE;
	}

	// Функция для добавления заказа в БД
	function add_order($address, $org = '', $adds = '', $custumer = '', $email = '', $phone = '', $payment_type = '', $notify = 0)
	{   global $CONFIG, $PAGE, $db, $server, $lang;

		$user_id = (int)$_SESSION['siteuser']['id'];
		$db->query('SELECT * FROM core_users WHERE id = '.$user_id);
		if ($db->nf() > 0) {
			for ($i = 0; $i < $db->nf(); $i++) {
				$db->next_record();
				$user[$i]['id']				= $db->f('id');
				$user[$i]['group_id ']		= $db->f('group_id');
				$user[$i]['client_type']	= $db->f('client_type ');
				$user[$i]['siteusername']	= $db->f('username');
				$user[$i]['password']		= $db->f('password');
				$user[$i]['surname']		= $db->f('surname');
				$user[$i]['firstname']		= $db->f('firstname');
				$user[$i]['company']		= $db->f('company');
				$user[$i]['activity']		= $db->f('activity');
				$user[$i]['post']			= $db->f('post');
				$user[$i]['phone']			= $db->f('phone');
				$user[$i]['email']			= $db->f('email');
				$user[$i]['last_visit']		= $db->f('last_visit');
				$user[$i]['is_new']			= $db->f('is_new');
				$user[$i]['active']			= $db->f('active');
				$user[$i]['get_subscr']		= $db->f('get_subscr');
			}
		}
		$sum			= (double)$_SESSION['order']['sum'];
		$cost			= (double)$_SESSION['order']['cost'];
		$discount		= (double)$_SESSION['order']['discount'];
		$org			= $db->escape($org);
		$adds			= $db->escape($adds);
		$currency		= $db->escape($_SESSION['order']['currency']);
		$organization	= $db->escape($_SESSION['siteuser']['company']);
		$custumer		= $custumer ? $custumer : $user[0]['surname'].' '.$user[0]['firstname'];
		$email			= $email ? $email : $user[0]['email'];
		$phone			= $phone ? $phone : $user[0]['phone'];
		$$payment_type	= $payment_type > 1 ? (int)$payment_type : $CONFIG['order_default_pay_type'];
		$notify = $notify ? 1 : 0;

        $user_id = intval($user[0]['id']);
        $dlvr_id = $dlvr_cost = 0;
        if ($_SESSION['order']['delivery_id'] && ($dlvr = $this->getDelivery($_SESSION['order']['delivery_id'])) ) {
            $dlvr_id = $dlvr['id'];
            $dlvr_cost = (float)$dlvr['cost'];
        }
		$db->query("INSERT INTO {$this->table_prefix}_shop_orders (customer, type,"
		    ."siteuser_id, delivery_id, delivery_cost, phone, address, "
		    ."email, organization, jpinfo, `date`, addinfo, sum, discount, "
		    ." total_sum, currency, pay_type, session, notify) "
		    ."VALUES ('".$custumer."', '{$CONFIG['siteusers_client_types'][$_SESSION['siteuser']['client_type']]}', "
		    .$user_id.", {$dlvr_id}, {$dlvr_cost}, '{$phone}', '{$address}', "
			."'{$email}', '{$organization}', '{$org}', NOW(), '{$adds}', {$sum}, {$discount}, "
			."{$cost}, '{$currency}', {$payment_type}, '".($user_id ? '' : session_id())."', {$notify})");
		if ($db->affected_rows() > 0) {
			$lid = $db->lid();
			$this->add_order_items($lid);
			return $lid;
		} else {
			return FALSE;
		}
	}


	// Функция для добавления заказанных товаров в БД
	function add_order_items($id = 0)
	{   global $CONFIG, $db, $server, $lang;
		
		$id = (int)$id;
		if (!$id) {
		    return FALSE;
		}

		$ctlg = Module::load_mod('catalog', 'only_create_object');
		$prod_list = $this->getCartProdList();
		$ord_prop_list = $ctlg->getOrderPropList();
		$ins = array();
		foreach ($_SESSION["order"]["items"] as $prod_id => $val) {
		    foreach ($val as $k => $v) {
		        $inf = '';
    			if (! empty($v['prop'])) {
    				foreach ($v['prop'] as $pk => $pv) {
        				$inf .= $ord_prop_list[$pk]['title'] . ' - ' . $ord_prop_list[$pk]['val'][$pv].'; ';
        			}
        			$inf = serialize(array('dscr' => $inf, 'prop' => $v['prop']));
    			}
    			$title = My_Sql::escape($prod_list[$prod_id]['title']);
    			$code = My_Sql::escape($prod_list[$prod_id]['code']);
    			$price = $prod_list[$prod_id]['price'];
    			$rate = $_SESSION['catalog_rates'][$CONFIG['shop_order_concurency'].'/'.$prod_list[$prod_id]['currency']];
    			$sum = $this->exchange($price*$v['cnt'], $prod_list[$prod_id]['currency'], $CONFIG['shop_order_concurency']);
    			$ins[] = "({$id}, {$prod_id}, '{$title}', '{$code}', '{$price}', "
		            ."'{$prod_list[$prod_id]['currency']}', '{$rate}', "
		            ."'{$v['cnt']}', '{$sum}', '{$inf}')";
		    }
		}
		if (!empty($ins)) {
		    $db->query("INSERT INTO {$this->table_prefix}_shop_order_items "
		       ."(order_id, item_id, item_name, item_code, item_price, "
		       ."item_currency, item_rate, item_qty, item_cost, info) VALUES "
		       .implode(", ", $ins));
			$this->do_export_XML();
		}
		return TRUE;
	}


	// обработка цены
	function get_item_price($qty, $item_array = array()) {
		// для Сеула:
		if ($_SESSION["siteuser"]["is_authorized"]) {
			$price = $item_array["price{$_SESSION["siteuser"]["client_type"]}"];
		} else {
			$price = $item_array["price1"];
		}
		return preg_replace("/[^0-9]/", "", $price);
	}


	// Функция для пересчета корзины покупок
	function recalculate_cart($prods = array(), $delivery = 0)
	{   global $CONFIG;
	
		$prod_list = $this->getCartProdList();
		if (! empty($prod_list)) {
		    foreach ($_SESSION["order"]["items"] as $key => $val) {
		    	if (! array_key_exists($key, $prod_list)) {
		    	    unset($_SESSION["order"]["items"][$key]);
		    	} else {
		    	    foreach ($val as $k => $v) {
		    	        if (isset($prods[$key])) {
    		    	        $cart_key = $v['key'] ? $v['key'] : 0;
    		    	        if ($prods[$key][$cart_key] <= 0) {
    		    	            $this->delete_item_from_cart($key, $cart_key);
    		    	            $v['cnt'] = 0;
    		    	        } else {
    		    	            $v['cnt'] = $_SESSION["order"]["items"][$key][$k]['cnt'] = (int) $prods[$key][$cart_key];
    		    	        }
    		    	    }
    		    	    if ($v['cnt'] > 0) {
    		    	        $prod_sum = ShopPrototype::exchange($v['cnt']*$prod_list[$key]['price'], $prod_list[$key]['currency'], $CONFIG['shop_order_concurency']);
                			$sum += $prod_sum;
                			$total += $v['cnt'];  
    		    	    }
    		    	}
		    	}
		    }
		    $_SESSION['order']['sum'] = number_format(round($sum), 2, ".", ""); // Полная стоимость
			$accmlt_dscnt = $this->getAccumulativeDiscount($_SESSION['order']['sum'], $CONFIG['shop_order_concurency']); //Накопительная скидка
			$simple_dscnt = $this->getSimpleDiscount($_SESSION['order']['sum'], $CONFIG['shop_order_concurency']);
			$_SESSION['order']['discount'] = 0;
			$_SESSION['order']['discount_id'] = 0;
			$_SESSION['order']['discount_is_simple'] = 0;
			if ($simple_dscnt && $simple_dscnt['discount_sum'] >= $accmlt_dscnt['discount_sum']) {
				$_SESSION['order']['discount'] = $simple_dscnt['discount_sum'];
    			$_SESSION['order']['discount_id'] = $simple_dscnt['discount_id'];
    			$_SESSION['order']['discount_is_simple'] = 1;
			} else if ($accmlt_dscnt && $accmlt_dscnt['discount_sum'] > $simple_dscnt['discount_sum']) {
			    $_SESSION['order']['discount'] = $accmlt_dscnt['discount_sum'];
    			$_SESSION['order']['discount_id'] = $accmlt_dscnt['id'];
    			$_SESSION['order']['discount_is_simple'] = 0;
			}
			$_SESSION['order']['delivery_id'] = 0;
			$_SESSION['order']['delivery_cost'] = 0;
			$dlvr = $this->getDelivery($delivery);
			if ($dlvr) {
			    $_SESSION['order']['delivery_id'] = $dlvr['id'];
			    $_SESSION['order']['delivery_cost'] = $dlvr['cost']>0 ? $dlvr['cost'] : 0;
			}
			$_SESSION['order']['cost']		= number_format($_SESSION['order']['sum'] - $_SESSION['order']['discount'] + $_SESSION['order']['delivery_cost'], 2, ".", ""); // Стоимость с учётом скидки
			$_SESSION['order']['currency']	= $CONFIG['shop_order_concurency'];
			$_SESSION['order']['total']		= $total;
		} else {
		    unset ($_SESSION['order']);
		}
	}

	function showPayTypes($block_name = 'block_pay_types')
	{   global $CONFIG, $tpl;

		foreach ($CONFIG['order_pay_types'] as $key => $val) {
			if ($key != 4 || (4 == $key && $CONFIG['shop_WM_activ']) ) {
				$tpl->newBlock('block_pay_types');
				$tpl->assign(array('title' => $val, 'value' => $key));
			}
		}
	}

	function getCompanyInfo()
	{   global $CONFIG;

		return array(
			'concurency_id' => $CONFIG['order_concurency'],
			'concurency' => $CONFIG['catalog_currencies'][$CONFIG['order_concurency']],
			'company' => $CONFIG['shop_company'],
			'inn' => $CONFIG['shop_inn'],
			'kpp' => $CONFIG['shop_kpp'],
			'bank' => $CONFIG['shop_bank'],
			'sett_account' => $CONFIG['shop_sett_account'],
			'corr_account' => $CONFIG['shop_corr_account'],
			'bik' => $CONFIG['shop_bik'],
			'order_recipient' => $CONFIG['shop_order_recipient']
		);
	}

	/**
	 * Изменить состояние заказа.
	 *
	 * Изменение сохраняется в "истории изменений соссояний заказа"
	 *
	 * @param int $order_id
	 * @param int $status
	 * @param string $info
	 * @return unknown
	 */
	function setOrderStatus($order_id, $status)
	{   global $CONFIG, $db, $main;

		$order_id = (int) $order_id;
		if (!$order = $this->getOrder($order_id)) {
			return FALSE;
		}
		$manager_id = (int)$_SESSION['siteuser']['id'];
		$status = (int) $status;
		$status_list = $this->getOrdStatusList();
		if ($order['status'] == $status || !array_key_exists($status, $status_list)) {
			return FALSE;
		}

		$query = "UPDATE {$this->table_prefix}_shop_orders SET status={$status}, "
		    ."manager_id={$manager_id} WHERE id={$order_id}";
		$db->query($query);
		if (!$db->affected_rows()) {
			return FALSE;
		}
		$info = My_Sql::escape($status_list[$order['status']]['title']." -> ".$status_list[$status]['title']);
		$query = "INSERT INTO ".$this->table_prefix."_shop_order_history";
		$query .= " (order_id, manager_id, old_status, new_status, `date`, info) VALUES";
		$query .= " ({$order['order_id']}, {$manager_id}, '{$order['status']}', {$status}, NOW(), '{$info}')";
		$db->query($query);
		
		$order = $this->getOrder($order_id);
		if ($order['notify'] && $order['email']) {
		    $tpl = new AboTemplate(RP.'tpl/'.SITE_PREFIX.'/'.$this->module_name.'_mail_notify.html');
		    $tpl->prepare();
		    $tpl->assign(array(
		        'order_id' => $order['order_id'],
		        'site_name' => $CONFIG['sitename_rus'],
		        'status_name' => $order['order_status'],
		        'host' => $CONFIG['host'],
		    ));
		    
		    $subject = "Изменение статуса заказа №{$order_id} на сайте {$CONFIG['sitename_rus']}";
			require_once(RP.'/inc/class.Mailer.php');
			$mail = new Mailer();
            $mail->CharSet		= $CONFIG['email_charset'];
            $mail->ContentType	= "text/html"; //$CONFIG['email_type'];
            $mail->From			= $CONFIG['shop_order_recipient'];
            $mail->Mailer		= 'mail';
            $mail->AddAddress($order['email']);
            $mail->Subject		= $subject;
            $mail->Body			= $tpl->getOutputContent();
            $mail->Send();
		}

		return TRUE;
	}
	
	function setOrderNotes($order_id, $notes)
	{   global $CONFIG, $db;
	
		$db->query("UPDATE {$this->table_prefix}_shop_orders SET notes='"
		    .My_Sql::escape(htmlspecialchars($notes))
		    ."' WHERE id=".intval($order_id));
		return $db->affected_rows() ? TRUE: FALSE;
	}
	

	function exchange($sum, $from_cur, $to_cur)
	{   global $CONFIG;

		if (!array_key_exists($from_cur, $CONFIG['catalog_currencies'])
			|| !array_key_exists($to_cur, $CONFIG['catalog_currencies'])
			//|| !is_numeric($sum)
		) {
			return FALSE;
		}

		return $to_cur != $from_cur ? $sum * $_SESSION['catalog_rates'][$from_cur . '/' . $to_cur] : $sum;
	}

	function getFilterCondition()
	{
		if (!isset($_REQUEST['filter']) && !isset($_SESSION['shop_fltr']) ) {
			return "";
		}

		$f = $_REQUEST['filter'] ? $_REQUEST['filter'] : $_SESSION['shop_fltr'];
		$_SESSION['shop_fltr'] = $f;
		$op = "AND";
		$condtn = array();
		
		if (isset($f['status']) && $f['status'] >= 0) {
			$condtn[] = "status = '".intval($f['status'])."'";
		}

		$date_from = @$f['date_from'] ? Main::transform_date(My_Sql::escape($f['date_from'])) : "";
		$date_to = @$f['date_to'] ? Main::transform_date(My_Sql::escape($f['date_to'])) : "";
		if ($date_from && !$date_to) {
			$condtn[] = "date >= '".$date_from."'";
		} elseif ($date_to && !$date_from) {
			$condtn[] = "date <= '".$date_to."'";
		} elseif ($date_from && $date_to) {
			$condtn[] = "date BETWEEN '".$date_from."' AND '".$date_to."'";
		}

		$customer = @$f['customer'] ? My_Sql::escape($f['customer']) : "";
		if ($customer) {
			$condtn[] = "(customer LIKE '%".$customer."%' OR O.email LIKE '%".$customer."%')";
		}

		if (@$f['reg_user']) {
			$condtn[] = "siteuser_id";
		}
		if ($f['custm_type']!='' && in_array($f['custm_type'], $this->client_types)) {
			$condtn[] = "type='".My_Sql::escape($f['custm_type'])."'";
		}
		if (isset($f['manager']) && $f['manager'] > 0) {
			$condtn[] = "manager_id='".intval($f['manager'])."'";
		}
		
		return implode(" ".$op." ", $condtn);
	}

	function showFilter()
	{   global $tpl, $baseurl, $lang;

		$f = isset($_REQUEST['filter']) ? $_REQUEST['filter'] : $_SESSION['shop_fltr'];
		$start = isset($_REQUEST['start']) && $_REQUEST['start'] > 1 ? (int)$_REQUEST['start'] : 1;
		$tpl->newBlock("block_filter");
		$tpl->assign(Array(
			"MSG_Filter" => $this->_msg["Filter"],
			"MSG_Date_from" => $this->_msg["Date_from"],
			"MSG_Select" => $this->_msg["Select"],
			"MSG_date_to" => $this->_msg["date_to"],
			"MSG_Status" => $this->_msg["Status"],
			"MSG_All" => $this->_msg["All"],
			"MSG_Customer_FIO_Email" => $this->_msg["Customer_FIO_Email"],
			"MSG_Registered" => $this->_msg["Registered"],
			"MSG_Customer_type" => $this->_msg["Customer_type"],
			"MSG_Select" => $this->_msg["Select"],
			"MSG_Reset" => $this->_msg["Reset"],
			"MSG_Responsible" => $this->_msg["Responsible"],
		));

		$date_from = isset($f['date_from']) ? htmlspecialchars($f['date_from']) : "";
		$date_to = isset($f['date_to']) ? htmlspecialchars($f['date_to']) : "";
		$customer = isset($f['customer']) ? htmlspecialchars($f['customer']) : "";
		$reg_user = isset($f['reg_user']) ? "checked" : "";

		$tpl->assign(
			array(
				"baseurl" => $baseurl,
				"lang" => $lang,
				"start" => $start,
				"filter_checked" => ! empty($f) ? "checked" : "",
				"filter_display" => ! empty($f) ? "block" : "none",
				"date_from_val" => $date_from,
				"date_to_val" => $date_to,
				"customer_val" => $customer,
				"reg_user_val" => $reg_user,
			)
		);

		$selct = isset($f['status']) && $f['status'] >= 0 ? $f['status'] : -1;
		$list = $this->getOrdStatusList();
		foreach ($list as $val) {
		    $tpl->newBlock('block_order_status');
			$val['selected'] = $val['id'] == $selct ? 'selected' : '';
			$tpl->assign($val);
		}

		$tpl->newBlock('block_custm_types');
		$tpl->assign(
			array(
				"elm_idx" => 0,
				"elm_val" => $this->_msg["All"],
 				"checked" => !$f['custm_type'] ? "checked" : ""

			)
		);

		if (is_array($this->client_types)) {
			foreach ($this->client_types as $key => $val) {
				$tpl->newBlock('block_custm_types');
				$tpl->assign(
					array(
						"elm_idx" => $key,
						"elm_val" => $val,
						#"checked" => (strcmp($val,$f['custm_type'])==0) ? "checked" : ""
						"checked" => (strcmp($val,$f['custm_type'])==0)  ? "selected" : ""
					)
				);
			}
		}
		
		$list = $this->getManagersList();
		$selct = isset($f['manager']) && $f['manager'] >= 0 ? $f['manager'] : -1;
		if ($list) {
		    foreach ($list as $val) {
    		    $tpl->newBlock('block_manager');
    			$val['selected'] = $val['id'] == $selct ? 'selected' : '';
    			$tpl->assign($val);
    		}
		}		

	}

	function getFilterHref()
	{
		$f = isset($_REQUEST['filter']) ? $_REQUEST['filter'] : array();

		$href = @$_REQUEST['filter_check'] ? "&filter_check=".$_REQUEST['filter_check'] : "";

		$href .= isset($f['status']) && $f['status'] >= 0 ? "&filter[status]=".(int)$f['status'] : "";

		$href .= @$f['date_from'] ? "&filter[date_from]=".@$f['date_from'] : "";

		$href .= @$f['date_to'] ? "&filter[date_to]=".$f['date_to'] : "";

		$href .= @$f['customer'] ? "&filter[customer]=".$f['customer'] : "";
		
		$href .= @$f['manager'] ? "&filter[manager]=".$f['manager'] : "";

		$href .= @$f['reg_user'] ? "&filter[reg_user]=1" : "";

		$href .= @$f['custm_type'] > 0 && array_key_exists($f['custm_type'], $this->client_types)
			? "&filter[custm_type]=".(int)$f['custm_type'] : "";

		return $href;
	}

	function getManagersList()
	{   global $db;
		$ret = false;
		$db->query("SELECT DISTINCT manager_id, username FROM {$this->table_prefix}_shop_orders O LEFT JOIN core_users U ON U.id=manager_id WHERE manager_id>0 ORDER BY username");
		while ($db->next_record()) {
			$ret[$db->Record['manager_id']] = array(
			    'id' => $db->Record['manager_id'],
			    'username' => $db->Record['username'] ? $db->Record['username'] : "user{$db->Record['id']}",
			);
		}
		return $ret;
	}
	function do_export_XML() {
		global $CONFIG, $lang;
		$doc = domxml_new_doc("1.0");
		$root = $doc->add_root("orders");
		$root->set_attribute("date", gmdate('d.m.Y H:i:s').date("O"));
		$root->set_attribute("lang", $lang);
		if ($this->get_orders_XML($doc, $root)) {
			$out = $doc->dump_mem(TRUE, 'UTF-8');

			$file	= $CONFIG['shop_export_path'].'orders_'.gmdate('Ymd_His').substr(date("O"), 0, 3).'.xml';
			$handle = fopen(RP.$file, 'w');
			fwrite($handle, $out);
			fclose($handle);
			return $file;
		} else {
			return false;
		}
	}

	function get_orders_XML(&$doc, &$parent) {
		global $db, $CONFIG;

		$query = "SELECT o.id, o.siteuser_id, o.delivery_id, o.manager_id, o.delivery_cost, "
		    ."o.customer, o.type, o.address, o.phone, o.email, o.organization, o.jpinfo, "
		    ."DATE_FORMAT(o.date,'%Y.%m.%d %H:%i:%s') AS date, o.sum, o.discount, o.total_sum, "
		    ."o.currency, o.addinfo, o.status, o.pay_type, o.session, o.notes,"
		    ."oi.item_id, oi.item_name, oi.item_code, oi.item_price, item_currency, item_rate, "
		    ."oi.item_qty, item_cost, oi.info AS item_info "
		    ."FROM `".$this->table_prefix."_shop_orders` o "
		    ."LEFT JOIN `".$this->table_prefix."_shop_order_items` oi ON o.id = oi.order_id "
		    ." ORDER BY o.id,oi.item_rate";
		$db->query($query);
		$cur_order_id = 0;
		if ($db->nf()) {
			while ($db->next_record()) {
				$order_id = $db->f('id');
				if ($cur_order_id != $order_id) {
					$orders[] = $order_id;
					$cur_order_id = $order_id;
					$order = $doc->create_element("order");
					$order->set_attribute("id", $order_id);
					$order->set_attribute("user_id", $db->f('siteuser_id'));
					$order->set_attribute("manager_id", $db->f('manager_id'));
					$order = $parent->append_child($order);
					$order->new_child("customer", $this->conv_str($db->f('customer')));
					$node = $order->new_child("delivery", floatval($db->f('delivery_cost')));
					$node->set_attribute("id", intval($db->f('delivery_id')));
					$order->new_child("type", $this->conv_str($db->f('type')));
					$order->new_child("address", $this->conv_str($db->f('address')));
					$order->new_child("phone", $this->conv_str($db->f('phone')));
					$order->new_child("email", $this->conv_str($db->f('email')));
					$order->new_child("organization", $this->conv_str($db->f('organization')));
					$order->new_child("jpinfo", $this->conv_str($db->f('jpinfo')));
					$order->new_child("date", $this->conv_str($db->f('date')));
					$order->new_child("sum", floatval($db->f('sum')));
					$order->new_child("discount", floatval($db->f('discount')));
					$order->new_child("total", floatval($db->f('total_sum')));
					$order->new_child("currency", $this->conv_str($db->f('currency')));
					$order->new_child("addinfo", $this->conv_str($db->f('addinfo')));
					$order->new_child("status", intval($db->f('status')));
					$payment = $order->new_child("payment", $this->conv_str($CONFIG['order_pay_types'][intval($db->f('pay_type'))]));
					$payment->set_attribute("type", intval($db->f('pay_type')));
					$order->new_child("session", $this->conv_str($db->f('session')));
					$order->new_child("notes", $this->conv_str($db->f('notes')));
					$items = $doc->create_element("items");
					$items = $order->append_child($items);
				}
				if ($db->f('item_id') > 0) {
				    $product = $doc->create_element("product");
    				$product->set_attribute("id", intval($db->f('item_id')));
    				$product->set_attribute("quantity", intval($db->f('item_qty')));
    				$product = $items->append_child($product);
    				$product->new_child("code", $this->conv_str($db->f('item_code')));
    				$product->new_child("name", $this->conv_str($db->f('item_name')));
    				$product->new_child("price", floatval($db->f('item_price')));
    				$product->new_child("currency", $this->conv_str($db->f('item_currency')));
    				$product->new_child("rate", floatval($db->f('item_rate')));
    				$product->new_child("cost", floatval($db->f('item_cost')));
    				$product->new_child("info", $this->conv_str($db->f('item_info')));
				}				
			}
			return true;
		} else {
			return false;
		}
	}

	function getPropertyFields() {
		GLOBAL $request_sub_action;
		if ('' != $request_sub_action) {

			$tpl = $this->getTmpProperties();

			switch ($request_sub_action) {
				default:
					$tpl->newBlock('block_properties_none');
					$tpl->assign(Array(
						"MSG_No" => $this->_msg["No"],
					));
					$result = $this->getOutputContent($tpl->getOutputContent());
					break;
			}
			return $result;
		}
		return FALSE;
	}

	function getEditLink($sub_action = NULL, $block_id = NULL) {
		GLOBAL $request_name, $db, $lang, $server;
		$block_id	= (int)$block_id;
/*
		if ($sub_action && $block_id) {
			$db->query('SELECT	property1,
								property2,
								property3,
								property4,
								property5
							FROM '.$server.$lang.'_pages_blocks
							WHERE id = '.$block_id);
			if ($db->nf() > 0) {
				$db->next_record();
				$arr[]	= $db->f('property1');
				$arr[]	= $db->f('property2');
				$arr[]	= $db->f('property3');
				$arr[]	= $db->f('property4');
				$arr[]	= $db->f('property5');

				switch ($sub_action) {
					case 'showbanner':
						$link['material_url']	= '/admin.php?lang='.$lang.'&name='.$request_name.'&action=showbanners&category=';
						$link['material_id']	= $arr[0];
						break;
				}
				return $link;
			}

			switch ($sub_action) {
				case 'showbanner':
					$link['material_url']	= '/admin.php?lang='.$lang.'&name='.$request_name.'&action=showbanners&category=';
					$link['material_id']	= '';
					break;
			}
			return $link;
		}
*/
		return FALSE;
	}

	function getDiscountsAdm($url, $start) {
        global $CONFIG, $db, $server, $lang;
		$start = (int)$start;
		if (!$start) {$start = 1;}
		$db->query('SELECT *, DATE_FORMAT(from_date, "'.$CONFIG['calendar_date'].'") AS from_date, DATE_FORMAT(to_date, "'
		    .$CONFIG['calendar_date'].'") AS to_date FROM '.$server.$lang.'_shop_discounts LIMIT '.(($start-1)*$CONFIG['shop_max_rows'])
		    .', '.$CONFIG['shop_max_rows']);
        if ($db->nf() > 0) {
            for ($i = 0; $i < $db->nf(); $i++) {
            	$db->next_record();
       			$arr[$i]['id']			= $db->f('id');
           		$arr[$i]['name']		= htmlspecialchars($db->f('name'));
           		$arr[$i]['value']		= $db->f('value');
           		$arr[$i]['min']			= $db->f('min');
           		$arr[$i]['max']			= $db->f('max');
    			$arr[$i]['from_date']    = $db->f('from_date');
    			$arr[$i]['to_date']		= $db->f('to_date');
           		$arr[$i]['is_percent']	= $db->f('is_percent') ? '%' : 'абс.';
           		$arr[$i]['active']		= $db->f('active');
           		$arr[$i]['img_stat']	= $db->f('active') ? 'ico_swof.gif' : 'ico_swon.gif';
                $arr[$i]['act_stat']	= $db->f('active') ? $this->_msg["Suspend"] : $this->_msg["Activate"];
           		$arr[$i]['active_id']	= $db->f('active') ? $url.'&action=dsnt_d&id='.$db->f('id').'&start='.$start : $url.'&action=dsnt_a&id='.$db->f('id').'&start='.$start;
           		$arr[$i]['edit_id']		= $url.'&action=dsnt&id='.$db->f('id').'&step=3&start='.$start;
           		$arr[$i]['del_id']		= $url.'&action=dsnt_del&id='.$db->f('id').'&start='.$start;
			}
        	return $arr;
        }
    	return FALSE;
    }

    function getDiscount($id) {
        global $CONFIG, $db, $server, $lang;
		$id = (int)$id;
		if ($id) {
			$db->query('SELECT *, DATE_FORMAT(from_date, "'.$CONFIG['calendar_date']
			    .'") AS from_date, DATE_FORMAT(to_date, "'.$CONFIG['calendar_date']
			    .'") AS to_date FROM '.$server.$lang.'_shop_discounts WHERE id = '.$id);
        	if ($db->nf() > 0) {
    			$db->next_record();
    			$arr['id']			= $db->f('id');
    			$arr['discount']	= htmlspecialchars($db->f('name'));
    			$arr['min']			= (double)($db->f('min'));
    			$arr['max']			= (double)($db->f('max'));
    			$arr['value']		= (double)($db->f('value'));
    			$arr['from_date']	= $db->f('from_date');
    			$arr['to_date']		= $db->f('to_date');
    			$arr['is_percent']	= $db->f('is_percent') ? 'checked' : '';
        		return $arr;
        	}
    		return FALSE;
    	}
	}

	function addDiscounts($discount, $min, $max, $value, $is_percent, $from_date, $to_date) {
		global $CONFIG, $db, $server, $lang;
        $discount	= $db->escape($discount);
        $min		= $min;
        $max		= $max;
        $value		= $value;
        if (isset($discount) && $discount != '' && ($min || $max || $value)) {
            if ($is_percent) {$is_percent = 1;} else {$is_percent = 0;}
        	$query = 'INSERT INTO '.$server.$lang.'_shop_discounts (name, value, min, max, from_date, to_date, is_percent) VALUES ("'
        	    .$discount.'", '.$value.', '.$min.', '.$max.', "'.$db->escape(Main::transform_date($from_date)).'", "'
        	    .$db->escape(Main::transform_date($to_date)).'", '.$is_percent.')';
        	$db->query($query);
        	if ($db->affected_rows() > 0) {
        		return $db->lid();
        	}
		}
    	return FALSE;
	}

	function updateDiscount($id, $discount, $min, $max, $value, $is_percent, $from_date, $to_date) {
		global $CONFIG, $db, $server, $lang;
        $dicount	= $db->escape($discount);
        $id			= (int)$id;
        $min		= $min;
        $max		= $max;
        $value		= $value;
        if (isset($discount) && $discount != '' && ($min || $max || $value)) {
			if ($is_percent) {$is_percent = 1;} else {$is_percent = 0;}
        	$query = 'UPDATE '.$server.$lang.'_shop_discounts
        				SET name = "'.$discount.'",
        					min = '.$min.',
        					max = '.$max.',
        					from_date = "'.$db->escape(Main::transform_date($from_date)).'",
        					to_date = "'.$db->escape(Main::transform_date($to_date)).'",
        					value = '.$value.',
        					is_percent = '.$is_percent.'
        				WHERE id = '.$id;
        	$db->query($query);
        	if ($db->affected_rows() > 0) {
        		return $db->lid();
        	}
		}
    	return FALSE;
	}

    function delDiscount($id) {
        global $CONFIG, $db, $server, $lang;
        $id		= (int)$id;
        if ($id) {
        	$query = 'DELETE FROM '.$server.$lang.'_shop_discounts WHERE id = '.$id;
        	$db->query($query);
        	if ($db->affected_rows() > 0) {
        		return $db->lid();
        	}
		}
    	return FALSE;
    }

    function setDiscountActive($id) {
        global $CONFIG, $db, $server, $lang;
        $id		= (int)$id;
        if ($id) {
        	$query = 'UPDATE '.$server.$lang.'_shop_discounts SET active = 1 WHERE id = '.$id;
        	$db->query($query);
        	if ($db->affected_rows() > 0) {
        		return TRUE;
        	}
		}
    	return FALSE;
    }

    function setDiscountUnActive($id) {
        global $CONFIG, $db, $server, $lang;
        $id		= (int)$id;
        if ($id) {
        	$query = 'UPDATE '.$server.$lang.'_shop_discounts SET active = 0 WHERE id = '.$id;
        	$db->query($query);
        	if ($db->affected_rows() > 0) {
        		return TRUE;
        	}
		}
    	return FALSE;
    }

/**
 * Получение налогов
 */
    function getTaxesAdm($url, $start) {
        global $CONFIG, $db, $server, $lang;
		$start = (int)$start;
		if (!$start) {$start = 1;}
        $query = 'SELECT *
        			FROM '.$server.$lang.'_shop_taxes
        			LIMIT '.(($start-1)*$CONFIG['shop_max_rows']).', '.$CONFIG['shop_max_rows'];
        $db->query($query);
        if ($db->nf() > 0) {
            for ($i = 0; $i < $db->nf(); $i++) {
            	$db->next_record();
       			$arr[$i]['id']			= $db->f('id');
           		$arr[$i]['tax']			= htmlspecialchars($db->f('tax'));
           		$arr[$i]['percent']		= $db->f('percent');
           		$arr[$i]['rank']		= $db->f('rank');
           		$arr[$i]['active']		= $db->f('active');
           		$arr[$i]['img_stat']	= $db->f('active') ? 'ico_swof.gif' : 'ico_swon.gif';
                $arr[$i]['act_stat']	= $db->f('active') ? $this->_msg["Suspend"] : $this->_msg["Activate"];
           		$arr[$i]['active_id']	= $db->f('active') ? $url.'&action=taxes_deac&id='.$db->f('id').'&start='.$start : $url.'&action=taxes_act&id='.$db->f('id').'&start='.$start;
           		$arr[$i]['edit_id']		= $url.'&action=taxes&id='.$db->f('id').'&step=3&start='.$start;
           		$arr[$i]['del_id']		= $url.'&action=taxes_del&id='.$db->f('id').'&start='.$start;
			}
        	return $arr;
        }
    	return FALSE;
    }

/**
 * Получение налога
 */
    function getTax($id) {
        global $CONFIG, $db, $server, $lang;
		$id = (int)$id;
		if ($id) {
        	$query = 'SELECT *
        				FROM '.$server.$lang.'_shop_taxes
        				WHERE id = '.$id;
			$db->query($query);
        	if ($db->nf() > 0) {
    			$db->next_record();
    			$arr['id']			= $db->f('id');
				$arr['tax']			= htmlspecialchars($db->f('tax'));
           		$arr['percent']		= $db->f('percent');
           		$arr['rank']		= $db->f('rank');
        		return $arr;
        	}
    		return FALSE;
    	}
	}

/**
 * Добавление налога $tax,  с величиной $percent и ранком $rank в БД
 */
    function addTax($tax, $percent, $rank) {
        global $CONFIG, $db, $server, $lang;
        $tax		= $db->escape($tax);
        $percent	= (int)$percent;
        $rank		= (int)$rank;
        if (isset($tax) && $tax != '' && $percent && $rank) {
        	$query = 'INSERT INTO '.$server.$lang.'_shop_taxes (tax, percent, rank)
        				VALUES ("'.$tax.'", '.$percent.', '.$rank.')';
        	$db->query($query);
        	if ($db->affected_rows() > 0) {
        		return $db->lid();
        	}
		}
    	return FALSE;
    }

/**
 * Изменение налога $id в БД
 */
    function updateTax($id, $tax, $percent, $rank) {
        global $CONFIG, $db, $server, $lang;
        $tax		= $db->escape($tax);
        $id			= (int)$id;
        $percent	= (int)$percent;
        $rank		= (int)$rank;
        if (isset($tax) && $tax != '' && $percent && $rank) {
        	$query = 'UPDATE '.$server.$lang.'_shop_taxes
        				SET tax = "'.$tax.'",
        					percent = '.$percent.',
        					rank = '.$rank.'
        				WHERE id = '.$id;
        	$db->query($query);
        	if ($db->affected_rows() > 0) {
        		return $db->lid();
        	}
		}
    	return FALSE;
    }

/**
 * Добавление налога $tax,  с величиной $percent и ранком $rank в БД
 */
    function delTax($id) {
        global $CONFIG, $db, $server, $lang;
        $id		= (int)$id;
        if ($id) {
        	$query = 'DELETE FROM '.$server.$lang.'_shop_taxes WHERE id = '.$id;
        	$db->query($query);
        	if ($db->affected_rows() > 0) {
        		return $db->lid();
        	}
		}
    	return FALSE;
    }

    function setTaxActive($id) {
        global $CONFIG, $db, $server, $lang;
        $id		= (int)$id;
        if ($id) {
        	$query = 'UPDATE '.$server.$lang.'_shop_taxes SET active = 1 WHERE id = '.$id;
        	$db->query($query);
        	if ($db->affected_rows() > 0) {
        		return TRUE;
        	}
		}
    	return FALSE;
    }

    function setTaxUnActive($id) {
        global $CONFIG, $db, $server, $lang;
        $id		= (int)$id;
        if ($id) {
        	$query = 'UPDATE '.$server.$lang.'_shop_taxes
        				SET active = 0 WHERE id = '.$id;
        	$db->query($query);
        	if ($db->affected_rows() > 0) {
        		return TRUE;
        	}
		}
    	return FALSE;
    }


/**
 * Получение страны
 */
    function getCity($id) {
        global $CONFIG, $db, $server, $lang;
		$id = (int)$id;
		if (!$id) {return FALSE;}
        $query = 'SELECT * FROM '.$server.$lang.'_shop_cities WHERE id = '.$id;
        $db->query($query);
        if ($db->nf() > 0) {
            $db->next_record();
       		$arr['id']		= $db->f('id');
           	$arr['city']	= htmlspecialchars($db->f('city'));
        	return $arr;
        }
    	return FALSE;
    }

/**
 * Получение массива городов
 */
    function getCities($group_id, $start, $url) {
        global $CONFIG, $db, $server, $lang;
		$start		= (int)$start;
        $group_id	= (int)$group_id;
        if (!$group_id) {return FALSE;}
		if (!$start) {$start = 1;}
        $query = 'SELECT * FROM '.$server.$lang.'_shop_cities
                    WHERE group_id = '.$group_id.'
                    ORDER BY city
                    LIMIT '.(($start-1)*$CONFIG['shop_max_rows']).', '.$CONFIG['shop_max_rows'];
        $db->query($query);
        if ($db->nf() > 0) {
			for($i = 0; $i < $db->nf(); $i++) {
                $db->next_record();
        		$arr[$i]['edit_id']	= $url.'&action=grp_cty_edit&city_id='.$db->f('id').'&cty_id='.$group_id;
        		$arr[$i]['del_id']	= $url.'&action=grp_cty_del&city_id='.$db->f('id').'&cty_id='.$group_id;
            	$arr[$i]['city']	= htmlspecialchars($db->f('city'));
			}
        	return $arr;
        }
    	return FALSE;
    }

/**
 * Добавление страны $country в БД
 */
    function addCity($group_id, $city) {
        global $CONFIG, $db, $server, $lang;
        $city = $db->escape($city);
        if (isset($city) && $city != '') {
        	$query = 'INSERT INTO '.$server.$lang.'_shop_cities (group_id, city) VALUES ('.$group_id.', "'.$city.'")';
        	$db->query($query);
        	if ($db->affected_rows() > 0) {
        		return $db->lid();
        	}
		}
    	return FALSE;
    }

/**
 * Изменение страны $id в БД
 */
    function updateCity($id, $city) {
        global $CONFIG, $db, $server, $lang;
        $id			= (int)$id;
        $city	= $db->escape($city);
        if (isset($city) && $city != '' && isset($id)) {
        	$query = 'UPDATE '.$server.$lang.'_shop_cities SET city = "'.$city.'" WHERE id = '.$id;
        	$db->query($query);
        	if ($db->affected_rows() > 0) {
        		return $db->lid();
        	}
		}
    	return FALSE;
    }

/**
 * Удаление страны
 */
    function delCity($id) {
    	global $CONFIG, $db, $server, $lang;
        $id = (int)$id;
        if (!$id) {
        	return FALSE;
        }
        $query = 'DELETE FROM '.$server.$lang.'_shop_cities WHERE id = '.$id;
        $db->query($query);
        if ($db->affected_rows() > 0) {
			return TRUE;
        }
    	return FALSE;
    }

/**
 * Получение массива стран
 */
    function getCountries($start, $url) {
        global $CONFIG, $db, $server, $lang;
		$start = (int)$start;
		if (!$start) {$start = 1;}
        $query = 'SELECT a.id AS id, a.country AS country, count(b.city) AS cities
        			FROM '.$server.$lang.'_shop_countries AS a
        				LEFT OUTER JOIN '.$server.$lang.'_shop_cities AS b ON a.id = b.group_id
                    GROUP BY a.id, a.country
                    ORDER BY a.country
        			LIMIT '.(($start-1)*$CONFIG['shop_max_rows']).', '.$CONFIG['shop_max_rows'];
        $db->query($query);
        if ($db->nf() > 0) {
			for($i = 0; $i < $db->nf(); $i++) {
                $db->next_record();
        		$arr[$i]['link_id']	= $url.'&action=grp_cty_list&cty_id='.$db->f('id');
        		$arr[$i]['edit_id']	= $url.'&action=cty_edit&cty_id='.$db->f('id');
        		$arr[$i]['del_id']	= $url.'&action=cty_del&cty_id='.$db->f('id');
            	$arr[$i]['country']	= htmlspecialchars($db->f('country'));
            	$arr[$i]['cities']	= $db->f('cities');
			}
        	return $arr;
        }
    	return FALSE;
    }

/**
 * Получение страны
 */
    function getCountry($id) {
        global $CONFIG, $db, $server, $lang;
		$id = (int)$id;
		if (!$id) {return FALSE;}
        $query = 'SELECT * FROM '.$server.$lang.'_shop_countries WHERE id = '.$id;
        $db->query($query);
        if ($db->nf() > 0) {
            $db->next_record();
       		$arr['id']		= $db->f('id');
           	$arr['country']	= htmlspecialchars($db->f('country'));
        	return $arr;
        }
    	return FALSE;
    }

/**
 * Добавление страны $country в БД
 */
    function addCountry($country) {
        global $CONFIG, $db, $server, $lang;
        $country = $db->escape($country);
        if (isset($country) && $country != '') {
        	$query = 'INSERT INTO '.$server.$lang.'_shop_countries (country) VALUES ("'.$country.'")';
        	$db->query($query);
        	if ($db->affected_rows() > 0) {
        		return $db->lid();
        	}
		}
    	return FALSE;
    }

/**
 * Изменение страны $id в БД
 */
    function updateCountry($id, $country) {
        global $CONFIG, $db, $server, $lang;
        $id			= (int)$id;
        $country	= $db->escape($country);
        if (isset($country) && $country != '' && isset($id)) {
        	$query = 'UPDATE '.$server.$lang.'_shop_countries
        				SET country = "'.$country.'"
        				WHERE id = '.$id;
        	$db->query($query);
        	if ($db->affected_rows() > 0) {
        		return $db->lid();
        	}
		}
    	return FALSE;
    }

/**
 * Удаление страны
 */
    function delCountry($id) {
    	global $CONFIG, $db, $server, $lang;
        $id = (int)$id;
        if (!$id) {
        	return FALSE;
        }
        $query = 'DELETE FROM '.$server.$lang.'_shop_countries WHERE id = '.$id;
        $db->query($query);
        if ($db->affected_rows() > 0) {
            $query = 'DELETE FROM '.$server.$lang.'_shop_cities WHERE group_id = '.$id;
        	$db->query($query);
			return TRUE;
        }
    	return FALSE;
    }

	// функция для удаления заказа из базы данных
	function delete_order($id = NULL) {
		global $CONFIG, $db, $server, $lang;
		$id = (int)$id;
		if ($id) {
			$db->query('DELETE FROM '.$server.$lang.'_shop_orders WHERE id = '.$id);
			if ($db->affected_rows() > 0) {
				$db->query('DELETE FROM '.$server.$lang.'_shop_order_items WHERE order_id = '.$id);
			}
			return TRUE;
		}
		return FALSE;
	}

	function showWmConf()
	{   global $CONFIG, $tpl, $baseurl;

		$tpl->newBlock('block_webmoney');
		$tpl->assign(Array(
			"MSG_Webmoney_params" => $this->_msg["Webmoney_params"],
			"MSG_Active" => $this->_msg["Active"],
			"MSG_Currency" => $this->_msg["Currency"],
			"MSG_Select" => $this->_msg["Select"],
			"MSG_Purse" => $this->_msg["Purse"],
			"MSG_Info_success_URL" => $this->_msg["Info_success_URL"],
			"MSG_Info_fail_URL" => $this->_msg["Info_fail_URL"],
			"MSG_Info_percent" => $this->_msg["Info_percent"],
		));
		$tpl->assign(
			array(
				'WM_purse'			=> $CONFIG['shop_WM_purse'],
				'WM_secret_key'		=> $CONFIG['shop_WM_secret_key'],
				'WM_success_url'	=> $CONFIG['shop_WM_success_url'],
				'WM_fail_url'		=> $CONFIG['shop_WM_fail_url'],
				'WM_discount'		=> $CONFIG['shop_WM_discount'],
				'WM_checked'        => $CONFIG['shop_WM_activ'] ? 'checked' : '',
				'WM_result_url'		=> "http://".$_SERVER['HTTP_HOST'].$CONFIG['shop_WM_result_url'],
			)
		);
		foreach ($CONFIG['catalog_currencies'] as $key => $val) {
			$tpl->newBlock('block_WM_currency');
			$tpl->assign(
				array(
					'currency_id'		=> $key,
					'currency_val'		=> $val,
					'currency_selected'	=> $key == $CONFIG['shop_WM_currency'] ? 'selected' : ''
				)
			);
		}
	}

	function showAssistConf()
	{   global $CONFIG, $tpl, $baseurl;

		$tpl->newBlock('block_assist');
		$tpl->assign(Array(
			"MSG_ASSIST_params" => $this->_msg["ASSIST_params"],
			"MSG_Active" => $this->_msg["Active"],
			"MSG_Currency" => $this->_msg["Currency"],
			"MSG_Select" => $this->_msg["Select"],
			"MSG_Shop_code" => $this->_msg["Purse"],
			"MSG_Login" => $this->_msg["Info_success_URL"],
			"MSG_Password" => $this->_msg["Info_fail_URL"],
			"MSG_Info_URLs" => $this->_msg["Info_percent"],
			"MSG_Info_success_URL" => $this->_msg["Info_success_URL"],
			"MSG_Info_fail_URL" => $this->_msg["Info_fail_URL"],
			"MSG_Info_percent" => $this->_msg["Info_percent"],
		));
		$tpl->assign(
			array(
				'assist_idp'			=> $CONFIG['shop_assist_idp'],
				'assist_login'			=> $CONFIG['shop_assist_login'],
				'assist_password'		=> $CONFIG['shop_assist_password'],
				'assist_success_url'	=> $CONFIG['shop_assist_success_url'],
				'assist_fail_url'		=> $CONFIG['shop_assist_fail_url'],
				'assist_discount'		=> $CONFIG['shop_assist_discount'],
				'assist_checked'        => $CONFIG['shop_assist_activ'] ? 'checked' : '',
				'assist_result_url'		=> "http://".$_SERVER['HTTP_HOST'].$CONFIG['shop_assist_result_url'],
			)
		);
		foreach ($CONFIG['catalog_currencies'] as $key => $val) {
			$tpl->newBlock('block_assist_currency');
			$tpl->assign(
				array(
					'currency_id'		=> $key,
					'currency_val'		=> $val,
					'currency_selected'	=> $key == $CONFIG['shop_assist_currency'] ? 'selected' : ''
				)
			);
		}
	}
	
	function showYaMoneyConf()
	{
	    global $CONFIG, $tpl, $baseurl;
	
	    $tpl->newBlock('block_ya_money');
	    $tpl->assign(array(
	        'ya_money_uid' => $CONFIG['ya_money_uid'],
	        'ya_money_secret' => $CONFIG['ya_money_secret'],
	        'ya_money_checked' => $CONFIG['shop_ya_money_activ'] ? 'checked' : '',
	    ));
	}
	
	function showRobokassaConf()
	{
	    global $CONFIG, $tpl, $baseurl, $lang;
	
	    $shop_link = Core::formPageLink($CONFIG['shop_page_link'], $CONFIG['shop_page_address'], $lang, 1);
	    $tpl->newBlock('block_robokassa');
	    $tpl->assign(array(
	        'robokassa_test_mode_checked' => $CONFIG['shop_robokassa_test_mode'] ? 'checked' : '',
	        'robokassa_login'	=> $CONFIG['shop_robokassa_login'],
	        'robokassa_pass1'	=> $CONFIG['shop_robokassa_pass1'],
	        'robokassa_pass2'	=> $CONFIG['shop_robokassa_pass2'],
	        'robokassa_checked'    => $CONFIG['shop_robokassa_activ'] ? 'checked' : '',
	        'robokassa_result_url' => "http://".$_SERVER['HTTP_HOST'].$shop_link.'action=robokassa_result',
	        'robokassa_success_url' => "http://".$_SERVER['HTTP_HOST'].$shop_link.'action=robokassa_success',
	        'robokassa_fail_url' => "http://".$_SERVER['HTTP_HOST'].$shop_link.'action=robokassa_fail',
	    ));
	}
	
	function showPayOnlineConf()
	{
	    global $CONFIG, $tpl, $baseurl, $lang;
	
	    $tpl->newBlock('block_payonline');
	    $tpl->assign(array(
	        'payonline_MerchantId' => $CONFIG['payonline_MerchantId'],
	        'payonline_PrivateSecurityKey' => $CONFIG['payonline_PrivateSecurityKey'],
	        'payonline_checked' => $CONFIG['shop_payonline_activ'] ? 'checked' : '',
	        'CallBackUrl' => 'http://'.$_SERVER['HTTP_HOST'].Core::formPageLink($CONFIG["shop_page_address"], $CONFIG["shop_page_address"], $lang, 1).'action=payonlineCallBack'
	    ));
	    foreach ($CONFIG['shop_payonline_redirect_list'] as $key => $val) {
	        $tpl->newBlock('payonline_redirect_list_item');
	        $tpl->assign(array(
	                'key' => $key,
	                'title' => $val,
	                'selected' => $key == $CONFIG['payonline_redirect'] ? 'selected' : ''
	        ));
	    }
	    $status_lost = $this->getOrdStatusList();
	    foreach ($status_lost as $key => $val) {
	        $tpl->newBlock('payonline_paid_status_list_item');
	        $tpl->assign(array(
	                'key' => $val['id'],
	                'title' => $val['title'],
	                'selected' => $val['id'] == $CONFIG['payonline_paid_status'] ? 'selected' : ''
	        ));
	    }
	    reset($status_lost);
	    foreach ($status_lost as $key => $val) {
	        $tpl->newBlock('payonline_fail_status_list_item');
	        $tpl->assign(array(
	                'key' => $val['id'],
	                'title' => $val['title'],
	                'selected' => $val['id'] == $CONFIG['payonline_fail_status'] ? 'selected' : ''
	        ));
	    }
	}

	function saveWmConf()
	{
		$conf_str = "<?php\n\$NEW = array(\n/* ABOCMS:START */\n";
		$conf_str .= "'shop_WM_currency' => '".$_POST['WM_currency']."',\n'shop_WM_purse' => '".$_POST['WM_purse']."',\n";
		$conf_str .= "'shop_WM_secret_key' => '".$_POST['WM_secret_key']."',\n'shop_WM_success_url' => '".$_POST['WM_success_url']."',\n";
		$conf_str .= "'shop_WM_fail_url' => '".$_POST['WM_fail_url']."',\n'shop_WM_discount' => '".$_POST['WM_discount']."'\n";
		$conf_str .= "/* ABOCMS:END */\n);\n?>";
		@chmod(RP."/mod/shop/wm_config.php", 0777);
		$fp = @fopen(RP."/mod/shop/wm_config.php", "w");
		if (!$fp) {
			fclose($fp);
			return FALSE;
		}
		if (!@fwrite($fp, $conf_str)) {
			fclose($fp);
			return FALSE;
		}
		fclose($fp);
		return TRUE;
	}

	function saveAssistConf()
	{
		$conf_str = "<?php\n\$NEW = array(\n/* ABOCMS:START */\n";
		$conf_str .= "'shop_assist_currency' => '".$_POST['assist_currency']."',\n'shop_assist_idp' => '".$_POST['assist_idp']."',\n";
		$conf_str .= "'shop_assist_login' => '".$_POST['assist_login']."',\n'shop_assist_password' => '".$_POST['assist_password']."',\n";
		$conf_str .= "'shop_assist_success_url' => '".$_POST['assist_success_url']."',\n'shop_assist_fail_url' => '".$_POST['assist_fail_url']."',\n";
		$conf_str .= "'shop_assist_discount' => '".$_POST['assist_discount']."'\n";
		$conf_str .= "/* ABOCMS:END */\n);\n?>";
		@chmod(RP."/mod/shop/assist_config.php", 0777);
		$fp = @fopen(RP."/mod/shop/assist_config.php", "w");
		if (!$fp) {
			fclose($fp);
			return FALSE;
		}
		if (!@fwrite($fp, $conf_str)) {
			fclose($fp);
			return FALSE;
		}
		fclose($fp);
		return TRUE;
	}

	function saveYaMoneyConf()
	{
		$conf_str = "<?php\n\$NEW = array(\n/* ABOCMS:START */\n'shop_ya_money_activ' => '".($_POST['ya_money_activ'] ? 1 : 0)."',\n";
		$conf_str .= "'ya_money_uid' => '".$_POST['ya_money_uid']."',\n";
		$conf_str .= "'ya_money_secret' => '".$_POST['ya_money_secret']."',\n";
		$conf_str .= "/* ABOCMS:END */\n);\n?>";
		@chmod(RP."/mod/shop/ya_money_config.php", 0777);
		$fp = @fopen(RP."/mod/shop/ya_money_config.php", "w");
		if (!$fp) {
			fclose($fp);
			return FALSE;
		}
		if (!@fwrite($fp, $conf_str)) {
			fclose($fp);
			return FALSE;
		}
		fclose($fp);
		return TRUE;
	}
	
	function saveRobokassaConf()
	{
	    $conf_str = "<?php\n\$NEW = array(\n/* ABOCMS:START */\n";
	    $conf_str .= "'shop_robokassa_test_mode' => '".($_POST['robokassa_test_mode']?1:0)."',\n";
	    $conf_str .= "'shop_robokassa_currency' => '".$_POST['robokassa_currency']."',\n";
	    $conf_str .= "'shop_robokassa_login' => '".$_POST['robokassa_login']."',\n";
	    $conf_str .= "'shop_robokassa_pass1' => '".$_POST['robokassa_pass1']."',\n";
	    $conf_str .= "'shop_robokassa_pass2' => '".$_POST['robokassa_pass2']."',\n";
	    $conf_str .= "/* ABOCMS:END */\n);\n?>";
	    @chmod(RP."/mod/shop/robokassa_config.php", 0777);
	    $fp = @fopen(RP."/mod/shop/robokassa_config.php", "w");
	    if (!$fp) {
	        fclose($fp);
	        return FALSE;
	    }
	    if (!@fwrite($fp, $conf_str)) {
	        fclose($fp);
	        return FALSE;
	    }
	    fclose($fp);
	    return TRUE;
	}

	function savePayOnlineConf()
	{
		$conf_str = "<?php\n\$NEW = array(\n/* ABOCMS:START */\n'shop_payonline_activ' => '".($_POST['payonline_activ'] ? 1 : 0)."',\n";
		$conf_str .= "'payonline_MerchantId' => '".$_POST['payonline_MerchantId']."',\n";
		$conf_str .= "'payonline_PrivateSecurityKey' => '".$_POST['payonline_PrivateSecurityKey']."',\n";
		$conf_str .= "'payonline_redirect' => '".$_POST['payonline_redirect']."',\n";
		$conf_str .= "'payonline_paid_status' => '".$_POST['payonline_paid_status']."',\n";
		$conf_str .= "'payonline_fail_status' => '".$_POST['payonline_fail_status']."',\n";
		$conf_str .= "/* ABOCMS:END */\n);\n?>";
		@chmod(RP."/mod/shop/payonline_config.php", 0777);
		$fp = @fopen(RP."/mod/shop/payonline_config.php", "w");
		if (!$fp) {
			fclose($fp);
			return FALSE;
		}
		if (!@fwrite($fp, $conf_str)) {
			fclose($fp);
			return FALSE;
		}
		fclose($fp);
		return TRUE;
	}

 	function getNodeValue($parent, $node_name) {
		$node_array = $parent->get_elements_by_tagname($node_name);
		return (sizeof($node_array)) ? $this->conv_str_from_utf8($node_array[0]->get_content()) : '';
	}

 	function getNode($parent, $node_name) {
		$node_array = $parent->get_elements_by_tagname($node_name);
		return (sizeof($node_array)) ? $node_array[0] : false;
	}

	function doImportXMLData($dom) {
		global $db;

		$insert = array();
		$ord_goods = array();
		$ids = array();
		$ord_query = "REPLACE INTO `{$this->table_prefix}_shop_orders` "
			."(id, siteuser_id, delivery_id, manager_id, delivery_cost, customer, type, "
			."address, phone, email, organization, jpinfo, date, sum, discount, total_sum, "
			."currency, addinfo, status, pay_type, session, notes) VALUES ";
		$gds_query = "INSERT INTO {$this->table_prefix}_shop_order_items ("
		    ."order_id, item_id, item_name, item_code, item_price, "
		    ."item_currency, item_rate, item_qty, item_cost, info) VALUES ";
		$i = $j = $k = 0;
		foreach ($dom->get_elements_by_tagname('order') as $order) {
		    $i++;
			$order_id = intval($order->get_attribute('id'));
			if ($order_id) {
			    $ids[] = $order_id;
			    $ins = "({$order_id},";
			    $ins .= intval($order->get_attribute('user_id')).",";
			    $node = $this->getNode($order, 'delivery');
			    $ins .= ($node ? intval($node->get_attribute('id')) : '0').",";			    
			    $ins .= intval($order->get_attribute('manager_id')).",";
			    $ins .= ($node ? floatval($node->get_content()) : 0).",";
			    $ins .= "'".My_Sql::escape($this->getNodeValue($order, 'customer'))."',";
			    $ins .= "'".My_Sql::escape($this->getNodeValue($order, 'type'))."',";
			    $ins .= "'".My_Sql::escape($this->getNodeValue($order, 'address'))."',";
			    $ins .= "'".My_Sql::escape($this->getNodeValue($order, 'phone'))."',";
			    $ins .= "'".My_Sql::escape($this->getNodeValue($order, 'email'))."',";
			    $ins .= "'".My_Sql::escape($this->getNodeValue($order, 'organization'))."',";
			    $ins .= "'".My_Sql::escape($this->getNodeValue($order, 'jpinfo'))."',";
			    $ins .= "'".My_Sql::escape($this->getNodeValue($order, 'date'))."',";
			    $ins .= floatval($this->getNodeValue($order, 'sum')).",";
			    $ins .= floatval($this->getNodeValue($order, 'discount')).",";
			    $ins .= floatval($this->getNodeValue($order, 'total')).",";
			    $ins .= "'".My_Sql::escape($this->getNodeValue($order, 'currency'))."',";
			    $ins .= "'".My_Sql::escape($this->getNodeValue($order, 'addinfo'))."',";
			    $ins .= intval($this->getNodeValue($order, 'status')).",";
			    $node = $this->getNode($order, 'payment');
			    $ins .= ($node ? intval($node->get_attribute('type')) : '0').",";
			    $ins .= "'".My_Sql::escape($this->getNodeValue($order, 'session'))."',";
			    $ins .= "'".My_Sql::escape($this->getNodeValue($order, 'notes'))."')";
			    $insert[] = $ins;
			    foreach ($order->get_elements_by_tagname('product') as $goods) {
			        $j++; $k++;
    			    $gds = "(".$order_id.",".intval($goods->get_attribute('id')).",";
    			    $gds .= "'".My_Sql::escape($this->getNodeValue($goods, 'name'))."',";
    			    $gds .= "'".My_Sql::escape($this->getNodeValue($goods, 'code'))."',";
    			    $gds .= floatval($this->getNodeValue($goods, 'price')).",";
    			    $gds .= "'".My_Sql::escape($this->getNodeValue($goods, 'currency'))."',";
    			    $gds .= floatval($this->getNodeValue($goods, 'rate')).",";
    			    $gds .= intval($goods->get_attribute('quantity')).",";
    			    $gds .= floatval($this->getNodeValue($goods, 'cost')).",";
    			    $gds .= "'".My_Sql::escape($this->getNodeValue($goods, 'info'))."')";
    			    $ord_goods[] = $gds;
    			}
    			if ($i>100) {
    			    $db->query($ord_query.implode(", ", $insert));
    			    $i = 0;
    			    $insert = array();
    			    $db->query("DELETE FROM {$this->table_prefix}_shop_order_items WHERE order_id IN (".implode(",", $ids).")");
    			    $ids = array();
    			}
    			if ($j>100) {    			    
    			    $db->query($gds_query.implode(", ", $ord_goods));
    			    $j = 0;
    			    $ord_goods = array();    			    
    			}
			}
		}
		if ($i>0) {
    		$db->query($ord_query.implode(", ", $insert));
    		$db->query("DELETE FROM {$this->table_prefix}_shop_order_items WHERE order_id IN (".implode(",", $ids).")");
    	}
    	if ($j>0) {
    	    $db->query($gds_query.implode(", ", $ord_goods));
    	}
	}

	function my_iconv($charset_from, $charset_to, $str){
		if ($ret = iconv($charset_from, $charset_to, $str)) {
			return $ret;
		}
		$str_arr = explode(" ", $str);
		for ($i=0; $i < sizeof($str_arr); $i++) {
			$str_arr[$i] = iconv($charset_from, $charset_to, $str_arr[$i]);
		}
		return implode(" ", $str_arr);
	}

	function conv_str($str){
		switch ($this->data_charset) {
		case 'cp1251':
			return $this->my_iconv("WINDOWS-1251", "UTF-8", $str);
		case 'koi8-r':
			return $this->my_iconv("KOI8-R", "UTF-8", $str);
		case 'iso-8859-1':
			return $this->my_iconv("ISO-8859-1", "UTF-8", $str);
		default:
			return $str;
		}
	}

	function conv_str_from_utf8($str){
		switch ($this->data_charset) {
		case 'cp1251':
			return $this->my_iconv("UTF-8", "WINDOWS-1251", $str);
		case 'koi8-r':
			return $this->my_iconv("UTF-8", "KOI8-R", $str);
		case 'iso-8859-1':
			return $this->my_iconv("UTF-8", "ISO-8859-1", $str);
		default:
			return $str;
		}
	}

		/**
	 * Метод для получения списка пользовательских (накопителных) скидок.
	 *
	 * @param int $user_discount_id - идентификатор скидки, если 0 - извлекается информация о всех скидках.
	 */
	function GetUsersDiscounts($users_discount_id = false)
	{
    	global $db;

    	if (!$users_discount_id && $users_discount_id !== false)
    	{
    		return false;
    	}

		$users_discount_id = to_int($users_discount_id);

		$where = '';
		if ($users_discount_id)
		{
			$where .= " AND {$this->table_prefix}_shop_users_discounts.id = '$users_discount_id'";
		}

		$sql = "SELECT * FROM {$this->table_prefix}_shop_users_discounts WHERE 1 $where ORDER BY id";
		$result = $db->getArrayOfResult($sql);

		return $result;
	}

	/**
	 * Метод возвращаем список всех групп и признак их включения в указанную скидку.
	 *
	 * @param int $discount_id - идентификатор скидки.
	 */
	function GetGroupsWithDiscounts($discount_id)
	{
		global $db;

		$discount_id = to_int($discount_id);

		$sql = "SELECT ug.*, dg.users_discound_id, dg.users_group_id FROM core_groups AS ug
		LEFT JOIN {$this->table_prefix}_shop_users_discounts_groups AS dg ON (ug.id = dg.users_group_id AND dg.users_discound_id = '$discount_id')
		ORDER BY ug.id";

		$result = $db->getArrayOfResult($sql);

		return $result;
	}

	/**
	 * Метод удаляет все связи с группами для указанной скидки.
	 *
	 * @param int $discount_id - идентификатор скидки.
	 */
	function ClearGroupsOfDiscount($discount_id)
	{
		global $db;

		$discount_id = to_int($discount_id);

		$sql = "DELETE FROM {$this->table_prefix}_shop_users_discounts_groups WHERE `users_discound_id` = '$discount_id'";
		$db->query($sql);

		return true;
	}

	/**
	 * Метод добавляет связь скидки с группой пользователей.
	 *
	 * @param int $discount_id - идентификатор скидки.
	 * @param int $group_id - идентификатор группы пользователей.
	 * @return int идентификатор вставленной записи.
	 */
	function InsertDiscountForGroup($discount_id, $group_id)
	{
		global $db;

		$discount_id = to_int($discount_id);
		$group_id = to_int($group_id);

		$sql = "INSERT INTO `{$this->table_prefix}_shop_users_discounts_groups` SET
			`users_discound_id` = '$discount_id',
			`users_group_id` = '$group_id'";

		$db->query($sql);
        if ($db->affected_rows() > 0)
        {
        	return $db->lid();
        }
        else
        {
        	return false;
        }
	}

	function InsertDiscount($params)
	{
		global $db;

		$params = to_array($params);
		$sql_params = array();

		$id = to_int($params['id']);

		if (isset($params['name']))
			$sql_params['name'] = to_str($params['name']);

		if (isset($params['min']))
			$sql_params['min'] = to_float($params['min']);

		if (isset($params['max']))
			$sql_params['max'] = to_float($params['max']);

		if (isset($params['value']))
			$sql_params['value'] = to_float($params['value']);

		if (isset($params['interval']))
			$sql_params['interval'] = to_int($params['interval']);

		if (isset($params['is_percent']))
			$sql_params['is_percent'] = to_int($params['is_percent']);

		if (isset($params['active']))
			$sql_params['active'] = to_int($params['active']);

		if (!count($sql_params))
		{
			return false;
		}

		// Скомпонуем запрос.
		$m = array();
		foreach ($sql_params as $key => $value)
		{
			$m[] = "`$key` = '$value'";
		}

		$sql = implode(', ', $m);

		if ($id)
		{
			// SQL для обновления.
			$sql = "UPDATE `{$this->table_prefix}_shop_users_discounts` SET $sql WHERE `id` = '$id'";
		}
		else
		{
			// SQL для добавления.
			$sql = "INSERT INTO `{$this->table_prefix}_shop_users_discounts` SET $sql";
		}

		$db->query($sql);
		if ($id)
		{
			return $db->affected_rows() > 0 ? $id : false;
		}
		else
		{
			return $db->affected_rows() > 0 ? $db->lid() : false;
		}
	}

	function DeleteDiscount($discount_id)
	{
		global $db;

		$discount_id = to_int($discount_id);
		if (!$discount_id)
		{
			return false;
		}

		$sql = "DELETE FROM `{$this->table_prefix}_shop_users_discounts` WHERE `id` = '$discount_id'";
		$db->query($sql);

		return $db->affected_rows() > 0;
	}

	function GetOrderStat($period, $usertype, $status = -1, $manager = -1)
	{   global $db;
		
	    $from = $to = false;
	    $data_format = "%d.%m.%Y";
	    $status = '' == $status ? array() : explode(",", $status);
	    foreach ($status as $key => $val) {
	    	if (-1 == $val) {
	    	    $status = array();
	    	} else {
	    	    $status[$key] = (int)$val;
	    	}
	    }
	    $manager = (int) $manager;
		$clause = array();
		if ($period['from']) {
		    $from = Main::transform_date($period['from']);
		    $clause[] = "date > '".My_Sql::escape($from)."'";
		}
		if ($period['to']) {
		    $to = Main::transform_date($period['to']);
		    $clause[] = "date < DATE_ADD('".My_Sql::escape($to)."', INTERVAL 1 DAY)";
		}
		if ('0' === $usertype) {
		    $clause[] = "siteuser_id=0";
		} else if ($usertype > 0) {
		    $clause[] = "client_type=".intval($usertype);
		}
		if (!$to) {
		    $to = date("Y-m-d");
		}
		if ($from && $to) {
		    if ((strtotime($to) - strtotime($from)) > 24*30*24*3600) {
		        $from = strtotime($from);
    		    $to = strtotime($to);
    		    $data_format = "%Y";		    
		    } else if ((strtotime($to) - strtotime($from)) > 60*24*3600) {
		        $from = strtotime($from);
    		    $to = strtotime($to);
    		    $data_format = "%m.%Y";
		    }
		}
		if (! empty($status)) {
		    $clause[] = "status IN (".implode(",", $status).")";
		}
		if ($manager >= 0) {
		    $clause[] = "manager_id={$manager}";
		}
		$ret = false;
		if (! empty($clause)) {
		    $query = "SELECT DATE_FORMAT(date, '{$data_format}') as date, UNIX_TIMESTAMP(date) AS timestamp, "
		        ."COUNT(*) as cnt, SUM(ROUND(total_sum)) as sum "
		        ."FROM {$this->table_prefix}_shop_orders"
		        .($usertype > 0 ? " INNER JOIN core_users U ON U.id=siteuser_id" : "")
				." WHERE ".implode(" AND ", $clause)
				." GROUP BY DATE_FORMAT(date, '{$data_format}') ORDER BY timestamp";
			//echo "<!--$query-->";
			$db->query($query);
			while ($db->next_record()) {
				$ret[] = array(
				    'date' => $db->Record['date'],
				    'cnt' => $db->Record['cnt'],
				    'sum' => $db->Record['sum'],
				    'timestamp' => $db->Record['timestamp']
				);
			}
		}
		return $ret;
	}


	/**
	 * Расчет накопительной скидки для пользователя.
	 *
	 *
	 * @param int $sum - сумм
	 * @param int $user_id - идентификатор пользователя.
	 * @return mixed размер скидки.
	 */
	function getAccumulativeDiscount($sum, $currency, $user_id = 0)
	{
		global $db, $CONFIG;

		$discount = 0;
		$ret = false;
		$sum = ShopPrototype::exchange(to_float($sum), $currency, $CONFIG['shop_order_concurency']);
		$user_id = $user_id ? (int) $user_id : $_SESSION['siteuser']['id'];
		if ($user_id < 1 || $sum <= 0) {
			return $ret;
		}

		// Список групп, к которым принадлежит пользователь.
		$groups = array();
		$db->query("SELECT group_id FROM core_users_groups WHERE user_id={$user_id}");
		while ($db->next_record()) {
			$groups[] = $db->Record['group_id'];
		}
		// Извлечем информацию о скидках, доступных для групп данного пользователя.
		// Если группа пользователей для скидки не указана, то скидна действительна для всех пользователей
		$dscnt_list = $db->getArrayOfResult("SELECT DISTINCT d.* FROM
		    {$this->table_prefix}_shop_users_discounts AS d LEFT JOIN
		    {$this->table_prefix}_shop_users_discounts_groups AS dg ON d.id=dg.users_discound_id
		    WHERE d.active AND (dg.users_group_id IS NULL"
		    .(!empty($groups) ? " OR dg.users_group_id IN (".implode(",", $groups)."))" : ")"));
		if ($dscnt_list) {
			foreach ($dscnt_list as $dscnt) {
        		$sql = "SELECT (SUM(sum)) AS `disc_sum` FROM
        		{$this->table_prefix}_shop_orders WHERE siteuser_id={$user_id}
        		AND date > DATE_SUB(NOW(), INTERVAL {$dscnt['interval']} MONTH)
        		GROUP BY siteuser_id HAVING disc_sum BETWEEN {$dscnt['min']} AND {$dscnt['max']}";
        		$db->query($sql);
        		if ($db->next_record()) {
        			$d = ($dscnt['is_percent']) ? ($sum / 100 * to_float($dscnt['value'])) : to_float($dscnt['value']);
        			if ($d > $discount) {
        			    $discount = $d;
        			    $ret = $dscnt;
        			    $ret['discount_sum'] = number_format(ShopPrototype::exchange($d, $currency, $CONFIG['shop_order_concurency']), 2, ".", "");
        			}
        		}
			}
		}
		return $ret;
	}
	
	function getCartProdList()
	{   global $db, $CONFIG;
	    static $list = false;
	
	    if (empty($_list)) {
    		$ids = array();
    		foreach ($_SESSION["order"]["items"] as $key => $val) {
    		    $ids[] = (int) $key;
    		}
    		$ctlg = Module::load_mod('catalog', 'only_create_object');
    		if (! empty($ids)) {
    		    $clnt_price = 'price_'.(@$_SESSION['siteuser']['client_type'] ? $_SESSION['siteuser']['client_type'] : '1');
    		    $db->query("SELECT P.*, if(P.alias is not null and P.alias!='', P.alias, P.id) as product_alias,"
    		        ." if(C.alias is not null and C.alias!='', C.alias, C.id) as ctg_alias FROM "
    		        ."{$this->table_prefix}_catalog_products P INNER JOIN {$this->table_prefix}_catalog_categories C "
    		        ."ON C.id=category_id WHERE P.id IN (".implode(", ", $ids).")");
    		    while ($db->next_record()) {
    		    	$_list[$db->Record['id']] = array(
    		    	    'id' => $db->Record['id'],
    		    	    'alias' => $db->Record['alias'],
    		    	    'category_id' => $db->Record['category_id'],
    		    	    'title' => $db->Record['product_title'],
    		    	    'code' => $db->Record['product_code'],
    		    	    'inf' => $db->Record['product_inf'],
    		    	    'description' => $db->Record['product_description'],
    		    	    'currency' => $db->Record['currency'],
    		    	    'currency_name'	=> $ctlg->currencies[$db->Record['currency']],
    		    	    'price_1' => $ctlg->getCostWithTaxes($db->Record['price_1'], false),
    		    	    'price_2' => $ctlg->getCostWithTaxes($db->Record['price_2'], false),
    		    	    'price_3' => $ctlg->getCostWithTaxes($db->Record['price_3'], false),
    		    	    'price_4' => $ctlg->getCostWithTaxes($db->Record['price_4'], false),
    		    	    'price_5' => $ctlg->getCostWithTaxes($db->Record['price_5'], false),                
    		    	    'price' => $ctlg->getCostWithTaxes($db->Record[$clnt_price], false),
    		    	    'image' => $db->Record['image_middle'],
    		    	    'image_big' => $db->Record['image_big'],
    		    	    'availability' => $db->Record['product_availability'],
    		    	    'prod_alias' => $db->Record['product_alias'],
    		    	    'ctgr_alias' => $db->Record['ctg_alias']
    		    	);
    		    }
    		}
	    }
		
		return $_list;
	}
	/**
	 * Получить уникальный ключ для списка свойств
	 *
	 * @param array $prop_list
	 * @return mixed string OR false
	 */
	function getPropKey($prop_list)
	{
	    $ret = false;
	    if (! empty($prop_list)) {
	        ksort($prop_list);
	        $ret = md5(serialize($prop_list));
	    }
		return $ret;
	}
	
    function getDelivery($id)
    {
        global $db;

        $db->query("SELECT * FROM {$this->table_prefix}_shop_delivery WHERE id=".intval($id));
        $ret = false;
        if ($db->next_record()) {
            $ret = array(
                'id' => $db->Record['id'],
                'title' => $db->Record['title'],
                'cost' => $db->Record['cost'],
                'dscr' => $db->Record['dscr'],
            );
        }
        return $ret;
    }

    function deliveryExists($id)
    {
        global $db;

        $db->query("SELECT id FROM {$this->table_prefix}_shop_delivery WHERE id=".intval($id));
        return $db->nf() ? true : false;
    }

    function delDelivery($id)
    {
        global $db;
        $db->query("DELETE FROM {$this->table_prefix}_shop_delivery WHERE id=".intval($id));
        
        return $db->affected_rows() ? true : false;
    }

    function setDelivery($data)
    {
        global $db;

        $data['title'] = My_Sql::escape($data['title']);
        $data['dscr'] = My_Sql::escape($data['dscr']);
        $data['cost'] = (float) $data['cost'];
        $ret = false;
        if (! empty($data['title']) && $data['cost'] >= 0) {
            if ($data['id']) {
                if ($this->deliveryExists($data['id'])) {
                    $db->query("UPDATE {$this->table_prefix}_shop_delivery SET title='"
                    .$data['title']."', cost={$data['cost']}, dscr='"
                    .$data['dscr']."' WHERE id=".intval($data['id']));
                    $ret = true;
                }
            } else {
                $db->query("INSERT INTO {$this->table_prefix}_shop_delivery SET title='"
                    .$data['title']."', cost={$data['cost']}, dscr='"
                    .$data['dscr']."'");
                $ret = $db->affected_rows() ? $db->lid() : false;
            }
        }
        return $ret;
    }

    function getDeliveryList()
    {
        global $db;

        $db->query("SELECT * FROM {$this->table_prefix}_shop_delivery ORDER BY id");
        $ret = false;
        while ($db->next_record()) {
            $ret[$db->Record['id']] = array(
                'id' => $db->Record['id'],
                'title' => $db->Record['title'],
                'cost' => $db->Record['cost'],
                'dscr' => $db->Record['dscr'],
            );
        }
        return $ret;
    }

    function showDeliveryList($transurl, $active_dlvr = 0)
    {
        global $tpl;
        $ret = false;
        $list = $this->getDeliveryList();
        if ($list) {
            $ret = true;
            $tpl->newBlock('block_delivery_list');
            $assign = array(
                'MSG_Ed' => $this->_msg['Ed'],
            	'Edit' => $this->_msg['Edit'],
            	'MSG_Del' => $this->_msg['Del'],
            	'MSG_Delete' => $this->_msg['Delete'],
            	'MSG_Title' => $this->_msg['Title'],
            	'MSG_Cost' => $this->_msg['Cost'],
            	'MSG_description' => $this->_msg['description'],
            	'transurl' => $transurl,
            	'baseurl' => $transurl
            );
            $tpl->assign($assign);
            foreach ($list as $val) {
            	$tpl->newBlock('block_delivery');
            	$val['checked'] = $active_dlvr == $val['id'] ? 'checked' : '';
            	$val['selected'] = $val['checked'] ? 'selected' : '';
            	$tpl->assign($assign + $val);
            }
        }
        return $ret;
    }

    function showDelivery($id)
    {
        global $tpl;
        $ret = false;
        $dlvr = $this->getDelivery($id);
        if ($dlvr) {
            $ret = true;
            $tpl->newBlock('block_delivery');
            $tpl->assign($dlvr);
        }
        return $ret;
    }
	
    function getOrdStatus($id)
    {
        global $db;

        $db->query("SELECT * FROM {$this->table_prefix}_shop_order_status WHERE id=".intval($id));
        $ret = false;
        if ($db->nf()) {
            $db->next_record();
            $ret = array(
                'id' => $db->Record['id'],
                'title' => $db->Record['title'],
                'payable' => $db->Record['payable'],
            );
        }
        return $ret;
    }

    function ordStatusExists($id)
    {
        global $db;

        $db->query("SELECT id FROM {$this->table_prefix}_shop_order_status WHERE id=".intval($id));
        return $db->nf() ? true : false;
    }

    function delOrdStatus($id)
    {
        global $db;
        $db->query("DELETE FROM {$this->table_prefix}_shop_order_status WHERE id=".intval($id));
        
        return $db->affected_rows() ? true : false;
    }

    function setOrdStatus($data)
    {
        global $db;

        $data['title'] = My_Sql::escape($data['title']);
        $ret = false;
        if (! empty($data['title'])) {
            if ($data['id']) {
                if ($this->ordStatusExists($data['id'])) {
                    $db->query("UPDATE {$this->table_prefix}_shop_order_status SET title='"
                    .$data['title']."', payable=".($data['payable'] ? 1 : 0)
                    ." WHERE id=".intval($data['id']));
                    $ret = true;
                }
            } else {
                $db->query("INSERT INTO {$this->table_prefix}_shop_order_status SET title='"
                    .$data['title']."', payable=".($data['payable'] ? 1 : 0));
                $ret = $db->affected_rows() ? $db->lid() : false;
            }
        }
        return $ret;
    }

    function getOrdStatusList($includ_default = true)
    {
        global $db;
        static $ret = false;

        if (!$ret) {
            $ret = $includ_default ? array(0 => array(
                'id' => 0,
                'title' => $this->_msg['Default_status'],
                'payable' => 0,
            )) : array();
            $db->query("SELECT * FROM {$this->table_prefix}_shop_order_status ORDER BY id");
            while ($db->next_record()) {
                $ret[$db->Record['id']] = array(
                    'id' => $db->Record['id'],
                    'title' => $db->Record['title'],
                    'payable' => $db->Record['payable'],
                );
            }
        }        
        return $ret;
    }

    function showOrdStatusList($transurl, $includ_default = true)
    {
        global $tpl;
        $ret = false;
        $list = $this->getOrdStatusList($includ_default);
        if ($list) {
            $ret = true;
            $tpl->newBlock('block_status_list');
            $assign = array(
                'MSG_Ed' => $this->_msg['Ed'],
            	'Edit' => $this->_msg['Edit'],
            	'MSG_Del' => $this->_msg['Del'],
            	'MSG_Delete' => $this->_msg['Delete'],
            	'MSG_Title' => $this->_msg['Title'],
				'MSG_Payable' => $this->_msg["Payable"],
            	'transurl' => $transurl,
            	'baseurl' => $transurl
            );
            $tpl->assign($assign);
            foreach ($list as $val) {
            	$tpl->newBlock('block_status');
            	$tpl->assign($assign + $val);
            }
        }
        return $ret;
    }
    
    function getStatusTitle($title, $id)
    {
    	return $title ? $title : (0 == $id ? $this->_msg['Default_status'] : $this->_msg['undef']);
    }
    
    function getStatParamXml()
    {   global $db, $CONFIG;
    
        $siteusers = Module::load_mod('siteusers');
        $list = $siteusers->getGroups();
    	$ret = "<result>\n";
        $ret .= "<usertypes>\n";
        $ret .= "<usertype><id>-1</id><title>{$this->_msg['All_groups']}</title></usertype>\n";
        $ret .= "<usertype><id>0</id><title>{$this->_msg['No_auth_user']}</title></usertype>\n";
        foreach ($CONFIG['siteusers_client_types'] as $key=>$val) {
            $ret .= "<usertype><id>{$key}</id><title>{$val}</title></usertype>\n";
        }
        $ret .= "</usertypes>\n";
        $ret .= "<states>\n";
        $ret .= "<state><id>-1</id><title>{$this->_msg['All']}</title></state>\n";
        $list = $this->getOrdStatusList(true);
        foreach ($list as $key=>$val) {
            $ret .= "<state><id>{$key}</id><title>{$val['title']}</title></state>\n";
        }
        $ret .= "</states>\n";
        $ret .= "<managers>\n";
        $ret .= "<manager><id>-1</id><username>{$this->_msg['All']}</username></manager>\n";
        $list = $this->getManagersList();
        if (! empty($list)) {
            foreach ($list as $key=>$val) {
                $ret .= "<manager><id>{$key}</id><username>{$val['username']}</username></manager>\n";
            }
        }        
        $ret .= "</managers>\n";
        $ret .= "</result>\n";
        return $ret;
    }
    
    function isValidYaRequest($param)
    {
        global $CONFIG;
    
        return $param['sha1_hash'] == sha1($param['notification_type'].'&'.$param['operation_id'].'&'.$param['amount'].'&'.$param['currency'].'&'.$param['datetime'].'&'.$param['sender'].'&'.$param['codepro'].'&'.$CONFIG['ya_money_secret'].'&'.$param['label']);
    }
    
    function getRobakassaForm($robokassa_amount, $order_id)
    {   global $CONFIG;
        return  '<script language="javascript" type="text/javascript" src="'
            .($CONFIG['shop_robokassa_test_mode']
                    ? $CONFIG['shop_robokassa_test_url']
                    : $CONFIG['shop_robokassa_real_url']).'?'
            .'MrchLogin='.$CONFIG['shop_robokassa_login']
            .'&OutSum='.$robokassa_amount.'&InvId='.$order_id.'&Desc='.urlencode('Заказ № '.$order_id)
            .'&SignatureValue='.$this->getRobokassaSignature($robokassa_amount, $order_id)
            .'&Culture=ru&IncCurrLabel=&Encoding=utf-8'
            .'"></script>';
    }
    
    function getRobokassaSignature($robokassa_amount, $order_id)
    {   global $CONFIG;
        return  md5($CONFIG['shop_robokassa_login'].':'.$robokassa_amount.':'.$order_id.':'.$CONFIG['shop_robokassa_pass1']);
    }
    
    function isValidRobokassaResultSignature($signature, $sum, $order_id)
    {   global $CONFIG;
        return  strtoupper($signature) == strtoupper(md5($sum.':'.$order_id.':'.$CONFIG['shop_robokassa_pass2']));
    }
    
    function isValidRobokassaSuccessSignature($signature, $sum, $order_id)
    {   global $CONFIG;
        return  strtoupper($signature) == strtoupper(md5($sum.':'.$order_id.':'.$CONFIG['shop_robokassa_pass1']));
    }
}

?>